require "uuid"
local api_utils = require "api.utils"

module((...), package.seeall)

local entityType = "whatsapp"
local baseUri = string.format("/%s/", entityType)
local m_apiDefaultConfig = api_utils.GetApiURLsDefaultConfig()

local m_apiDefinition = {
	info = {
		name = entityType
	},
	items = {
		--[[
			Start 
				url: /whatsapp/start/
				method: POST
		]]--
		{
			entityType = entityType,
			id = "d742e5c9-1bdc-4fb4-a8a1-68aeeb41ce13",
			name = "StartWhatsAppConversation",
			description = "Start WhatsApp Conversation",
			url = baseUri .. "start/",
			method = "POST",
			header = {
				Authorization = "....",
				["Content-Type"] = "application/json"
			},
			body = {
				{	id = "campaign",					required = true,	type = "string"	},
				{	id = "account",						required = true,	account = { name = "account_name", campaign = "campaign" } },
				{	id = "interactionId", 				required = false,	type = "string", default = uuid.new() },
				{	id = "name",						required = true,	type = "string" },
				{	id = "address",						required = true,	type = "string" },
				{	id = "text",						required = false,	type = "string" },
				{	id = "attachments",					required = false,	type = "table", array = true, default = {}, children = {
						{	id = "name",				required = true,	type = "string" },
						{	id = "type",				required = true,	type = "string" },
						{	id = "id",					required = true,	type = "string" },
						{	id = "content-disposition",	required = true,	type = "string" },
					}
				}
			},
			response = {},
			responseErrors = {},
			config = {
				permission = m_apiDefaultConfig.permissions.write,
				rateLimits = api_utils.GetApiURLRateLimit,
				resourceType = "medium_light", -- low, medium_light, medium, high
				--filters    = api_utils.GetApiURLFilters,
				--paged      = api_utils.GetApiURLPaged,
				urlLinkedFunction = "Start"
			}
		}
	}
}

function Get ()
	local m_apiDefinition = m_apiDefinition
	return m_apiDefinition
end