module(..., package.seeall)

local utils = require "shared.apps.utils"
local m_apiUtils = require "api.utils"
local m_datasource

function GetName ()
	return "Interactions"
end

function GetDefinition (datasource)
	m_datasource = datasource
	return _M
end

function Get (interactionId, keyspace)
	--redis
	
	if not interactionId or interactionId == "" then
		LogWarning("[API:interactions:Get] The interactionId is empty but cannot be empty")
		return nil
	end

	local interactionsModel = m_apiUtils.GetAgentModel("Interactions")
	local interaction = interactionsModel.GetInteraction(interactionId, keyspace, m_datasource)
	if not utils.TableIsEmpty(interaction) then
		--LogDebug("[API:interactions:Get] %s - found in redis", interactionId)
	else
		--cassandra
		interaction = interactionsModel.GetFromArchive(interactionId, ks_interactions)
		if not utils.TableIsEmpty(interaction) then
			--LogDebug("[API:interactions:Get] %s - found in cassandra", interactionId)
		else
			--not found
			LogWarning("[API:interactions:Get] %s - not found", interactionId)
			return nil
		end
	end
	--check vcc
	if interaction.VCC ~= inconcert.authUser.virtualContactCenter then
		LogWarning("[API:interactions:Get] %s - belongs to another vcc %s", interactionId, interaction.VCC)
		return nil
	end
	return interaction
end
