module(..., package.seeall, inconcert.orbit.application.Decorate)

function GetConditionsDefinition(required)
	return { id = "conditions", required = required, type = "table" }
end

function GetScopeDefinition()
	return { id = "scope", 	required = true,	type = "table", children = {
			{ id = "batchId",     	required = false, type = "string" },
			{ id = "contactId",     required = false, type = "string" },
			{ id = "contacts",     	required = false, type = "table", array = true, children = {
					{ id = "id",		required = true,	type = "string" },
				}
			},
			GetConditionsDefinition(false),
		}
	}
end

function GetAddressFieldsDefinition()
	return {
		{ id = "Type",     		required = true, type = "string" },
		{ id = "Kind",     		required = false, type = "string", default = "HOME" },
		{ id = "Channels",     	required = true, type = "table", array = true, default = {"CALL"}, },
		{ id = "Status",     	required = false, type = "string", default = "Enabled",
			domain = { Enabled = true, Disabled = true } },
		{ id = "Number",     	required = true, type = "string" },
	}
end
