local m_definitions = {
	basic = {
		isSimple = false,
		--getEntity = nil, -- custom function con la cual podemos obtener la entidad segun el JSON o tabla LUA.
		fields = {
			{
				field_id = "Id",
				validations = {
					id = "Only letters, numbers, dashes and dots are allowed in the signature Id.",
					html_malicious_code = "Possible malicious code in the signature Id."
				}
			},
			{
				field_id = "Name",
				validations = {
					id = "Only letters, numbers, dashes and dots are allowed in the signature Name.",
					html_malicious_code = "Possible malicious code in the signature Name."
				}
			},
			{
				field_id = "Description",
				validations = {
					html_malicious_code = "Possible malicious code in the signature Description."
				}
			},
			{
				field_id = "Signature",
				validations = {
					html_malicious_code = {
						reason = "Possible malicious code in the Signature.",
						canCleanJSElement = function (element)
							local skipElements = {
								href = true,
								target = true,
								link = true
							}
							if skipElements[element] then
								return false
							end
							return true
						end
					}
				}
			}
		}
	}
}

return {
	GetDefinitions = function() return m_definitions end
}
