module(..., package.seeall)

local utils = require "shared.apps.utils"
local m_datasource
local m_cachedSystemConfiguration = {}

function GetName ()
	return "SystemConfiguration"
end

function GetDefinition (datasource)
	m_datasource = datasource
	return _M
end

--[[
	Estos datos se puede cachear en las diferentes LUA VM ya que los mismos NUNCA sufren cambios.
	Y en algun caso extremo en los cuales sufran cambios, deberia reiniciar el WebHandler.
]]--
function Get (elementId, keyspace, columns)
	assert(elementId)
	if m_cachedSystemConfiguration[elementId] then
		--LogDebug("1 - LOADING FROM CACHE")
		return m_cachedSystemConfiguration[elementId]
	end
	--LogDebug("2 - LOADING FROM DB")
	local info = utils.GetAllColumns {
		keyspace = keyspace or "Provisioning",
		columnFamily = "SystemConfiguration",
		key = elementId,
		columns = columns
	}
	m_cachedSystemConfiguration[elementId] = info
	return info
end

function LoadAllSystemConfiguration (keyspace)
	local systemConfiguration = utils.GetAllColumns({
		keyspace     = keyspace or "Provisioning",
		columnFamily = "SystemConfiguration",
		startKey     = "",
		endKey       = ""
	}) or {}
	return systemConfiguration
end

