module(..., package.seeall)

local utils = require "shared.apps.utils"
local m_datasource

function GetName()
	return "TtsAsrEngines"
end

function GetDefinition(datasource)
	m_datasource = datasource
	return _M
end

local function AddSystemAppNotificationData(appId, appData, integrations)
	appData.System = true
	local url = integrations and integrations[appId] and integrations[appId].Enabled == "1" and 
		integrations[appId].Notifications and integrations[appId].Notifications.Url or ""
	if url ~= "" then
		appData.Url = url
		return true
	else
		appData.Url = nil
		return false
	end
end

function GetTtsAsrEngines(vcc, keyspace)
	local engines = utils.GetAllColumns {
		keyspace = keyspace or "Agent",
		columnFamily = "VCCTtsAsrEngines",
		superColumns = false,
		key = vcc,
		columns = {ttsasrEngines}
	}
	engines = engines or {}
	local engines = engines.ttsasrEngines or {}
	return engines
end

function SaveTtsAsrEngine(vcc, engines, keyspace)
	utils.SaveRows {
		keyspace = keyspace or "Agent",
		columnFamily = "VCCTtsAsrEngines",
		superColumns = false,
		rows = {
			[vcc] = {
				ttsasrEngines = engines
			}
		}
	}
	return true
end
