/* jshint forin:true, noarg:true, jquery:true, noempty:true, eqeqeq:true, bitwise:true,
	strict:true, undef:true, unused:vars, curly:false, browser:true, indent:false, maxerr:50, esversion: 11 */
/* global $, inConcert */

/*
La siguiente variable LUA_CODE contiene codigo de LUA, el mismo se ejecuta en el momento que se inserta el archivo JavaScript en el inboxMaster.html.
El mismo se encuentra asignado como string a una variable de JavaScript para que el validador jshint no encuentre el codigo como error.
El codigo de LUA podria haber estado dentro de un bloque de comentario de JavaScript, esto en modo desarrollo funciona bien, pero en modo produccion
el archivo JavaScript se comprime y los comentarios se eliminan y por ende el codigo LUA tambien es eliminado.
Por esta razon es que se asigna el codigo LUA a una variable LUA_CODE.

Tambien hay que escapear las comillas dobles en LUA cuando se hace json.encode(), ya que sino el compresor cambia las comillas dobles por simples y el JavaScript queda invalido.

Ejemplo del error despues de ofuscar el JavaScript:

c=JSON.parse("{"warnings":{"expiredTimeSec":120,"stepNumber":4}}")

*/

/*
	local utils = require "shared.apps.utils";
	local json  = require "json";
	--[[
		Estos valores se utilizan en VCC de Allegro y si la campana es de tipo CALL.
		Los mismos se utilizan para determinar si la sincronizacion de Usuarios entre OCC vs Allegro ha fallado (ejemplo por caidas de los ambientes, webhandlers, etc.)
		Estos valores se utilizan en /administration/controllers/campaigns funcion "Search"
		Sample:
			{
				warnings = {
					stepNumber     = 4, -- o menor
					expiredTimeSec = 10
				}
			}
	]]--
	local function GetUpdateMembersInfo ()
		return json.encode(utils.GetUpdateMembersInfo()):gsub('"', '\\"')
	end;
*/
// el codigo de la variable LUA_CODE lo tengo que poner "inline" ya que sino el compresor lo modifcia al codigo lua. El codigo es el codigo que se encuentra en el comentario.

/* jshint unused:false */
const LUA_CODE = `<%local utils = require 'shared.apps.utils';local json = require 'json'; local function GetUpdateMembersInfo () return json.encode(utils.GetUpdateMembersInfo()):gsub('"', '\\"') end;%>`;

if (!this.inConcert) {
	this.inConcert = {};
}

(function () {
	const format = inConcert.Utils.format;
	const m_errMessages = {
		["ALLEGRO_INTEGRATION_ERROR"]: "<%=_T('There is a users synchronization problem with Allegro.<br>To fix the problem you need to validate the services in Allegro and update the users again.')%>",
		["UNRECOGNIZED ERROR"]       : "<%=_T('Unrecognized error with user list.')%>"
	};

	/**
	Class workgroups popups.
	*/
	function adm_workgroups_popup()
	{
		adm_workgroups_popup.uber.constructor.call(this);
		this.clickEventName = this.clickEventName + "_workgroups";
		this.ownerId = "adm_form_campaign_members_workgroups_popups";
		this.canReposition = true;
	}

	inConcert.Utils.inherit(adm_workgroups_popup, inConcert.PopupWindow);

	/*******************************************************************
	 *
	 */
	adm_workgroups_popup.prototype.get_selected_workgroups = function()
	{
		var user_workgroups = {};

		$("#" + this.ownerId).find("ul[workgroup_list='true'] input[selector='1'][type='checkbox']").each( function( _, workgroup )
		{
			var $workgroup = $(workgroup);
			var checked = $workgroup.prop("checked");
			if (checked) {
				var wkg_id = $workgroup.parent().parent().parent().attr("wkg_id");
				user_workgroups[wkg_id] = true;
			}
		});

		return user_workgroups;
	};

	/*******************************************************************
	 * Metodo que setea eventos de los controles
	 */
	adm_workgroups_popup.prototype.set_events = function()
	{
		var self = this;
		var $container = $("#" + this.ownerId);

		$container.find("button[action='update']")
			.off("click")
			.on("click", function() {
				var user_workgroups = self.get_selected_workgroups();
				self.close({user_workgroups: user_workgroups});
			});

		$container.find("button[action='cancel']")
			.off("click")
			.on("click", function() {
				self.close();
			});
	};

	/*******************************************************************
	 * Metodo que crea el markup contenedor de la ventana
	 */
	adm_workgroups_popup.prototype.create_markup = function()
	{
		var self = this;
		var container_id = this.ownerId;
		$("#" + container_id).remove();

		var get_html_workgroups = function()
		{
			var html = "";
			var workgroups = self.data.workgroups;
			var user_workgroups = self.data.user_workgroups;
			$.each( workgroups, function( _, workgroup )
			{
				var wkg_id = workgroup.Id;
				var has_selected = !user_workgroups ? false : user_workgroups[wkg_id];
				var opt_wkg_id = "opt_wkg_" + wkg_id;
				html = html +
					"<li class='addWorkgroupItem' wkg_id='" + wkg_id + "'>" +
						"<div class='form-check'>" +
							"<label for='" + opt_wkg_id + "' class='form-check-label form-check-label-title'>" +
								"<input id='" + opt_wkg_id + "' selector='1' type='checkbox' " + (has_selected ? "checked" : "") + " class='form-check-input' />" +
								(workgroup.Name || wkg_id) + 
							"</label>" +
						"</div>" +						
					"</li>";
			});
			return html;
		};

		var node = $("".concat(
			"<div id='", container_id, "' class='windowContainer popOver' hidden >",
				"<div class='windowMiddle'>",
					"<div class='row'>",
						"<div class='col-12'>",
							"<label class='windowTitleLabel'><%=_T('Workgroups (supervisor role)')%></label>",
						"</div>",
					"</div>",
					"<div class='row'>",
						"<div class='col-12'>",
							"<ul workgroup_list='true' class='addWorkgroupContentScroll'>", get_html_workgroups(), "</ul>",
						"</div>",
					"</div>",
				"</div>",
				"<div class='windowBottom'>",
					"<button action='cancel' class='pageButtonGeneric buttonColorWhite' ><%=_T('Cancel')%></button>",
					"<button action='update' class='pageButtonGeneric buttonColorBlue' ><%=_T('Confirm')%></button>",
				"</div>",
			"</div>"));

		$("body").append(node);

		return node;
	};


	/*******************************************************************
	 * Metodo que visualiza el popup con los disposition codes e inicializa eventos de la ventana!
	 */
	adm_workgroups_popup.prototype.initialize = function() {
		var self = this;
		self.data.container = self.create_markup();
		// set events
		self.set_events();
	};

	/*******************************************************************
	 * Metodo que cierra el popup
	 */
	adm_workgroups_popup.prototype.close = function(params) {
		var self = this;
		self.data.container.remove();
		self.finalize(params);
	};

	//---------------------------------------------------------------------
	// form campaigns class - members section
	function adm_form_campaigns_section_members(params)
	{
		var success = adm_form_campaigns_section_members.uber.constructor.call(this, params);
		if (!success) {
			return;
		}

		this.view_action_id  = "view_campaigns_members";  // view action id de permisos
		this.save_action_id  = "save_campaign_members"; // save action id de permisos
		this.loading_message = "<%=_T('Please wait until retrieving users list.')%>";
		this.members = null;
		this.workgroups = null;
		this.search_text = null;
		this.workgroups_popup = new adm_workgroups_popup();

		// instancia del handle del override de permisos
		this.perm_gui_override = new inConcert.perm_gui_override( {
			container_id: "#adm_form_campaign_members_permission_list_2014",
			override_type: "campaign",
			cleanup_external_container_id: "adm_form_campaign_members_cancel_permissions"
		});

		// instancia del handle del override de permisos
		this.capability_handle = new inConcert.adm_capability_handle_override({
			override_type : "CAMPAIGN-MEMBER",
			container_id  : "adm_form_campaign_members_capability",
			is_required   : false,
			prefix_id     : "adm_form_campaign_members_",
			panel_id      : "adm_form_campaign_members_capability_panel",
			parent_frm    : this,
			parent_type   : "FORM-SECTION",
			proxies       : {
				CALL       : true,
				VOICEMAIL  : true,
				WEBCONTACT : true,
				FACEBOOK   : true,
				INSTAGRAM  : true,
				YOUTUBE	   : true,
				APPSTORE   : true,
				GOOGLEPLAY : true,
				RCS        : true,
				IM         : true,
				MAIL       : true,
				TWITTER    : true,
				CHAT       : true,
				SMS        : true,
				WHATSAPP   : true
			}
		});

		this.editing_row_id = null;

		return true;
	}

	inConcert.Utils.inherit( adm_form_campaigns_section_members, inConcert.conf_form_section );

	if ( typeof inConcert.adm_form_campaigns_section_members !== "function" ) {
		inConcert.adm_form_campaigns_section_members = adm_form_campaigns_section_members;
	}

	adm_form_campaigns_section_members.prototype.dispose = function()
	{
		if ( this.workgroups_popup.isVisible() ) {
			this.workgroups_popup.close();
		}
		this.search_text = null;
	};

	adm_form_campaigns_section_members.prototype.initialize = function()
	{
		this.perm_gui_override.initialize();
		this.capability_handle.initialize();

		if ( !this.is_overrideable_capability() ) {
			// se deja readonly el override de capability del member
			this.readonly_override_capability();
		}
	};

	adm_form_campaigns_section_members.prototype.set = function(campaign)
	{
		var self = this;

		console.log("adm_form_campaigns_section_members.prototype.set --> START set members section.");

		this.show_waiting("<%=_T('Loading users.')%>");
		this.initialize();

		this.set_load(true);
		var end_load = function() {
			self.set_load(false);
			self.hide_waiting();
			console.log("adm_form_campaigns_section_members.prototype.set --> END set members section.");
		};

		campaign.getFullUserList(function( members, error )
		{
			if ( !error ) {
				self.fill_grid(members, function() {
					end_load();
				});
			}
			else {
				var default_message = "<%=_T('Error retrieving campaign users configuration.')%>";
				var messages_error = {
					FORBIDDEN: "<%=_T('You dont have permissions for retrieving campaign members configuration.')%>"
				};
				var err_code = ( error.result || "" ).toUpperCase();
				var message = messages_error[ err_code ] || default_message;
				self.show_status_message( message, "Error" );
				end_load();
			}
		});
	};

	adm_form_campaigns_section_members.prototype.editable_override_permissions = function()
	{
		this.perm_gui_override.editable();
		$( "#adm_form_campaign_members_save_permissions" ).show();
		$( "#adm_form_campaign_members_cancel_permissions" ).html("<%=_T('Cancel')%>" );
		$( "#adm_form_campaign_members_cancel_permissions" ).removeClass("mr-0");
	};

	adm_form_campaigns_section_members.prototype.readonly_override_permissions = function()
	{
		this.perm_gui_override.readonly();
		$( "#adm_form_campaign_members_save_permissions" ).hide();
		$( "#adm_form_campaign_members_cancel_permissions" ).html("<%=_T('Back to Members')%>" );
		$( "#adm_form_campaign_members_cancel_permissions" ).addClass("mr-0");
	};

	adm_form_campaigns_section_members.prototype.editable_override_capability = function()
	{
		this.capability_handle.editable();
		$( "#adm_form_campaign_members_save_capability" ).show();
		$( "#adm_form_campaign_members_cancel_capability" ).attr( "value", "<%=_T('Cancel')%>" );
	};

	adm_form_campaigns_section_members.prototype.readonly_override_capability = function()
	{
		this.capability_handle.readonly();
		$( "#adm_form_campaign_members_save_capability" ).hide();
		$( "#adm_form_campaign_members_cancel_capability" ).attr( "value", "<%=_T('Close')%>" );
	};

	adm_form_campaigns_section_members.prototype.editable = function()
	{
		// La siguiente linea de codigo la dejo comentada, solo como referencia, ya que especificamente en esta seccion no se utiliza ( de momento )
		//   las propias acciones de editable la realiza la funcion de propia clase.
		//
		// adm_form_campaigns_section_members.uber.editable.call( this );

		// $("#adm_form_campaign_members_save")
			// .prop("disabled", false)
			// .show();

		$( "#adm_form_campaign_members_cancel" ).attr( "value", "<%=_T('Cancel')%>" );

		// se deja editable el override de permisos del member
		this.editable_override_permissions();
		// se deja editable el override de capability del member
		this.editable_override_capability();
		this.set_edit_mode(true);
	};

	adm_form_campaigns_section_members.prototype.readonly = function()
	{
		// La siguiente linea de codigo la dejo comentada, solo como referencia, ya que especificamente en esta seccion no se utiliza ( de momento )
		//   las propias acciones de readonly la realiza la funcion de propia clase.
		//
		// adm_form_campaigns_section_members.uber.readonly.call( this );

		// Atencion: los checkbox y controles de la lista se desactivan despues de cargar la misma de forma asincronica.
		$("#adm_form_campaign_members_save")
			.prop("disabled", true)
			.hide();

		$( "#adm_form_campaign_members_cancel" ).attr( "value", "<%=_T('Close')%>" );
		// se deja readonly el override de permisos del member
		this.readonly_override_permissions();
		// se deja readonly el override de capability del member
		this.readonly_override_capability();
	};

	adm_form_campaigns_section_members.prototype.on_show = function()
	{
		adm_form_campaigns_section_members.uber.on_show.call( this, { show: false } );
		this.frm.dashboard.$get_dom_element_by_id( "form_buttons_actions" ).hide();
		if ( !this.editing_row_id ) {
			$( "#adm_form_campaign_members_buttons" ).show();
			$( "#adm_form_campaign_members_footer" ).show();
		}
	};

	adm_form_campaigns_section_members.prototype.on_hide = function()
	{
		adm_form_campaigns_section_members.uber.on_hide.call( this );
		if ( this.workgroups_popup.isVisible() ) {
			this.workgroups_popup.close();
		}
	};

	adm_form_campaigns_section_members.prototype.has_workgroups = function()
	{
		if ( !this.workgroups ) {
			return false;
		}
		return Object.keys( this.workgroups ).length > 0;
	};

	adm_form_campaigns_section_members.prototype.fill_workgroups = function(workgroups)
	{
		var self = this;
		this.workgroups = {};
		$.each( workgroups, function( _, workgroup )
		{
			self.workgroups[workgroup.Id] = workgroup;
		});
	};

	adm_form_campaigns_section_members.prototype.set_workgroups_to_member_in_grid = function($wkg_section, user_workgroups)
	{
		var workgroups = user_workgroups || {};
		var self = this;
		var html_wkg = "";
		var i = 1;
		var $wkg_section_icon = $wkg_section.find("span");
		$.each(workgroups, function(workgroup_id)
		{
			if (i > 1) {
				html_wkg = html_wkg + ", ";
			}
			var wkg = self.workgroups[workgroup_id];
			if (wkg) {
				html_wkg = html_wkg + "\"" + (wkg.Name || workgroup_id) + "\"";
				i++;
			}
		});
		$wkg_section.removeClass("withoutWorkgroups withWorkgroups");
		$wkg_section_icon.removeClass("checkboxImageUnchecked checkboxImageChecked");
		if (html_wkg.length > 0) {
			$wkg_section.addClass("withWorkgroups");
			$wkg_section_icon.addClass("checkboxImageChecked");
		}
		else {
			$wkg_section.addClass("withoutWorkgroups");
			$wkg_section_icon.addClass("checkboxImageUnchecked");
		}
		$wkg_section.data("workgroups", workgroups);
		const $workgroups_assigned_list = $wkg_section.find("div[workgroups_assigned_list='true']");
		$workgroups_assigned_list.html(html_wkg);
	};

	adm_form_campaigns_section_members.prototype.is_overrideable_capability = function()
	{
		var is_readonly = this.is_readonly(); // la seccion actual de members.
		if ( is_readonly ) {
			return false;
		}
		if (this.frm.is_allegro_campaign()) {
			return false;
		}
		return true;
	};

	adm_form_campaigns_section_members.prototype.is_overrideable_permissions = function(role)
	{
		var is_readonly = this.is_readonly(); // la seccion actual de members.
		if ( is_readonly ) {
			return false;
		}

		if (!role.is_system) {
			return true;
		}
		if (this.isAllegro()) {
			// los roles del sistema en un vcc con integracion con allegro, no quedan disponibles para realizar override.
			return false;
		}

		return true;
	};

	adm_form_campaigns_section_members.prototype.merge_role_permissions = function( group_permissions, override_vcc_user_permissions, override_role_campaign )
	{
		// primero realizo merge de los permisos del grupo con los permisos particulares del member ( los override a nivel del VCC )
		var role_merged_permissions = inConcert.permissions.merge_permissions( group_permissions, override_vcc_user_permissions );
		// segundo realizo merge del resultado de lo anterior con los override particulares del role / campaign ( los override a nivel de la CAMPANA )
		role_merged_permissions = inConcert.permissions.merge_permissions( role_merged_permissions, override_role_campaign );
		return role_merged_permissions;
	};

	adm_form_campaigns_section_members.prototype.$create_member_row = function( member )
	{
		if (!this.frm.campaign) {
			return false;
		}
		var member_id = member.Id;
		var member_without_vcc = inConcert.Utils.getIdWithoutVCC( member_id );
		var member_role = member.UserGroup || "";
		var opt_user_id = "opt_user_" + member_without_vcc;
		var is_member = member.Role ? true : false;
		var checked_option = is_member ? "checked" : "";

		var get_user_name = function() {
			if ( !member.Name ) {
				return member_id;
			}
			if ( typeof member.FirstSurname !== "string" || member.FirstSurname.trim().length === 0 ) {
				return member.Name;
			}
			return member.Name + " " + member.FirstSurname;
		};

		var role = this.frm.get_role( member_role );
		var get_role_description = function() {
			if ( typeof role === "object" ) {
				return role.Name;
			}
			return member_role;
		};

		var html_buttons = "";

		var is_system_role = role.IsSystemGroup === "1";
		if (this.is_overrideable_permissions({ Id: role.Id, is_system: is_system_role })) {
			html_buttons = html_buttons + "<button class='buttonColorGray gridActionButton editPermissions' action_type='override_permissions' style='display:none;' disabled='true' title='"+ "<%=_T('Permissions')%>" + "'><i class='far fa-key'></i>" + "<%=_T('Permissions')%>" + "</button>";
		}
		else {
			html_buttons = html_buttons + "<button class='buttonColorGray gridActionButton viewPermissions' action_type='override_permissions' style='display:none;' disabled='true' title='"+ "<%=_T('View Permissions')%>" + "'><i class='far fa-key'></i>" + "<%=_T('View Permissions')%>" + "</button>";
		}

		if (this.is_overrideable_capability()) {
			html_buttons = html_buttons + "<button class='buttonColorGray gridActionButton editCapability' action_type='override_capability' style='display:none;' disabled='true' title='"+ "<%=_T('Capability')%>" + "'><i class='far fa-inbox'></i>" + "<%=_T('Capability')%>" + "</button>";
		}
		else {
			let attr_disabled = "";
			if (this.frm.is_allegro_campaign()) {
				attr_disabled = "disabled";
				html_buttons = html_buttons + "<button class='buttonColorGray gridActionButton viewCapability' action_type='override_capability' style='display:none;'" + attr_disabled + " title='"+ "<%=_T('View Capability')%>" + "'><i class='far fa-inbox'></i>" + "<%=_T('View Capability')%>" + "</button>";
			} else {
				html_buttons = html_buttons + "<button class='buttonColorGray gridActionButton viewCapability' action_type='override_capability' style='display:none;' disabled='true' title='"+ "<%=_T('View Capability')%>" + "'><i class='far fa-inbox'></i>" + "<%=_T('View Capability')%>" + "</button>";
			}
		}

		var user_name = get_user_name();
		// get override permisos role & campaign
		var override_role_campaign = this.frm.campaign.getOverrideSpecificRolePermissions( role );
		var override_member_campaign = this.frm.campaign.getOverrideSpecificMemberPermissions( member_without_vcc );
		var override_permissions_class = override_member_campaign ? " override" : "";
		// capability override
		var override_capability_member = member.OverrideCapabilities;
		var override_capability_class = ( Object.keys( override_capability_member || {} ).length > 0 ) ? "overrideCapability" : "";
		var override_capability_icon_class = ( Object.keys( override_capability_member || {} ).length > 0 ) ? "checkboxImageChecked" : "checkboxImageUnchecked";
		var role_name = get_role_description();
		var search_text = user_name + member_without_vcc + role_name;

		var $member_row = $(
			"<li class='viewListItem" + override_permissions_class + " " + override_capability_class + "' user_id='" + member_without_vcc + "' role_id='" + role.Id + "' user_role='" + member_role + "' user_name='" + user_name + "' search_text='" + search_text + "'>" +

				"<input id='" + opt_user_id + "' type='checkbox' " + checked_option + " selector='1' class='viewListCheck' />" +

// Queda comentado para realizar despues del primer congelado del 2024 !!!!!!!!!!!!
				// "<div class='avatarContainer'>" +
				// 	"<img avatar_src='"+ inConcert.app.getBaseDomain() + "/inconcert/apps/agent/users/get_avatar/" + member_without_vcc +"' />" +
				// "</div>" +

				"<div class='viewListItemText'>" +
					"<label for='" + opt_user_id + "'>" + member_without_vcc + "</label>" +
				"</div>" +

				"<div class='viewListItemText'>" +
					"<label for='" + opt_user_id + "'>" + user_name + "</label>" +
				"</div>" +

				"<label class='viewListItemText role'>" + 
					"<i error='true' class='formFieldValidation formFieldError' hidden></i>" +
					// "<i class='gridImageBoolean' hidden></i>" +
					"<label>" + role_name + "</label>" +
				"</label>" +

				"<div class='viewListItemText checkboxImageCol capability'>" +
					"<span class='" + override_capability_icon_class + "'></span>" +
				"</div>" +

			// markup workgroups
				"<div workgroups='true' class='viewListItemText checkboxImageCol workgroups' style='display:none;'>" +
					"<span></span>" +
					"<div class='workgroupsTooltipList' workgroups_assigned_list='true'></div>" +
				"</div>" +

			// markup buttons ( overrides capability & permissions )
				html_buttons +

			// btn workgroups
				"<button abm_wkg='true' style='display:none;' disabled='true' class='buttonColorGray gridActionButton workgroupListButton configureWorkgroups' title='"+ "<%=_T('Workgroups')%>" + "'><i class='far fa-users-cog'></i>" + "<%=_T('Workgroups')%>" + "</button>" +

			"</li>");

		// overrides permissions data
		var override_vcc_user_permissions = member.OverrideVccPermissions || {};
		// mergeo los overrides de vcc y campaign al rol original
		var merge_role_permissions = this.merge_role_permissions( role.grouppermissions, override_vcc_user_permissions, override_role_campaign );

		$member_row.data(
			"override_permissions",
			{
				role_id                  : role.Id                      ,
				role_name                : role_name                    ,
				user_id                  : member_without_vcc           ,
				user_name                : user_name                    ,
				is_system                : is_system_role               ,
				group_permissions        : role.grouppermissions        ,
				override_vcc_permissions : override_vcc_user_permissions,
				merge_role_permissions   : merge_role_permissions       ,
				override_role_campaign   : override_role_campaign       ,
				override_member          : override_member_campaign
			}
		);

		var $last_action_button = $member_row.find(".gridActionButton:last");
		if ( $last_action_button.length ) {
			$last_action_button.addClass( "last" );
		}

		// overrides capability data
		$member_row.data(
			"override_capability",
			{
				user_id             : member_without_vcc        ,
				user_name           : user_name                 ,
				override_capability : override_capability_member
			}
		);
		// acceso a las diferentes apps ( de momento solo a supervisor e interaction )
		$member_row.data( "apps_permisson", member.apps_permisson );

		// #11818: Buttons disabled for internal campaign
		if ( is_member && this.frm.campaign.Id !== inConcert.app.get_internal_campaign_id()) {
			// workgroups data
			var $wkg_section = $member_row.find("div[workgroups='true']");
			$wkg_section.data("configuredWorkgroups", member.supervisor_workgroups);

			// inserto en array de members
			this.members.push({
				id   : member_without_vcc,
				name : user_name,
				apps_permisson : member.apps_permisson
			});
			// override capability button
			var $override_cap_btn = $member_row.find( "button[action_type='override_capability']" );
			this.show_override_button( $override_cap_btn, checked_option );
			// override permissions button
			var $override_perm_btn = $member_row.find( "button[action_type='override_permissions']" );
			this.show_override_button( $override_perm_btn, checked_option );

			if ( member.supervisor_workgroups ) {
				this.set_workgroups_to_member_in_grid( $wkg_section, member.supervisor_workgroups );
				this.show_workgroup_button( $wkg_section, checked_option );
			}
		}

		return { $row : $member_row, is_member : is_member };
	};

	/*
		Esta funcion es invocada desde la seccion de override de grupos (adm_form_campaigns_section_groups)
		Lo que hace es actualizar los override del grupo que han cambiado en la lista de members que pertenzcan a este grupo.
	*/
	adm_form_campaigns_section_members.prototype.update_members_permissions_by_role = function( role_id, override_role_campaign )
	{
		var self = this;
		var $members_by_role = $( "#adm_form_campaign_members_list li[role_id='" + role_id || "" + "']" );

		$members_by_role.each( function( _, row )
		{
			var $member_row = $( row );
			// member permissions
			var ov = $member_row.data( "override_permissions" );
			if ( ov ) {
				// mergeo los overrides de vcc y campaign al rol original
				var merged_role_permissions = self.merge_role_permissions( ov.group_permissions, ov.override_vcc_permissions, override_role_campaign );

				ov.override_role_campaign = override_role_campaign;
				ov.merge_role_permissions = merged_role_permissions;

				$member_row.data( "override_permissions", ov );
			}
		});

		$( "#adm_form_campaign_members_cancel_permissions" ).trigger( "click" );
	};

	adm_form_campaigns_section_members.prototype.show_workgroup_button = function( $wkg_section, is_visible )
	{
		var $configure_button = $wkg_section.parent().find("button[abm_wkg='true']");

		var show_or_hide = function(action)
		{
			/*
			(***) jQuery LAST VERSION
				Tenemos que usar ".css(..display:none" ..) el lugar .show()" 
				ya que en la version de jQuery 3.4.1, cuando el markup se encuentra en memoria, es decir aun no se ha insertado en el DOM
				los metodos "show" y "hide" de jQuery no se comportan de la misma manera que lo hacen en la version 1.9.1 de jQuery.
			*/
			let display_val = action === "show" ? "" : "none";
			let disabled_val = action === "show" ? false : true;
			$configure_button.css("display", display_val);
			$configure_button.prop("disabled", disabled_val);
			$wkg_section.css("display", display_val);
		};

		if ( !this.has_permission_to_save() ) {
			show_or_hide("hide");
			return;
		}
		if ( !this.has_workgroups() ) {
			show_or_hide("hide");
			return;
		}
		if ( !$wkg_section.data("configuredWorkgroups") ) {
			return;
		}
		// si tiene workgroups y la opcion se encuentra marcada, muestra la seccion de wkg, sino la oculta
		show_or_hide( is_visible ? "show" : "hide" );
	};

	adm_form_campaigns_section_members.prototype.show_override_button = function( $override_button, is_visible )
	{
		/*
		(***) jQuery LAST VERSION - Ver comentario
		*/
		if ( is_visible ) {
			$override_button.css("display", "");
			$override_button.prop("disabled", false);
		}
		else {
			$override_button.css("display", "none");
			$override_button.prop("disabled", true);
		}
	};

	adm_form_campaigns_section_members.prototype.build_header_custom_buttons = function()
	{
		let value = this.search_text || "";
		adm_form_campaigns_section_members.uber.build_header_custom_buttons.call(this, "");
		window.setTimeout(function() {
			$("#adm_form_campaign_members_search_text").text(value).focus();
		}, 50);
	};

// Queda comentado para realizar despues del primer congelado del 2024 !!!!!!!!!!!!
	// adm_form_campaigns_section_members.prototype.set_user_avatar = function( $user )
	// {
	// 	// avatar
	// 	const $avatar = $user.find("[avatar_src]");
	// 	if ($avatar.length === 0) {
	// 		return;
	// 	}
	// 	const avatar_src = $avatar.attr("avatar_src");
	// 	if (!avatar_src) {
	// 		return;
	// 	}
	// 	$avatar.removeAttr("avatar_src");
	// 	$avatar.attr("src", avatar_src);
	// };

	adm_form_campaigns_section_members.prototype.fill_grid = function( members, callback )
	{
		var self = this;

		callback = callback || $.noop;
		var $members_list = $("#adm_form_campaign_members_list");

		// list header
		var $header = $(
			"<li header='true' class='viewListTitle'>" +
				"<input id='adm_form_campaign_members_paginator_check_all_visible' class='formListCheck' type='checkbox'>" +
// Queda comentado para realizar despues del primer congelado del 2024 !!!!!!!!!!!!
				// "<label class='avatarColumnTitle'></label>" +
				"<label class='viewListTitleText'>" + "<%=_T('Id')%>" + "</label>" +
				"<label class='viewListTitleText'>" + "<%=_T('Name')%>" + "</label>" +
				"<label class='viewListTitleText'>" + "<%=_T('Permission')%>" + "</label>" +
				"<label class='viewListTitleText checkboxImageCol'>" + "<%=_T('Modified capability')%>" + "</label>" +
				"<label class='viewListTitleText checkboxImageCol'>" + "<%=_T('Workgroups')%>" + "</label>" +
				"<label class='gridAction3ButtonCol'></label>" +
			"</li>"
		);
		$members_list.html("").append($header);

		if ( !$.isArray( members ) || members.length === 0 ) {
			$members_list.find("li[user_id]").remove();
			callback(true);
			return;
		}

		console.log("adm_form_campaigns_section_members.prototype.fill_grid--> START sort members");
		var sorted_members = inConcert.Utils.hash_to_sorted_array( members,
			function( member ) {
				return member.Id.toLowerCase();
			}
		);
		console.log("adm_form_campaigns_section_members.prototype.fill_grid--> END sort members");

		var $initial_items = [];
		this.members = [];

		var init_paginator = function()
		{
			console.log("adm_form_campaigns_section_members.prototype.fill_grid--> START paginator");

			self.m_paginator = jQuery.Paginator.init({
				pages_container   : $("#adm_form_campaign_members_paginator"),
				data_container    : $members_list,
// Para que los registros se agreguen en el DOM en memoria y luego se reailce efectiva la insersion en el DOM de todos los rows de una unica vez.
//	Despues del primer congelado del 2024 esta opcion debe ser por defecto en el jQuery-paginator, es decir que en todos los lugares donde se use este plugin se realice la insersion en memoria.
				append_with_detach: true,
				previous          : "",
				next              : "",
				show_at_least     : 12,
				items             : $initial_items,
				ignored_elements  : ".viewListTitle",
				text_format       : "<%=_T('{page_row_start}-{page_row_end} of {many}')%>",
				on_changed_page   : function( _, $page_users )
				{
					//aca marco/desmarco el chk del header, segun si estan todos marcados o no los rows de la grilla
					var mark_header_chk = true;
					$.each( $page_users, function( _, user )
					{
						const $user = $(user);
						// avatar
// Queda comentado para realizar despues del primer congelado del 2024 !!!!!!!!!!!!
						// self.set_user_avatar($user);
						//selector
						const $chk = $user.find("input[selector='1'][type='checkbox']");
						if ( !$chk.prop("checked") ) {
							mark_header_chk = false;
							return true; // continue
						}
					});
					$("#adm_form_campaign_members_paginator_check_all_visible").prop("checked", mark_header_chk);
				}
			});

			// all members are retrieved at once (yeah)
			self.m_paginator.no_more_pages();

			// esto lo tengo que realizar aca y no el metodo readonly, ya que esta lista se carga de forma asincronica.
			if (self.is_readonly()) {
				// checkboxes de la lista
				$("#adm_form_campaign_members_list input[selector='1'][type='checkbox']").prop("disabled", true);
				// boton workgroup de la lista
				$("#adm_form_campaign_members_list > button[abm_wkg='true']").hide();
				$("#adm_form_campaign_members_list > button[abm_wkg='true']").prop("disabled", true);
			}

			console.log("adm_form_campaigns_section_members.prototype.fill_grid--> END paginator");
		};

		const startDate = new Date();
		console.log(`adm_form_campaigns_section_members.prototype.fill_grid--> START creating HTML rows members, time: ${startDate}.`);

		// se carga en un foreach que corre dentro de un timeout para que el navegador no quede colgado
		inConcert.Utils.foreach_timeout({
			rows: sorted_members,
			append_fn : function( member ) 
			{
				//console.log("adm_form_campaigns_section_members.prototype.fill_grid--> Make member: '" + _ + "' = '" + member.Id + "'");
				var member_row = self.$create_member_row( member );
				if (!member_row) {
					console.log("adm_form_campaigns_section_members.prototype.fill_grid--> BREAK creating HTML rows members.");
					callback(false);
					return {cancel: true}; // break
				}
				$initial_items.push( member_row.$row );
			},
			waiting_message : "<%=_T('Please wait, adding user, {0} of {1}.')%>",
			waiting_fn : function( message ) {
				self.show_waiting(message);
				// if (waiting_message) {
					// console.log("adm_form_campaigns_section_members.prototype.fill_grid: " + message);
				// }
			},
			complete_fn : function() {
				const endDate = new Date();
				const elapsedTimeSec = (endDate.getTime() - startDate.getTime()) / 1000;
				console.log(`adm_form_campaigns_section_members.prototype.fill_grid--> END creating HTML rows members, time: ${endDate}. ELAPSED TIME (sec): ${elapsedTimeSec}.`);
				init_paginator();
				callback(true);
			}
		});
	};

	adm_form_campaigns_section_members.prototype.get_current_members = function()
	{
		return this.members;
	};

	adm_form_campaigns_section_members.prototype.update_members = function( callback )
	{
		var self = this;

		callback = callback || $.noop;

		var members = [];
		$("#adm_form_campaign_members_list input[selector='1'][type='checkbox']").each( function( _, member )
		{
			var $member = $(member);
			var checked = $member.prop("checked");
			if ( checked ) {
				var $member_row = $member.parent();

				// member capability
				var capability = $member_row.data( "override_capability" );
				var override_capability = null;
				if ( capability && capability.override_capability ) {
					override_capability = inConcert.Utils.cloneObject( capability.override_capability );
				}

				// member permissions
				var campaign_permissions = null;
				var override_permissions = $member_row.data( "override_permissions" );
				if ( override_permissions && override_permissions.override_member ) {
					campaign_permissions = override_permissions.override_member;
				}

				// acceso a las diferentes apps ( de momento solo a supervisor e interaction )
				var apps_permisson = $member_row.data( "apps_permisson" );

				// workgroups
				var $wkg_section = $member_row.find( "div[workgroups='true']" );
				var member_workgroups = $wkg_section.data("workgroups") || null;

				var member_obj = {
					id                    : $member_row.attr( "user_id" )   ,
					name                  : $member_row.attr( "user_name")  ,
					role                  : $member_row.attr( "user_role" ) ,
					supervisor_workgroups : member_workgroups               ,
					campaign_permissions  : campaign_permissions            ,
					member_capability     : override_capability             ,
					apps_permisson        : apps_permisson
				};

				members.push(member_obj);
			}
		});

		// hide marked errors
		$("#adm_form_campaign_members_list li[user_id] i[error]").hide();

		this.show_waiting("<%=_T('Please wait until updating users list.')%>");
		var campaign = this.frm.campaign;

		campaign.UpdateMembersList( members, function( success, error )
		{
			if ( success ) {
			// Se agrego correctamente
				var message_success = "<%=_T('Users list was successfully updated.')%>";
				self.show_status_message( message_success, "Info" );
				self.members = members;
				callback( success );
				return;
			}

			// Error actualizando
			var error_message;
			var problematic_users;
			var mark_members_with_error = function()
			{
				if (!$.isArray(problematic_users)) {
					return;
				}
				$.each(problematic_users, function(_, member)
				{
					var $row = $("#adm_form_campaign_members_list li[user_id='" + member.id + "']");
					$row.find("i[error='true']").show();
				});
			};
			const raw_error = error;
			if (typeof error === "object") {
				problematic_users = error.problematicUsers;
				error = ( error.result || "").toUpperCase();
			}

			if (error === "ALLEGRO_INTEGRATION_ERROR") {
				const resp = inConcert.app.validateAllegroWarningsCampaigns([{
					campaignId: inConcert.app.get_id(campaign.Id),
					error     : raw_error.err
				}]);
				if (resp.campaignsWithServerDownErrors.length > 0) {
					$.inconcertPopup.Show(
						"<%=_T('Update Problems.')%>",
						m_errMessages.ALLEGRO_INTEGRATION_ERROR,
						$.inconcertPopup.ButtonSets.BS_OK,
						function(/*response*/) {
							self.hide_waiting();
						},
						undefined,
						{
							popup_id        : "agent_inconcertPopup",
							container_class : "confirmationPopUp",
							overlay_class   : "confirmationOverlay"
						}
					);
					// esta marca sirve para la vista de campanas (adm_config.js)
					self.frm.dashboard.get_current_action_obj().with_error = true;
					return callback(false, error);
				}
			}

			switch (error)
			{
				case "INVALID_REQUEST":
					error_message = "<%=_T('Invalid request.')%>";
				break;

				case "ERROR_USERS_EXCEEDS_LIMIT_ALLOWED":
					const limit = inConcert.app.getMaxConfigurationsAllowed("MaxCampaignsUsers");
					error_message = format("<%=_T('The total number of users assigned to the campaigns exceeds the limit allowed {0}.')%>", limit);
				break;

				case "THERE_IS_ANOTHER_USERS_UPDATE_IN_PROGRESS_FOR_THIS_CAMPAIGN":
					error_message = "<%=_T('Unable to update users list. There is another users update in progress for this campaign.')%>";
				break;

				case "SOME_USERS_HAS_INTERACTIONS":
					error_message = "<%=_T('Error updating users list, some users has assigned conversations, and can not be removed, please try again later...')%>";
					mark_members_with_error();
				break;

				case "SOME_USERS_ASSIGNED_IN_ATTENTION_LEVELS":
					error_message = "<%=_T('Error updating users list, some users has assigned in attention levels, and can not be removed, please try again later...')%>";
					mark_members_with_error();
				break;

				case "USER_HAS_INTERACTIONS_MEMBER_HAVE_NOT_PERMISSION_TO_INTERACTION_APP":
					var count = raw_error.problematicUsers[0].assigned_interactions;
					error_message = format(
						"<%=_T('User has {0} assigned {1}. Error updating users permissions, user does not have permission to interaction app ...')%>",
						count,
						count > 1 ? "<%=_T('conversations')%>" : "<%=_T('conversation')%>"
					);
					mark_members_with_error();
					//self.rollback_update_row(); // TODO: ver si es correcto que este esto aca. Si llega a tener que estar, hay que revisarlo.
				break;

				case "USER_IN_ATTENTION_LEVELS_MEMBER_HAVE_NOT_PERMISSION_TO_INTERACTION_APP":
					error_message = "<%=_T('Attention levels conflict. Error updating users permissions, user does not have permission to interaction app ...')%>";
					mark_members_with_error();
					//self.rollback_update_row(); // TODO: ver si es correcto que este esto aca. Si llega a tener que estar, hay que revisarlo.
				break;

				case "UNABLE TO CONNECT WITH ALLEGRO":
					error_message = "<%=_T('Unable to connect to Allegro server.')%>";
				break;

				case "FORBIDDEN":
					error_message = "<%=_T('You do not have permissions to save the users list.')%>";
				break;

				case "ALLEGRO_INTEGRATION_ERROR":
					error_message = "<%=_T('Error updating information on Allegro integration...')%>";
				break;

				default:
					error_message = "<%=_T('Failed updating users list, please try again in a few minutes...')%>";
			}
			const timeout_ms = 10000;
			self.show_status_message( error_message, "Error", timeout_ms );
			callback( success, error );
		});
	};

	adm_form_campaigns_section_members.prototype.show_member_permissions = function( $row )
	{
		var self = this;

		if ( !$row || $row.length === 0 ) {
			return;
		}

		var info = $row.data( "override_permissions" );
		this.editing_row_id = $row.attr( "user_id" );

		if ( !this.has_permission_to_section() ) {
			var message = format( "<%=_T('Unable to view {0} user: You do not have permissions for this action.')%>", info.user_name );
			this.show_status_message( message, "Error", 5000 );
			return;
		}

		if ( this.has_permission_to_save() ) {
			let title = format(format("<%=_T('Override User Permissions: {0}')%>", "<span>\"{0}\"</span>"), info.user_name);
			$( "#adm_form_campaign_members_permission_title" ).html( title );
			this.editable();
		}
		else {
			let title = format(format("<%=_T('View Member Permissions: {0}')%>", "<span>\"{0}\"</span>"), info.user_name);
			$( "#adm_form_campaign_members_permission_title" ).html( title );
			this.readonly();
		}

		this.perm_gui_override.mark_actions(
			info.merge_role_permissions,
			function() {
				if ( info.override_member ) {
					//marco/desmarco las diferencias (los permisos customs)
					self.perm_gui_override.mark_difference_actions( info.override_member );
				}
				$("#adm_form_campaign_members_list").hide();
				$("#adm_form_campaign_members_paginator").hide();
				$("#adm_form_campaign_members_buttons").hide();
				$("#adm_form_campaign_members_footer").hide();
				$("#adm_form_campaign_members_body_buttons").hide();
				$("#adm_form_campaign_members_permissions_panel").show();
			}
		);

		var role = { Id: info.role_id, is_system: info.is_system };

		if (this.is_overrideable_permissions(role)) {
			// si tiene permiso de edicion de override de roles
			this.editable_override_capability();
		}
		else {
			// si NO tiene permisos de edicion de override de roles
			this.readonly_override_permissions();
		}
		this.frm.change_title_section(this.section_id, info.user_name);
		// google analytics
		const analyticsInfo = {
			source_path: [
				{name: "action_2_id", value: "permissions"      }, // "/main/administration/campaigns/edit/camp1@vcc1/members/pepe@a/permissions"
				{name: "role_id"    , value: info.role_id       }, // "/main/administration/campaigns/edit/camp1@vcc1/members/pepe@a/permissions/adm@system"
				{name: "action_3_id", value: "override"         }  // "/main/administration/campaigns/edit/camp1@vcc1/members/pepe@a/permissions/adm@system/override"
			]
		};
		this.AnalyticsSend(analyticsInfo);
	};

	adm_form_campaigns_section_members.prototype.hide_member_permissions = function()
	{
		this.editing_row_id = null;
		$("#adm_form_campaign_members_permissions_panel").hide();
		$("#adm_form_campaign_members_list").show();
		$("#adm_form_campaign_members_paginator").show();
		$("#adm_form_campaign_members_buttons").show();
		$("#adm_form_campaign_members_footer").show();
		$("#adm_form_campaign_members_body_buttons").show();
		this.set_edit_mode(false);
		this.frm.change_title_section();
		// google analytics
		this.AnalyticsSend();
	};

	adm_form_campaigns_section_members.prototype.show_member_capability = function( $row )
	{
		var self = this;
		if ( !$row || $row.length === 0 ) {
			return;
		}

		var info = $row.data( "override_capability" );
		this.editing_row_id = $row.attr( "user_id" );

		if ( !this.has_permission_to_section() ) {
			var message = format( "<%=_T('Unable to view {0} user: You do not have permissions for this action.')%>", info.user_name );
			this.show_status_message( message, "Error", 5000 );
			return;
		}

		var title = format(format("<%=_T('Override {0} User Capability')%>", "<span>\"{0}\"</span>"), info.user_name);
		$( "#adm_form_campaign_members_capability_title" ).html( title );

		if ( this.has_permission_to_save() ) {
			this.editable();
		}
		else {
			this.readonly();
		}

		var rebuild_markup = true;
		this.capability_handle.set( true, info.override_capability, rebuild_markup, function( success ) {
			if ( !success ) {
				return;
			}
			self.frm.change_title_section(self.section_id, info.user_name);
			self.capability_handle.show(function() {
				$("#adm_form_campaign_members_list").hide();
				$("#adm_form_campaign_members_paginator").hide();
				$("#adm_form_campaign_members_buttons").hide();
				$("#adm_form_campaign_members_footer").hide();
				$("#adm_form_campaign_members_body_buttons").hide();
			});
		});
		// google analytics
		const analyticsInfo = {
			source_path: [
				{name: "action_2_id", value: "capability"} // "/main/administration/campaigns/edit/camp1@vcc1/capability"
			]
		};
		this.AnalyticsSend(analyticsInfo);
	};

	adm_form_campaigns_section_members.prototype.hide_member_capability = function()
	{
		this.editing_row_id = null;
		const self = this;
		this.capability_handle.hide(function() {
			$("#adm_form_campaign_members_list").show();
			$("#adm_form_campaign_members_paginator").show();
			$("#adm_form_campaign_members_buttons").show();
			$("#adm_form_campaign_members_footer").show();
			$("#adm_form_campaign_members_body_buttons").show();
			self.set_edit_mode(false);
			self.frm.change_title_section();
			// google analytics
			self.AnalyticsSend();
		});
	};

	adm_form_campaigns_section_members.prototype.update_row_by_permission = function()
	{
		if ( this.editing_row_id === null ) {
			return;
		}
		var $row = $( "#adm_form_campaign_members_list" ).find( "li[user_id='" + this.editing_row_id + "']" );
		if ( $row.length === 0 ) {
			return;
		}

		// actualizo los permisos
		var override_permissions = $row.data( "override_permissions" );
		var previous_info = inConcert.Utils.cloneObject( override_permissions );
		$row.data( "previous_override_permissions", previous_info );

		var new_overrides = this.perm_gui_override.get_overrides();

		// actualizo la clase (css) que indica si se ha realizado override sobre el grupo en la lista
		if ( $row.hasClass( "override" ) ) {
			$row.removeClass( "override" );
		}
		if ( new_overrides.has_override === "1" ) {
			new_overrides = {
				apps    : new_overrides.apps,    // override de apps
				actions : new_overrides.actions  // override de actions
			};
			$row.addClass( "override" );
		}
		else {
			new_overrides = null;
		}

		// actualizo la info de la data a guardar
		override_permissions.override_member = new_overrides;

		$row.data( "override_permissions", override_permissions );
	};

	adm_form_campaigns_section_members.prototype.rollback_update_row = function()
	{
		if ( this.editing_row_id === null ) {
			return;
		}
		var $row = $( "#adm_form_campaign_members_list" ).find( "li[user_id='" + this.editing_row_id + "']" );
		if ( $row.length === 0 ) {
			return;
		}
		// 1 -rollback de permisos
		var previous_permissions_info = $row.data( "previous_override_permissions" );
		var cloned_previous_permissions = inConcert.Utils.cloneObject( previous_permissions_info );
		$row.data( "override_permissions", cloned_previous_permissions );
		$row.data( "previous_override_permissions", {} );
		$row.removeClass( "override" );
		// actualizo la clase (css) que indica si se ha realizado override sobre el rol del member en la lista
		if ( previous_permissions_info.override_member ) {
			$row.addClass( "override" );
		}

		// 2 -rollback de capability
		var previous_capability_info = $row.data( "previous_override_capability" );
		var cloned_previous_capability = inConcert.Utils.cloneObject( previous_capability_info );
		var $capability_override_icon = $row.find("div.capability span");
		$row.data( "override_capability", cloned_previous_capability );
		$row.data( "previous_override_capability", {} );
		$row.removeClass( "overrideCapability" );
		$capability_override_icon.removeClass("checkboxImageChecked");
		$capability_override_icon.addClass("checkboxImageUnchecked");
		// actualizo la clase (css) que indica si se ha realizado override sobre el capability del member en la lista 
		if ( previous_capability_info && Object.keys( previous_capability_info.override_capability || {} ).length > 0 ) {
			$row.addClass( "overrideCapability" );
			$capability_override_icon.addClass("checkboxImageChecked");
			$capability_override_icon.removeClass("checkboxImageUnchecked");
		}
	};

	adm_form_campaigns_section_members.prototype.update_row_by_capability = function()
	{
		if ( this.editing_row_id === null ) {
			return;
		}
		var $row = $( "#adm_form_campaign_members_list" ).find( "li[user_id='" + this.editing_row_id + "']" );
		if ( $row.length === 0 ) {
			return;
		}

		// actualizo los capability
		var override_capability = $row.data( "override_capability" );
		var previous_info = inConcert.Utils.cloneObject( override_capability );
		$row.data( "previous_override_capability", previous_info );
		var $capability_override_icon = $row.find("div.capability span");

		var new_overrides = this.capability_handle.get();

		// actualizo la clase (css) que indica si se ha realizado override sobre el grupo en la lista
		if ( $row.hasClass( "overrideCapability" ) ) {
			$row.removeClass( "overrideCapability" );
			$capability_override_icon.removeClass("checkboxImageChecked");
			$capability_override_icon.addClass("checkboxImageUnchecked");
		}
		var overrides_channels;
		if ( new_overrides.has_override ) {
			overrides_channels = new_overrides.channels;
			$row.addClass( "overrideCapability" );
			$capability_override_icon.addClass("checkboxImageChecked");
			$capability_override_icon.removeClass("checkboxImageUnchecked");
		}

		// actualizo la info de la data a guardar
		override_capability.override_capability = overrides_channels;

		$row.data( "override_capability", override_capability );
	};

	adm_form_campaigns_section_members.prototype.validate_groups_permissions = function()
	{
		// valida que exista al menos una accion marcada de cualquier aplicacion.
		// var result = this.perm_gui_override.validate( "marked-all-actions" );
		// if ( !result.success ) {
			// return result;
		// }

		// valida que si se marco alguna aplicacion, que al menos se marque una accion de esta.
		var result = this.perm_gui_override.validate( "mark-at-least-a-action-of-the-app" );
		if ( !result.success ) {
			return result;
		}
		return result;
	};

	adm_form_campaigns_section_members.prototype.save_override_member_permissions = function()
	{
		var self = this;
		var response = this.validate_groups_permissions();
		if ( !response.success ) {
			this.show_status_message( response.message, "Error" /* message type */, 5000 /* timeout ms */ );
			return;
		}
		this.update_row_by_permission();
		this.update_members( function( success, error )
		{
			if ( success ) {
			// Se actualizo correctamente
				var message_success = "<%=_T('Override User permissions was successfully updated.')%>";
				self.show_status_message( message_success, "Info" );
			}
			else {
				if ( error === "FORBIDDEN" ) {
					self.rollback_update_row();
				}
			}
			self.hide_member_permissions();
		});
	};

	adm_form_campaigns_section_members.prototype.save_override_member_capability = function()
	{
		var self = this;

		if ( !this.capability_handle.validate() ) {
			return;
		}
		this.update_row_by_capability();
		this.update_members( function( success, error )
		{
			if ( success ) {
			// Se actualizo correctamente
				var message_success = "<%=_T('Override Member capability was successfully updated.')%>";
				self.show_status_message( message_success, "Info" );
			}
			else {
				if ( error === "FORBIDDEN" ) {
					self.rollback_update_row();
				}
			}
			self.hide_member_capability();
		});
	};

	adm_form_campaigns_section_members.prototype.before_jump_to_other_menunav = function(){
		if ($("#adm_form_campaign_members_permissions_panel").is(':visible')) {
			return this.hide_member_permissions();
		}
		
		if ($("#adm_form_campaign_members_capability_panel").is(':visible')) {
			return this.hide_member_capability();
		}
	};

	adm_form_campaigns_section_members.prototype.set_events = function()
	{
		var self = this;

		$("#adm_form_campaign_members_cancel")
			.off("click")
			.on("click", function() {
				self.frm.close();
			});

		$("#adm_form_campaign_members_cancel_permissions")
			.off("click")
			.on("click", function() {
				self.hide_member_permissions();
			});

		$("#adm_form_campaign_members_cancel_capability")
			.off("click")
			.on("click", function() {
				self.hide_member_capability();
			});

		var grid_actions = function()
		{
			var $this = $( this );
			var action_type = $this.attr("action_type");
			var $row = $this.parent();

			if ( action_type === "override_permissions" ) {
				self.show_member_permissions( $row );
			}
			else if ( action_type === "override_capability" ) {
				self.show_member_capability( $row );
			}
			else {
				throw( "Unrecognized permission button action '" + action_type + "' " );
			}
		};

		// click en el boton que abre la seccion overrides ( permisos, capability )
		var event_selector = "> li button[action_type]";
		$("#adm_form_campaign_members_list")
			.off("click", event_selector)
			.on("click", event_selector, grid_actions );

		// seteo los eventos del container de acciones de override de permisos
		this.perm_gui_override.set_events();

		// actualiza la lista de members de la campana
		$("#adm_form_campaign_members_save")
			.off("click")
			.on("click", function() {
				self.update_members();
			});

		$("#adm_form_campaign_members_save_permissions")
			.off("click")
			.on("click", function() {
				self.save_override_member_permissions();
			});

		$("#adm_form_campaign_members_save_capability")
			.off("click")
			.on("click", function() {
				self.save_override_member_capability();
			});

		// click en el boton que abre el popup con la lista de workgroups
		event_selector = "> li button[abm_wkg='true']";
		$("#adm_form_campaign_members_list")
			.off("click", event_selector)
			.on("click", event_selector, function()
			{
				var permission_message = "<%=_T('You dont have permissions for this action.')%>";
				if ( !self.has_permission_to_save() ) {
					self.show_status_message( permission_message, "Error", 5000 );
					return;
				}
				if ( !self.has_workgroups() ) {
					return;
				}
				var $button = $(this);
				var $wkg_section = $button.parent().find("div[workgroups='true']");
				var user_workgroups = $wkg_section.data("workgroups");
				self.workgroups_popup.show(
				{
					owner_object: self,
					parentNode: $button,
					workgroups: self.workgroups,
					user_workgroups: user_workgroups,
					callbacks: {
						onOpen: $.noop,
						onClose: function( response ) {
							if ( !self.has_permission_to_save() ) {
								self.show_status_message( permission_message, "Error", 5000 );
								return;
							}
							if (response && response.user_workgroups) {
								var user_workgroups = response.user_workgroups;
								self.set_workgroups_to_member_in_grid($wkg_section, user_workgroups);
							}
						}
					}
				});
			});

		// click en el checkbox que agrega/quita el member a la campana
		event_selector = "input[selector='1'][type='checkbox']";
		$("#adm_form_campaign_members_list")
			.off("click", event_selector)
			.on("click", event_selector, function()
			{
				var $this = $(this);
				var mark = $this.prop("checked");
				var $member_row = $this.parent();
				self.check_uncheck_member( mark, $member_row );
			});

		// check all del header
		event_selector = "#adm_form_campaign_members_paginator_check_all_visible";
		$("#adm_form_campaign_members_list")
			.off("click", event_selector)
			.on("click", event_selector, function() {
				var mark_all = $(this).prop("checked");
				self.check_uncheck_all_visible_members( mark_all );
			});

		// funcion de busqueda de members
		const $search_text = $("#adm_form_campaign_members_search_text");
		this.search_timeout = null;
		const search_members = function() {
			self.show_waiting("<%=_T('Please wait ...')%>");
			const text = $search_text.val();
			if (self.search_timeout) {
				window.clearTimeout(self.search_timeout);
				self.search_timeout = null;
			}
			self.search_timeout = window.setTimeout(function() {
				self.filter(text, function() {
					self.hide_waiting();
				});
				window.clearTimeout(self.search_timeout);
				self.search_timeout = null;
			}, 100);
		};

		// boton de busqueda
		const $body_buttons = $("#adm_form_campaign_members_body_buttons");
		event_selector = "#adm_form_campaign_members_search_start";
		$body_buttons
			.off("click", event_selector)
			.on("click", event_selector, function() {
				search_members();
			});

		// boton de reset de la busqueda
		event_selector = "#adm_form_campaign_members_search_reset";
		$body_buttons
			.off("click", event_selector)
			.on("click", event_selector, function() {
				$search_text.val("");
				search_members();
			});

		// evento keyup del text de search
		event_selector = "#adm_form_campaign_members_search_text";
		$body_buttons
			.off("keyup", event_selector)
			.on("keyup", event_selector, function(e) {
				// enter
				if (e.keyCode === 13) {
					search_members();
				}
			});
	};

	adm_form_campaigns_section_members.prototype.make_search_regexp = function( word )
	{
		if (typeof word !== "string") {
			return "";
		}
		var search_pattern = inConcert.Utils.removeSpecialChars(word);
		return new RegExp(search_pattern.replace(/[^\w\s]/gi, ""), "i");
	};

	adm_form_campaigns_section_members.prototype.show_not_results_found = function( message )
	{
		$("#adm_form_campaign_members_not_results_found")
			.text( message || "<%=_T('No users found.')%>" )
			.show();
		$("#adm_form_campaign_members_list").hide();
	};

	adm_form_campaigns_section_members.prototype.hide_not_results_found = function()
	{
		$("#adm_form_campaign_members_list").show();
		$("#adm_form_campaign_members_not_results_found").hide();
	};

	adm_form_campaigns_section_members.prototype.filter = function(text, callback = $.noop)
	{
		const self = this;

		if (text === this.search_text) {
			callback();
			return;
		}

		this.search_text = text;
		const $list_container = $("#adm_form_campaign_members_list");
		const $form_container = this.$get_dom_element_by_id("form_container");
		const $search_reset = $("#adm_form_campaign_members_search_reset");

		if (text.trim().length === 0) {
		// si no hay texto buscado en el filtro, no filtro las row
			$("#adm_form_campaign_members_paginator").show(); // muestro la botonera del paginado
			$("#adm_form_campaign_members_footer").show();
			this.hide_not_results_found();
			$list_container.find("li[user_id]").hide();
			this.m_paginator.refresh_page();
			$form_container.removeClass("filterResultState");
			$search_reset.hide();
			callback();
			return;
		}

		const startDate = new Date();
		console.log(`adm_form_campaigns_section_members.prototype.filter 1--> START members search, text: '${text}', time: ${startDate}.`);

		$search_reset.show();
		let total_rows = 0;
		let hidden_rows = 0;

		// Para que la busqueda sea mas rapida, la misma se realiza en memoria despues se debe de volver a insertar en el DOM (**).
		const $parent = $list_container.parent();
		$list_container.detach();

		$list_container.find("li[user_id]").each(function(_, row) {
			total_rows++;
			const $row = $(row);
			let row_value = $row.attr("search_text");
			let search_regexp = self.make_search_regexp(text);
			if (row_value.search(search_regexp) === -1) {
				// console.log(`   - ${total_rows} hide row_value: '${row_value}'`);
				$row.hide();
				hidden_rows++;
			}
			else {
				// console.log(`   + ${total_rows} show row_value: '${row_value}'`);
// Queda comentado para realizar despues del primer congelado del 2024 !!!!!!!!!!!!
				// self.set_user_avatar($row);
				$row.show();
			}
		});
		// (**) despues de finalizar la busqueda, se vuelve a insertar en el DOM.
		$parent.append( $list_container );

		$("#adm_form_campaign_members_paginator").hide(); // oculto la botonera del paginado
		$form_container.removeClass("filterResultState").addClass("filterResultState");
		if (total_rows === hidden_rows) {
			this.show_not_results_found();
		}
		else {
			this.hide_not_results_found();
		}

		const endDate = new Date();
		const elapsedTimeSec = (endDate.getTime() - startDate.getTime()) / 1000;
		console.log(`adm_form_campaigns_section_members.prototype.filter 2--> END members search, text: '${text}', time: ${endDate}. ELAPSED TIME (sec): ${elapsedTimeSec}.`);
		callback();
	};

	adm_form_campaigns_section_members.prototype.check_uncheck_all_visible_members = function( mark )
	{
		var self = this;

		// al waiting lo muestra solo si tiene filtro aplicado, ya que puede demorar.
		var can_show_waiting = this.search_text !== null && this.search_text.trim().length > 0;
		if ( can_show_waiting ) {
			var action_name = mark ? "<%=_T('mark')%>" : "<%=_T('unmark')%>";
			var waiting_message = format("<%=_T('Please wait until {0} users.')%>", action_name);
			this.show_waiting(waiting_message);
		}

		window.setTimeout(function()
		{
			$("#adm_form_campaign_members_list").find("li[user_id]").each(function( _, user )
			{
				var $user = $(user);
				if ( !$user.is(":visible") ) {
					return true; // continue
				}
				var $chk = $user.find("input[selector='1'][type='checkbox']");
				$chk.prop("checked", mark);
				self.check_uncheck_member( mark, $user );
			});
			if ( can_show_waiting ) {
				self.hide_waiting();
			}
		}, 50);
	};

	adm_form_campaigns_section_members.prototype.check_uncheck_member = function( mark, $member_row )
	{
		var is_visible = mark && this.frm.campaign.Id !== inConcert.app.get_internal_campaign_id();

		// 1 - workgroups
		var $wkg_section = $member_row.find("div[workgroups='true']");
		this.show_workgroup_button( $wkg_section, is_visible );

		// 2 - override de capability
		$member_row.removeClass( "overrideCapability" );
		var $capability_override_icon = $member_row.find("div.capability span");
		$capability_override_icon.removeClass("checkboxImageChecked");
		$capability_override_icon.addClass("checkboxImageUnchecked");

		var override_capability = $member_row.data( "override_capability" );
		if ( is_visible && override_capability && Object.keys( override_capability.override_capability || {} ).length > 0 ) {
			$member_row.addClass( "overrideCapability" );
			$capability_override_icon.addClass("checkboxImageChecked");
			$capability_override_icon.removeClass("checkboxImageUnchecked");
		}
		var $override_cap_btn = $member_row.find("button[action_type='override_capability']");
		this.show_override_button( $override_cap_btn, is_visible );

		// 3 - override de permisos
		$member_row.removeClass( "override" );
		var override_permissions = $member_row.data( "override_permissions" );
		if ( is_visible && override_permissions && override_permissions.override_member ) {
			$member_row.addClass( "override" );
		}
		var $override_perm_btn = $member_row.find("button[action_type='override_permissions']");
		this.show_override_button( $override_perm_btn, is_visible );
	};

	adm_form_campaigns_section_members.prototype.attach_load_request = function( request )
	{
		if ( !$.isArray( request ) ) {
			return;
		}

		var self = this;
// TODO: obtener la lista de groups para hacer el mapeo y obtener la descripcion cuando se muestra el rol en la lista de usuarios
		var base_uri = inConcert.app.getBaseDomain() + "/inconcert/apps/administration/";
		request.push(
			{
				url: base_uri + "workgroups/search/",
				type: "POST",
				data: {columns: ["Id", "Name", "Description"]},
				success: function(workgroups)
				{
					self.fill_workgroups(workgroups.rows);
				}
			}
		);

		request.push(
			{
				// esto tiene que estar en una funcion dentro de otra, porque sino
				//	dentro de "load_apps_actions, no accede al this que corresponde.
				request_function: function( success ) {
					//realiza un return del resultado del air.invoke.
					//	el mismo es utilizado por si se desea cancelar el request.
					return inConcert.permissions.load_apps_actions( success );
				},
				success: function( application_actions ) {
					self.perm_gui_override.build_apps_permissions( application_actions );
				}
			}
		);
	};

	adm_form_campaigns_section_members.prototype.validate_entity = function() {
		if (!inConcert.app.has_allegro_integration()) {
			// ok
			return {
				success: true
			};
		}
		const campaign = this.get_entity_instance();
		if (!campaign) {
			// ok
			return {
				success: true
			};
		}
		const updateMembersResult = campaign.UpdateMembersResult;
		const resp = inConcert.app.validateAllegroWarningsCampaigns([{
			campaignId: inConcert.app.get_id(campaign.Id),
			error     : updateMembersResult
		}]);
		if (resp.campaignsWithServerDownErrors.length === 0)
			return { // ok
				success: true
			};
		const errType = updateMembersResult.errType;
		if ("ALLEGRO_INTEGRATION_ERROR" === errType) {
			// ALLEGRO error.
			return {
				success: false,
				errType: errType,
				errMsg : m_errMessages[errType]
			};
		}
		/*
			estos valores salen de LUA en el momento que se inserta el archivo JavaScript en el inboxMaster.html
		*/
		const updateMembersInfo = JSON.parse("<%=GetUpdateMembersInfo()%>");
		const nowInSec = Math.floor(new Date().getTime() / 1000);
		const updateMemberElapsedTimeSec = nowInSec - updateMembersResult.time;
		if (updateMembersResult.stepNumber < updateMembersInfo.warnings.stepNumber && updateMemberElapsedTimeSec > updateMembersInfo.warnings.expiredTimeSec) {
			// OCC error.
			return {
				success: false,
				errType: errType,
				errMsg : m_errMessages.ALLEGRO_INTEGRATION_ERROR
			};
		}
		// ok
		return {
			success: true
		};
	};

	adm_form_campaigns_section_members.prototype.AnalyticsSend = function(info = {})
	{
		// basic info
		const analyticsInfo = {};
		// el path viene se envia en un array
		if (this.editing_row_id) {
			analyticsInfo.source_path = [
				{name: "member_id"  , value: this.editing_row_id} // "/main/administration/campaigns/edit/camp1@vcc1/members/pepe@a"
			].concat(info.source_path);
		}
		// invoco a la clase base de secciones
		adm_form_campaigns_section_members.uber.AnalyticsSend.call(this, analyticsInfo);
	};
}());