/*  jshint forin:true, noarg:true, jquery:true, noempty:true, eqeqeq:true, bitwise:true,
  strict:true, undef:true, unused:true, curly:false, browser:true, indent:false, maxerr:50, -W014, esversion: 11 */
 
/* global $, inConcert, Mustache */

if (!this.inConcert) {
	this.inConcert = {};
}

(function () {

	const format = inConcert.Utils.format;
	const _T = inConcert.i18n.getString;

	/*---------------------------------------------------------------------
	CLASS RULES FRM.
	---------------
		Esta clase es la encargada de realizar el Alta/Modificacion client/side desde el frm de rules.
		Aqui se encuentra el nombre, la descripcion.
	*/

	function rules_frm( params )
	{
		this.parent = params.parent;
	// dom ids
		// frm
		this.id_frm_container		= "adm_form_campaign_rules_edition";
		// inputs
		this.id_rule_name			= "adm_form_campaign_rules_edition_name";
		this.id_rule_description	= "adm_form_campaign_rules_edition_description";
		this.id_rule_channel		= "adm_form_campaign_rules_edition_channel";
		this.id_rule_account		= "adm_form_campaign_rules_edition_account";
		this.id_rule_direction		= "adm_form_campaign_rules_edition_direction";
		this.id_rule_type			= "adm_form_campaign_rules_edition_type";
		this.id_rule_page			= "adm_form_campaign_rules_edition_page";
		this.id_rule_post			= "adm_form_campaign_rules_edition_post";
		this.id_rule_batch			= "adm_form_campaign_rules_edition_batch";
		this.id_stop_processing		= "adm_form_campaign_rules_edition_stoprules";
		this.id_actions_selector	= "adm_form_campaign_rules_edition_actionoptions";
		// buttons actions
		this.id_frm_actions			= "adm_form_campaign_rules_edition_actions";
		this.id_create				= "adm_form_campaign_rules_edition_create";
		this.id_cancel				= "adm_form_campaign_rules_edition_close";
		//filters
		this.id_filters_container	= "adm_form_campaign_rules_edition_form_filters";
		//fields filters
		this.id_filters_preexistent	= "adm_form_campaign_rules_edition_form_filters_preexistent";
		this.id_filters_captured	= "adm_form_campaign_rules_edition_form_filters_captured";
		this.id_filters_limit		= "adm_form_campaign_rules_edition_form_filters_limit";
		//actions
		this.id_actions_container	= "adm_form_campaign_rules_edition_form_actions";
		this.id_action_labels		= "adm_form_campaign_rules_edition_form_actions_labels";

		this.filters = {
			matches: {
				container_id		: "adm_form_campaign_rules_edition_match_container"
			},
			contact_id: {
				container_id		: "adm_form_campaign_rules_edition_contactid_container",
				control_id			: "adm_form_campaign_rules_edition_contactid"
			},
			contact_name: {
				container_id		: "adm_form_campaign_rules_edition_contactname_container",
				control_id			: "adm_form_campaign_rules_edition_contactname"
			},
			addresses: {
				container_id		: "adm_form_campaign_rules_edition_addresses_container",
				control_id			: "adm_form_campaign_rules_edition_addresses",
				tooltip				: "<%=_T('FILTER ADDRESSES TOOLTIP')%>"
			},
			from_email: {
				container_id		: "adm_form_campaign_rules_edition_fromemail_container",
				control_id			: "adm_form_campaign_rules_edition_fromemail",
				tooltip				: "<%=_T('FILTER E-MAIL FROM TOOLTIP')%>"
			},
			to_email: {
				container_id		: "adm_form_campaign_rules_edition_toemail_container",
				control_id			: "adm_form_campaign_rules_edition_toemail",
				tooltip				: "<%=_T('FILTER E-MAIL TO TOOLTIP')%>"
			},
			subject: {
				container_id		: "adm_form_campaign_rules_edition_subject_container",
				control_id			: "adm_form_campaign_rules_edition_subject"
			},
			contains: {
				container_id		: "adm_form_campaign_rules_edition_contains_container",
				control_id			: "adm_form_campaign_rules_edition_contains"
			},
			not_contains: {
				container_id		: "adm_form_campaign_rules_edition_notcontains_container",
				control_id			: "adm_form_campaign_rules_edition_notcontains"
			},
			has_attachment: {
				container_id		: "adm_form_campaign_rules_edition_attachment_container",
				control_id			: "adm_form_campaign_rules_edition_attachment"
			},
			from: {
				container_id		: "adm_form_campaign_rules_edition_from_container",
				control_id			: "adm_form_campaign_rules_edition_from"
			},
			hashtag: {
				container_id		: "adm_form_campaign_rules_edition_hashtag_container",
				control_id			: "adm_form_campaign_rules_edition_hashtag"
			},
			language: {
				container_id		: "adm_form_campaign_rules_edition_language_container",
				control_id			: "adm_form_campaign_rules_edition_language"
			},
			country: {
				container_id		: "adm_form_campaign_rules_edition_country_container",
				control_id			: "adm_form_campaign_rules_edition_country"
			},
			transferred: {
				container_id		: "adm_form_campaign_rules_edition_transferred_container",
				active				: "adm_form_campaign_rules_edition_transferred",
				campaign			: "adm_form_campaign_rules_edition_transferred_campaign",
				account				: "adm_form_campaign_rules_edition_transferred_account"
			},
			post_attributes: {
				container_id		: "adm_form_campaign_rules_edition_post_attributes_container",
				control_id			: "adm_form_campaign_rules_edition_post_attributes"
			},
			batch_attributes: {
				container_id		: "adm_form_campaign_rules_edition_batch_attributes_container",
				control_id			: "adm_form_campaign_rules_edition_batch_attributes"
			},
			out_of_hour: {
				container_id		: "adm_form_campaign_rules_edition_out_of_hour_container",
				control_id			: "adm_form_campaign_rules_edition_out_of_hour"
			},
			followers: {
				container_id		: "adm_form_campaign_rules_edition_followers_container",
				comparator_symbol	: "adm_form_campaign_rules_edition_followers_comparator",
				followers_to_compare: "adm_form_campaign_rules_edition_followers"
			}
		};

		this.directions = {
			"ALL" : "<%=_T('All directions')%>",
			"INBOUND" : "<%=_T('Inbound')%>",
			"OUTBOUND" : "<%=_T('Outbound')%>"
		};

		this.types = {
			"ALL" : "<%=_T('All types')%>",
			"TWEET_MENTION" : "<%=_T('Mention tweet')%>",
			"PAGE_TWEET_RESPONSE" : "<%=_T('Page tweet response')%>",
			"PAGE_TWEET_QUOTE" : "<%=_T('Page tweet quote')%>",
			"PAGE_TWEET" : "<%=_T('Page tweet')%>",
			"SEARCH_TWEET" : "<%=_T('Search tweet')%>",
			"MENTION" : "<%=_T('Mention')%>",
			"MENTION_POST" : "<%=_T('Mention Post')%>",
			"MENTION_COMMENT" : "<%=_T('Mention Comment')%>",
			"CLIENT_POST" : "<%=_T('Client post')%>",
			"RATE_POST" : "<%=_T('Client rate')%>",
			"PAGE_POST_COMMENT" : "<%=_T('Page post comment')%>",
			"PAGE_POST" : "<%=_T('Page post')%>",
			"PRIVATE_MESSAGE" : "<%=_T('Private message')%>"
		};

		this.actions = {
			mark_as_spam: {
				name					: "<%=_T('Mark as SPAM')%>"
			},
			archive: {
				name					: "<%=_T('Archive conversation')%>"
			},
			transfer: {
				name					: "<%=_T('Transfer')%>",
				destination: {
					container_id		: "adm_form_campaign_rules_edition_transferdestination_container",
					control_id			: "adm_form_campaign_rules_edition_transferdestination"
				},
				campaign: {
					container_id		: "adm_form_campaign_rules_edition_transfercampaign_container",
					control_id			: "adm_form_campaign_rules_edition_transfercampaign"
				},
				account: {
					container_id		: "adm_form_campaign_rules_edition_transferaccount_container",
					control_id			: "adm_form_campaign_rules_edition_transferaccount"
				},
				attentionLevel: {
					container_id		: "adm_form_campaign_rules_edition_transferal_container",
					control_id			: "adm_form_campaign_rules_edition_transferal"
				},
				number: {
					container_id		: "adm_form_campaign_rules_edition_transfernumber_container",
					control_id			: "adm_form_campaign_rules_edition_transfernumber"
				}
			},
			priority: {
				name					: "<%=_T('Change priority')%>",
				container_id			: "adm_form_campaign_rules_edition_priority_container",
				control_id				: "adm_form_campaign_rules_edition_priority"
			},
			skills: {
				name					: "<%=_T('Override skills')%>",
				container_id			: "adm_form_campaign_rules_edition_skills_container"
			},
			play_audio:{
				name					: "<%=_T('Play audio')%>",
				container_id            : "adm_form_campaign_rules_edition_play_audio_container",
				control_id				: "adm_form_campaign_rules_edition_play_audio_add_btn",
				transfer: {
					control_id			: "adm_form_campaign_rules_edition_play_audio_transfer"
				},
				audio: {
					control_id        : "adm_form_campaign_rules_edition_play_audio_name",
				}
			}
		};

		this.actionsByDirection = {
			ALL : {},
			OUTBOUND : {},
			INBOUND : {
				mark_as_spam : true,
				archive : true,
				transfer : true,
				priority : true,
				skills:true,
				play_audio:true,
			}
		};

		this.channels = {
			"ALL": {
				name: "<%=_T('All')%>",
				filters: {
					matches			: this.filters.matches,
					contact_id		: this.filters.contact_id,
					contact_name	: this.filters.contact_name,
					post_attributes : this.filters.post_attributes,
					batch_attributes : this.filters.batch_attributes
				},
				filters_preexistent	: false,
				filters_captured	: false,
				filters_limit		: true,
				actions : {
					archive	: { 
						definition: this.actions.archive 
					},
					transfer : { 
						definition : this.actions.transfer,
						campaign : false,
						attentionLevel : true
					},
					priority : { 
						definition: this.actions.priority 
					},
					skills: {
						definition: this.actions.skills
					}
				},
				directions : {
					ALL : [],
					INBOUND : [],
					OUTBOUND : []
				}
			},
			"CALL": {
				name: "<%=_T('Call')%>",
				filters: {
					matches			: this.filters.matches,
					contact_id		: this.filters.contact_id,
					contact_name	: this.filters.contact_name
				},
				filters_preexistent	: false,
				filters_captured	: false,
				filters_limit		: true,
				actions : {
					archive : { 
						definition: this.actions.archive 
					},
					transfer : { 
						definition : this.actions.transfer,
						campaign : true,
						attentionLevel : true,
						number: true
					},
					priority : { 
						definition: this.actions.priority 
					},
					skills: {
						definition: this.actions.skills
					},
					play_audio:{
						definition: this.actions.play_audio
					}
				},
				directions : {
					ALL : [],
					INBOUND : [],
					OUTBOUND : []
				}
			},
			"WEBCONTACT": {
				name: "<%=_T('Contact Form')%>",
				filters: {
					matches			: this.filters.matches,
					contact_id		: this.filters.contact_id,
					contact_name	: this.filters.contact_name,
					addresses		: this.filters.addresses
				},
				filters_preexistent	: true,
				filters_captured	: true,
				filters_limit		: true,
				actions : {
					archive	: { 
						definition: this.actions.archive 
					},
					transfer : { 
						definition : this.actions.transfer,
						campaign : false,
						attentionLevel : true
					},
					priority	: { 
						definition: this.actions.priority 
					},
					skills: {
						definition: this.actions.skills
					}
				},
				directions : {
					INBOUND : []
				}
			},
			"CHAT": {
				name: "<%=_T('Web Chat')%>",
				filters: {
					matches			: this.filters.matches,
					contact_id		: this.filters.contact_id,
					contact_name	: this.filters.contact_name,
					addresses		: this.filters.addresses,
					transferred		: this.filters.transferred
				},
				filters_preexistent	: true,
				filters_captured	: true,
				filters_limit		: true,
				actions : {
					archive	: { 
						definition: this.actions.archive 
					},
					transfer : { 
						definition : this.actions.transfer,
						campaign : true,
						attentionLevel : true
					},
					priority : { 
						definition: this.actions.priority 
					},
					skills: {
						definition: this.actions.skills
					}
				},
				directions : {
					INBOUND : []
				}
			},
			"FACEBOOK": {
				name: "<%=_T('Facebook')%>",
				filters: {
					matches			: this.filters.matches,
					contact_id		: this.filters.contact_id,
					contact_name	: this.filters.contact_name,
					contains		: this.filters.contains,
					not_contains	: this.filters.not_contains,
					from			: this.filters.from,
					hashtag			: this.filters.hashtag,
					post_attributes : this.filters.post_attributes
				},
				tooltips : {
					hashtag			: "<%=_T('Message contains determined hashtag (like #MY_HASHTAG)')%>",
					contains		: "<%=_T('Matches message content and from')%>",
					not_contains	: "<%=_T('Matches message content and from')%>"
				},
				filters_preexistent	: false,
				filters_captured	: false,
				filters_limit		: true,
				actions : {
					archive	: { 
						definition: this.actions.archive 
					},
					transfer : { 
						definition : this.actions.transfer,
						campaign : false,
						attentionLevel : true
					},
					priority : { 
						definition: this.actions.priority 
					},
					skills: {
						definition: this.actions.skills
					}
				},
				directions : {
					INBOUND : ["ALL", "CLIENT_POST", "RATE_POST", "PAGE_POST_COMMENT", "PRIVATE_MESSAGE"]
				}
			},
			"INSTAGRAM": {
				name: "<%=_T('Instagram')%>",
				filters: {
					matches			: this.filters.matches,
					contact_id		: this.filters.contact_id,
					contact_name	: this.filters.contact_name,
					contains		: this.filters.contains,
					not_contains	: this.filters.not_contains,
					from			: this.filters.from,
					hashtag			: this.filters.hashtag,
					post_attributes : this.filters.post_attributes
				},
				tooltips : {
					hashtag			: "<%=_T('Message contains determined hashtag (like #MY_HASHTAG)')%>",
					contains		: "<%=_T('Matches message content and from')%>",
					not_contains	: "<%=_T('Matches message content and from')%>"
				},
				filters_preexistent	: false,
				filters_captured	: false,
				filters_limit		: true,
				actions : {
					archive	: { 
						definition: this.actions.archive 
					},
					transfer : { 
						definition : this.actions.transfer,
						campaign : false,
						attentionLevel : true
					},
					priority : { 
						definition: this.actions.priority 
					},
					skills: {
						definition: this.actions.skills
					}
				},
				directions : {
					INBOUND : ["ALL", "PAGE_POST_COMMENT", "MENTION_POST", "MENTION_COMMENT"/*, "PRIVATE_MESSAGE"*/]
				}
			},
			"YOUTUBE": {
				name: "<%=_T('Youtube')%>",
				filters: {
					matches			: this.filters.matches,
					contact_id		: this.filters.contact_id,
					contact_name	: this.filters.contact_name,
					contains		: this.filters.contains,
					not_contains	: this.filters.not_contains,
					from			: this.filters.from,
					hashtag			: this.filters.hashtag,
					post_attributes : this.filters.post_attributes
				},
				tooltips : {
					hashtag			: "<%=_T('Message contains determined hashtag (like #MY_HASHTAG)')%>",
					contains		: "<%=_T('Matches message content and from')%>",
					not_contains	: "<%=_T('Matches message content and from')%>"
				},
				filters_preexistent	: false,
				filters_captured	: false,
				filters_limit		: true,
				actions : {
					archive	: { 
						definition: this.actions.archive 
					},
					transfer : { 
						definition : this.actions.transfer,
						campaign : false,
						attentionLevel : true
					},
					priority : { 
						definition: this.actions.priority 
					},
					skills: {
						definition: this.actions.skills
					}
				},
				directions : {
					INBOUND : ["ALL", "PAGE_POST_COMMENT", "MENTION_POST", "MENTION_COMMENT"/*, "PRIVATE_MESSAGE"*/]
				}
			},
			"APPSTORE": {
				name: "<%=_T('Appstore')%>",
				filters: {
					matches			: this.filters.matches,
					contact_id		: this.filters.contact_id,
					contact_name	: this.filters.contact_name,
					contains		: this.filters.contains,
					not_contains	: this.filters.not_contains,
					from			: this.filters.from,
					hashtag			: this.filters.hashtag
				},
				tooltips : {
					hashtag			: "<%=_T('Message contains determined hashtag (like #MY_HASHTAG)')%>",
					contains		: "<%=_T('Matches message content and from')%>",
					not_contains	: "<%=_T('Matches message content and from')%>"
				},
				filters_preexistent	: false,
				filters_captured	: false,
				filters_limit		: true,
				actions : {
					archive	: { 
						definition: this.actions.archive 
					},
					transfer : { 
						definition : this.actions.transfer,
						campaign : false,
						attentionLevel : true
					},
					priority : { 
						definition: this.actions.priority 
					},
					skills: {
						definition: this.actions.skills
					}
				},
				directions : {
					ALL : [],
					INBOUND : []
				}
			},
			"GOOGLEPLAY": {
				name: "<%=_T('Googleplay')%>",
				filters: {
					matches			: this.filters.matches,
					contact_id		: this.filters.contact_id,
					contact_name	: this.filters.contact_name,
					contains		: this.filters.contains,
					not_contains	: this.filters.not_contains,
					from			: this.filters.from,
					hashtag			: this.filters.hashtag
				},
				tooltips : {
					hashtag			: "<%=_T('Message contains determined hashtag (like #MY_HASHTAG)')%>",
					contains		: "<%=_T('Matches message content and from')%>",
					not_contains	: "<%=_T('Matches message content and from')%>"
				},
				filters_preexistent	: false,
				filters_captured	: false,
				filters_limit		: true,
				actions : {
					archive	: { 
						definition: this.actions.archive 
					},
					transfer : { 
						definition : this.actions.transfer,
						campaign : false,
						attentionLevel : true
					},
					priority : { 
						definition: this.actions.priority 
					},
					skills: {
						definition: this.actions.skills
					}
				},
				directions : {
					ALL : [],
					INBOUND : []
				}
			},
			"IM": {
				name: "<%=_T('IM')%>",
				filters : {
					matches			: this.filters.matches,
					contact_id		: this.filters.contact_id,
					contact_name	: this.filters.contact_name
				},
				filters_preexistent	: false,
				filters_captured	: false,
				filters_limit		: true,
				actions : {
					archive	: { 
						definition: this.actions.archive 
					},
					transfer : { 
						definition : this.actions.transfer,
						campaign : false,
						attentionLevel : true
					},
					priority : { 
						definition: this.actions.priority 
					},
					skills: {
						definition: this.actions.skills
					}
				},
				directions : {
					ALL : [],
					INBOUND : [],
					OUTBOUND : []
				}
			},
			"MAIL": {
				name: "<%=_T('E-mail')%>",
				filters: {
					matches			: this.filters.matches,
					contact_id		: this.filters.contact_id,
					contact_name	: this.filters.contact_name,
					contains		: this.filters.contains,
					not_contains	: this.filters.not_contains,
					from_email		: this.filters.from_email,
					to_email		: this.filters.to_email,
					has_attachment	: this.filters.has_attachment,
					subject			: this.filters.subject
				},
				tooltips : {
					contains		: "<%=_T('Matches subject, body and addresses')%>",
					not_contains	: "<%=_T('Matches subject, body and addresses')%>"
				},
				filters_preexistent	: false,
				filters_captured	: false,
				filters_limit		: true,
				actions : {
					archive	: { 
						definition: this.actions.archive 
					},
					mark_as_spam : { 
						definition: this.actions.mark_as_spam 
					},
					transfer : { 
						definition : this.actions.transfer,
						campaign : true,
						attentionLevel : true
					},
					priority : { 
						definition: this.actions.priority 
					},
					skills: {
						definition: this.actions.skills
					}
				},
				directions : {
					ALL : [],
					INBOUND : [],
					OUTBOUND : []
				}
			},
			"SMS": {
				name: "<%=_T('SMS')%>",
				filters: {
					matches			: this.filters.matches,
					contact_id		: this.filters.contact_id,
					contact_name	: this.filters.contact_name,
					batch_attributes : this.filters.batch_attributes
				},
				filters_preexistent	: false,
				filters_captured	: false,
				filters_limit		: true,
				actions : {
					archive	: { 
						definition: this.actions.archive 
					},
					transfer : { 
						definition : this.actions.transfer,
						campaign : true,
						attentionLevel : true
					},
					priority	: { 
						definition: this.actions.priority 
					},
					skills: {
						definition: this.actions.skills
					}
				},
				directions : {
					ALL : [],
					INBOUND : [],
					OUTBOUND : []
				}
			},
			"WHATSAPP": {
				name: "<%=_T('Whatsapp')%>",
				filters: {
					matches			: this.filters.matches,
					contact_id		: this.filters.contact_id,
					contact_name	: this.filters.contact_name,
					batch_attributes : this.filters.batch_attributes,
					out_of_hour		: this.filters.out_of_hour
				},
				filters_preexistent	: false,
				filters_captured	: false,
				filters_limit		: true,
				actions : {
					archive	: { 
						definition: this.actions.archive 
					},
					transfer : { 
						definition : this.actions.transfer,
						campaign : true,
						attentionLevel : true
					},
					priority	: { 
						definition: this.actions.priority 
					},
					skills: {
						definition: this.actions.skills
					}
				},
				directions : {
					ALL : [],
					INBOUND : [],
					OUTBOUND : []
				}
			},
			"RCS": {
				name: "<%=_T('Rcs')%>",
				filters: {
					matches			: this.filters.matches,
					contact_id		: this.filters.contact_id,
					contact_name	: this.filters.contact_name,
					batch_attributes : this.filters.batch_attributes
				},
				filters_preexistent	: false,
				filters_captured	: false,
				filters_limit		: true,
				actions : {
					archive	: { 
						definition: this.actions.archive 
					},
					transfer : { 
						definition : this.actions.transfer,
						campaign : true,
						attentionLevel : true
					},
					priority	: { 
						definition: this.actions.priority 
					},
					skills: {
						definition: this.actions.skills
					}
				},
				directions : {
					ALL : [],
					INBOUND : [],
					OUTBOUND : []
				}
			},
			"TWITTER": {
				name: "<%=_T('Twitter')%>",
				filters: {
					matches			: this.filters.matches,
					contact_id		: this.filters.contact_id,
					contact_name	: this.filters.contact_name,
					contains		: this.filters.contains,
					not_contains	: this.filters.not_contains,
					from			: this.filters.from,
					hashtag			: this.filters.hashtag,
					country			: this.filters.country,
					language		: this.filters.language,
					post_attributes : this.filters.post_attributes,
					followers       : this.filters.followers,
				},
				tooltips : {
					hashtag			: "<%=_T('Tweet contains determined hashtag (like #MY_HASHTAG)')%>",
					contains		: "<%=_T('Matches message and participants')%>",
					not_contains	: "<%=_T('Matches message and participants')%>",
					country			: "<%=_T('TWITTER COUNTRY TOOLTIP')%>",
					language		: "<%=_T('TWITTER LANGUAGE TOOLTIP')%>"
				},
				filters_preexistent	: false,
				filters_captured	: false,
				filters_limit		: true,
				actions : {
					archive	: { 
						definition: this.actions.archive 
					},
					transfer : { 
						definition : this.actions.transfer,
						campaign : false,
						attentionLevel : true
					},
					priority	: { 
						definition: this.actions.priority 
					},
					skills: {
						definition: this.actions.skills
					}
				},
				directions : {
					INBOUND : ["ALL", "TWEET_MENTION", "PAGE_TWEET_RESPONSE", "PAGE_TWEET_QUOTE", "SEARCH_TWEET", "PRIVATE_MESSAGE"]
				}
			}
		};

		this.m_campaigns = null;
		this.initialize();
	}
	
	rules_frm.prototype.__channelHasPages = function(channel) {
		return inConcert.app.channelHasPages(channel);
	};

	rules_frm.prototype.__show_or_hide_play_audio_section = function(show) {
		$("#" + this.actions.play_audio.container_id).toggle(show);
		$("#" + this.actions.play_audio.audio.control_id).val("");
		$("#" + this.actions.play_audio.transfer.control_id).prop("checked", false);
		$("#" + this.actions.play_audio.transfer.control_id).change();
	};

	rules_frm.prototype.show_popup_shared_file = function($parent)
	{
		const self = this;

		this.m_filePopup = null;
		this.m_filePopup = new inConcert.SharedFilesPopupList({
			from_app            : "administration",
			owner               : this,
			popupId             : "adm_form_campaign_rules_edition_play_audio_shared_file_popup_container",
			search_files_type_id: "asterisk_audio",
			abm_files_type_id   : "asterisk_audio",
			visibility          : {
				AgentVisible          : true,
				AccountMessagesVisible: false,
				FlowDesignerVisible   : false
			},
			custom_class        : "internalPopUpContainer formPopUp flowDesignerPopUpContainer flowDesignerSharedFilesSelectorPopup",
			callbacks: {
				on_show: function() {},
				on_close: function(selected_file) {
					if (!selected_file) {
						// Si cerro el popup por cancelar
						return;
					}
					// Si cerro el popup por guardar
					let file_info = {
						id     : selected_file.RepositoryId,
						section: selected_file.Section || "-1",
						name : selected_file.Name,
						type: selected_file.ContentType,
						extension: selected_file.Extension
					};
					$("#" + self.actions.play_audio.audio.control_id).data(file_info);
					$("#" + self.actions.play_audio.audio.control_id).val(selected_file.Name);
				}
			}
		});

		this.m_filePopup.show({
			parentNode: $parent,
			option_id : "audio",
			can_create_new_file: true
		});
	};

	rules_frm.prototype.show_or_hide_skills_section = function(show) {

		if (this.skills_handle) {
			if (show) {
				this.skills_handle.show_container();
			}
			else {
				this.skills_handle.hide_container();
			}		
		}
	};

	rules_frm.prototype.initialize_skills = function()
	{
		const parameters = {
			container_id : "adm_form_campaign_rules_edition_skills_container",
			input_ctrls  : {
				skill_value : "COMBO",
				skill_required : true
			},
			parent_frm   : this.parent.frm,
			parent_type  : "FORM-SECTION",
			title        : "<%=_T('Skills')%>",
			help         : "<%=_T('Override campaign skill weights from a rule.')%>"
		};

		this.skills_handle = new inConcert.adm_skills_handle( parameters );
		this.skills_handle.initialize();
	};

	rules_frm.prototype.initialize = function() {
		this.initialize_skills();
		this.load_channels();
		this.__load_Channel_call_packages();
		this.set_events();
	};

	rules_frm.prototype.__load_Channel_call_packages = function() {
		/*
			Esta funcion va a permitir buscar cuando se selecciona canal de CALL, para la cuenta seleccionadas o todas.
			Si la/s cuenta/s tienen packetes en modo salida, para poder ver la opcion de transferir a numero.
		*/
		const self = this;
		inConcert.app.loadPackages("CALL", false, function(success, packages) {

			if (success && Object.keys( packages || {} ).length > 0) {
				self.telephonyPackages = packages;
				return;
			}
			delete self.telephonyPackages;
			if (!success) {
				let message = "<%=_T('Error retrieving inconcert telephony packages.')%>";
				console.log(message);
			}
		});
	};

	rules_frm.prototype.load_channels = function() {
		var can_add_fn = function(channel_id/*, item*/) {
			if (channel_id !== "ALL" && !inConcert.app.hasLicensesForChannel(channel_id)) {
				return false;
			}
			return true;
		};
		const $rule_channel = $("#" + this.id_rule_channel);
		this.parent.frm.fill_combo($rule_channel, false, this.channels, null, "name", false, can_add_fn);
	};

	rules_frm.prototype.get = function()
	{
		var name = $("#" + this.id_rule_name).val();
		var description = $("#" + this.id_rule_description).val();
		var channel = $("#" + this.id_rule_channel).val();
		var account = $("#" + this.id_rule_account).val();
		var direction = $("#" + this.id_rule_direction).val();
		var interaction_type = $("#" + this.id_rule_type).val() || "ALL";
		var page = this.__channelHasPages(channel) && $("#" + this.id_rule_page).val() || "ALL";

		const social_networks_api = inConcert.app.getSocialNetworksAPI();
		var post = social_networks_api.isChannelAvailable(channel) && $("#" + this.id_rule_post).val() || "ALL";
		if (post !== "ALL") {
			direction = "ALL";
			interaction_type = "ALL";
		}

		const batches_mng_api = inConcert.app.getBatchesMngAPI();
		var batch = batches_mng_api.isChannelAvailable(channel) && $("#" + this.id_rule_batch).val() || "ALL";
		if (batch !== "ALL") {
			direction = "ALL";
			interaction_type = "ALL";
		}
		//id
		var id;
		if ( this.parent.$row_editing ) {
			id = this.parent.$row_editing.attr("rule_id");
		}
		else {
			id = name;
		}
		id = id.toUpperCase();
		//index
		var index = this.parent.$row_editing?
				  parseInt(this.parent.$row_editing.attr("rule_index"))
				: this.parent.$get_rows().length;
		//filters
		var filters = {};
		var available_filters = this.channels[channel].filters;

		var filters_matches = available_filters.matches?
			  $("#" + available_filters.matches.container_id)
					.find("input[type=radio]:checked")
					.val()
			: "ALL";

		filters.contact_id = available_filters.contact_id?
			($("#" + available_filters.contact_id.control_id).val() || undefined) : undefined;

		filters.contact_name = available_filters.contact_name?
			($("#" + available_filters.contact_name.control_id).val() || undefined) : undefined;

		filters.addresses = available_filters.addresses?
			($("#" + available_filters.addresses.control_id).val() || undefined) : undefined;

		filters.from_email = available_filters.from_email?
			($("#" + available_filters.from_email.control_id).val() || undefined) : undefined;

		filters.to_email = available_filters.to_email?
			($("#" + available_filters.to_email.control_id).val() || undefined) : undefined;

		filters.subject = available_filters.subject?
			($("#" + available_filters.subject.control_id).val() || undefined) : undefined;

		filters.contains = available_filters.contains?
			($("#" + available_filters.contains.control_id).val() || undefined) : undefined;

		filters.not_contains = available_filters.not_contains?
			($("#" + available_filters.not_contains.control_id).val() || undefined) : undefined;

		filters.from = available_filters.from?
			($("#" + available_filters.from.control_id).val() || undefined) : undefined;

		filters.hashtag = available_filters.hashtag?
			($("#" + available_filters.hashtag.control_id).val() || undefined) : undefined;

		filters.country = available_filters.country?
			($("#" + available_filters.country.control_id).val() || undefined) : undefined;

		filters.language = available_filters.language?
			($("#" + available_filters.language.control_id).val() || undefined) : undefined;

		filters.post_attributes = available_filters.post_attributes?
			($("#" + available_filters.post_attributes.control_id).val() || undefined) : undefined;

		filters.batch_attributes = available_filters.batch_attributes?
			($("#" + available_filters.batch_attributes.control_id).val() || undefined) : undefined;
			
		filters.has_attachment = available_filters.has_attachment?
			  $("#" + available_filters.has_attachment.control_id).prop("checked")? "1" : undefined
			: undefined;
			
		filters.out_of_hour = available_filters.out_of_hour?
			  $("#" + available_filters.out_of_hour.control_id).prop("checked")? "1" : undefined
			: undefined;			
			
		if (available_filters.transferred && $("#" + available_filters.transferred.active).prop("checked")) {
			filters.transferred = {
				campaign : $("#" + available_filters.transferred.campaign).val() || "ALL",
				account : $("#" + available_filters.transferred.account).val() || "ALL"
			};
		}

		if(available_filters.followers ){

			const $comparator_symbol = $("#" + available_filters.followers.comparator_symbol);
			const $followers_to_compare = $("#" + available_filters.followers.followers_to_compare);

			if($comparator_symbol.val() !== "" && $followers_to_compare.val() !== "") {
				filters.followers = {
					comparator_symbol : $comparator_symbol.val(),
					followers_to_compare : $followers_to_compare.val()
				};
			}
			else {
				filters.followers = undefined;
				$comparator_symbol.val("");
				$followers_to_compare.val("");
			}
		}

		var filters_preexistent = this.channels[channel].filters_preexistent?
			this.fields_filter_get(this.id_filters_preexistent) : undefined;
		var filters_captured = this.channels[channel].filters_captured?
			this.fields_filter_get(this.id_filters_captured) : undefined;
		var filters_limit = this.channels[channel].filters_limit?
			this.fields_filter_get(this.id_filters_limit) : undefined;

		//actions
		var actions = {};
		var stop_processing = $("#" + this.id_stop_processing).prop("checked")? "1" : "0";

		var selectedAction = $("#" + this.id_actions_selector).val();
		switch(selectedAction) {
			case "mark_as_spam":
				actions.mark_as_spam = "1";
				break;
			case "archive":
				actions.archive = "1";
				break;
			case "transfer":
				actions.transfer = {
					destination : $("#" + this.actions.transfer.destination.control_id).val()
				};
				switch(actions.transfer.destination) {
					case "campaign":
						actions.transfer.campaign = $("#" + this.actions.transfer.campaign.control_id).val();
						actions.transfer.account = $("#" + this.actions.transfer.account.control_id).val();
						break;
					case "attentionLevel":
						actions.transfer.attentionLevel = $("#" + this.actions.transfer.attentionLevel.control_id).val();
						break;
					case "number":
						actions.transfer.number = $("#" + this.actions.transfer.number.control_id).val();
						break;
				}
				break;
			case "priority":
				actions.priority = $("#" + this.actions.priority.control_id).val();
				break;
			case "skills":
				actions.skills = this.skills_handle.get();
				break;
			case "play_audio":
				this.action_play_audio_get(actions);
				break;
		}

		var actions_labels = this.action_labels_get();

		return {
			id						: id,
			name					: name,
			description				: description,
			disabled				: this.currentRule.disabled || "0",
			channel					: channel,
			account					: account,
			direction				: direction,
			interaction_type		: interaction_type,
			page					: page,
			post					: post,
			batch					: batch,
			index					: index,
			filters					: filters,
			filters_matches			: filters_matches,
			filters_preexistent		: filters_preexistent,
			filters_captured		: filters_captured,
			filters_limit			: filters_limit,
			actions					: actions,
			actions_labels			: actions_labels,
			stop_processing			: stop_processing
		};
	};

	rules_frm.prototype.set = function( rule )
	{
		rule = rule || 
			{
				filters : {}, 
				filters_preexistent: [], 
				filters_captured: [],
				filters_limit: [], 
				actions : {},
				actions_labels: []
			};
		this.currentRule = rule;

		$("#" + this.id_rule_name).val( rule.name || "" );
		$("#" + this.id_rule_description).val( rule.description || "");

		$("#" + this.id_rule_channel).val( rule.channel || "ALL");

		$("#" + this.id_rule_direction)
				.val( rule.direction || "ALL")
				.change();

		$("#" + this.id_rule_type).val( rule.interaction_type || "ALL");

		this.load_channel_change(rule.filters, rule.actions, rule.account);

		$("#" + this.id_rule_page)
				.val( rule.page || "ALL")
				.change();

		$("#" + this.id_rule_post)
			.val(rule.post || "ALL")
			.change();

		$("#" + this.id_rule_batch)
			.val(rule.batch || "ALL")
			.change();

		//filters
		$("#" + this.filters.matches.container_id)
			.find(format("input[type=radio][value={0}]", rule.filters_matches || "ALL"))
			.prop("checked", true);

		$("#" + this.filters.contact_id.control_id).val( rule.filters.contact_id || "");

		$("#" + this.filters.contact_name.control_id).val( rule.filters.contact_name || "");

		$("#" + this.filters.addresses.control_id).val( rule.filters.addresses || "");

		$("#" + this.filters.from_email.control_id).val( rule.filters.from_email || "");

		$("#" + this.filters.to_email.control_id).val( rule.filters.to_email || "");

		$("#" + this.filters.subject.control_id).val( rule.filters.subject || "");

		$("#" + this.filters.contains.control_id).val( rule.filters.contains || "");

		$("#" + this.filters.not_contains.control_id).val( rule.filters.not_contains || "");

		$("#" + this.filters.from.control_id).val( rule.filters.from || "");

		$("#" + this.filters.hashtag.control_id).val( rule.filters.hashtag || "");

		$("#" + this.filters.country.control_id).val( rule.filters.country || "");

		$("#" + this.filters.language.control_id).val( rule.filters.language || "");

		$("#" + this.filters.post_attributes.control_id).val( rule.filters.post_attributes || "");

		$("#" + this.filters.batch_attributes.control_id).val( rule.filters.batch_attributes || "");

		$("#" + this.filters.followers.comparator_symbol).val((rule.filters.followers && rule.filters.followers.comparator_symbol) || "");
		$("#" + this.filters.followers.followers_to_compare).val( (rule.filters.followers && rule.filters.followers.followers_to_compare) || "");

		$("#" + this.filters.has_attachment.control_id).prop("checked", rule.filters.has_attachment === "1");
		
		$("#" + this.filters.out_of_hour.control_id).prop("checked", rule.filters.out_of_hour === "1");

		this.fields_filter_load(this.id_filters_preexistent, rule.filters_preexistent);
		this.fields_filter_load(this.id_filters_captured, rule.filters_captured);
		this.fields_filter_load(this.id_filters_limit, rule.filters_limit);

		//actions (el resto se procesan en load_channel_change)

		$("#" + this.id_stop_processing).prop("checked", rule.stop_processing === "1");

		$("#" + this.actions.priority.control_id).val(rule.actions.priority || "");

		//se agrego el procesamiento de los datos de skills
		if (this.skills_handle) {
			if (rule.actions.skills) {
				this.skills_handle.set(rule.actions.skills);
			}
			else{
				this.skills_handle.initialize();
			}
		}
		this.actions_labels_load(rule.actions_labels);

		//play_audio for call
		if (rule.actions.play_audio) {
			const is_checked = !!rule.actions.play_audio.transfer;
			$("#" + this.actions.play_audio.transfer.control_id).prop("checked", is_checked);
			if (is_checked) {
				this.show_transfer_options(true, rule.actions.play_audio.transfer.destination);
				$("#" + this.actions.transfer.destination.control_id).val(rule.actions.play_audio.transfer.destination);
			}
			$("#" + this.actions.play_audio.audio.control_id).val(rule.actions.play_audio.audio.name);
			$("#" + this.actions.play_audio.audio.control_id).data(rule.actions.play_audio.audio);
		}
	};

	rules_frm.prototype.show = function( current_rule, callback )
	{
		callback = callback || $.noop;
		var self = this;
		self.__load_data(function() {
			self.set( current_rule );
			var $create = $("#" + self.id_create);

			if ( !current_rule ) {
			// si presione el boton para crear uno nuevo
				$create.val("<%=_T('Create')%>");
			}
			else {
			// si presione el boton para editar
				$create.val("<%=_T('Update')%>");
				if (current_rule.error) {
					self.parent.frm.show_status_message( self.parent.make_rule_error(current_rule.error), "Error", false );
				}
				self.parent.frm.change_title_section(self.parent.section_id, current_rule?.name);
			}
			$("#" + self.id_frm_container).show();
			$("#" + self.id_frm_actions).show();

			callback();
			self.on_show();
		});
	};
	
	rules_frm.prototype.__load_data = function(callback) {
		var self = this;
		self.__load_posts(function() {
			self.__load_batches(callback);
		});
	};

	rules_frm.prototype.__load_posts = function(callback) {
		const self = this;
		const social_networks_api = inConcert.app.getSocialNetworksAPI();
		let campaignId = this.parent.frm.campaign.Id;
		social_networks_api.getCampaignPosts(campaignId, function(posts) {
			if (!posts) {
				self.parent.frm.show_status_message("<%=_T('Error loading posts.')%>", "Error", false );
			}
			self.m_posts = posts || [];
			callback();
		});
	};

	rules_frm.prototype.__load_batches = function(callback = $.noop) {
		const self = this;
		const batches_mng_api = inConcert.app.getBatchesMngAPI();
		let campaignId = this.parent.frm.campaign.Id;
		batches_mng_api.getCampaignBatches(campaignId, function(batches) {
			if (!batches) {
				self.parent.frm.show_status_message("<%=_T('Error loading batches.')%>", "Error", false );
			}
			self.m_batches = batches || [];
			callback();
		});
	};

	rules_frm.prototype.on_show = function()
	{
		//this.parent.frm.add_css_class("pageFormForVisibleButtons");
		var $name = $("#" + this.id_rule_name);
		if ( this.parent.$row_editing ) {
			this.parent.readonly_control( $name, true, false );
			//TODO: dar el foco al resto de los controles, para el siguiente target version
		}
		else {
			this.parent.readonly_control( $name, false, true );
			$name.focus();
		}
	};

	rules_frm.prototype.hide = function()
	{
		this.parent.hide_rule_frm_edition();
	};

	rules_frm.prototype.on_hide = function()
	{
		$("#" + this.id_frm_container).hide();
		$("#" + this.id_frm_actions).hide();
		//this.parent.frm.remove_css_class("pageFormForVisibleButtons");
	};

	rules_frm.prototype.validateFilters = function(filters, show_error)
	{
		var self = this;

		var email_list, validationError;
		//from email
		if (filters.from_email) {
			email_list = {
				from: {
					addresses: filters.from_email,
					get_error: function(result) {
						var message_error;
						var address = inConcert.Utils.truncateWord( result.address );
						switch( result.error_type )
						{
							case "invalid_mail":
								message_error = format( "<%=_T('FROM e-mail account must be a valid e-mail address: {0}.')%>", address );
								break;
							case "invalid_mail_list":
								message_error = format( "<%=_T('FROM e-mail account list must be a valid: {0}. Must use the separator ;.  Example: Contact Name <sample@sample.com>; ... OR sample@sample.com; ...')%>", address );
								break;
							default:
								throw "Invalid validation mail message type";
						}
						return message_error;
					},
					container: null
				}
			};
			validationError = function(result) {
				var email_type = email_list[result.type];
				var message_error = email_type.get_error( result );
				show_error(message_error, $("#" + self.filters.from_email.control_id));
			};
			if (!inConcert.Utils.validateEmails(email_list, validationError)) {
				return false;
			}
		}

		//to email
		if (filters.to_email) {
			email_list = {
				to: {
					addresses: filters.to_email,
					get_error: function(result) {
						var message_error;
						var address = inConcert.Utils.truncateWord( result.address );
						switch( result.error_type )
						{
							case "invalid_mail":
								message_error = format( "<%=_T('TO e-mail account must be a valid e-mail address: {0}.')%>", address );
								break;
							case "invalid_mail_list":
								message_error = format( "<%=_T('TO e-mail account list must be a valid: {0}. Must use the separator ;.  Example: Contact Name <sample@sample.com>; ... OR sample@sample.com; ...')%>", address );
								break;
							default:
								throw "Invalid validation mail message type";
						}
						return message_error;
					},
					container: null
				}
			};
			validationError = function(result) {
				var email_type = email_list[result.type];
				var message_error = email_type.get_error( result );
				show_error(message_error, $("#" + self.filters.to_email.control_id));
			};
			if (!inConcert.Utils.validateEmails(email_list, validationError)) {
				return false;
			}
		}

		//validate followers
		if (filters.followers) {
			var numFollowers = parseInt(filters.followers.followers_to_compare);
			if (isNaN(numFollowers)) {
				show_error("<%=_T('Must enter a followers number.')%>", $("#"+ self.filters.followers.followers_to_compare));
				return false;
			}
		}

		return true;
	};

	rules_frm.prototype.validateTransfer = function(transfer, show_error) {
		if (!transfer) {
			return true;
		}
		var validation_result;
		switch(transfer.destination) {
			case "campaign":
				validation_result = inConcert.Utils.validate( transfer.campaign, "required" );
				if ( !validation_result.success ) {
					show_error("<%=_T('Transferred campaign is required.')%>", 
						$("#" + this.actions.transfer.campaign.control_id));
					return false;
				}
				validation_result = inConcert.Utils.validate( transfer.account, "required" );
				if ( !validation_result.success ) {
					show_error("<%=_T('Transferred account is required.')%>", 
						$("#" + this.actions.transfer.account.control_id));
					return false;
				}
				break;
			case "attentionLevel":
				validation_result = inConcert.Utils.validate( transfer.attentionLevel, "required" );
				if ( !validation_result.success ) {
					show_error("<%=_T('Transferred attention level is required.')%>", 
						$("#" + this.actions.transfer.attentionLevel.control_id));
					return false;
				}
				break;
			case "number":
				validation_result = inConcert.Utils.validate( transfer.number, "required" );
				if ( !validation_result.success ) {
					show_error("<%=_T('Transferred number is required.')%>", 
						$("#" + this.actions.transfer.number.control_id));
						return false;
				}

				if ( !inConcert.app.validatePhoneNumber(transfer.number, "CALL")) {
					show_error("<%=_T('Invalid transfer number.')%>", 
						$("#" + this.actions.transfer.number.control_id));
						return false;
				}

				break;
		}
		return true;
	};


	// VALIDADOR DE SKILLS
	
	rules_frm.prototype.validate_skills = function()
	{
		if ( !this.skills_handle ) {
			return { success: true };
		}
		return this.skills_handle.validate();
	};

	rules_frm.prototype.validate = function()
	{
		var self = this;
		this.parent.frm.hide_messages();

		var show_error = function(message_error, $control)
		{
			self.parent.frm.show_status_message( message_error, "Error", false );
			if ($control) {
				var error_id = $control.attr("id") + "_validation";
				var $error_indicator = $("#" + error_id);
				if ($error_indicator) {
					$error_indicator.show();
				}
				$control.focus();
			}
		};

		var $name = $("#" + this.id_rule_name );
		var $description = $("#" + this.id_rule_description );
		var rule_info = this.get();
		var new_name = rule_info.name.trim().toUpperCase();

		var validation_result = inConcert.Utils.validate( new_name, "required" );
		if ( !validation_result.success ) {
			// valida que el name tenga al menos un caracter
			show_error("<%=_T('Name is required.')%>", $name);
			return false;
		}
		validation_result = inConcert.Utils.validate( new_name, "id" );
		if ( !validation_result.success ) {
			// valida que el name tenga al menos un caracter
			show_error("<%=_T('Only letters, numbers, dashes and dots are allowed in the Name.')%>", $name);
			return false;
		}

		validation_result = inConcert.Utils.validate(new_name, "html_malicious_code");
		if ( !validation_result.success ) {
			// valida codigo malicioso
			show_error("<%=_T('Possible malicious code in the field value.')%>", $name);
			return false;
		}

		var is_new = this.parent.$row_editing ? false : true;
		var $rows = this.parent.$get_rows();
		var already = function()
		{
			var edit_rule_id;
			if ( !is_new ) {
				edit_rule_id = self.parent.$row_editing.attr("rule_id");
			}
			var already_exist = false;
			$rows.each(function( _, row )
			{
				var $row = $(row);
				if ( edit_rule_id !== undefined ) {
				// si estoy editando, no valido sobre el mismo row.
					var row_rule_id = $row.attr("rule_id");
					if (row_rule_id === edit_rule_id) {
						return true; // continue
					}
				}
				var current_name = $row.find( self.parent.selector_row_name ).text();
				already_exist = current_name.trim().toUpperCase() === new_name;
				if (already_exist) {
					show_error("<%=_T('Name already exists.')%>", $name);
					return false; // break
				}
			});
			return already_exist;
		};

		// valida que si estoy agregando un nuevo rule, el mismo ya no exista.
		if (already()) {
			return false;
		}

		validation_result = inConcert.Utils.validate( rule_info.description, "required" );
		if ( !validation_result.success ) {
			show_error("<%=_T('Description is required.')%>", $description);
			return false;
		}

		validation_result = inConcert.Utils.validate(rule_info.description, "html_malicious_code");
		if ( !validation_result.success ) {
			// valida codigo malicioso
			show_error("<%=_T('Possible malicious code in the field value.')%>", $description);
			return false;
		}

		if (!this.validateFilters(rule_info.filters, show_error) ||
			!this.fields_filter_validate(this.id_filters_preexistent, rule_info.filters_preexistent) ||
			!this.fields_filter_validate(this.id_filters_captured, rule_info.filters_captured) ||
			!this.fields_filter_validate(this.id_filters_limit, rule_info.filters_limit) ||
			!this.validateTransfer(rule_info.actions.transfer, show_error)
		) {
			return false;
		}

		if (rule_info.actions.priority !== undefined) {
			var priority = parseInt(rule_info.actions.priority);
			if (isNaN(priority)) {
				show_error("<%=_T('Must enter a priority number.')%>", $(this.actions.priority.control_id));
				return false;
			}
			if (priority < 0 || priority > 99) {
				show_error("<%=_T('Priority must be a number between 0 and 99.')%>", $(this.actions.priority.control_id));
				return false;
			}
		}
		
		if (rule_info.actions.play_audio && !rule_info.actions.play_audio.audio) {
			show_error("<%=_T('Must enter a audio file.')%>", $(this.actions.play_audio.audio.control_id));
			return false;
		}else if(rule_info.actions.play_audio && !this.validateTransfer(rule_info.actions.play_audio.transfer, show_error)){
			return false;
		}

		//validate any action exists
		var actions = rule_info.stop_processing === "1";
		$.each(rule_info.actions, function(_, action) {
			if (action && action !== "0") {
				actions = true;
				return false;
			}
		});
		if (!actions && !rule_info.actions_labels.length) {
			show_error("<%=_T('Must select any action.')%>");
			return false;
		}

		$("#" + this.id_frm_container).find(".formFieldValidation").hide();
		$name.val("");

		// Validacion de SKILLS
		const result_skills = this.validate_skills();
		if ( !result_skills.success ) {
			show_error( result_skills.message, result_skills.$ctrl );
			return false;
		}
	
		return rule_info;
	};
	
	rules_frm.prototype.fields_filter_get_entry_default = function($field) {
		let field = {
			name: $field.find(".ruleFieldName").val(),
			condition: $field.find(".ruleFieldCondition").val(),
			value: $field.find(".ruleFieldValue").val(),
			$control: $field
		};
		if (!field.name && !field.value) {
			field.empty = true;
		}
		return field;
	};
	
	rules_frm.prototype.fields_filter_get_entry_limit = function($field) {
		let field = {
			scope: $field.find(".ruleFieldScope").val(),
			state: $field.find(".ruleFieldState").val(),
			value: parseInt($field.find(".ruleFieldValue").val()),
			$control: $field
		};
		if (!field.scope && !field.value) {
			field.empty = true;
		}
		return field;
	};
	
	rules_frm.prototype.fields_filter_get_entry = function(container, $field) {
		switch(container) {
			case this.id_filters_limit:
				return this.fields_filter_get_entry_limit($field);
			default:
				return this.fields_filter_get_entry_default($field);
		}
	};

	rules_frm.prototype.fields_filter_get = function(container) {
		const self = this;
		let fields = [];
		$("#" + container)
			.find("div.ruleField")
			.each(function(_, field) {
				fields.push(self.fields_filter_get_entry(container, $(field)));
			});
		if (fields.length === 1 && fields[0].empty) {
			return [];
		}
		return fields;
	};
	
	rules_frm.prototype.fields_filter_validate_entry_default = function(field) {
		if (!field.name) {
			return "<%=_T('Field name is required.')%>";
		}
		if (!field.value) {
			return "<%=_T('Field value is required.')%>";
		}
	};
	
	rules_frm.prototype.fields_filter_validate_entry_limit = function(field) {
		if (!field.scope) {
			return "<%=_T('Scope is required.')%>";
		}
		if (!field.state) {
			return "<%=_T('State is required.')%>";
		}
		if (!field.value) {
			return "<%=_T('Limit is required.')%>";
		}
	};
	
	rules_frm.prototype.fields_filter_validate_entry = function(container, field) {
		switch(container) {
			case this.id_filters_limit:
				return this.fields_filter_validate_entry_limit(field);
			default:
				return this.fields_filter_validate_entry_default(field);
		}
	};

	rules_frm.prototype.fields_filter_validate = function(container, fields) {
		const self = this;
		if (!fields) {
			return true;
		}
		
		let show_error = function(message_error, $control)
		{
			self.parent.frm.show_status_message( message_error, "Error", false );
			$control
				.find(".formFieldValidation")
				.show();
			$control
				.find("input.ruleFieldName")
				.focus();
		};

		let error = null;
		$.each(fields, function(_, field) {
			error = self.fields_filter_validate_entry(container, field);
			if (error) {
				show_error(error, field.$control);
				return false;
			}
			delete field.$control;
		});
		return !error;
	};

	rules_frm.prototype.fields_filter_load = function(container, fields) {
		var self = this;
		this.fields_filter_remove_entries(container);
		if (!$.isArray(fields) || !fields.length) {
			return this.fields_filter_add_entry(container);
		}
		$.each(fields, function(_, field) {
			self.fields_filter_add_entry(container, field);
		});
	};

	rules_frm.prototype.fields_filter_remove_entries = function(container) {
		$("#" + container)
			.find("div.ruleField")
			.remove();
	};
	
	rules_frm.prototype.fields_filter_make_entry_default = function(field) {
		let $entry = $(
			"<div class='row ruleField'>" +
				"<div class='col-12'>" +
					"<div class='ruleFieldContent'>" +
						"<div class='form-group flex-grow-1 mr-2'>" +
							"<input class='form-control ruleFieldName' type='text' placeholder='"+ "<%=_T('Enter the value')%>" + "...'>" +
						"</div>" +
						"<div class='form-group mr-2'>" +
							"<select class='form-control ruleFieldCondition'>" +
								"<option value='EQUAL'>=</option>" +
								"<option value='DISTINCT'>!=</option>" +
								"<option value='LESS'>&lt;</option>" +
								"<option value='GREATER'>&gt;</option>" +
								"<option value='LESS_EQUAL'>&lt;=</option>" +
								"<option value='GREATER_EQUAL'>&gt;=</option>" +
								"<option value='CONTAINS'><%=_T('Contains')%></option>" +
								"<option value='NOT_CONTAINS'><%=_T('Not contains')%></option>" +
							"</select>" +
						"</div>" +
						"<div class='form-group flex-grow-1 mr-2'>" +
							"<input class='form-control ruleFieldValue' type='text' placeholder='"+ "<%=_T('Enter the value')%>" + "...'>" +
						"</div>" +
						"<div class='ruleFieldButtons form-group d-flex align-items-end'>" +
							"<button class='buttonToggle buttonToggleOutlined ruleFieldDelete' title='" + " <%=_T('Delete')%> " + "'><i class='far fa-minus-circle'></i></button>" +
							"<button class='buttonToggle buttonToggleOutlined ml-1 ruleFieldAdd' title='" + " <%=_T('Add')%> " + "'><i class='far fa-plus'></i></button>" +
							"<i class='formFieldValidation formFieldError' hidden></i>" +
						"</div>" +
					"</div>" +
				"</div>" +
			"</div>"
		);
		$entry.find(".ruleFieldName").val(field.name || "");
		$entry.find(".ruleFieldCondition").val(field.condition || "EQUAL");
		$entry.find(".ruleFieldValue").val(field.value || "");
		return $entry;
	};
	
	rules_frm.prototype.fields_filter_make_entry_limit = function(field) {
		const self = this;
		let $entry = $(
			"<div class='row ruleField ruleFieldLimit'>" +
				"<div class='col-12'>" +
					"<div class='ruleFieldContent'>" +
						"<div class='form-group flex-grow-1 mr-2'>" +
							"<label>" +
								"<%=_T('Level')%>" +
							"</label>" +
							"<select class='form-control ruleFieldScope'>" +
								"<option value=''></option>" +
								"<option value='CAMPAIGN'><%=_T('Campaign')%></option>" +
								"<option value='ACCOUNT'><%=_T('Account')%></option>" +
								"<option value='ATTENTION_LEVEL'><%=_T('Att Level')%></option>" +
							"</select>" +
						"</div>" +
						"<div class='form-group flex-grow-1 mr-2'>" +
							"<label>" +
								"<%=_T('State')%>" +
							"</label>" +
							"<select class='form-control ruleFieldState'>" +
								"<option value='ALL'><%=_T('All (open)')%></option>" +
								"<option value='BOT'><%=_T('Bot')%></option>" +
								"<option value='WAITING'><%=_T('Waiting (ACD)')%></option>" +
								"<option value='QUEUED'><%=_T('Queued')%></option>" +
								"<option value='ASSIGNED'><%=_T('Assigned')%></option>" +
							"</select>" +
						"</div>" +
						"<div class='form-group flex-grow-1 mr-2'>" +
							"<label>" +
								"<%=_T('Greater or equal than')%>" +
							"</label>" +
							"<input class='form-control ruleFieldValue formFieldHour' type='text' placeholder='"+ "<%=_T('Enter the value')%>" + "...'>" +
						"</div>" +
						"<div class='ruleFieldButtons form-group d-flex align-items-end'>" +
							"<button class='buttonToggle buttonToggleOutlined ruleFieldDelete' title='" + " <%=_T('Delete')%> " + "'><i class='far fa-minus-circle'></i></button>" +
							"<button class='buttonToggle buttonToggleOutlined ml-1 ruleFieldAdd' title='" + " <%=_T('Add')%> " + "'><i class='far fa-plus'></i></button>" +
							"<i class='formFieldValidation formFieldError' hidden></i>" +
						"</div>" +
					"</div>" +
				"</div>" +
			"</div>"
		);
		$entry.find(".ruleFieldScope")
			.change(function() {
				let disabled = !$(this).val();
				self.parent.frm.disable_control($entry.find(".ruleFieldState"), disabled, false);
				self.parent.frm.disable_control($entry.find(".ruleFieldValue"), disabled, false);
			})
			.val(field.scope || "")
			.change();
		$entry.find(".ruleFieldState").val(field.state || "ALL");
		$entry.find(".ruleFieldValue").val(field.value || "");
		return $entry;
	};
	
	rules_frm.prototype.fields_filter_make_entry = function(container, field) {
		switch(container) {
			case this.id_filters_limit:
				return this.fields_filter_make_entry_limit(field);
			default:
				return this.fields_filter_make_entry_default(field);
		}
	};
	
	rules_frm.prototype.fields_filter_add_entry = function(container, field = {}, $addAfter = null) {
		const self = this;
		let $container = $("#" + container);
		let $entry = self.fields_filter_make_entry(container, field);
		
		$entry.find(".ruleFieldAdd").click(function() {
			self.fields_filter_add_entry(container, {}, $entry);
		});
		$entry.find(".ruleFieldDelete").click(function() {
			$entry.remove();
			let $fields = $container.find(".ruleField");
			if (!$fields.length) {
				self.fields_filter_add_entry(container);
			}
		});
		if ($addAfter) {
			$addAfter.after($entry);
		}
		else {
			$container.find(".ruleFieldsDisclaimer").before($entry);
		}
	};

	rules_frm.prototype.action_labels_get = function() {
		var labels = [];
		$("#" + this.id_action_labels)
			.find("li.formListItem")
			.each(function(_, label) {
				var $label = $(label);
				if ($label.find("input.formListCheck:checked").length) {
					labels.push($label.attr("label_id"));
				}
			});
		return labels;
	};

	rules_frm.prototype.action_play_audio_get = function(actions) {
		const transfer = $("#" + this.actions.play_audio.transfer.control_id).prop("checked");
		let play_audio = {
		};
		const $audio_file = $("#" + this.actions.play_audio.audio.control_id);
		if ($audio_file.val().trim() !== "") {
			play_audio.audio = $audio_file.data();
		}

		if (transfer) {
			const destination = $("#" + this.actions.transfer.destination.control_id).val();
			play_audio.transfer = {
				destination : destination
			};
			switch(destination) {
				case "campaign":
					play_audio.transfer.campaign = $("#" + this.actions.transfer.campaign.control_id).val();
					play_audio.transfer.account = $("#" + this.actions.transfer.account.control_id).val();
					break;
				case "attentionLevel":
					play_audio.transfer.attentionLevel = $("#" + this.actions.transfer.attentionLevel.control_id).val();
					break;
				case "number":
					play_audio.transfer.number = $("#" + this.actions.transfer.number.control_id).val();
					break;
			}
		}
		actions.play_audio = play_audio;
	};

	rules_frm.prototype.actions_labels_load = function(selectedLabels) {
		var self = this;
		var $notFound	= $("#" + this.id_action_labels + "_not_results_found");
		var $list		= $("#" + this.id_action_labels + "_list");

		function show_not_results_found(show) {
			$notFound.toggle(!!show);
			$list.toggle(!show);
		}

		function add_label(label, selected) {
			var id = label.Id;
			var input_id = self.id_action_labels + "_" + id;
			var name = label.name || id;
			var color = label.color || "#FFF5EB";
			var class_is_system = label.system === "1" ? "gridImageChecked" : "gridImageUnchecked";

			var $row_html = $(format("".concat(
				"<li label_id='{0}' class='formListItem'>",
					"<input id='{2}' type='checkbox' class='formListCheck' {3} >",
					"<div class='formItemText'>",
						"<label for='{2}' title='{1}'>{1}</label>",
					"</div>",
					"<div class='formItemText gridImageCol'><div class='labelColorContainer' style='background-color:"+ color +";'></div></div>",
					"<div class='formItemText gridImageCol'>",
						"<label for='{2}'>",
							"<span boolean='true' class='{4}' ></span>",
						"</label>",
					"</div>",
				"</li>"
				), id, name, input_id, selected? "checked" : "", class_is_system
			));

			$list.append($row_html);
		}

		function set_labels(labels, selected) {
			$list
				.find("li.formListItem")
				.remove();

			if (!$.isPlainObject(labels)) {
				show_not_results_found(true);
				return;
			}
			var sorted_labels = inConcert.Utils.hash_to_sorted_array(labels,
				function(label) {
					return ( label.name || "" ).toLowerCase();
				}) || {};
			if ( sorted_labels.length === 0 ) {
				show_not_results_found(true);
				return;
			}
			show_not_results_found(false);

			$.each(sorted_labels, function( _, label ) {
				add_label(label, selected[label.Id]);
			});
		}

		var selectedLabelsDictionary = {};
		$.each(selectedLabels, function(_, label) {
			selectedLabelsDictionary[label] = true;
		});

		this.parent.frm.campaign.loadLabels(function(labels, error) {
			if (error) {
				var timeout_ms = 5000;
				self.parent.frm.show_status_message("<%=_T('Campaign has no configured labels.')%>", "Info", timeout_ms);
				return;
			}
			set_labels(labels, selectedLabelsDictionary);
			self.enable_transfer_to_campaign();
		});
	};

	rules_frm.prototype.show_transfer_options = function(active, destination) {
		$("#" + this.actions.transfer.destination.container_id).toggle(active);
		var enabled_camp_destination = active && destination === "campaign";
		$("#" + this.actions.transfer.campaign.container_id).toggle(enabled_camp_destination);
		$("#" + this.actions.transfer.account.container_id).toggle(enabled_camp_destination);
		$("#" + this.actions.transfer.attentionLevel.container_id).toggle(active && destination === "attentionLevel");
		$("#" + this.actions.transfer.number.container_id).toggle(active && destination === "number");
	};

	rules_frm.prototype.load_transfer_options = function(active, destination, values) {
		this.show_transfer_options(active, destination);
		switch(destination) {
			case "campaign":
				return this.load_transfer_options_campaign(values);
			case "attentionLevel":
				return this.load_transfer_options_attentionLevel(values);
			case "number":
				$("#" + this.actions.transfer.number.control_id).val(values && values.number);
				return;
		}
	};

	rules_frm.prototype.load_transfer_options_campaign = function(values) {
		var self = this;
		var currentCampaign = this.parent.frm.campaign.Id;

		function loadCampaigns(callback) {
			inConcert.app.getCampaignAccountsForTransfer(function( success, data )
			{
				if (!success) {
					self.parent.frm.show_status_message("<%=_T('Error retrieving campaign accounts for transfer.')%>", 'Error', false);
					callback();
					return;
				}
				self.m_campaigns = data;
				callback();
			});
		}

		function loadOptions() {
			var campaigns = self.m_campaigns[$("#" + self.id_rule_channel).val()] || {};
			var sorted_campaigns = [];
			if ($.isPlainObject(campaigns)) {
				sorted_campaigns = inConcert.Utils.hash_to_sorted_array(campaigns,
					function(campaign) {
						return ( campaign.Name || "" ).toLowerCase();
					}) || {};
			}

			var html = "";
			$.each(sorted_campaigns, function(_, campaign) {
				if (campaign.Id !== currentCampaign) {
					html += format("<option value='{0}'>{1}</option>", campaign.Id, campaign.Name);
				}
			});

			const $campaign = $("#" + self.actions.transfer.campaign.control_id);
			$campaign.html(html);
			if (values) {
				$campaign.val(values.campaign);
				self.load_transfer_options_account(values);
			}
			else {
				$campaign.change();
			}
		}

		if (this.m_campaigns) {
			return loadOptions();
		}
		loadCampaigns(loadOptions);
	};

	rules_frm.prototype.load_transfer_options_account = function(values) {
		var campaigns	= this.m_campaigns[$("#" + this.id_rule_channel).val()] || {},
			campaign	= campaigns[$("#" + this.actions.transfer.campaign.control_id).val()] || {},
			accounts	= campaign.accounts || {};

		var sorted_accounts = [];
		if ($.isPlainObject(accounts)) {
			sorted_accounts = inConcert.Utils.hash_to_sorted_array(accounts,
				function(account) {
					return ( account.Name || "" ).toLowerCase();
				}) || {};
		}
		var html = "";
		$.each(sorted_accounts, function(_, account) {
			html += format("<option value='{0}'>{1}</option>", account.Id, account.Name);
		});
		$("#" + this.actions.transfer.account.control_id).html(html);
		if (values) {
			$("#" + this.actions.transfer.account.control_id).val(values.account);
		}
	};

	rules_frm.prototype.load_transfer_options_attentionLevel = function(values, callback) {
		callback = callback || $.noop;
		var self = this;
		this.parent.frm.campaign.getAttentionLevels(function(attention_levels, error)
		{
			if (error) {
				self.parent.frm.show_status_message("<%=_T('Error retrieving campaign attention levels.')%>", "Error", false);
				return callback();
			}
			var sorted_attention_levels = [];
			if ($.isPlainObject(attention_levels)) {
				sorted_attention_levels = inConcert.Utils.hash_to_sorted_array(attention_levels,
					function(attention_level) {
						return ( attention_level.name || "" ).toLowerCase();
					}) || {};
			}
			var account_attention_levels = null;
			var account_id = $("#" + self.id_rule_account).val();
			if (account_id && account_id !== "ALL") {
				var account = self.parent.frm.campaign.getAccount(account_id);
				account_attention_levels = account.AttentionLevels;
			}
			var html = "";
			$.each(sorted_attention_levels, function(_, attention_level) {
				if (!account_attention_levels || account_attention_levels[attention_level.id]) {
					html += format("<option value='{0}'>{1}</option>", attention_level.id, attention_level.name);
				}
			});
			$("#" + self.actions.transfer.attentionLevel.control_id).html(html);
			if (values && values.attentionLevel) {
				$("#" + self.actions.transfer.attentionLevel.control_id).val(values.attentionLevel);
			}
			return callback();
		});
	};

	rules_frm.prototype.load_transferred_options_campaign = function(values) {
		var self = this;
		var currentCampaign = this.parent.frm.campaign.Id;

		function loadCampaigns(callback) {
			inConcert.app.getCampaignAccountsForTransfer(function( success, data )
			{
				if (!success) {
					self.parent.frm.show_status_message("<%=_T('Error retrieving campaign accounts for transfer.')%>", 'Error', false);
					callback();
					return;
				}
				self.m_campaigns = data;
				callback();
			});
		}

		function loadOptions() {
			var campaigns = self.m_campaigns[$("#" + self.id_rule_channel).val()] || {};
			var sorted_campaigns = [];
			if ($.isPlainObject(campaigns)) {
				sorted_campaigns = inConcert.Utils.hash_to_sorted_array(campaigns,
					function(campaign) {
						return ( campaign.Name || "" ).toLowerCase();
					}) || {};
			}

			var html = "<option value='ALL'><%=_T('All')%></option>";
			$.each(sorted_campaigns, function(_, campaign) {
				if (campaign.Id !== currentCampaign) {
					html += format("<option value='{0}'>{1}</option>", campaign.Id, campaign.Name);
				}
			});
			$("#" + self.filters.transferred.campaign).html(html);
			if (values) {
				$("#" + self.filters.transferred.campaign).val(values.campaign);
				self.load_transferred_options_account(values);
			}
			else {
				$("#" + self.filters.transferred.campaign).change();
			}
		}

		if (this.m_campaigns) {
			return loadOptions();
		}
		loadCampaigns(loadOptions);
	};

	rules_frm.prototype.load_transferred_options_account = function(values) {
		var campaigns	= this.m_campaigns[$("#" + this.id_rule_channel).val()] || {},
			campaign	= campaigns[$("#" + this.filters.transferred.campaign).val()] || {},
			accounts	= campaign.accounts || {};

		var sorted_accounts = [];
		if ($.isPlainObject(accounts)) {
			sorted_accounts = inConcert.Utils.hash_to_sorted_array(accounts,
				function(account) {
					return ( account.Name || "" ).toLowerCase();
				}) || {};
		}
		var html = "<option value='ALL'><%=_T('All')%></option>";
		$.each(sorted_accounts, function(_, account) {
			html += format("<option value='{0}'>{1}</option>", account.Id, account.Name);
		});
		$("#" + this.filters.transferred.account).html(html);
		if (values) {
			$("#" + this.filters.transferred.account).val(values.account);
		}
	};

	rules_frm.prototype.show_account_pages = function() {
		var self = this;
		var channel = $("#" + this.id_rule_channel).val();
		var account_id = $("#" + this.id_rule_account).val();
		var html = "<option value='ALL'><%=_T('All pages')%></option>";

		if (this.__channelHasPages(channel) && account_id !== "ALL") {
			var pagesNames = self.parent.frm.campaign.getAccountPages(account_id);
			var account = self.parent.frm.campaign.getAccount(account_id);
			if (account && account.pages && pagesNames) {
				$.each(account.pages, function(_, page) {
					var pageName = pagesNames[page];
					html+= format("<option value='page{0}'>{1}</option>", page, pageName);
				});
			}
		}

		$("#" + this.id_rule_page).html(html);
	};

	rules_frm.prototype.show_account_posts = function() {
		let channel = $("#" + this.id_rule_channel).val();
		let account_id = $("#" + this.id_rule_account).val();
		let page_id = $("#" + this.id_rule_page).val();
		let html = "<option value='ALL'><%=_T('All posts')%></option>";

		var get_id_string = function(post) {
			let id = post.id || "";
			if ((post.type || "").toUpperCase() === "FACEBOOK") {
				let id_a = id.split("_");
				id = id_a.length === 2 ? id_a[1] : id;
			}
			return id;
		};
		var get_text = function(post) {
			if (!post.data) {
				return "";
			}
			let data = post.data || {};
			const channel = (post.type || "").toUpperCase();
			if (channel === "FACEBOOK") {
				return data.message || "";
			}
			else if (channel === "INSTAGRAM") {
				return data.text || "";
			}
			else if (channel === "TWITTER") {
				return data.text || "";
			}
			else if (channel === "YOUTUBE") {
				return data.text || "";
			}
			return "";
		};

		let posts = [];
		$.each(this.m_posts || [], function(_, post) {
			if (channel !== "ALL" && channel !== post.type || 
				account_id !== "ALL" && account_id !== post.account ||
				page_id !== "ALL" && page_id !== ("page" + post.page))
			{
				return;
			}
			posts.push({
				id : post.id,
				id_s : get_id_string(post),
				text : get_text(post),
				date : inConcert.Utils.formatDate(post.publish_timestamp * 1000)
			});
		});
		//queda asi por si lo queremos ordenar (viene por fecha)
		$.each(posts, function(_, post) {
			html+= Mustache.render("<option value='post{{ id }}' title='{{ date }} - {{ text }}'>{{ id_s }}</option>", post);
		});

		$("#" + this.id_rule_post)
			.html(html)
			.change();
	};

	rules_frm.prototype.show_account_batches = function() {
		let channel = $("#" + this.id_rule_channel).val();
		let account_id = $("#" + this.id_rule_account).val();
		let page_id = $("#" + this.id_rule_page).val();
		let html = "<option value='ALL'><%=_T('All batches')%></option>";
		let batches = [];

		var get_id_string = function(batch) {
			return batch.id || "";
		};
		var get_text = function(batch) {
			if (!batch.data) {
				return "";
			}
			let data = batch.data || {};
			if ((batch.type || "").toUpperCase() === "MAIL") {
				return data.subject || "";
			}
			return data.text || "";
		};

		$.each(this.m_batches || [], function(_, batch) {
			if (channel !== "ALL" && channel !== batch.type ||
				account_id !== "ALL" && account_id !== batch.account ||
				page_id !== "ALL" && page_id !== ("page" + batch.page))
			{
				return;
			}
			batches.push({
				id : batch.id,
				id_s : get_id_string(batch),
				text : get_text(batch),
				date : inConcert.Utils.formatDate(batch.publish_timestamp * 1000)
			});
		});
		//queda asi por si lo queremos ordenar (viene por fecha)
		$.each(batches, function(_, batch) {
			html+= Mustache.render("<option value='batch{{ id }}' title='{{ date }} - {{ text }}'>{{ id_s }}</option>", batch);
		});

		$("#" + this.id_rule_batch)
			.html(html)
			.change();
	};

	rules_frm.prototype.show_channel_actions = function(actions) {
		var self = this;
		if (!actions) {
			actions = {};
			actions[$("#" + self.id_actions_selector).val()] = true;
		}
		var channel = $("#" + this.id_rule_channel).val();
		var direction = $("#" + this.id_rule_direction).val() || "ALL";
		var definition = this.channels[channel].actions;
		var html = "<option value=''></option>";
		var hasOptions = false;
		$.each(definition, function(id, action) {
			if (!self.actionsByDirection[direction] || !self.actionsByDirection[direction][id]) {
				return;
			}
			html += format("<option value='{0}' {1} >{2}</option>", 
				id, 
				actions[id]? "selected" : "",
				action.definition.name);
			hasOptions = true;
		});
		var $actionsSelector = $("#" + self.id_actions_selector);
		$actionsSelector.html(html);
		this.parent.frm.disable_control($actionsSelector, !hasOptions, false);
		$actionsSelector.change();
	};

	rules_frm.prototype.can_transfer_to_number = function() {
		//EL objetivo es validar que la/s cuenta/s de call tengan al menos un package en modo saliente, para poder transferir.
		if (!this.telephonyPackages) {
			return false;
		}
		
		const rule_account = $("#" + this.id_rule_account).val() || "";
		if (!rule_account || rule_account.trim() === "") {
			return false;
		}
		
		//Si esta marcado todos, busco todas las cuentas
		const campaign_accounts = this.parent.frm.campaign.accounts;
		const accounts = campaign_accounts.filter(function(acc) {
			if ((acc.proxyType.toUpperCase() !== "CALL") || (rule_account !== "ALL" && rule_account !== acc.id )) {
				return false;
			}
			return true;
		});

		if (!accounts.length) {
			return false;
		}
		//Devuelvo si todas las cuentas tienen al menos un package saliente.
		const self = this;
		return accounts.every(
			function(acc) {
				const acc_packages = acc.packages || {};
				for (const package_id in acc_packages) {
					if (Object.hasOwnProperty.call(acc_packages, package_id)) {
						const packData = (self.telephonyPackages[package_id] || {});
						if (packData.ioMode === "I/O" || packData.ioMode === "O") {
							return true;
						}
					}
				}
				return false;
			}
		);
	};

	rules_frm.prototype.__load_transfer_destinations_options = function(destinations) {
		const options = (destinations.campaign? "<option value='campaign'><%=_T('Campaign')%></option>" : "") +
		(destinations.attentionLevel? "<option value='attentionLevel'><%=_T('Attention Level')%></option>":"") +
		((destinations.number && this.can_transfer_to_number()) ? "<option value='number'><%=_T('Number')%></option>" : "");
		$("#" + this.actions.transfer.destination.control_id).html(options);
	};

	rules_frm.prototype.__show_transfer_destinations = function(destinations, transfer) {
		this.__load_transfer_destinations_options(destinations);
		if (transfer) {
			$("#" + this.actions.transfer.destination.control_id).val(transfer.destination);
			this.load_transfer_options(true, transfer.destination, transfer);
		}
		else {
			$("#" + this.actions.transfer.destination.control_id).change();
		}
	};

	rules_frm.prototype.load_channel_change = function(filters, actions, account)
	{
		var self = this;
		actions = actions || {};
		filters = filters || {};

		var show_form_fields = function(form, fields, tooltips) {
			$("#" + form + " div.col-6").hide();
			$.each(fields, function(field_id, field) {
				$("#" + field.container_id).show();
				$("#" + field.control_id).prop("title", field.tooltip || tooltips[field_id] || "");
			});
		};

		var show_transferred_sources = function(available, data) {
			if (!available) {
				return;
			}
			self.load_transferred_options_campaign(data);
			$("#" + self.filters.transferred.active)
				.prop("checked", !!data)
				.change();
		};

		var show_channel_accounts = function(channel, account) {
			var accounts = self.parent.frm.campaign.get_accounts();
			if (!accounts) {
				return;
			}
			var html = "<option value='ALL'><%=_T('All accounts')%></option>";
			$.each(accounts, function(_, account) {
				if (channel === account.proxyType) {
					html += format("<option value='{0}'>{1}</option>", account.id, account.name);
				}
			});
			$("#" + self.id_rule_account).html(html);
			if (account) {
				$("#" + self.id_rule_account).val(account);
			}
			self.show_account_pages();
			self.show_account_posts();
			self.show_account_batches();
		};

		var show_channel_pages = function(channel_id) {
			$("#" + self.id_rule_page + "_container").toggle(self.__channelHasPages(channel_id));
		};

		const social_networks_api = inConcert.app.getSocialNetworksAPI();
		var show_channel_posts = function(channel_id) {
			$("#" + self.id_rule_post + "_container").toggle(social_networks_api.isChannelAvailable(channel_id));
		};

		const batches_mng_api = inConcert.app.getBatchesMngAPI();
		var show_channel_batches = function(channel_id) {
			$("#" + self.id_rule_batch + "_container").toggle(batches_mng_api.isChannelAvailable(channel_id));
		};

		const $rule_direction = $("#" + this.id_rule_direction);
		var show_channel_directions = function(channel) {
			let directions = channel.directions;
			let selected_value = $rule_direction.val();
			let exist_selected_value_in_list = false;

			var field_name_fn = function (key/*, item*/) {
				if (key === selected_value) { 
					exist_selected_value_in_list = true;
				}
				return self.directions[key];
			};
			self.parent.frm.fill_combo($rule_direction, false, directions, null, field_name_fn);
			if (exist_selected_value_in_list) {
				$rule_direction.val(selected_value);
			}
		};

		var channel_id = $("#" + this.id_rule_channel).val();
		var channel  = this.channels[channel_id];
		show_channel_accounts(channel_id, account);
		show_channel_directions(channel);
		show_channel_pages(channel_id);
		show_channel_posts(channel_id);
		show_channel_batches(channel_id);
		show_form_fields(this.id_filters_container, channel.filters, channel.tooltips || {});
		self.__show_transfer_destinations(channel.actions.transfer, actions.transfer || (actions.play_audio && actions.play_audio.transfer));
		show_transferred_sources(channel.filters.transferred, filters.transferred);
		this.show_channel_actions(actions);
		$("#" + this.id_filters_preexistent).toggle(!!channel.filters_preexistent);
		$("#" + this.id_filters_captured).toggle(!!channel.filters_captured);
		$("#" + this.id_filters_limit).toggle(!!channel.filters_limit);
	};

	//si hay transferencia a campa�a no aplican labels
	//siempre que se transfiere a campa�a se deja de procesar filtros
	rules_frm.prototype.enable_transfer_to_campaign = function(force_enabled) {
		var self = this;

		var enabled =  (force_enabled || $("#" + self.id_actions_selector).val() === "transfer") &&
					$("#" + self.actions.transfer.destination.control_id).val() === "campaign";

		self.parent.frm.disable_control($("#" + self.id_stop_processing), enabled, false);
		if (enabled) {
			$("#" + self.id_stop_processing).prop("checked", true);
		}

		$("#" + self.id_action_labels)
			.find("li.formListItem")
			.find("input[type=checkbox]")
			.each(function() {
				self.parent.frm.disable_control($(this), enabled, false);
				if (enabled) {
					$(this).prop("checked", false);
				}
			});
	};

	rules_frm.prototype.set_events = function()
	{
		var self = this;

		$("#" + this.id_create)
			.off("click")
			.on("click", function() {
				self.parent.add_or_update_rule();
			});
		$("#" + this.id_cancel)
			.off("click")
			.on("click", function() {
				self.hide();
				self.parent.hide_messages();
			});

		$("#" + this.filters.transferred.active)
			.off("change")
			.on("change", function() {
				var enabled = $(this).prop("checked");
				self.parent.frm.disable_control($("#" + self.filters.transferred.campaign), !enabled, true);
				self.parent.frm.disable_control($("#" + self.filters.transferred.account), !enabled, true);
			});

		$("#" + this.filters.transferred.campaign)
			.off("change")
			.on("change", function() {
				self.load_transferred_options_account();
			});

		$("#" + this.actions.transfer.campaign.control_id)
			.off("change")
			.on("change", function() {
				self.load_transfer_options_account();
			});

		$("#" + this.actions.transfer.destination.control_id)
			.off("change")
			.on("change", function() {
				var destination = $(this).val();
				var action = $("#" + self.id_actions_selector).val();
				const $check_transfer_after_audio = $("#" + self.actions.play_audio.transfer.control_id);
				const active = action === "transfer" || $check_transfer_after_audio.prop("checked");
				self.load_transfer_options(active, destination);
				self.enable_transfer_to_campaign();
			});

		$("#" + this.actions.play_audio.control_id)
			.off("click")
			.on("click", function() {
				self.show_popup_shared_file($(this));
			});

		$("#" + this.id_actions_selector)
			.off("change")
			.on("change", function() {
				var destination = $("#" + self.actions.transfer.destination.control_id).val();
				var action = $(this).val();
				self.show_transfer_options(action === "transfer", destination);
				self.enable_transfer_to_campaign();
				$("#" + self.actions.priority.container_id).toggle(action === "priority");
				self.show_or_hide_skills_section(action === "skills");
				self.__show_or_hide_play_audio_section(action === "play_audio");
			});

			$("#" + this.actions.play_audio.transfer.control_id)
			.off("click")
			.on("click", function() {
				const is_checked = $(this).prop("checked");
				$("#" + self.actions.transfer.destination.control_id).val("campaign");
				$("#" + self.actions.transfer.destination.control_id).change();
				self.enable_transfer_to_campaign(is_checked);
			});

		$("#" + this.id_rule_channel)
			.off("change")
			.on("change", function() {
				self.load_channel_change();
				$("#" + self.id_rule_direction).change();
			})
			.change();

		$("#" + this.id_rule_account)
			.off("change")
			.on("change", function() {
				//intenta mantener el valor del attention level (por ejemplo, cuando cambiamos de una cuenta
				//que lo tiene a ALL o a otra que tambien lo tiene.
				var attention_level = $("#" + self.actions.transfer.attentionLevel.control_id).val();
				self.load_transfer_options_attentionLevel(null, function() {
					$("#" + self.actions.transfer.attentionLevel.control_id).val(attention_level);
				});
				//procesa las paginas disponibles
				self.show_account_pages();
				self.show_account_posts();
				self.show_account_batches();
				if ($("#" + self.id_rule_channel).val().toUpperCase() === "CALL") {
					const channel  = self.channels.CALL;
					const $destination = $("#" + self.actions.transfer.destination.control_id);
					if (!$destination) {
						return;
					}
					const val_destination = $destination.val();
					self.__load_transfer_destinations_options(channel.actions.transfer);
					if (val_destination === "number") {
						$destination.change();
					}
					else{
						$destination.val(val_destination);
					}
				}
			})
			.change();

		$("#" + this.id_rule_page)
			.off("change")
			.on("change", function() {
				self.show_account_posts();
				self.show_account_batches();
			})
			.change();

		$("#" + this.id_rule_post)
			.off("change")
			.on("change", function() {
				$("#adm_form_campaign_rules_edition_direction_container, #adm_form_campaign_rules_edition_type_container")
					.toggleClass("withPost", $(this).val() && $(this).val() !== "ALL" || false);
			})
			.change();

		$("#" + this.id_rule_batch)
			.off("change")
			.on("change", function() {
				$("#adm_form_campaign_rules_edition_direction_container, #adm_form_campaign_rules_edition_type_container")
					.toggleClass("withBatch", $(this).val() && $(this).val() !== "ALL" || false);
			})
			.change();

		$("#" + this.id_rule_direction)
			.off("change")
			.on("change", function() {
				const channel = $("#" + self.id_rule_channel).val();
				const direction = $("#" + self.id_rule_direction).val() || "ALL";
				if (self.channels[channel] && self.channels[channel].directions[direction]) {
					const types = self.channels[channel].directions[direction];
					let html = "";
					$.each(types, function(_, type) {
						html += format("<option value='{0}'>{1}</option>", type, self.types[type]);
					});
					$("#" + self.id_rule_type).html(html);
					$("#" + self.id_rule_type + "_container").toggle(types.length > 0);
					self.show_channel_actions();
				}
			})
			.change();
	};
	//
	//-----------------------------------------


	//---------------------------------------------------------------------
	// 
	/*---------------------------------------------------------------------
	CLASS RULES SECTION 
	------------------------
		Esta clase hereda de la clase "conf_form_section" utilizado en las diferentes secciones de la campana.

		Es la encargada de mostrar la lista de rules, y de realizar el ABM de estos.
	*/
	function adm_form_campaigns_section_rules(params)
	{
		var success = adm_form_campaigns_section_rules.uber.constructor.call(this, params);
		if (!success) {
			return;
		}
		// permisos
		this.view_action_id           = "view_campaigns_rules";   // view action id de permisos
		this.save_action_id           = "save_campaign_rules";   // save action id de permisos
		this.erase_action_id          = "delete_campaign_rules"; // delete action id de permisos
		this.has_perm_to_save         = null;
		this.has_perm_to_erase        = null;

		// dom ids
		// 
		this.id_list_container        = "adm_form_campaign_rules_list_container";
		this.rules                    = "adm_form_campaign_rules_list";
		this.id_new_rule              = "adm_form_campaign_rules_new";
		this.id_sort_rules            = "adm_form_campaign_rules_sort";
		this.id_sort_rules_title	  = "adm_form_campaign_rules_sort_title";
		this.rules_not_result_found   = "adm_form_campaign_rules_not_results_found";

		// selectors - row
		this.selector_row_name        = "label[col_name]";
		this.selector_row_description = "label[col_description]";
		this.selector_row_channel     = "label[col_channel]";
		this.selector_row_enabled     = "i[col_enabled]";

		// sort ids
		this.id_sort_actions		  = "adm_form_campaign_rules_sort_actions";
		this.id_sort_save			  = "adm_form_campaign_rules_sort_save";
		this.id_sort_cancel			  = "adm_form_campaign_rules_sort_cancel";

		this.$row_editing = null; // Aca se encuentra el row html de jquery que se esta editando
		this.all_rules = {}; // todos los rules de la campana (utilizado para la busqueda general)
		this.list_to_save = {}; // los added/updated rules que se agregan en el popup y se deben guardar al cerrar el mismo. TODO: Cambiar !! feo muy feo, pero de momento no encontre otra forma para hacerlo rapido y sin romper todo lo que esta armado.

		this.rules_frm = null; // instancia de la clase que maneja la actualizacion.
		this.sorting_rules = false; // flag que indica cuando esta ordenando

		return true;
	}

	inConcert.Utils.inherit( adm_form_campaigns_section_rules, inConcert.conf_form_section );

	if (typeof inConcert.adm_form_campaigns_section_rules !== "function") {
		inConcert.adm_form_campaigns_section_rules = adm_form_campaigns_section_rules;
	}

	adm_form_campaigns_section_rules.prototype.dispose = function()
	{
		this.has_perm_to_save  = null;
		this.has_perm_to_erase = null;
		this.m_filePopup = null;
	};

	// Alta en el hash de todos los rules
	adm_form_campaigns_section_rules.prototype.add_rule_to_full_list = function(id, rule)
	{
		this.all_rules[id.toUpperCase()] = rule;
	};

	// Actualiza en el hash de todos los rules
	adm_form_campaigns_section_rules.prototype.update_rule_on_full_list = function(id, rule)
	{
		if (!this.all_rules.hasOwnProperty(id.toUpperCase())) {
			return;
		}
		this.all_rules[id.toUpperCase()] = rule;
	};

	// Baja en el hash todos los rules
	adm_form_campaigns_section_rules.prototype.erase_rule_on_full_list = function(id)
	{
		if (!this.all_rules.hasOwnProperty(id.toUpperCase())) {
			return;
		}
		delete this.all_rules[id.toUpperCase()];
	};

	adm_form_campaigns_section_rules.prototype.get_rule_from_full_list = function(id)
	{
		if (!id) {
			return {};
		}
		return this.all_rules[id.toUpperCase()];
	};

	// Alta en el hash rule que se han modificado en el popup y se enviaran a guardar al server.
	adm_form_campaigns_section_rules.prototype.update_list_to_save = function( rule, is_new)
	{
		this.list_to_save = this.list_to_save || {};
		this.list_to_save[rule.id.toUpperCase()] = { is_new: is_new || false, rule: rule };
	};

	// Vacia el hash que mantiene la lista de rules a guardar en el server.
	adm_form_campaigns_section_rules.prototype.empty_list_to_save = function()
	{
		this.list_to_save = {};
	};

	// Valida si el hash de rules a guardar se encuentra vacio.
	adm_form_campaigns_section_rules.prototype.is_empty_list_to_save = function()
	{
		return $.isEmptyObject(this.list_to_save);
	};

	adm_form_campaigns_section_rules.prototype.$get_row = function(id)
	{
		if ( typeof id !== "string" ) {
			id = "";
		}
		return $("#" + this.rules).find("li[row_data][rule_id='" + id + "']");
	};

	adm_form_campaigns_section_rules.prototype.$get_rows = function()
	{
		return $("#" + this.rules).find("li[row_data]");
	};

	// agrega un row ordenado alfabeticamente
	adm_form_campaigns_section_rules.prototype.add_sorted_row = function(new_index, $new_row)
	{
		var self = this;
		var $grid = $("#" + this.rules);
		var added = false;
		$grid.find("li[row_data]").each(function( _, row )
		{
			var $row = $(row);
			var id = $row.attr("rule_id");
			var rule_data = self.get_rule_from_full_list(id);
			var current_index = parseInt(rule_data.index);
			if (new_index < current_index) {
				$row.before($new_row);
				added = true;
				return false; // break
			}
		});
		if (!added) {
			$grid.append($new_row);
		}
	};

	adm_form_campaigns_section_rules.prototype.has_permission_to_delete = function()
	{
		if ( this.has_perm_to_erase !== null ) {
			return this.has_perm_to_erase;
		}
		this.has_perm_to_erase = adm_form_campaigns_section_rules.uber.has_permission_to_delete.call( this );
		return this.has_perm_to_erase;
	};

	adm_form_campaigns_section_rules.prototype.add_row = function(rule, is_new)
	{
		var self = this;
		if (!$.isPlainObject(rule)) {
			return;
		}
		var id = rule.id;
		var name = rule.name || id;
		var enabled = rule.disabled !== "1";
		var $row = this.$get_row(id);

		var already_rule = $row.length > 0;
		if ( already_rule ) {
		// si el rule a agregar ya existe en la lista de la GUI me voy
			return;
		}
		var get_actions = function()
		{
			var has_perm_to_save  = self.has_permission_to_save();
			var has_perm_to_erase = self.has_permission_to_delete();
			if ( !has_perm_to_save && ! has_perm_to_erase ) {
				return "";
			}
			var erase_html = "";
			if ( has_perm_to_erase ) { 
				erase_html = "<button action_del='true' class='buttonColorGray gridActionButton delete last' type='button' title='"+ "<%=_T('Delete')%>" + "'><i class='buttons-icons-delete'></i>" + "<%=_T('Delete')%>" + "</button>";
			}
			var save_html = "";
			if ( has_perm_to_save ) {
				save_html += "<button action_enable_disable='true' class='buttonColorGray gridActionButton deactivate form-switch' type='button' " + 
					(enabled? " title='"+ "<%=_T('Deactivate')%>" + "'> <i class='buttons-icons-deactivate '></i><label><%=_T('Deactivate')%>" : " title='"+ "<%=_T('Activate')%>" + "'> <i class='buttons-icons-activate '></i><label><%=_T('Activate')%>") + "</label></button> <span class='action-buttons-separator'></span>";
				save_html += "<button action_edit='true' class='buttonColorGray gridActionButton edit' type='button' title='"+ "<%=_T('Edit')%>" + "'><i class='buttons-icons-edit'></i>" + "<%=_T('Edit')%>" + "</button>";
				
			}
			return "".concat( save_html, erase_html);
		};
		var $row_html = $("".concat(
			"<li row_data='true' rule_id='", id, "' rule_index='", rule.index, "' class='viewListItem ", 
				enabled? "" : "ruleListItemDisabled","'>",
				"<label col_name='true' class='viewListItemText'>", name, "</label>",
				"<label col_description='true' class='viewListItemText'>", rule.description, "</label>",
				"<label col_channel='true' class='viewListItemText lastColumn'>", rule.channel === "ALL"? "<%=_T('All')%>" :_T(rule.channel), "</label>",
				get_actions(),
			"</li>")
		);

		if (!is_new) {
			$("#" + this.rules).append($row_html);
		}
		else {
			this.add_sorted_row(rule.index, $row_html); // agregar ordenada
		}
		// add rule in full hash
		this.add_rule_to_full_list(id, rule);
		// update message found
		this.show_or_hide_not_results_found();
		this.show_or_hide_errors();
	};

	adm_form_campaigns_section_rules.prototype.update_row = function( new_row_data )
	{
		if ( !$.isPlainObject( new_row_data ) ) {
			return;
		}
		
		var enabled = new_row_data.disabled !== "1";
		
		var $current_row = this.$get_row( new_row_data.id );
		var $name = $( $current_row.find( this.selector_row_name ) );
		var $description = $( $current_row.find( this.selector_row_description ) );
		var $channel = $( $current_row.find( this.selector_row_channel ) );

		// actualiza la lista completa de rules
		this.update_rule_on_full_list( new_row_data.id, new_row_data );
		$name.text( new_row_data.name );
		$description.text( new_row_data.description );
		$channel.text( new_row_data.channel === "ALL"? "<%=_T('All')%>" :_T(new_row_data.channel));
		$current_row.find("[action_enable_disable]").html(enabled? "<i class='buttons-icons-deactivate'></i><label><%=_T('Deactivate')%></label>" : "<i class='buttons-icons-activate'></i><label><%=_T('Activate')%></label>");
		$current_row.find("[action_enable_disable]").attr("title", enabled? "<%=_T('Deactivate')%>" : "<%=_T('Activate')%>");
		$current_row
			.toggleClass("ruleListItemDisabled", !enabled)
			.attr("rule_index", new_row_data.index);
		this.show_or_hide_not_results_found();
		this.show_or_hide_errors();
	};

	adm_form_campaigns_section_rules.prototype.show_not_results_found = function( message )
	{
		$("#" + this.rules_not_result_found)
			.text( message || "<%=_T('No rules found')%>" )
			.show();
		$("#" + this.rules).hide();
	};

	adm_form_campaigns_section_rules.prototype.hide_not_results_found = function()
	{
		$("#" + this.rules).show();
		$("#" + this.rules_not_result_found).hide();
	};

	adm_form_campaigns_section_rules.prototype.show_or_hide_not_results_found = function()
	{
		var count = Object.keys( this.all_rules || {} ).length;
		if ( count > 0 ) {
			this.hide_not_results_found();
		}
		else {
			this.show_not_results_found();
		}
		$("#" + this.id_sort_rules).prop("disabled", count < 2);
	};

	adm_form_campaigns_section_rules.prototype.make_rule_error = function(error) {
		var errorMessage = "";
		switch(error.reason) {
			case "LABEL_NOT_FOUND":
				errorMessage += format("<%=_T('Label {0} not found.')%>", error.label_id);
				break;
			case "CAMPAIGN_NOT_FOUND":
				errorMessage += format("<%=_T('Transferred campaign {0} not found.')%>", error.campaign);
				break;
			case "ACCOUNT_NOT_FOUND":
				errorMessage += format("<%=_T('Transferred Account {0} not found.')%>", error.account);
				break;
			case "AL_NOT_FOUND":
				errorMessage += format("<%=_T('Transferred Attention Level {0} not found.')%>", error.attentionLevel);
				break;
		}
		return errorMessage;
	};

	adm_form_campaigns_section_rules.prototype.show_or_hide_errors = function()
	{
		var self = this;
		var errors = "";
		$.each(this.all_rules, function(rule_id, rule) {
			var errorMessage = rule.error?
					(format("<%=_T('Rule {0}: ')%>", rule.name) + self.make_rule_error(rule.error))
					: "";

			$("#" + self.rules)
				.find(format("li[rule_id={0}]", rule_id))
				.prop("title", errorMessage)
				.toggleClass("rowErrorNotification", errorMessage !== "");

			errors += (errors? "&#10;" : "") + errorMessage;
		});

		$("#conf_application_actions")
			.find("li[sub_menu_id=rules]")
			.prop("title", errors)
			.toggleClass("sectionErrorNotification", errors !== "");
	};

	adm_form_campaigns_section_rules.prototype.set_rules = function( rules )
	{
		var self = this;

		$("#" + this.rules).find("li[row_data]").remove();
		this.all_rules = {};

		if (!$.isPlainObject(rules)) {
			this.show_or_hide_not_results_found();
			this.show_or_hide_errors();
			return;
		}

		var sorted_rules = inConcert.Utils.hash_to_sorted_array(rules,
			function(rule) {
				return parseInt(rule.index);
			}) || {};

		if ( sorted_rules.length > 0 ) {
			$.each(sorted_rules, function( _, item )
			{
				item.id = item.Id;
				delete item.Id; // la funcion hash to sorted array, mete el id, lo pelo porque aca no lo necesito.
				self.add_row(item);
			});
		}
		this.show_or_hide_not_results_found();
		this.show_or_hide_errors();
		this.frm.dashboard.hide_waiting();
	};

	adm_form_campaigns_section_rules.prototype.after_save_rules = function(success, message_error, callback)
	{
		callback = callback || $.noop;
		var self = this;
		var rule_list = this.list_to_save;

		if (success) {
			if (this.$row_editing || this.sorting_rules) {
			// update actual
				$.each(rule_list, function( _, rule_info )
				{
					self.update_row( rule_info.rule );
				});
			}
			else {
			// add all new
				var is_new = true;
				$.each(rule_list, function( _, rule_info )
				{
					if ( rule_info.is_new ) {
						self.add_row( rule_info.rule, is_new );
					}
					else {
						self.update_row( rule_info.rule );
					}
				});
			}
			this.empty_list_to_save();
			this.$row_editing = null;
			var message = "<%=_T('Rules have been saved successfully.')%>";
			this.frm.show_status_message(
				message ,                /* mensaje          */
				"Info"  ,                /* tipo de mensaje  */
				3000                     /* timeout ms       */);
			callback(true);
		}
		else {
			this.frm.show_status_message(
				message_error,           /* mensaje                                            */
				"Error",                 /* tipo de mensaje                                    */
				false,                   /* timeout ms (false = inifito)                       */
				false,                   /* scroll to top (false = no se mueve)                */
				{                        /* muestra la accion personalizada (en este caso retry) */
					message: "<%=_T('Retry')%>",
					callback: function(){
						self.save_rules(callback);
					}
				}
			);
		}
	};

	adm_form_campaigns_section_rules.prototype.save_rules = function(callback)
	{
		callback = callback || $.noop;
		var self = this;
		this.hide_rule_frm_edition();

		var rule_list = this.list_to_save;
		if ( $.isEmptyObject( rule_list ) ) {
			return callback(false);
		}
		this.saving = true;

		this.frm.dashboard.show_waiting("<%=_T('Please wait until rules are saved.')%>");
		// Lo meto dentro de un timeout minimo, para que se pueda ver el waiting, ya que si la grilla tiene muchos registros
		//   parece que queda la pantalla congelada, porque no da el tiempo para que se vea el waiting
		window.setTimeout(function()
		{
			var rules = [];
			$.each(rule_list, function(id, rule_info)
			{
				var rule = rule_info.rule;
				rule.id = rule.id || id;
				rules.push(rule);
			});

			self.frm.campaign.saveRules(rules, function(error)
			{
				var success = !error;
				var message_error;
				if ( !success ) {
					var err_type;
					if (typeof error === "object") {
						err_type = error.result;
					}
					else {
						err_type = error;
					}
					switch ((err_type || "").toUpperCase())
					{
						case "CAMPAIGN_DOES_NOT_EXIST":
							message_error = "<%=_T('Unable to save campaign rules, campaign does not exist...')%>";
							break;

						case "FORBIDDEN":
							message_error = "<%=_T('You dont have permissions for save campaign rules.')%>";
							break;

						case "INVALID_REQUEST":
							message_error = "<%=_T('Invalid request.')%>";
							break;

						default:
							message_error = "<%=_T('Failed to save rules, please try again in a few minutes...')%>";
					}
				}
				self.after_save_rules( success, message_error, callback );
				self.saving = false;
			});
		}, 50);
	};

	adm_form_campaigns_section_rules.prototype.remove_rules = function(rules, callback)
	{
		var self = this;
		callback = callback || $.noop;

		if ( !$.isArray( rules ) || rules.length === 0 ) {
			callback(false);
			return;
		}

		this.frm.dashboard.show_waiting("<%=_T('Please wait until rules are deleted.')%>");
		// lo meto dentro de un timeout minimo, para que se pueda ver el waiting, ya que si la grilla tiene muchos registros
		//	parece que queda la pantalla congelada, porque no da el tiempo para que se vea el waiting
		window.setTimeout(function()
		{
			self.frm.campaign.deleteRules(rules, function(error)
			{
				var success = !error;
				var message, type, timeout_ms;

				if ( success ) {
					message = "<%=_T('Rules have been deleted successfully.')%>";
					type = "Info";
					timeout_ms = 3000;
				}
				else {
					if (typeof error !== "object") {
						error = {result: error};
					}
					switch ((error.result || "").toUpperCase())
					{
						case "INVALID_REQUEST":
							message = "<%=_T('Invalid request.')%>";
							break;
						case "CAMPAIGN_DOES_NOT_EXIST":
							message = "<%=_T('Unable to delete rules. Campaign does not exist...')%>";
							break;
						case "FORBIDDEN":
							message = "<%=_T('You dont have permissions for delete rules.')%>";
							break;
						case "NO_CONFIGURED_RULES":
							message = "<%=_T('Unable to delete rules. No configured rules in campaign.')%>";
							break;
						case "NO_RULES_TO_DELETE":
							message = "<%=_T('Unable to delete rules. No exist assigned rules.')%>";
							break;
						default:
							message = "<%=_T('Failed to delete rules, please try again in a few minutes...')%>";
					}
					type = "Error";
					timeout_ms = false; // infinito
				}

				self.frm.show_status_message(
					message,        /* mensaje          */
					type,           /* tipo de mensaje  */
					timeout_ms      /* timeout ms       */
				);
				callback( success );
			});
		}, 50);
	};

	adm_form_campaigns_section_rules.prototype.build_header_custom_buttons = function()
	{
		var html_buttons =
			"<button id='" + this.id_sort_rules + "' class='pageButtonGeneric buttonColorSecondary pageButtonNew' ><%=_T('Sort')%></button>"+
			"<button id='" + this.id_new_rule + "' class='pageButtonGeneric buttonColorPrimary pageButtonNew' ><%=_T('Create rule')%></button>";
		adm_form_campaigns_section_rules.uber.build_header_custom_buttons.call(this, html_buttons);
		this.show_or_hide_not_results_found();
		this.show_or_hide_errors();
	};

	adm_form_campaigns_section_rules.prototype.add_or_update_rule = function()
	{
		var rule_info = this.rules_frm.validate();
		if ( !rule_info ) {
			return;
		}
		var is_new = !this.$row_editing;
		this.update_list_to_save( rule_info, is_new );
		this.save_rules();
	};

	adm_form_campaigns_section_rules.prototype.enable_disable_rule = function()
	{
		this.frm.hide_messages();

		var rule_data;
		if ( this.$row_editing ) {
		// si presione el boton para editar
			var id = this.$row_editing.attr("rule_id");
			rule_data = this.get_rule_from_full_list(id);
		}

		if ( !this.has_permission_to_section() || !this.has_permission_to_save() ) {
			var message;
			if ( !rule_data ) {
				message = "<%=_T('Unable to view rule: You dont have permissions for this action.')%>";
			}
			else {
				message = format( "<%=_T('Unable to view {0} rule: You dont have permissions for this action.')%>", rule_data.name );
			}
			this.$row_editing = null;
			this.frm.show_status_message( message, "Error", 5000 );
			return;
		}

		rule_data.disabled = rule_data.disabled === "1"? "0" : "1";
		this.update_list_to_save( rule_data );
		this.save_rules();
	};

	adm_form_campaigns_section_rules.prototype.show_rule_frm_edition = function(info = {})
	{
		var self = this;
		this.frm.hide_messages();

		var rule_data;
		let is_new = true;
		if ( this.$row_editing ) {
		// si presione el boton para editar
			var id = this.$row_editing.attr("rule_id");
			rule_data = this.get_rule_from_full_list(id);
			is_new = false;
		}

		if ( !this.has_permission_to_section() || !this.has_permission_to_save() ) {
			var message;
			if ( !rule_data ) {
				message = "<%=_T('Unable to view rule: You dont have permissions for this action.')%>";
			}
			else {
				message = format( "<%=_T('Unable to view {0} rule: You dont have permissions for this action.')%>", rule_data.name );
			}
			this.$row_editing = null;
			this.frm.show_status_message( message, "Error", 5000 );
			return;
		}

		this.empty_list_to_save();
		// show frm
		this.rules_frm.show( rule_data, function() {
			$("#" + self.id_list_container).hide();
			$("#" + self.id_new_rule).hide();
			$("#" + self.id_sort_rules).hide();
		});

		this.set_edit_mode(true);

		if (is_new) {
			this.frm.change_title_section(undefined, "<%=_T('New Rule')%>");
		}
		// google analytics
		this.AnalyticsSend(info);
	};

	adm_form_campaigns_section_rules.prototype.hide_rule_frm_edition = function(canSendAnalytics = true)
	{
		this.rules_frm.on_hide();
		$("#" + this.id_list_container).show();

		const $btn_sort_rules = $("#" + this.id_sort_rules);
		const $list_rules = $("#" + this.rules);
		const $btn_new_rule = $("#" + this.id_new_rule);
		const is_sortable = $list_rules.hasClass("ui-sortable");
		if (is_sortable) {
			$btn_new_rule.hide();
			$btn_sort_rules.hide();
		}
		else{
			$btn_new_rule.show();
			$btn_sort_rules.show();
		}

		if ( this.is_empty_list_to_save() ) {
			this.$row_editing = null;
		}
		
		this.set_edit_mode(false);
		// google analytics
		if (canSendAnalytics)
			this.AnalyticsSend();
	};

	adm_form_campaigns_section_rules.prototype.set_events_frm_abm = function()
	{
		var self = this;
		// new message event
		var event_selector = "#" + this.id_new_rule;
		var $header_buttons = this.frm.dashboard.$get_dom_element_by_id( "form_custom_buttons" ); //conf_form_custom_buttons
		$header_buttons
			.off("click", event_selector)
			.on("click", event_selector, function() {
				const analyticsInfo = {
					source_path: [
						{name: "rules_action", value: "new"} // "/main/administration/campaigns/edit/camp1@vcc1/rules/new"
					]
				};
				self.show_rule_frm_edition(analyticsInfo);
			});
		// sort rules event
		event_selector = "#" + this.id_sort_rules;
		$header_buttons
			.off("click", event_selector)
			.on("click", event_selector, function() {
				self.enable_sort_rules();
			});
	};

	adm_form_campaigns_section_rules.prototype.set_events = function()
	{
		var self = this;

		var $grid = $("#" + this.rules);
		var rows_event_selector = "li[row_data]";

		// boton delete de la lista de parametros
		var event_selector = rows_event_selector + " button[action_del]";
		$grid
			.off("click", event_selector)
			.on("click", event_selector, function()
			{
				self.frm.hide_messages();
				self.empty_list_to_save();
				self.$row_editing = null;
				var $row = $(this).parent();
				var id = $row.attr("rule_id");
				var rule = self.get_rule_from_full_list(id);
				var message = format(
					"<%=_T('Do you want to delete rule {0} ?')%>",
					rule.name);

				$.inconcertPopup.Show(
					"<%=_T('Confirm')%>",
					message,
					$.inconcertPopup.ButtonSets.BS_YESNO,
					function(response) {
						if (response.toLowerCase() !== "yes") {
							return;
						}
						var rules_list = [];
						rules_list.push(rule.id);
						// envia a remover al server
						self.remove_rules(
							rules_list,
							function(success) {
								if (!success) {
									return;
								}
								// elimino del hash de rules
								self.erase_rule_on_full_list(rule.id.toUpperCase());
								$row.fadeOut("slow", function() {
									$row.remove();
									self.load_campaign_rules(true);
									self.show_or_hide_not_results_found();
									self.show_or_hide_errors();
								});
							});
					},
					undefined,
					{
						popup_id        : "conf_inconcertPopup",
						container_class : "confirmationPopUp",
						overlay_class   : "confirmationOverlay"
					}
				);
			});

		/*
		*/
		const show_rule_frm_edition = () => {
			const rule_id = this.$row_editing.attr("rule_id");
			const analyticsInfo = {
				source_path: [
					{name: "rules_action", value: "edit" }, // "/main/administration/campaigns/edit/camp1@vcc1/rules/edit"
					{name: "rules_id"    , value: rule_id}  // "/main/administration/campaigns/edit/camp1@vcc1/rules/edit/label1"
				]
			};
			this.show_rule_frm_edition(analyticsInfo);
		};

		// doble click sobre la row edita la misma
		$grid
			.off("dblclick", rows_event_selector)
			.on("dblclick", rows_event_selector, function(event) {
				event.stopPropagation();
				if (self.sorting_rules) {
					return;
				}
				self.$row_editing = $(this);
				show_rule_frm_edition();
			});

		// boton edit de la lista de parametros
		event_selector = rows_event_selector + " button[action_edit]";
		$grid
			.off("click", event_selector)
			.on("click", event_selector, function() {
				self.$row_editing = $(this).parent();
				show_rule_frm_edition();
			});

		// boton enable/disable de la lista de parametros
		event_selector = rows_event_selector + " button[action_enable_disable]";
		$grid
			.off("click", event_selector)
			.on("click", event_selector, function() {
				self.$row_editing = $(this).parent();
				self.enable_disable_rule();
			});

		// eventos del abm del frm
		this.set_events_frm_abm();
		// eventos del ordenamiento
		this.set_events_sort();
	};

	adm_form_campaigns_section_rules.prototype.load_campaign_rules = function(force_update)
	{
		var self = this;
		if ( this.frm.campaign.isNew === true ) {
			// si estoy creando una nueva campana, asigno los rules vacios
			this.set_rules();
			return;
		}
		// si estoy modificando una campana, voy a buscar la lista de rules al server
		this.frm.campaign.loadRules(function(rules, error)
		{
			if (error) {
				var message_type = "Error";
				var timeout_ms = false; // infinite
				self.frm.show_status_message("<%=_T('Error retrieving campaign rules.')%>", message_type, timeout_ms);
				return;
			}
			self.set_rules(rules);
		}, force_update);
	};

	adm_form_campaigns_section_rules.prototype.enable_sort_rules = function()
	{
		this.frm.hide_messages();
		if ( !this.has_permission_to_section() || !this.has_permission_to_save() ) {
			var message = "<%=_T('Unable to sort rules: You dont have permissions for this action.')%>";
			this.$row_editing = null;
			this.frm.show_status_message( message, "Error", 5000 );
			return;
		}

		this.sorting_rules = true;
		$("#" + this.id_new_rule).hide();
		$("#" + this.id_sort_rules).hide();
		$("#" + this.id_sort_actions).show();
		$("#" + this.id_sort_rules_title).show();

		$("#" + this.rules)
			.find("button[action_del], button[action_edit]")
			.hide();

		$("#" + this.rules).sortable({
			cursor : "move",
			items  : "li.viewListItem"
		});

		$("#" + this.rules)
			.find("li.viewListItem")
			.addClass("rule_sortable")
			.find("*")
			.addClass("rule_sortable");

		$("#" + this.rules)
			.find("label.gridAction3ButtonCol")
			.addClass("gridAction1ButtonCol")
			.removeClass("gridAction3ButtonCol");

		this.empty_list_to_save();
		this.set_edit_mode(true);
		this.frm.change_title_section(undefined, "<%=_T('Sort Rules')%>");
	};

	adm_form_campaigns_section_rules.prototype.hide_sort_rules = function(after_save)
	{
		this.sorting_rules = false;

		$("#" + this.id_new_rule).show();
		$("#" + this.id_sort_rules).show();
		$("#" + this.id_sort_actions).hide();
		$("#" + this.id_sort_rules_title).hide();

		$("#" + this.rules)
			.find("button[action_del], button[action_edit]")
			.show();

		$("#" + this.rules)
			.find("li.viewListItem")
			.removeClass("rule_sortable")
			.find("*")
			.removeClass("rule_sortable");

		$("#" + this.rules)
			.find("li.viewListTitle label.gridAction1ButtonCol")
			.addClass("gridAction3ButtonCol")
			.removeClass("gridAction1ButtonCol");

		$("#" + this.rules).sortable("destroy");

		this.empty_list_to_save();
		if (!after_save) {
			this.load_campaign_rules();
		}
		this.set_edit_mode(false);
	};

	adm_form_campaigns_section_rules.prototype.save_sort_rules = function()
	{
		var self = this;
		$("#" + this.rules)
			.find("li.viewListItem")
			.each(function(current_index, rule) {
				var $rule = $(rule);
				var index = parseInt($rule.attr("rule_index"));
				if (index !== current_index) {
					var rule_info = self.get_rule_from_full_list($rule.attr("rule_id"));
					rule_info.index = current_index;
					self.update_list_to_save(rule_info, false);
				}
			});

		this.save_rules(function(/*status*/) {
			self.hide_sort_rules(true);
		});
	};

	adm_form_campaigns_section_rules.prototype.before_jump_to_menu = function(){

		if (this.sorting_rules) {
			this.hide_sort_rules();
		}
		else if(this.rules_frm){
			this.rules_frm.hide();
		}
		
		this.hide_messages();
	};

	adm_form_campaigns_section_rules.prototype.set_events_sort = function()
	{
		var self = this;
		$("#" + this.id_sort_save)
			.off("click")
			.on("click", function() {
				self.save_sort_rules();
			});

		$("#" + this.id_sort_cancel)
			.off("click")
			.on("click", function() {
				self.hide_sort_rules();
			});
	};

	adm_form_campaigns_section_rules.prototype.initialize = function()
	{
		this.has_perm_to_save  = null;
		this.has_perm_to_erase = null;
		this.rules_frm = new rules_frm( {
			parent: this
		});
		this.load_campaign_rules();
	};

	adm_form_campaigns_section_rules.prototype.set = function()
	{
		this.initialize();
	};

	adm_form_campaigns_section_rules.prototype.on_show = function()
	{
		adm_form_campaigns_section_rules.uber.on_show.call(this, {show: false});
		this.frm.dashboard.$get_dom_element_by_id("form_buttons_actions").hide();
	};

	adm_form_campaigns_section_rules.prototype.on_hide = function()
	{
		adm_form_campaigns_section_rules.uber.on_hide.call( this );
		this.hide_rule_frm_edition(false /*canSendAnalytics*/);
		if (this.sorting_rules) {
			this.hide_sort_rules();
		}
	};

	adm_form_campaigns_section_rules.prototype.editable = function()
	{
		adm_form_campaigns_section_rules.uber.editable.call( this );
	};

	adm_form_campaigns_section_rules.prototype.readonly = function() {
		adm_form_campaigns_section_rules.uber.readonly.call( this );
	};

	adm_form_campaigns_section_rules.prototype.readonly = function() {
		adm_form_campaigns_section_rules.uber.readonly.call( this );
	};

}());