/* jshint forin:true, noarg:true, jquery:true, noempty:true, eqeqeq:true, bitwise:true,
	strict:true, undef:true, unused:vars, curly:true, browser:true, indent:false, maxerr:50, quotmark:double, esversion: 9 */

/* global $, inConcert */

if (!this.inConcert) {
	this.inConcert = {};
}

(function () {
	//"use strict";

	//---------------------------------------------------------------------
	// form signatures class
	function adm_form_signatures(params)
	{
		let success = adm_form_signatures.uber.constructor.call(this, params);
		if (!success) {
			return;
		}

		this.new_title      = "<%=_T('Create signature')%>";
		this.update_title   = "<%=_T('Update signature {0}')%>";
		this.view_title     = "<%=_T('View signature {0}')%>"; 
		this.tagline        = "<%=_T('Tagline form Signature!!!')%>";

		this.html_file_name = "/inconcert/apps/administration/signatures/frm/render/";
		this.save_uri       = "/inconcert/apps/administration/signatures/save/";
		this.get_uri        = "/inconcert/apps/administration/signatures/get/";

		this.mail_mng = new inConcert.MailManagement({
			owner: this,
			auto_init: false,
			ids: {
				body     : "adm_form_signature_body",
				container: "adm_form_signature_body_container"
			}
		});

		return true;
	}

	inConcert.Utils.inherit(adm_form_signatures, inConcert.conf_form);

	if (typeof inConcert.adm_form_signatures !== "function") {
		inConcert.adm_form_signatures = adm_form_signatures;
	}

	adm_form_signatures.prototype.initialize = function()
	{
		this.mail_mng.initialize();
	};

	adm_form_signatures.prototype.get = function()
	{
		let signature = {
			Name: $("#adm_form_signature_name").val(),
			Description: $("#adm_form_signature_desc").val(),
			Signature : this.__get_signature(),
			Attachments : this.__get_signature_attachments()
		};
		let action = this.dashboard.get_current_action_obj();
		let id = action.view.row_id;
		if (!this.is_new) {
			signature[id] = this.$current_row.attr("row_id");
		}
		return signature;
	};

	adm_form_signatures.prototype.__get_signature = function()
	{
		return this.mail_mng.get(true);
	};

	adm_form_signatures.prototype.__get_signature_attachments = function()
	{
		return this.mail_mng.get_repository_images_list();
	};

	adm_form_signatures.prototype.set = function(success, signature)
	{
		if (!success) {
			return;
		}
		$("#adm_form_signature_name").val(signature.Name);
		$("#adm_form_signature_desc").val(signature.Description);
		this.mail_mng.set(signature.Signature);
	};

	adm_form_signatures.prototype.empty_controls = function()
	{
		$("#adm_form_signature_name").val("").focus();
		$("#adm_form_signature_desc").val("");
		this.mail_mng.set("");
	};

	adm_form_signatures.prototype.err_save_messages = function(err)
	{
		adm_form_signatures.uber.err_save_messages.call( this, err, false /* custom message*/ );  //invokes the base class method
		if (typeof err !== "object") {
			return;
		}
		if (err.result === "MUST_HAVE_A_NAME" || err.result === "MUST_HAVE_UNIQUE_NAME") {
			$("#adm_form_signature_name").focus();
		}
		else if (err.result === "MUST_HAVE_A_DESCRIPTION") {
			$("#adm_form_signature_desc").focus();
		}
	};

	adm_form_signatures.prototype.get_validation_def = function()
	{
		const self = this;

		let definitions = [
			{
				control_id: "adm_form_signature_name",
				messages: {
					required: "<%=_T('Please enter the signature name.')%>",
					id      : "<%=_T('Only letters, numbers, dashes and dots are allowed in the signature name.')%>"
				}
			},
			{
				control_id: "adm_form_signature_desc",
				messages: {
					required: "<%=_T('Please enter the signature description.')%>"
				}
			},
			{
				control_id: "adm_form_signature_body",
				messages: {
					custom: {
						type :  "custom",
						async: true,
						valid: function(_, callback){
							self.mail_mng.start_upload_images(function(status) {
								if (!status) {
									return callback({
										success : false,
										message : "<%=_T('Error uploading embeed images.')%>"
									});
								}
								self.mail_mng.validate(callback);
							});
						}
					}
				}
			}
		];

		return definitions;
	};

	adm_form_signatures.prototype.ready = function()
	{
		adm_form_signatures.uber.ready.call( this ); //invokes the base class method
		$("#adm_form_signature_name").focus();
	};

	adm_form_signatures.prototype.readonly = function()
	{
		adm_form_signatures.uber.readonly.call(this); //invokes the base class method
		this.mail_mng.readonly();
	};

	adm_form_signatures.prototype.set_events = function()
	{
		adm_form_signatures.uber.set_events.call( this ); //invokes the base class method
		this.mail_mng.set_events();
	};
}());
