/* jshint forin:true, noarg:true, jquery:true, noempty:true, eqeqeq:true, bitwise:true,
	strict:true, undef:true, unused:vars, curly:false, browser:true, indent:false, maxerr:50, -W083, -W014, esversion: 11 */

/* global $, inConcert, CryptoJS */

if (!this.inConcert) {
	this.inConcert = {};
}

(function () {

//	"use strict";

	const FORMAT = inConcert.Utils.format;

	//---------------------------------------------------------------------
	// form users class
	//
	function adm_form_users( params )
	{
		var success = adm_form_users.uber.constructor.call( this, params );
		if (!success) {
			return;
		}
		var self = this;
		this.new_title      = "<%=_T('Create user')%>";
		this.update_title   = "<%=_T('Update user {0}')%>";
		this.view_title     = "<%=_T('View user {0}')%>";
		this.tagline        = "<%=_T('Tagline form User!!!')%>";

		this.html_file_name = "/inconcert/apps/administration/users/frm/render/";
		this.save_uri       = "/inconcert/apps/administration/users/save/";
		this.get_uri        = "/inconcert/apps/administration/users/get/";

		this.requests = [];
		this.cbo_timezone_id = "#adm_form_user_timezone";

		// instancia del handle de permisos
		this.perm_gui_override = new inConcert.perm_gui_override({
			container_id: "#adm_form_user_permission_list",
			cleanup_external_container_id: this.dashboard.prefix_id + "form_button_cancel",
			override_type: "vcc",
			callback: function( data ) {
				self.perm_callback( data );
			}
		});

		// instancia del handle de skills (asignacion)
		this.skills_handle = new inConcert.adm_skills_handle({
			container_id : "adm_form_user_skills_config",
			input_ctrls  : {
				skill_value : "TEXTBOX"
			},
			parent_frm   : this,
			parent_type  : "FORM",
			title        : "<%=_T('User Skills')%>",
			help         : "<%=_T('Set the skills that distinguish the user as an agent. Only useful on interaction module.')%>"
		});

		// del popoup de importaciones de usuarios
		this.m_importations_handle = new inConcert.adm_form_users_importations({
			owner: this
		});

		this.telephone_codes = inConcert.app.getInstanceTelephonyCodes();
		this.sorted_countries = null;
		this.sorted_timezones = null; // Este array se carga en la funcion definida en clase base "conf_form.fill_timezones"
		this.password_has_changed = null;
		this.workgroups = null;
		this.current_user = null; // el usuario que se esta editando ( esto solo sirve para editar )
		this.roles = null;

		return true;
	}

	inConcert.Utils.inherit( adm_form_users, inConcert.conf_form );

	if ( typeof inConcert.adm_form_users !== "function" ) {
		inConcert.adm_form_users = adm_form_users;
	}

	adm_form_users.prototype.initialize = function()
	{
		this.password_has_changed = null;	
	};

	adm_form_users.prototype.get_full_role_id = function( simple_role_id )
	{
		if ( !this.roles ) {
			return simple_role_id;
		}
		var is_system_role;
		var role = this.roles[ simple_role_id ];
		if ( !role ) {
			is_system_role = "1";
		}
		else {
			is_system_role = this.roles[ simple_role_id ].IsSystemGroup;
		}
		return simple_role_id + "@" + ( is_system_role === "1" ? "system" : inConcert.app.getDomain() );
	};

	/*
		callback de la clase de permisos cuando, se chequea / deschequea algun permiso ( action/app/grupo )
	*/
	adm_form_users.prototype.perm_callback = function( data )
	{
		if ( data.type !== "mark_app" ) {
			return;
		}
		// solo utilizo el callback para las apps
		var show, hide;

		switch ( data.app_id )
		{
			case "interaction":
				show = this.show_interaction_app_panels;
				hide = this.hide_interaction_app_panels;
			break;

			case "supervisor":
				show = this.show_supervisor_app_panels;
				hide = this.hide_supervisor_app_panels;
			break;

			case "administration":
				if (data.marked) {
					this.perm_gui_override.mark_specific_checkbox(false,"group","administration","admin_restricted","click");
				}

			/* falls through */
			default:
				return;
		}

		if ( data.marked ) { show(); } else { hide(); }
	};

	adm_form_users.prototype.get = function()
	{
		var user = {
			newUser             : this.is_new,
			Enabled             : "1",   // esto no sirve de nada del lado del server, sino que me sirve para actualizar la grilla.
			Id                  : $("#adm_form_user_id").val(),
			Name                : $("#adm_form_user_first_name").val(),
			LastName            : $("#adm_form_user_last_name").val(),
			FirstSurname        : $("#adm_form_user_first_surname").val(),
			LastSurname         : $("#adm_form_user_last_surname").val(),
			TimeZoneId          : $("#adm_form_user_timezone").val(),
			LanguageId          : $("#adm_form_user_app_language").val(),
			countryCode         : $("#adm_form_user_country").val(),
			areaCode            : this.__get_selected_area($("#adm_form_user_area")),
			CompanyInformation  : this.__get_company_information(),
			CustomInformation   : this.__get_custom_information(),
			UserGroup           : $( "#adm_form_user_role" ).val(),
			DefaultCampaign     : null,
			WorkgroupId         : false,  // va false porque con ese valor lo elimina si ya existia.
			groups              : [],
			skills              : [],
			custom_permissions  : this.perm_gui_override.get_overrides(),
			MustChangePassword  : $("#adm_form_user_must_change_password").prop("checked") ? "1" : "0",
			DateFormat 		    : $("#adm_form_user_format_datetime").val()
		};

		var email = $("#adm_form_user_mail").val().trim();
		if (email.length > 0) {
			user.Mail = email;
		}

		if ( this.$current_row ) {
			var row_data = this.$current_row.data( "row_data" );
			user.status = row_data.status;
		}

		var campaigns_info = this.get_users_campaigns();
		user.groups = campaigns_info.campaigns;

		if ( this.password_has_changed ) {
			user.Password = inConcert.Utils.md5( user.Id.toLowerCase() + $( "#adm_form_user_pwd" ).val() );
			user.PasswordHasChanged = true;
				
			// Ademas de enviar el md5, enviamos el jwt para poder hacer las validaciones en el server
			var header = {
				"alg": "HS256",
				"typ": "JWT"
			};

			var stringifiedHeader = CryptoJS.enc.Utf8.parse(JSON.stringify(header));
			var encodedHeader = inConcert.Utils.base64url(stringifiedHeader);

			var data = {
				"password": $("#adm_form_user_pwd").val()
			};

			var stringifiedData = CryptoJS.enc.Utf8.parse(JSON.stringify(data));
			var encodedData = inConcert.Utils.base64url(stringifiedData);

			var token = encodedHeader + "." + encodedData;
			var secret = inConcert.app.getLoggedUserToken();

			var signature = CryptoJS.HmacSHA256(token, inConcert.Utils.md5(secret));
			signature = inConcert.Utils.base64url(signature);

			var signedToken = token + "." + signature;	
			user.jwtToken = signedToken;	
		}
		var perm = this.perm_gui_override.get_perm_instance();
		var allowed_int_app = perm.to_application( "interaction" );
		if ( allowed_int_app ) {
		// 1 - obtengo el default campaign
			user.DefaultCampaign = campaigns_info.default_campaign;
		// 2 - si tiene wkg, obtengo el mismo
			var workgroup = $( "#adm_form_user_agent_workgroup" ).val();
			if (workgroup && workgroup.trim().length > 0) {
				user.WorkgroupId = workgroup;
			}
		// 3 - obtengo la lista de skills
			user.skills = this.skills_handle.get();
		}

		// Aqui asignamos la informacion que puede cambiar dependiendo si tenemos allegro integration o no.
		user.initialState = this.__get_initial_state();

		return user;
	};

	adm_form_users.prototype.__get_company_information = function()
	{
		return {
			Location     : $("#adm_form_user_company_location").val(),
			Position     : $("#adm_form_user_company_position").val(),
			Organization : $("#adm_form_user_company_organization").val()
		};
	};

	adm_form_users.prototype.__get_initial_state = function()
	{
		return $("#adm_form_user_initial_state").val();
	};

	adm_form_users.prototype.__get_custom_information = function()
	{
		var customs = {};
		var custom_index = 0;
		$("#adm_form_user_custom_information").find("[user_custom_property]").each(function(_, custom_row)
		{
			var $custom_row = $(custom_row);
			$custom_row.find("[user_custom_value]").each(function(_, custom_value)
			{
				custom_index++;
				var $custom_value = $(custom_value);
				var value = $custom_value.val().trim();
				var custom_id = "custom_agent_info_" + custom_index;
				customs[custom_id] = value;
			});
		});

		return customs;
	};

	adm_form_users.prototype.__set_company_information = function( company_info )
	{
		if (!company_info) {
			return;
		}
		$("#adm_form_user_company_location").val(company_info.Location || "");
		$("#adm_form_user_company_position").val(company_info.Position || "");
		$("#adm_form_user_company_organization").val(company_info.Organization || "");
	};

	adm_form_users.prototype.__set_custom_information = function( custom_info )
	{
		if (!custom_info) {
			return;
		}
		var custom_index = 0;
		$("#adm_form_user_custom_information").find("[user_custom_property]").each(function(_, custom_row)
		{
			var $custom_row = $(custom_row);
			$custom_row.find("[user_custom_value]").each(function(_, custom_value)
			{
				custom_index++;
				var custom_id = "custom_agent_info_" + custom_index;
				if (custom_info.hasOwnProperty(custom_id)) {
					var $custom_value = $(custom_value);
					var value = custom_info[custom_id];
					$custom_value.val(value);
					return true; //continue
				}
			});
		});
	};

	adm_form_users.prototype.__set_user_datetime_format = function( dateFormat ){
		if (dateFormat) {
			$("#adm_form_user_format_datetime").val(dateFormat);
		}
	};

	adm_form_users.prototype.__set_initial_state = function( initial_state )
	{
		$("#adm_form_user_initial_state").val( initial_state );
	};

	adm_form_users.prototype.__empty_company_controls = function()
	{
		$("#adm_form_user_company_location").val("");
		$("#adm_form_user_company_position").val("");
		$("#adm_form_user_company_organization").val("");
	};

	adm_form_users.prototype.__empty_custom_controls = function()
	{
		$("#adm_form_user_custom_information").find("[user_custom_property]").each(function(_, custom_row)
		{
			var $custom_row = $(custom_row);
			$custom_row.find("[user_custom_value]").each(function(_, custom_value)
			{
				var $custom_value = $(custom_value);
				$custom_value.val("");
			});
		});
	};

	adm_form_users.prototype.__validate_custom_information = function()
	{
		var self = this;

		var response = {
			success: true
		};

		var validate = function( $ctrl, type, message ) {
			response.success = self.validate_field( $ctrl, type, message );
			if (!response.success) {
				response.message = message;
			}
		};

		var can_continue = true;
		$("#adm_form_user_custom_information").find("[user_custom_property]").each(function(_, custom_row)
		{
			var $custom_row = $(custom_row);
			$custom_row.find("[user_custom_value]").each(function(_, custom_value)
			{
				var $custom_value = $(custom_value);
				var value = $custom_value.val().trim();
				if (value.length === 0) {
					return true; // continue
				}
				// 1 - valida que el "VALUE" contega valores alfanumericos.
				var message = "<%=_T('Only letters, numbers, dashes and dots are allowed in the custom value.')%>";
				validate( $custom_value, "alpha", message );
				if (!response.success) {
					can_continue = false;
					return false; // break
				}
			});
			if ( !can_continue ) {
				return false; // break
			}
		});

		return response;
	};

	adm_form_users.prototype.check_updateable_fields = function( user )
	{
		if (this.is_readonly()) {
			return;
		}

		if (typeof user !== "object") {
			return true;
		}
		var self = this;

		var show_alert = function( message, $control )
		{
			var disabled = true;
			self.disable_control( $control, disabled );
			var control_id = $control.attr("id");
			var $control_message = $("#" + control_id + "_message");
			$control_message.text(message).show();
		};

		var message;
		var $role = $("#adm_form_user_role");
		var logged_user_id = inConcert.app.getLoggedUserId();
		if (logged_user_id.toLowerCase() === user.Id.toLowerCase())
		{
			message = "<%=_T('This user is logged in, some information cannot be modified.')%>";
			show_alert(message, $role);

			// disable los checkboxes de la app administration / seccion vista usuarios y sus hijos.
			this.perm_gui_override.disable_specific_group(
				true             , /* disabled */
				"administration" , /* app */
				"viewusers"     , /* group id */
				true               /* aplicar cambios a todos los hijos */
			);
			// disable los checkboxes de la app administration / seccion vista permisos y sus hijos.
			this.perm_gui_override.disable_specific_group(
				true             , /* disabled */
				"administration" , /* app */
				"viewgroups"     , /* group id */
				true               /* aplicar cambios a todos los hijos */
			);
			// disable el checkbox de la app administration / seccion vista permisos.
			this.perm_gui_override.disable_specific_app(
				true             , /* disabled */
				"administration" , /* app */
				false               /* aplicar cambios a todos los hijos */
			);

			return false;
		}

		if (typeof user.status === "object" &&
			(user.status.state.length > 0 && user.status.state.toUpperCase() !== "OFFLINE"))
		{
			message = "<%=_T('This user is logged in, some information cannot be modified.')%>";
			show_alert(message, $role);
			return false;
		}

		return true;
	};

	adm_form_users.prototype.set = function( success, user )
	{
		if (!success) {
			return;
		}
		if (!this.is_new) {
		/* este codigo queda comentado porque en algun momento se va a poder visualizar el avatar en el frm de usuarios
			var avatar_uri = inConcert.app.getBaseDomain() + "/inconcert/apps/agent/users/get_avatar/" + user.Id;
			$("#adm_form_user_avatar").attr("src", avatar_uri);
		*/
			this.check_updateable_fields( user );
			this.current_user = user;
		}

		$("#adm_form_user_id").val(user.Id);

		$("#adm_form_user_first_name").val(user.Name);
		$("#adm_form_user_last_name").val(user.LastName);
		$("#adm_form_user_first_surname").val(user.FirstSurname);
		$("#adm_form_user_last_surname").val(user.LastSurname);
		$("#adm_form_user_mail").val(user.Mail || "");
		$("#adm_form_user_timezone").val(user.TimeZoneId);
		$("#adm_form_user_app_language").val(user.LanguageId);
		$("#adm_form_user_country").val(user.countryCode);
		const $area = $("#adm_form_user_area");
		this.fill_combo_areas(user.countryCode, $area, true);
		$area.val(user.areaCode);
		$("#adm_form_user_pwd").val("****");
		$("#adm_form_user_role").val(user.UserGroup);
		$("#adm_form_user_must_change_password").prop("checked", user.MustChangePassword === "1");

		// informacion de la compania y de los campos customs
		this.__set_company_information(user.CompanyInformation);
		this.__set_custom_information(user.CustomInformation);

		//marco las acciones del grupo
		var $role = $( "#adm_form_user_role option:selected" );
		this.on_change_role( $role );

		//marco/desmarco las diferencias (los permisos customs)
		this.perm_gui_override.mark_difference_actions( user.custom_permissions );

		this.set_user_campaigns( user);

		this.__set_user_datetime_format( user.DateFormat );

		this.show_role_panels();

		var perm = this.perm_gui_override.get_perm_instance();
		var allowed_int_app = perm.to_application( "interaction" );
		if ( allowed_int_app ) {
		// 1 - si tiene wkg, lo asigno
			if ( user.WorkgroupId ) {
				$("#adm_form_user_agent_workgroup").val( user.WorkgroupId );
			}
		// 2 - asigno los skills
			this.skills_handle.set( user.skills );
		}

		// Aqui cargamos la informacion que puede cambiar dependiendo si tenemos allegro integration o no.
		this.__set_initial_state( user.initialState );

		if (!this.is_new && user.isExpired) {
			this.validation.show_validation_error($("#adm_form_user_pwd"), "<%=_T('User locked. The password has expired.')%>", 6000);
		}
	};

	adm_form_users.prototype.empty_controls = function()
	{
		$("#adm_form_user_id").val("").focus();
		$("#adm_form_user_first_name").val("");
		$("#adm_form_user_last_name").val("");
		$("#adm_form_user_first_surname").val("");
		$("#adm_form_user_last_surname").val("");

		var $pwd = $("#adm_form_user_pwd");
		$pwd.val("");
		$("#" + $pwd.attr("strengthPwdId")).hide(); // oculto la fuerza de la pwd
		$("#adm_form_user_pwd_confirmation").val("");
		$("#adm_form_user_mail").val("");
		$("#adm_form_user_app_language").val("").trigger("change");
		// informacion geografica
		$("#adm_form_user_timezone").val("").trigger("change");
		$("#adm_form_user_country").val("").trigger("change");
		$("#adm_form_user_area").val("").trigger("change");
		// informacion de workgroups
		$("#adm_form_user_agent_workgroup").val("");

		this.__empty_company_controls();
		this.__empty_custom_controls();

		// desmarco todas las campanas
		this.unmark_all_campaigns();

		var perm = this.perm_gui_override.get_perm_instance();
		var allowed_int_app = perm.to_application( "interaction" );
		if (allowed_int_app) {
		// Skills, los dejo desmarcados y con el valor por defecto
			this.skills_handle.unmark_all();
		}
		// las acciones las desmarco.
		this.perm_gui_override.unmark_all_actions();
		// cambio el role
		$("#adm_form_user_role").val("").trigger("change");
		this.hide_interaction_app_panels();
		this.hide_interaction_app_panels();

		// Aqui cargamos la informacion que puede cambiar dependiendo si tenemos allegro integration o no.
		this.__set_initial_state( "BREAK" );
	};

	adm_form_users.prototype.unmark_all_campaigns = function()
	{
		$("#adm_form_user_campaigns input[selector='1'][type='checkbox']").each(function(_, campaign)
		{
			var $checkbox = $(campaign);
			if ($checkbox.prop("checked")) {
				$checkbox.trigger("click");
			}
		});
	};

	adm_form_users.prototype.readonly = function()
	{
		adm_form_users.uber.readonly.call( this );  //invokes the base class method

		// readonly campaign list
		$("#adm_form_user_campaigns input[selector='1'][type='checkbox']")
			.prop("disabled", true)
			.addClass("readonly");

		// readonly skills list
		this.skills_handle.readonly();

		// disable los checkbox de la seccion de permisos.
		this.perm_gui_override.disable_all_actions( true /* disabled */ );
	};

	adm_form_users.prototype.__get_server_error_description = function( err_type, err )
	{
		err = err || {};

		const response = { is_custom_message: true, message: undefined };
		const timeout_ms = false; // infinite
		const $pwd = $("#adm_form_user_pwd");

		switch (err_type) {
		//user id errors
			case "USER ALREADY EXISTS":
				this.validation.show_validation_error($("#adm_form_user_id"), "<%=_T('User id already taken, please choose another one.')%>", timeout_ms);
			break;
			case "USER IDENTIFIER IN USE":
				this.validation.show_validation_error($("#adm_form_user_id"), FORMAT(
					"<%=_T('You do not own the lock on user id {0}, will not save, please try again later...')%>",
					$("#adm_form_user_id").val()
				), timeout_ms);
			break;
		//mail errors
			case "MAIL ALREADY EXISTS":
				this.validation.show_validation_error($("#adm_form_user_mail"), "<%=_T('E-mail address taken by another user, please choose another one.')%>", timeout_ms);
			break;
			case "MAIL IDENTIFIER IN USE":
				this.validation.show_validation_error($("#adm_form_user_mail"), "<%=_T('E-mail address taken by another user, please choose another one.')%>", timeout_ms);
			break;
			case "MAIL IS REQUIRED IN VCC WITH HELPDESK INTEGRATION":
				this.validation.show_validation_error($("#adm_form_user_mail"), "<%=_T('E-mail is required in VCC with HelpDesk Integration.')%>", timeout_ms);
			break;
		//resources
			case "NOT RESOURCES AVAILABLES":
				response.message = "<%=_T('User limit has been reached, please try again later...')%>";
			break;
		//workgroups
			case "WORKGROUP IDENTIFIER IN USE":
				response.message = "<%=_T('Workgroup identifier in use, please try again later...')%>";
			break;
			case "WORKGROUP DOES NOT EXIST":
				response.message = "<%=_T('Workgroup does not exist, please try again later...')%>";
			break;
			case "ERROR_WORKGROUPS_USERS_EXCEEDS_LIMIT_ALLOWED":
				const limitWGUsers = inConcert.app.getMaxConfigurationsAllowed("MaxWorkgroupsUsers");
				response.message = FORMAT("<%=_T('Cannot assign workgroup to the user, exceeds the allowed limit {0}.')%>", limitWGUsers);
			break;
		//permission
			case "USER_HAS_NOT_PERMISSION":
				response.message = "<%=_T('User has no right to grant permission, please try again later...')%>";
			break;
			case "GROUP_NOT_HAS_ENABLED_ACTIONS":
				response.message = "<%=_T('Error updating actions in group, Please select some permission...')%>";
			break;
			case "UNABLE TO REMOVE YOUR OWN PERMISSIONS TO UPDATE USERS":
				response.message = "<%=_T('You cannot remove your own permissions to update users.')%>";
			break;
		//campaign
			case "USER_HAS_INTERACTIONS_ON_CAMPAIGNS":
				response.message = "<%=_T('Error updating campaigns list, user has assigned conversations on campaigns, can not be removed, please try again later...')%>";
			break;
			case "ERROR_CAMPS_USERS_EXCEEDS_LIMIT_ALLOWED":
				const limitCampaignsUsers = inConcert.app.getMaxConfigurationsAllowed("MaxCampaignsUsers");
				response.message = FORMAT("<%=_T('The total number of users assigned to the campaigns exceeds the limit allowed {0}.')%>", limitCampaignsUsers);
			break;
		// role
			case "USER GROUP DOES NOT EXIST":
				this.validation.show_validation_error($("#adm_form_user_role"), "<%=_T('Permission does not exist, please choose another one.')%>", timeout_ms);
			break;
			case "UNABLE TO MODIFY ROLE OF THE LOGGED USER":
				this.validation.show_validation_error($("#adm_form_user_role"), "<%=_T('Unable to modify role permission. User has beend logged in.')%>", timeout_ms);
			break;
			case "USER_HAS_INTERACTIONS_ROLE_HAVE_NOT_PERMISSION_TO_INTERACTION_APP":
				this.validation.show_validation_error($("#adm_form_user_role"), FORMAT("<%=_T('User has {0} assigned conversations. Unable to modify role permission, new role not have permission to Interaction app.')%>", err.assigned_interactions), timeout_ms);
			break;
			case "USER_IN_ATTENTION_LEVELS_ROLE_HAVE_NOT_PERMISSION_TO_INTERACTION_APP":
				this.validation.show_validation_error($("#adm_form_user_role"), "<%=_T('Attention levels conflict. Unable to modify role permission, new role not have permission to Interaction app.')%>", timeout_ms);
			break;
		// initial state
			case "NOT ALLOWED INITIAL AVAILABLE SYSTEM STATE":
				this.validation.show_validation_error($("#adm_form_user_initial_state"), "<%=_T('The user must have permissions to Interaction application to use Available system state.')%>", timeout_ms);
			break;
		// app language
			case "UNSUPPORTED_APP_LANGUAGE":
				this.validation.show_validation_error($("#adm_form_user_app_language"), "<%=_T('Unsupported current app language.')%>", timeout_ms);
			break;
		// helpdesk integration
			case "HELPDESK_INTEGRATION_ERROR":
				const vcc_id = inConcert.app.get_vcc_id();
				const message_error = err.message_error.replace("@"+vcc_id,"")
				response.message = "<%=_T('Error updating information on HelpDesk integration...')%>" + message_error;
			break;
		// password
			case "INVALID CHARACTERS IN PASSWORD":
				response.message = "<%=_T('The new password value must not contain reserved characters (#, &, ?, =).')%>";
				$pwd.focus();
			break;
			case "INVALID JWT PASSWORD":
				response.message = "<%=_T('The new password has a invalid JWT.')%>";
				$pwd.focus();
			break;
			case "PASSWORD EXTERNAL AUTH ERROR":
				response.message = "<%=_T('Invalid password')%>";
				$("#password_checks_list").html("");
				if (typeof err.fieldValue === "object") {
					for(let checkElem of this.makePasswordsCheckUI(err.fieldValue)) {
						$("#password_checks_list").append(checkElem);
					}
					this.passwordChecks_HISTORY = err.fieldValue.HISTORY;
				}
				$pwd.focus();
			break;
		// system roles
			case "UNABLE TO UPDATE USER - FULL SYSTEM ACCESS":
				response.message = "<%=_T('Unable to update user of full system access.')%>";
			break;
		// default
			default:
				response.is_custom_message = false;
				response.message = err_type;
		}

		return response;
	};

	adm_form_users.prototype.err_save_messages = function(err)
	{
		const mark_campaigns_with_error = function(campaigns)
		{
			if (!$.isArray(campaigns)) {
				return;
			}
			$.each(campaigns, function( _, campaign )
			{
				const campaign_id_with_vcc = campaign.id + "@" + inConcert.app.getDomain();
				const $row = $("#adm_form_user_campaigns li[campaign_id='" + campaign_id_with_vcc + "']");
				$row.find("i[error='true']").show();
			});
		};

		let response = {};
		switch ( typeof err )
		{
			case "object":
				const error_type = (err.msg || err.result).toUpperCase();
				if (error_type === "MUST_HAVE_A_NAME" || error_type === "MUST_HAVE_UNIQUE_NAME") {
					$("#adm_form_user_first_name").focus();
				}
				else {
					if (error_type === "USER_HAS_INTERACTIONS_ON_CAMPAIGNS") {
						mark_campaigns_with_error(err.problematicCampaigns);
					}
					response = this.__get_server_error_description(error_type, err);
				}
			break;

			case "string":
				response = this.__get_server_error_description(err.toUpperCase(), err);
			break;
		}

		if ( response.message ) {
			adm_form_users.uber.err_save_messages.call( this, response.message, response.is_custom_message );  //invokes the base class method
		}
	};

	adm_form_users.prototype.can_validate_field = function( /*field_id*/ )
	{
		return true;
	};

	adm_form_users.prototype.get_validation_def = function()
	{
		var self = this;

		var definitions = [
			{
				control_id: "adm_form_user_id",
				messages: {
					required: "<%=_T('Please enter the user Id.')%>",
					id:       "<%=_T('Only letters, numbers, dashes and dots are allowed in the user Id.')%>",
					range: {
						between: { from: 8, to: 255 },
						get_value: function(user_id) {
							var must_validate = self.can_validate_field("adm_form_user_id");
							if ( must_validate ) {
								return user_id.length.toString();
							}
							return "";
						},
						message: "<%=_T('Length of User Id must be between {0} and {1} characters.')%>"
					}
				}
			},
			{
				control_id: "adm_form_user_first_name",
				messages: {
					required: "<%=_T('Please enter the first name.')%>"
				}
			},
			{
				control_id: "adm_form_user_first_surname",
				messages: {
					required: "<%=_T('Please enter the first surname.')%>"
				}
			},
			{
				control_id: "adm_form_user_pwd",
				can_validate: function() {
					return !inConcert.app.HasExternalUsersAuth() && (self.is_new || self.password_has_changed);
				},
				messages: {
					required: "<%=_T('Please enter the password.')%>",
					custom: {
						type:  "custom",
						valid: function() {
							var response = {
								success: true
							};
							var pwd = $("#adm_form_user_pwd").val();
							var pwd_confirm = $("#adm_form_user_pwd_confirmation").val();
							if (pwd !== pwd_confirm) {
								response.success = false;
								response.message = "<%=_T('Passwords do not match.')%>";
							}
							return response;
						}
					}
				}
			},
			{
				control_id: "adm_form_user_mail",
				messages: {
					custom: {
						type:  "custom",
						valid: function() {
							let response = {
								success: true
							};
							const has_integration = inConcert.app.has_helpdesk_integration();
							if (has_integration) {
								let email = $("#adm_form_user_mail").val().trim();
								if (email.length === 0) {
									response.success = false;
									if (!response.success) {
										response.message = "<%=_T('Please enter the e-mail address.')%>";
									}
								}
							}
							return response;
						}
					},
					email: "<%=_T('Please enter a valid e-mail address.')%>"
				}
			},
			{
				control_id: "adm_form_user_role",
				messages: {
					required: "<%=_T('Please select the permission.')%>"
				}
			},
			{
				control_id: "adm_form_user_initial_state",
				can_validate: function() {
					return self.can_validate_field("adm_form_user_initial_state");
				},
				messages: {
					required: "<%=_T('Please select the initial state.')%>",
					custom: {
						type:  "custom",
						valid: function() {
							var response = {
								success: true
							};
							var state = $("#adm_form_user_initial_state").val();
							if ( state.toUpperCase() === "ACTIVE" ) {
								var perm = self.perm_gui_override.get_perm_instance();
								response.success = perm.to_application( "interaction" );
								if ( !response.success ) {
									response.message = "<%=_T('The user must have permissions to Interaction application to use Available system state.')%>";
								}
							}
							return response;
						}
					}
				}
			},
			{
				control_id: "adm_form_user_app_language",
				messages: {
					required: "<%=_T('Please select the app language.')%>"
				}
			},
			{
				control_id: "adm_form_user_timezone",
				messages: {
					required: "<%=_T('Please select the timezone.')%>"
				}
			},
			{
				control_id: "adm_form_user_country",
				messages: {
					required: "<%=_T('Please select the country.')%>"
				}
			},
			{
				control_id: "adm_form_user_area",
				messages: {
					custom: {
						type:  "custom",
						valid: function() {
							var response = {
								success: true
							};
							var area_code = self.__get_selected_area($("#adm_form_user_area"));
							if ( area_code === null ) {
								response.success = false;
								response.message = "<%=_T('Please select the area code.')%>";
								return response;
							}
							return response;
						}
					}
				}
			},
			{
				control_id: "adm_form_user_company_location",
				messages: {
					alpha: "<%=_T('Only letters, numbers, dashes and dots are allowed in the company location.')%>",
				}
			},
			{
				control_id: "adm_form_user_company_position",
				messages: {
					alpha: "<%=_T('Only letters, numbers, dashes and dots are allowed in the company position.')%>",
				}
			},
			{
				control_id: "adm_form_user_company_organization",
				messages: {
					alpha: "<%=_T('Only letters, numbers, dashes and dots are allowed in the company organization.')%>",
				}
			},
			{
				control_id: "adm_form_user_custom_information", // con este id + el sufijo _validation visualiza la cruz indicadora de error
				messages: {
					custom: {
						type:  "custom",
						valid: function() {
							return self.__validate_custom_information();
						}
					}
				}
			},
			{
				control_id: "adm_form_user_campaigns",
				messages: {
					custom: {
						type:  "custom",
						valid: function() {
							var response = {
								success: true
							};

							var perm = self.perm_gui_override.get_perm_instance();
							var allowed_int_app = perm.to_application( "interaction" );
							if ( !allowed_int_app) {
								return response;
							}
							var has_selected_default_campaign = false;
							$("#adm_form_user_campaigns input[selector='1'][type='checkbox']").each(function( _, campaign )
							{
								var $campaign = $(campaign);
								var checked = $campaign.prop("checked");
								if (checked) {
									var $default_campaign = $("#" + $campaign.attr("id") + "_def_camp");
									has_selected_default_campaign = $default_campaign.prop("checked");
									if (has_selected_default_campaign) {
										return false; //break
									}
								}
							});

							if (!has_selected_default_campaign) {
								response.success = false;
								response.message = "<%=_T('Please select the default campaign.')%>";
							}
							return response;
						}
					}
				}
			},
			{
				control_id: "adm_form_user_permission_list", // con este id + el sufijo _validation visualiza la cruz indicadora de error
				messages: {
					custom: {
						type:  "custom",
						valid: function() {
							// valida que si se marco alguna aplicacion, que al menos se marque una accion de esta.
							return self.perm_gui_override.validate( "mark-at-least-a-action-of-the-app" );
						}
					}
				}
			},
			{
				control_id: "adm_form_user_skills_config", // con este id + el sufijo _validation visualiza la cruz indicadora de error
				messages: {
					custom: {
						type:  "custom",
						valid: function() {
							return self.skills_handle.validate();
						}
					}
				}
			}
		];

		return definitions;
	};

	adm_form_users.prototype.save = function(after_save)
	{
		var self = this;

		var callback = function(user)
		{
			var logged_user = inConcert.app.getLoggedUserId();
			if (user && logged_user === user.Id) {
				var setting = {
					personal: user
				};
				//actualizo los datos del usuario logueado.
				inConcert.app.updateSettings(setting);
				inConcert.app.m_mainWindow.updateUserInformation();
			}
			if (after_save === "SAVE_AND_CONTINUE") {
			// vacia los controles y deja pronto para agregar una nueva entidad.
				self.empty_controls();
				return;
			}
			self.close();
		};

		// hide marked errors
		$("#adm_form_user_campaigns li[campaign_id] > img[error]").hide();

		adm_form_users.uber.save.call(this, callback); //invokes the base class method
	};

	adm_form_users.prototype.on_saved = function( success, entity, after_save, err )
	{
		if ( entity.custom_permissions && entity.custom_permissions.has_override === "1" ) {
			entity.HasRoleOverride = "1";
		}
		adm_form_users.uber.on_saved.call( this, success, entity, after_save, err ); //invokes the base class method
	};

	adm_form_users.prototype.get_users_campaigns = function()
	{
		var self = this;
		var response = {
			campaigns: [],
			default_campaign: null
		};
		var role = $("#adm_form_user_role").val().toLowerCase();

		$("#adm_form_user_campaigns input[selector='1'][type='checkbox']").each(function( _, campaign )
		{
			var $campaign = $(campaign);
			var checked = $campaign.prop("checked");
			if (checked) {
				var $parent = $campaign.parent();
				var campaign_id = $parent.attr("campaign_id");
				response.campaigns.push({
					id:     campaign_id,
					role:   role,
					invite: true // TODO: ver que hago con las invitaciones de mail
				});

				var perm = self.perm_gui_override.get_perm_instance();
				var allowed_int_app = perm.to_application( "interaction" );
				if ( allowed_int_app && response.default_campaign === null) {
					var $default_campaign = $("#" + $campaign.attr("id") + "_def_camp");
					checked = $default_campaign.prop("checked");
					if (checked) {
						response.default_campaign = campaign_id;
					}
				}
			}
		});

		return response;
	};

	adm_form_users.prototype.set_user_campaigns = function( user )
	{
		var self = this;

		var user_campaigns = user.user_campaigns;
		if (!user_campaigns) {
			return;
		}

		var user_role = user.UserGroup;
		var user_campaigns_permissions = user.categorized_camp_permissions;
		var default_campaign_without_vcc = inConcert.Utils.getIdWithoutVCC(user.DefaultCampaign);
		var supervisor_workgroups = user.SupervisorWorkgroups;
		var enabled = true;
		var is_readonly = this.is_readonly();

		$.each( user_campaigns, function( campaign_id )
		{
			var id_without_vcc = inConcert.Utils.getIdWithoutVCC( campaign_id );
			var campaign_id_with_vcc = id_without_vcc + "@" + inConcert.app.getDomain();
			var chk_id = "opt_usu_cmp_" + inConcert.Utils.getNormalizedId( id_without_vcc );

			var $checkbox = $("#" + chk_id);
			$checkbox.prop("checked", enabled);
			var $default_campaign = $("#" + $checkbox.attr("id") + "_def_camp");

			if ( is_readonly ) {
				$default_campaign.addClass("readonly").prop("disabled", true);
			}
			else {
				$default_campaign.removeClass("readonly").prop("disabled", false);
			}

			$default_campaign.parent().show();

			var categorized_camp_permissions = user_campaigns_permissions[ campaign_id_with_vcc ] || {};
			$checkbox.data( "categorized_camp_permissions", categorized_camp_permissions );

			var full_role_id = self.get_full_role_id( user_role );
			var perm = self.perm_gui_override.get_perm_instance();
			perm.attach_user_one_campaign_permissions( campaign_id_with_vcc, full_role_id, categorized_camp_permissions );

			var allowed_int_app = perm.to_application( "interaction" );
			if ( allowed_int_app ) {
				if (default_campaign_without_vcc === id_without_vcc) {
					$default_campaign.prop("checked", enabled);
				}
			}
			var allowed_sup_app = perm.to_application( "supervisor" );
			if ( allowed_sup_app ) {
				if (supervisor_workgroups && supervisor_workgroups[campaign_id]) {
					var workgroups = supervisor_workgroups[campaign_id];
					var html_wkg = "";
					var i = 1;
					$.each(workgroups, function(workgroup_id)
					{
						if (i > 1) {
							html_wkg = html_wkg + ", ";
						}
						var wkg = self.workgroups[workgroup_id];
						if (wkg) {
							html_wkg = html_wkg + "\"" + (wkg.Name || workgroup_id) + "\"";
							i++;
						}
					});
					$checkbox.parent().find("div[group='supervisor'] > div[list='true']").html(html_wkg);
				}
			}
		});
	};

	adm_form_users.prototype.fill_campaigns = function( campaigns )
	{
		var sorted_campaigns = inConcert.Utils.sortArray(campaigns, null, null,
			function(campaign) {
				return campaign.Name || campaign.Id;
			});

		var $campaigns = $("#adm_form_user_campaigns");
		$campaigns.html("");

		var is_readonly = this.is_readonly();
		var readonly_class = is_readonly ? "readonly" : "";
		var readonly_prop = is_readonly ? " disabled='true' " : "";

		$.each(sorted_campaigns, function( _, campaign )
		{
			var id_without_vcc = inConcert.Utils.getIdWithoutVCC(campaign.Id);
			var campaign_name = campaign.Name || id_without_vcc;
			var campaign_desc = campaign.Description || "";

			// seccion user - grilla de campaigns
			var user_campaign_id = "opt_usu_cmp_" + inConcert.Utils.getNormalizedId( id_without_vcc );


			var $camp = $(
				"<li class='viewListItem formListItem' campaign_id='" + campaign.Id + "'>" +

					"<input class='formListCheck " + readonly_class + "' id='"  + user_campaign_id + "' campaign_id='" + id_without_vcc + "' selector='1' type='checkbox' " + readonly_prop + " />"  +
					"<div class='viewListItemText'>"                                                                   +
						"<label for='" + user_campaign_id + "'>" + campaign_name + "</label>"                      +
					"</div>"                                                                                       +
					"<div class='viewListItemText'>"                                                                   +
						"<label for='" + user_campaign_id + "'>" + campaign_desc + "</label>"                      +
					"</div>"                                                                                       +
					"<i error='true' class='formFieldValidation formFieldError' hidden ></i>" +

				// markup grupo agent
					"<div class='formItemCheckbox200'>" +
						"<div group='agent' class='form-check' style='display:none;'>" +
							"<input class='formListRadio " + readonly_class + "' id='"  + user_campaign_id + "_def_camp' type='radio' name='default_campaign' disabled='true' />" +
							"<label class='form-check-label' for='" + user_campaign_id + "_def_camp'>" + "<%=_T('Default Campaign')%>" + "</label>" +
						"</div>" +
					"</div>" +

				// markup grupo supervisor
				//	"<div group='supervisor' class='formWorkgroupList' style='display:none;'><div list='true'></div></div>" + im:oculte esto porque rompe todo y no carga nada

				"</li>");

			// agrego la campana al markup
			$campaigns.append( $camp );
		});
	};

	adm_form_users.prototype.fill_roles = function( roles )
	{
		var self = this;
		this.roles = roles;
		var $combo = $("#adm_form_user_role");
		$combo.html("");

		// el hash de grupos se pasa a un array ordenado alfabeticamente, y se filtra segun la funcion "has_permissions"
		var sorted_roles = inConcert.Utils.hash_to_sorted_array( roles,
			function(role) {
				return role.Name? role.NameLabel : role.IdLabel;
			});
		var selected = true;
		this.combo_add_value( $combo, "", "", selected );
		// ahora se recorre el array ordenado y se agregan los items al combo.
		$.each(sorted_roles, function( _, role )
		{
			selected = false;
			var name = role.NameLabel || role.IdLabel;
			var $option = self.combo_add_value( $combo, role.Id, name, selected, "permissions", role.grouppermissions );
			if ( $option && $option.length > 0 ) {
				$option.data( "categorized_permissions", role.categorized_permissions );
			}
		});
	};

	adm_form_users.prototype.fill_user_states = function()
	{
		var self = this;
		var $combo = $("#adm_form_user_initial_state");
		$combo.html("");

		var user_states = inConcert.app.getAvailableStates();
		$.each(user_states, function( _, state )
		{
			var selected = state.Id === "BREAK";
			self.combo_add_value($combo, state.Id,
				function() {
					return inConcert.app.getStatusDescription(state.Id);
				},
				selected);
		});
	};

	adm_form_users.prototype.fill_workgroups = function( workgroups )
	{
		var self = this;
		var $combo = $("#adm_form_user_agent_workgroup");
		$combo.html("");
		this.combo_add_value($combo, "", "<%=_T('-- none --')%>", true);

		this.workgroups = {};
		$.each(workgroups, function( _, workgroup )
		{
			self.combo_add_value($combo, workgroup.Id, workgroup.Name, false);
			self.workgroups[workgroup.Id] = workgroup;
		});
	};

	adm_form_users.prototype.fill_combo_datetime_formats = function()
	{
		const formats = [
			{ id: "dd/mm/yy"  , name: "dd/mm/yy"   },
			{ id: "dd/mm/yyyy", name: "dd/mm/yyyy" },
			{ id: "mm/dd/yyyy", name: "mm/dd/yyyy" },
			{ id: "yyyy-mm-dd", name: "yyyy-mm-dd" }
		];

		const $format_container = $("#adm_form_user_format_datetime");
		const is_blank_first_item = false;
		const attr_id = "id";
		const attr_name = "name";

		this.fill_combo( $format_container, is_blank_first_item, formats, attr_id, attr_name );
	};

	adm_form_users.prototype.load_specific_data = function( /*editing_user_id*/ )
	{
		var self = this;
		// Requests unicamente SI NO tenemos integracion con Allegro
		this.requests.push({
			request_function: function(success) {
				return inConcert.app.refreshAvailableStates(success);
			},
			success: function() {
				self.fill_user_states();
			}
		});
	};

	adm_form_users.prototype.load_data = function( callback_complete_requests, editing_user_id )
	{
		var self = this;
		var base_uri = inConcert.app.getBaseDomain() + "/inconcert/apps/administration/";

		this.requests = [
			{
				// esto tiene que estar en una funcion dentro de otra, porque sino
				//	dentro de "request_load_apps_actions, no accede al this que corresponde.
				request_function: function( success ) {
					//realiza un return del resultado del air.invoke.
					// el mismo es utilizado por si se desea cancelar el request.
					return inConcert.permissions.load_apps_actions( success );
				},
				success: function(application_actions) {
					self.perm_gui_override.build_apps_permissions( application_actions );
				}
			},
			{
				request_function: function(success /*, response */) {
					return inConcert.app.loadAllRoles( success );
				},
				success: function(roles) {
					self.fill_roles(roles);
				}
			},
			{
				request_function: function( success ) {
					return self.telephone_codes.loadCountries( success );
				},
				success: function( countries ) {
					self.fill_countries( countries, $("#adm_form_user_country") );
				}
			},
			{
				request_function: function(success) {
					return inConcert.app.loadTimezones(success);
				},
				success: function(response) {
					var $combo_timezone = $(self.cbo_timezone_id);
					self.fill_timezones(response, $combo_timezone); // funcion definida en clase base "conf_form"
				}
			},
			{
				url: base_uri + "campaigns/search/",
				type: "POST",
				data: {columns: ["Id", "Name", "Description" ]},
				success: function(campaigns)
				{
					self.fill_campaigns(campaigns.rows);
				}
			},
			{
				url: base_uri + "workgroups/search/",
				type: "POST",
				data: {columns: ["Id", "Name", "Description"]},
				success: function(workgroups)
				{
					self.fill_workgroups(workgroups.rows);
				}
			}
		];

		// carga datos especificos segun la clase user o las clases que extienden de ella
		this.load_specific_data( editing_user_id );

		// realiza sus propios requests, desacoplado de los request del frm
		this.skills_handle.load_data();
		this.fill_combo_app_languages($("#adm_form_user_app_language"), true);
		this.fill_combo_datetime_formats();

		adm_form_users.uber.load_data.call( this, callback_complete_requests );  //invokes the base class method
	};

	adm_form_users.prototype.show_interaction_app_panels = function()
	{
		$("#adm_form_user_role_panels").find("[panel='agent']").show();
		$("#adm_form_user_role_panels_workgroup").find("[panel='agent']").show();

		var is_readonly = this.is_readonly();

		$("#adm_form_user_campaigns").find("input[selector='1'][type='checkbox']").each(function( _, campaign )
		{
			var $campaign         = $(campaign);
			var checked           = $campaign.prop("checked");
			var $default_campaign = $("#" + $campaign.attr("id") + "_def_camp");
			var is_internal       = $campaign.attr("id").includes("internal_calls");

			if ( checked && !is_internal ) {
				$default_campaign.prop("disabled", false);
				$default_campaign.parent().show();
			}
			else {
				$default_campaign.prop("disabled", true);
				$default_campaign.parent().hide();
			}

			if ( is_readonly ) {
				$default_campaign.addClass("readonly").prop("disabled", true);
			}
			else {
				$default_campaign.removeClass("readonly");
			}
		});
	};

	adm_form_users.prototype.hide_interaction_app_panels = function()
	{
		$("#adm_form_user_role_panels").find("[panel='agent']").hide();
		$("#adm_form_user_role_panels_workgroup").find("[panel='agent']").hide();
	};

	adm_form_users.prototype.show_supervisor_app_panels = function()
	{
		$("#adm_form_user_campaigns").find("[group='supervisor']").show();
	};

	adm_form_users.prototype.hide_supervisor_app_panels = function()
	{
		$("#adm_form_user_campaigns").find("[group='supervisor']").show();
	};

	adm_form_users.prototype.show_role_panels = function()
	{
		var perm = this.perm_gui_override.get_perm_instance();
		var $role_panels = $("#adm_form_user_role_panels");
		var $role_panels_workgroup = $("#adm_form_user_role_panels_workgroup");
		var $grid_user_campaigns = $("#adm_form_user_campaigns");

		$role_panels.find("[panel]").hide();
		$role_panels_workgroup.find("[panel]").hide();
		$grid_user_campaigns.find("[group]").hide();

		var allowed_int_app = perm.to_application( "interaction" );
		if ( allowed_int_app ) {
			this.show_interaction_app_panels();
		}

		var allowed_sup_app = perm.to_application( "supervisor" );
		if ( allowed_sup_app ) {
			this.show_supervisor_app_panels();
		}
	};

	adm_form_users.prototype.on_change_role = function( $role )
	{
		var group_permissions = $role.data( "permissions" );
		this.perm_gui_override.mark_actions( group_permissions );

		var perm = this.perm_gui_override.get_perm_instance();
		var categorized_permissions = $role.data( "categorized_permissions" );
		perm.set_group_permissions( categorized_permissions );

		if ( this.current_user && this.current_user.categorized_permissions ) {
			perm.set_user_vcc_permissions( this.current_user.categorized_permissions );
			this.current_user.categorized_permissions = null;
		}
		else {
			perm.set_user_vcc_permissions( null );
		}

		var full_role_id = this.get_full_role_id( $role.val() );

		$("#adm_form_user_campaigns input[selector='1'][type='checkbox']").each(function(_, campaign)
		{
			var $checkbox = $(campaign);
			var checked = $checkbox.prop("checked");
			if ( checked ) {
				var $parent = $checkbox.parent();
				var campaign_id = $parent.attr("campaign_id");
				perm.detach_user_one_campaign_permissions( campaign_id );
				var categorized_campaign_permissions = $checkbox.data( "categorized_camp_permissions" );
				perm.attach_user_one_campaign_permissions( campaign_id, full_role_id, categorized_campaign_permissions );
			}
		});

		// If have administration permissions and is restricted
		if (group_permissions && group_permissions.administration && group_permissions.administration.admin_restricted) {
			// Disable the checkboxes for  administration app / view users section and his childs.
			this.perm_gui_override.disable_specific_group(
				true             , /* disabled */
				"administration" , /* app */
				"viewusers"     , /* group id */
				true               /* aplicar cambios a todos los hijos */
			);
			// Disable the checkboxes for  administration app / view permissions section and his childs.
			this.perm_gui_override.disable_specific_group(
				true             , /* disabled */
				"administration" , /* app */
				"viewgroups"     , /* group id */
				true               /* aplicar cambios a todos los hijos */
			);
		}
		else {
			// Enable the checkboxes for  administration app / view users section and his childs.
			this.perm_gui_override.disable_specific_group(
				false             , /* disabled */
				"administration" , /* app */
				"viewusers"     , /* group id */
				true               /* aplicar cambios a todos los hijos */
			);
			// Enable the checkboxes for  administration app / view permissions section and his childs.
			this.perm_gui_override.disable_specific_group(
				false             , /* disabled */
				"administration" , /* app */
				"viewgroups"     , /* group id */
				true               /* aplicar cambios a todos los hijos */
			);
		}
	};

	adm_form_users.prototype.set_events = function()
	{
		var self = this;

		adm_form_users.uber.set_events.call( this );  //invokes the base class method

		if (this.is_readonly()) {
			return;
		}

		// seteo los eventos del container de acciones de permisos
		self.perm_gui_override.set_events();

		// evento change del combo de groups roles
		$("#adm_form_user_role")
			.off("change keyup")
			.on("change keyup", function(e)
			{
				if (e.type.toLowerCase() === "keyup") {
					var key = e.keyCode;
					//teclas del cursor
					if (key < 37 && key > 40) {
						return;
					}
				}
				var $combo = $(this);
				var $option_selected = $("option:selected", this);

				// Este timeout es agregado para que no quede la opcion del combo congelada
				// mientras se realizan las operaciones cuando se cambia de opcion en el combo
				window.setTimeout(function()
				{
					var role = $combo.val();
					if ( role.length === 0 ) {
					// si no selecciono ningun grupo
						self.perm_gui_override.unmark_all_actions();
					}
					else {
					// si selecciono algun grupo marco
						self.on_change_role( $option_selected );
					}
					self.show_role_panels();
				}, 100);
			});

		// Esta funcion muestra el textbox de confirmacion de pwd.
		var show_pwd_confirm = function()
		{
			if (self.password_has_changed) {
				return;
			}
			self.password_has_changed = true;
			$("#adm_form_user_pwd_confirmation_section").show();
		};
		//---------------
		// eventos (paste, keypress, keydown) del text de pwd que habilitan el textbox de confirmación de pwd
		$("#adm_form_user_pwd")
			.on("paste", null, show_pwd_confirm)	//evento paste, ya sea desde el menu contextual o presionando ctrl-v
			.on("keypress", show_pwd_confirm)		//este evento captura las teclas presionandas que modifican el valor, menos las teclas "backspace" y "delete"
			.on("keydown", function(event) {
				/*
					En el evento keydown capturo y proceso las teclas que se han presionado y que modifican el texto existente.
						-keyCode 8  = tecla "backspace" y -keyCode 46 = tecla "delete"
				*/
				if (event.keyCode === 8 || event.keyCode === 46) {
					show_pwd_confirm();
				}
			}
		);

		const $area = $("#adm_form_user_area");
		$("#adm_form_user_country").change(function() {
			var country_code = $(this).val();
			window.setTimeout(function() {
				self.fill_combo_areas(country_code, $area, true);
			}, 50);
		});

		var show_specifics_ctrls = function( $checkbox, is_internal ) {
			var perm = self.perm_gui_override.get_perm_instance();
			self.show_role_panels();

			var allowed_int_app = perm.to_application( "interaction" );
			if ( !allowed_int_app ) {
				return;
			}
			var $default_campaign = $("#" + $checkbox.attr("id") + "_def_camp");
			if ( $checkbox.prop( "checked" ) && !is_internal ) {
				$default_campaign
					.prop("disabled", false)
					.focus();
				$default_campaign.parent().show();
			}
			else {
				$default_campaign
					.prop("disabled", true)
					.prop("checked", false);
				$default_campaign.parent().hide();
			}

			if ( self.is_readonly() ) {
				$default_campaign.addClass("readonly").prop("disabled", true);
			}
			else {
				$default_campaign.removeClass("readonly");
			}
		};

		// evento de los checkbox del panel user campaigns (habilita los options de default campaign)
		$("#adm_form_user_campaigns input[selector='1'][type='checkbox']")
			.off("click")
			.on("click", function()
			{
				var $role = $("#adm_form_user_role");
				var role = $role.val();
				if ( typeof role !== "string" ) {
					return;
				}

				var perm = self.perm_gui_override.get_perm_instance();
				if ( !perm ) {
					return;
				}

				var full_role_id = self.get_full_role_id( role );
				var $checkbox    = $( this );
				var campaign_id  = $checkbox.parent().attr( "campaign_id" );
				var is_internal  = campaign_id.includes("internal_calls");

				if ( $checkbox.prop( "checked" ) && !is_internal ) {
					var categorized_campaign_permissions = $checkbox.data( "categorized_camp_permissions" );
					if ( categorized_campaign_permissions ) {
						perm.attach_user_one_campaign_permissions( campaign_id, full_role_id, categorized_campaign_permissions );
						show_specifics_ctrls( $checkbox, is_internal );
					}
					else {
						var campaign = new inConcert.Campaign( {Id: campaign_id}, undefined, "administration");
						var user_id = $("#adm_form_user_id").val();

						campaign.getUserCampaignPermissions( user_id,
							function( response /*, err*/ ) {
								if ( !response ) {
									var timeout_ms = false; //infinite
									self.show_status_message( "<%=_T('Error retrieving user campaign permissions.')%>", "Error", timeout_ms);
									return;
								}
								categorized_campaign_permissions = response[ campaign_id ];
								$checkbox.data( "categorized_camp_permissions", categorized_campaign_permissions ); // lo cacheo, asi la proxima vez no realizo el request
								perm.attach_user_one_campaign_permissions( campaign_id, full_role_id, categorized_campaign_permissions );
								show_specifics_ctrls( $checkbox, is_internal );
							});
					}
				}
				else {
					perm.detach_user_one_campaign_permissions( campaign_id );
					show_specifics_ctrls( $checkbox, is_internal );
				}
			});

			//Para que muestre/oculte las restricciones de password
			$("#adm_form_user_pwd")
				.off("focusin")
				.on("focusin", function() {
					// Al tomar el foco debemos actualizar el status de cada check
					let hasExternalUsersAuth = inConcert.app.HasExternalUsersAuth();
					if(!hasExternalUsersAuth && self.password_has_changed && self.m_vccInfo.passwordChecks) {
						//Deep copy to avoid change self.m_vccInfo.passwordChecks object
						let passwordChecks = JSON.parse(JSON.stringify(self.m_vccInfo.passwordChecks));
						const minUpperChars = passwordChecks.UPPERS.range[0];
						const minLowerChars = passwordChecks.LOWERS.range[0];
						const minSpecialChars = passwordChecks.SYMBOLS.range[0];
						const minNumericChars = passwordChecks.NUMBERS.range[0];
						const minLen = passwordChecks.LEN.range[0];
						const maxLen = passwordChecks.LEN.range[1];
						const passwordChecksValid = !isNaN(minUpperChars) && !isNaN(minLowerChars) && !isNaN(minSpecialChars) && !isNaN(minNumericChars) && !isNaN(minLen) && !isNaN(maxLen);
						if(passwordChecksValid) {
							const password = $("#adm_form_user_pwd").val();
							var numUpper = password.length - password.replace(/[A-Z]/g, "").length; 
							var numLower = password.length - password.replace(/[a-z]/g, "").length; 
							var numSpecial = password.length - password.replace(/[^a-zA-Z0-9]/g, "").length; 
							var numNumbers = password.length - password.replace(/[0-9]/g, "").length; 

							passwordChecks.UPPERS.success = numUpper >= minUpperChars;
							passwordChecks.LOWERS.success = numLower >= minLowerChars;
							passwordChecks.SYMBOLS.success = numSpecial >= minSpecialChars;
							passwordChecks.NUMBERS.success = numNumbers >= minNumericChars;
							passwordChecks.LEN.success = password.length >= minLen && password.length <= maxLen;
							passwordChecks.HISTORY = self.passwordChecks_HISTORY || self.m_vccInfo.passwordChecks.HISTORY || {range:[]};

							$("#password_checks_list").html("");
							for(var checkElem of self.makePasswordsCheckUI(passwordChecks)) {
								$("#password_checks_list").append(checkElem);
							}
						}
					}
					$("#password_checks_container").toggle(!hasExternalUsersAuth);
				});
			$("#adm_form_user_pwd")
				.off("focusout")
				.on("focusout", function() {
					$("#password_checks_container").toggle(false);
				});	
	};

	adm_form_users.prototype.apply_initial_config = function()
	{
		var conf = this.instance_config;
		if (conf) {
			if (conf.message.mail) {
				var message = conf.message.mail;
				var timeout_ms = false; //infinite
				this.show_status_message(message, "Error", timeout_ms);
			}
			if (conf.message.update_button) {
				$("#" + conf.message.update_button.id).val(conf.message.update_button.caption);
			}
			if (conf.focus) {
				$("#" + conf.focus).focus();
				$("#" + conf.focus + "_validation").show();
			}
			else {
				$("#adm_form_user_id").focus();
			}
		}
		else {
			$("#adm_form_user_id").focus();
		}
	};

	adm_form_users.prototype.makePasswordsCheckUI = function(passwordChecks)
	{
		if (typeof passwordChecks !== "object") {
			return [];
		}
		const makePasswordCheckUI = function(cssClass, text) {
			return $(
				"<div class='" + cssClass + "'>" +
					text +
				"</div>"
			);
		};
		let translatedPasswordChecks = [];
		//passwordLen always goes
		let passwordLenText = inConcert.Utils.format("<%=_T('Be between {0} and {1} characters long')%>", passwordChecks.LEN.range[0], passwordChecks.LEN.range[1]);

		let passwordLenClass = passwordChecks.LEN.success === true ? "passwordCheckStatusPass" : (passwordChecks.LEN.success === false ? "passwordCheckStatusFail" : "passwordCheckStatusInitial");
		translatedPasswordChecks.push(makePasswordCheckUI(passwordLenClass, passwordLenText));

		if(passwordChecks.LOWERS.range[0] > 0) {
			let minLowerCharsText = inConcert.Utils.format("<%=_T('Include at least {0} lowercase characters')%>", passwordChecks.LOWERS.range[0]);
			let minLowerCharsLenClass = passwordChecks.LOWERS.success === true ? "passwordCheckStatusPass" : (passwordChecks.LOWERS.success === false ? "passwordCheckStatusFail" : "passwordCheckStatusInitial");
			translatedPasswordChecks.push(makePasswordCheckUI(minLowerCharsLenClass, minLowerCharsText));
		}
		if(passwordChecks.UPPERS.range[0] > 0) {
			let minUpperCharsText = inConcert.Utils.format("<%=_T('Include at least {0} uppercase characters')%>", passwordChecks.UPPERS.range[0]);
			let minUpperCharsLenClass = passwordChecks.UPPERS.success === true ? "passwordCheckStatusPass" : (passwordChecks.UPPERS.success === false ? "passwordCheckStatusFail" : "passwordCheckStatusInitial");
			translatedPasswordChecks.push(makePasswordCheckUI(minUpperCharsLenClass, minUpperCharsText));
		}
		if(passwordChecks.NUMBERS.range[0] > 0){
			let minNumericCharsText = inConcert.Utils.format("<%=_T('Include at least {0} numeric characters')%>", passwordChecks.NUMBERS.range[0]);
			let minNumericCharsLenClass = passwordChecks.NUMBERS.success === true ? "passwordCheckStatusPass" : (passwordChecks.NUMBERS.success === false ? "passwordCheckStatusFail" : "passwordCheckStatusInitial");
			translatedPasswordChecks.push(makePasswordCheckUI(minNumericCharsLenClass, minNumericCharsText));
		}
		if(passwordChecks.SYMBOLS.range[0] > 0) {
			let minSpecialCharsText = inConcert.Utils.format("<%=_T('Include at least {0} special characters')%>", passwordChecks.SYMBOLS.range[0]);
			let minSpecialCharsLenClass = passwordChecks.SYMBOLS.success === true ? "passwordCheckStatusPass" : (passwordChecks.SYMBOLS.success === false ? "passwordCheckStatusFail" : "passwordCheckStatusInitial");
			translatedPasswordChecks.push(makePasswordCheckUI(minSpecialCharsLenClass, minSpecialCharsText));
		}
		if(passwordChecks.HISTORY.range[0] > 0) {
			let historyText = inConcert.Utils.format("<%=_T('Not have been used in the last {0} passwords')%>", passwordChecks.HISTORY.range[0]);
			let historyClass = passwordChecks.HISTORY.success === true ? "passwordCheckStatusPass" : (passwordChecks.HISTORY.success === false ? "passwordCheckStatusFail" : "passwordCheckStatusInitial");
			translatedPasswordChecks.push(makePasswordCheckUI(historyClass, historyText));
		}
		return translatedPasswordChecks;
	};

	adm_form_users.prototype.ready = function()
	{
		// inicio el override de permisos
		this.perm_gui_override.initialize();
		// inicio la asignacion de skills
		this.skills_handle.initialize();

		adm_form_users.uber.ready.call( this );  //invokes the base class method

		var $id = $("#adm_form_user_id");
		$("#adm_form_user_pwd_section").toggle(!inConcert.app.HasExternalUsersAuth());
		$("#adm_form_user_must_change_password_section").toggle(!inConcert.app.HasExternalUsersAuth());
		if ( this.is_new ) {
			if(inConcert.app.HasExternalUsersAuth()) {
				$("#adm_form_user_pwd").val("");
			}
			$("#adm_form_user_pwd_confirmation_section").toggle(!inConcert.app.HasExternalUsersAuth());
		/* este codigo queda comentado porque en algun momento se va a poder visualizar el avatar en el frm de usuarios
			$("#adm_form_user_avatar").hide();
		*/
			this.readonly_control( $id, false /* disabled */ , true /* is_required */ );
			$id.focus();
		}
		else {
			$("#adm_form_user_pwd_confirmation_section").hide();

			this.readonly_control( $id, true /* disabled */ );

		/* este codigo queda comentado porque en algun momento se va a poder visualizar el avatar en el frm de usuarios
			$("#adm_form_user_avatar").show();
		*/
		}

		// Deshabilito controles de campos que provienen de una sincronización de usuarios desde app externa
		var hasExternalUsersSync = inConcert.app.HasExternalUsersSync();
		var controlIdToFocus = hasExternalUsersSync ? "#adm_form_user_last_name" : "#adm_form_user_first_name";
		var $adm_form_user_first_name = $("#adm_form_user_first_name");
		var $adm_form_user_first_surname = $("#adm_form_user_first_surname");
		var $adm_form_user_role = $("#adm_form_user_role");
		var $adm_form_user_pwd = $("#adm_form_user_pwd");

		this.readonly_control( $adm_form_user_first_name, hasExternalUsersSync, true /*required*/);
		this.readonly_control( $adm_form_user_first_surname, hasExternalUsersSync, true /*required*/);
		this.readonly_control( $adm_form_user_role, hasExternalUsersSync, true /*required*/);
		this.readonly_control( $adm_form_user_pwd, hasExternalUsersSync, true /*required*/);

		$(controlIdToFocus).focus();

		// Password checks
		this.m_vccInfo = inConcert.app.get_vcc_info();
		if(!hasExternalUsersSync && this.m_vccInfo.passwordChecks) {
			$("#password_checks_list").html("");
			for(var checkElem of this.makePasswordsCheckUI(this.m_vccInfo.passwordChecks)) {
				$("#password_checks_list").append(checkElem);
			}
		}		

		//inicializo el plugin password strength
		$("#adm_form_user_pwd").inconcert_password_strength(
		{
			veredictWords: {
				empty: {
					text: "<%=_T('Empty')%>",
					className: "passwordMessage passwordEmpty"
				},
				very_weak: {
					text: "<%=_T('Very Weak')%>",
					className: "passwordMessage passwordVeryWeak"
				},
				weak: {
					text: "<%=_T('Weak')%>",
					className: "passwordMessage passwordWeak"
				},
				mediocre: {
					text: "<%=_T('Mediocre')%>",
					className: "passwordMessage passwordMediocre"
				},
				strong: {
					text: "<%=_T('Strong')%>",
					className: "passwordMessage passwordStrong"
				},
				stronger: {
					text: "<%=_T('Stronger')%>",
					className: "passwordMessage passwordStronger"
				}
			}
		});
	};

	adm_form_users.prototype.popup_html = function(/*params*/)
	{
		return this.m_importations_handle.$get_markup();
	};

	adm_form_users.prototype.popup_on_render = function(/*params*/)
	{
		return this.m_importations_handle.on_render();
	};

	adm_form_users.prototype.popup_set_events = function(/*params*/)
	{
		return this.m_importations_handle.set_events();
	};

	adm_form_users.prototype.popup_dispose = function()
	{
		return this.m_importations_handle.dispose();
	};

	adm_form_users.prototype.popup_hide = function()
	{
		adm_form_users.uber.popup_hide.call(this); //invokes the base class method
		if (this.m_importations_handle.has_made_imports()) {
			this.dashboard.view.refresh();
		}
	};

}());
