/* jshint forin:true, noarg:true, jquery:true, noempty:true, eqeqeq:true, bitwise:true,
	strict:true, undef:true, unused:vars, curly:false, -W014, browser:true, indent:false, maxerr:50, esversion: 11 */

/* global $, inConcert */

if (!this.inConcert) {
	this.inConcert = {};
}

// try improve namespacing a bit
if ( !this.inConcert.Administration ) {
	this.inConcert.Administration = {};
}

if ( !this.inConcert.Administration.Campaigns ) {
	this.inConcert.Administration.Campaigns = {};
}

(function () {

	"use strict";

	const SEC        = inConcert.Utils.millisecondsToSeconds;
	const MS         = inConcert.Utils.secondsToMilliseconds;
	const BOOL       = inConcert.Utils.to_boolean;
	const FORMAT     = inConcert.Utils.format;
	const MAX_ALLOWED_PHONE_ACCOUNTS = -1; // es infinito
	const INC_TAB_ID = "incoming";
	const OUT_TAB_ID = "outgoing";
	// Este valor debe coincidir con el valor que se valida en el "IR.CALL"
	const UNLIMITED_VALUE_AFTER_CONVERSATION_WORK = 999999999;

	const AGENT_NOANSWER_MIN_SECCONDS = 30;
	const AGENT_NOANSWER_MAX_SECCONDS = 1800;

	//---------------------------------------------------------------------
	// frm call account edition
	function CallAccountPanel( params )
	{
		const self = this;
		/* jshint validthis: true*/
		this.prefix_id = "adm_form_campaign_accounts_call_";
		var success = CallAccountPanel.uber.constructor.call( this, params );
		if ( !success ) {
			return;
		}
		this.panel_type                  = "call";

		this.container_id                = "#adm_form_campaign_accounts_call_panel";
		this.packages_conf               = "#adm_form_campaign_accounts_call_packages_config";

		// controles
		this.name                        = "#adm_form_campaign_accounts_call_name";
		this.distribution                = "#adm_form_campaign_accounts_call_distribution";
		this.language                    = "#adm_form_campaign_accounts_call_language";
		this.priority                    = "#adm_form_campaign_accounts_call_priority";
		this.tagline_new                 = "<%=_T('New call account.')%>";
		this.tagline_edit                = "<%=_T('Edit call account {0}.')%>";
		this.tagline_readonly            = "<%=_T('Call account {0}.')%>";
		this.allowAgentListenContactOnHold                = "#adm_form_campaign_accounts_call_allow_agent_listen_contact_on_hold";

		// common ctrls
		this.optimizeNodeDistribution    = "#adm_form_campaign_accounts_call_optimizeNodeDistribution";
		this.callback                    = "#adm_form_campaign_accounts_call_callback";
		this.callback_retain_abandoned   = "#adm_form_campaign_accounts_call_callback_retain_abandoned";
		this.callback_retain_appointment = "#adm_form_campaign_accounts_call_callback_retain_appointment";

		// after conversation
		this.uses_after_conversation_work       = "#adm_form_campaign_accounts_call_after_conversation_work";
		this.after_conversation_work_panel      = "#adm_form_campaign_accounts_call_after_conversation_work_data_panel";
		this.after_conversation_work_time       = "#adm_form_campaign_accounts_call_after_conversation_work_time";
		this.after_conversation_work_time_limit = "#adm_form_campaign_accounts_call_after_conversation_work_time_limit";

		// screen recording
		this.screen_recording_container           = "#adm_form_campaign_accounts_call_screen_recording_container";
		this.screen_recording                     = "#adm_form_campaign_accounts_call_screen_recording";
		this.screen_recording_percentage          = "#adm_form_campaign_accounts_call_screen_recording_percentage";

		// incoming controls
		this.inc_enabled_config          = "#adm_form_campaign_accounts_call_enabled_incoming";
		this.inc_panel_enabled           = "#adm_form_campaign_accounts_call_enabled_panel_incoming";
		this.inc_redial                  = "#adm_form_campaign_accounts_call_redial_incoming";
		this.inc_auto_answer             = "#adm_form_campaign_accounts_call_auto_answer_incoming";
		this.inc_auto_answer_time        = "#adm_form_campaign_accounts_call_auto_answer_time_incoming";
		//voicemail controls
		this.inc_voicemail_lifetime      = "#adm_form_campaign_accounts_call_voicemail_timeout_retain_incoming";
		this.inc_voicemail_lifetime_help = "#adm_form_campaign_accounts_call_voicemail_timeout_retain_incoming_help";
		this.inc_voicemail_timeout       = "#adm_form_campaign_accounts_call_voicemail_timeout_incoming";
		this.inc_voicemail_waiting       = "#adm_form_campaign_accounts_call_voicemail_waiting_incoming";
		this.inc_voicemail_waiting_digit = "#adm_form_campaign_accounts_call_voicemail_waiting_digit_incoming";
		this.inc_voicemail_of_hours      = "#adm_form_campaign_accounts_call_voicemail_leave_at_out_of_hours_incoming";

		this.inc_virtualhold_waiting       = "#adm_form_campaign_accounts_call_virtualhold_waiting_incoming";
		this.inc_virtualhold_waiting_digit = "#adm_form_campaign_accounts_call_virtualhold_waiting_digit_incoming";
		this.inc_virtualhold_waiting_no_answer = "#adm_form_campaign_accounts_call_virtualhold_waiting_no_answer_incoming";
		this.inc_virtualhold_callback_process = "#adm_form_campaign_accounts_call_virtualhold_callback_process";
		this.inc_virtualhold_callback_batch = "#adm_form_campaign_accounts_call_virtualhold_callback_batch";

		this.inc_timeout_callback	     = "#adm_form_campaign_accounts_call_timeout_callback";
		this.inc_timeout_callback_process = "#adm_form_campaign_accounts_call_timeout_callback_process";
		this.inc_timeout_callback_batch  = "#adm_form_campaign_accounts_call_timeout_callback_batch";

		// outgoing controls
		this.out_enabled_config          = "#adm_form_campaign_accounts_call_enabled_outgoing";
		this.out_panel_enabled           = "#adm_form_campaign_accounts_call_enabled_panel_outgoing";
		this.out_manual_calls            = "#adm_form_campaign_accounts_call_allow_manual_calls_outgoing";
		this.out_invalid_numbers         = "#adm_form_campaign_accounts_call_allow_invalid_numbers_outgoing";
		this.out_prefix                  = "#adm_form_campaign_accounts_call_outbound_prefix_outgoing";

		// thresholds
		this.thresholds_info             = "#adm_form_campaign_accounts_call_thresholds_info";

		this.messages_class              = inConcert.adm_form_campaigns_call_account_messages;		
		
		//webcall
		this.webcall_enabled               = "#adm_form_campaign_accounts_webcall_enabled"                             ;
		this.webcall_package               = "#adm_form_campaign_accounts_webcall_package"                             ;

		this.tracking                      = "#adm_form_campaign_accounts_webcall_tracking"                            ;
		this.tracking_code                 = "#adm_form_campaign_accounts_webcall_tracking_code"                       ;
		this.tracking_disclaimer           = "#adm_form_campaign_accounts_webcall_tracking_disclaimer"                 ;
		
		this.tweety_app_name               = "#adm_form_campaign_accounts_webcall_tweety_app_name"                     ;
		this.tweety_info                   = "#adm_form_campaign_accounts_webcall_tweety_info"                         ;

		this.snippet_code                  = "#adm_form_campaign_accounts_webcall_snippet"                             ;
		this.snippet_param_list            = "#adm_form_campaign_accounts_webcall_snippet_parameters"                  ;
		this.snippet_param_new             = "#adm_form_campaign_accounts_webcall_snippet_new_parameter"               ;
		this.snippet_param_popup           = "#adm_form_campaign_accounts_webcall_snippet_popup_parameters"            ;
		this.snippet_param_control_id      = "#adm_form_campaign_accounts_webcall_snippet_param_control_id"            ;
		this.snippet_param_type            = "#adm_form_campaign_accounts_webcall_snippet_param_type"                  ;
		this.snippet_param_alias           = "#adm_form_campaign_accounts_webcall_snippet_param_alias"                 ;
		this.snippet_param_hidden          = "#adm_form_campaign_accounts_webcall_snippet_param_hidden"                ;
		this.snippet_param_create          = "#adm_form_campaign_accounts_webcall_snippet_param_create"                ;
		this.snippet_param_create_continue = "#adm_form_campaign_accounts_webcall_snippet_param_create_and_continue"   ;
		this.snippet_param_cancel          = "#adm_form_campaign_accounts_webcall_snippet_param_cancel"                ;
		this.snippet_param_message         = "#adm_form_campaign_accounts_webcall_snippet_popup_message"               ;
		this.snippet_message               = "#adm_form_campaign_accounts_webcall_snippet_has_changed"                 ;

		this.triggers_list                 = "#adm_form_campaign_accounts_webcall_triggers"                            ;
		this.triggers_new                  = "#adm_form_campaign_accounts_webcall_triggers_new"                        ;
		this.triggers_popup_ctrl           = "#adm_form_campaign_accounts_webcall_triggers_popup"                      ;
		this.triggers_type                 = "#adm_form_campaign_accounts_webcall_triggers_type"                       ;
		this.triggers_regex                = "#adm_form_campaign_accounts_webcall_triggers_regex"                      ;
		this.triggers_regex_test           = "#adm_form_campaign_accounts_webcall_triggers_regex_test"                 ;
		this.triggers_timeout              = "#adm_form_campaign_accounts_webcall_triggers_timeout"                    ;
		this.triggers_open                 = "#adm_form_campaign_accounts_webcall_triggers_open"                       ;
		this.triggers_create               = "#adm_form_campaign_accounts_webcall_triggers_create"                     ;
		this.triggers_create_continue      = "#adm_form_campaign_accounts_webcall_triggers_create_and_continue"        ;
		this.triggers_cancel               = "#adm_form_campaign_accounts_webcall_triggers_cancel"                     ;
		this.triggers_popupmessage         = "#adm_form_campaign_accounts_webcall_triggers_popup_message"              ;

		this.window_type                   = "#adm_form_campaign_accounts_webcall_window_type"                         ;
		this.start_button                  = "#adm_form_campaign_accounts_webcall_start_button"                        ;
		this.button_id                     = "#adm_form_campaign_accounts_webcall_button_id"                           ;

		this.google_panel                  = "#adm_form_campaign_accounts_webcall_google_panel"                        ;
		this.google_enabled                = "#adm_form_campaign_accounts_webcall_google_enabled"                      ;
		this.google_key                    = "#adm_form_campaign_accounts_webcall_google_key"                          ;
		this.google_bySections             = "#adm_form_campaign_accounts_webcall_google_bysection"                    ;

		this.outHours_panel                = "#adm_form_campaign_accounts_webcall_outHours_panel"                      ;
		this.outHours_enabled              = "#adm_form_campaign_accounts_webcall_outHours_enabled"                    ;
		this.outHours_campaign             = "#adm_form_campaign_accounts_webcall_outHours_campaign"                   ;
		this.outHours_account              = "#adm_form_campaign_accounts_webcall_outHours_account"                    ;

		this.on_agent_noanswer_enabled              = "#adm_form_campaign_accounts_call_on_agent_noanswer_enabled"              ;
		this.on_agent_noanswer_timeout_container    = "#adm_form_campaign_accounts_call_on_agent_noanswer_timeout_container"    ;
		this.on_agent_noanswer_timeout              = "#adm_form_campaign_accounts_call_on_agent_noanswer_timeout"              ;
		this.on_agent_noanswer_no_logout_container  = "#adm_form_campaign_accounts_call_on_agent_noanswer_no_logout_container"  ;
		this.on_agent_noanswer_no_logout            = "#adm_form_campaign_accounts_call_on_agent_noanswer_no_logout"            ;

		this.dids_receive_callback       		= "#adm_form_campaign_accounts_call_receive_callback";
		this.dids_receive_callback_panel      	= "#adm_form_campaign_accounts_call_receive_callback_data_panel";
		this.dids_receive_callback_time       	= "#adm_form_campaign_accounts_call_receive_callback_time";
		this.dids_receive_callback_time_period 	= "#adm_form_campaign_accounts_call_receive_callback_time_period";

		this.dids_geographic_prioritization 	= "#adm_form_campaign_accounts_geographic_prioritization_dids";

		this.tweety_webcall_projects = null;
		this.default_project_id = "webcall{9CA752E9-3BA3-4FEB-931D-3E61734151D8}";
		this.current_snippet = null;
		this.parameter_editing = null;

		this.snippet_parameters_types = {
			ID:     { id: "ID"     , description: "<%=_T('Id')%>"     , has_alias: false } ,
			NAME:   { id: "NAME"   , description: "<%=_T('Name')%>"   , has_alias: false } ,
			PHONE:  { id: "PHONE"  , description: "<%=_T('Phone')%>"  , has_alias: false } ,
			EMAIL:  { id: "EMAIL"  , description: "<%=_T('E-mail')%>" , has_alias: false } ,
			CUSTOM: { id: "CUSTOM" , description: "<%=_T('Custom')%>" , has_alias: true  }
		};

		this.trigger_types = {
			time:   { id: "time"     , description: "<%=_T('Time on Page')%>"            }
		};

		this.parameters_popup = new inConcert.PopupWindow({
			ownerId: "adm_form_campaign_accounts_webcall_snippet_popup_parameters", // container id
			eventName: "campaign_accounts_parameters", // evento click personalizado
			callbacks: {
				onClose: function(){
					self.hide_popup_parameters();
				}
			}
		});

		this.triggers_popup = new inConcert.PopupWindow({
			ownerId: "adm_form_campaign_accounts_webcall_triggers_popup", // container id
			eventName: "campaign_accounts_triggers", // evento click personalizado
			callbacks: {
				onClose: function(){
					self.hide_popup_triggers();
				}
			}
		});

		this.adm_account_dids_pool_mng = new inConcert.AdministrationAccountDidsPoolMng({
			owner       : this,
			prefix      : "adm_form_campaign_accounts_call_dids_pool",
			container_id: "adm_form_campaign_accounts_call_dids_pool_panel",
		});

		// Instancia de la clase los TABs
		this.m_call_tabs = null;

		return true;
	}

	inConcert.Utils.inherit( CallAccountPanel, inConcert.adm_form_campaigns_section_accounts_base_panel );

	if ( typeof inConcert.Administration.Campaigns.CallAccountPanel !== "function" ) {
		inConcert.Administration.Campaigns.CallAccountPanel = CallAccountPanel;
	}

	CallAccountPanel.prototype.has_flow_management = function() {return true;};
	
	CallAccountPanel.prototype.initialize = function()
	{
		CallAccountPanel.uber.initialize.call(this);
		this.adm_account_dids_pool_mng.initialize();
		this.__initialize_inc_out_tab();
		this.__initialize_webcall();
		this.initialize_on_agent_noanswer();
		this.fill_outbound_processes();
		if($("#adm_form_campaign_accounts_call_thresholds_actionOnAcdWaitTimeout").val() === "TransferToCampaign") {
			$(this.inc_voicemail_timeout).prop("checked", false);
			$(this.inc_voicemail_timeout).prop("disabled", true);
			$(this.inc_timeout_callback).prop("checked", false);
			$(this.inc_timeout_callback).prop("disabled", true).trigger("change");
		}
		else {
			$(this.inc_voicemail_timeout).prop("disabled", false);
			$(this.inc_timeout_callback).prop("disabled", false).trigger("change");
		}
		if(!inConcert.app.getAgentScreenServiceEnabled())
		{
			$(this.screen_recording_container).hide();
			$(this.screen_recording).prop("checked", false).trigger("change").prop("disabled", true);
		}	
		else
		{
			$(this.screen_recording_container).show();
			if(!this.current_account)
			{
				$(this.screen_recording).prop("checked", false).trigger("change");
			}
		}
		const $receive_callback_time_period = $(this.receive_callback_time_period);
		const rowsCallback = [
			{ id: "Days", description: "<%=_T('Days')%>"  },
			{ id: "Hours"  , description: "<%=_T('Hours')%>" },
			{ id: "Minutes", description: "<%=_T('Minutes')%>"  },
		];
		// la lleno a la lista de AFTER CONVERSATION WORK TIME
		this.parent.fill_combo(
			$receive_callback_time_period,
			false, // is_blank_first_item
			rowsCallback,
			"id", // id
			"description", // description
			false //sorted
		);	
	};

	CallAccountPanel.prototype.initialize_thresholds = function()
	{
		const self = this;
		// build thresholds panel
		CallAccountPanel.uber.initialize_thresholds.call(
			this,
			"CALL",
			{
				parent    : this.parent,
				prefix_id : "adm_form_campaign_accounts_call_thresholds",
				callbacks: {
					on_show_tab: function() {
						$(self.thresholds_info).hide();
					},
					on_hide_all_tabs: function() {
						$(self.thresholds_info).show();
					}
				}
			}
		);
	};

	CallAccountPanel.prototype.__initialize_inc_out_tab = function()
	{
		let tab_config = {};

		tab_config[INC_TAB_ID] = {
			id              : INC_TAB_ID,
			name            : "<%=_T('Incoming')%>",
			tab_container_id: "adm_form_campaign_accounts_call_incoming_tab",
			selected        : true,
			on_show         : $.noop
		};
		tab_config[OUT_TAB_ID] =  {
			id              : OUT_TAB_ID,
			name            : "<%=_T('Outgoing')%>",
			tab_container_id: "adm_form_campaign_accounts_call_outgoing_tab",
			on_show         : $.noop
		};

		this.m_call_tabs = new inConcert.conf_form_tab({
			parent         : this,
			frm            : this.parent.frm,
			container_id   : "adm_form_campaign_accounts_call_inc_out_tabs_panels",
			must_initialize: true,
			tabs_list      : tab_config
		});

		this.m_call_tabs.show_tabs_container();
	};

	CallAccountPanel.prototype.initialize_contact_mng = function()
	{
		// build contact management panel
		CallAccountPanel.uber.initialize_contact_mng.call(
			this,
			{
				type         : "CALL"                                             ,
				parent       : this                                               ,
				auto_add_type: "BOTH"                                             , // incoming y outgoing
				container_id : "adm_form_campaign_accounts_call_contact_mng_panel",
				prefix_id    : "adm_form_campaign_accounts_call_contact_mng"
			}
		);
	};

	CallAccountPanel.prototype.initialize_flows_mng = function()
	{
		// build flows designer management panel
		CallAccountPanel.uber.initialize_flows_mng.call(
			this,
			{
				type         : "CALL"                                                    ,
				parent       : this                                                      ,
				container_id : "adm_form_campaign_accounts_call_flows_designer_mng_panel",
				prefix_id    : "adm_form_campaign_accounts_call_flows_designer_mng"
			}
		);
	};

	CallAccountPanel.prototype.initialize_ticket_emitter = function()
	{
		CallAccountPanel.uber.initialize_ticket_emitter.call(
			this,
			{
				type         : "CALL",
				parent       : this,
				container_id : "adm_form_campaign_accounts_call_tickets_mng_panel",
				prefix_id    : "adm_form_campaign_accounts_call_tickets_mng"
			}
		);
	};

	CallAccountPanel.prototype.initialize_tabs = function()
	{
		// build tabs
		CallAccountPanel.uber.initialize_tabs.call(
			this,
			{
				parent       : this                              ,
				frm          : this.parent.frm                   ,
				container_id : "adm_form_campaign_accounts_tabs" ,
				tabs_list    : {
					basic : {
						id               : "basic",
						name             : "<%=_T('Call Config')%>",
						tab_container_id : "adm_form_campaign_accounts_call_panel_tab_basic",
						selected         : true
					},
					messages : {
						id               : "messages",
						name             : "<%=_T('Messages')%>",
						tab_container_id : "adm_form_campaign_accounts_call_panel_tab_messages"
					}
				}
			}
		);
	};

	CallAccountPanel.prototype.initialize_skills = function()
	{
		CallAccountPanel.uber.initialize_skills.call(
			this,
			{
				container_id : "adm_form_campaign_accounts_call_skills_config",
				parent_frm   : this.parent,
				parent_type  : "FORM-SECTION"
			}
		);
	};

	CallAccountPanel.prototype.initialize_attention_levels = function()
	{
		CallAccountPanel.uber.initialize_attention_levels.call(
			this,
			{
				container_id : "adm_form_campaign_accounts_call_attention_levels_config",
				parent_frm   : this.parent,
				parent_type  : "FORM-SECTION",
				proxy_type   : "CALL"
			}
		);
	};
	
	CallAccountPanel.prototype.__initialize_webcall = function()
	{
		this.current_snippet = null;
		this.generate_token();
		this.fill_parameters_types();
		this.fill_triggers_types();
		this.fill_combo_tweety_webcalls();
		this.fill_combo_webContact_campaigns();
		$(this.outHours_campaign).change();
		this.disable_tweety_calls();
		$(this.google_key).prop("disabled", true);
		$(this.outHours_enabled)
			.prop("checked", false)
			.change();
		$(this.webcall_enabled)
			.prop("checked", false)
			.change();
	};
	
	CallAccountPanel.prototype.initialize_on_agent_noanswer = function()
	{
		$(this.on_agent_noanswer_enabled)
			.prop("checked", false)
			.change();
	};

	CallAccountPanel.prototype.load_webcontact_campaigns = async function()
	{
		try {
			this.m_campaigns = await inConcert.Utils.asyncCallObjectMethod(
				inConcert.app,
				"GetWebcontactCampaignAccounts"
			);
		} catch(e) {
			this.parent.frm.show_status_message(
				"<%=_T('Error retrieving campaign accounts for out of hours.')%>",
				"Error",
				false
			);
		}
	};

	CallAccountPanel.prototype.load_outbound_processes = async function()
	{
		try {
			const processes =
				await inConcert.app.getOutboundEngineAPI().asyncCall("processesList");
			this.m_oeProcesses = processes.map((processId) => ({
				id: processId,
				name: inConcert.Utils.getIdWithoutVCC(processId)
			}));
		} catch(e) {
			this.parent.frm.show_status_message(
				"<%=_T('Error retrieving outbound processes for out of hours.')%>",
				"Error",
				false
			);
		}
	};

	CallAccountPanel.prototype.show = async function(account)
	{
		await this.load_webcontact_campaigns();
		await this.load_outbound_processes();
		CallAccountPanel.uber.show.call(this, account);
	};

	CallAccountPanel.prototype.disable_tweety_calls = function()
	{
		var disabled, is_required;
		if ( this.parent.is_readonly() || !this.tweety_webcall_projects || Object.keys( this.tweety_webcall_projects ).length <= 1 ) {
		/* si solo tiene un elemento en el cbo, es el default y el combo tiene que quedar readonly*/
			disabled = true;
			is_required = false;
		}
		else {
			disabled = false;
			is_required = true;
		}
		this.parent.frm.readonly_control( $( this.tweety_app_name ), disabled, is_required );
	};

	CallAccountPanel.prototype.set_tweety_webcall_projects = function( projects )
	{
		var self = this;
		if ( projects ) {
			this.tweety_webcall_projects = {};
			this.tweety_webcall_projects[ this.default_project_id ] = {
				id   : this.default_project_id,
				name : "<%=_T('Default')%>"
			};
			$.each( projects, function( _, project )
			{
				self.tweety_webcall_projects[project.id] = project;
			});
		}
		else {
			this.tweety_webcall_projects = null;
		}
	};

	CallAccountPanel.prototype.fill_parameters_types = function()
	{
		var $combo = $( this.snippet_param_type );
		var is_blank_first_item = true;
		var attr_id = "id";
		var attr_name = "description";
		var list = this.snippet_parameters_types;
		this.parent.frm.fill_combo( $combo, is_blank_first_item, list, attr_id, attr_name );
	};

	CallAccountPanel.prototype.fill_triggers_types = function()
	{
		var $combo = $( this.triggers_type );
		var is_blank_first_item = false;
		var attr_id = "id";
		var attr_name = "description";
		var list = this.trigger_types;
		this.parent.frm.fill_combo( $combo, is_blank_first_item, list, attr_id, attr_name );
	};

	CallAccountPanel.prototype.fill_combo_tweety_webcalls = function()
	{
		var $combo = $( this.tweety_app_name );
		var is_blank_first_item = false;
		var attr_id = "id";
		var attr_name = "name";
		var sorted = true;
		var list = this.tweety_webcall_projects || {};

		this.parent.frm.fill_combo( $combo, is_blank_first_item, list, attr_id, attr_name, sorted );
	};

	CallAccountPanel.prototype.fill_combo_webContact_campaigns = function()
	{
		var $combo = $( this.outHours_campaign );
		var is_blank_first_item = false;
		var attr_id = true;
		var attr_name = "Name";
		var sorted = true;
		var list = this.m_campaigns || {};

		this.parent.frm.fill_combo( $combo, is_blank_first_item, list, attr_id, attr_name, sorted );
	};

	CallAccountPanel.prototype.fill_combo_webContact_accounts = function()
	{
		var $combo = $( this.outHours_account );
		var is_blank_first_item = false;
		var attr_id = "Token";
		var attr_name = "Name";
		var sorted = true;
		
		var campaign = $( this.outHours_campaign ).val();
		var list = this.m_campaigns && this.m_campaigns[campaign] && this.m_campaigns[campaign].accounts || {};

		this.parent.frm.fill_combo( $combo, is_blank_first_item, list, attr_id, attr_name, sorted );
	};

	CallAccountPanel.prototype.fill_outbound_processes = function()
	{
		[
			this.inc_virtualhold_callback_process,
			this.inc_timeout_callback_process
		].forEach((field) => 
			this.parent.frm.fill_combo(
				$(field),
				true,
				this.m_oeProcesses,
				"id",
				"name",
				true
			)
		);
	};

	CallAccountPanel.prototype.is_enable_menu_option = function( callback )
	{
		// 1 - valida si ya existe alguna cuenta de telefonia configurada.
		var count_accounts_call = 0;
		var section = this.parent;
		var accounts = section.frm.campaign.accounts;
		var response = { enabled: true };

		$.each( accounts || {}, function( _, account ) {
			if ( section.is_account_type( account, "CALL" ) ) {
				count_accounts_call++;
				return false; // BREAK
			}
		});
		if (MAX_ALLOWED_PHONE_ACCOUNTS !== -1 && count_accounts_call > MAX_ALLOWED_PHONE_ACCOUNTS) {
			// si ya existe alguna se va retornado FALSE, para que NO muestre la opcion en el menu
			response.enabled = false;
			response.message = FORMAT("<%=_T('A maximum of {0} phone accounts is allowed.')%>", MAX_ALLOWED_PHONE_ACCOUNTS);
			callback( response );
			return;
		}

		// 2 - valida si existen paquetes de telefonia configurados en "VCCPackages"
		const from_cache = true;
		inConcert.app.loadPackages("CALL",
			from_cache,
			function( success, packages ) {
				if ( !success ) {
					// si fallo el request se va retornado FALSE, para que NO muestre la opcion en el menu
					response.enabled = false;
					response.message ="<%=_T('Error retrieving packages.')%>";
					callback( response );
				}
				var count_packages = Object.keys( packages || {} ).length;
				if ( count_packages > 0 ) {
					// si existen packages se va retornado TRUE, para que SI muestre la opcion en el menu
					callback( response );
				}
				else {
					// si no existen packages se va retornado FALSE, para que NO muestre la opcion en el menu
					response.enabled = false;
					response.message ="<%=_T('There are no provisioned telephony packages.')%>";
					callback( response );
				}
			});
	};

	CallAccountPanel.prototype.readonly = function()
	{
		CallAccountPanel.uber.readonly.call( this );

		// disable combo tweety projects (web call)
		this.parent.frm.readonly_control( $( this.tweety_app_name ), true /*disable*/ );

		// disable actions popup parameters (new, delete, edit)
		this.disable_actions_snippet_parameters(true);
		this.disable_actions_trigger(true);
	};

	CallAccountPanel.prototype.generate_token = function()
	{
		this.current_token = inConcert.Utils.generateGuid();
		if (!this.is_new()) {
		// esta editando una account existente
			var acc = this.current_account;
			this.current_token = (acc.webcallConfig && acc.webcallConfig.Token) ? 
				acc.webcallConfig.Token : this.current_token;
		}
	};

	CallAccountPanel.prototype.generate_snippet = function()
	{		
		// get WebChat url but strip the protocol
		var webchat_url = inConcert.app.getWebchatUrl().match("^http[s]?://(.+)")[1];
		var token = this.current_token;
		
		/*
		*	Sample:
		<script type='text/javascript'>
			(function() {
				var proto  = document.location.protocol || 'http:';
				var node   = document.createElement('script');
				node.type  = 'text/javascript';
				node.async = true;
				node.src   = proto +  '//webchat-i6.inconcert.cc/v3/click_to_chat?token=710DB0B21AD6F20F16531D5821811601';
				var s = document.getElementsByTagName('script')[0];
				s.parentNode.insertBefore(node, s);
			})();
		</script>
		*/
		var new_url = FORMAT(
			"{0}/click_to_chat?token={1}",
			webchat_url              ,          // {0}
			encodeURIComponent(token)           // {1}
		);

		var snippet = "".concat(
			"<script type='text/javascript'>\n",
			"  (function() {\n",
			"    var proto  = document.location.protocol || 'http:';\n",
			"    var node   = document.createElement('script');\n",
			"    node.type  = 'text/javascript';\n",
			"    node.async = true;\n",
			"    node.src   = proto +  '//", new_url, "';\n",
			"    var s = document.getElementsByTagName('script')[0];\n",
			"    s.parentNode.insertBefore(node, s);\n",
			"  })();\n" +
			"</script>\n");

		$(this.snippet_code).val(snippet);

		return snippet;
	};

	CallAccountPanel.prototype.show_tracking = function()
	{
		var snippet = "".concat(
			"<script type='text/javascript'>\n",
			"  (function() {\n",
			"    var proto  = document.location.protocol || 'http:';\n",
			"    var trme   = document.createElement('script');\n",
			"    trme.type  = 'text/javascript';\n",
			"    trme.async = true;\n",
			"    trme.src   = proto +  '//", inConcert.app.getTrackmeServerAddress(), "/inconcert/apps/trackme/js/tm.js';\n",
			"    var s = document.getElementsByTagName('script')[0];\n",
			"    s.parentNode.insertBefore(trme, s);\n",
			"  })();\n" +
			"</script>\n");

		$(this.tracking_code).val(snippet);

		var $tracking_disclaimer = $(this.tracking_disclaimer);
		$tracking_disclaimer.parent().parent()
			// .removeClass("highRow")
			// .addClass("highRowWithMessage");
			.removeClass("d-none");
		$tracking_disclaimer.show();
	};

	CallAccountPanel.prototype.hide_tracking = function()
	{
		$(this.tracking_code)
			.val("");
		var $tracking_disclaimer = $(this.tracking_disclaimer);
		$tracking_disclaimer.parent().parent()
			// .removeClass("highRowWithMessage")
			// .addClass("highRow");
			.addClass("d-none");
		$tracking_disclaimer.hide();
	};

	CallAccountPanel.prototype.has_changed_snippet = function()
	{
		let has_configured_webcall = $(this.webcall_enabled).prop("checked");
		if (!has_configured_webcall) {
			return false;
		}
		let actual_snippet = $(this.snippet_code).val();
		return this.is_new() || this.current_snippet !== actual_snippet;
	};

	CallAccountPanel.prototype.show_message_after_save = function(_ /*account*/, callback = $.noop)
	{
		if (this.has_changed_snippet()) {
			var actual_snippet = $(this.snippet_code).val();
			var $snippet_message = $(this.snippet_message);
			$snippet_message.find("textarea").text(actual_snippet);
			$snippet_message
				.off("click", "button")
				.on("click", "button", function() {
					callback();
					$snippet_message.hide();
				});
			$snippet_message.show();
		}
		else {
			callback();
		}
	};

	CallAccountPanel.prototype.edit = function( account )
	{
		const self = this;
		
		CallAccountPanel.uber.edit.call( this, account );
		if ( !this.current_account ) {
			return;
		}
		this.__clean_up_ctrls();

		const acc = this.current_account;
		// common info
		$( this.name ).val(acc.name || "");
		this.set_packages(acc.packages);

		// optimizeNodeDistribution
		$(this.optimizeNodeDistribution).prop("checked", 
			acc.optimizeNodeDistribution && acc.optimizeNodeDistribution.to_boolean());

		// callback is allowed
		const $callback = $(this.callback);
		const $retain_abandoned = $(this.callback_retain_abandoned);
		const $retain_appointment = $(this.callback_retain_appointment);

		if (acc.CallbackIsAllowed && acc.CallbackIsAllowed.to_boolean()) {
			$callback.prop("checked", true).trigger("change");
			$retain_abandoned.val(acc.LifeTimeAbandonedCalls);
			$retain_appointment.val(acc.LifeTimeAppointmentCalls);
		}
		else {
			$callback.prop("checked", false).trigger("change");
			$retain_abandoned.val("");
			$retain_appointment.val("");
		}

		// screen recording
		if(inConcert.app.getAgentScreenServiceEnabled())
		{
			var screen_recording_percentage = parseInt(acc.ScreenRecording, 10);
			if ( screen_recording_percentage > 0 ) {
				$(this.screen_recording).prop("checked", true).trigger("change");
				$(this.screen_recording_percentage).val(screen_recording_percentage.toString());
			}
			else {
				$(this.screen_recording).prop("checked", false).trigger("change");
			}
		}

		// after conversation work
		var after_conversation_work = parseFloat(acc.AfterInteractionWork, 10);
		if ( after_conversation_work > 0 ) {

			var limit_type;
			if ( after_conversation_work === UNLIMITED_VALUE_AFTER_CONVERSATION_WORK ) {
				limit_type = "Unlimited";
				after_conversation_work = "";
			}
			else {
				limit_type = "TimeLimited";
				after_conversation_work = SEC(after_conversation_work);
			}

			$(this.uses_after_conversation_work).prop("checked", true).trigger("change");
			$(this.after_conversation_work_time).val(limit_type).trigger("change");
			$(this.after_conversation_work_time_limit).val(after_conversation_work);
		}
		else {
			$(this.uses_after_conversation_work).prop("checked", false).trigger("change");
		}

		// configuracion INCOMING ---------------------------------------
		const incoming_config = acc.incomingConfig;
		if (incoming_config && incoming_config.enabled) {
			$(this.inc_enabled_config).prop("checked", true).trigger("change");
			// redial
			const allowed_redial = BOOL(incoming_config.ContactCenter.CheckRedial);
			if (allowed_redial) {
				$(this.inc_redial).prop("checked", true);
			}
			// auto answer
			if (incoming_config.AutoAnswerTime !== undefined) {
				$(this.inc_auto_answer).prop("checked", true).trigger("change");
				$(this.inc_auto_answer_time).val(SEC(incoming_config.AutoAnswerTime));
			}

			// voicemail
			$(this.inc_voicemail_lifetime).val(incoming_config.ContactCenter.LifeTimeVoicemail || "");
			if (incoming_config.ContactCenter.VoicemailOnTimeout) {
				$(this.inc_voicemail_timeout).prop("checked", true).trigger("change");
			} else if (incoming_config.ContactCenter.DialerCallbackOnTimeout) {
				$(this.inc_timeout_callback).prop("checked", true).trigger("change");
				$(this.inc_timeout_callback_process).val(
					incoming_config.ContactCenter.DialerCallbackOnTimeoutProcess);
					$(this.inc_timeout_callback_batch).val(
						incoming_config.ContactCenter.DialerCallbackOnTimeoutBatch);
			}
			if (incoming_config.ContactCenter.LeaveVoicemailAtOutOfHours) {
				$(this.inc_voicemail_of_hours).prop("checked", true).trigger("change");
			}
			if (incoming_config.ContactCenter.VoicemailOnWait) {
				$(this.inc_voicemail_waiting).prop("checked", true).trigger("change");
				$(this.inc_voicemail_waiting_digit).val(incoming_config.ContactCenter.VoicemailOnWaitDigit || "ANY");
			}
		}

		// configuracion OUTGOING ---------------------------------------
		const outgoing_config = acc.outgoingConfig;
		if (outgoing_config && outgoing_config.enabled) {
			$(this.out_enabled_config).prop("checked", true).trigger("change");
			// outboundprefix
			$(this.out_prefix).val(outgoing_config.outboundPrefix);
			// outgoing contact center
			if (BOOL(outgoing_config.ContactCenter.AllowManualCalls)) {
				$(this.out_manual_calls).prop("checked", true);
			}
			if (BOOL(outgoing_config.ContactCenter.AllowInvalidNumbers)) {
				$(this.out_invalid_numbers).prop("checked", true);
			}
			// outgoing blacklists
			//$(this.out_prefix).val(outgoing_config.outboundPrefix);
		}

		// incoming dependiente de outgoing
		if (incoming_config && incoming_config.enabled) {
			if (incoming_config.ContactCenter.VirtualholdOnWait) {
				$(this.inc_virtualhold_waiting).prop("checked", true).trigger("change");
				$(this.inc_virtualhold_waiting_digit).val(
					incoming_config.ContactCenter.VirtualholdOnWaitDigit || "ANY");
				$(this.inc_virtualhold_waiting_no_answer).val(
					incoming_config.ContactCenter.VirtualholdOnWaitNoAnswer || "CANCELED");
				$(this.inc_virtualhold_callback_process).val(
					incoming_config.ContactCenter.VirtualholdCallbackProcess || "");
				$(this.inc_virtualhold_callback_batch).val(
					incoming_config.ContactCenter.VirtualholdCallbackBatch || "");
			}
		}

		// configuracion webcall ---------------------------------------
		const webcall = acc.webcallConfig;
		if (webcall && webcall.enabled) {
			$(this.webcall_enabled).prop("checked", true).trigger("change");
			$(this.webcall_package).val(webcall.Package);
			$( this.tracking ).prop( "checked", webcall.Tracking === "1" ).change();
			this.set_tweety_app_name( webcall.TweetyAppName );
			
			$(this.snippet_param_list).find("li[param_data]").remove();
			if (webcall.snippet_parameters) {
				$.each(webcall.snippet_parameters, function(_, parameter)
				{
					self.add_html_snippet_parameter(parameter.controlId, parameter.type, parameter.alias, parameter.hidden);
				});
				this.disable_actions_snippet_parameters( false );
			}

			$(this.triggers_list).find("li[param_data]").remove();
			if (webcall.triggers) {
				$.each(webcall.triggers, function(_, trigger)
				{
					self.add_html_trigger(trigger);
				});
				this.disable_actions_trigger( false );
			}

			$(this.window_type).val(webcall.window_type || "embedded");
			$(this.start_button).val(webcall.start_button || "app").trigger("change");
			$(this.button_id).val(webcall.containerId || "");

			$(this.google_enabled)
				.prop("checked", webcall.google_enabled === "true" || webcall.google_enabled === true)
				.trigger("change");
			$(this.google_key).val(webcall.google_key || "");
			$(this.google_bySections)
				.prop("checked", webcall.google_bySections === "true" || webcall.google_bySections === true);

			$(this.outHours_enabled)
				.prop("checked", webcall.outHours_enabled === "true" || webcall.outHours_enabled === true)
				.trigger("change");
			$(this.outHours_campaign)
				.val(webcall.outHours_campaign || "")
				.trigger("change");
			$(this.outHours_account).val(webcall.outHours_account || "");
		}
		this.__enable_disable_incoming_outgoing_config();

		// configuracion on agent no answer ---------------------------------------
		const agent_noanswer = acc.agentNoAnswerConfig;
		if (agent_noanswer && agent_noanswer.enabled) {
			$(this.on_agent_noanswer_enabled).prop("checked", true).trigger("change");
			$(this.on_agent_noanswer_timeout).val(agent_noanswer.timeout);
			$(this.on_agent_noanswer_no_logout).prop("checked", agent_noanswer.noLogout);
		}

		$(this.allowAgentListenContactOnHold).prop("checked", parseInt(acc.allowAgentListenContactOnHold) === 1);

		this.set_dids_pool(acc);
	};

	CallAccountPanel.prototype.get_account_name = function()
	{
		return this.current_account.name;
	};

	CallAccountPanel.prototype.set_tweety_app_name = function( project_id )
	{
		project_id = project_id || this.default_project_id;
		$( this.tweety_app_name ).val( project_id );
		this.show_tweety_info( project_id );
	};

	CallAccountPanel.prototype.empty_controls = function()
	{
		this.empty_dids_pool();
		CallAccountPanel.uber.empty_controls.call( this );
		this.__clean_up_ctrls();
	};

	CallAccountPanel.prototype.__clean_up_ctrls = function()
	{
		// common info
		$( this.name ).val( "" );
		$(this.optimizeNodeDistribution).prop("checked", true);
		// after conversation
		$(this.uses_after_conversation_work).prop("checked", true).trigger("change");
		$(this.after_conversation_work_time).val("Unlimited").trigger("change");
		$(this.after_conversation_work_time_limit).val("");
		// packages
		this.unselect_packages();
		$(this.callback).prop("checked", true).trigger("change");
		// incoming
		$(this.inc_enabled_config).prop("checked", false).trigger("change");
		$(this.inc_redial).prop("checked", false);
		this.parent.frm.related_empty_disabled($(this.inc_auto_answer));
		// voicemail
		$(this.inc_voicemail_lifetime).val("");
		$(this.inc_voicemail_waiting).prop("checked", false).trigger("change");
		$(this.inc_virtualhold_waiting).prop("checked", false).trigger("change");
		// outgoing
		$(this.out_enabled_config).prop("checked", false).trigger("change");
		$(this.out_prefix).val("...");
		// outgoing contact center
		$(this.out_manual_calls).prop("checked", false);
		$(this.out_invalid_numbers).prop("checked", false);
		// webcall
		$(this.webcall_package).html("");
		$(this.webcall_enabled).prop("checked", false).trigger("change");
		$( this.button_id            ).val( "" );
		this.set_tweety_app_name( /* default */ );
		$( this.snippet_param_list   ).find("li[param_data]").remove();
		$( this.triggers_list        ).find("li[param_data]").remove();
		// outgoing blacklists
		//$(this.out_prefix).val(outgoing_config.outboundPrefix);
		$(this.on_agent_noanswer_enabled).prop("checked", false).trigger("change");
		//receiva callback
		// after conversation
		$(this.receive_callback_time_period).val("Days").trigger("change");
		$(this.receive_callback_time_period).val("Hours").trigger("change");
		$(this.receive_callback_time_period).val("Minutes").trigger("change");
		$(this.receive_callback_time).val("");
		$(this.inc_virtualhold_callback_batch).val("");
		$(this.inc_timeout_callback_batch).val("");
	};

	CallAccountPanel.prototype.disable_actions_snippet_parameters = function(disable)
	{
		disable = disable === undefined ? true : disable;

		if (this.parent.is_readonly()) {
			disable = true;
		}

		$(this.snippet_param_new).prop("disabled", disable);
		var $snippet_param_data = $(this.snippet_param_list).find("li[param_data]");
		// boton edit de la lista de parametros
		$snippet_param_data.find("button[action_edit]").prop("disabled", disable);
		// boton delete de la lista de parametros
		$snippet_param_data.find("button[action_del]").prop("disabled", disable);
	};

	CallAccountPanel.prototype.disable_actions_trigger = function(disable)
	{
		disable = disable === undefined ? true : disable;

		if (this.parent.is_readonly()) {
			disable = true;
		}

		$(this.triggers_new).prop("disabled", disable);
		var $trigger_param_data = $(this.triggers_list).find("li[param_data]");
		// boton edit de la lista de parametros
		$trigger_param_data.find("button[action_edit]").prop("disabled", disable);
		// boton delete de la lista de parametros
		$trigger_param_data.find("button[action_del]").prop("disabled", disable);
	};

	CallAccountPanel.prototype.show_popup_parameters = function()
	{
		$(this.snippet_param_message).hide();
		this.parameters_popup.show();
		// disable actions popup parameters (new, delete, edit)
		this.disable_actions_snippet_parameters(true);

		var control_id = "", type_id = "", alias = "", hidden = false;
		if (!this.parameter_editing) {
		// si presione el boton para crear uno nuevo
			$(this.snippet_param_create).val("<%=_T('Create')%>");
			$(this.snippet_param_create_continue).show();
		}
		else {
		// si presione el boton para editar
			$(this.snippet_param_create).val("<%=_T('Update')%>");
			$(this.snippet_param_create_continue).hide();
			control_id = this.parameter_editing.find("label[param_control_id='true']").text();
			type_id = this.parameter_editing.find("label[param_type='true']").attr("type_id");
			var type = this.snippet_parameters_types[type_id];
			if (type) {
				var $alias = this.parameter_editing.find("label[param_alias='true']");
				alias = $alias.text();
			}
			hidden = this.parameter_editing.attr("is_hidden") === "true";
		}

		$(this.snippet_param_type).val(type_id).change();
		$(this.snippet_param_alias).val(alias);
		$(this.snippet_param_hidden).prop("checked", hidden);
		$(this.snippet_param_control_id).focus().val(control_id);
	};

	CallAccountPanel.prototype.show_popup_triggers = function()
	{
		$(this.triggers_popupmessage).hide();
		this.triggers_popup.show();
		// disable actions popup parameters (new, delete, edit)
		this.disable_actions_trigger(true);

		var type = "", regex = ".*", timeout = "", open = "CHAT_WINDOW";
		if ( !this.trigger_editing ) {
		// si presione el boton para crear uno nuevo
			$(this.triggers_create).val("<%=_T('Create')%>");
			$(this.triggers_create_continue).show();
		}
		else {
		// si presione el boton para editar
			$(this.triggers_create).val("<%=_T('Update')%>");
			$(this.triggers_create_continue).hide();
			var trigger = this.trigger_editing.data("trigger");
				type = trigger.type;
				regex = trigger.regex;
				timeout = trigger.timeout;
				open = trigger.open;
		}

		$(this.triggers_regex_test)
			.val("")
			.parent()
			.removeClass("regex_matches")
			.removeClass("regex_notmatches");

		$(this.triggers_type).val(type).change();
		$(this.triggers_timeout).val(timeout);
		$(this.triggers_regex).focus().val(regex);
		$(this.triggers_open).val(open);
	};

	CallAccountPanel.prototype.hide_popup_parameters = function()
	{
		$(this.snippet_param_popup).hide();
		// enable actions popup parameters (new, delete, edit)
		this.disable_actions_snippet_parameters(false);
	};

	CallAccountPanel.prototype.hide_popup_triggers = function()
	{
		$(this.triggers_popup_ctrl).hide();
		// enable actions popup parameters (new, delete, edit)
		this.disable_actions_trigger(false);
	};

	CallAccountPanel.prototype.add_html_snippet_parameter = function(control_id, type_id, alias, hidden)
	{
		if (typeof control_id !== "string" || typeof type_id !== "string") {
			return;
		}
		var type = this.snippet_parameters_types[type_id];
		var unique_id = control_id.trim().toLowerCase();
		alias = alias || "";

		$(this.snippet_param_list).append(
			"<li param_data='true' class='formListItem' is_hidden='" + (hidden? "true" : "false") + "' >" +
				"<label param_control_id='true' class='formItemText nameColumn' unique_id='" + unique_id + "'>" + control_id  + "</label>" +
				"<label param_type='true' class='formItemText valueColumn' type_id='" + type.id + "'>" + type.description + "</label>" +
				"<label param_alias='true' class='formItemText valueColumn'>" + alias + "</label>" +
				"<button action_edit='true' class='buttonColorGray gridActionButton edit' disabled='true'><i class='buttons-icons-edit'></i>" + "<%=_T('Edit')%>" + "</button>" +
				"<button action_del='true' class='buttonColorGray gridActionButton delete last' disabled='true'><i class='buttons-icons-delete'></i>" + "<%=_T('Delete')%>" + "</button>" +
			"</li>");
	};

	CallAccountPanel.prototype.make_trigger_action = function(trigger)
	{
		var type = this.trigger_types[trigger.type];
		var action = "";
		if (type.id === "time" ) {
			action = FORMAT("<%=_T('After {0} seconds on page')%>", trigger.timeout);
		}
		return action;
	};

	CallAccountPanel.prototype.add_html_trigger = function(trigger)
	{
		var type = this.trigger_types[trigger.type];
		var action = this.make_trigger_action(trigger);

		$(this.triggers_list)
			.append(
				"<li param_data='true' class='formListItem' >" +
					"<label class='formItemText nameColumn'  trigger_type >" + type.description  + "</label>" +
					"<label class='formItemText valueColumn' trigger_regex >" + trigger.regex + "</label>" +
					"<label class='formItemText valueColumn' trigger_action >" + action + "</label>" +
					"<button action_edit='true' class='buttonColorGray gridActionButton edit' disabled='true'><i class='buttons-icons-edit'></i>" + "<%=_T('Edit')%>" + "</button>" +
					"<button action_del='true' class='buttonColorGray gridActionButton delete last' disabled='true'><i class='buttons-icons-delete'></i>" + "<%=_T('Delete')%>" + "</button>" +
				"</li>"
			)
			.children("li[param_data]")
			.last()
			.data("trigger", trigger);
	};

	CallAccountPanel.prototype.validate_snippet_parameter = function(control_id, type, alias)
	{
		var self = this;

		var show_error = function(message, $control)
		{
			$(self.snippet_param_message).text(message).show();
			if ($control) {
				$control.focus();
			}
		};

		var message;
		if (control_id.trim().length === 0) {
			// valida que el control_id tenga al menos un caracter
			message = "<%=_T('Parameter control id is required')%>";
			show_error(message, $(this.snippet_param_control_id));
			return false;
		}

		if (!type) {
			// valida que hayan seleccionado un tipo en el combo
			message = "<%=_T('Parameter type is required')%>";
			show_error(message, $(this.snippet_param_alias));
			return false;
		}

		if (type.has_alias) {
			if (alias.trim().length === 0) {
				// valida que el alias tenga al menos un caracter
				message = "<%=_T('Parameter display name is required')%>";
				show_error(message, $(this.snippet_param_alias));
				return false;
			}
		}

		var unique_id = control_id.trim().toLowerCase();
		var already_exist = function()
		{
			var current_param = $(self.snippet_param_list).find("li[param_data] label[param_control_id='true'][unique_id='" + unique_id + "']");
			var len = current_param.length;
			if (len > 0) {
				message = FORMAT("<%=_T('Already exist parameter control id {0}.')%>", control_id);
				show_error(message, $(self.snippet_param_control_id));
				return true;
			}
			return false;
		};

		if (!this.parameter_editing) {
			// si es un paramerto nuevo valida que el mismo ya no exista en la lista
			if (already_exist()) {
				return false;
			}
		}
		else {
			var actual_name = this.parameter_editing.find("[param_control_id='true']").text();
			actual_name = actual_name.trim().toLowerCase();
			if (actual_name !== unique_id) {
			// si es name del paramerto ha cambiado valido que el nuevo nombre ya no exista en la lista
				if (already_exist()) {
					return false;
				}
			}
		}

		// validation successfully
		return true;
	};

	CallAccountPanel.prototype.validate_trigger = function(trigger)
	{
		var self = this;

		var show_error = function(message, $control)
		{
			$(self.triggers_popupmessage).text(message).show();
			if ($control) {
				$control.focus();
			}
		};

		var message;
		var result = this.parent.valid(trigger.timeout, "required");
		if ( !result.success ) {
			message = "<%=_T('Trigger regex is required')%>";
			show_error(message, $(this.triggers_regex));
			return false;
		}

		if ( trigger.type === "time" ) {
			result = this.parent.valid(trigger.timeout, "number");
			if ( !result.success ) {
				message = "<%=_T('Trigger time on page is not a number')%>";
				show_error(message, $(this.triggers_timeout));
				return;
			}
			trigger.timeout = parseInt(trigger.timeout, 10);
		}

		// validation successfully
		return true;
	};

	CallAccountPanel.prototype.add_or_update_snippet_parameter = function(has_continue)
	{
		$(this.snippet_param_message).hide();
		var control_id = $(this.snippet_param_control_id).val();
		var type_id = $(this.snippet_param_type).val();
		var type = this.snippet_parameters_types[type_id];
		var	alias = $(this.snippet_param_alias).val();
		var hidden = $(this.snippet_param_hidden).prop("checked");

		// validate snippet parameters
		if (!this.validate_snippet_parameter(control_id, type, alias)) {
			return;
		}

		if (!this.parameter_editing) {
		// add new parameter
			this.add_html_snippet_parameter(control_id, type.id, alias, hidden);
		}
		else {
		// update actual parameter
			// control id
			var $parameter_control_id = this.parameter_editing.find("[param_control_id='true']");
			$parameter_control_id.attr("unique_id", control_id);
			$parameter_control_id.text(control_id);
			// combo type
			var $parameter_type = $(this.parameter_editing.find("[param_type='true']"));
			$parameter_type.attr("type_id", type.id);
			$parameter_type.text(type.description);
			// alias
			var $parameter_alias = $(this.parameter_editing.find("[param_alias='true']"));
			$parameter_alias.text(alias);
			//hidden
			this.parameter_editing.attr("is_hidden", hidden? "true" : "false");
		}

		$(this.snippet_param_type).val("").change();
		$(this.snippet_param_alias).val("");
		$(this.snippet_param_control_id).val("");
		$(this.snippet_param_hidden).prop("checked", false);

		if (!has_continue) {
			this.hide_popup_parameters();
			return;
		}
		$(this.snippet_param_control_id).focus();
	};

	CallAccountPanel.prototype.add_or_update_trigger = function(has_continue)
	{
		$(this.triggers_popupmessage).hide();

		var trigger = {
			type : $(this.triggers_type).val(),
			regex: $(this.triggers_regex).val(),
			open: $(this.triggers_open).val()
		};

		if (trigger.type === "time") {
			trigger.timeout = $(this.triggers_timeout).val();
		}

		// validate snippet parameters
		if (!this.validate_trigger(trigger)) {
			return;
		}

		if (!this.trigger_editing) {
		// add new parameter
			this.add_html_trigger(trigger);
		}
		else {
			// update actual parameter
			var type = this.trigger_types[trigger.type];
			var action = this.make_trigger_action(trigger);

			this.trigger_editing.data("trigger", trigger);
			this.trigger_editing.find("[trigger_type]").text(type.description);
			this.trigger_editing.find("[trigger_regex]").text(trigger.regex);
			this.trigger_editing.find("[trigger_action]").text(action);
		}

		$(this.triggers_type)
			.val($(this.triggers_type + " option:first").val())
			.change();
		$(this.triggers_regex).val("");
		$(this.triggers_timeout).val("");

		this.generate_snippet();

		if (!has_continue) {
			this.hide_popup_triggers();
			return;
		}
		$(this.triggers_type).focus();
	};

	CallAccountPanel.prototype.set_events_popup_parameters = function()
	{
		var self = this;

		// boton new que abre el popup para poder agregar un nuevo parametro
		$(this.snippet_param_new)
			.off("click")
			.on("click", function() {
				self.parameter_editing = null;
				self.show_popup_parameters();
			});

		// boton create parameter
		$(this.snippet_param_create)
			.off("click")
			.on("click", function() {
				var has_continue = false;
				self.add_or_update_snippet_parameter(has_continue);
			});

		// boton create & continue parameter
		$(this.snippet_param_create_continue)
			.off("click")
			.on("click", function() {
				var has_continue = true;
				self.add_or_update_snippet_parameter(has_continue);
			});

		// boton que cancela la creacion del parametro
		$(this.snippet_param_cancel)
			.off("click")
			.on("click", function() {
				self.hide_popup_parameters();
			});

		// change en el combo de type en el popup
		$(this.snippet_param_type)
			.off("change")
			.on("change", function() {
				var type_id = $(this).val();
				var type = self.snippet_parameters_types[type_id];
				var $alias = $(self.snippet_param_alias);

				var $alias_lbl = $alias.parent().find("label[for='adm_form_campaign_accounts_webcall_snippet_param_alias']");
				if (type && type.has_alias) {
					$alias.prop("disabled", false).removeClass("readonly");
					$alias_lbl
						// .removeClass("formLabel-ds")
						// .addClass("formLabel-rq");
						.addClass("required");
				}
				else {
					$alias.prop("disabled", true).addClass("readonly");
					$alias_lbl
						// .removeClass("formLabel-rq")
						.removeClass("required");
						// .addClass("formLabel-ds");
				}

				$alias.val("").focus();
			});

			$(this.receive)
			.off("change")
			.on("change", function() {
				var type_id = $(this).val();
				var type = self.snippet_parameters_types[type_id];
				var $alias = $(self.snippet_param_alias);

				var $alias_lbl = $alias.parent().find("label[for='adm_form_campaign_accounts_webcall_snippet_param_alias']");
				if (type && type.has_alias) {
					$alias.prop("disabled", false).removeClass("readonly");
					$alias_lbl
						// .removeClass("formLabel-ds")
						// .addClass("formLabel-rq");
						.addClass("required");
				}
				else {
					$alias.prop("disabled", true).addClass("readonly");
					$alias_lbl
						// .removeClass("formLabel-rq")
						.removeClass("required");
						// .addClass("formLabel-ds");
				}

				$alias.val("").focus();
			});

		var $snippet_param = $(this.snippet_param_list);
		// boton edit de la lista de parametros
		var event_selector = "li[param_data='true'] button[action_edit='true']";
		$snippet_param
			.off("click", event_selector)
			.on("click", event_selector, function()
			{
				self.parameter_editing = $(this).parent();
				self.show_popup_parameters();
			});

		// boton delete de la lista de parametros
		event_selector = "li[param_data='true'] button[action_del='true']";
		$snippet_param
			.off("click", event_selector)
			.on("click", event_selector, function()
			{
				var $parameter = $(this).parent();
				var message = FORMAT(
					"<%=_T('Do you want to delete parameter control id {0} type {1} ?')%>",
					$parameter.find("[param_control_id='true']").text(),
					$parameter.find("[param_type='true']").text()
				);
				$.inconcertPopup.Show(
					"<%=_T('Confirm')%>",
					message,
					jQuery.inconcertPopup.ButtonSets.BS_YESNO,
					function(response) {
						if (response.toLowerCase() !== "yes") {
							return;
						}
						$parameter.fadeOut("slow", function() {
							$parameter.remove();
							self.generate_snippet();
						});
					},
					undefined,
					{
						popup_id        : "conf_inconcertPopup",
						container_class : "confirmationPopUp",
						overlay_class   : "confirmationOverlay"
					}
				);
			});
	};

	CallAccountPanel.prototype.set_events_popup_triggers = function()
	{
		var self = this;

		// boton new que abre el popup para poder agregar un nuevo parametro
		$(this.triggers_new)
			.off("click")
			.on("click", function() {
				self.trigger_editing = null;
				self.show_popup_triggers();
			});

		// boton create parameter
		$(this.triggers_create)
			.off("click")
			.on("click", function() {
				var has_continue = false;
				self.add_or_update_trigger(has_continue);
			});

		// boton create & continue parameter
		$(this.triggers_create_continue)
			.off("click")
			.on("click", function() {
				var has_continue = true;
				self.add_or_update_trigger(has_continue);
			});

		// boton que cancela la creacion del parametro
		$(this.triggers_cancel)
			.off("click")
			.on("click", function() {
				self.hide_popup_triggers();
			});

		var $triggers_popup_ctrl = $(this.triggers_popup_ctrl);
		// change en el combo de type en el popup
		var $triggers_type = $(this.triggers_type);
		$triggers_type
			.off("change")
			.on("change", function() {
				if ( $(this).val() === "time" ) {
					$triggers_popup_ctrl.find("[webcall_trigger_time]").show();
				}
			});

		var $triggers_list = $(this.triggers_list);
		// boton edit de la lista de parametros
		var event_selector = "li[param_data='true'] button[action_edit='true']";
		$triggers_list
			.off("click", event_selector)
			.on("click", event_selector, function()
			{
				self.trigger_editing = $(this).parent();
				self.show_popup_triggers();
			});

		// boton delete de la lista de parametros
		event_selector = "li[param_data='true'] button[action_del='true']";
		$triggers_list
			.off("click", event_selector)
			.on("click", event_selector, function()
			{
				var $trigger = $(this).parent();
				var message = FORMAT(
					"<%=_T('Do you want to delete trigger with action {0} and regex {1}?')%>",
					$trigger.find("[trigger_action]").text(),
					$trigger.find("[trigger_regex]").text()
				);
				$.inconcertPopup.Show(
					"<%=_T('Confirm')%>",
					message,
					jQuery.inconcertPopup.ButtonSets.BS_YESNO,
					function(response) {
						if (response.toLowerCase() !== "yes") {
							return;
						}
						$trigger.fadeOut("slow", function() {
							$trigger.remove();
							self.generate_snippet();
						});
					},
					undefined,
					{
						popup_id        : "conf_inconcertPopup",
						container_class : "confirmationPopUp",
						overlay_class   : "confirmationOverlay"
					}
				);
			});

			var $triggers_regex_test = $(this.triggers_regex_test);
			var test_trigger_regex_fn = function() {
				var regex_s = $(self.triggers_regex).val();
				var url = $triggers_regex_test.val();
				if (!regex_s || !url) {
					$triggers_regex_test
						.parent()
						.removeClass("regex_matches")
						.removeClass("regex_notmatches");
					return;
				}
				var regex = new RegExp(regex_s, "i");
				var matches = regex.test(url);
				$triggers_regex_test
					.parent()
					.toggleClass("regex_matches", matches)
					.toggleClass("regex_notmatches", !matches);
			};

		 $(this.triggers_regex_test + ", " + this.triggers_regex)
			.off("paste")
			.on("paste", function() {
				window.setTimeout(function() {
					test_trigger_regex_fn();
				}, 100);
			})
			.off("keyup")
			.on("keyup", function() {
				test_trigger_regex_fn();
			});
	};

	CallAccountPanel.prototype.show_tweety_info = function( project_id )
	{
		var self = this;
		var $tweety_info = $( this.tweety_info );

		var show = function( info )
		{
			var only_default = ( self.parent.is_readonly() || !self.tweety_webcall_projects || Object.keys( self.tweety_webcall_projects ).length <= 1 );

			$.each( $tweety_info.find("[info_type]"), function ( _, img )
			{
				var $img = $( img );
				$img.removeClass().addClass( "checkboxImageUnchecked" );
				if ( only_default ) {
					var $lbl = $img.parent().find( "label" );
					$lbl.removeClass().addClass( "readonly" );
				}
			});

			if ( info && info.status ) {
				var views = info.result.views;
				$.each( views, function ( _, view )
				{
					if ( view.name ) {
						var $img = $tweety_info.find("[info_type='" + view.name + "']");
						if ( $img.length > 0 ) {
							$img.removeClass("checkboxImageUnchecked")
								.addClass("checkboxImageChecked");
						}
					}
				});
				$tweety_info.show();
			}
			else {
				$tweety_info.hide();
			}
			self.__setProjectVersion(info);
		};

		var tweety_project = this.tweety_webcall_projects[project_id];
		if ( tweety_project && tweety_project.info ) {
		// si la info para este proyecto ya se recupero al menos una vez, la toma del cache asi no tiene que realizar el request nuevamente.
			show( tweety_project.info );
		}
		else {
		// si la info para este proyecto no se ha recuperado nunca (o sea es la primera vez), realizo el request y luego me lo guardo, para una siguiente vez.
			var tweety = inConcert.app.getTweetyAPI();
			return tweety.get_info( project_id,
				function( info ) {
					if ( self.tweety_webcall_projects[project_id] ) {
					// aca lo cacheo a la info, en la info del proyecto.
						self.tweety_webcall_projects[project_id].info = info;
					}
					show( info );
				}
			);
		}
	};

	CallAccountPanel.prototype.__setProjectVersion = function(_) {
		const $outHours_enabled = $(this.outHours_enabled);
		this.parent.disable_control($(this.start_button), false, true);
		this.parent.disable_control($(this.window_type), false, true);
		this.parent.disable_control($outHours_enabled, false, false);
		$outHours_enabled.change();
		this.generate_snippet();
	};

	CallAccountPanel.prototype.__validate_requrired_voicemail_timeout_retain = function() {
		const is_enabled_inc_voicemail_timeout = $(this.inc_voicemail_timeout).prop("checked");
		const is_enabled_inc_voicemail_waiting = $(this.inc_voicemail_waiting).prop("checked");
		const is_required = is_enabled_inc_voicemail_timeout || is_enabled_inc_voicemail_waiting;
		const $inc_voicemail_lifetime = $(this.inc_voicemail_lifetime);
		this.parent.frm.readonly_control($inc_voicemail_lifetime, false, is_required);
		// const $inc_voicemail_lifetime_help = $(this.inc_voicemail_lifetime_help);
		// $inc_voicemail_lifetime_help[is_required ? "show" : "hide"]();
	};

	CallAccountPanel.prototype.set_events = function() {
		CallAccountPanel.uber.set_events.call(this);
		const self = this;

		// 1 common ---------------
		// ...
		$(this.uses_after_conversation_work)
			.off("change")
			.on("change", function() {
				var is_enabled = $(this).prop("checked");
				$(self.after_conversation_work_panel)[ is_enabled ? "show" : "hide" ]();
			});

		const $after_work_time_limit = $(this.after_conversation_work_time_limit);
		$(this.after_conversation_work_time)
			.off("change")
			.on("change", function() {
				const is_disabled = $(this).val() !== "TimeLimited";
				const is_requerid = true;
				self.parent.disable_control( $after_work_time_limit, is_disabled, is_requerid );
				if (!is_disabled) {
					$after_work_time_limit.focus();
				}
			});

		// PACKAGES
		const $packages = $("#adm_form_campaign_accounts_call_packages");
		let event_selector = "[selector='1']";
		$packages
			.off("change", event_selector)
			.on("change", event_selector,
				function() {
					self.__enable_disable_incoming_outgoing_config();
				}
			);

		// 2 incoming ---------------
		$(this.inc_enabled_config)
			.off("change")
			.on("change", function() {
				const is_enabled = $(this).prop("checked");
				self.__enable_disable_incoming_config(is_enabled);
			});

		const $inc_voicemail_timeout = $(this.inc_voicemail_timeout);
		const $inc_timeout_callback = $(this.inc_timeout_callback);
		const $inc_timeout_callback_fields = $(".timeout-dialer-callback-fields");

		const on_inc_voicemail_timeout_change = () => {
			self.__validate_requrired_voicemail_timeout_retain();
			const is_enabled = $inc_voicemail_timeout.prop("checked");
			self.parent.frm.disable_control($inc_timeout_callback, is_enabled);
		};
		const on_inc_timeout_callback_change = () => {
			const is_enabled = $inc_timeout_callback.prop("checked");
			$inc_timeout_callback_fields.toggle(is_enabled);
			self.parent.frm.disable_control($inc_voicemail_timeout, is_enabled);
			if (is_enabled) {
				$inc_voicemail_timeout.prop("checked", false);
			}
		};

		$inc_voicemail_timeout
			.off("change")
			.on("change", function() {
				on_inc_voicemail_timeout_change();
				on_inc_timeout_callback_change();
			});
		$inc_timeout_callback
			.off("change")
			.on("change", function() {
				on_inc_timeout_callback_change();
				on_inc_voicemail_timeout_change();
			});

		// dids receive callback
		$(this.dids_receive_callback)
			.off("change")
			.on("change", function() {
				$(self.dids_receive_callback_panel)[ $(this).prop("checked") ? "show" : "hide" ]();
			});

		const $inc_voicemail_waiting = $(this.inc_voicemail_waiting);
		const $inc_voicemail_waiting_digit = $(this.inc_voicemail_waiting_digit);
		const $inc_virtualhold_waiting = $(this.inc_virtualhold_waiting);
		const $inc_virtualhold_waiting_no_answer = $(this.inc_virtualhold_waiting_no_answer);
		const $inc_virtualhold_fields = $(".virtualhold-fields");
		const $inc_virtualhold_no_anwer_fields = $(".virtualhold-no-answer-fields");

		const on_inc_voicemail_waiting_change = () => {
			self.__validate_requrired_voicemail_timeout_retain();
			const is_enabled = $inc_voicemail_waiting.prop("checked");
			const is_required = is_enabled;
			self.parent.frm.disable_control($inc_voicemail_waiting_digit, !is_enabled, is_required);
			self.parent.frm.disable_control($inc_virtualhold_waiting, is_enabled || !$(self.out_enabled_config).is(":checked"));
			if (is_enabled) {
				$inc_virtualhold_waiting.prop("checked", false);
			}
		};
		const on_inc_virtualhold_waiting_change = () => {
			if (!$(self.out_enabled_config).is(":checked")) {
				$inc_virtualhold_waiting.prop("checked", false);
			}
			const is_enabled = $inc_virtualhold_waiting.prop("checked");
			$inc_virtualhold_fields.toggle(is_enabled);
			self.parent.frm.disable_control($inc_voicemail_waiting, is_enabled);
			if (is_enabled) {
				$inc_voicemail_waiting.prop("checked", false);
			}
			else {
				$inc_virtualhold_waiting_no_answer.val("CANCELED");
			}
		};
		const on_inc_virtualhold_waiting_no_answer_change = () => {
			const value = $inc_virtualhold_waiting_no_answer.val();
			$inc_virtualhold_no_anwer_fields
				.hide()
				.filter(`[virtualhold-no-answer-fields=${value}]`)
				.show();
		};

		$inc_voicemail_waiting
			.off("change")
			.on("change", function() {
				on_inc_voicemail_waiting_change();
				on_inc_virtualhold_waiting_change();
				on_inc_virtualhold_waiting_no_answer_change();
			});
		$inc_virtualhold_waiting
			.off("change")
			.on("change", function() {
				on_inc_virtualhold_waiting_change();
				on_inc_voicemail_waiting_change();
				on_inc_virtualhold_waiting_no_answer_change();
			});
		$inc_virtualhold_waiting_no_answer
			.off("change")
			.on("change", function() {
				on_inc_virtualhold_waiting_no_answer_change();
			});

		// 3 outgoing ---------------
		$(this.out_enabled_config)
			.off("change")
			.on("change", function() {
				const is_enabled = $(this).prop("checked");
				self.__enable_disable_outgoing_config(is_enabled);
				$inc_virtualhold_waiting.trigger("change");
			});
			
		// 4 webcall ---------------
		
		$( this.webcall_enabled )
			.off( "change" )
			.on({
				change: function() {
					$(".webcallField").toggle($(this).is(":checked"));
				}
			});
		
		$( this.tweety_app_name )
			.off( "change" )
			.on({
				change: function() {
					var project_id = $( this ).val();
					self.show_tweety_info( project_id );
				}
			});

		if ( this.parent.is_readonly() ) {
			return;
		}

		// input element id de la page
		$(this.button_id + ", " + this.google_key)
				.off("keyup")
				.on("keyup", function() {
					self.generate_snippet();
				});

		$(this.google_bySections)
				.off("change")
				.on("change", function() {
					self.generate_snippet();
				});

		// chk enabled tracking
		$(this.tracking)
			.off("change")
			.on("change", function() {
				if ($(this).prop("checked")) {
					self.show_tracking();
				}
				else {
					self.hide_tracking();
				}
			});

		$(this.start_button)
			.off("change")
			.on("change", function()
			{
				$(self.button_id).parent().toggle($(this).val() === "control");
			});

		var $google_panel = $(this.google_panel);
		var $google_enabled = $(this.google_enabled);
		$google_enabled
			.off("change")
			.on("change", function()
			{
				$google_panel.find("[webcall_google]")
					.find("input, select")
					.prop("disabled", !$google_enabled.is(":checked"))
					// .siblings("label.formLabel")
					.siblings("label");
					// .toggleClass("formLabel-ds", !$google_enabled.is(":checked"));

				$(self.google_key)
					// .siblings("label.formLabel")
					.siblings("label")
					// .toggleClass("formLabel-rq", $google_enabled.is(":checked"));
					.toggleClass("required", $google_enabled.is(":checked"));

				self.generate_snippet();
			});

		var $outHours_enabled = $(this.outHours_enabled);
		$outHours_enabled
			.off("change")
			.on("change", function()
			{
				self.parent.disable_control( $(self.outHours_campaign), !$outHours_enabled.is(":checked"), false );
				self.parent.disable_control( $(self.outHours_account), !$outHours_enabled.is(":checked"), false );
			});
		var $outHours_campaign = $(this.outHours_campaign);
		$outHours_campaign
			.off("change")
			.on("change", function()
			{
				self.fill_combo_webContact_accounts();
			});
			
		$(this.snippet_code + ", " + this.tracking_code)
			.off("click")
			.on("click", function() {
				this.setSelectionRange(0, this.value.length);
			});
			
		$(this.snippet_message)
			.find(".formTextarea")
			.off("click")
			.on("click", function() {
				this.setSelectionRange(0, this.value.length);
			});

		// snippet events
		this.set_events_popup_parameters();
		this.set_events_popup_triggers();
			
		// on agent no answer ---------------
		$( this.distribution )
			.off( "change" )
			.on({
				change: function() {
					const distribution = $(this).val();
					const auto_answer = $( self.adm_form_campaign_accounts_call_auto_answer_incoming ).is(":checked");
					const on_agent_noanswer_enabled_allowed = ["CIRCULAR", "SKILL"].includes(distribution) && !auto_answer;
					if(!on_agent_noanswer_enabled_allowed) {
						$( self.on_agent_noanswer_enabled ).prop("checked", false).change();
					}					
					self.parent.disable_control($( self.on_agent_noanswer_enabled ), !on_agent_noanswer_enabled_allowed, false, false);
				}
			});

		$( this.inc_auto_answer )
			.off("change")
			.on("change", function() {
				const distribution = $( self.distribution ).val();
				const auto_answer = $(this).is(":checked");
				const on_agent_noanswer_enabled_allowed = ["CIRCULAR", "SKILL"].includes(distribution) && !auto_answer;
				if(!on_agent_noanswer_enabled_allowed) {
					$( self.on_agent_noanswer_enabled ).prop("checked", false).change();
				}					
				self.parent.disable_control($( self.on_agent_noanswer_enabled ), !on_agent_noanswer_enabled_allowed, false, false);
			});			

		$( this.on_agent_noanswer_enabled )
			.off( "change" )
			.on({
				change: function() {
					$( self.on_agent_noanswer_timeout_container ).toggle($(this).is(":checked"));
					$( self.on_agent_noanswer_no_logout_container ).toggle($(this).is(":checked"));
				}
			});
	};

	CallAccountPanel.prototype.__enable_disable_incoming_config = function(is_enabled)
	{
		const $msg = $("#adm_form_campaign_accounts_call_enabled_incoming_msg .inlineMessagesContainer");
		const $inc_panel_enabled = $(this.inc_panel_enabled);
		if (is_enabled) {
			$msg.text("<%=_T('You have to configure the Incoming settings for the telephony account.')%>");
			$inc_panel_enabled.show();
			if (this.thresholds_instance) {
				this.thresholds_instance.show_internal_tab( INC_TAB_ID );
				this.disable_thresholds( false, INC_TAB_ID );
			}
		}
		else {
			$msg.text("<%=_T('To configure the Incoming telephony account settings, you must select a Inbound package.')%>");
			$inc_panel_enabled.hide();
			if (this.thresholds_instance) {
				if (this.is_new()) {
					this.thresholds_instance.hide_internal_tab( INC_TAB_ID );
				}
				this.disable_thresholds( true, INC_TAB_ID );
			}
		}
	};

	CallAccountPanel.prototype.__enable_disable_outgoing_config = function( is_enabled )
	{
		const $msg = $("#adm_form_campaign_accounts_call_enabled_outgoing_msg .inlineMessagesContainer");
		const $out_panel_enabled = $(this.out_panel_enabled);
		if (is_enabled) {
			$msg.text("<%=_T('You have to configure the Outgoing settings for the telephony account.')%>");
			$out_panel_enabled.show();
			if (this.thresholds_instance) {
				this.thresholds_instance.show_internal_tab( OUT_TAB_ID );
				this.disable_thresholds( false, OUT_TAB_ID );
			}
		}
		else {
			$msg.text("<%=_T('To configure the Outgoing telephony account settings, you must select a Outbound package.')%>");
			$out_panel_enabled.hide();
			if (this.thresholds_instance) {
				if (this.is_new()) {
					this.thresholds_instance.hide_internal_tab( OUT_TAB_ID );
				}
				this.disable_thresholds( true, OUT_TAB_ID );
			}
		}
	};

	/*
		Esta funcion se encarga de habilitar o inhabilitar la configuracion entrante y/o saliente, dependiendo del ioMode del Package que se ha seleccionado.
	*/
	CallAccountPanel.prototype.__enable_disable_incoming_outgoing_config = function()
	{
		let is_enabled_incoming_config = false;
		let is_enabled_outgoing_config = false;

		const $packages_selector = $("#adm_form_campaign_accounts_call_packages").find("[selector='1']");
		$.each($packages_selector, function(_, chk)
		{
			if (is_enabled_incoming_config && is_enabled_outgoing_config) {
				return false; // break
			}
			const $chk = $(chk);
			if ($chk.prop("checked")) {
				const pkg = $chk.data("package");
				let ioMode = pkg.ioMode || "";
				if (ioMode.trim().length > 0) {
					if (ioMode === "I") {
						is_enabled_incoming_config = true;
					}
					else if (ioMode === "O") {
						is_enabled_outgoing_config = true;
					}
					else if (ioMode === "I/O") {
						is_enabled_incoming_config = true;
						is_enabled_outgoing_config = true;
					}
				}
			}
		});

		$(this.inc_enabled_config).prop("checked", is_enabled_incoming_config).trigger("change");
		$(this.out_enabled_config).prop("checked", is_enabled_outgoing_config).trigger("change");
	};

	CallAccountPanel.prototype.on_hide = function()
	{
		CallAccountPanel.uber.on_hide.call( this );

		if ( ! this.tweety_webcall_projects ) {
			return;
		}
		$.each( this.tweety_webcall_projects, function ( _, data )
		{
			if ( data && data.info ) {
				data.info = null;
			}
		});
	};

	CallAccountPanel.prototype.on_show = function()
	{
		CallAccountPanel.uber.on_show.call( this );

		const $packages_chks = $("#adm_form_campaign_accounts_call_packages .formListCheck");
		if ( this.parent.is_readonly() ) {
			$packages_chks.removeClass( "readonly" ).addClass( "readonly" ).prop( "disabled", true );
		}
		else {
			$packages_chks.removeClass( "readonly" ).prop( "disabled", false );
		}

		// checkbox inbound enabled
		this.parent.frm.readonly_control($(this.inc_enabled_config), true);
		// checkbox outbound enabled
		this.parent.frm.readonly_control($(this.out_enabled_config), true);
		// prefijo saliente
		this.parent.frm.readonly_control($(this.out_prefix), true);
			// outgoing blacklists
			//$(this.out_prefix).val(outgoing_config.outboundPrefix);

		this.current_snippet = this.generate_snippet();
		this.hide_popup_parameters();

		$(this.name).focus();
	};

	CallAccountPanel.prototype.on_saved = function(new_account, current_account, callback = $.noop)
	{
		CallAccountPanel.uber.on_saved.call(this, new_account, current_account, callback);

		const self = this;

		let new_webcall = new_account.webcallConfig || {};
		let current_webcall = (current_account || {}).webcallConfig || {};
		let project_id = new_webcall.TweetyAppName;
		let token = new_webcall.Token;

		// si estoy actualizando una account y no se ha cambiado de proyecto de tweety, no actualizo el authfilter
		if (current_account &&
			(current_webcall.TweetyAppName === project_id && current_webcall.Token === token)) {
			return;
		}

		const tweety = inConcert.app.getTweetyAPI();
		return tweety.set_authfilter(project_id, token,
			function(success) {
				if (success) {
					return;
				}
				const error_message = "<%=_T('Error setting auth filter to web desginer.')%>";
				const timeout_ms = 5000;
				self.parent.frm.show_status_message(error_message, "Error", timeout_ms);
			}
		);
	};

	CallAccountPanel.prototype.make_html_packages = function(packages)
	{
		const self = this;

		let sorted_packages = inConcert.Utils.sortArray(packages, null, null,
			function( current_package ) {
				return current_package.id;
			})
		;

		var get_mode_value = function(row) {
			let value = row.ioMode || "";
			if (value.trim().length > 0) {
				if (value === "I") {
					value = "<%=_T('I')%>";
				}
				else if (value === "O") {
					value = "<%=_T('O')%>";
				}
				else if (value === "I/O") {
					value = "<%=_T('I/O')%>";
				}
			}
			return value;
		};

		const campaign_id = inConcert.app.get_id(this.get_campaign_id());
		const is_new_account = this.is_new();

		var must_include_package = function(row, is_inbound_package) {

			if (is_inbound_package) {
				if (!row.campaigns) {
					return true;
				}
				let total_campaigns = Object.keys(row.campaigns).length;
				if (is_new_account) {
					if (total_campaigns > 0) {
						return false;
					}
				}
				else {
					for (let package_camp_id in row.campaigns) {
						if (row.campaigns.hasOwnProperty(package_camp_id)) {
							if (campaign_id.toLowerCase() !== package_camp_id.toLowerCase()) {
								return false;
							}
						}
					}
				}
			}

			return true;
		};

		// list header
		const $header =  $(
			"<li header='true' class='formListTitle'>" +
				"<div class='firstItemCheckbox'></div>" +
				"<label class='formListTitleText'>" + "<%=_T('Name')%>"        + "</label>" +
				"<label class='formListTitleText'>" + "<%=_T('DID')%>"         + "</label>" +
				"<label class='formListTitleText'>" + "<%=_T('Description')%>" + "</label>" +
				"<label class='formListTitleText'>" + "<%=_T('Mode')%>"        + "</label>" +
			"</li>");

		const $packages = $("#adm_form_campaign_accounts_call_packages");
		$packages.html("").append( $header );

		let total_added_packages = 0;
		$.each(sorted_packages, function(_, current_package)
		{
			const id_mode = (current_package.ioMode || "").toUpperCase();
			const is_inbound_package = (id_mode === "I" || id_mode === "I/O");
			
			let must_include = must_include_package(current_package, is_inbound_package);
			if (!must_include) {
				return true; // continue
			}
	
			total_added_packages++;
			let package_id = current_package.id || "";
			let package_did = current_package.DID || "";
			let package_desc = current_package.description || "";
			let package_mode = get_mode_value(current_package);

			var opt_package_id = "opt_package_" + inConcert.Utils.getNormalizedId( package_id );

			var $package = $(
				"<li class='formListItem' package_id='" + package_id + "'>" +

					"<input class='formListCheck' id='"  + opt_package_id + "' selector='1' type='checkbox' " + 
						" inbound_package='" + (is_inbound_package? "true" : "false") + "' />" +

					"<div class='formItemText'>"                                                                +
						"<label for='" + opt_package_id + "'>" + package_id + "</label>"                        +
					"</div>"                                                                                    +

					"<div class='formItemText'>"                                                                +
						"<label for='" + opt_package_id + "'>" + package_did + "</label>"                       +
					"</div>"                                                                                    +

					"<div class='formItemText'>"                                                                +
						"<label for='" + opt_package_id + "'>" + package_desc + "</label>"                      +
					"</div>"                                                                                    +

					"<div class='formItemText'>"                                                                +
						"<label for='" + opt_package_id + "'>" + package_mode + "</label>"                      +
					"</div>"                                                                                    +

					"<i error='true' class='formFieldValidation formFieldError' hidden ></i>"                   +

				"</li>");

			$package.find("[selector]")
				.data("package", current_package)
				.change(function() {
					self.set_webcall_packages();
				});

			// agrego el package al markup
			$packages.append( $package );
		});

		const $packages_not_found = $("#adm_form_campaign_accounts_call_packages_not_found");

		if (total_added_packages === 0) {
			$packages.hide();
			$packages_not_found.show();
		}
		else {
			if (!is_new_account) {
				const current_account = this.get_account();
				this.set_packages(current_account.packages);
			}
			$packages_not_found.hide();
			$packages.show();
		}
	};

	CallAccountPanel.prototype.validate_selected_packages = function()
	{
		var result = { success: true, error_message: null };

		var has_selected_packages = false;
		var $packages = $( "#adm_form_campaign_accounts_call_packages" );

		$packages.find( "input[selector='1'][type='checkbox']" ).each(
			function( _, current_package )
			{
				var $package = $( current_package );
				var checked = $package.prop("checked");
				if ( checked ) {
					has_selected_packages = true;
				}
			});

		if ( !has_selected_packages ) {
			result.success = false;
			result.error_message = "<%=_T('Packages is required.')%>";
		}

		if ( !result.success ) {
			this.mark_error( $packages );
		}

		return result;
	};

	CallAccountPanel.prototype.get_selected_packages = function()
	{
		var packages = {};

		var $packages = $( "#adm_form_campaign_accounts_call_packages" );

		$packages.find( "input[selector='1'][type='checkbox']" )
			.each(function( _, current_package )
			{
				var $package = $(current_package);
				var checked = $package.prop( "checked" );
				if ( checked ) {
					var $parent = $package.parent();
					var package_id = $parent.attr( "package_id" );
					packages[ package_id ] = "";
				}
			});

		return packages;
	};

	CallAccountPanel.prototype.set_packages = function( packages )
	{
		packages = packages || {};
		this.unselect_packages();
		$.each( packages, function( package_id, _ )
		{
			var opt_package_id = "opt_package_" + inConcert.Utils.getNormalizedId( package_id );
			var $checkbox = $( "#" + opt_package_id );
			$checkbox.prop( "checked", true );
		});
		this.set_webcall_packages();
	};

	CallAccountPanel.prototype.unselect_packages = function()
	{
		$( "#adm_form_campaign_accounts_call_packages input[selector='1'][type='checkbox']" ).prop( "checked", false );
	};
	
	CallAccountPanel.prototype.set_webcall_packages = function()
	{
		const $webcall_package = $(this.webcall_package);
		const currentValue = $webcall_package.val();
		let currentValueFound = false;
		const inboundPackages = [];
		const $inboundPackages = $("#adm_form_campaign_accounts_call_packages")
			.find("input[selector='1'][type='checkbox'][inbound_package='true']:checked");
		$inboundPackages.each(function(_, current_package) {
			var pack = $( current_package ).data("package");
			inboundPackages.push({ id : pack.id, name : pack.DID });
			currentValueFound = currentValueFound || pack.id === currentValue;
		});
		this.parent.fill_combo(
			$webcall_package,
			false, // is_blank_first_item
			inboundPackages,
			"id", // id
			"description", // description
			false //sorted
		);
		if (currentValueFound) {
			$webcall_package.val(currentValue);
		}
	};

	CallAccountPanel.prototype.__switch_conversation_tab = function(tab_id, on_selected = $.noop)
	{
		if (!tab_id) {
			on_selected(true);
			return;
		}
		this.m_call_tabs.switch_tab(tab_id, function() {
			on_selected(true);
		});
	};

	CallAccountPanel.prototype.validate = function()
	{
		const self = this;

		const is_new = this.is_new();
		let account_info = {
			success       : false,
			account       : null,
			is_new        : is_new,
			error_message : null
		};

		const error_in_basic_tab = function(conversation_tab_type, $field)
		{
			self.tabs.switch_tab("basic");
			self.__switch_conversation_tab(conversation_tab_type);
			if ( $field ) {
				window.setTimeout(function() {
					$field.focus();
				});
			}
			return account_info;
		};

		this.hide_marked_errors(); // oculto todos los errors de los campos
		
		let msg_err;
		const is_enabled_incoming_config = $( this.inc_enabled_config ).prop("checked");
		const is_enabled_outgoing_config = $( this.out_enabled_config ).prop("checked");

	// -------------------------------------------------------
	// 1 - Validacion de "COMMON CONTROLS"
	//
		// NAME - validation
		const $name = $( this.name );
		if ( !this.validate_field( $name, "required", "<%=_T('Account name is required.')%>" ) ) {
			return error_in_basic_tab();
		}
		if ( !this.validate_field( $name, "alpha", "<%=_T('Only letters, numbers, dashes and dots are allowed in the Account Name.')%>" ) ) {
			return error_in_basic_tab();
		}

		// DISTRIBUTION - validation
		const $distribution = $( this.distribution );
		if ( !this.validate_field( $distribution, "required", "<%=_T('Distribution is required.')%>" ) ) {
			return error_in_basic_tab();
		}

		let range;
		// PRIORITY - validation
		const $priority = $(this.priority);
		let has_att_levels = this.attention_levels_handle.count_selected() > 0;
		if (!has_att_levels && $priority.val().trim().length > 0) {
			range = { between: { from: 0, to: 99 } }; // range attention_level value validation
			if (!this.validate_field($priority, "range", FORMAT("<%=_T('Account priority value out of range. Please enter account priority value between {0} and {1}.')%>", range.between.from, range.between.to ), range )) {
				return error_in_basic_tab();
			}
		}

		// LANGUAGE - validation
		const $language = $(this.language);
		if (!this.validate_field($language, "required", "<%=_T('Language is required.')%>")) {
			return error_in_basic_tab();
		}

		// AFTER CONVERSATION WORK TIME LIMIT - validation
		const $uses_after_conversation_work = $(this.uses_after_conversation_work);
		if ($uses_after_conversation_work.prop("checked")) {
			const $after_conversation_work_time_limit = $(this.after_conversation_work_time_limit);
			msg_err = "<%=_T('After conversation work time is required.')%>";
			if ( !this.validate_field( $after_conversation_work_time_limit, "required", msg_err ) ) {
				return error_in_basic_tab();
			}
			range = { between: { from: 5, to: 600 } };
			msg_err = FORMAT("<%=_T('After conversation work time value out of range. Please enter value between {0} and {1}.')%>", range.between.from, range.between.to);
			if ( !this.validate_field($after_conversation_work_time_limit, "range", msg_err, range)) {
				return error_in_basic_tab();
			}
		}

		// PACKAGE - validation
		let package_validation = this.validate_selected_packages();
		if ( !package_validation.success ) {
			this.show_validation_error( null, package_validation.error_message, false );
			return error_in_basic_tab();
		}

		// CALLBACK IS ALLOWED - validation
		const $retain_abandoned = $(this.callback_retain_abandoned);
		const $retain_appointment = $(this.callback_retain_appointment);
		const $callback = $(this.callback);

		if ($callback.prop("checked")) {
			msg_err = "<%=_T('To configure callback, you must select at least one outgoing package.')%>";
			if (!is_enabled_outgoing_config) {
				this.show_validation_error( $callback, msg_err, false );
				return error_in_basic_tab();
			}
			// RETAIN ABANDONED - validation
			msg_err = "<%=_T('Retain abandoned is required.')%>";
			if ( !this.validate_field( $retain_abandoned, "required", msg_err ) ) {
				return error_in_basic_tab();
			}
			range = { between: { from: 0, to: 15 } };
			msg_err = FORMAT("<%=_T('Retain abandoned value out of range. Please enter retain abandoned value between {0} and {1}.')%>", range.between.from, range.between.to);
			if ( !this.validate_field($retain_abandoned, "range", msg_err, range)) {
				return error_in_basic_tab();
			}
			// RETAIN APPOINTMENT - validation
			msg_err = "<%=_T('Retain appointment is required.')%>";
			if ( !this.validate_field( $retain_appointment, "required", msg_err ) ) {
				return error_in_basic_tab();
			}
			range = { between: { from: 0, to: 15 } };
			msg_err = FORMAT("<%=_T('Retain appointment value out of range. Please enter retain appointment value between {0} and {1}.')%>", range.between.from, range.between.to);
			if ( !this.validate_field($retain_appointment, "range", msg_err, range)) {
				return error_in_basic_tab();
			}
		}

		// SCREEN RECORDING PERCENTAGE - validation
		if ($(this.screen_recording).prop("checked")) {
			var $screen_recording_percentage = $( this.screen_recording_percentage );
			msg_err = "<%=_T('Screen recording percentage is required.')%>";
			if ( !this.validate_field( $screen_recording_percentage, "required", msg_err ) ) {
				return error_in_basic_tab();
			}
		}

	// -------------------------------------------------------
	// 2 - Validacion de "INCOMING CONTROLS"
	//
		let incoming_config = {enabled: false, ContactCenter: {}};

		if (is_enabled_incoming_config) {
			incoming_config.enabled = true;
			// REDIAL
			incoming_config.ContactCenter.CheckRedial = this.parent.frm.convert_chk_bool_to_string(this.inc_redial);

			// validacion del answer time (requerido y rango)
			if ($(this.inc_auto_answer).prop("checked")) {
				const $inc_auto_answer_time = $(this.inc_auto_answer_time);
				msg_err = "<%=_T('Incoming answer time is required.')%>";
				if ( !this.validate_field( $inc_auto_answer_time, "required", msg_err ) ) {
					return error_in_basic_tab( INC_TAB_ID );
				}
				let range = { between: { from: 0, to: 20 } };
				msg_err = FORMAT("<%=_T('Incoming answer time value out of range. Please enter value between {0} and {1}.')%>", range.between.from, range.between.to);
				if (!this.validate_field($inc_auto_answer_time, "range", msg_err, range)) {
					return error_in_basic_tab( INC_TAB_ID );
				}
				incoming_config.AutoAnswerTime = MS($inc_auto_answer_time.val());
			}

			const enabled_inc_voicemail_timeout = $(this.inc_voicemail_timeout).prop("checked"); // enabled retain voicemal
			const enabled_inc_voicemail_waiting = $(this.inc_voicemail_waiting).prop("checked"); // enabled voicemail answer time
			const enabled_inc_virtualhold_waiting = $(this.inc_virtualhold_waiting).prop("checked"); // enabled virtualhold answer time
			const enabled_inc_timeout_callback = $(this.inc_timeout_callback).prop("checked"); // enabled callback
			
			// validacion retain voicemal
			if (enabled_inc_voicemail_timeout || enabled_inc_voicemail_waiting) {
				const $inc_voicemail_timeout_retain = $(this.inc_voicemail_lifetime);
				msg_err = "<%=_T('Incoming retain voicemail is required.')%>";
				if ( !this.validate_field( $inc_voicemail_timeout_retain, "required", msg_err ) ) {
					return error_in_basic_tab( INC_TAB_ID );
				}
				range = { between: { from: 1, to: 15 } };
				msg_err = FORMAT("<%=_T('Incoming retain voicemail value out of range. Please enter value between {0} and {1}.')%>", range.between.from, range.between.to);
				if ( !this.validate_field($inc_voicemail_timeout_retain, "range", msg_err, range)) {
					return error_in_basic_tab( INC_TAB_ID );
				}
				incoming_config.ContactCenter.LifeTimeVoicemail = parseInt($inc_voicemail_timeout_retain.val(), 10);
			}

			if (enabled_inc_voicemail_timeout) {
				incoming_config.ContactCenter.VoicemailOnTimeout = true;
			}

			if (enabled_inc_timeout_callback) {
				const $inc_timeout_callback_process = $(this.inc_timeout_callback_process);
				const $inc_timeout_callback_batch = $(this.inc_timeout_callback_batch);
				if (
					!this.validate_field(
						$inc_timeout_callback_process,
						"required",
						"<%=_T('Timeout callback process is required.')%>"
					) ||
					!this.validate_field(
						$inc_timeout_callback_batch,
						"required",
						"<%=_T('Timeout callback batch is required.')%>"
					) ||
					!this.validate_field(
						$inc_timeout_callback_batch,
						"id",
						"<%=_T('Only letters, numbers, dashes and dots are allowed in the Timeout callback batch.')%>"
					)
				) {
					return error_in_basic_tab( INC_TAB_ID );
				}
				incoming_config.ContactCenter.DialerCallbackOnTimeout = true;
				incoming_config.ContactCenter.DialerCallbackOnTimeoutProcess =
					$inc_timeout_callback_process.val();
				incoming_config.ContactCenter.DialerCallbackOnTimeoutBatch =
					$inc_timeout_callback_batch.val();
			}

			// voicemail leave at out of hours
			incoming_config.ContactCenter.LeaveVoicemailAtOutOfHours = $(this.inc_voicemail_of_hours).prop("checked");

			// validacion del answer time (requerido y rango)
			if (enabled_inc_voicemail_waiting) {
				incoming_config.ContactCenter.VoicemailOnWait = true;
				incoming_config.ContactCenter.VoicemailOnWaitDigit = $(this.inc_voicemail_waiting_digit).val();
			}

			// validacion del virtualhold (requerido y rango)
			if (enabled_inc_virtualhold_waiting) {
				incoming_config.ContactCenter.VirtualholdOnWait = true;
				incoming_config.ContactCenter.VirtualholdOnWaitDigit =
					$(this.inc_virtualhold_waiting_digit).val();
				incoming_config.ContactCenter.VirtualholdOnWaitNoAnswer =
					$(this.inc_virtualhold_waiting_no_answer).val();
				switch(incoming_config.ContactCenter.VirtualholdOnWaitNoAnswer) {
					case "DIALER_CALLBACK":
						const $inc_virtualhold_callback_process = $(this.inc_virtualhold_callback_process);
						const $inc_virtualhold_callback_batch = $(this.inc_virtualhold_callback_batch);
						if (
							!this.validate_field(
								$inc_virtualhold_callback_process,
								"required",
								"<%=_T('Virtualhold callback process is required.')%>"
							) ||
							!this.validate_field(
								$inc_virtualhold_callback_batch,
								"required",
								"<%=_T('Virtualhold callback batch is required.')%>"
							) ||
							!this.validate_field(
								$inc_virtualhold_callback_batch,
								"id",
								"<%=_T('Only letters, numbers, dashes and dots are allowed in the Virtualhold callback batch.')%>"
							)
						) {
							return error_in_basic_tab( INC_TAB_ID );
						}

						incoming_config.ContactCenter.VirtualholdCallbackProcess =
							$inc_virtualhold_callback_process.val();
						incoming_config.ContactCenter.VirtualholdCallbackBatch =
							$inc_virtualhold_callback_batch.val();
						break;
					default:
						break;
				}
			}
		}
	// -------------------------------------------------------
	// 3 - Validacion de "OUTGOING CONTROLS"
	//
		let outgoing_config = {enabled: false, ContactCenter: {}, Blacklists: {}};
		if (is_enabled_outgoing_config ) {
			outgoing_config.enabled = true;
			// Allow Manual Calls
			outgoing_config.ContactCenter.AllowManualCalls =
				this.parent.frm.convert_chk_bool_to_string(this.out_manual_calls);
			// Allow Invalid Numbers
			outgoing_config.ContactCenter.AllowInvalidNumbers =
				this.parent.frm.convert_chk_bool_to_string(this.out_invalid_numbers);
			// Blacklists
			const result_blacklists = this.validate_blacklists();
			if (!result_blacklists.success) {
				return error_in_basic_tab( OUT_TAB_ID );
			}
		}
		
	// -------------------------------------------------------
	// 4 - Validacion de "WEBCALL"
	//
	let webcall_config = { enabled: $(this.webcall_enabled).is(":checked") };
	if (webcall_config.enabled) {
		// incoming package - validation
		var $webcall_package = $( this.webcall_package );
		if (!this.validate_field( $webcall_package, "required", "<%=_T('Web call incoming package is required.')%>" ) ) {
			return error_in_basic_tab();
		}
		// tweety app name - validation
		var $tweety_app_name = $( this.tweety_app_name );
		if (!this.validate_field( $tweety_app_name, "required", "<%=_T('Web call name is required.')%>" ) ) {
			return error_in_basic_tab();
		}
		// START BUTTON - validation
		if ($(this.start_button).val() === "control") {
			if (!this.validate_field( $(this.button_id), "required", "<%=_T('Start Button Id is required.')%>")) {
				return error_in_basic_tab();
			}
			if (!this.validate_field( $(this.button_id), "html_element_id", "<%=_T('Only letters, numbers, dashes and dots are allowed in the Start Button Id.')%>" )) {
				return error_in_basic_tab();
			}
		}

		//valido la configuracion de out of hours
		var $outHours_enabled = $(this.outHours_enabled),
			$outHours_campaign = $(this.outHours_campaign),
			$outHours_account = $(this.outHours_account);

		var outHours_enabled = $outHours_enabled.is(":checked");
		if (outHours_enabled) {
			if (!this.validate_field( $outHours_campaign, "required", "<%=_T('Out of hours contact form campaign is required.')%>" ) ) {
				return error_in_basic_tab();
			}
			if (!this.validate_field( $outHours_account, "required", "<%=_T('Out of hours contact form account is required.')%>" ) ) {
				return error_in_basic_tab();
			}
		}

		//valido la configuracion de google analytics
		var $google_enabled = $(this.google_enabled),
			$google_key = $(this.google_key),
			$google_bySections = $(this.google_bySections);

		var google_enabled = $google_enabled.is(":checked");
		if (google_enabled) {
			if (!this.validate_field( $google_key, "required", "<%=_T('Google Analytics key is required.')%>" ) ) {
				return error_in_basic_tab();
			}
		}
		
		webcall_config.Package				   = $webcall_package.val();
		webcall_config.Tracking                = BOOL( this.tracking );
		webcall_config.TweetyAppName           = $tweety_app_name.val();
		webcall_config.Token                   = this.current_token;
		webcall_config.GUI                     = this.get_gui_config();
		webcall_config.window_type             = $(this.window_type).val();
		webcall_config.start_button            = $(this.start_button).val();
		webcall_config.containerId             = $(this.button_id).val();
		webcall_config.google_enabled          = google_enabled;
		webcall_config.google_key              = $google_key.val();
		webcall_config.google_bySections       = $google_bySections.is(":checked");
		webcall_config.outHours_enabled        = outHours_enabled;
		webcall_config.outHours_campaign       = $outHours_campaign.val();
		webcall_config.outHours_account        = $outHours_account.val();
		webcall_config.snippet_parameters = [];
		// carga la lista de snippet parameters
		$(this.snippet_param_list).find("li[param_data]").each(function(_, param_data)
		{
			var $param_data  = $(param_data);

			var new_parameter = {
				controlId  : $param_data.find("label[param_control_id]").text(),
				type       : $param_data.find("label[param_type]").attr("type_id")
			};
			if ($param_data.attr("is_hidden") === "true") {
				new_parameter.hidden = true;
			}
			var type = self.snippet_parameters_types[new_parameter.type];
			if (type && type.has_alias) {
				new_parameter.alias = $param_data.find("label[param_alias]").text();
			}

			webcall_config.snippet_parameters.push(new_parameter);
		});

		webcall_config.triggers = [];
		$(this.triggers_list).find("li[param_data]").each(function(_, param_data) {
			var $param_data  = $(param_data);
			webcall_config.triggers.push($param_data.data("trigger"));
		});
	}

	// -------------------------------------------------------
	// 5 - Validacion OTROS VALORES
	//
		// valido los skills ----------
		let result_skills = this.validate_skills();
		if ( !result_skills.success ) {
			this.show_validation_error( result_skills.$ctrl, result_skills.message );
			return error_in_basic_tab();
		}

		// valido los attention levels ----------
		let result_attention_levels = this.validate_attention_levels();
		if ( !result_attention_levels.success ) {
			this.show_validation_error(
				result_attention_levels.$ctrl,
				result_attention_levels.message,
				false, //timeout_ms
				true, //scrolling
				result_attention_levels.show_custom_button
			);
			return error_in_basic_tab();
		}

		// valido los thresholds ----------
		let result_th = this.validate_thresholds({
			incoming_config: incoming_config,
			outgoing_config: outgoing_config
		});
		if ( !result_th.success ) {
			this.show_validation_error( result_th.$ctrl, result_th.error_message );
			return error_in_basic_tab();
		}

		// valido los contact mng ----------
		let result_contact_mng = this.validate_contact_mng();
		if ( !result_contact_mng.success ) {
			this.show_validation_error( result_contact_mng.$ctrl, result_contact_mng.error_message );
			return error_in_basic_tab();
		}

		// valido los flows mng ----------
		let result_flows_mng = this.validate_flows_mng();
		if ( !result_flows_mng.success ) {
			this.show_validation_error( result_flows_mng.$ctrl, result_flows_mng.error_message );
			return error_in_basic_tab();
		}

		// valido los qna maker mng ----------
		let result_qna_maker_mng = this.validate_qna_maker_mng();
		if ( !result_qna_maker_mng.success ) {
			this.show_validation_error( result_qna_maker_mng.$ctrl, result_qna_maker_mng.error_message );
			return error_in_basic_tab();
		}

		//  valido los messages de la account ----------
		let result_messages = this.validate_messages();
		if ( !result_messages.success ) {
			this.show_validation_error( undefined, result_messages.error_message );
			return account_info;
		}

		// valido la configuracion de tickets
		let result_ticket_emitter = this.validate_ticket_emitter();
		if (!result_ticket_emitter.success) {
			this.show_validation_error( result_ticket_emitter.$ctrl, result_ticket_emitter.error_message );
			return account_info;
		}

		// valido los dids pool ----------
		let result_dids_pool = this.validate_dids_pool();
		if ( !result_dids_pool.success ) {
			this.show_validation_error( result_dids_pool.$ctrl, result_dids_pool.error_message );
			return error_in_basic_tab();
		}

		// valido la configuracion de on agent no answer
		let agent_noanswer_config = { enabled: $(this.on_agent_noanswer_enabled).is(":checked") };
		if (agent_noanswer_config.enabled) {
			// timeout - validation
			var $on_agent_noanswer_timeout = $( this.on_agent_noanswer_timeout );
			range = { between: { from: AGENT_NOANSWER_MIN_SECCONDS, to: AGENT_NOANSWER_MAX_SECCONDS } }; // range timeout value validation
			if (!this.validate_field( $on_agent_noanswer_timeout, "range", FORMAT("<%=_T('The value of available again after seconds is out of range. Please enter a value between {0} and {1}.')%>", range.between.from, range.between.to ), range )){
				return error_in_basic_tab();
			}
			agent_noanswer_config.timeout = $on_agent_noanswer_timeout.val();
			agent_noanswer_config.noLogout = $(this.on_agent_noanswer_no_logout).is(":checked");
		}		

		// //------------------------------------------------------
		// // paso la validacion correctamente, ahora a guardar!!!
		let name = $name.val();
		let account_id;
		if ( is_new ) {
			let campaign = this.parent.frm.campaign;
			account_id = "CALL_" + campaign.Id + "_" + name;
		}
		else {
			account_id = this.current_account.id;
		}

		let account = {
			id                      : account_id,
			name                    : name,
			uid                     : name,
			proxyType               : "CALL",
			CCAlgorithm             : $distribution.val(),
			optimizeNodeDistribution : $(this.optimizeNodeDistribution).prop("checked") ? 1 : 0,
			language                : $language.val(),
			TicketEmitter           : result_ticket_emitter.result,
			packages                : this.get_selected_packages(),
			Skills                  : this.skills_handle.get(),
			Priority                : $priority.val(),
			AttentionLevels         : this.attention_levels_handle.get(),
			GUI                     : this.get_gui_config(),
			CallbackIsAllowed       : $callback.prop("checked") ? 1 : 0,
			LifeTimeAbandonedCalls  : $retain_abandoned.val(),
			LifeTimeAppointmentCalls: $retain_appointment.val(),
			ScreenRecording         : this.__GetScreenRecording(),
			AfterInteractionWork    : this.__GetAfterConversationWork(),
			allowAgentListenContactOnHold: $(this.allowAgentListenContactOnHold).prop("checked") ? 1 : 0,
			//
			incomingConfig          : incoming_config,
			outgoingConfig          : outgoing_config,
			ttsDefaultVoice         : $("#ttsDefaultVoice").val() || "",
			webcallConfig           : webcall_config,
			ActionOnAcdWaitTimeout  : result_th.ActionOnAcdWaitTimeout,
			agentNoAnswerConfig     : agent_noanswer_config,
			didsPool				: result_dids_pool.data,
		};
		this.contact_mng_instance.attach_data( account );
		if (this.flow_mng_instance) {
			this.flow_mng_instance.attach_data( account );
		}
		if (this.qna_maker_mng_instance) {
			this.qna_maker_mng_instance.attach_data(account);
		}
		if (is_enabled_outgoing_config ) {
			// outgoing_config.Blacklists = {
			// 	enabled: true,
			// 	scopes: {}
			// };
			// let blackListId = $("#adm_form_campaign_accounts_call_name").val();
			// outgoing_config.Blacklists.scopes[blackListId] = {isGlogal: false};
			this.blacklists_mng_instance.attach_data(account);
		}
		account_info.account = account;
		account_info.success = true;

		return account_info;
	};

	CallAccountPanel.prototype.has_blacklists = function() {return true;};

	CallAccountPanel.prototype.initialize_blacklists_mng = function()
	{
		const prefix_id = "adm_form_campaign_accounts_call_blacklists_mng";
		// build blacklists management panel
		CallAccountPanel.uber.initialize_blacklists_mng.call(
			this,
			{
				type        : "CALL"              ,
				addressType : "PHONE"             ,
				parent      : this                ,
				frm         : this.parent.frm     ,
				container_id: `${prefix_id}_panel`,
				prefix_id   : prefix_id,
				title       : null,
				//help        : "<%=_T('You can select the blacklists of phone numbers that you will not be able to call.')%>"
			}
		);
	};

	CallAccountPanel.prototype.has_qna_maker = function() {return true;};

	CallAccountPanel.prototype.initialize_qna_maker_mng = function()
	{
		// build qna_maker management panel
		CallAccountPanel.uber.initialize_qna_maker_mng.call(
			this,
			{
				type         : "CALL"                                               ,
				parent       : this                                                 ,
				container_id : "adm_form_campaign_accounts_call_qna_maker_mng_panel",
				prefix_id    : "adm_form_campaign_accounts_call_qna_maker_mng"
			}
		);
	};

	CallAccountPanel.prototype.__GetScreenRecording = function()
	{
		if ( !$(this.screen_recording).prop("checked") ) {
			return 0; // Si ha marcado que no quiere "screen recording"
		}
		// Si ha marcado que quiere "screen recording"
		return $(this.screen_recording_percentage).val();
	};

	CallAccountPanel.prototype.__GetAfterConversationWork = function()
	{
		if ( !$(this.uses_after_conversation_work).prop("checked") ) {
			return 0; // Si ha marcado que no quiere "after conversation work"
		}
		if ( $(this.after_conversation_work_time).val() === "Unlimited" ) {
			return UNLIMITED_VALUE_AFTER_CONVERSATION_WORK; // Si ha marcado que quiere "after conversation work" y ha seleccionado ilimitado
		}
		// Si ha marcado que quiere "after conversation work" y ha seleccionado con un tiempo limitado
		return MS( $(this.after_conversation_work_time_limit).val() );
	};

	CallAccountPanel.prototype.empty_dids_pool = function()
	{
		$(this.dids_receive_callback).prop("checked", false).trigger("change");
		$(this.dids_geographic_prioritization).prop("checked", false).trigger("change");
		this.adm_account_dids_pool_mng.empty_controls();
	};

	CallAccountPanel.prototype.set_dids_pool = function(account)
	{
		const didsPool = account.didsPool || {};
		didsPool.dids = didsPool.dids || [];
		this.adm_account_dids_pool_mng.set(didsPool.dids, account.name);
		if (!didsPool.dids.length)
			return;

		$(this.dids_receive_callback).prop("checked", !!didsPool.callback).trigger("change");
		if (didsPool.callback) {
			$(this.dids_receive_callback_time).val(didsPool.callback.time);
			$(this.dids_receive_callback_time_period).val(didsPool.callback.period);
		}
		$(this.dids_geographic_prioritization).prop("checked", !!didsPool.geographic).trigger("change");
	};

	CallAccountPanel.prototype.validate_dids_pool = function()
	{
		const result = this.adm_account_dids_pool_mng.validate();
		if (!result.success || !result.data.dids.length)
			return result;

		result.data.callback = $(this.dids_receive_callback).prop("checked") ? {} : null;
		if (result.data.callback) {
			result.data.callback.time = parseInt($(this.dids_receive_callback_time).val());
			if (!result.data.callback.time) {
				return {
					success : false,
					$ctrl: $(this.dids_receive_callback_time),
					error_message : "<%=_T('Must enter a DIDs pool callback time')%>"
				};
			}

			result.data.callback.period = $(this.dids_receive_callback_time_period).val();
		}
		result.data.geographic = $(this.dids_geographic_prioritization).prop("checked");
		return result;
	};

	CallAccountPanel.prototype.load = function(callback = $.noop)
	{
		const self = this;
		let pending_requests = 0; // variable que lleva en contador de request pendientes

		var on_complete_request = function() {
			pending_requests--;
			if (pending_requests === 0) {
				callback();
			}
		};

		// 1 - para obtener las SCREEN RECORDING PERCENTAGE e incremento en 1 el contador de request
		const $screen_recording_percentage = $(this.screen_recording_percentage);
		pending_requests++;

		window.setTimeout(function() {
			const rows = [];
			var step = 5;
			var start = step;
			var end = 100;
			for (var i = start; i <= end; i += step) {
				var percentage = i.toString();
				rows.push({
					id: percentage,
					description: percentage + " %"
				});
			}
			// la lleno a la lista de SCREEN RECORDING PERCENTAGE
			self.parent.fill_combo(
				$screen_recording_percentage,
				false, // is_blank_first_item
				rows,
				"id", // id
				"description", // description
				false //sorted
			);
			on_complete_request();
		});

		// 2 - ejecuto para obtener las AFTER CONVERSATION WORK TIME e incremento en 1 el contador de request
		const $after_conversation_work_time = $(this.after_conversation_work_time);
		pending_requests++;

		window.setTimeout(function() {
			const rows = [
				{ id: "TimeLimited", description: "<%=_T('Time limited')%>"  },
				{ id: "Unlimited"  , description: "<%=_T('No time Limit')%>" }
			];
			// la lleno a la lista de AFTER CONVERSATION WORK TIME
			self.parent.fill_combo(
				$after_conversation_work_time,
				false, // is_blank_first_item
				rows,
				"id", // id
				"description", // description
				false //sorted
			);
			on_complete_request();
		});

		// 3 - ejecuto para obtener las AFTER CONVERSATION WORK TIME e incremento en 1 el contador de request
		pending_requests++;
		const from_cache = false;
		inConcert.app.loadPackages("CALL", from_cache, function(success, packages) {
			on_complete_request();
			if (!success) {
				let message = "<%=_T('Error retrieving inconcert telephony packages.')%>";
				let timeout_ms = 5000;
				self.parent.frm.show_status_message(message, "Error", timeout_ms);
				return;
			}
			self.make_html_packages(packages);
		});

		// 3 - para obtener los dids en uso
		pending_requests++;
		inConcert.app.loadAccountDids("CALL", function(success, dids) {
			on_complete_request();
			if (!success) {
				let message = "<%=_T('Error retrieving inconcert telephony dids.')%>";
				let timeout_ms = 5000;
				self.parent.frm.show_status_message(message, "Error", timeout_ms);
				return;
			}
			self.adm_account_dids_pool_mng.set_existing_dids(dids);
		});
	};
}());
