/* jshint forin:true, noarg:true, jquery:true, noempty:true, eqeqeq:true, bitwise:true,
	strict:true, undef:true, unused:vars, curly:false, -W014, browser:true, indent:false, maxerr:50, esversion: 11 */

/* global $, inConcert */

if (!this.inConcert) {
	this.inConcert = {};
}

// try improve namespacing a bit
if ( !this.inConcert.Administration ) {
	this.inConcert.Administration = {};
}

if ( !this.inConcert.Administration.Campaigns ) {
	this.inConcert.Administration.Campaigns = {};
}

(function () {

	"use strict";

	var format = inConcert.Utils.format;

	//---------------------------------------------------------------------
	// frm contact form account edition
	function contact_form_panel(params)
	{
		/* jshint validthis: true*/
		var self = this;
		this.prefix_id = "adm_form_campaign_accounts_contact_form_";
		var success = contact_form_panel.uber.constructor.call(this, params);
		if (!success) {
			return;
		}
		this.panel_type                    = "contactfrm";
		this.container_id                  = "#adm_form_campaign_accounts_contact_form_panel"                            ;
		// controles
		this.name                          = "#adm_form_campaign_accounts_contact_form_name"                             ;
		this.button_id                     = "#adm_form_campaign_accounts_contact_form_button_id"                        ;
		this.distribution                  = "#adm_form_campaign_accounts_contact_form_distribution"                     ;
		this.language                      = "#adm_form_campaign_accounts_contact_form_language"                         ;
		this.priority                      = "#adm_form_campaign_accounts_contact_form_priority"                         ;
		this.always_enabled				   = "#adm_form_campaign_accounts_contact_form_always_enabled"					 ;

		this.tweety_app_name               = "#adm_form_campaign_accounts_contact_form_tweety_app_name"                  ;
		// accounts list
		this.accounts_list                 = "#adm_form_campaign_accounts_contact_form_accounts_list"                    ;
		this.accounts_list_not_found       = "#adm_form_campaign_accounts_contact_form_accounts_list_not_results_found"  ;

		// snippet
		this.snippet_code                  = "#adm_form_campaign_accounts_contact_form_snippet"                          ;
		this.snippet_param_list            = "#adm_form_campaign_accounts_contact_form_snippet_parameters"               ;
		this.snippet_param_new             = "#adm_form_campaign_accounts_contact_form_snippet_new_parameter"            ;
		this.snippet_param_popup           = "#adm_form_campaign_accounts_contact_form_snippet_popup_parameters"         ;
		this.snippet_param_control_id      = "#adm_form_campaign_accounts_contact_form_snippet_param_control_id"         ;
		this.snippet_param_type            = "#adm_form_campaign_accounts_contact_form_snippet_param_type"               ;
		this.snippet_param_alias           = "#adm_form_campaign_accounts_contact_form_snippet_param_alias"              ;
		this.snippet_param_hidden          = "#adm_form_campaign_accounts_contact_form_snippet_param_hidden"             ;
		this.snippet_param_create          = "#adm_form_campaign_accounts_contact_form_snippet_param_create"             ;
		this.snippet_param_create_continue = "#adm_form_campaign_accounts_contact_form_snippet_param_create_and_continue";
		this.snippet_param_cancel          = "#adm_form_campaign_accounts_contact_form_snippet_param_cancel"             ;
		this.snippet_param_message         = "#adm_form_campaign_accounts_contact_form_snippet_popup_message"            ;
		this.snippet_message               = "#adm_form_campaign_accounts_contact_form_snippet_has_changed"              ;

		this.tagline_new      = "<%=_T('New contact form.')%>";
		this.tagline_edit     = "<%=_T('Edit contact form {0}.')%>";
		this.tagline_readonly = "<%=_T('Contact form {0}.')%>";

		this.tweety_contact_form_projects = null;
		this.default_project_id = "ctfrm{5E1E3B54-5ED0-42be-A2C1-FDFEC827199A}";
		this.current_snippet = null;
		this.parameter_editing = null;
		this.snippet_parameters_types =
		{
			ID:     { id: "ID"     , description: "<%=_T('Id')%>"     , has_alias: false } ,
			NAME:   { id: "NAME"   , description: "<%=_T('Name')%>"   , has_alias: false } ,
			PHONE:  { id: "PHONE"  , description: "<%=_T('Phone')%>"  , has_alias: false } ,
			EMAIL:  { id: "EMAIL"  , description: "<%=_T('E-mail')%>" , has_alias: false } ,
			CUSTOM: { id: "CUSTOM" , description: "<%=_T('Custom')%>" , has_alias: true  }
		};

		this.parameters_popup = new inConcert.PopupWindow(
		{
			ownerId: "adm_form_campaign_accounts_contact_form_snippet_popup_parameters", // container id
			eventName: "campaign_accounts_parameters", // evento click personalizado
			callbacks: {
				onClose: function(){
					self.hide_popup_parameters();
				}
			}
		});

		return true;
	}

	inConcert.Utils.inherit( contact_form_panel, inConcert.adm_form_campaigns_section_accounts_base_panel );

	if ( typeof inConcert.Administration.Campaigns.ContactFormAccountPanel !== "function" ) {
		inConcert.Administration.Campaigns.ContactFormAccountPanel = contact_form_panel;
	}

	contact_form_panel.prototype.initialize = function()
	{
		contact_form_panel.uber.initialize.call(this);
		this.current_snippet = null;
		this.generate_token();
		this.fill_parameters_types();
		this.fill_combo_tweety_contact_forms();
		this.disable_tweety_contact_forms();
		this.fill_accounts();
	};

	contact_form_panel.prototype.initialize_thresholds = function()
	{
		// build thresholds panel
		contact_form_panel.uber.initialize_thresholds.call(
			this,
			"WEBCONTACT",
			{
				parent    : this.parent,
				prefix_id : "adm_form_campaign_accounts_contact_form_thresholds"
			}
		);
	};

	contact_form_panel.prototype.initialize_contact_mng = function()
	{
		// build contact management panel
		contact_form_panel.uber.initialize_contact_mng.call(
			this,
			{
				type         : "WEBCONTACT"                                                ,
				parent       : this                                                        ,
				auto_add_type: "BOTH"                                                      , // incoming y outgoing
				container_id : "adm_form_campaign_accounts_contact_form_contact_mng_panel" ,
				prefix_id    : "adm_form_campaign_accounts_contact_form_contact_mng"
			}
		);
	};

	contact_form_panel.prototype.initialize_flows_mng = function()
	{
		// build flows designer management panel
		contact_form_panel.uber.initialize_flows_mng.call(
			this,
			{
				type         : "WEBCONTACT"                                                      ,
				parent       : this                                                              ,
				container_id : "adm_form_campaign_accounts_contact_form_flows_designer_mng_panel",
				prefix_id    : "adm_form_campaign_accounts_contact_form_flows_designer_mng"
			}
		);
	};

	contact_form_panel.prototype.initialize_ticket_emitter = function()
	{
		contact_form_panel.uber.initialize_ticket_emitter.call(
			this,
			{
				type         : "WEBCONTACT",
				parent       : this,
				container_id : "adm_form_campaign_accounts_contact_form_tickets_mng_panel",
				prefix_id    : "adm_form_campaign_accounts_contact_form_tickets_mng"
			}
		);
	};

	contact_form_panel.prototype.initialize_tabs = function()
	{
		// build tabs
		contact_form_panel.uber.initialize_tabs.call(
			this,
			{
				parent       : this                              ,
				frm          : this.parent.frm                   ,
				container_id : "adm_form_campaign_accounts_tabs" ,
				tabs_list    : {
					basic : {
						id               : "basic",
						name             : "<%=_T('Contact Form Config')%>",
						tab_container_id : "adm_form_campaign_accounts_contact_form_panel_tab_basic",
						selected : true
					}
				}
			}
		);
	};

	contact_form_panel.prototype.initialize_skills = function()
	{
		contact_form_panel.uber.initialize_skills.call(
			this,
			{
				container_id : "adm_form_campaign_accounts_contact_form_skills_config",
				parent_frm   : this.parent,
				parent_type  : "FORM-SECTION"
			}
		);
	};

	contact_form_panel.prototype.initialize_attention_levels = function()
	{
		contact_form_panel.uber.initialize_attention_levels.call(
			this,
			{
				container_id : "adm_form_campaign_accounts_contact_form_attention_levels_config",
				parent_frm   : this.parent,
				parent_type  : "FORM-SECTION",
				proxy_type   : "CONTACT_FORM"
			}
		);
	};

	contact_form_panel.prototype.show_accounts_not_results_found = function( message )
	{
		$( this.accounts_list_not_found )
			.text( message || "<%=_T('No accounts found.')%>" )
			.show();
		$( this.accounts_list ).hide();
	};

	contact_form_panel.prototype.hide_accounts_not_results_found = function()
	{
		$( this.accounts_list_not_found ).hide();
		$( this.accounts_list ).show();
	};

	contact_form_panel.prototype.fill_accounts = function()
	{
		var self = this;
		var campaign = this.parent.frm.campaign;
		var html_accounts = "";
		var is_readonly = this.parent.is_readonly();

		var get_account_class = function( account )
		{
			var proxy_type = ( account.proxyType || "" ).toUpperCase();
			return "accountListItemType" + ( ( proxy_type === "MAIL" && account.type === "GMAIL" ) ? "GMAIL" : proxy_type );
		};

		var filter = function( account )
		{
			if ( self.parent.is_account_type( account, "WEBCONTACT" ) ) {
				// si es un contact form, lo excluyo
				return false;
			}
			var excluded_account_types = { "CHAT": true /* los webchat son solo entrantes*/ };
			var proxy = account.proxyType.toUpperCase();
			if (  excluded_account_types[ proxy ] ) {
				return false;
			}
			return true;
		};

		var sorted_accounts = inConcert.Utils.sortArray( campaign.accounts, null, null,
			function( account ) {
				/*return (
						( account.proxyType || "" ) + "_"  +
						( account.name || account.Id || account.id || "" )
				).toUpperCase();*/
				////
				return account.id;
			});

		var added_accounts = 0;
		$.each( sorted_accounts || {}, function(_, account)
		{
			if ( !filter( account ) ) {
				return true; // continue
			}
			added_accounts++;
			var account_id = account.id; //account.Id || account.id; // TODO: ver el tema del id, por que se guarda en 2 attrs.
			var account_desc = campaign.getAccountDescription( account ) || "";

			// seccion accounts
			var acc_campaign_id = "opt_acc_cmp_" + inConcert.Utils.getNormalizedId( account_id );
			html_accounts = html_accounts +
				"<li class='formListItem " + get_account_class( account ) + " accountListItemDisabled' account_id='" + account_id + "' account_proxy='" + account.proxyType + "'>" +

					"<input class='formListCheck" + (is_readonly ? " readonly" : "") + "' id='"  + acc_campaign_id + "' selector='1' type='checkbox' " + (is_readonly ? " disabled='true'" : "") + " />" +
					"<label class='formListTitleText formListCheckOnlyCol'><i class='accountListItemType ml-auto'></i></label>" +
					"<div class='formItemText'>" +
						"<label account_lbl='acc desc' for='" + acc_campaign_id + "'>" + account_desc + "</label>" +
					"</div>" +
					"<i error='true' class='formFieldValidation formFieldError' hidden ></i>" +

					// markup grupo agent
					"<div class='formItemText checkboxImageCol'>" +
						"<div group='agent' class='form-check form-check-only' style='display:none;'>" +
							"<input class='formListRadio" + (is_readonly ? " readonly" : "") + "' id='"  + acc_campaign_id + "_def_account' type='radio' name='default_account' disabled='true' />" +
							// "<label class='form-check-label' for='" + acc_campaign_id + "_def_account'>" + "<%=_T('Default Account')%>" + "</label>" +
						"</div>" +
					"</div>" +
				"</li>";
		});
		// cargo la grilla de accounts
		$( this.accounts_list ).append( html_accounts );

		if ( added_accounts === 0 ) {
			this.show_accounts_not_results_found();
		}
		else {
			this.hide_accounts_not_results_found();
		}
	};

	contact_form_panel.prototype.get_preferred_accounts = function()
	{
		var response = {
			Accounts: [],
			DefaultAccount: null
		};

		// #adm_form_campaign_accounts_contact_form_accounts_list + " bla bla"
		$( this.accounts_list + " input[selector='1'][type='checkbox']").each(function(_, account)
		{
			var $account = $(account);
			var checked = $account.prop("checked");
			if ( checked ) {
				var $parent = $account.parent();
				var account_id = $parent.attr("account_id");
				var account_proxy = $parent.attr("account_proxy");
				response.Accounts.push({
					id    : account_id    ,
					proxy : account_proxy
				});
				if ( response.DefaultAccount === null ) {
					var $default_account = $("#" + $account.attr("id") + "_def_account");
					checked = $default_account.prop("checked");
					if ( checked ) {
						response.DefaultAccount = account_id;
					}
				}
			}
		});

		return response;
	};

	contact_form_panel.prototype.set_preferred_accounts = function( account )
	{
		if ( !account && !account.PreferredAccounts ) {
			return;
		}
		var preferred_accounts = account.PreferredAccounts;
		var default_account = preferred_accounts.DefaultAccount;
		var enabled = true;
		var is_readonly = this.parent.is_readonly();

		$.each( preferred_accounts.Accounts || {}, function( _, preferred_account )
		{
			var preferred_account_id = preferred_account.id;
			var chk_id = "opt_acc_cmp_" + inConcert.Utils.getNormalizedId( preferred_account_id );
			var $checkbox = $("#" + chk_id);
			var $item_list = $checkbox.parent();
			var $label = $item_list.find("label[account_lbl]");

			$label.removeClass("formLabel-ds");
			$item_list.removeClass("accountListItemDisabled");
			$checkbox.prop( "checked", enabled );
			var $default_account = $( "#" + $checkbox.attr("id") + "_def_account" );

			if ( !is_readonly ) {
				$default_account.prop( "disabled", false );
			}
			$default_account.parent().show();
			if ( default_account === preferred_account_id ) {
				$default_account.prop( "checked", enabled );
			}
		});
	};

	contact_form_panel.prototype.disable_tweety_contact_forms = function()
	{
		var disabled, is_required;
		if ( this.parent.is_readonly() || !this.tweety_contact_form_projects || Object.keys( this.tweety_contact_form_projects ).length <= 1 ) {
		/* si solo tiene un elemento en el cbo, es el default y el combo tiene que quedar disabled*/
			disabled = true;
			is_required = false;
		}
		else {
			disabled = false;
			is_required = true;
		}
		this.parent.frm.readonly_control( $( this.tweety_app_name ), disabled, is_required );
	};

	contact_form_panel.prototype.set_tweety_contact_form_projects = function( projects )
	{
		var self = this;
		if ( projects ) {
			this.tweety_contact_form_projects = {};
			this.tweety_contact_form_projects[ this.default_project_id ] = {
				id   : this.default_project_id,
				name : "<%=_T('Default')%>"
			};
			$.each( projects, function( _, project )
			{
				self.tweety_contact_form_projects[project.id] = project;
			});
		}
		else {
			this.tweety_contact_form_projects = null;
		}
	};

	contact_form_panel.prototype.fill_parameters_types = function()
	{
		var $combo = $( this.snippet_param_type );
		var is_blank_first_item = true;
		var attr_id = "id";
		var attr_name = "description";
		var list = this.snippet_parameters_types;
		this.parent.frm.fill_combo( $combo, is_blank_first_item, list, attr_id, attr_name );
	};

	contact_form_panel.prototype.fill_combo_tweety_contact_forms = function()
	{
		var $combo = $( this.tweety_app_name );
		var is_blank_first_item = false;
		var attr_id = "id";
		var attr_name = "name";
		var sorted = true;
		var list = this.tweety_contact_form_projects || {};

		this.parent.frm.fill_combo( $combo, is_blank_first_item, list, attr_id, attr_name, sorted );
	};

	contact_form_panel.prototype.readonly = function()
	{
		contact_form_panel.uber.readonly.call( this );
		// disable actions popup parameters (new, delete, edit)
		this.disable_actions_snippet_parameters(true);
	};

	contact_form_panel.prototype.generate_token = function()
	{
		this.current_token = inConcert.Utils.generateGuid();
		if (!this.is_new()) {
		// esta editando una account existente
			var acc = this.current_account;
			this.current_token = acc.Token ? acc.Token : this.current_token;
		}
	};

	contact_form_panel.prototype.generate_snippet = function()
	{
		// get Webcontact url but strip the protocol
		var webcontact_url = inConcert.app.getWebcontactUrl().match("^http[s]?://(.+)")[1];
		var token = this.current_token;
		var container_id = $(this.button_id).val();
		
		/*
		*	Sample:
		<script type='text/javascript'>
			(function() {
				var proto  = document.location.protocol || 'http:';
				var node   = document.createElement('script');
				node.type  = 'text/javascript';
				node.async = true;
				node.src   = proto +  '//webcontact-i6.inconcert.cc/click_to_contact?token=87CB6FA5D2B34B32212ABD1FDCD7464B&container_id=contactbutton';
				var s = document.getElementsByTagName('script')[0];
				s.parentNode.insertBefore(node, s);
			})();
		</script>
		*/
		var new_url = format(
			"{0}/click_to_contact?token={1}&container_id={2}",
			webcontact_url           , // {0}
			token                    , // {1}
			container_id);             // {2}

		var snippet = "".concat(
			"<script type='text/javascript'>\n",
			"  (function() {\n",
			"    var proto  = document.location.protocol || 'http:';\n",
			"    var node   = document.createElement('script');\n",
			"    node.type  = 'text/javascript';\n",
			"    node.async = true;\n",
			"    node.src   = proto +  '//", new_url, "';\n",
			"    var s = document.getElementsByTagName('script')[0];\n",
			"    s.parentNode.insertBefore(node, s);\n",
			"  })();\n" +
			"</script>\n");

		$(this.snippet_code).val(snippet);

		return snippet;
	};

	contact_form_panel.prototype.has_changed_snippet = function()
	{
		var actual_snippet = $(this.snippet_code).val();
		return this.current_snippet !== actual_snippet;
	};

	contact_form_panel.prototype.show_message_after_save = function(_ /*account*/, callback = $.noop)
	{
		if (this.has_changed_snippet()) {
			var actual_snippet = $(this.snippet_code).val();
			var $snippet_message = $(this.snippet_message);
			$snippet_message.find("textarea").text(actual_snippet);
			$snippet_message
				.off("click", "button")
				.on("click", "button", function() {
					callback();
					$snippet_message.hide();
				});
			$snippet_message.show();
		}
		else {
			callback();
		}
	};

	contact_form_panel.prototype.show = function(account)
	{
		contact_form_panel.uber.show.call(this, account);
	};

	contact_form_panel.prototype.get_account_name = function()
	{
		var acc = this.current_account;
		if (acc.name) {
			return acc.name;
		}
		var uris = acc.url_regexp;
		if ($.isArray(uris) && uris.length > 0) {
			return uris[0];
		}
		return acc.id;
	};

	contact_form_panel.prototype.edit = function(account)
	{
		contact_form_panel.uber.edit.call( this, account );

		if ( !this.current_account ) {
			return;
		}
		var self = this;
		var acc = this.current_account;
		var project_id = acc.TweetyAppName;

		$( this.name ).val( this.get_account_name() );
		$( this.button_id ).val( acc.containerId );
		$ ( this.always_enabled ).prop("checked", !!acc.AlwaysEnabled);
		this.set_tweety_app_name( project_id );
		// los snippet parameters
		$(this.snippet_param_list).find("li[param_data]").remove();
		if (acc.snippet_parameters) {
			$.each(acc.snippet_parameters, function(_, parameter)
			{
				self.add_html_snippet_parameter(parameter.controlId, parameter.type, parameter.alias, parameter.hidden);
			});
			this.disable_actions_snippet_parameters( false );
		}
		// las account seleccionadas y la por default
		this.set_preferred_accounts( acc );
	};

	contact_form_panel.prototype.set_tweety_app_name = function( project_id )
	{
		project_id = project_id || this.default_project_id;
		$( this.tweety_app_name ).val( project_id );
	};

	contact_form_panel.prototype.empty_controls = function()
	{
		contact_form_panel.uber.empty_controls.call( this );
		$( this.name               ).val( "" );
		$( this.button_id          ).val( "" );
		$( this.always_enabled	   ).prop("checked", false);
		this.set_tweety_app_name( /* default */ );
		$( this.snippet_param_list ).find("li[param_data]").remove();
	};

	contact_form_panel.prototype.disable_actions_snippet_parameters = function(disable)
	{
		disable = disable === undefined ? true : disable;

		if (this.parent.is_readonly()) {
			disable = true;
		}

		$(this.snippet_param_new).prop("disabled", disable);
		var $snippet_param_data = $(this.snippet_param_list).find("li[param_data]");
		// boton edit de la lista de parametros
		$snippet_param_data.find("button[action_edit]").prop("disabled", disable);
		// boton delete de la lista de parametros
		$snippet_param_data.find("button[action_del]").prop("disabled", disable);
	};

	contact_form_panel.prototype.show_popup_parameters = function()
	{
		$(this.snippet_param_message).hide();
		this.parameters_popup.show();
		// disable actions popup parameters (new, delete, edit)
		this.disable_actions_snippet_parameters(true);

		var control_id = "", type_id = "", alias = "", hidden = false;
		if (!this.parameter_editing) {
		// si presione el boton para crear uno nuevo
			$(this.snippet_param_create).val("<%=_T('Create')%>");
			$(this.snippet_param_create_continue).show();
		}
		else {
		// si presione el boton para editar
			$(this.snippet_param_create).val("<%=_T('Update')%>");
			$(this.snippet_param_create_continue).hide();
			control_id = this.parameter_editing.find("label[param_control_id='true']").text();
			type_id = this.parameter_editing.find("label[param_type='true']").attr("type_id");
			var type = this.snippet_parameters_types[type_id];
			if (type) {
				var $alias = this.parameter_editing.find("label[param_alias='true']");
				alias = $alias.text();
			}
			hidden = this.parameter_editing.attr("is_hidden") === "true";
		}

		$(this.snippet_param_type).val(type_id).change();
		$(this.snippet_param_alias).val(alias);
		$(this.snippet_param_hidden).prop("checked", hidden);
		$(this.snippet_param_control_id).focus().val(control_id);
	};

	contact_form_panel.prototype.hide_popup_parameters = function()
	{
		$(this.snippet_param_popup).hide();
		// enable actions popup parameters (new, delete, edit)
		this.disable_actions_snippet_parameters(false);
	};

	contact_form_panel.prototype.add_html_snippet_parameter = function(control_id, type_id, alias, hidden)
	{
		if (typeof control_id !== "string" || typeof type_id !== "string") {
			return;
		}
		var type = this.snippet_parameters_types[type_id];
		var unique_id = control_id.trim().toLowerCase();
		alias = alias || "";

		$(this.snippet_param_list).append(
			"<li param_data='true' class='formListItem' is_hidden='" + (hidden? "true" : "false") + "' >" +
				"<label param_control_id='true' class='formItemText nameColumn' unique_id='" + unique_id + "'>" + control_id  + "</label>" +
				"<label param_type='true' class='formItemText valueColumn' type_id='" + type.id + "'>" + type.description + "</label>" +
				"<label param_alias='true' class='formItemText valueColumn'>" + alias + "</label>" +
				"<button action_edit='true' class='buttonColorGray gridActionButton edit' disabled='true'><i class='far fa-pencil'></i>" + "<%=_T('Edit')%>" + "</button>"+
				"<button action_del='true' class='buttonColorGray gridActionButton last' disabled='true'><i class='far fa-trash-alt'></i>" + "<%=_T('Delete')%>" + "</button>"+
			"</li>");
	};

	contact_form_panel.prototype.validate_snippet_parameter = function(control_id, type, alias)
	{
		var self = this;

		var show_error = function(message, $control)
		{
			$(self.snippet_param_message).text(message).show();
			if ($control) {
				$control.focus();
			}
		};

		var message;
		if (control_id.trim().length === 0) {
			// valida que el control_id tenga al menos un caracter
			message = "<%=_T('Parameter control id is required')%>";
			show_error(message, $(this.snippet_param_control_id));
			return false;
		}

		if (!type) {
			// valida que hayan seleccionado un tipo en el combo
			message = "<%=_T('Parameter type is required')%>";
			show_error(message, $(this.snippet_param_alias));
			return false;
		}

		if (type.has_alias) {
			if (alias.trim().length === 0) {
				// valida que el alias tenga al menos un caracter
				message = "<%=_T('Parameter display name is required')%>";
				show_error(message, $(this.snippet_param_alias));
				return false;
			}
		}

		var unique_id = control_id.trim().toLowerCase();
		var already_exist = function()
		{
			var current_param = $(self.snippet_param_list).find("li[param_data] label[param_control_id='true'][unique_id='" + unique_id + "']");
			var len = current_param.length;
			if (len > 0) {
				message = format("<%=_T('Already exist parameter control id {0}.')%>", control_id);
				show_error(message, $(self.snippet_param_control_id));
				return true;
			}
			return false;
		};

		if (!this.parameter_editing) {
			// si es un paramerto nuevo valida que el mismo ya no exista en la lista
			if (already_exist()) {
				return false;
			}
		}
		else {
			var actual_name = this.parameter_editing.find("[param_control_id='true']").text();
			actual_name = actual_name.trim().toLowerCase();
			if (actual_name !== unique_id) {
			// si es name del paramerto ha cambiado valido que el nuevo nombre ya no exista en la lista
				if (already_exist()) {
					return false;
				}
			}
		}

		// validation successfully
		return true;
	};

	contact_form_panel.prototype.add_or_update_snippet_parameter = function(has_continue)
	{
		$(this.snippet_param_message).hide();
		var control_id = $(this.snippet_param_control_id).val();
		var type_id = $(this.snippet_param_type).val();
		var type = this.snippet_parameters_types[type_id];
		var	alias = $(this.snippet_param_alias).val();
		var hidden = $(this.snippet_param_hidden).prop("checked");

		// validate snippet parameters
		if (!this.validate_snippet_parameter(control_id, type, alias)) {
			return;
		}

		if (!this.parameter_editing) {
		// add new parameter
			this.add_html_snippet_parameter(control_id, type.id, alias, hidden);
		}
		else {
		// update actual parameter
			// control id
			var $parameter_control_id = this.parameter_editing.find("[param_control_id='true']");
			$parameter_control_id.attr("unique_id", control_id);
			$parameter_control_id.text(control_id);
			// combo type
			var $parameter_type = $(this.parameter_editing.find("[param_type='true']"));
			$parameter_type.attr("type_id", type.id);
			$parameter_type.text(type.description);
			// alias
			var $parameter_alias = $(this.parameter_editing.find("[param_alias='true']"));
			$parameter_alias.text(alias);
			//hidden
			this.parameter_editing.attr("is_hidden", hidden? "true" : "false");
		}

		$(this.snippet_param_type).val("").change();
		$(this.snippet_param_alias).val("");
		$(this.snippet_param_control_id).val("");
		$(this.snippet_param_hidden).prop("checked", false);

		if (!has_continue) {
			this.hide_popup_parameters();
			return;
		}
		$(this.snippet_param_control_id).focus();
	};

	contact_form_panel.prototype.set_events_popup_parameters = function()
	{
		var self = this;

		// boton new que abre el popup para poder agregar un nuevo parametro
		$(this.snippet_param_new)
			.off("click")
			.on("click", function() {
				self.parameter_editing = null;
				self.show_popup_parameters();
			});

		// boton create parameter
		$(this.snippet_param_create)
			.off("click")
			.on("click", function() {
				var has_continue = false;
				self.add_or_update_snippet_parameter(has_continue);
			});

		// boton create & continue parameter
		$(this.snippet_param_create_continue)
			.off("click")
			.on("click", function() {
				var has_continue = true;
				self.add_or_update_snippet_parameter(has_continue);
			});

		// boton que cancela la creacion del parametro
		$(this.snippet_param_cancel)
			.off("click")
			.on("click", function() {
				self.hide_popup_parameters();
			});

		// change en el combo de type en el popup
		$(this.snippet_param_type)
			.off("change")
			.on("change", function() {
				var type_id = $(this).val();
				var type = self.snippet_parameters_types[type_id];
				var $alias = $(self.snippet_param_alias);

				var $alias_lbl = $alias.parent().find("label[for='adm_form_campaign_accounts_contact_form_snippet_param_alias']");
				if (type && type.has_alias) {
					$alias.prop("disabled", false).removeClass("readonly");
					$alias_lbl
						// .removeClass("formLabel-ds")
						.addClass("required");
				}
				else {
					$alias.prop("disabled", true).addClass("readonly");
					$alias_lbl
						.removeClass("required");
						// .addClass("formLabel-ds");
				}

				$alias.val("").focus();
			});

		var $snippet_param = $(this.snippet_param_list);
		// boton edit de la lista de parametros
		var event_selector = "li[param_data='true'] button[action_edit='true']";
		$snippet_param
			.off("click", event_selector)
			.on("click", event_selector, function()
			{
				self.parameter_editing = $(this).parent();
				self.show_popup_parameters();
			});

		// boton delete de la lista de parametros
		event_selector = "li[param_data='true'] button[action_del='true']";
		$snippet_param
			.off("click", event_selector)
			.on("click", event_selector, function()
			{
				var $parameter = $(this).parent();
				var message = format(
					"<%=_T('Do you want to delete parameter control id {0} type {1} ?')%>",
					$parameter.find("[param_control_id='true']").text(),
					$parameter.find("[param_type='true']").text()
				);
				$.inconcertPopup.Show(
					"<%=_T('Confirm')%>",
					message,
					jQuery.inconcertPopup.ButtonSets.BS_YESNO,
					function(response) {
						if (response.toLowerCase() !== "yes") {
							return;
						}
						$parameter.fadeOut("slow", function() {
							$parameter.remove();
							self.generate_snippet();
						});
					},
					undefined,
					{
						popup_id        : "conf_inconcertPopup",
						container_class : "confirmationPopUp",
						overlay_class   : "confirmationOverlay"
					}
				);
			});
	};

	contact_form_panel.prototype.set_events = function()
	{
		contact_form_panel.uber.set_events.call( this );

		if ( this.parent.is_readonly() ) {
			return;
		}

		var self = this;
		// input element id de la page
		$(this.button_id)
			.off("keyup")
			.on("keyup", function() {
				self.generate_snippet();
			});

		// evento de los checkbox del panel account (habilita los options de default account)
		var event_selector = "input[selector='1'][type='checkbox']";
		$( this.accounts_list )
			.off("click", event_selector)
			.on("click", event_selector, function() {
				var $this = $( this );
				var $item_list = $this.parent();
				var $label = $item_list.find("label[account_lbl]");

				var checked = $this.prop("checked");
				var $default_account = $("#" + $this.attr("id") + "_def_account");
				if ( checked ) {
					$default_account
						.prop("disabled", false)
						.focus();
					$default_account.parent().show();
					$item_list.removeClass("accountListItemDisabled");
					$label.removeClass("formLabel-ds");
				}
				else {
					$default_account
						.prop("disabled", true)
						.prop("checked", false);
					$default_account.parent().hide();
					$item_list.addClass("accountListItemDisabled");
					$label.addClass("formLabel-ds");
				}
			});

		// snippet events
		this.set_events_popup_parameters();
	};

	contact_form_panel.prototype.on_hide = function()
	{
		contact_form_panel.uber.on_hide.call( this );

		if ( ! this.tweety_contact_form_projects ) {
			return;
		}
		$.each( this.tweety_contact_form_projects, function ( _, data )
		{
			if ( data && data.info ) {
				data.info = null;
			}
		});
	};

	contact_form_panel.prototype.on_show = function()
	{
		contact_form_panel.uber.on_show.call( this );
		this.current_snippet = this.generate_snippet();
		this.hide_popup_parameters();
		$(this.name).focus();
	};

	contact_form_panel.prototype.on_saved = function(new_account, current_account, callback = $.noop)
	{
		contact_form_panel.uber.on_saved.call(this, new_account, current_account, callback);

		var self = this;
		var project_id = new_account.TweetyAppName;
		var token = new_account.Token;
		// si estoy actualizando una account y no se ha cambiado de proyecto de tweety, no actualizo el authfilter
		if ( current_account &&
			( current_account.TweetyAppName === project_id && current_account.Token === token ) ) {
			return;
		}
		var tweety = inConcert.app.getTweetyAPI();

		return tweety.set_authfilter( project_id, token,
			function( success )
			{
				if ( !success ) {
					var error_message = "<%=_T('Error setting auth filter to web desginer.')%>";
					var timeout_ms = 5000;
					self.parent.frm.show_status_message(error_message, "Error", timeout_ms);
				}
			}
		);
	};

	contact_form_panel.prototype.validate = function()
	{
		var self = this;

		var is_new = this.is_new();
		var account_info = {
			success: false,
			account: null,
			is_new:  is_new,
			error_message: null
		};

		this.hide_marked_errors(); // oculto todos los errores de los campos

		// NAME - validation
		var $name = $(this.name);
		if (!this.validate_field($name, "required", "<%=_T('Account name is required.')%>")) {
			return account_info;
		}
		if (!this.validate_field($name, "alpha", "<%=_T('Only letters, numbers, dashes and dots are allowed in the Account Name.')%>")) {
			return account_info;
		}

		// DISTRIBUTION - validation
		var $distribution = $(this.distribution);
		if (!this.validate_field($distribution, "required", "<%=_T('Distribution is required.')%>")) {
			return account_info;
		}

		// PRIORITY - validation
		var $priority = $(this.priority);
		var has_att_levels = this.attention_levels_handle.count_selected() > 0;
		if (!has_att_levels && $priority.val().trim().length > 0) {
			var range = { between: { from: 0, to: 99} }; // range attention_level value validation
			if (!this.validate_field($priority, "range", format("<%=_T('Account priority value out of range. Please enter account priority value between {0} and {1}.')%>", range.between.from, range.between.to ), range )) {
				return account_info;
			}
		}

		// valido los skills ----------
		var result_skills = this.validate_skills();
		if ( !result_skills.success ) {
			this.show_validation_error( result_skills.$ctrl, result_skills.message );
			return account_info;
		}

		// LANGUAGE - validation
		var $language = $(this.language);
		if (!this.validate_field($language, "required", "<%=_T('Language is required.')%>")) {
			return account_info;
		}

		// tweety app name - validation
		var $tweety_app_name = $( this.tweety_app_name );
		if (!this.validate_field( $tweety_app_name, "required", "<%=_T('Contact form name is required.')%>" ) ) {
			return account_info;
		}

		// START BUTTON - validation
		var $button_id = $(this.button_id);
		if (!this.validate_field($button_id, "required", "<%=_T('Start Button Id is required.')%>")) {
			return account_info;
		}
		if (!this.validate_field($button_id, "html_element_id", "<%=_T('Only letters, numbers, dashes and dots are allowed in the Start Button Id.')%>")) {
			return account_info;
		}

		// valido los attention levels ----------
		var result_attention_levels = this.validate_attention_levels();
		if ( !result_attention_levels.success ) {
			this.show_validation_error(
				result_attention_levels.$ctrl,
				result_attention_levels.message,
				false, //timeout_ms
				true, //scrolling
				result_attention_levels.show_custom_button
			);
			return account_info;
		}

		// valido la configuracion de tickets
		var result_ticket_emitter = this.validate_ticket_emitter();
		if (!result_ticket_emitter.success) {
			this.show_validation_error( result_ticket_emitter.$ctrl, result_ticket_emitter.error_message );
			return account_info;
		}

		// valido los contact mng ----------
		var result_contact_mng = this.validate_contact_mng();
		if ( !result_contact_mng.success ) {
			this.show_validation_error( result_contact_mng.$ctrl, result_contact_mng.error_message );
			return account_info;
		}

		// valido los flows mng ----------
		var result_flows_mng = this.validate_flows_mng();
		if ( !result_flows_mng.success ) {
			this.show_validation_error( result_flows_mng.$ctrl, result_flows_mng.error_message );
			return account_info;
		}

		// valido los thresholds ----------
		var result_th = this.validate_thresholds();
		if ( !result_th.success ) {
			this.show_validation_error( result_th.$ctrl, result_th.error_message );
			return account_info;
		}

		//------------------------------------------------------
		// paso la validacion correctamente, ahora a guardar!!!
		var name = $name.val();
		var account = {};
		if (is_new) {
			var campaign = this.parent.frm.campaign;
			// Builds an ID for this new account, in the form PROXYTYPE_<campaign.Id>_<account name>
			account.id = "WEBCONTACT_" + campaign.Id + "_" + name;
		}
		else {
			account.id = this.current_account.id;
		}

		account.proxyType       = "WEBCONTACT";
		account.name            = name;
		account.uid             = name;
		account.containerId     = $button_id.val();
		account.CCAlgorithm     = $distribution.val();
		account.language        = $language.val();
		account.AlwaysEnabled	= $(this.always_enabled).is(":checked");
		account.TweetyAppName   = $tweety_app_name.val();
		account.Token           = this.current_token;
		account.TicketEmitter   = result_ticket_emitter.result;
		account.Skills          = this.skills_handle.get();
		account.Priority        = $priority.val();
		account.AttentionLevels = this.attention_levels_handle.get();
		account.GUI                = this.get_gui_config();
		account.ActionOnAcdWaitTimeout = result_th.ActionOnAcdWaitTimeout;

		this.contact_mng_instance.attach_data( account );
		if (this.flow_mng_instance) {
			this.flow_mng_instance.attach_data( account );
		}

		account.snippet_parameters = [];
		// carga la lista de snippet parameters
		$(this.snippet_param_list).find("li[param_data]").each(function(_, param_data)
		{
			var $param_data  = $(param_data);

			var new_parameter = {
				controlId  : $param_data.find("label[param_control_id]").text(),
				type       : $param_data.find("label[param_type]").attr("type_id")
			};
			if ($param_data.attr("is_hidden") === "true") {
				new_parameter.hidden = true;
			}
			var type = self.snippet_parameters_types[new_parameter.type];
			if (type && type.has_alias) {
				new_parameter.alias = $param_data.find("label[param_alias]").text();
			}

			account.snippet_parameters.push(new_parameter);
		});

		// accounts preferidas y por default
		account.PreferredAccounts = this.get_preferred_accounts();

		account_info.account = account;
		account_info.success = true;

		return account_info;
	};

}());
