/* jshint forin:true, noarg:true, jquery:true, noempty:true, eqeqeq:true, bitwise:true,
	strict:true, undef:true, unused:vars, curly:true, browser:true, indent:false, maxerr:50, quotmark:false, esversion: 11*/

/* global inConcert, Mustache */

if (!this.inConcert) {
	this.inConcert = {};
}

(function () {
	//"use strict";
	
	var format = inConcert.Utils.format;
	var templates =  {
		base : ('').concat(

			'<div id="{{ popup_id }}" class="internalPopUpContainer pageMessengerPopUp popUpFullHeight formPopUp popUp1300w" hidden>',
				'<div class="internalPopUpOverlay"></div>',
				'<div class="internalPopUp">',
					// waiting
					'<div popup_loading class="popupWaitingContainer">',
						'<div popup_loading_label class="internalWaitingMessage">',
							"<%=_T('Loading bot configuration')%>...",
						'</div>',
						'<div class="popupWaitingAnimation"></div>',
						'<div class="popupWaitingOverlay"></div>',
					'</div>',

					// title
					'<div class="internalPopUpTitle">',
						'<span>',
							"<%=_T('Messenger bot')%>",
							'<span class="messengerPageName">',
								'{{ name }}',
							'</span>',
						'</span>',
						
						'<button cancel_button class="internalPopUpCloseButton"><i class="far fa-times"></i></button>',
					'</div>',

					'<div popup_form class="internalPopUpMiddle pageFormContainer" hidden>',
						
						// mensaje de error
						'<div popup_error class="genericFormMessagesContainer messageError" hidden style="display:none;">',
							'<label popup_error_label class="messageText"></label>',
						'</div>',

						// content
						'<div class="card no-card">',
							'<div class="card-block">',
								'<div class="row">',
									'<div class="col-12">',
										'<div class="formTabsMainContainer">',
											'<div id="page_messenger_tabs">',
											'</div>',
				
											'<div id="page_messenger_tabs_configuration"  class="formTabsBody" hidden >',
											'</div>',
			
										'</div>',
									'</div>',
								'</div>',
							'</div>',
						'</div>',

					'</div>',

					// MODAL FOOTER BUTTONS
					'<div class="internalPopUpButtons">',
						"<button cancel_button class='pageButtonGeneric buttonColorWhite float-right'>" + "<%=_T('Cancel')%>" + "</button>",
						"<button restore_button class='pageButtonGeneric buttonColorWhite float-right'>" + "<%=_T('Restore to Defaults')%>" + "</button>",
						"<button update_button class='pageButtonGeneric buttonColorBlue float-right'>" + "<%=_T('Confirm')%>" + "</button>",
					'</div>',

				'</div>',
			'</div>'
		),
		global_configuration: ('').concat(
			'<div>',
			'</div>'
		),
		process_flow: ('').concat(
			'<div class="row">',
				'<div class="col-6">',
					'<div class="form-group">',
						'<label for="{{ guid }}_process_flow">',
							"<%=_T('Process Flow')%>:",
						'</label>',
						'<select control="process_flow" id="{{ guid }}_process_flow" class="form-control">',
						'</select>',
						'<i validation="process_flow" class="formFieldValidation formFieldError" style="display: none;"></i>',
					'</div>',	
				'</div>',
				'<div class="col-4 d-flex flex-row">',
					'<div class="form-group flex-grow-1 mr-2 w-100 position-relative">',
						'<label control_label="process_flow_inactivity_time" for="{{ guid }}_process_flow_inactivity_time">', "<%=_T('Inactivity Time')%>", ' <span disclaimer="process_flow_inactivity_time" class="fa fa-question-circle" title="', "<%=_T('The interaction will be closed if the customer does not respond during the configured idle time (maximum: 24 hours).')%>",' "></span> </label>',
						
						'<input control="process_flow_inactivity_time" id="{{ guid }}_process_flow_inactivity_time" class="form-control" type="text">',
						'<i validation="process_flow_inactivity_time" class="formFieldValidation formFieldError" style="display: none;"></i>',
					'</div>',	
					'<div class="form-group flex-grow-1 w-100 align-self-end">',
						'<select control="process_flow_inactivity_time_unit" id="{{ guid }}_process_flow_inactivity_time_unit" class="form-control">',
							'<option value="minutes"><%=_T("Minutes")%></option>',
							'<option value="hours"><%=_T("Hours")%></option>',
						'</select>',
					'</div>',			
				'</div>',
			'</div>',
			'<hr />',
		),
		ice_breakers: ('').concat(
			'<div>',

				'<div class="row">',
					'<div class="col-12">',
						'<div class="card-header d-flex flex-row justify-content-between">',
							'<h5>', "<%=_T('Ice breakers questions')%>", ' <span class="fa fa-question-circle" title="', "<%=_T('Ice breakers questions provide a way for users to start a conversation with a business with a list of up to 4 frequently asked questions.')%>",' "></span> </h5>',

							'<div class="d-flex align-items-start pt-1 align-self-start mb-4">',
								'<button new_ice_breaker class="pageButtonGeneric buttonColorWhite pageButtonNew"> <i class="far fa-plus"> </i>', "<%=_T('Add Question')%>", '</button>',
							'</div>',
						'</div>',
					'</div>',
				'</div>',

				'<div class="row">',
					'<div class="col-12">',
						'<ul ice_breaker_list class="formList formListAsGrid mt-0">',
							'<li class="formListTitle">',
								'<label class="formListTitleText nameColumn">',
									"<%=_T('Question')%>",
								'</label>',
								'<label class="formListTitleText nameColumn">',
									"<%=_T('Payload')%>",
								'</label>',
								'<label class="gridAction2ButtonCol"></label>',
							'</li>',
						'</ul>',
					'</div>',
				'</div>',




			'</div>'
		),
		ice_breaker_row: ('').concat(
			'<li ice_breaker_row locale="{{ question }}" text="{{ text }}" class="formListItem">',
				'<label class="formItemText nameColumn">',
					'{{ question }}',
				'</label>',
				'<label class="formItemText nameColumn">',
					'{{ payload }}',
				'</label>',
				'<button ice_breaker_action="edit" class="buttonColorGray gridActionButton chatbotConfigEdit">',
					'<i class="buttons-icons-edit"></i>',
				'</button>',
				'<button ice_breaker_action="delete" class="buttonColorGray gridActionButton chatbotConfigDelete last">',
					'<i class="buttons-icons-delete"></i>',
				'</button>',
				'<i validation class="formFieldValidation formFieldError" style="display: none;"></i>',
			'</li>'
		),
		ice_breaker_form: ('').concat(
			'<div id="adm_form_campaign_page_messenger_popup_ice_breaker" class="internalPopUpContainer formPopUp popUp520w pageMessengerPersistentMenuPopUp" hidden>',
				'<div class="internalPopUpOverlay"></div>',
				'<div class="internalPopUp">',

					// title
					'<div class="internalPopUpTitle">',
						'<label>', 
							// "<%=_T('Messenger bot')%>", 
							// '<span class="messengerPageName">',
							// '{{ main_title }}',
							// '</span>',
							"<%=_T('Ice breaker question')%>", 
						'</label>',
						'<button ice_breaker_cancel_button class="internalPopUpCloseButton"><i class="far fa-times"></i></button>',
					'</div>',

					'<div ice_breaker_popup_form class="internalPopUpMiddle pageFormContainer">',

						// mensaje de error
						'<div popup_error class="genericFormMessagesContainer messageError" hidden style="display:none;">',
							'<label popup_error_label class="messageText"></label>',
						'</div>',

						// form
						'<div class="card">' ,
							'<div class="card-block">' ,
								'<div class="row">',
									'<div class="col-12">',
										'<div class="form-group">',
											'<label for="{{ guid }}_question" class="required">',
												"<%=_T('Question')%>:",
											'</label>',
											'<input control="question" id="{{ guid }}_question" class="form-control" type="text">',
											'<i validation="question" class="formFieldValidation formFieldError" style="display: none;"></i>',
										'</div>',
									'</div>',
								'</div>',
								'<div class="row">',
									'<div class="col-12">',
										'<div class="form-group">',
											'<label for="{{ guid }}_payload" class="required">',
												"<%=_T('Payload')%>:",
											'</label>',
											'<input control="payload" id="{{ guid }}_payload" class="form-control" type="text">',
											'<i validation="payload" class="formFieldValidation formFieldError" style="display: none;"></i>',
										'</div>',
									'</div>',
								'</div>',
							'</div>',
						'</div>',
					'</div>',

					// MODAL FOOTER BUTTONS
					'<div class="internalPopUpButtons">' ,
					'<button ice_breaker_cancel_button class="pageButtonGeneric buttonColorWhite float-right"><%=_T("Cancel")%> </button>',
						'<button ice_breaker_update_button class="pageButtonGeneric buttonColorBlue float-right"><%=_T("Confirm")%> </button>',
					'</div>' ,

				'</div>',
			'</div>'
		)
	};

	function PageMessengerInstagramAdministration(parent, pageId, pageName, accessToken, data, onSave) {
		this.parent = parent;
		this.pageId = pageId;
		this.pageName = pageName;
		this.accessToken = accessToken;
		this.data = data || {};
		this.onSave = onSave || $.noop;
	}

	if (typeof inConcert.PageMessengerInstagramAdministration !== "function") {
		inConcert.PageMessengerInstagramAdministration = PageMessengerInstagramAdministration;
	}
	
	PageMessengerInstagramAdministration.prototype.Show = function(callback) {
		callback = callback || $.noop;
		var self = this;
		self.__make();
		$("body").append(self.$container);
		self.popup = new inConcert.PopupWindow();
		self.popup.show({
			ownerId         : self.__getPopupId(),
			eventName       : self.__getPopupId(),
			canReposition   : true,
			closeOnFocusLost: false,
			overlay         : true,
			container       : self.$container,
			callbacks: {
				onOpen: function() {
					self.$container.show();
				},
				onClose: function( callback ) {
					callback = callback || $.noop;
					if (self.popup) {
						self.popup.hide(function() {
							callback();
						});
					}
					else {
						callback();
					}
				}
			}
		});
		self.__loadForm(function() {
			self.__afterAppendBody();
			callback();
		});
	};
	
	PageMessengerInstagramAdministration.prototype.Close = function(callback) {
		callback = callback || $.noop;
		var self = this;
		if (self.IsProcessing()) {
			return;
		}
		if (self.popup && self.popup.isVisible()) {
			self.popup.finalize(function() {
				self.popup = null;
				self.$container.remove();
				callback();
			});
		}
		else {
			self.$container.remove();
			callback();
		}
	};
	
	PageMessengerInstagramAdministration.prototype.RestoreDefaults = function() {
		var self = this;
		if (self.IsProcessing()) {
			return;
		}
		self.__clearErrors();
		
		function doAction() {
			self.__restoreForm();
			self.__save();
		}
		
		$.inconcertPopup.Show(
			"<%=_T('Confirmation')%>",
			"<%=_T('Do you want to restore default settings?')%>",
			$.inconcertPopup.ButtonSets.BS_YESNO,
			function(response) {
				if (response.toLowerCase() === "yes") {
					doAction();
				}
			},
			undefined,
			{
				popup_id        : "conf_inconcertPopup",
				container_class : "confirmationPopUp",
				overlay_class   : "confirmationOverlay"
			}
		);
	};
	
	PageMessengerInstagramAdministration.prototype.__restoreForm = function() {
		this.__restoreProcessFlow();
		this.__restoreIceBreaker();
	};
	
	PageMessengerInstagramAdministration.prototype.__save = function(callback) {
		var self = this;
		callback = callback || $.noop;
		
		var data = {};
		var fbData = {};
		self.__validateProcessFlow(data, fbData);
		self.__validateIceBreaker(data, fbData);
		
		if (data.error) {
			self.__showError(data.error);
			return callback(false);
		}
		
		self.__processing(true);
		self.__updateFbData(fbData, function(error) {
			self.__processing(false);
			if (!error) {
				self.onSave(self.pageId, data);
			}
			else {
				self.__showError(error);
			}
			callback(!error);
		});
	};
	
	PageMessengerInstagramAdministration.prototype.Save = function() {
		var self = this;
		if (self.IsProcessing()) {
			return;
		}
		self.__clearErrors();
		
		self.__save(function(status) {
			if (status) {
				self.Close();
			}
		});
	};
	
	PageMessengerInstagramAdministration.prototype.__updateFbData = function(data, callback) {
		callback = callback || $.noop;
		var self = this;
		var dataToUpdate = {};
		var dataToDelete = [];
		$.each(data, function(id, property) {
			if (property && !$.isEmptyObject(property)) {
				dataToUpdate[id] = property;
			}
			else {
				dataToDelete.push(id);
			}
		});
		
		function updateProperties(callback) {
			if ($.isEmptyObject(dataToUpdate)) {
				return callback();
			}
			self.parent.update_messenger_profile(self.accessToken, dataToUpdate, function(status, error) {
				callback(status? null : format("<%=_T('Error updating {0} properties: {1}.')%> ", self.parent.current_account.proxyType.toLowerCase(), error || ""));
			});
		}
		
		function deleteProperties(callback) {
			if (!dataToDelete.length) {
				return callback();
			}
			self.parent.delete_messenger_profile(self.accessToken, dataToDelete, function(status, error) {
				callback(status? null : format("<%=_T('Error deleting {0} properties: {1}.')%> ", self.parent.current_account.proxyType.toLowerCase(), error || ""));
			});
		}
		
		deleteProperties(function(errorDeleting) {
			updateProperties(function(errorUpdating) {
				var error = "" + (errorDeleting || "") + (errorUpdating || "");
				callback(error);
			});
		});
	};
	
	PageMessengerInstagramAdministration.prototype.IsProcessing = function() {
		return !!this.processing;
	};

	PageMessengerInstagramAdministration.prototype.__processing = function(processing, text) {
		this.processing = !!processing;
		this.$container.find("[popup_loading_label]").text(text || "<%=_T('Updating bot configuration')%>...");
		this.$container.find("[popup_loading]").toggle(this.processing);
	};

	PageMessengerInstagramAdministration.prototype.__clearErrors = function($container) {
		$container = $container || this.$container;
		$container.find("[validation], [popup_error]").hide();
		$container.find("[popup_error_label]").text("");
	};

	PageMessengerInstagramAdministration.prototype.__showError = function(error, $container) {
		var root = !$container;
		$container = $container || this.$container;
		if (typeof error === "string") {
			error = { message : error };
		}
		$container.find("[popup_error]").show();
		$container.find("[popup_error_label]").text(error.message);
		if (error.control) {
			$container.find(format("[validation={0}]", error.control)).show();
		}
		else if (error.$control) {
			error.$control.find("[validation]:first").show();
		}
		$container.find(".internalPopUpMiddle").scrollTop(0);
		if (root) {
			this.tabs.switch_tab("configuration");
		}
	};
	
	PageMessengerInstagramAdministration.prototype.__make = function() {
		var self = this;
		self.$container = $(Mustache.render(templates.base, {
			name : self.pageName,
			popup_id : self.__getPopupId()
		}));
		self.$container.find("[update_button]")
			.click(function() {
				self.Save();
			})
			.prop("disabled", true);
		self.$container.find("[cancel_button]").click(function() {
			self.Close();
		});
		self.$container.find("[restore_button]").click(function() {
			self.RestoreDefaults();
		});
	};
	
	PageMessengerInstagramAdministration.prototype.__getPopupId = function() {
		return "adm_form_campaign_page_messenger_popup";
	};
	
	PageMessengerInstagramAdministration.prototype.__enableDisableNewQuestion = function() {
		var questions = this.$container.find("[ice_breaker_row]").length;
		if(questions >= 4)
		{
			this.$container.find("[new_ice_breaker]").prop("disabled", true);
		}
		else
		{
			this.$container.find("[new_ice_breaker]").prop("disabled", false);
		}
	};

	PageMessengerInstagramAdministration.prototype.__afterAppendBody = function() {
		this.__enableDisableNewQuestion();
	};
	
	PageMessengerInstagramAdministration.prototype.__loadProcessFlows = function(callback) {
		callback = callback || $.noop;
		var self = this;
		var proxyTypeBot = this.parent.current_account.proxyType + "_BOT";
		var flowAPI = inConcert.app.getFlowDesignerAPI();
		flowAPI.loadFlowsByType({ proxyType : proxyTypeBot}, function(success, flows) {
			if (success) {
				self.processFlows = flows;
				callback();
			}
			else {
				callback("<%=_T('Error loading process flows.')%>");
			}
		});
	};
	
	PageMessengerInstagramAdministration.prototype.__loadFacebookData = function(callback) {
		callback = callback || $.noop;
		var self = this;
		self.parent.get_messenger_profile(self.accessToken, function(data, error) {
			if (data) {
				self.fbData = data;
				callback();
			}
			else {
				callback(format("<%=_T('Error loading {0} profile. Please try to reauthorize app.')%> - {1}", self.parent.current_account.proxyType.toLowerCase(), error || ""));
			}
		});
	};
	
	PageMessengerInstagramAdministration.prototype.__loadForm = function(callback) {
		callback = callback || $.noop;
		var self = this;
		//load flows
		self.__loadProcessFlows(function(error) {
			if (error) {
				self.__processing(false);
				self.$container.find("[popup_form]").show();
				return self.__showError(error);
			}
			//load fb data
			self.__loadFacebookData(function(error) {
				if (error) {
					self.__processing(false);
					self.$container.find("[popup_form]").show();
					return self.__showError(error);
				}
				//make form
				self.__makeForm();
				callback();
			});
		});
	};
	
	PageMessengerInstagramAdministration.prototype.__makeForm = function() {
		var self = this;
		var $form = self.$container.find("[popup_form]");
		//configuration
		var $configuration = $form.find("#page_messenger_tabs_configuration");
		var $globalConfiguration = $(templates.global_configuration);
		$configuration.append($globalConfiguration);
		$globalConfiguration.append(self.__makeProcessFlow());
		self.__loadProcessFlowStates();
		$configuration.append(self.__makeIceBreaker());
		//tabs
		this.tabs = new inConcert.conf_form_tab({
			parent       : this,
			container_id : "page_messenger_tabs",
			tabs_list    : {
				configuration : {
					id               : "configuration",
					name             : "<%=_T('Configuration')%>",
					tab_container_id : "page_messenger_tabs_configuration",
					selected         : true,
					initial_state    : "enabled"
				}
			}
		});
		this.tabs.show_tabs_container();
		//show form
		self.__processing(false);
		self.$container.find("[update_button]").prop("disabled", false);
		$form.show();
	};
	
	PageMessengerInstagramAdministration.prototype.__loadProcessFlowStates = function() {
		var self = this;
		var flowId = self.$container.find("[control=process_flow]").val();
		var flow = flowId && self.processFlows[flowId] || null;
		//form
		self.$container.find("[control_label=process_flow_inactivity_time]")
			.toggleClass("formLabel-ds", !flow)
			.toggleClass("formLabel-rq", !!flow);
		self.$container.find("[control=process_flow_inactivity_time]").prop("disabled", !flow);
		self.$container.find("[control=process_flow_inactivity_time_unit]").prop("disabled", !flow);
		self.$container.find("[disclaimer=process_flow_inactivity_time]").toggle(!!flow);
		//states
		self.states = {};
		self.states_byName = {};
		self.states_a = [];
		if (flow) {
			$.each(flow.Draw.states, function(id, state) {
				id  = "state_" + id;
				var stateData = {
					id : id,
					name : state.name,
					description : state.description
				};
				self.states[id] = stateData;
				self.states_byName[state.name] = stateData;
				self.states_a.push(stateData);
			});
		}
		self.states_a.sort(function(a, b) {
			return a.name.localeCompare(b.name);
		});
		self.states_o = "<option value=''></option>";
		$.each(self.states_a, function(_, state) {
			self.states_o += format("<option value='{0}' title={1}'>{2}</option>",
				state.id, state.description, state.name);
		});
	};
	
	PageMessengerInstagramAdministration.prototype.__getStateFromPayload = function(payload) {
		if (!payload) {
			return null;
		}
		var sections = payload.split(":");
		if (sections.length < 4 || sections[0] !== "state") {
			return null;
		}
		var stateId = sections[1];
		var stateName = sections[2];
		if (this.states[stateId]) {
			return stateId;
		}
		return this.states_byName[stateName]? this.states_byName[stateName].id : null;
	};
	
	PageMessengerInstagramAdministration.prototype.__showPopup = function(parentId) {
		$("#" + (parentId || this.__getPopupId())).addClass("withChildPopup");
	};
	
	PageMessengerInstagramAdministration.prototype.__closePopup = function(parentId) {
		$("#" + (parentId || this.__getPopupId())).removeClass("withChildPopup");
	};
	
	
//process flow
	PageMessengerInstagramAdministration.prototype.__makeProcessFlow = function() {
		var self = this;
		var $container = $(Mustache.render(templates.process_flow, {
			guid : inConcert.Utils.generateGuid()
		}));
		//load options
		var options_a = self.processFlows;
		self.processFlows = {};
		options_a.sort(function(a, b) {
			return a.Name.localeCompare(b.Name);
		});
		var options_s = "<option value=''>---<%=_T('Without process')%>---</option>";
		$.each(options_a, function(_, option) {
			options_s += format("<option value='{0}' title={1}'>{2}</option>",
				option.Id, option.Description, option.Name);
			self.processFlows[option.Id] = option;
		});
		$container.find("[control=process_flow]")
			.html(options_s)
			.change(function() {
				self.__loadProcessFlowStates();
			})
			.val(self.data.processFlow || "");
		var inactivityUnit = self.data.inactivityTimeUnit || "minutes";
		var inactivityTime = self.data.inactivityTimeSeconds || 30 * 60;
		$container.find("[control=process_flow_inactivity_time_unit]").val(inactivityUnit);
		switch(inactivityUnit) {
			case "minutes":
					$container.find("[control=process_flow_inactivity_time]").val(inactivityTime / 60);
					break;
				case "hours":
					$container.find("[control=process_flow_inactivity_time]").val(inactivityTime / 60 / 60);
					break;
		}
		return $container;
	};
	
	PageMessengerInstagramAdministration.prototype.__validateProcessFlow = function(data/*, fbData*/) {
		var self = this;
		data.processFlow = self.$container.find("[control=process_flow]").val() || null;
		if (data.processFlow) {
			var inactivityTime = parseInt(self.$container.find("[control=process_flow_inactivity_time]").val());
			data.inactivityTimeUnit = self.$container.find("[control=process_flow_inactivity_time_unit]").val();
			switch(data.inactivityTimeUnit) {
				case "minutes":
					data.inactivityTimeSeconds = inactivityTime * 60;
					break;
				case "hours":
					data.inactivityTimeSeconds = inactivityTime * 60 * 60;
					break;
			}
			if (!data.inactivityTimeSeconds || data.inactivityTimeSeconds < 0 || data.inactivityTimeSeconds > 24 * 60 * 60) {
				data.error = data.error = {
					control : "process_flow_inactivity_time",
					message : "<%=_T('Inactivity time must be a number and less than 24 hours.')%>"
				};
			}
		}
	};
	
	PageMessengerInstagramAdministration.prototype.__restoreProcessFlow = function() {
		this.$container.find("[control=process_flow]")
			.val("")
			.change();
	};
	
//ice breaker
	PageMessengerInstagramAdministration.prototype.__makeIceBreaker = function() {
		var self = this;
		var $container = $(templates.ice_breakers);
		var $rows = [];
		var rows = self.fbData.ice_breakers || [];
		rows.sort(function(a, b) {
			return a.question.localeCompare(b.question);
		});
		$.each(rows, function(_, row) {
			$rows.push(self.__makeIceBreakerRow(row));
		});
		
		$container.find("[ice_breaker_list]").append($rows);
		$container.find("[new_ice_breaker]").click(function() {
			self.__newIceBreaker();
		});
		return $container;
	};
	
	PageMessengerInstagramAdministration.prototype.__validateIceBreakerRow = function(data) {
		var error = "";
		if(!data.question) {
			return "<%=_T('Ice breaker question cant be empty.')%>";
		}
		if(!data.payload) {
			return "<%=_T('Ice breaker payload cant be empty.')%>";
		}
		return error;
	};
	
	PageMessengerInstagramAdministration.prototype.__makeIceBreakerRow = function(data) {
		var self = this;
		var $row = $(Mustache.render(templates.ice_breaker_row, {
			question : data.question,
			payload : data.payload
		}));		
		if (self.__validateIceBreakerRow(data)) {
			$row.addClass("invalidRow");
		}
		$row.attr("question", data.question);
		$row.attr("payload", data.payload);
		$row.data("call_to_actions", data.call_to_actions);
		$row.find("[ice_breaker_action=edit]").click(function() {
			if ($("#adm_form_campaign_page_messenger_popup_ice_breaker").length) {
				return;
			}
			self.__editIceBreaker(self.__getIceBreakerRowData($(this).closest("[ice_breaker_row]")));
		});
		$row.dblclick(function() {
			if ($("#adm_form_campaign_page_messenger_popup_ice_breaker").length) {
				return;
			}
			self.__editIceBreaker(self.__getIceBreakerRowData($(this)));
		});
		$row.find("[ice_breaker_action=delete]").click(function() {
			var data = self.__getIceBreakerRowData($(this).closest("[ice_breaker_row]"));
			$.inconcertPopup.Show(
				"<%=_T('Confirmation')%>",
				"<%=_T('Do you want to delete ice breaker question?')%>",
				$.inconcertPopup.ButtonSets.BS_YESNO,
				function(response) {
					if (response.toLowerCase() === "yes") {
						self.__removeIceBreakerRow(data);
					}
				},
				undefined,
				{
					popup_id        : "conf_inconcertPopup",
					container_class : "confirmationPopUp",
					overlay_class   : "confirmationOverlay"
				}
			);
		});
		return $row;
	};
	
	PageMessengerInstagramAdministration.prototype.__addIceBreakerRow = function(data) {
		var self = this;
		var $row = self.__makeIceBreakerRow(data);
		self.$container.find("[ice_breaker_list]").append($row);
		this.__enableDisableNewQuestion();
	};
	
	PageMessengerInstagramAdministration.prototype.__removeIceBreakerRow = function(data) {
		this.$container.find(format("[ice_breaker_row][question='{0}']", data.question)).remove();
		this.__enableDisableNewQuestion();
	};
	
	PageMessengerInstagramAdministration.prototype.__getIceBreakerRowData = function($row) {
		return {
			question : $row.attr("question"),
			payload : $row.attr("payload")
		};
	};
	
	PageMessengerInstagramAdministration.prototype.__newIceBreaker = function(data) {
		this.__showIceBreakerPopup(data || {}, true);
	};
	
	PageMessengerInstagramAdministration.prototype.__editIceBreaker = function(data) {
		this.__showIceBreakerPopup(data, false);
	};
	
	PageMessengerInstagramAdministration.prototype.__showIceBreakerPopup = function(data, isNew) {
		var self = this;
		self.iceBreakerIsNew = isNew;
		self.iceBreakerOriginal = data;
		self.__makeIceBreakerPopup(data);
		$("body").append(self.$iceBreakerContainer);
		self.iceBreakerPopup = new inConcert.PopupWindow();
		self.iceBreakerPopup.show({
			ownerId         : self.__getIceBreakerPopupId(),
			eventName       : self.__getIceBreakerPopupId(),
			canReposition   : true,
			closeOnFocusLost: false,
			overlay         : true,
			container       : self.$iceBreakerContainer,
			callbacks: {
				onOpen: function() {
					self.__showPopup();
					self.$iceBreakerContainer.show();
				},
				onClose: function( callback ) {
					callback = callback || $.noop;
					if (self.iceBreakerPopup) {
						self.iceBreakerPopup.hide(function() {
							callback();
						});
					}
					else {
						callback();
					}
				}
			}
		});
		self.__afterAppendIceBreakerBody();
	};
	
	PageMessengerInstagramAdministration.prototype.__getIceBreakerPopupId = function() {
		return "adm_form_campaign_page_messenger_popup_ice_breaker";
	};
	
	PageMessengerInstagramAdministration.prototype.__makeIceBreakerPopup = function(data) {
		var self = this;
		self.$iceBreakerContainer = $(Mustache.render(templates.ice_breaker_form, {
			main_title : self.pageName,
			guid : inConcert.Utils.generateGuid()
		}));
		
		self.$iceBreakerContainer.find("[control=question]").val(data.question);
		self.$iceBreakerContainer.find("[control=payload]").val(data.payload);

		self.$iceBreakerContainer.find("[ice_breaker_update_button]").click(function() {
			self.__saveIceBreaker();
		});
		self.$iceBreakerContainer.find("[ice_breaker_cancel_button]").click(function() {
			self.__closeIceBreakerPopup();
		});
	};
	
	PageMessengerInstagramAdministration.prototype.__addIceBreakerButton = function($list, data) {
		$list.append(this.__makeIceBreakerButton(data));
	};
	
	PageMessengerInstagramAdministration.prototype.__updateIceBreakerButton = function($button, data) {
		$button.find("[button_title]").text(data.title);
		$button.find("[button_subtitle]").text(data.url);
		$button.attr("class", "formListItem persistentMenuButton " + data.type + "Button");
		$button.data("data", data);
		$button.find("[button_list_container]").remove();
		$button.find("[add_button]").remove();
	};
	
	PageMessengerInstagramAdministration.prototype.__afterAppendIceBreakerBody = function() {
		
	};
	
	PageMessengerInstagramAdministration.prototype.__closeIceBreakerPopup = function() {
		var self = this;
		self.__closePopup();
		if (self.iceBreakerPopup && self.iceBreakerPopup.isVisible()) {
			self.iceBreakerPopup.finalize(function() {
				self.iceBreakerPopup = null;
				self.$iceBreakerContainer.remove();
			});
		}
		else {
			self.$iceBreakerContainer.remove();
		}
	};
	
	PageMessengerInstagramAdministration.prototype.__saveIceBreaker = function() {
		this.__clearErrors(this.$iceBreakerContainer);
		var data = {};
		data.question = this.$iceBreakerContainer.find("[control=question]").val();
		data.payload = this.$iceBreakerContainer.find("[control=payload]").val();
		var error = this.__validateIceBreakerRow(data);
		if (error) {
			this.__showError(error, this.$iceBreakerContainer);
			return;
		}
		if (!this.iceBreakerIsNew) {
			this.__removeIceBreakerRow(this.iceBreakerOriginal);
		}
		this.__addIceBreakerRow(data);
		this.__closeIceBreakerPopup();
	};
	
	PageMessengerInstagramAdministration.prototype.__validateIceBreaker = function(data, fbData) {
		const self = this;
		fbData.ice_breakers = [];
		this.$container.find("[ice_breaker_row]").each(function() {
			let rowData = self.__getIceBreakerRowData($(this));
			let error = self.__validateIceBreakerRow(rowData);
			if (error) {
				data.error = {
					message : error,
					$control : $(this)
				};
				return false;
			}
			fbData.ice_breakers.push(rowData);
		});
	};

	PageMessengerInstagramAdministration.prototype.__restoreIceBreaker = function() {
		this.$container.find("[ice_breaker_row]").remove();
	};
}());