local oo = require "loop.base"
require "inconcert.translators"

local models = require("apps.agent.model"):GetModels()

local m_moduleLocation = select(2, ...)

module(..., package.seeall, inconcert.orbit.application.Decorate)

m_htmlRender = nil

function MapUris(module, htmlRender, prefix)

	local LogRequest = require("apps.agent.requestFilters").LogRequest
	
	module:dispatch_get(  LogRequest .. GetAutoAttendant, prefix.."/get/([^/]+)/(.*)")
	module:dispatch_post( LogRequest .. SaveAutoAttendant, prefix.."/save/(.*)")
	
	m_htmlRender = htmlRender
end


function GetAutoAttendant(web, addressId, addressType)
	web.headers["Content-Type"] = "application/json"
	
	local vcc = inconcert.authUser.virtualContactCenter
	local name = inconcert.authUser.userName
	
	LogInfo("User %s on vcc %s retriving auto attendant %s of type %s", name, vcc, addressId, addressType)

	local autoAttendant = models["AutoAttendant"].Get(addressId, addressType) or {}
	return json.encode(autoAttendant)
end

function SaveAutoAttendant(web)
	web.headers["Content-Type"] = "application/json"
	local vcc = inconcert.authUser.virtualContactCenter
	local name = inconcert.authUser.userName

	local postedData = web.input["post_data"]
	local autoAttendant = json.decode(postedData)

	LogInfo("User %s on vcc %s saving auto attendantposted info %s", name, vcc, postedData)
	local saved = models["AutoAttendant"].Save(autoAttendant)
	if not saved then
		LogError("Unable to save auto attendant for campaign %s", campaignId)
	end
	return json.encode({result = saved})

end

