local oo = require "loop.base"
local dateClass = require "LuaOrm.Date"
require "LuaOrm.Mapper"
require "inconcert.translators"
local jsonEncoder = require "LuaOrm.Serializers.Json"
local rpairs = LuaOrm.Associations.AssociationArray.Iterator
local models = require("apps.agent.model"):GetModels()
local m_moduleLocation = select(2, ...)

module(..., package.seeall, inconcert.orbit.application.Decorate)

m_htmlRender = nil

local function GetAllStates (web)
	local _T = m_htmlRender.extension.makeTextTranslator()
	local vcc = inconcert.authUser.virtualContactCenter
	local name = inconcert.authUser.userName

	LogInfo("[STATES:GetAllStates] Retrieving available states %s on vcc %s", name, vcc)

	local agentStates = models.AgentStates.FindAll(vcc)
	for stateId, state in pairs(agentStates) do
		state.DescriptionLabel = _T(state.Description or "")
		state.ShortMessageLabel = _T(state.ShortMessage or "")
	end

	web.headers["Content-Type"] = "application/json"
	return json.encode(agentStates)
end

function MapUris(module, htmlRender, prefix)
	local LogRequest = require("apps.agent.requestFilters").LogRequest
	module:dispatch_get( LogRequest .. GetAllStates, prefix.."/find_all/([^.]*)")
	m_htmlRender = htmlRender
end