module(..., package.seeall)

-- Receives a string.
-- If the string is of the form 'id@VCC' (with VCC containing no @), returns (id, VCC). 
-- Else, returns the string.
function SeparateVCC(s)
	local a, b = s:match("^(.+)@([^@]+)$")
	return (a or s), b
end

-- Receives a string and a VCC. If the string is of the form 'id@VCC', the '@VCC' part is removed.
-- Returns the modified string.
function StripVCC(s, VCC)
	local strippedID, strippedVCC = SeparateVCC(s)
	return strippedVCC == VCC and strippedID or s
end

-- Receives a string and a VCC. If the string is NOT of the form 'id@VCC', the '@VCC' part is added.
-- Returns the modified string.
function AddVCC(s, VCC)
	return StripVCC(s, VCC).."@"..VCC
end


