local Filter = require "nozzle"

module(..., package.seeall)

LogRequest = Filter{
	input = function(self, web, ...)
		LogInfo("Begin request with id: '%s' for url: '%s'", web.vars.HTTP_X_ICC_RID, web.path_info)
		web.time = os.time(os.date("!*t"))
	end,
	output = function(self, web, ...)
		local actualTime = os.time(os.date("!*t"))
		local initTime = web.time or 0
		local totalTimeSec = actualTime - initTime
		local ACCEPTABLE_TIME_SEC = 20
		if totalTimeSec < ACCEPTABLE_TIME_SEC then
			LogInfo("Finished request with id: '%s', %s, status %s, Total Time: %s seconds", web.vars.HTTP_X_ICC_RID, web.path_info, web.status, totalTimeSec)
		else
			LogWarning("Finished request with id: '%s', %s, status %s, Total Time: %s seconds. ATTENTION: The request time has exceeded %s seconds !!", web.vars.HTTP_X_ICC_RID, web.path_info, web.status, totalTimeSec, ACCEPTABLE_TIME_SEC)
		end
		return ...
	end
}