/*jshint browser:true, quotmark:false, smarttabs:true, esversion: 11*/
/*global inConcert, $*/

/*
	Funcion que es invocada en el archivo "loginForm_common.js"
*/
function CheckIfLoginRetryNeeded (response) {
	return false;
}

/*
	Funcion que es invocada en el archivo "loginForm_common.js"
*/
function DoLogin (params) {
	//required params
	let username = params.username;
	let password = params.password;
	let vcc = params.vcc;
	let userAtVCC = username + "@" + vcc;
	//optional params
	let domain = params.domain || "";
	let data = params.data || null;
	let info = params.info;
	let autoLogin = params.autoLogin || false;
	let mustChangePassword = params.mustChangePassword || false;
	let newPassword = params.newPassword;
	let callback = params.callback || $.noop;
	let mfaCallback = params.mfaCallback || $.noop;
	//call authenticator login
	inConcert.InconcertAuth.login({
		domain : domain,
		userAtVCC : userAtVCC,
		password : password,
		mustChangePassword : mustChangePassword,
		newPassword : newPassword,
		data : data,
		info : info,
		autoLogin : autoLogin,
		callback : function(result, data){
			callback(result, data);
		},
		mfaCallback : function(mfa, finalStepFn) {
			mfaCallback(mfa, finalStepFn);
		}
	});
}

function GetAuthToken(params) {
	//required params
	let username = params.username;
	let vcc = params.vcc;
	let userAtVCC = username + "@" + vcc;
	//optional params
	let domain = params.domain || "";
	let data = params.data || null;
	let callback = params.callback || $.noop;
	let mfaCallback = params.mfaCallback || $.noop;
	//call authenticator GetAuthToken
	inConcert.InconcertAuth.GetAuthToken({
		domain : domain,
		userAtVCC : userAtVCC,
		data : data,
		callback : function(result, data){
			callback(result, data);
		},
		mfaCallback : function(mfa, finalStepFn) {
			mfaCallback(mfa, finalStepFn);
		}
	});
}
