/* jshint forin:true, noarg:true, jquery:true, noempty:true, eqeqeq:true, bitwise:true,
	strict:true, undef:true, unused:vars, curly:true, browser:true, indent:false, maxerr:50, quotmark:false, esversion: 9 */

	(function() {

		"use strict";
	
		var BUTTON_SET = { BS_OK:0, BS_YESNO:1, BS_OKCANCEL:2, BS_ABORTRETRY:3, BS_SAVECLOSE:4, BS_YESNOCANCEL:5, BS_SAVEEXIT:6 };
	
		/**
		Private: Creates the buttons as childs of the given node.
		*/
		function CreateButtons(node, buttonset, customButtons) {
			switch (buttonset) {
	
				case BUTTON_SET.BS_OK:
					node.append("<input id='popupOk' type='submit' class='popupButtonOk buttonColorBlack' value='" + "<%=_T('Ok')%>" + "' key='Ok' />");
					break;
	
				case BUTTON_SET.BS_YESNO:
					node.append("<input id='popupYes' type='submit' class='popupButtonOk buttonColorBlack' value='" + "<%=_T('Yes')%>" + "' key='Yes' />");
					node.append("<input id='popupNo' type='submit' class='popupButtonCancel buttonColorGray' value='" + "<%=_T('No')%>" + "' key='No' />");
					break;
	
				case BUTTON_SET.BS_YESNOCANCEL:
					node.append("<input id='popupYes' type='submit' class='popupButtonOk buttonColorBlack' value='" + "<%=_T('Yes')%>" + "' key='Yes' />");
					node.append("<input id='popupNo' type='submit' class='popupButtonCancel buttonColorGray' value='" + "<%=_T('No')%>" + "' key='No' />");
					node.append("<input id='popupCancel' type='submit' class='popupButtonCancel buttonColorGray' value='" + "<%=_T('Cancel')%>" + "' key='Cancel' />");
					break;
	
				case BUTTON_SET.BS_OKCANCEL:
					node.append("<input id='popupOkCancel-Ok' type='submit' class='popupButtonOk buttonColorBlack' value='" + "<%=_T('Ok')%>" + "' key='Ok' />");
					node.append("<input id='popupOkCancel-Cancel' type='submit' class='popupButtonCancel buttonColorGray' value='" + "<%=_T('Cancel')%>" + "' key='Cancel' />");
					break;
	
				case BUTTON_SET.BS_ABORTRETRY:
					node.append("<input id='popupRetry' type='submit' class='popupButtonOk buttonColorBlack' value='" + "<%=_T('Retry')%>" + "' key='Retry' />");
					node.append("<input id='popupAbort' type='submit' class='popupButtonCancel buttonColorGray' value='" + "<%=_T('Abort')%>" + "' key='Abort' />");
					break;
	
				case BUTTON_SET.BS_SAVECLOSE:
					node.append("<input id='popupSave' type='submit' class='popupButtonCancel pageButtonGeneric buttonColorOrange pageButtonNew' value='" + "<%=_T('Save')%>" + "' key='Save' />");
					node.append("<input id='popupClose' type='submit' class='popupButtonCancel pageButtonGeneric buttonColorWhite pageButtonNew' value='" + "<%=_T('Not Save')%>" + "' key='Close' />");
					node.append("<input id='popupCancel' type='submit' class='popupButtonCancel pageButtonGeneric buttonColorWhite pageButtonNew' value='" + "<%=_T('Cancel')%>" + "' key='Cancel' />");
					break;
	
				case BUTTON_SET.BS_SAVECANCEL:
					node.append("<input id='popupSave' type='submit' class='popupButtonOk buttonColorBlack' value='" + "<%=_T('Save')%>" + "' key='Save' />");
					node.append("<input id='popupCancel' type='submit' class='popupButtonCancel buttonColorGray' value='" + "<%=_T('Cancel')%>" + "' key='Cancel' />");
					break;
	
				case BUTTON_SET.BS_SAVEEXIT:
					node.append("<input id='popupClose' type='submit' class='pageButtonGeneric buttonColorWhite' value='" + "<%=_T('Do not save and close')%>" + "' key='Close' />");				
					node.append("<input id='popupSave' type='submit' class='pageButtonGeneric buttonColorBlue' value='" + "<%=_T('Save')%>" + "' key='Save' />");
					break;
			}
	
			if(typeof(customButtons) !== "undefined") {
				for(var i = 0; i < customButtons.length; i++) {
					var button = customButtons[i];
					var newButton = $('<input type="submit" class="' + (button.className === undefined ? 'popupButtonOk' : button.className) + '" ' +
						'value="' + (button.label === undefined ? '' : button.label) + '" />');
					if(typeof(button.onClick) === "function") {
						newButton.click(button.onClick);
					}
					node.append(newButton);
				}
			}
		}
	
		/**
		Private: Creates the popup itself
		*/
		function CreatePopupContent(node, buttonset, customButtons, close_cross_icon) {
			//creo botones
			node.append('<div class="inconcertPopupWindow"></div');
			var $child = node.find('.inconcertPopupWindow');
			if (close_cross_icon) 
				// $child.append('<div class="generalPopUpTop"><div class="popUpTitle clearfix"></div><div close_cross_icon id="popupClose" class="closeBtn" key="Close"><i class="far fa-times"></i></div></div>');
				$child.append('<div class="generalPopUpTop"><div class="popUpTitle clearfix"></div><button close_button_icon id="popupCancel" class="internalPopUpCloseButton" key="Cancel"><i class="far fa-times"></i></button></div>');
			else
				$child.append('<div class="generalPopUpTop"><div class="popUpTitle clearfix"></div></div>');
			$child.append('<div class="generalPopUpMiddle"></div');
			node.find('.generalPopUpMiddle').append('<p class="inconcertPopupMessage">');
			$child.append('<div class="generalPopUpBottom"></div');
			CreateButtons(node.find('.generalPopUpBottom'), buttonset, customButtons);
		}
	
		/**
		Public: Creates a MessageBox with the given title, message, set of buttons, an optional callback and an optional array of custom buttons.
		Each button is an object with the following properties:
			- className: the css class it will have
			- label: the caption
			- onClick: a function callback
		*/
		function MessageBox(title, msg, buttonset, callback, customButtons, custom_values, close_cross_icon)
		{
			var popup_id = "inconcertPopup";
			var container_class = "skinOCCNew";
			var overlay_class = "";
	
			if (typeof custom_values === "object") {
				if (typeof custom_values.popup_id === "string") {
					popup_id = custom_values.popup_id;
				}
				if (typeof custom_values.container_class === "string") {
					container_class = container_class + " " + custom_values.container_class;
				}
				if (typeof custom_values.overlay_class === "string") {
					overlay_class = " " + custom_values.overlay_class;
				}
			}
			var jquery_popup_id = '#' + popup_id;
			if ($(jquery_popup_id).length) {
				$(jquery_popup_id).html('');
				CreatePopupContent($(jquery_popup_id), buttonset, customButtons, close_cross_icon);
			}
			else {
				$('body').append('<div class="inconcertPopup ' + container_class + '" id="' + popup_id + '"></div>');
				CreatePopupContent($(jquery_popup_id), buttonset, customButtons, close_cross_icon);
				$(jquery_popup_id).jqm({overlay: 75, modal: true, trigger: false, overlayClass: 'inconcertPopupOverlay' + overlay_class});
			}
			var message = (msg === undefined ? '' : msg);
			var messageTitle = (title === undefined ? '' : title);
	
			$(jquery_popup_id)
				.jqmShow()
				.find('p.inconcertPopupMessage')
					.html(message)
				.end()
				.find('.popUpTitle')
					.html(messageTitle)
				.end()
				.find(':submit:visible, [close_button_icon]')
					.click(function(){
						if (callback) {
							var key = jQuery("#" + this.id).attr("key");
							callback(key);
						}
						$(jquery_popup_id).jqmHide();
					});
		}
		
		async function MessageBoxReceiveAndResponse(title, msg, buttonset, customButtons, custom_values, close_cross_icon)
		{
			return new Promise((resolve, _reject) => {
				const callback = (response) => resolve(response);
				MessageBox(title, msg, buttonset, callback, customButtons, custom_values, close_cross_icon);
			});
		}

		jQuery.inconcertPopup = {};
		jQuery.inconcertPopup.Show = MessageBox;
		jQuery.inconcertPopup.ShowAndReceiveResponse = MessageBoxReceiveAndResponse;
		jQuery.inconcertPopup.ButtonSets = BUTTON_SET;
	
	})(jQuery);