/* jshint forin:true, noarg:true, jquery:true, noempty:true, eqeqeq:true, bitwise:true,
	strict:true, undef:true, unused:vars, curly:true, browser:true, indent:false, maxerr:50, esversion: 11 */

/* global $, inConcert, _ */

if (!this.inConcert) {
	this.inConcert = {};
}

(function () {

//	"use strict";

	const FORMAT = inConcert.Utils.format;

	//===================================================================================================
	//===================================================================================================
	/**
	Class transfer base.
	@param params
	*/
	function transfer_base ( params )
	{
		this.parent = params.parent;
		this.$tab_container = undefined;
		this.selected_item_id = null;
		this.jquery_txt_search_selector = "input[txt_search='true']";
		this.total_rows = 0;
		this.total_message_one  = "<%=_T('{0} row.')%>";  // el por defecto
		this.total_message_many = "<%=_T('{0} rows.')%>"; // el por defecto
		this.load_fn = null;
		this.is_loaded = false;
		this.m_has_allegro_integration = inConcert.app.has_allegro_integration();
	}

	/*******************************************************************
	* Metodo que xxx
	*/
	transfer_base.prototype.initialize = function()
	{
		var initializing = false;
		var result = this.is_enabled();
		if ( result.enabled ) {
			initializing = true;
		}
		else {
			this.disable( result.reason );
		}
		this.set_events();
		return initializing;
	};

	/*******************************************************************
	* Metodo que xxx
	*/
	transfer_base.prototype.disable = function()
	{
		var $tab_container = this.$get_tab_container();
		var $search = $tab_container.find(this.jquery_txt_search_selector);
		this.hide_list( "<%=_T('Transfer Disabled')%>" );
		$search.prop("disabled", true);
	};

	transfer_base.prototype.enable = function()
	{
		var $tab_container = this.$get_tab_container();
		var $search = $tab_container.find(this.jquery_txt_search_selector);
		this.show_list();
		$search.prop("disabled", false).focus();
	};

	/*******************************************************************
	* Metodo que xxx
	*/
	transfer_base.prototype.is_enabled = function()
	{
		return { enabled : true };
	};

	/*******************************************************************
	* Metodo que xxx
	*/
	transfer_base.prototype.is_visible = function()
	{
		return { visible : true };
	};

	/*******************************************************************
	* Metodo que xxx
	* @param callback
	*/
	transfer_base.prototype.load = function( callback )
	{
		var interactions = this.parent.data.interactions;
		if ( !this.load_fn ) {
			throw "transfer_base.load - this.load_fn is required!!";
		}
		callback = callback || $.noop;
		var interactions_ids = _.pluck( interactions , "id");
		this.load_fn( interactions_ids, callback );
	};

	/*******************************************************************
	* Metodo que xxx
	* @param callback
	*/
	transfer_base.prototype.on_finish_load = function( callback )
	{
		callback = callback || $.noop;
		this.is_loaded = true;
		this.set_totals();
		if ( this.total_rows === 0 ) {
			this.disable();
		}
		else {
			this.enable();
		}
		this.parent.hide_waiting();
		callback();
	};

	/*******************************************************************
	* Metodo que xxx
	*/
	transfer_base.prototype.on_switch_tab = function()
	{
		this.parent.enable_disable_transfer();
		var $tab_container = this.$get_tab_container();
		$tab_container.find(this.jquery_txt_search_selector).focus();
		//this.parent.setPosition();
	};

	/*******************************************************************
	* Metodo que xxx
	* @param id
	*/
	transfer_base.prototype.get_radio_dom_id = function( id )
	{
		return this.prefix_radio_id + inConcert.Utils.getNormalizedId(id);
	};

	/*******************************************************************
	* Metodo que xxx
	*/
	transfer_base.prototype.$get_tab_container = function()
	{
		if ( !this.$tab_container ) {
			this.$tab_container = this.parent.data.container.find(this.jquery_tab_selector);
		}
		return this.$tab_container;
	};

	transfer_base.prototype.get_selected_item_id = function()
	{
		return this.selected_item_id;
	};

	transfer_base.prototype.make_detail = function() { return false; };

	transfer_base.prototype.show_detail = function()
	{
		var $detail_list = this.$get_tab_container().find("[detail_list='true']");
		if ( !$detail_list || $detail_list.length === 0 ) {
			return;
		}
		if ( !this.selected_item_id ) {
			$detail_list.html("");
			return;
		}
		var $item_container = $("#" + this.selected_item_id).parent();
		if ( !$item_container.is(":visible") ) {
			$detail_list.html("");
			return;
		}
		var item_data = $item_container.data("row");
		if ( !item_data ) {
			$detail_list.html("");
			return;
		}
		if ( !this.make_detail(item_data) ) {
			$detail_list.html("");
		}
	};

	/*******************************************************************
	* Metodo que xxx
	*/
	transfer_base.prototype.on_selected_item = function( $new_selected_item /* radio buttom */ )
	{
		if ( this.selected_item_id !== null ) {
			$("#" + this.selected_item_id).parent().removeClass("selected");
		}
		this.selected_item_id = $new_selected_item.attr("for");
		const $transfer_to = $("#" + this.selected_item_id);
		$transfer_to.prop("checked", true).parent().addClass("selected");

		let transfer_to = $transfer_to.attr("transfer_to");
		const $tab_container = this.$get_tab_container();
		$tab_container.find(this.jquery_txt_search_selector).val(transfer_to);

		this.show_detail();
		this.parent.enable_transfer();
	};

	/*******************************************************************
	* Metodo que xxx
	*/
	transfer_base.prototype.set_events = function()
	{
		var self = this;
		var $tab_container = this.$get_tab_container();

		// click en la row del item
		$tab_container
			.off("click", this.jquery_item_selector)
			.on("click", this.jquery_item_selector, function () {
				self.on_selected_item($(this));
			});
		// dbl click en la row del item
		$tab_container
			.off("dblclick", this.jquery_item_selector)
			.on("dblclick", this.jquery_item_selector, function () {
				const $this = $(this);
				self.parent.transfer_conversations($this);
			});

		var search = function(text, $txt) {
			var callback = function() {
				$txt.prop("disabled", false);
				$txt.focus();
			};
			$txt.prop("disabled", true);
			self.filter(text, callback);
			window.clearTimeout(self.timeout);
			self.timeout = null;
		};

		// evento keyup del text de search
		$tab_container
			.off("keyup", this.jquery_txt_search_selector)
			.on("keyup", this.jquery_txt_search_selector, function(e)
			{
				var $txt = $(this);
				var text = $txt.val();
				if (self.timeout) {
					window.clearTimeout(self.timeout);
					self.timeout = null;
				}
				if (text.length === 0) {
					search(text, $txt);
				}
				else {
					if (e.keyCode === 13) {
						// enter
						search(text, $txt);
					}
					else if (e.keyCode === 27) {
						// escape
						search("", $txt);
					}
					else {
						self.timeout = window.setTimeout(function() {
							search(text, $txt);
						}, 400);
					}
				}
			});
	};

	/*******************************************************************
	* Metodo que xxx
	* @param word
	*/
	transfer_base.prototype.make_search_regexp = function( word )
	{
		if (typeof word !== "string") {
			return "";
		}
		var search_pattern = inConcert.Utils.removeSpecialChars(word);
		return new RegExp(search_pattern.replace(/[^\w\s]/gi, ""), "i");
	};

	/*******************************************************************
	* Metodo que xxx
	*/
	transfer_base.prototype.set_totals = function()
	{
		var text = this.total_rows === 1 ? this.total_message_one : this.total_message_many;
		var $tab_container = this.$get_tab_container();
		$tab_container.find("[total='true']").text(FORMAT(text, this.total_rows));
	};

	transfer_base.prototype.filter = function(text, callback)
	{
		let self = this;
		let agentsFilterActive  = $("#filter_online_agents").prop( "checked" );
		callback = callback || $.noop;

		let $tab_container  = this.$get_tab_container();
		let $list_container = $tab_container.find("[list_container='true']");
		let waiting_msg;

		if (text.trim().length === 0 && !agentsFilterActive) {
		// si no hay texto buscado en el filtro, no filtro la row
			waiting_msg = "<%=_T('Removing search')%>";
			this.parent.show_waiting(waiting_msg);
			// pequeno timeout para meter feedback y que se pueda visualizar el waiting
			window.setTimeout(function() {
				$list_container.find(self.jquery_item_selector).show();
				self.show_list();
				callback();
			}, 10);
			return;
		}

		waiting_msg = FORMAT("<%=_T('Searching: {0}')%>", text);
		this.parent.show_waiting(waiting_msg);
		// pequeno timeout para meter feedback y que se pueda visualizar el waiting
		window.setTimeout(function() {
			let hidden_rows = 0;
			$list_container.find(self.jquery_item_selector).each(function(_, row)
			{
				let $row           = $(row);
				let row_value      = $row.attr("search_text");
				let search_regexp  = self.make_search_regexp(text);
				let filter_offline = (agentsFilterActive && $row.attr("is_online") === "false") ? true : false;
				if ( row_value.search(search_regexp) === -1 || filter_offline ) {
					$row.hide();
					hidden_rows++;
				}
				else {
					$row.show();
				}
			});

			if ( self.total_rows === hidden_rows ) {
				self.hide_list();
			}
			else {
			// muestra la lista
				self.show_list();
				self.show_detail();
			}
			callback();
		}, 10);
	};

	/*******************************************************************
	* Metodo que xxx
	* @param message
	*/
	transfer_base.prototype.hide_list = function( message )
	{
		message = message || this.not_found_default_msg || "<%=_T('Not found.')%>";
		var $tab_container = this.$get_tab_container();
		$tab_container.find("[data_container='true']").hide(); // TODO: ver si remuevo o lo dejo para cargar nuevamente la lista
		var $message_container = $tab_container.find("[not_found_container='true']");
		$message_container.find(".col-12 > span").text(message);
		$message_container.show();
		this.parent.disable_transfer();
		this.parent.hide_waiting();
	};

	/*******************************************************************
	* Metodo que xxx
	*/
	transfer_base.prototype.show_list = function()
	{
		var $tab_container = this.$get_tab_container();
		$tab_container.find("[data_container='true']").show();
		$tab_container.find("[not_found_container='true']").hide();
		this.parent.enable_disable_transfer();
		this.parent.hide_waiting();
	};

	/*******************************************************************
	* Metodo que xxx
	* @param campaign_with_vcc
	*/
	transfer_base.prototype.get_campaign_name = function( campaign_with_vcc )
	{
		const campaign_id = inConcert.app.get_id(campaign_with_vcc);
		return campaign_id || campaign_with_vcc;
	};

	/*******************************************************************
	* Metodo que xxx
	* @param account
	*/
	transfer_base.prototype.get_account_name = function( account )
	{
		var channel_name = this.parent.get_channel_name(account.proxyType);
		return "(" + channel_name + ") " + account.name;
	};

	/*******************************************************************
	* Metodo que xxx
	* @param account
	*/
	transfer_base.prototype.can_disable_transfer = function()
	{
		return true;
	};

	//===================================================================================================
	//===================================================================================================
	/**
	Class transfer member hereda de transfer_base.
	* @param params
	*/
	function transfer_member ( params )
	{
		transfer_member.uber.constructor.call(this, params);
		this.jquery_item_selector  = "[member_item]";
		this.jquery_tab_selector   = "[tab_container='members']";
		this.not_found_default_msg = "<%=_T('No users found.')%>";
		this.prefix_radio_id       = "transfer_member_";
		this.total_message_one     = "<%=_T('{0} user.')%>";
		this.total_message_many    = "<%=_T('{0} users.')%>";
		this.online_agents_chk     = false;
		this.agents_cached         = false;
		this.load_fn = function( interactions, callback ) { inConcert.app.getInteractionManager().getMembersForTransfer( interactions, callback, this.parent.from_app, this.online_agents_chk ); };
	}

	inConcert.Utils.inherit( transfer_member, transfer_base );

	/*******************************************************************
	* Metodo que inicializa los requerimientos de la clase member.
	*/
	transfer_member.prototype.initialize = function()
	{
		this.show_online_agent_cbox();
		return transfer_member.uber.initialize.call(this); // Call base class initalization.
	};

	transfer_member.prototype.set_events = function()
	{
		let self = this;
		let apply_filter = function() {
			let $tab_container = self.$get_tab_container();
			let $search_box    = $tab_container.find(self.jquery_txt_search_selector);

			if ($search_box && $search_box.val().length) {
				self.filter($search_box.val());
			}
			else {
				self.filter_online_agents();
			}
		};

		$("#filter_online_agents")
			.off("click")
			.on("click", function() 
			{
				let $chk = $(this);
				self.online_agents_chk = $chk.prop( "checked" );

				// It's required to retrieve agents again
				if (self.online_agents_chk === true && self.agents_cached === false) {
					self.load(function () {
						self.agents_cached = true;
						apply_filter();
					});
				}
				else {
					apply_filter();
				}
			});

		transfer_member.uber.set_events.call(this); // Call base class set_events.
	};

	/*******************************************************************
	* Metodo que verifica si se muestra el checkbox de filtrado de agentes en linea.
	*/
	transfer_member.prototype.show_online_agent_cbox = function()
	{
		if (!this.parent.is_batch) {
			let interaction_type = this.parent.data.interactions[0].type;
			
			if (interaction_type !== "IM" && interaction_type !== "CHAT" && interaction_type !== "CALL") {
				$("#online_agents_transfer_popup_container").show();
			}
		}
	};

	/*******************************************************************
	* Metodo que filtra la lista de agentes por aquellos que estan en linea o muestra todos.
	*/
	transfer_member.prototype.filter_online_agents = function()
	{
		let self = this;
		let waiting_msg;
		let $tab_container = this.$get_tab_container();
		let $list_container = $tab_container.find("[list_container='true']");

		if (!this.online_agents_chk) {
			waiting_msg = "<%=_T('Showing all agents')%>";
			this.parent.show_waiting(waiting_msg);
			window.setTimeout(function() {
				$list_container.find(self.jquery_item_selector).show();
				self.show_list();
			}, 10);
			return;
		}

		waiting_msg = "<%=_T('Filtering online agents')%>";
		this.parent.show_waiting(waiting_msg);

		window.setTimeout(function() {
			let hidden_rows = 0;
			$list_container.find(self.jquery_item_selector).each(function(_, row)
			{
				let $row = $(row);
				let row_value = $row.attr("is_online");

				if ( row_value === "false" ) {
					$row.hide();
					hidden_rows++;
				}
				else {
					$row.show();
				}
			});

			if ( self.total_rows === hidden_rows ) {
				self.hide_list();
			}
			else {
				self.show_list();
				self.show_detail();
			}
		}, 10);
	};

	/*******************************************************************
	* Metodo que xxx
	* @param member
	*/
	transfer_member.prototype.get_member_name = function( member, al )
	{
		var member_name = member.Id;
		var can_name = false;
		if (( member.Name || "" ).trim().length > 0) {
			member_name = member.Name;
			can_name = true;
		}
		if (( member.FirstSurname || "" ).trim().length > 0) {
			member_name = ( can_name ? ( member_name + " " ) : "" ) + member.FirstSurname;
		}
		if (al) {
			member_name += ` (${al.name})`;
		}
		return member_name;
	};

	/*******************************************************************
	* Metodo que xxx
	* @param member
	*/
	transfer_member.prototype.make_search_item_text = function( member )
	{
		return this.get_member_name(member) + " " + member.Id;
	};
	
	transfer_member.prototype.__makeMeberRow = function(member, al)
	{
		let member_dom_id = this.get_radio_dom_id(member.Id + (al? `_${al.id}` : ""));
		let search_text = this.make_search_item_text(member);
		let member_name = this.get_member_name(member, al);
		let is_online   = (member.IsOnline !== undefined) ? member.IsOnline : false;

		let $row = $(`
			<div member_item='true' for='${member_dom_id}' search_text='${search_text}' is_online='${is_online}' class='targetListItem'>
				
				<input id='${member_dom_id}' transfer_to='${member.Id}' selector='true' type='radio' name='member' class='targetItemCheck' />
				<div class='targetItemData'>
					<label for='${member_dom_id}' class='targetItemName'>${member_name}</label>
					<label class='targetItemInfo'>${member.Id}</label>
				</div>
			</div>
		`);//<div class="targetItemIcon"></div>
		$row.removeClass("selected");
		if (this.parent?.current_container && this.parent.list_handle && this.parent.list_handle[this.parent.current_container] &&
			this.parent.list_handle[this.parent.current_container].get_selected_item_id() === member_dom_id) {
				$row.addClass("selected");
				$row.find("[selector='true']").prop("checked", true);
		}

		$row
			.data("row", member)
			.data("al", al);
		return $row;
	}; 

	/*******************************************************************
	* Metodo que xxx
	* @param callback
	*/
	transfer_member.prototype.load = function( callback )
	{
		callback = callback || $.noop;
		var self = this;

		var waiting_msg = "<%=_T('Loading users, wait moment please')%>";
		this.parent.show_waiting( waiting_msg );

		// invoco a la clase base
		transfer_member.uber.load.call(
			this,
			// callback del request
			function( members )
			{
				if ( !members || members.length === 0 ) {
					self.on_finish_load( callback );
					self.hide_list();
					return;
				}

				var $data_container = self.$tab_container.find("[data_container='true']");
				var $list_container = $data_container.find("[list_container='true']");

				$list_container.empty();
				$list_container.detach();

				var sorted_members = inConcert.Utils.sortArray(members, "Name");
				self.total_rows = 0;
				// se carga en un foreach que corre dentro de un timeout para que el navegador no quede colgado
				inConcert.Utils.foreach_timeout({
					rows : sorted_members,
					max_append_per_loop: 500,
					pause_between_loop_ms: 2,
					waiting_message : "<%=_T('Please wait, adding user, {0} of {1}.')%>",
					append_fn : function( member )
					{
						self.total_rows++;
						var attention_levels = member.getAttentionLevels(true);
						if (attention_levels.length) {
							attention_levels.forEach((al) => $list_container.append(self.__makeMeberRow(member, al)));
						}
						else {
							$list_container.append(self.__makeMeberRow(member));
						}
					},
					waiting_fn : function(message) {
						self.parent.show_waiting(message);
					},
					complete_fn : function() {
						$data_container.prepend($list_container);
						self.on_finish_load( callback );
					}
				});
			}
		);
	};

	transfer_member.prototype.is_enabled = function()
	{
		var self = this;
		var availables_channels = {
			CALL       : true,
			CHAT       : true,
			FACEBOOK   : true,
			INSTAGRAM  : true,
			YOUTUBE	   : true,
			APPSTORE   : true,
			GOOGLEPLAY : true,
			RCS	   	   : true,
			IM         : true,
			MAIL       : true,
			SMS        : true,
			WHATSAPP   : true,
			TWITTER    : true,
			WEBCONTACT : true,
			VOICEMAIL  : true
		};
		var response = { enabled : true };
		$.each(this.parent.data.interactions, function( _, interaction )
		{
			if ( !availables_channels[interaction.type] ) {
				response.enabled = false;
				response.reason = FORMAT("<%=_T('Transfer disabled for {0} channel.')%>", self.parent.get_channel_name(interaction.type));
				return false; // break
			}
		});
		return response;
	};

	transfer_member.prototype.get_transfer_to = function()
	{
		var $tab_container = this.$get_tab_container();
		var $transfer_to = $tab_container.find("div[list_container='true'] input[name='member']:checked");
		if ( $transfer_to.length === 0 ) {
			return;
		}
		var transfer_to = $transfer_to.attr("transfer_to");
		var al = $transfer_to.parent().data("al");
		return {
			to   : "member",
			user : transfer_to,
			att_level_id : al && al.id || null
		};
	};

	//===================================================================================================
	//===================================================================================================
	/**
	Class transfer number hereda de transfer_base.
	* @param params
	*/
	function transfer_number ( params )
	{
		const self = this;
		transfer_number.uber.constructor.call(this, params);
		this.jquery_item_selector = "[addresses_book_item]";
		this.jquery_tab_selector = "[tab_container='number']";
		this.not_found_default_msg = "<%=_T('No numbers found.')%>";
		this.prefix_radio_id = "transfer_number_";
		this.total_message_one  = "<%=_T('{0} number.')%>";
		this.total_message_many = "<%=_T('{0} numbers.')%>";
		this.always_enabled = true;
		this.m_contacts_model = null;

		this.load_fn = function( _, callback )
		{
			if (!self.m_contacts_model) {
				const first_interaction = (self.parent.data.interactions || [])[0];
				if (!first_interaction) {
					throw "Interaction not found";
				}
				let channel = first_interaction.type;
				self.m_contacts_model = new inConcert.AddressesBookSelectorModel(channel);
			}
			self.m_contacts_model.search("", function(success) { 
				if (success) {
					let contacts = self.m_contacts_model.getContacts();
					callback(contacts);
					return;
				}
				callback([]);
			});
		};
	}

	inConcert.Utils.inherit( transfer_number, transfer_base );

	/*******************************************************************
	* Metodo que xxx
	* @param callback
	*/
	transfer_number.prototype.load = function( callback = $.noop)
	{
		const self = this;

		let waiting_msg = "<%=_T('Loading Addresses Book, wait moment please')%>";
		this.parent.show_waiting( waiting_msg );

		// invoco a la clase base
		transfer_number.uber.load.call(
			this,
			// callback del request
			function( addresses_book )
			{
				if ( !addresses_book || addresses_book.length === 0 ) {
					self.on_finish_load( callback );
					self.hide_list();
					return;
				}

				const $data_container = self.$tab_container.find("[data_container='true']");
				const $list_container = $data_container.find("[list_container='true']");
				$list_container.detach();

				let sorted_addresses_book = inConcert.Utils.sortArray(addresses_book, "Number");
				self.total_rows = 0;
				// se carga en un foreach que corre dentro de un timeout para que el navegador no quede colgado
				inConcert.Utils.foreach_timeout({
					rows : sorted_addresses_book,
					max_append_per_loop: 500,
					pause_between_loop_ms: 2,
					waiting_message : "<%=_T('Please wait, adding Addresses Book, {0} of {1}.')%>",
					append_fn : function( address_book )
					{
						self.total_rows++;
						let address_book_dom_id = self.get_radio_dom_id( address_book.AddressId );
						let search_text = self.make_search_item_text( address_book );
						let full_phone_number = self.get_addresses_book_full_phone_number(address_book);

						const $item = $("".concat(
							"<div addresses_book_item='true' for='", address_book_dom_id ,"' search_text='", search_text, "' class='targetListItem'>",
								// "<div class='targetItemIcon'></div>",
								"<input id='", address_book_dom_id ,"' transfer_to='", full_phone_number ,"' selector='true' type='radio' name='address_book' class='targetItemCheck' />",
								"<div class='targetItemData'>",
									"<label for='", address_book_dom_id ,"' class='targetItemName'>", self.get_addresses_book_name( address_book ), "</label>",
									"<label class='targetItemInfo'>", full_phone_number, "</label>",
								"</div>",
							"</div>"
						));
						if (address_book.Description) {
							$item.attr("title", address_book.Description);
						}
						$item.data("row", address_book);
						$list_container.append($item);
					},
					waiting_fn : function(message) {
						self.parent.show_waiting(message);
					},
					complete_fn : function() {
						$data_container.prepend($list_container);
						self.on_finish_load( callback );
					}
				});
			}
		);
	};

	transfer_number.prototype.is_visible = function()
	{
		var self = this;

		var availables_channels = {
			CALL       : true ,
			CHAT       : false,
			FACEBOOK   : false,
			INSTAGRAM  : false,
			YOUTUBE	   : false,
			APPSTORE   : false,
			GOOGLEPLAY : false,
			RCS	   	   : false,
			IM         : false,
			MAIL       : false,
			SMS        : false,
			WHATSAPP   : false,
			TWITTER    : false,
			WEBCONTACT : false,
			VOICEMAIL  : false
		};

		var response = { visible : true };

		$.each(this.parent.data.interactions, function( _, interaction )
		{
			if ( !availables_channels[interaction.type] ) {
				response.visible = false;
				response.reason = FORMAT("<%=_T('Transfer disabled for {0} channel.')%>", self.parent.get_channel_name(interaction.type) );
				return false; // break
			}
		});

		return response;
	};

	transfer_number.prototype.is_enabled = function()
	{
		return { enabled : this.is_visible().visible };
	};

	transfer_number.prototype.validatePhoneNumber = function(number) {
		// transfer a number es solo para interacciones de CALL
		return inConcert.app.validatePhoneNumber(number, "CALL");
	};

	transfer_number.prototype.get_transfer_to = function()
	{
		var $tab_container = this.$get_tab_container();
		var transfer_to = $tab_container.find(this.jquery_txt_search_selector).val();
		if (!this.validatePhoneNumber(transfer_to)) {
			return { error : "<%=_T('Invalid phone number')%>" };
		}
		return { to: "number", number: transfer_to };
	};

	transfer_number.prototype.on_finish_load = function( callback )
	{
		callback = callback || $.noop;
		this.is_loaded = true;
		this.enable();
		this.parent.hide_waiting();
		callback();
	};

	transfer_number.prototype.get_addresses_book_full_phone_number = function( address_book )
	{
		let phone_number = address_book.Number;
		if (address_book.Area) {
			phone_number = address_book.Area + phone_number;
		}
		if (address_book.Country) {
			phone_number = address_book.Country + phone_number;
			if (!this.m_has_allegro_integration) {
				phone_number = "+" + phone_number;
			}
		}
		return phone_number;
	};

	transfer_number.prototype.get_addresses_book_name = function( address_book )
	{
		let name = address_book.Name || this.get_addresses_book_full_phone_number(address_book);
		return name;
	};

	transfer_number.prototype.make_search_item_text = function( address_book )
	{
		return this.get_addresses_book_name(address_book) + " " + this.get_addresses_book_full_phone_number(address_book);
	};

	// El boton para transferir a number, nunca tiene que quedar disabled, ya que no depende de la lista de addresses book.
	transfer_number.prototype.can_disable_transfer = function()
	{
		return false;
	};

	//===================================================================================================
	//===================================================================================================
	/**
	Class transfer campaign.
	* @param params
	*/
	function transfer_campaign ( params )
	{
		transfer_campaign.uber.constructor.call(this, params);
		var self = this;
		this.jquery_item_selector = "[account_item]";
		this.jquery_tab_selector = "[tab_container='campaigns']";
		this.not_found_default_msg = "<%=_T('No campaigns found.')%>";
		this.prefix_radio_id = "transfer_account_";
		this.total_message_one  = "<%=_T('{0} account.')%>";
		this.total_message_many = "<%=_T('{0} accounts.')%>";
		this.load_fn = function( interactions, callback )
		{
			inConcert.app.getInteractionManager().getCampaignsAccountsForTransfer(
			{
				app_id       : self.parent.from_app,
				callback     : callback,
				interactions : interactions
			});
		};
	}

	inConcert.Utils.inherit( transfer_campaign, transfer_base );

	/*******************************************************************
	* Metodo que xxx
	*/
	transfer_campaign.prototype.is_enabled = function()
	{
		var self = this;
		var availables_channels = {
			CALL       : true,
			CHAT       : true,
			FACEBOOK   : false,
			INSTAGRAM  : false,
			YOUTUBE	   : false,
			IM         : false,
			APPSTORE   : false,
			GOOGLEPLAY : false,
			RCS	   	   : true,
			MAIL       : true,
			SMS        : true,
			WHATSAPP   : true,
			TWITTER    : false,
			WEBCONTACT : false,
			VOICEMAIL  : false
		};
		var response = { enabled : true };
		$.each(this.parent.data.interactions, function( _, interaction )
		{
			if ( !availables_channels[interaction.type] ) {
				response.enabled = false;
				response.reason = FORMAT("<%=_T('Transfer disabled for {0} channel.')%>", self.parent.get_channel_name(interaction.type) );
				return false; // break
			}
		});
		return response;
	};

	/*******************************************************************
	* Metodo que xxx
	* @param account
	* @param campaign_id
	*/
	transfer_campaign.prototype.make_search_item_text = function( account, campaign_id  )
	{
		return this.get_campaign_name( campaign_id ) + this.get_account_name( account );
	};

	/*******************************************************************
	* Metodo que xxx
	* @param callback
	*/
	transfer_campaign.prototype.load = function( callback )
	{
		callback = callback || $.noop;
		var self = this;

		var waiting_msg = "<%=_T('Loading campaigns, wait moment please')%>";
		this.parent.show_waiting( waiting_msg );

		// invoco a la clase base
		transfer_campaign.uber.load.call(
			this,
			// callback del request
			function( campaigns )
			{
				if ( !campaigns || Object.keys(campaigns).length === 0 ) {
					self.on_finish_load( callback );
					self.hide_list();
					return;
				}
				var sorted_campaigns = inConcert.Utils.hash_to_sorted_array(campaigns,
					function(campaign) {
						return campaign.Id;
					}
				);
				self.total_rows = 0;
				var $data_container = self.$tab_container.find("[data_container='true']");
				var $list_container = $data_container.find("[list_container='true']");
				$list_container.detach();

				// se carga en un foreach que corre dentro de un timeout para que el navegador no quede colgado
				inConcert.Utils.foreach_timeout({
					rows : sorted_campaigns,
					pause_between_loop_ms: 2,
					waiting_message : "<%=_T('Please wait, adding campaign, {0} of {1}.')%>",
					append_fn : function( campaign )
					{
						var campaign_id = campaign.Id;
						var sorted_accounts = inConcert.Utils.hash_to_sorted_array(campaign.accounts,
							function(account) {
								return self.get_account_name( account );
							}
						);
						$.each( sorted_accounts, function( _, account )
						{
							self.total_rows++;
							var account_dom_id = self.get_radio_dom_id( account.id );
							var search_text = self.make_search_item_text( account, campaign_id );
							var $item = $("".concat(
								"<div account_item='true' for='", account_dom_id ,"' search_text='", search_text, "' class='targetListItem'>",
									// "<div class='targetItemIcon'></div>",
									"<input id='", account_dom_id ,"' campaign_transfer_to='", campaign_id ,"' account_transfer_to='", account.id ,"' selector='true' type='radio' name='account' class='targetItemCheck' />",
									"<div class='targetItemData'>",
										"<label for='", account_dom_id ,"' class='targetItemName'>", self.get_campaign_name( campaign_id ), "</label>",
										"<label class='targetItemInfo'>", self.get_account_name( account ), "</label>",
										"<label class='targetItemInfo'>", account.info.attention_level_name || "", "</label>",
									"</div>",
								"</div>"
							));
							$item.data("row", account);
							$list_container.append($item);
						});
					},
					waiting_fn : function(message) {
						self.parent.show_waiting(message);
					},
					complete_fn : function() {
						$data_container.prepend($list_container);
						self.on_finish_load( callback );
					}
				});
			}
		);
	};

	transfer_campaign.prototype.get_transfer_to = function()
	{
		var $tab_container = this.$get_tab_container();
		var $transfer_to = $tab_container.find("div[list_container='true'] input[name='account']:checked");
		if ( $transfer_to.length === 0 ) {
			return;
		}
		var campaign_transfer_to = $transfer_to.attr("campaign_transfer_to");
		var account_transfer_to = $transfer_to.attr("account_transfer_to");
		return {
			to          : "campaign",
			campaign_id : campaign_transfer_to,
			account_id  : account_transfer_to
		};
	};


	//===================================================================================================
	//===================================================================================================
	/**
	Class transfer attention level.
	* @param params
	*/
	function transfer_att_level ( params )
	{
		transfer_att_level.uber.constructor.call(this, params);
		var self = this;
		this.jquery_item_selector = "[att_level_item]";
		this.jquery_tab_selector = "[tab_container='attention_levels']";
		this.not_found_default_msg = "<%=_T('No attention levels found.')%>";
		this.prefix_radio_id = "transfer_att_level_";
		this.total_message_one  = "<%=_T('{0} attention level.')%>";
		this.total_message_many = "<%=_T('{0} attention levels.')%>";
		this.load_fn = function( interactions, callback )
		{
			inConcert.app.getInteractionManager().getAccountsAttentionLevelsForTransfer(
			{
				app_id       : self.parent.from_app,
				callback     : callback,
				interactions : interactions
			});
		};
	}

	inConcert.Utils.inherit( transfer_att_level, transfer_base );

	/*******************************************************************
	* Metodo que xxx
	* @param att_level
	*/
	transfer_att_level.prototype.get_att_level_name = function( att_level )
	{
		return att_level.name;
	};

	/*******************************************************************
	* Metodo que xxx
	* @param account
	* @param att_level
	*/
	transfer_att_level.prototype.make_search_item_text = function( account, att_level  )
	{
		return this.get_account_name( account ) + this.get_att_level_name( att_level);
	};

	/*******************************************************************
	* Metodo que xxx
	* @param callback
	*/
	transfer_att_level.prototype.load = function( callback )
	{
		callback = callback || $.noop;
		var self = this;

		var waiting_msg = "<%=_T('Loading attention levels, wait moment please')%>";
		this.parent.show_waiting( waiting_msg );

		// invoco a la clase base
		transfer_att_level.uber.load.call(
			this,
			// callback del request
			function( campaigns )
			{
				if ( !campaigns || Object.keys(campaigns).length === 0 ) {
					self.on_finish_load( callback );
					self.hide_list();
					return;
				}
				var sorted_campaigns = inConcert.Utils.hash_to_sorted_array(campaigns,
					function(campaign) {
						return campaign.Id;
					}
				);
				self.total_rows = 0;

				var $data_container = self.$tab_container.find("[data_container='true']");
				var $list_container = $data_container.find("[list_container='true']");
				$list_container.detach();

				// se carga en un foreach que corre dentro de un timeout para que el navegador no quede colgado
				inConcert.Utils.foreach_timeout({
					rows : sorted_campaigns,
					pause_between_loop_ms: 2,
					waiting_message : "<%=_T('Please wait, adding attention level, {0} of {1}.')%>",
					append_fn : function( campaign )
					{
						var campaign_id = campaign.Id;
						var sorted_accounts = inConcert.Utils.hash_to_sorted_array(campaign.accounts,
							function(account) {
								return self.get_account_name( account );
							}
						);
						$.each( sorted_accounts, function( _, account )
						{
							var sorted_att_levels = inConcert.Utils.hash_to_sorted_array(account.AttentionLevels,
								function(att_level) {
									return self.get_att_level_name( att_level );
								}
							);
							$.each( sorted_att_levels, function( _, att_level )
							{
								self.total_rows++;
								var att_level_id = att_level.attention_level_id;
								var att_level_dom_id = self.get_radio_dom_id(att_level_id);
								var account_name = self.get_account_name( account );
								var search_text = self.make_search_item_text( account, att_level );

								var $item = $("".concat(
									"<div att_level_item='true' for='", att_level_dom_id ,"' search_text='", search_text, "' class='targetListItem'>",
										// "<div class='targetItemIcon'></div>",
										"<input id='", att_level_dom_id ,"' campaign_transfer_to='", campaign_id ,"' account_transfer_to='", account.id ,"' att_level_transfer_to='", att_level_id ,"' selector='true' type='radio' name='att_level' class='targetItemCheck' />",
										"<div class='targetItemData'>",
											"<label class='targetItemName'>", self.get_att_level_name( att_level ), "</label>",
											"<label for='", att_level_dom_id ,"' class='targetItemInfo'>", account_name , "</label>",
										"</div>",
									"</div>"
								));
								$item.data("row", att_level);
								$list_container.append($item);
							});
						});
					},
					waiting_fn : function(message) {
						self.parent.show_waiting(message);
					},
					complete_fn : function() {
						$data_container.prepend($list_container);
						self.on_finish_load( callback );
					}
				});
			}
		);
	};

	transfer_att_level.prototype.is_enabled = function()
	{
		var self = this;
		var availables_channels = {
			CALL       : !this.m_has_allegro_integration,
			CHAT       : true,
			FACEBOOK   : true,
			INSTAGRAM  : true,
			YOUTUBE	   : true,
			APPSTORE   : true,
			GOOGLEPLAY : true,
			RCS	   	   : true,
			IM         : true,
			MAIL       : true,
			SMS        : true,
			WHATSAPP   : true,
			TWITTER    : true,
			WEBCONTACT : true,
			VOICEMAIL  : false
		};
		var response = { enabled : true };
		$.each(this.parent.data.interactions, function( _, interaction )
		{
			if ( !availables_channels[interaction.type] ) {
				response.enabled = false;
				response.reason = FORMAT("<%=_T('Transfer disabled for {0} channel.')%>", self.parent.get_channel_name(interaction.type) );
				return false; // break
			}
		});
		return response;
	};

	transfer_att_level.prototype.is_visible = function()
	{
		var self = this;
		var availables_channels = {
			CALL       : !this.m_has_allegro_integration,
			CHAT       : true,
			FACEBOOK   : true,
			INSTAGRAM  : true,
			YOUTUBE	   : true,
			APPSTORE   : true,
			GOOGLEPLAY : true,
			RCS	   	   : true,
			IM         : true,
			MAIL       : true,
			SMS        : true,
			WHATSAPP   : true,
			TWITTER    : true,
			WEBCONTACT : true,
			VOICEMAIL  : false
		};
		var response = { visible : true };
		$.each(this.parent.data.interactions, function( _, interaction )
		{
			if ( !availables_channels[interaction.type] ) {
				response.visible = false;
				response.reason = FORMAT("<%=_T('Transfer disabled for {0} channel.')%>", self.parent.get_channel_name(interaction.type) );
				return false; // break
			}
		});
		return response;
	};

	transfer_att_level.prototype.get_transfer_to = function()
	{
		var $tab_container = this.$get_tab_container();
		var $transfer_to = $tab_container.find("div[list_container='true'] input[name='att_level']:checked");
		if ( $transfer_to.length === 0 ) {
			return;
		}
		var campaign_transfer_to  = $transfer_to.attr("campaign_transfer_to");
		var account_transfer_to   = $transfer_to.attr("account_transfer_to");
		var att_level_transfer_to = $transfer_to.attr("att_level_transfer_to");
		return {
			to           : "attention_level",
			campaign_id  : campaign_transfer_to,
			account_id   : account_transfer_to,
			att_level_id : att_level_transfer_to
		};
	};

	//===================================================================================================
	//===================================================================================================
	/**
	Class transfer bot.
	* @param params
	*/
	function transfer_bot ( params )
	{
		transfer_bot.uber.constructor.call(this, params);
		var self = this;
		this.jquery_item_selector = "[bot_item]";
		this.jquery_tab_selector = "[tab_container='bots']";
		this.not_found_default_msg = "<%=_T('No processes found.')%>";
		this.prefix_radio_id = "transfer_bot_";
		this.total_message_one  = "<%=_T('{0} process.')%>";
		this.total_message_many = "<%=_T('{0} processes.')%>";
		this.load_fn = function( interactions, callback )
		{
			inConcert.app.getInteractionManager().getAccountsBotsForTransfer(
			{
				app_id       : self.parent.from_app,
				callback     : callback,
				interactions : interactions
			});
		};
	}

	inConcert.Utils.inherit( transfer_bot, transfer_base );

	/*******************************************************************
	* Metodo que xxx
	* @param bot
	*/
	transfer_bot.prototype.get_bot_name = function( bot )
	{
		return bot.name;
	};

	/*******************************************************************
	* Metodo que xxx
	* @param account
	* @param bot
	*/
	transfer_bot.prototype.make_search_item_text = function( _, bot )
	{
		return bot.name;
	};

	/*******************************************************************
	* Metodo que xxx
	* @param callback
	*/
	transfer_bot.prototype.load = function( callback )
	{
		callback = callback || $.noop;
		var self = this;

		var waiting_msg = "<%=_T('Loading processes, wait moment please')%>";
		this.parent.show_waiting( waiting_msg );

		// invoco a la clase base
		transfer_bot.uber.load.call(
			this,
			// callback del request
			function( bots )
			{
				if ( !bots || Object.keys(bots).length === 0 ) {
					self.on_finish_load( callback );
					self.hide_list();
					return;
				}
				var sorted_bots = inConcert.Utils.hash_to_sorted_array(bots,
					function(bot) {
						return bot.id;
					}
				);
				self.total_rows = 0;

				var $data_container = self.$tab_container.find("[data_container='true']");
				var $list_container = $data_container.find("[list_container='true']");
				$list_container.detach();

				// se carga en un foreach que corre dentro de un timeout para que el navegador no quede colgado
				inConcert.Utils.foreach_timeout({
					rows : sorted_bots,
					pause_between_loop_ms: 2,
					waiting_message : "<%=_T('Please wait, adding bot, {0} of {1}.')%>",
					append_fn : function( bot )
					{
						//$.each( sorted_bots, function( _, bot )
						//{
							self.total_rows++;
							var bot_id = bot.id;
							var bot_dom_id = self.get_radio_dom_id(bot_id);
							var bot_name = bot.name;
							var search_text = bot.name;
							var return_to_agent = bot.returnToAgent ? "<%=_T('Yes')%>" : "<%=_T('No')%>";
							var bot_return_label = "<%=_T('The process returns: ')%>" + return_to_agent;

							var $item = $("".concat(
								"<div bot_item='true' for='", bot_dom_id ,"' search_text='", search_text, "' class='targetListItem'>",
									// "<div class='targetItemIcon'></div>",
									"<input id='", bot_dom_id ,"' bot_transfer_to='", bot_id ,"' return_to_agent='", bot.returnToAgent, "' selector='true' type='radio' name='bot' class='targetItemCheck' />",
									"<div class='targetItemData'>",
										"<label class='targetItemName'>", bot_name, "</label>",
										"<label for='", bot_dom_id ,"' class='targetItemInfo'>", bot_return_label, "</label>",
									"</div>",
								"</div>"
							));
							$item.data("row", bot);
							$list_container.append($item);
						//});
					},
					waiting_fn : function(message) {
						self.parent.show_waiting(message);
					},
					complete_fn : function() {
						$data_container.prepend($list_container);
						self.on_finish_load( callback );
					}
				});
			}
		);
	};

	transfer_bot.prototype.is_enabled = function()
	{
		var self = this;
		var availables_channels = {
			CALL       : !this.m_has_allegro_integration,
			CHAT       : false,
			FACEBOOK   : false,
			INSTAGRAM  : false,
			YOUTUBE	   : false,
			APPSTORE   : false,
			GOOGLEPLAY : false,
			RCS	   	   : false,
			IM         : false,
			MAIL       : false,
			SMS        : false,
			WHATSAPP   : false,
			TWITTER    : false,
			WEBCONTACT : false,
			VOICEMAIL  : false
		};
		var response = { enabled : true };
		$.each(this.parent.data.interactions, function( _, interaction )
		{
			if ( !availables_channels[interaction.type] ) {
				response.enabled = false;
				response.reason = FORMAT("<%=_T('Transfer disabled for {0} channel.')%>", self.parent.get_channel_name(interaction.type) );
				return false; // break
			}
		});
		return response;
	};

	transfer_bot.prototype.is_visible = function()
	{
		var self = this;
		var availables_channels = {
			CALL       : !this.m_has_allegro_integration,
			CHAT       : true,
			FACEBOOK   : true,
			INSTAGRAM  : false,
			YOUTUBE	   : false,
			APPSTORE   : false,
			GOOGLEPLAY : false,
			RCS	   	   : false,
			IM         : false,
			MAIL       : true,
			SMS        : true,
			WHATSAPP   : true,
			TWITTER    : true,
			WEBCONTACT : false,
			VOICEMAIL  : false
		};
		var response = { visible : true };
		$.each(this.parent.data.interactions, function( _, interaction )
		{
			if ( !availables_channels[interaction.type] ) {
				response.visible = false;
				response.reason = FORMAT("<%=_T('Transfer disabled for {0} channel.')%>", self.parent.get_channel_name(interaction.type) );
				return false; // break
			}
		});
		return response;
	};

	transfer_bot.prototype.get_transfer_to = function()
	{
		var $tab_container = this.$get_tab_container();
		var $transfer_to = $tab_container.find("div[list_container='true'] input[name='bot']:checked");
		if ( $transfer_to.length === 0 ) {
			return;
		}
		var return_to_agent = $transfer_to.attr("return_to_agent") === "true" ? true : false;
		var bot_transfer_to = $transfer_to.attr("bot_transfer_to");
		return {
			to             : "bot",
			return_to_agent: return_to_agent,
			bot_id         : bot_transfer_to
		};
	};
	
	//===================================================================================================
	//===================================================================================================
	/**
	Class transfer_popup.
	* @param params
	*/
	function transfer_popup (params)
	{
		var self = this;
		transfer_popup.uber.constructor.call(this);
		this.clickEventName = this.clickEventName + "transfer";
		this.ownerId = "window_transfer_popup_container";
		this.canReposition = true;
		this.callbacks = params.callbacks;
		if (!params) {
			throw "transfer_popup - params is required";
		}
		if (!params.from_app) {
			throw "transfer_popup - params is required.from_app";
		}

		this.from_app = params.from_app;
		this.transfer_type = params.transfer_type;
		this.current_container = null;
		this.count_loading_list = 0;
		this.m_is_transferring = false;

		// instancias de los handles de las listas
		this.list_handle = {
			attention_levels : transfer_att_level,
			campaigns        : transfer_campaign,
			members          : transfer_member,
			number           : transfer_number,
			bots             : transfer_bot
		};

		if (this.transfer_type) {
			$.each(this.transfer_type, function(transfer_type) {
				if (!self.list_handle.hasOwnProperty(transfer_type)) {
					throw "transfer_popup - Unrecognized transfer type " + transfer_type;
				}
				self.list_handle[transfer_type] = new self.list_handle[transfer_type]({parent: self});
			});

			var handles_to_delete = {};
			$.each(this.list_handle, function(transfer_type) {
				if (!self.transfer_type.hasOwnProperty(transfer_type)) {
					handles_to_delete[transfer_type] = true;
				}
			});

			$.each(handles_to_delete, function(transfer_type) {
				delete self.list_handle[transfer_type];
			});
		}
		else {
			$.each(this.list_handle, function(id, transfer_class) {
				self.list_handle[id] = new transfer_class({parent: self});
			});
		}
	}

	inConcert.Utils.inherit(transfer_popup, inConcert.PopupWindow);

	//----------------------------
	if (typeof(inConcert.transfer_popup) !== "function") {
		inConcert.transfer_popup = transfer_popup;
	}

	/*******************************************************************
	*
	* @param text
	* @param type
	* @param closeDisabled
	* @param timeout_ms
	*/
	transfer_popup.prototype.show_status_message = function(text, type, closeDisabled, timeout_ms )
	{
		var $section = $("#transfer_message");
		$section.removeClass().addClass("genericFormMessagesContainer").addClass("message" + type);
		$section.show().find(".messageText").text(text);
		if (timeout_ms) {
			window.setTimeout(function() {
				$section.show();
			}, timeout_ms);
		}
		if (closeDisabled) {
			$("#transfer_close_message").show();
		}
		else {
			$("#transfer_close_message").show();
		}
	};

	/*******************************************************************
	* funcion que oculta mensaje
	*/
	transfer_popup.prototype.hide_status_message = function() {
		$("#transfer_message").show();
	};

	/*******************************************************************
	*
	*/
	transfer_popup.prototype.validate = function()
	{
		if ( !this.current_container ) {
			return false;
		}
		if (this.list_handle[this.current_container].always_enabled) {
			return true;
		}
		var selected_item_id = this.list_handle[this.current_container].get_selected_item_id();
		return selected_item_id !== null;
	};

	/*******************************************************************
	* 
	*/
	transfer_popup.prototype.get_transfer_to = function()
	{
		if ( !this.current_container ) {
			return;
		}
		var list_handle = this.list_handle[this.current_container];
		if ( !list_handle ) {
			return;
		}
		return list_handle.get_transfer_to();
	};

	/*******************************************************************
	* 
	* @param message
	*/
	transfer_popup.prototype.show_message_in_main_window = function( message )
	{
		inConcert.app.getMainWindow().showBannerMessage(message);
	};

	transfer_popup.prototype.transfer_execute = function(transfer_to, dispositon_info, callback_end = $.noop)
	{
		const self = this;
		const $cancel = $("#transfer_popup_cancel_interaction");

		this.disable_transfer();
		$cancel.prop("disabled", true);

		var get_conflict_message = function(error, count_errors)
		{
			switch (error)
			{
				case "COULD_NOT_RESERVE_AGENT":
					return "<%=_T('Could not reserve the agent')%>";

				case "CHATSERVER_NOT_AVAILABLE":
					return "<%=_T('Chatserver not available')%>";

				case "FORBIDDEN":
					return FORMAT("<%=_T('You have not permissions to transfer {0} conversations on campaign.')%>", count_errors);

				case "GENERIC_ERROR":
					return FORMAT("<%=_T('{0} failed transferring conversations, please try again later')%>", count_errors);

				case "GENERIC_WARNING":
					return "<%=_T('Warning, some conflicts have occurred transferring conversations, please contact your supervisor')%>";

				case "INTERACTION_CLOSED_OR_TAKEN":
					return "<%=_T('Unable to transfer. The conversation was closed or taken')%>";

				case "INTERACTION_NOT_FOUND":
					return "<%=_T('Conversation not found')%>";

				case "INVALID_REQUEST":
					return "<%=_T('Invalid request please try again later')%>";

				case "TRANSFER_TYPE_NOT_SUPPORTED":
					return "<%=_T('Unsupported transfer type')%>";

				case "CAN_NOT_TRANSFER_YOURSELF":
					return "<%=_T('Unable to transfer conversation, cannot transfer yourself')%>";

				case "MEMBER_DOES_NOT_EXIST":
					return "<%=_T('Unable to transfer conversation, user does not exist')%>";

				case "MEMBER_IS_DISABLED":
					return "<%=_T('Unable to transfer conversation, user is disabled')%>";

				case "MEMBER_NOT_HAS_PERMISSION_TO_INTERACTION_APPLICATION":
					return "<%=_T('Unable to transfer conversation, user not has permission to Interaction Application')%>";

				case "MEMBER_NOT_AVAILABLE":
					return "<%=_T('Unable to transfer conversation, user not available')%>";

				case "CHANNEL_DOES_NOT_SUPPORTED_TRANSFERS_TO_MEMBERS":
					return "<%=_T('Unable to transfer conversation, the channel not supported transfers to users')%>";

				case "MEMBER_HAS_NOT_AVAILABLE_CAPABILITY_FOR_CHANNEL":
					return "<%=_T('Unable to transfer conversation, user has not available capability for channel')%>";

				case "CONVERSATION_ALREADY_TRANSFERRING":
					return "<%=_T('Conversation is already transferring')%>";

				case "ALLEGRO_MEMBER_DOES_NOT_HAVE_A_PHONE_CONFIGURED":
					return "<%=_T('Unable to transfer conversation, user does not have a Phone configured')%>";

				default:
					return "<%=_T('Unable to transfer conversation, please try again later')%>";
			}
		};

		var get_error_message = function(errors, total, callback)
		{
			var message = total > 1?
				FORMAT("<%=_T('Failed transfer {0} {1} of {2}')%>", 
					errors.count_total, "<%=_T('conversations')%>", total) :
				"<%=_T('Failed to transfer conversation')%>";
			if (errors.count_types > 1) {
				//multiple types: generic error
				return callback(message);
			}
			var type = errors.types[0];
			var raw = errors.types_raw[type] || {};
			let agentId = inConcert.Utils.getIdWithoutVCC(raw.agent);

			switch(type) {
				case "INTERACTION_OPEN":
					raw = raw.error_source;
					var openMessage;
					if (errors.count_total > 1) {
						openMessage = "<%=_T('there are open conversations with same clients in destination campaign')%>";
					}
					else {
						switch(raw.state) {
							case "WAITING":
								openMessage = "<%=_T('there is a conversation with same client in destination campaign waiting list')%>";
								break;
							case "QUEUED":
								openMessage = "<%=_T('there is a conversation with same client in destination campaign queue')%>";
								break;
							case "TAKEN":
								if (agentId === inConcert.app.getLoggedUserId()) {
									openMessage = "<%=_T('you have a conversation with same client in destination campaign')%>";
								}
								else {
									inConcert.app.getTeamMember(agentId, function(agent) {
										let displayName = (agent && agent.Name) ? agent.Name : agentId;
										message += ": " + FORMAT("<%=_T('there is a conversation with same client in destination campaign assigned to agent {0}')%>", displayName);
										callback(message);
									});
									return;
								}
								break;
							default:
								openMessage = "<%=_T('there is an open conversation with same client in destination campaign')%>";
								break;
						}
					}
					message += ": " + openMessage;
			}
			callback(message);
		};

		var cloned_interactions = inConcert.Utils.cloneArray(this.data.interactions) || [];
		var count_interactions = cloned_interactions.length;
		
		if (this.on_before_transfer_execute) {
			this.on_before_transfer_execute(transfer_to, cloned_interactions);
		}
		
		var callbacks = {
			onFinished : function(result)
			{
				self.m_is_transferring = false;
				var message      = null;
				var message_type = "Info";
				var errors       = result.errors;
				var warnings     = result.warnings;

				if ( errors && errors.count_total > 0 ) {
				// con errores
					message_type = errors.count_total === count_interactions ? "Error" : "Alert";
					get_error_message(errors, count_interactions, function(message_err) {
						self.show_message_in_main_window({message: message_err, messageType: message_type, timeout: 5000});
						self.close();
					});
					callback_end();
					return;
				}
				else {
					if ( warnings && warnings.count_total > 0 ) {
					// con conflictos
						message_type = "Alert";
						if ( warnings.count_types === 1 ) {
							var warning_type = warnings.types.pop();
							message = get_conflict_message(warning_type, warnings.count_total);
						}
						else {
							message = get_conflict_message("GENERIC_WARNING", warnings.count_total);
						}
					}
				}

				if (message === null) {
					//Se agrega overlay e icon de bot, si la Conversación se transfiere a bot y debe volver al agente
					if (transfer_to.to === "bot" && transfer_to.return_to_agent && self.callbacks) {
						self.callbacks.showScreenReadOnly(true);
					}
				// aca entra si es success, es decir si no tuvo ningun error ni ningun warning
					if ( count_interactions <= 1 ) {
						// no muestra ningun mensaje si transfirio con exito y es una unica interaccion.
						self.on_transfer_success();
						return;
					}
					message = count_interactions === 1 ? "<%=_T('Conversation transferred successfully!')%>" : "<%=_T('All conversations were transferred successfully!')%>";
				}
				callback_end();
				self.on_transfer_success( { message: message, messageType: message_type } );
			},
			onPartial: function(successfulNodes/*, unsuccessfulNodes*/)
			{
				if (successfulNodes) {
					$.each(successfulNodes, function(_, transferredInteraction) {
						var index_to_remove = -1;
						$.each(self.data.interactions, function(i, interaction) {
							if (transferredInteraction.id === interaction.id) {
								index_to_remove = i;
								return false; //break
							}
						});
						if (index_to_remove > -1) {
							self.data.interactions.splice(index_to_remove, 1);
						}
					});
				}
				callback_end();
			},
			onFailure: function(err_message)
			{
				self.on_transfer_error(get_conflict_message(err_message));
				callback_end();
			}
		};

		var panel = inConcert.app.getMainWindow().getPanel("AssignedInteractions");
		var batchFunction = function( ints, to, transfer_callback ) {
			return inConcert.app.getInteractionManager().batchTransfer(ints, to, transfer_callback, self.from_app, dispositon_info);
		};
		var destination = [ transfer_to ];
		var batchData = new panel.BatchData(batchFunction, cloned_interactions, destination, callbacks);
		panel.processBatchInteractions(batchData);
	};

	/*******************************************************************
	* Transfer interactions and save the current transfer code and comment.
	*/
	transfer_popup.prototype.transfer_conversations = function($parent_node)
	{
		const self = this;

		if (this.m_is_transferring) {
			return;
		}
		this.m_is_transferring = true;

		if (!this.validate()) {
			this.m_is_transferring = false;
			this.show_status_message("<%=_T('Please select destination item to transfer.')%>", "Error", undefined, 2500);
			return;
		}

		var transfer_to = this.get_transfer_to();
		if ( !transfer_to || transfer_to.error ) {
			this.m_is_transferring = false;
			this.show_status_message(transfer_to && transfer_to.error || "<%=_T('Error in selected transfer item.')%>", "Error", undefined, 2500);
			return;
		}

		if (transfer_to.to !== "campaign") {
			// 1 - Aca realizamos las transferencias que NO son a campanas
			this.transfer_execute(transfer_to);
			return;
		}

		// Aca realizamos la transferencia a campanas
		const first_interaction = (this.data.interactions || [])[0];
		if (!first_interaction) {
			throw "Interaction not found";
		}

		const campaign = inConcert.app.getCampaign(first_interaction.campaign);
		if (!campaign) {
			throw "Campaign has been deleted";
		}

		//------------------------------------------------------------------------------------------
		// proxies asincronicos que admiten disposiciones de finalizacion al transferir x campana
		//   existe la misma validacion en:
		//             1 - (AGENT) /agent/cotrollers/interactions.lua - en la funcion para transferir (proxiesThatSupportDispositionsWhenTransferring)
		//             2 - (IR)    /scripts/IR/chatscripts.lua        - en la funcion para transferir (proxiesThatSupportDispositionsWhenTransferring)
		const proxies_that_support_dispositions_when_transferring = {
			MAIL    : true,
			SMS     : true,
			WHATSAPP: true
		};

		if (!proxies_that_support_dispositions_when_transferring[first_interaction.type] || !campaign.hasDispositionCodes()) {
			// 2 - Transferencia a campana SIN dispositon code
			this.transfer_execute(transfer_to);
			return;
		}

		// 3 - Transferencia a campana CON dispositon code. Abro el popup de dispositions para seleccionar uno.
		this.m_is_transferring = false;
		const $cancel = $("#transfer_popup_cancel_interaction");
		this.disable_transfer();
		$cancel.prop("disabled", true);

		const dispositionCodes = campaign.getDispositionCodes();
		const dispositionCodesPopup = new inConcert.DispositionCodesPopup({from_app: this.from_app, action_type: "NOT_FINISH - GET_DISPOSITION"});

		dispositionCodesPopup.show({
			interactions:     [first_interaction],
			parentNode:       $parent_node,
			dispositionCodes: dispositionCodes,
			callbacks: {
				on_finish : function(disposition_info) {
					// Aca ejecuto la transferencia con el disposition seleccionado.
					self.m_is_transferring = true;
					self.transfer_execute(transfer_to, disposition_info);
				},
				onClose: function() {
					if (self.m_is_transferring === false) {
						self.enable_transfer();
					}
				}
			}
		});
	};

	/*******************************************************************
	* Metodo que setea eventos de los controles
	* @param tab_item
	*/
	transfer_popup.prototype.switch_transfer_container = function( tab_item )
	{
		var $tab_items = $("#transfer_tab_items");
		var $tab_item = $tab_items.find("[tab_item='" + tab_item + "']");
		if ( this.current_container === tab_item ) {
			return;
		}
		this.current_container = tab_item;
		$tab_items.find("[tab_item]").removeClass("selected");
		$tab_item.addClass("selected");
		var $container = $("#window_transfer_popup_container");
		$container.find("[tab_container]").hide();
		$container.find("[tab_container='" + tab_item + "']").show();
		this.list_handle[tab_item].on_switch_tab();
	};

	/*******************************************************************
	* Metodo que muestra u oculta el selector
	* @param tab_item
	*/
	transfer_popup.prototype.toggle_transfer_selector = function( tab_item )
	{
		var tab_handle = this.list_handle[tab_item];
		if (!tab_handle) {
			return;
		}
		var result = tab_handle.is_visible();
		$("#transfer_tab_items")
			.find("[tab_item='" + tab_item + "']")
			.toggle(result.visible);
	};

	/*******************************************************************
	* Metodo xxx
	*/
	transfer_popup.prototype.enable_transfer = function()
	{
		$("#transfer_popup_transfer_conversation").prop("disabled", false);
		$("#transfer_popup_cancel_interaction").prop("disabled", false);
	};

	transfer_popup.prototype.disable_transfer = function()
	{
		if (!this.can_disable_transfer()) {
			return;
		}
		$("#transfer_popup_transfer_conversation").prop("disabled", true);
	};

	transfer_popup.prototype.can_disable_transfer = function()
	{
		if (!this.current_container) {
			return true;
		}
		const list_handle = this.list_handle[this.current_container];
		if (!list_handle) {
			return true;
		}
		return list_handle.can_disable_transfer();
	};

	transfer_popup.prototype.enable_disable_transfer = function()
	{
		var list_handle = this.list_handle[this.current_container];
		var selected_item = list_handle.get_selected_item_id();
		var enabled = list_handle.always_enabled || false;

		if ( !enabled && selected_item ) {
			var $item = $("#" + selected_item);
			var $item_container = $item.parent();
			enabled = $item_container.is(":visible");
		}

		if ( enabled ) {
			this.enable_transfer();
		}
		else {
			this.disable_transfer();
		}
	};

	/*******************************************************************
	* Metodo que setea eventos de los controles
	*/
	transfer_popup.prototype.set_events = function()
	{
		var self = this;

		$("#transfer_popup_transfer_conversation")
			.bind("click", function() {
				const $this = $(this);
				self.transfer_conversations($this);
			});

		var close_popup = function() { self.close(); };

		// evento que cierra el dialogo y no realiza cambios
		$("#transfer_popup_cancel_interaction").bind("click", close_popup );
		// evento que cierra el dialogo y no realiza cambios
		$("#close_transfer_popup").bind("click", close_popup );

		$("#transfer_close_message")
			.bind("click", function() {
				self.hide_status_message();
			});

		var event_selector = "[tab_item]";
		$("#transfer_tab_items")
			.find(event_selector)
			.each(function() {
				var $this = $(this);
				var tab_item = $this.attr("tab_item");
				self.toggle_transfer_selector( tab_item );
			})
			.off("click")
			.on("click", function () {
				var $this = $( this );
				var tab_item = $this.attr("tab_item");
				self.switch_transfer_container( tab_item );
			}
		);
	};

	/*******************************************************************
	* Metodo que crea el markup contenedor de la ventana
	*/
	transfer_popup.prototype.create_markup = function()
	{
		$("#window_transfer_popup_container").remove();
		var $node = $("".concat(
			"<div id='window_transfer_popup_container' class='internalPopUpContainer  popUp380w formPopUp fullScreenPopUp' hidden>",
				"<div class='internalPopUpOverlay'></div>" ,
				"<div class='internalPopUp'>",
					// waiting
					"<div id='transfer_waiting' class='popupWaitingContainer' hidden>" ,
						"<div message='true' class='popupWaitingMessage'></div>" ,
						"<div class='popupWaitingAnimation'></div>" ,
						"<div class='popupWaitingOverlay'></div>" ,
					"</div>",
					// title
					"<div class='internalPopUpTitle'>",
						"<span class='windowTransferTitleText'></span>",
						//"<button id='close_transfer_popup' class='internalPopUpCloseButton'><i class='far fa-times'></i></button>",
					"</div>",
					// content
					"<div class='internalPopUpMiddle pageFormContainer pb-0'>" ,
						// mensaje de error
						"<div id='transfer_message' class='genericFormMessagesContainer messageError' hidden>",
							"<a id='transfer_close_message' class='messageClose' href='javascript:void(0);'>", "<%=_T('close')%>", "</a>",
							"<div class='messageContent'>",
								"<label class='messageText'></label>",
							"</div>",
						"</div>",
						// content
						"<div class='card no-card'>",
							"<div class='card-block'>",
								"<div class='row'>",
									"<div class='col-12'>",
										//"<label><%=_T('Scope')%>:</label>",
										// transfer options style=' display: none' 
										"<div id='transfer_tab_items' class='windowTabsMenu tabAsInputDisabled ' style=' display: none' > ",
											"<span tab_item='members' class='windowTabsMenuItem' hidden>", "<%=_T('Users')%>", "</span>",
											"<span tab_item='campaigns' class='windowTabsMenuItem' hidden>", "<%=_T('Campaigns')%>", "</span>",
											"<span tab_item='attention_levels' class='windowTabsMenuItem' hidden>", "<%=_T('Attention Levels')%>", "</span>",
											"<span tab_item='number' class='windowTabsMenuItem' hidden>", "<%=_T('Number')%>", "</span>",
											"<span tab_item='bots' class='windowTabsMenuItem' hidden>", "<%=_T('Processes')%>", "</span>",
										"</div>",
									"</div>",
								"</div>",
								////////// members list container
								"<div tab_container='members' class='windowTargetTransferContainer' hidden>",

									"<div class='row'>",
										"<div class='col-12'>",
											"<div class='searchFilter searchFieldIcon form-group'>",
												"<input txt_search='true' class='windowTargetSearch filterField' type='text' placeholder='", "<%=_T('Search')%>...", "' disabled='true'/>",
											"</div>",
										"</div>",
									"</div>",

									// Filter checkbox.
									"<div class='row'>",
										"<div class='col-12'>",
											"<div id='online_agents_transfer_popup_container' class='moduleTitle' hidden>",
												"<input id='filter_online_agents' class='moduleCheckbox' type='checkbox' />",
												"<label for='filter_online_agents' class='moduleTitleText'>",
													"<%=_T('Show only online agents')%>",
												"</label>",
											"</div>",
										"</div>",
									"</div>",

									"<div class='row windowTargetDetail'>",
										"<div class='col-12'>",
											"<label><%=_T('Scope')%>:</label>",
											"<p total='true' class='windowTargetTotal'></p>",
										"</div>",
									"</div>",
									//"<hr />",
									"<div class='row'>",
										"<div class='col-12 pl-0 pr-0'>",
											//"<div class='searchFilter searchFieldIcon'>",
												//"<input txt_search='true' class='windowTargetSearch filterField' type='text' placeholder='", 
												//"<%=_T('Search')%>...", "' disabled='true'/>",
											//"</div>",

											"<div data_container='true' class='windowTargetTransferControl' hidden>",
												"<div list_container='true' class='windowTargetTransferScrollArea'></div>",
												"<div class='windowTargetFooter'>",
													"<div detail='true' class='windowTargetDetailContainer'>",
														"<div detail_list='true' class='windowTargetDetailInfo'></div>",
													"</div>",
												"</div>",
											"</div>",
										"</div>",
									"</div>",
									// No results
									"<div class='row' not_found_container='true' hidden>",
										"<div class='col-12'>",
											"<span class='inlineMessagesContainer messageInfo d-block windowTargetNoResultsText mt-0'></span>",
										"</div>",
									"</div>",
								"</div>",
								//////// campaigns list container
								"<div tab_container='campaigns' class='windowTargetTransferContainer' hidden>",
									//"<hr />",
									"<div class='row'>",
										"<div class='col-12'>",
											"<div class='searchFilter searchFieldIcon form-group'>",
												"<input txt_search='true' class='windowTargetSearch filterField' type='text' placeholder='", "<%=_T('Search')%>...", "' disabled='true'/>",
											"</div>",
										"</div>",
									"</div>",
									"<div class='row windowTargetDetail'>",
										"<div class='col-12'>",
											"<label><%=_T('Scope')%>:</label>",
											"<p total='true' class='windowTargetTotal'></p>",
										"</div>",
									"</div>",
									"<div class='row'>",
										"<div class='col-12 pl-0 pr-0'>",
											"<div data_container='true' class='windowTargetTransferControl' hidden>",
												"<div list_container='true' class='windowTargetTransferScrollArea'></div>",
												"<div class='windowTargetFooter'>",
													"<div detail='true' class='windowTargetDetailContainer'>",
														"<div detail_list='true' class='windowTargetDetailInfo'></div>",
													"</div>",
												"</div>",
											"</div>",
										"</div>",
									"</div>",
									// No results
									"<div class='row' not_found_container='true' hidden>",
										"<div class='col-12'>",
											"<span class='inlineMessagesContainer messageInfo d-block windowTargetNoResultsText mt-0'></span>",
										"</div>",
									"</div>",
								"</div>",
								//////// attention levels list container
								"<div tab_container='attention_levels' class='windowTargetTransferContainer' hidden>",
									//"<hr />",
									"<div class='row'>",
										"<div class='col-12'>",
											"<div class='searchFilter searchFieldIcon form-group'>",
												"<input txt_search='true' class='windowTargetSearch filterField' type='text' placeholder='", "<%=_T('Search')%>...", "' disabled='true'/>",
											"</div>",
										"</div>",
									"</div>",
									"<div class='row windowTargetDetail'>",
										"<div class='col-12'>",
											"<label><%=_T('Scope')%>:</label>",
											"<p total='true' class='windowTargetTotal'></p>",
										"</div>",
									"</div>",
									"<div class='row'>",
										"<div class='col-12 pl-0 pr-0'>",
											"<div data_container='true' class='windowTargetTransferControl' hidden>",
												"<div list_container='true' class='windowTargetTransferScrollArea'></div>",
												"<div class='windowTargetFooter'>",
													"<div detail='true' class='windowTargetDetailContainer'>",
														"<div detail_list='true' class='windowTargetDetailInfo'></div>",
													"</div>",
												"</div>",
											"</div>",
										"</div>",
									"</div>",
									// No results
									"<div class='row' not_found_container='true' hidden>",
										"<div class='col-12'>",
											"<span class='inlineMessagesContainer messageInfo d-block windowTargetNoResultsText mt-0'></span>",
										"</div>",
									"</div>",
								"</div>",
								//////// number list container
								"<div tab_container='number' class='windowTargetTransferContainer' hidden>",
									//"<hr />",
									"<div class='row'>",
										"<div class='col-12'>",
											"<div class='searchFilter searchFieldIcon form-group'>",
												"<input txt_search='true' class='windowTargetSearch filterField' type='text' placeholder='", "<%=_T('Search')%>...", "' disabled='true'/>",
											"</div>",
											// "<div class='windowTargetTitleContainer'>",
											// 	"<span class='windowTargetTitle'>",
											// 		"<%=_T('Addresses Book')%>",
											// 	"</span>",
											// "</div>",
										"</div>",
									"</div>",
									"<div class='row windowTargetDetail'>",
										"<div class='col-12'>",
											"<label><%=_T('Scope')%>:</label>",
											"<p total='true' class='windowTargetTotal'></p>",
										"</div>",
									"</div>",
									"<div class='row'>",
										"<div class='col-12 pl-0 pr-0'>",
											"<div data_container='true' class='windowTargetTransferControl' hidden>",
												"<div list_container='true' class='windowTargetTransferScrollArea'></div>",
												"<div class='windowTargetFooter'>",
													"<div detail='true' class='windowTargetDetailContainer'>",
														"<div detail_list='true' class='windowTargetDetailInfo'></div>",
													"</div>",
												"</div>",
											"</div>",
										"</div>",
									"</div>",
									// No results
									"<div class='row' not_found_container='true' hidden>",
										"<div class='col-12'>",
											"<span class='inlineMessagesContainer messageInfo d-block windowTargetNoResultsText mt-0'></span>",
										"</div>",
									"</div>",
								"</div>",
								//////// bots list container
								"<div tab_container='bots' class='windowTargetTransferContainer' hidden>",
									//"<hr />",
									"<div class='row'>",
										"<div class='col-12'>",
											"<div class='searchFilter searchFieldIcon form-group'>",
												"<input txt_search='true' class='windowTargetSearch filterField' type='text' placeholder='", "<%=_T('Search')%>...", "' disabled='true'/>",
											"</div>",
										"</div>",
									"</div>",
									"<div class='row windowTargetDetail'>",
										"<div class='col-12'>",
											"<label><%=_T('Scope')%>:</label>",
											"<p total='true' class='windowTargetTotal'></p>",
										"</div>",
									"</div>",
									"<div class='row'>",
										"<div class='col-12 pl-0 pr-0'>",
											"<div data_container='true' class='windowTargetTransferControl' hidden>",
												"<div list_container='true' class='windowTargetTransferScrollArea'></div>",
												"<div class='windowTargetFooter'>",
													"<div detail='true' class='windowTargetDetailContainer'>",
														"<div detail_list='true' class='windowTargetDetailInfo'>",
														"</div>",
													"</div>",
												"</div>",
											"</div>",
										"</div>",
									"</div>",
									// No results
									"<div class='row' not_found_container='true' hidden>",
										"<div class='col-12'>",
											"<span class='inlineMessagesContainer messageInfo d-block windowTargetNoResultsText mt-0'></span>",
										"</div>",
									"</div>",
								"</div>",
							"</div>",
						"</div>",
					"</div>",
					// MODAL FOOTER BUTTONS
					"<div class='internalPopUpButtons'>",
						"<button id='transfer_popup_transfer_conversation' class='pageButtonGeneric buttonColorBlue float-right'>" + "<%=_T('Transfer')%>" + "</button>",
						"<button id='transfer_popup_cancel_interaction' class='pageButtonGeneric buttonColorWhite float-right'>" + "<%=_T('Cancel')%>" + "</button>",
					"</div>",
				"</div>",
			"</div>"
			));
		$("body").append($node);
		return $node;
	};

	transfer_popup.prototype.get_channel_name = function( type )
	{
		var channels = {
			CALL       : "<%=_T('Phone Call')%>"  ,
			CHAT       : "<%=_T('Web chat')%>"    ,
			FACEBOOK   : "<%=_T('Facebook')%>"    ,
			INSTAGRAM  : "<%=_T('Instagram')%>"   ,
			YOUTUBE    : "<%=_T('Youtube')%>"     ,
			APPSTORE   : "<%=_T('Appstore')%>"    ,
			GOOGLEPLAY : "<%=_T('Googleplay')%>"  ,
			RCS    	   : "<%=_T('Rcs')%>"     	  ,
			IM         : "<%=_T('Chat')%>"        ,
			MAIL       : "<%=_T('E-Mail')%>"      ,
			SMS        : "<%=_T('SMS')%>"         ,
			WHATSAPP   : "<%=_T('Whatsapp')%>"    ,
			TWITTER    : "<%=_T('Twitter')%>"     ,
			WEBCONTACT : "<%=_T('Web contact')%>" ,
			VOICEMAIL  : "<%=_T('Voice mail')%>"
		};
		return channels[type];
	};

	transfer_popup.prototype.set_popup_title = function()
	{
		var popup_title;
		if (this.is_batch){
			var count_interactions = this.data.interactions.length;
			popup_title = FORMAT("<%=_T('Batch Transfer - {0} conversations')%>", count_interactions);
		}
		else {
			var interaction_type = this.data.interactions[0].type;
			var channel_name = this.get_channel_name( interaction_type );
			if ( !channel_name ) {
				throw "No channel name found for the conversation of type " + interaction_type;
			}
			popup_title = FORMAT("<%=_T('{0} Transfer')%>", channel_name);
		}
		$("#window_transfer_popup_container .windowTransferTitleText").text(popup_title);
	};

	transfer_popup.prototype.on_transfer_success = function( message_object )
	{
		if ( message_object ) {
			message_object.timeout = 5000;
			this.show_message_in_main_window( message_object );
		}
		this.close();
		this.parent_on_transfer_success();
	};

	/*******************************************************************
	* Metodo que xxxx
	* @param message_err
	*/
	transfer_popup.prototype.on_transfer_error = function( message_err )
	{
		this.m_is_transferring = false;
		this.enable_transfer();
		this.show_message_in_main_window({ message: message_err, messageType : "Error", timeout : 5000 });
		this.parent_on_transfer_error();
	};

	/*******************************************************************
	* Metodo que xxx
	* @param message
	*/
	transfer_popup.prototype.show_waiting = function( message )
	{
		this.waiting_progress_count = this.waiting_progress_count || 0;
		if ( this.waiting_progress_count === 5 ) {
			this.waiting_progress_count = -1;
		}
		this.waiting_progress_count++;
		var progress_text = "";
		var progress = "...";
		for ( var i = 1; i <= this.waiting_progress_count; i++ ) {
			progress_text = progress_text + progress;
		}
		message = message || "<%=_T('Loading, wait moment please')%>";
		var $waiting = $("#transfer_waiting");
		$waiting.find("[message='true']").text(message + " " + progress_text);
		$waiting.show();
	};

	/*******************************************************************
	* Metodo que xxx
	*/
	transfer_popup.prototype.hide_waiting = function()
	{
		var count_loaded = 0;
		$.each( this.list_handle, function( _, instance )
		{
			var result = instance.is_enabled();
			if ( result.enabled && instance.is_loaded ) {
				count_loaded++;
			}
		});
		if ( this.count_loading_list === count_loaded ) {
			$("#transfer_waiting").hide();
		}
		//this.setPosition();
	};

	/*******************************************************************
	* Metodo que visualiza el popup con los transfer e inicializa eventos del popup!
	*/
	transfer_popup.prototype.initialize = function()
	{
		var self = this;
		var interactions = this.data.interactions;
		if ( !interactions ) {
			throw "transfer_popup.initialize - interactions is required!!";
		}
		this.is_batch = interactions.length > 1;
		this.data.container = this.create_markup();
		this.parent_on_transfer_success = this.data.callbacks.on_transfer_success || $.noop;
		this.parent_on_transfer_error   = this.data.callbacks.on_transfer_error   || $.noop;
		this.on_before_transfer_execute = this.data.callbacks.on_before_transfer_execute   || $.noop;
		this.set_popup_title();
		this.set_events();

		var pending_instances_load = [];
		// continuno con los request pendientes
		var on_load = function() {
			if ( pending_instances_load.length === 0 ) {
				return;
			}
			var instance = pending_instances_load.pop();
			if ( instance ) {
				instance.load( on_load );
			}
		};

		// inicializo las instancias de las diferentes listas
		$.each( this.list_handle, function( _, instance ) {
			if ( instance.initialize() ) {
				self.count_loading_list++;
				if (self.count_loading_list === 1) {
					instance.load( on_load );
				}
				else {
					// a los request los dejo como pendientes para que el siguiente request, recien mande a ejecutar, una vez que ha terminado el anterior.
					pending_instances_load.push( instance );
				}
			}
		});
		var transfer_type = "members";
		if (this.transfer_type) {
			for (var t in this.transfer_type) {
				if (this.transfer_type.hasOwnProperty(t)) {
					transfer_type = t;
					break;
				}
			}
		}
		this.switch_transfer_container(transfer_type);
	};

	/*******************************************************************
	* Metodo que cierra el popup
	*/
	transfer_popup.prototype.close = function() {
		this.data.container.remove();
		this.finalize();
	};
}());
