/*	jshint forin:true, noarg:true, jquery:true, noempty:true, eqeqeq:true, bitwise:true,
  strict:true, undef:true, unused:true, curly:true, browser:true, indent:false, maxerr:50, esversion: 9 */

  /* global inConcert, $ */

// Create an inConcert object only if one does not already exist. We create the
// methods in a closure to avoid creating global variables.

if (!this.inConcert) {
	this.inConcert = {};
}

(function () {

	'use strict';

	function Window(handlers, settings) {
		var self = this;

		window.onbeforeunload = function () {
			// TODO Change this to some kind of config thing?
			// if (true) {
			// //this will alert user
			// return 'inConcert 6 Warning!';
			// }
			// else {
			// //this wont
			// window.onbeforeunload = undefined;
			// }
		};

		window.onunload = function () {
			self.onClose();
		};

		window.onfocus = function() {
			inConcert.app.getWindowManager().onWindowActivated(self);
		};

		window.onblur = function(){
			inConcert.app.getWindowManager().onWindowDeactivated(self);
		};
	}

	if (typeof inConcert.Window !== 'function') {
		inConcert.Window = Window;
	}

	Window.prototype.isMinimized = $.noop;

	Window.prototype.isMaximized = $.noop;

	Window.prototype.setBounds =$.noop;

	Window.prototype.center = $.noop;

	Window.prototype.hide = $.noop;

	Window.prototype.onMinimize = $.noop;

	Window.prototype.onMaximize = $.noop;

	Window.prototype.onRestore = $.noop;

	Window.prototype.setHorizontalResizingLimits = $.noop;

	Window.prototype.notifyTaskbar = $.noop;

	Window.prototype.onDisplayStateChange = $.noop;

	Window.prototype.show = $.noop;

	Window.prototype.onWindowClosed = $.noop;

	Window.prototype.onShutdown = $.noop;

	Window.prototype.onClose = function() {
		this.onWindowClosed();
	};

	Window.prototype.onApplicationExit = function() {
		this.onShutdown();
	};

	Window.prototype.bringToFront = function() {
		window.focus();
	};

	Window.prototype.activate = function() {
		window.focus();
	};

}());
