local allegro = require "apps.allegro.proxy"

module(..., package.seeall, inconcert.orbit.application.Decorate)

m_htmlRender = nil
m_appLocation = nil

function MapUris (module, htmlRender, prefix, appLocation)
	m_htmlRender = htmlRender
	m_appLocation = appLocation
end

function HasIntegration ( vcc_id ) return allegro.HasIntegration(vcc_id) end

--[[
  Guarda states en 5.5
]]--
function Save ( states_omnichannel, vcc_id )

	assert(type(states_omnichannel) == "table")

	if not HasIntegration(vcc_id) then
		LogWarning("[ALLEGRO.STATES:Save] Error saving allegro states. VCC '%s' Without integration", vcc_id)
		return true -- no es un error
	end

	local encoded_states_omnichannel = json.encode(states_omnichannel)
	LogInfo("[ALLEGRO.STATES:Save] encoded states: %s", encoded_states_omnichannel)

	local success, allegro_err = allegro.Post(
		vcc_id,
		encoded_states_omnichannel,
		"administration/states/save/" -- la URL de 5.5
	)

	local err
	if not success then
		err = { type = "ALLEGRO_INTEGRATION_ERROR", sub_type = allegro_err }
		LogWarning("[ALLEGRO.STATES:Save] Error saving allegro states: %s. Err: %s.", encoded_states_omnichannel, json.encode(err))
	end

	return success, err
end

--[[
  Elimina los states en 5.5
]]--
function Delete ( states_omnichannel, vcc_id )

	assert(type(vcc_id) == "string")

	local encoded_states_omnichannel = json.encode(states_omnichannel)

	LogInfo("[ALLEGRO.STATES:Delete] Deleting allegro states '%s'", encoded_states_omnichannel)

	if not HasIntegration(vcc_id) then
		LogWarning("[ALLEGRO.STATES:Delete] Error deleting allegro states. VCC '%s' Without integration", vcc_id)
		return true -- no es un error
	end

	local success, allegro_err = allegro.Post(
		vcc_id,
		encoded_states_omnichannel,
		"administration/states/delete/" -- la URL de 5.5
	)

	local err
	if not success then
		err = { type = "ALLEGRO_INTEGRATION_ERROR", sub_type = allegro_err }
		if allegro_err.result == "NOT_FOUND" then
			err.type = "NOT_A_ERROR"
		end
		LogWarning("---> [ALLEGRO.STATES:Delete] Error deleting allegro states: %s. Err: %s.", encoded_states_omnichannel, json.encode(err))
	end

	return success, err
end
