/*jshint quotmark:false, esversion: 11*/
/*global inConcert*/

if (!this.inConcert) {
	this.inConcert = {};
}

if (!inConcert.batchManagementCreate) {
	inConcert.batchManagementCreate = {};
}

(function () {
/*jshint validthis:true*/
"use strict";

	const FORMAT = inConcert.Utils.format;

	function CreatePopup (account)
	{
		CreatePopup.uber.constructor.call(this, account);
	}
	
	inConcert.Utils.inherit(CreatePopup, inConcert.batchManagementCreate.base);
	if (typeof inConcert.batchManagementCreate.whatsapp !== "function") {
		inConcert.batchManagementCreate.whatsapp = CreatePopup;
	}
	
	CreatePopup.prototype.__getTitle = function() {
		return "<%=_T('Create Whatsapp messages batch on')%>";
	};
	
	CreatePopup.prototype.__getTextLimit = function() {
		return 5000;
	};
	
	CreatePopup.prototype.__getClassName = function() {
		return "whatsappBatch";
	};
	
	CreatePopup.prototype.__validatePhoneNumber = function(number) {
		// allow the agent to call a cab, but not Uruguay's Speaking clock
		return number.length > 2 && number.match(/^[\- \(\)\+0-9_.*#]+$/);
	};
	
	CreatePopup.prototype.__getAndValidateAddress = function(address_t) {
		return this.__validatePhoneNumber(address_t) && address_t.replace(/[^0-9#*\+]/g, "") || false;
	};
	
	CreatePopup.prototype.__getIntegrationType = function() {
		var account = inConcert.app.getBatchesManager().GetAccountConfiguration(
			this.account.campaign, this.account.account);
		if (!account) {
			return "";
		}
		return account.integrationType || "WEB";
	};
	
	var integrationTemplateMessagesRequired = {
		"WEB" : false
	};
	CreatePopup.prototype.isTemplateMessageRequired = function() {
		return integrationTemplateMessagesRequired[this.__getIntegrationType()] !== false;
	};
	
	CreatePopup.prototype.__addDataAsync = function(data, callback) {
		if(this.__getIntegrationType() === "ICC_CLOUD_API") {
			let request = {
				campaignAtVCC : this.account.campaign,
				account : this.account.account
			};
			inConcert.app.getBatchesManager().WhatsappGetAccountLimitData(request, function(success, result) {
				if(success && result.active_messages_sent && result.message_limit && (result.active_messages_sent + data.addresses.length > result.message_limit)) {
					$.inconcertPopup.Show(
						"<%=_T('Confirm')%>",
						FORMAT("<%=_T('Batch length ({0}) will exceed available 24 hours messages limit ({1}), and some messages will have to wait before they can be sent. Continue?')%>", data.addresses.length, result.message_limit),
						$.inconcertPopup.ButtonSets.BS_YESNO,
						function(response) {
							callback(response.toLowerCase() === "yes");
						},
						undefined,
						{
							popup_id        : "conf_inconcertPopup",
							container_class : "confirmationPopUp",
							overlay_class   : "confirmationOverlay"
						}
					);
				}
				else {
					callback(true);
				}
			});			
		}
		else {
			callback(true);
		}
	};

}());