/*  jshint forin:true, noarg:true, jquery:true, noempty:true, eqeqeq:true, bitwise:true,
  strict:true, undef:true, unused:true, curly:true, browser:true, indent:false, maxerr:50, esversion: 11 */

/*global $, inConcert*/

if (!this.inConcert) {
	this.inConcert = {};
}

(function () {
/*jshint validthis:true*/
"use strict";

	var actions = $.extend({}, inConcert.batchManagementActions.base, {
		EDIT		: null,
		RESCHEDULE	: null,
		PAUSE		: null,
		DELETE		: null,
		ADD_ADDRESSES: null
	});
	if (!inConcert.batchManagementActions.rcs) {
		inConcert.batchManagementActions.rcs = actions;
		$.each(actions, function(actionId, action) {
			inConcert.batchManagementActions.all[actionId] = inConcert.batchManagementActions.all[actionId] || action;
		});
	}

	function RcsBatch (rawData)
	{
		RcsBatch.uber.constructor.call(this, rawData);
	}

	inConcert.Utils.inherit(RcsBatch, inConcert.batchManagement.base);
	if (typeof inConcert.batchManagement.rcs !== "function") {
		inConcert.batchManagement.rcs = RcsBatch;
	}
	
	RcsBatch.prototype.HasAddresses = function() {
		return true;
	};
	
	RcsBatch.prototype.GetCharactersLimit = function() {
		return 160;
	};
	
	RcsBatch.prototype.__getScreenName = function() {
		var account = inConcert.app.getBatchesManager().GetAccountConfiguration(this.campaign, this.account);
		return account && account.name || "";
	};
	
	RcsBatch.prototype.GetAccountName = function() {
		return this.__getScreenName() || RcsBatch.uber.GetAccountName.call(this);
	};

}());