/* jshint forin:true, noarg:true, jquery:true, noempty:true, eqeqeq:true, bitwise:true,
	strict:true, undef:true, unused:vars, curly:false, browser:true, indent:false, maxerr:50, quotmark:double, -W014, esversion: 11 */

/* global inConcert */

if (!this.inConcert) {
	this.inConcert = {};
}

(function () {
/*jshint validthis:true*/
"use strict";

	const actions = $.extend({}, inConcert.batchManagementActions.base, {
		EDIT		: null,
		RESCHEDULE	: null,
		PAUSE		: null,
		DELETE		: null
	});
	if (!inConcert.batchManagementActions.whatsapp) {
		inConcert.batchManagementActions.whatsapp = actions;
		$.each(actions, function(actionId, action) {
			inConcert.batchManagementActions.all[actionId] = inConcert.batchManagementActions.all[actionId] || action;
		});
	}

	function WhatsappBatch (rawData)
	{
		WhatsappBatch.uber.constructor.call(this, rawData);
	}

	inConcert.Utils.inherit(WhatsappBatch, inConcert.batchManagement.base);
	if (typeof inConcert.batchManagement.whatsapp !== "function") {
		inConcert.batchManagement.whatsapp = WhatsappBatch;
	}
	
	WhatsappBatch.prototype.HasAddresses = function() {
		return true;
	};

	WhatsappBatch.prototype.GetCharactersLimit = function() {
		return 5000;
	};

	WhatsappBatch.prototype.__getScreenName = function() {
		var account = inConcert.app.getBatchesManager().GetAccountConfiguration(this.campaign, this.account);
		return account && account.name || "";
	};
	
	WhatsappBatch.prototype.GetAccountName = function() {
		return this.__getScreenName() || WhatsappBatch.uber.GetAccountName.call(this);
	};

	WhatsappBatch.prototype.IsCloudAPI = function() {
		let account = inConcert.app.getBatchesManager().GetAccountConfiguration(this.campaign, this.account);
		return account.integrationType === "ICC_CLOUD_API";
	};

	WhatsappBatch.prototype.__can_resume = function() {
		//#20270: Los lotes de Cloud API solo se pausan cuando durante el procesamiento el estado del template asociado cambia a pausado (pacing)
		//	Ref: https://developers.facebook.com/docs/whatsapp/message-templates/guidelines/#template-pacing
		//	El resume se realizara automaticamente despues de que el estado del template vuelva a ser activo
		inConcert.app.getBatchesManager().GetAccountConfiguration(this.campaign, this.account);
		return WhatsappBatch.uber.IsPaused.call(this) && !this.IsCloudAPI();
	};
}());