/*jshint quotmark:false*/
/*global $, inConcert, FB, Mustache*/

if (!this.inConcert) {
	this.inConcert = {};
}

if (!inConcert.outgoingBatchesStatistics) {
	inConcert.outgoingBatchesStatistics = {};
}
if (!inConcert.outgoingBatchesStatistics.batch) {
	inConcert.outgoingBatchesStatistics.batch = {};
}

(function () {
/*jshint validthis:true*/
"use strict";
	var format = inConcert.Utils.format;
	var templates = inConcert.templates.batch_management;

	var definition = [
		{
			id : "interactions",
			name : "<%=_T('Interactions')%>",
			description : "<%=_T('Number of interactions created related to this batch.')%>"
		}
	];

	function Statistics (rawData)
	{
		var slices = [];
		if (!rawData.batch.IsClosed() && !rawData.batch.IsDeleted()) {
			slices.push(inConcert.outgoingBatchesStatisticsSlices.today);
			slices.push(inConcert.outgoingBatchesStatisticsSlices.yesterday);
		}
		slices.push(inConcert.outgoingBatchesStatisticsSlices.last7days);
		slices.push(inConcert.outgoingBatchesStatisticsSlices.last28days);
		slices.push(inConcert.outgoingBatchesStatisticsSlices.total);
		Statistics.uber.constructor.call(this, definition, slices, inConcert.outgoingBatchesStatisticsSlices.last7days, rawData);
	}
	
	inConcert.Utils.inherit(Statistics, inConcert.outgoingBatchesStatistics.batch.base);
	if (typeof inConcert.outgoingBatchesStatistics.batch.mail !== "function") {
		inConcert.outgoingBatchesStatistics.batch.mail = Statistics;
	}
	
	Statistics.prototype.GetClassName = function() {
		return "mailBatch";
	};
	
	Statistics.prototype.GetNewBatchText = function() {
		return "<%=_T('New')%>";
	};
	
	Statistics.prototype.GetContent = function(callback) {
		callback = callback || $.noop;
		var content = this.batch.GetContent();
		content.$html = $(Mustache.render(templates.statistics_batch_mail, {
			id : this.batch.GetIdString(),
			subject : content.subject || ""
		}));
		callback(content);
	};
	
	Statistics.prototype.AfterUiLoad = function(callback) {
		var content = this.batch.GetContent();
		var body = content.body[0].content;
		var id = this.batch.GetIdString();
		var setContentFn = function() {
			var $body = $("#mail_batch_iframe_" + id).contents().find("#iframe_mail_body");
			if ( $body.length === 0 ) {
				window.setTimeout(setContentFn, 10);
				return;
			}
			$body.html(body);
			// Bindeo el click de los links, para que los mismos se abran en una nueva ventana.
			inConcert.Utils.bind_href($body);
			callback();
		};
		setContentFn();
	};

}());