/*jshint quotmark:false*/
/*global $, inConcert, FB*/

if (!this.inConcert) {
	this.inConcert = {};
}

if (!inConcert.outgoingBatchesStatistics) {
	inConcert.outgoingBatchesStatistics = {};
}
if (!inConcert.outgoingBatchesStatistics.batch) {
	inConcert.outgoingBatchesStatistics.batch = {};
}

(function () {
/*jshint validthis:true*/
"use strict";
	var format = inConcert.Utils.format;

	var definition = [
		{
			id : "interactions",
			name : "<%=_T('Interactions')%>",
			description : "<%=_T('Number of interactions created related to this batch.')%>"
		}
	];

	function Statistics (rawData)
	{
		var slices = [];
		if (!rawData.batch.IsClosed() && !rawData.batch.IsDeleted()) {
			slices.push(inConcert.outgoingBatchesStatisticsSlices.today);
			slices.push(inConcert.outgoingBatchesStatisticsSlices.yesterday);
		}
		slices.push(inConcert.outgoingBatchesStatisticsSlices.last7days);
		slices.push(inConcert.outgoingBatchesStatisticsSlices.last28days);
		slices.push(inConcert.outgoingBatchesStatisticsSlices.total);
		Statistics.uber.constructor.call(this, definition, slices, inConcert.outgoingBatchesStatisticsSlices.last7days, rawData);
	}
	
	inConcert.Utils.inherit(Statistics, inConcert.outgoingBatchesStatistics.batch.base);
	if (typeof inConcert.outgoingBatchesStatistics.batch.rcs !== "function") {
		inConcert.outgoingBatchesStatistics.batch.rcs = Statistics;
	}
	
	Statistics.prototype.GetClassName = function() {
		return "rcsBatch";
	};
	
	Statistics.prototype.GetNewBatchText = function() {
		return "<%=_T('New')%>";
	};
	
	Statistics.prototype.GetContent = function(callback) {
		callback = callback || $.noop;
		var content = this.batch.GetContent();
		content.text = this.batch.GetIdString() + (content.text? format(" - \"{0}\"", content.text) : "");
		callback(content);
	};

}());