/* jshint forin:true, noarg:true, jquery:true, noempty:true, eqeqeq:true, bitwise:true,
	strict:true, undef:true, unused:vars, curly:false, browser:true, indent:false, maxerr:50, quotmark:double, -W014, esversion: 11 */

/* global inConcert, Mustache */

if (!this.inConcert) {
	this.inConcert = {};
}

if (!inConcert.outgoingBatchesStatistics) {
	inConcert.outgoingBatchesStatistics = {};
}
if (!inConcert.outgoingBatchesStatistics.batch) {
	inConcert.outgoingBatchesStatistics.batch = {};
}

(function () {
/*jshint validthis:true*/
"use strict";
	var templates = inConcert.templates.batch_management;
	var definition = [
		{
			id : "interactions",
			name : "<%=_T('Interactions')%>",
			description : "<%=_T('Number of interactions created related to this batch.')%>"
		}
	];

	function Statistics (rawData)
	{
		var slices = [];
		if (!rawData.batch.IsClosed() && !rawData.batch.IsDeleted()) {
			slices.push(inConcert.outgoingBatchesStatisticsSlices.today);
			slices.push(inConcert.outgoingBatchesStatisticsSlices.yesterday);
		}
		slices.push(inConcert.outgoingBatchesStatisticsSlices.last7days);
		slices.push(inConcert.outgoingBatchesStatisticsSlices.last28days);
		slices.push(inConcert.outgoingBatchesStatisticsSlices.total);
		Statistics.uber.constructor.call(this, definition, slices, inConcert.outgoingBatchesStatisticsSlices.last7days, rawData);
	}
	
	inConcert.Utils.inherit(Statistics, inConcert.outgoingBatchesStatistics.batch.base);
	if (typeof inConcert.outgoingBatchesStatistics.batch.whatsapp !== "function") {
		inConcert.outgoingBatchesStatistics.batch.whatsapp = Statistics;
	}
	
	Statistics.prototype.GetClassName = function() {
		return "whatsappBatch";
	};
	
	Statistics.prototype.GetNewBatchText = function() {
		return "<%=_T('New')%>";
	};
	
	Statistics.prototype.GetContent = function(callback) {
		callback = callback || $.noop;
		var content = this.batch.GetContent();
		var paused_template;
		if(this.batch.IsCloudAPI && this.batch.IsCloudAPI() && this.batch.IsPaused()) {
			paused_template = {};
			paused_template.template_id = this.batch.data.template.id;
			paused_template.template_language = this.batch.data.template.language;
		}
		if(paused_template) {
			content.$html = $(Mustache.render(templates.statistics_batch_whatsapp_cloud_api_template_paused, {
				template_id: paused_template.template_id,
				template_language: paused_template.template_language
			}));
		}
		var $generalContent = $(Mustache.render(templates.statistics_batch_generic_content_account, {
			id : this.batch.GetIdString(),
			message: content.text
		}));
		if(paused_template) {
			content.$html.push($generalContent[0]);
		}
		else {
			content.$html = $generalContent;
		}
		callback(content);
	};

}());