/*jshint quotmark:false*/
/*global $, inConcert, Mustache*/

if (!this.inConcert) {
	this.inConcert = {};
}

(function () {
/*jshint validthis:true*/
"use strict";
	var templates = inConcert.templates.batch_management;

	function StatisticsPopup (parent)
	{
		StatisticsPopup.uber.constructor.call(this, parent);
	}

	inConcert.Utils.inherit(StatisticsPopup, inConcert.outgoingBatchesStatisticsUi.base);
	if (!inConcert.outgoingBatchesStatisticsUi.popup) {
		inConcert.outgoingBatchesStatisticsUi.popup = StatisticsPopup;
	}

	StatisticsPopup.prototype.Show = function(callback) {
		callback = callback || $.noop;
		var self = this;
		self.Close(function() {
			self.__show(callback);
		});
	};

	StatisticsPopup.prototype.Close = function(callback) {
		callback = callback || $.noop;
		var self = this;
		if (self.popup && self.popup.isVisible()) {
			self.popup.finalize(function() {
				self.popup = null;
				$("#outgoingBatchesStatsPopup").remove();
				callback();
			});
		}
		else {
			$("#outgoingBatchesStatsPopup").remove();
			callback();
		}
	};

	StatisticsPopup.prototype.__show = function(callback) {
		callback = callback || $.noop;
		var self = this;
		this.__make(function($body) {
			var $menu = $(Mustache.render (templates.statistics_popup_container, {
				className : self.parent.GetClassName()
			}));
			$menu.append($body);
			$("body").append($menu);
			self.popup = new inConcert.PopupWindow();
			self.popup.show({
				ownerId       : "outgoingBatchesStatsPopup",
				eventName     : "outgoingBatchesStatsPopup",
				canReposition : true,
				overlay       : true,
				container     : $menu,
				callbacks: {
					onOpen: function() {
						$("#outgoingBatchesStatsPopup").show();
					},
					onClose: function( callback ) {
						callback = callback || $.noop;
						if (self.popup) {
							self.popup.hide(function() {
								callback();
							});
						}
						else {
							callback();
						}
					}
				}
			});
			self.__afterLoad(callback);
		});
	};

	StatisticsPopup.prototype.Reload = function(callback) {
		callback = callback || $.noop;
		var self = this;
		if (!this.popup || !this.popup.isVisible()) {
			return callback();
		}
		this.__make(function($body) {
			$("#outgoingBatchesStatsPopup")
				.html("")
				.append($body);
			self.__afterLoad(callback);
		});
	};

	StatisticsPopup.prototype.__getViewName = function() {
		return "statistics_popup";
	};

	StatisticsPopup.prototype.__getPieChartSize = function() {
		return 100;
	};

	StatisticsPopup.prototype.__getLineChartSize = function() {
		return {
			width: 100,
			height: 30
		};
	};

	StatisticsPopup.prototype.__getBarsChartSize = function() {
		return {
			width: 200,
			height: 80
		};
	};

	StatisticsPopup.prototype.__makeBody = function(callback) {
		callback = callback || $.noop;
		var $body = $(Mustache.render (templates.statistics_popup, {
			name : this.parent.GetAccountName()
		}));
		callback($body);
	};

	StatisticsPopup.prototype.__make = function(callback) {
		callback = callback || $.noop;
		var self = this;
		StatisticsPopup.uber.__make.call(self, function($body) {
			$body.find("[close_popup]").click(function() {
				self.Close();
			});
			$body.find("button[bmPopupButtonClose]")
			.off("click")
			.on("click", function() {
				self.Close();
			});
			callback($body);
		});
	};

}());