local m_models = require("apps.campaign_analytics.model"):GetModels()
module(..., package.seeall, inconcert.orbit.application.Decorate)
local utils = require "shared.apps.utils"
m_htmlRender = nil

local LOG_CONTEXT = "campaign_analytics:configuration"

function MapUris(m, htmlRender, prefix)
	m_htmlRender = htmlRender
	local LogRequest = require("apps.agent.requestFilters").LogRequest

	m:dispatch_get(utils.JsonReply..LogRequest..ConfigList, prefix.."/")
	m:dispatch_get(utils.JsonReply..LogRequest..ConfigGet, prefix.."/(.+)")
	m:dispatch_post(utils.JsonValidatorReply..LogRequest..ConfigSaveAll, prefix.."/")
	m:dispatch_put(utils.JsonValidatorReply..LogRequest..ConfigSaveField, prefix.."/(.+)")
end

function ConfigList(web)
	local vcc = inconcert.authUser.virtualContactCenter
	local userId = utils.AppendVcc(inconcert.authUser.userName, vcc)
	LogInfo("[%s:ConfigList] %s ", LOG_CONTEXT, userId)

	local configuration = m_models.Configuration.GetConfiguration(userId)
	return { result = "OK", configuration = configuration }
end

function ConfigGet(web, field)
	local vcc = inconcert.authUser.virtualContactCenter
	local userId = utils.AppendVcc(inconcert.authUser.userName, vcc)
	LogInfo("[%s:ConfigGet] %s %s", LOG_CONTEXT, userId, field)

	local configuration = m_models.Configuration.GetConfigurationField(userId, field)
	return { result = "OK", configuration = configuration }
end

function ConfigSaveAll(web)
	local vcc = inconcert.authUser.virtualContactCenter
	local userId = utils.AppendVcc(inconcert.authUser.userName, vcc)
	local config = web.request.configuration
	if not config then
		web.status = 401
		return { result = "INVALID_REQUEST", reason = "empty configuration" }
	end

	LogInfo("[%s:ConfigSave] %s %s", LOG_CONTEXT, userId, json.encode(config))
	m_models.Configuration.SaveConfiguration(userId, config)
	return { result = "OK" }
end

function ConfigSaveField(web, field)
	local vcc = inconcert.authUser.virtualContactCenter
	local userId = utils.AppendVcc(inconcert.authUser.userName, vcc)
	local config = web.request.configuration
	if not config then
		web.status = 401
		return { result = "INVALID_REQUEST", reason = "empty configuration" }
	end

	LogInfo("[%s:ConfigSaveField] %s %s", LOG_CONTEXT, userId, json.encode(config))
	m_models.Configuration.SavefigurationField(userId, field, config)
	return { result = "OK" }
end
