module(..., package.seeall)

local utils = require "shared.apps.utils"
local m_datasource

function GetName()
	return "TrunkDids"
end

function GetDefinition(datasource)
	m_datasource = datasource
	return _M
end

function Get(trunkId, keyspace)
	local value = utils.GetColumnValue({
		keyspace = keyspace or "Provisioning",
		columnFamily = "Trunks",
		key = trunkId,
		column = "didsPool"
	}) or ""
	return value ~= "" and json.decode(value) or {}
end

function Save(trunkId, dids, keyspace)
	utils.SaveRows {
		keyspace = keyspace or "Provisioning",
		columnFamily = "Trunks",
		rows = {
			[trunkId] = { didsPool = json.encode(dids) },
		}
	}
end
