/*jshint quotmark:double, esversion: 11*/
/*global $, inConcert */
/*
Ha
*/
// Create an inConcert object only if one does not already exist. We create the
// methods in a closure to avoid creating global variables.

if (!this.inConcert) {
	this.inConcert = {};
}

(function () {
	/*jslint validthis:true */
	"use strict";

	const _T = inConcert.i18n.getString;
	const FORMAT = inConcert.Utils.format;
	const ZEROPAD = inConcert.Utils.zeropad;
	// funcion que retorna un array o una lista vacia dependiendo si es instanciado desde el OE Nativo.
	const makeEmtpyListByType = function(data_type) {
		return data_type === "ARRAY" ? [] : {};
	};

	//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	/**
	Class Add Range Popup.
	*/
	function RangePopup (params)
	{
		RangePopup.uber.constructor.call(this);
		this.clickEventName = this.clickEventName + "_batch_filter";
		this.ownerId = params.prefix + "range_popup";
		this.waitingId = this.ownerId + "_waiting";
		this.messageId = this.ownerId + "_message";
		this.closeMessageId = this.ownerId + "_message_close";
		this.params = params;
		this.frm = params.frm;
		this.canReposition = true;
	}

	inConcert.Utils.inherit(RangePopup, inConcert.PopupWindow);

	RangePopup.prototype.getMarkup = function() {
		let $container = $("#" + this.ownerId);
		return $container;
	};

	RangePopup.prototype.initialize = function()
	{
		this.data.container = this.getMarkup();
	};

	RangePopup.prototype.show_waiting = function()
	{
		let message = "<%=_T('Loading, wait moment please')%>";
		const $waiting = $("#" + this.waitingId);
		$waiting.find("[message='true']").text(message);
		$waiting.show();
	};

	RangePopup.prototype.hide_waiting = function()
	{
		$("#" + this.waitingId).hide();
		this.setPosition();
	};

	RangePopup.prototype.show_status_message = function(text, type, closeDisabled, timeout_ms)
	{
		const $message = $("#" + this.messageId);
		$message.removeClass().addClass("genericFormMessagesContainer").addClass("message" + type);
		$message.show().find(".messageText").text(text);
		if (timeout_ms) {
			window.setTimeout(function() {
				$message.hide();
			}, timeout_ms);
		}
		const $messageClose = $("#" + this.closeMessageId);
		if (closeDisabled) {
			$messageClose.hide();
		}
		else {
			$messageClose.show();
		}
	};

	RangePopup.prototype.hide_status_message = function() {
		const $message = $("#" + this.messageId);
		$message.hide();
	};

	RangePopup.prototype.ready = function()
	{
		const self = this;
		// 1 - Dejo marcado el dia que se ha selecciondo
		// 1.1 - abro la lista
		$(`#${self.params.prefix}day_range_selector`).trigger("click");
		// 1.2 - marco dia de la lista
		const $day = $(`#${self.params.prefix}day_range_list input[day='${this.params.day}']`);
		$day.trigger("click");
		// 1.3 - cierro la lista
		$(`#${self.params.prefix}day_range_selector`).trigger("click");
		// 2 - Dejo desmarcada la opcion "establecer todo el dia"
		const $all_day_range = $(`#${self.params.prefix}all_day_range`);
		if ($all_day_range.prop("checked")) {
			$all_day_range.click();
		}
	};

	RangePopup.prototype.close = function(params) {
		this.finalize(params);
	};

	RangePopup.prototype.__load_contacts_from_query = function(callback = $.noop)
	{
		let contacts = [];
		if (this.contact_query_result) {
			contacts = this.contact_query_result.contacts || contacts;
		}
		callback(true, contacts);
	};

	//---------------------------------------------------------------------
	// form basic class
	function conf_form_schedule(params)
	{
		const self = this;

		params = params || {};
		this.frm = params.frm;
		this.owner = params.owner;
		this.prefix = params.prefix + "_";
		this.container_id = params.container_id;
		this.without_buttons_container = params.without_buttons_container;
		this.err_msg_container_id = params.err_msg_container_id;
		this.buttons_container_id = params.buttons_container_id;
		this.waiting_container_id = params.waiting_container_id;
		this.m_data_type = params.data_type || "ARRAY"; // ARRAY or MAP
		this.m_attrNameSpecialDayRanges = this.m_data_type === "ARRAY" ? "scheduleSpecialDayRanges" : "ranges";
		this.form_paginator_special_days = null;
		this.current_scheduler = null;
		this.scheduled_ranges = null;
		this.ctrls_customs = params.ctrls_customs;

		this.days_popup = new inConcert.PopupWindow({
			ownerId   : this.prefix + "day_range_list", // container id
			eventName : "day_range_list"                // evento click personalizado
		});

		this.special_days_actions_list = {
			"AddRange" : {id: "AddRange" , value: "<%=_T('Add day range')%>"},
			"Override" : {id: "Override" , value: "<%=_T('Override day')%>" },
			"Exclusion": {id: "Exclusion", value: "<%=_T('Day exclusion')%>"}
		};

		this.special_days_exclusion_repeat_list = {
			"Year"  : {id: "Year"  , value: "<%=_T('Only This Year')%>"},
			"Always": {id: "Always", value: "<%=_T('Yearly')%>"        }
		};

		this.callbacks = {
			cancel: function() {
				if (params.callbacks.cancel) {
					params.callbacks.cancel();
					return;
				}
				self.frm.close();
			},
			can_configure_special_days: function() {
				if (!params.callbacks || typeof(params.callbacks.can_configure_special_days) !== "function") {
					return false;
				}
				return params.callbacks.can_configure_special_days();
			},
			save: function(scheduler, callback) {
				params.callbacks.save(scheduler, callback);
			},
			validate: function(scheduler, callback) {
				if (!params.callbacks.validate) {
					callback(true);
					return;
				}
				params.callbacks.validate(scheduler, callback);
			},
			can_add_scheduled_range: function(info, callback) {
				if (params.callbacks && typeof(params.callbacks.can_add_scheduled_range) === "function") {
					params.callbacks.can_add_scheduled_range(info, callback);
					return;
				}
				info.success = true;
				callback(info);
			},
			on_added_scheduled_range: function(callback = $.noop) {
				if (params.callbacks && typeof(params.callbacks.on_added_scheduled_range) === "function") {
					params.callbacks.on_added_scheduled_range(callback);
					return;
				}
				callback();
			},
			on_open_scheduled_range_popup: params.callbacks?.on_open_scheduled_range_popup || undefined,
			on_close_scheduled_range_popup: params.callbacks?.on_close_scheduled_range_popup || undefined,
		};
		return true;
	}

	if ( typeof inConcert.conf_form_schedule !== "function" ) {
		inConcert.conf_form_schedule = conf_form_schedule;
	}

	conf_form_schedule.prototype.initialize = function()
	{
		this.__render();
		this.__initialize_special_days();
		this.__set_events();
		this.__set_initial_data();
		this.hide_errors();
		this.frm.create_hours(this.container_id);
		if (this.__can_configure_special_days()) {
			this.form_paginator_special_days.initialize();
		}
	};

	conf_form_schedule.prototype.dispose = $.noop;

	conf_form_schedule.prototype.__can_configure_special_days = function()
	{
		return this.callbacks.can_configure_special_days();
	};

	conf_form_schedule.prototype.__set_initial_data = function()
	{
		this.scheduled_ranges = {
			Sunday   : { day: 1, ranges: [] },
			Monday   : { day: 2, ranges: [] },
			Tuesday  : { day: 3, ranges: [] },
			Wednesday: { day: 4, ranges: [] },
			Thursday : { day: 5, ranges: [] },
			Friday   : { day: 6, ranges: [] },
			Saturday : { day: 7, ranges: [] }
		};
	};

	conf_form_schedule.prototype.__initialize_special_days = function()
	{
		if (!this.__can_configure_special_days()) {
			return;
		}
		this.__new_grid_special_days();

		const special_days_container_id = this.prefix + "new_special_days_section";
		this.frm.create_datepickers(special_days_container_id);

		const $action_type = $("#" + this.prefix + "special_days_action_type");
		this.frm.fill_combo($action_type, false /* is_blank_first_item */, this.special_days_actions_list, "id" /* attr_id */, "value" /* attr_name */);

		const $exclusion_repeat = $("#" + this.prefix + "special_days_exclusion_repeat");
		this.frm.fill_combo($exclusion_repeat, true /* is_blank_first_item */, this.special_days_exclusion_repeat_list, "id" /* attr_id */, "value" /* attr_name */);

		this.__change_special_days_action();
	};

	conf_form_schedule.prototype.__new_grid_special_days = function()
	{
		const self = this;

		this.form_paginator_special_days = new inConcert.conf_form_paginator({
			paginator_name: "SCH_SPECIAL_DAYS",
			owner: this,
			frm: this.frm,
			row_id: "date",
			display_name: "date",
			rows_per_page: 500,
			show_at_least: 499,
			without_paginator: true,
			ids: {
				grid                     : this.prefix + "special_days_list",
				paginator                : this.prefix + "special_days_paginator",
				not_results_found        : this.prefix + "special_days_not_results_found",
				new_item                 : this.prefix + "special_days_new",
				container_new_btn        : this.prefix + "special_days_section",
				//popup
				popup                    : this.prefix + "new_special_days_section",
				popup_msg                : this.prefix + "special_days_message",
				popup_create             : this.prefix + "special_days_create",
				popup_create_and_continue: this.prefix + "special_days_create_and_continue",
				popup_close              : this.prefix + "special_days_close"
			},
			strings: {
				not_results_found: "<%=_T('No Special Days Found.')%>",
				can_remove       : "<%=_T('Do you want to delete Special Days: {0} ?')%>"
			},
			columns: [
				{id: "_number"   , name: "", type: "counter"},
				{id: "image_type", name: "", type: "icon", get_value: function(item) {
					return self.get_grid_value(item, "image_type");
				}},
				{id: "date"      , name: "<%=_T('Date')%>"  },
				{id: "reason"    , name: "<%=_T('Reason')%>"},
				{id: "when"      , name: "<%=_T('When')%>", get_value: function(item) {
					return self.get_grid_value(item, "when");
				}},
				{id: "_action", name: "",
					system_action: { erase: true }
				}
			],
			callbacks: {
				save: function(callback, must_create_and_contiune) {
					self.__add_special_day(callback, must_create_and_contiune);
				},
				edit: function(action) {
					self.on_edit_special_days(action);
				},
				on_closed_popup: function() {
					self.on_closed_special_days_popup();
				},
				on_removed_row: function() {
					self.__disabled_special_days_actions(false);
				},
				load_items: function(_, callback) {
					callback = callback || $.noop;
					var list = self.__load_special_days();
					callback(true, list);
				}
			}
		});
	};

	/*
		scheduler.scheduleSpecialDays = [
			{
				"day": "10",
				"month": "11",
				"year": "2017",
				"description": "wwwwwww",
				"scheduleSpecialDayRanges": [],
				"overrides": 1
			},
			{
				"day": "11",
				"month": "11",
				"year": "2017",
				"description": "",
				"scheduleSpecialDayRanges": [
					{
					  "startTime": "1970-01-01 " + "00:00:00",
					  "endTime": "1970-01-01 " + "00:00:00",
					  "day": "11",
					  "month": "11",
					  "year": "2017"
					}
				],
				"overrides": 0
			}
		];

		scheduler.scheduleSpecialDayAllYearss = [
			{
				"day": "10",
				"month": "11",
				"description": "eee",
				"overrides": 1,
				"year": "1970"
			},
			{
				"day": "11",
				"month": "11",
				"description": "swww",
				"overrides": 1,
				"year": "1970"
			}
		];
	*/
	conf_form_schedule.prototype.__load_special_days = function()
	{
		const self = this;

		let special_days = makeEmtpyListByType(this.m_data_type);
		if (!this.current_scheduler) {
			return special_days;
		}

		//primero los dias especiales con dia y/o rango
		$.each(this.current_scheduler.scheduleSpecialDays || [], function(_, sch_special_day)
		{
			let date = self.__format_date(sch_special_day.day, sch_special_day.month, sch_special_day.year);
			let sp_day = {
				date      : date,
				reason    : sch_special_day.description,
				ranges    : [],
				__raw_info: sch_special_day
			};
			// a esto hay que realizarlo asi ya que el OE Nativo almacena en una estructura diferente.
			let scheduleSpecialDayRanges = (sch_special_day[self.m_attrNameSpecialDayRanges] || []);
			if (scheduleSpecialDayRanges.length === 0) {
				//es un override only this year
				sp_day.action = "Exclusion";
				sp_day.type = "Year";
			}
			else {
				sp_day.action = (sch_special_day.overrides === 1 || sch_special_day.overrides === true) ? "Override" : "AddRange";
				$.each(scheduleSpecialDayRanges, function(_, range) {
					let created_range = self.create_range_from_date_time(range.startTime, range.endTime);
					sp_day.ranges.push(created_range);
				});
			}
			if (self.m_data_type === "ARRAY") {
				special_days.push(sp_day);
			}
			else {
				let key = date;
				special_days[key] = sp_day;
			}
		});

		if (this.m_data_type !== "ARRAY") {
			return special_days;
		}

		//luego las exclusiones para todos los anios
		$.each(this.current_scheduler.scheduleSpecialDayAllYearss || [], function(_, sch_special_day)
		{
			//lamentablemente con el cambio de tablas perdi el anio para manejar una fecha aca, siempre va a volver 1970 a los allyears
			let date = self.__format_date(sch_special_day.day, sch_special_day.month);
			let sp_day = {
				date      : date,
				action    : "Exclusion",
				type      : "Always",
				reason    : sch_special_day.description,
				ranges    : [],
				__raw_info: sch_special_day
			};
			special_days.push(sp_day);
		});

		return special_days;
	};

	conf_form_schedule.prototype.__format_date = function(day, month, year)
	{
		const month_day = ZEROPAD(month) + "-" + ZEROPAD(day);
		if (!year) {
			return month_day;
		}
		return year + "-" + month_day;
	};

	conf_form_schedule.prototype.get_grid_value = function(item, field_id)
	{
		let value = {
			original_value: "",
			value         : "",
			search_value  : ""
		};

		let item_value = item[field_id];
		if (item_value === undefined) {
			item_value = "";
		}

		if (field_id === "when") {
			let when;
			if (item.action === "Exclusion") {
				when = this.get_exclusion_string(item.type);
			}
			else {
				when = this.range_list_as_string(item.ranges);
			}
			item_value = when;
		}
		else if (field_id === "image_type") {
			let class_name;
			if (item.action === "Exclusion") {
				class_name = "far fa-calendar-minus ic-icon-size-20 ic-icon-orange";
			}
			else if (item.action === "AddRange") {
				class_name = "far fa-calendar-plus ic-icon-size-20 ic-icon-orange";
			}
			else {
				// Override
				class_name = "far fa-calendar-edit ic-icon-size-20 ic-icon-orange";
			}
			item_value = item.action;
			value.class_name = class_name;
		}

		value.original_value = item_value;
		value.value = item_value;
		value.search_value = item_value;

		return value;
	};

	conf_form_schedule.prototype.on_owner_hide = function()
	{
		if ( this.days_popup.isVisible() ) {
			this.days_popup.hide();
		}
	};

	conf_form_schedule.prototype.set = function(scheduler)
	{
		this.current_scheduler = scheduler;
		this.__set_initial_data();
		this.set_scheduler();
	};

	conf_form_schedule.prototype.set_scheduler = function()
	{
		if (typeof this.current_scheduler !== "object") {
			return;
		}
		let schedule_days = this.current_scheduler.scheduleDays;
		if (this.m_data_type === "ARRAY") {
			for (let i = 0; i < schedule_days.length; i++) {
				let schedule_day = schedule_days[i];
				let dayOfWeek = schedule_day.dayOfWeek || i;
				let day_name = this.get_day_name(dayOfWeek);
				if (day_name.length) {
					let range = this.create_range_from_date_time(schedule_day.startTime, schedule_day.endTime, schedule_day.additionalData);
					this.add_range(day_name, range);
				}
			}
		}
		else {
			for (let dayOfWeek in schedule_days) {
				if (schedule_days.hasOwnProperty(dayOfWeek)) {
					let schedule_day = schedule_days[dayOfWeek];
					let day_name = this.get_day_name(dayOfWeek);
					if (day_name.length) {
						for (let i = 0; i < schedule_day.length; i++) {
							let sch_day_config = schedule_day[i];
							let range = this.create_range_from_date_time(sch_day_config.startTime, sch_day_config.endTime, sch_day_config.additionalData);
							this.add_range(day_name, range);
						}
					}
				}
			}
		}
		this.refresh_range_table();
		if (this.__can_configure_special_days()) {
			if (this.form_paginator_special_days) {
				this.form_paginator_special_days.initialize();
			}
			else {
				this.initialize();
			}
		}
	};

	conf_form_schedule.prototype.get_day_name = function(index)
	{
		let day_number = parseInt(index, 10);
		for (let day in this.scheduled_ranges) {
			if (this.scheduled_ranges.hasOwnProperty(day)) {
				if (this.scheduled_ranges[day].day === day_number) {
					return day;
				}
			}
		}
		return "";
	};

	conf_form_schedule.prototype.create_range_from_date_time = function(start_time, end_time, additionalData)
	{
		let hour_regexp;
		let minutes_regexp;
		if (this.m_data_type === "ARRAY") {
			hour_regexp = /\d\d\d\d-\d\d-\d\d (\d\d):\d\d:\d\d/;
			minutes_regexp = /\d\d\d\d-\d\d-\d\d \d\d:(\d\d):\d\d/;
		}
		else {
			hour_regexp = /(\d\d):\d\d:\d\d/;
			minutes_regexp = /\d\d:(\d\d):\d\d/;
		}
		const build_range = function(string_date) {
			let range = {
				Hours  : string_date.match(hour_regexp)[1],
				Minutes: string_date.match(minutes_regexp)[1]
			};
			return range;
		};
		let info = {
			from          : build_range(start_time),
			to            : build_range(end_time),
			additionalData: additionalData // optional
		};
		return info;
	};

	/*
	 	Creates from scratch the schedule range table according to the internal range definition
	*/
	conf_form_schedule.prototype.refresh_range_table = function()
	{
		//set all disabled
		// $("#" + this.prefix + "interval_list").find(".formLabel").addClass("formLabel-ds");
		//empty all the defined intervals cause will be re-created
		$("#" + this.prefix + "interval_list").find(".scheduleIntervalContainer").html("");

		for (let day in this.scheduled_ranges) {
			if (this.scheduled_ranges.hasOwnProperty(day)) {
				let day_index = this.scheduled_ranges[day].day - 1;
				let day_node = $("#" + this.prefix + "interval_list li:eq(" + day_index + ")");
				if (day_node.length > 0 && this.scheduled_ranges[day].ranges.length > 0) {
					const total_ranges = this.scheduled_ranges[day].ranges.length;
					for (let i = 0; i < total_ranges; i++) {
						let range = this.scheduled_ranges[day].ranges[i];
						let html_range = this.build_html_range(range);
						day_node.find(".scheduleIntervalContainer").append(html_range);
					}
					// day_node.find(".formLabel").removeClass("formLabel-ds");
					
					day_node.find("[butIntervalDelete]")[total_ranges > 1? "show":"hide"]();
					day_node.find(".butIntervalDeleteDay").show();
				}
			}
		}
	};

	conf_form_schedule.prototype.__make_override_value = function(numberValue)
	{
		if (this.m_data_type === "ARRAY") {
			return numberValue;
		}
		return numberValue === 1 ? true : false;
	};

	conf_form_schedule.prototype.get_scheduler_special_days = function()
	{
		const self = this;
		if (!this.__can_configure_special_days()) {
			return;
		}
		let special_days = {
			scheduleSpecialDays: makeEmtpyListByType(this.m_data_type)
		};
		if (this.m_data_type === "ARRAY") {
			special_days.scheduleSpecialDayAllYearss = makeEmtpyListByType(this.m_data_type);
		}
		let schedules = this.form_paginator_special_days.get_items();
		$.each(schedules, function(_, schedule) {
			let special_day = schedule.__raw_info;
			if (self.m_data_type === "ARRAY") {
				if (schedule.action === "Exclusion" && schedule.type === "Always") {
					// //este es el unico caso donde relleno un ALLYEARS
					special_day.overrides = 1;
					//esto se hace para evitar que el delta historico pise cambios todas las veces
					special_day.year = special_day.year || "1970";
					special_days.scheduleSpecialDayAllYearss.push(special_day);
				}
				else {
					special_day.overrides = schedule.action === "AddRange" ? 0 : 1;
					special_days.scheduleSpecialDays.push(special_day);
				}
			}
			else {
				let key;
				if (schedule.action === "Exclusion" && schedule.type === "Always") {
					// //este es el unico caso donde relleno un ALLYEARS
					special_day.overrides = true;
					//esto se hace para evitar que el delta historico pise cambios todas las veces
					delete special_day.year; //special_day.year = special_day.year || "1970";
					key = self.__format_date(special_day.day, special_day.month);
				}
				else {
					special_day.overrides = schedule.action === "AddRange" ? false : true;
					key = self.__format_date(special_day.day, special_day.month, special_day.year);
				}
				special_days.scheduleSpecialDays[key] = special_day;
			}
		});
		return special_days;
	};

	conf_form_schedule.prototype.format_initial_date = function(time)
	{
		let hour;

		if (typeof(time) === "object") {
			hour = time.Hours + ":" + time.Minutes;
		}
		else {
			//string
			hour = time;
			if (hour.length === 4) {
				hour = "0" + hour;
			}
		}
		let hour_and_sec = hour + ":00";
		return {
			full        : "1970-01-01 " + hour_and_sec,
			hour_and_sec: hour_and_sec,
			hour        : hour
		};
	};

	conf_form_schedule.prototype.get_scheduler_structure = function()
	{
		let structure = {
			scheduleDays       : makeEmtpyListByType(this.m_data_type),
			scheduleSpecialDays: makeEmtpyListByType(this.m_data_type)
		};
		if (this.m_data_type === "ARRAY") {
			structure.scheduleSpecialDayAllYearss = [];
		}
		return structure;
	};

	conf_form_schedule.prototype.make_scheduler_day = function(from, to, day, additionalData, enabled = 1)
	{
		let start = this.format_initial_date(from);
		let end = this.format_initial_date(to);
		let scheduler_day;
		if (this.m_data_type === "ARRAY") {
			scheduler_day = {
				startTime: start.full,
				endTime  : end.full,
				startHour: start.hour,
				endHour  : end.hour,
				dayOfWeek: day,
				enabled  : enabled
			};
		}
		else {
			scheduler_day = {
				startTime: start.hour_and_sec,
				endTime  : end.hour_and_sec,
				startHour: start.hour,
				endHour  : end.hour,
				dayOfWeek: day
			};
		}
		if (additionalData) {
			scheduler_day.additionalData = additionalData;
		}
		return scheduler_day;
	};

	conf_form_schedule.prototype.get_scheduler = function()
	{
		let scheduler = this.get_scheduler_structure();

		if (this.m_data_type === "ARRAY") {
			for (let dayName in this.scheduled_ranges) {
				if (this.scheduled_ranges.hasOwnProperty(dayName)) {
					let scheduled_day = this.scheduled_ranges[dayName];
					for (let i = 0; i < scheduled_day.ranges.length; i++) {
						let dayNumber = scheduled_day.day;
						let range = scheduled_day.ranges[i];
						let scheduler_day = this.make_scheduler_day(range.from, range.to, dayNumber, range.additionalData);
						scheduler.scheduleDays.push(scheduler_day);
					}
				}
			}
		}
		else {
			for (let dayName in this.scheduled_ranges) {
				if (this.scheduled_ranges.hasOwnProperty(dayName)) {
					let scheduled_day = this.scheduled_ranges[dayName];
					for (let i = 0; i < scheduled_day.ranges.length; i++) {
						let dayNumber = scheduled_day.day;
						let range = scheduled_day.ranges[i];
						let scheduler_day = this.make_scheduler_day(range.from, range.to, dayNumber, range.additionalData);
						let strDayNumber = dayNumber.toString();
						scheduler.scheduleDays[strDayNumber] = scheduler.scheduleDays[strDayNumber] || [];
						scheduler.scheduleDays[strDayNumber].push(scheduler_day);
					}
				}
			}
		}

		let special_days = this.get_scheduler_special_days();
		$.extend(true, scheduler, special_days);
		return scheduler;
	};

	/*
	 	Validates a specific range
	 */
	conf_form_schedule.prototype.validate_range = function(range)
	{
		return (this.hour_is_greater(range.to, range.from) || (range.to.Hours === "00" && range.to.Minutes === "00"));
	};

	/*
	 Returns true if both ranges are the same
	 */
	conf_form_schedule.prototype.is_same_range = function(range1, range2)
	{
		return (this.hour_is_equal(range1.to, range2.to) && this.hour_is_equal(range1.from, range2.from));
	};

	/*
	 	Returns true if range is from 00 to 00
	 */
	conf_form_schedule.prototype.is_null_range = function(range)
	{
		return (this.is_null_time(range.from) && this.is_null_time(range.to));
	};

	/*
	 	Returns true for time 00:00 false otherwise
	 */
	conf_form_schedule.prototype.is_null_time = function(time)
	{
		return (time.Hours === "00" && time.Minutes === "00");
	};

	/*
	 	Returns True if hour1 is greater than hour2
	 */
	conf_form_schedule.prototype.hour_is_greater = function(hour1, hour2)
	{
		return (hour1.Hours > hour2.Hours || (hour1.Hours === hour2.Hours && hour1.Minutes > hour2.Minutes));
	};

	/*
	 	Returns True if hour1 is the same hour as hour2
	 */
	conf_form_schedule.prototype.hour_is_equal = function (hour1, hour2)
	{
		return (hour1.Hours === hour2.Hours && hour1.Minutes === hour2.Minutes);
	};

	conf_form_schedule.prototype.get_exclusion_string = function(type)
	{
		if (!type) {
			return "";
		}
		let exclusions_strings = {
			Always: "<%=_T('Yearly')%>",
			Year  : "<%=_T('Only This Year')%>"
		};
		return exclusions_strings[type] || "";
	};

	conf_form_schedule.prototype.range_as_string = function(range)
	{
		if (!range) {
			return "";
		}
		if (this.is_null_range(range)) {
			return "<%=_T('All day')%>";
		}
		return range.from.Hours + ":" + range.from.Minutes + "/" + range.to.Hours + ":" + range.to.Minutes;
	};

	conf_form_schedule.prototype.range_list_as_string = function(range_list)
	{
		const self = this;
		let str_ranges = "";
		$.each(range_list, function(_, range) {
			if (range) {
				str_ranges += self.range_as_string(range) + " ";
			}
		});
		return str_ranges;
	};

	/*
	 Adds the specified range to the specified day, fails if range overlaps with an existing range
	 */
	conf_form_schedule.prototype.add_range = function(day, new_range, show_error_fn)
	{
		let ranges = this.scheduled_ranges[day].ranges;
		let index = ranges.length;
		for (let i = ranges.length - 1; i >= 0; i--) {
			let range = ranges[i];
			if (this.ranges_overlap(range, new_range) || this.is_same_range(range, new_range) || this.is_null_range(range)) {
				let message = FORMAT("<%=_T('Invalid range, it overlaps with range {0} of day {1}')%>", this.range_as_string(range), _T(day));
				if (typeof show_error_fn === "function") {
					show_error_fn(message);
				}
				else {
					this.show_error(message);
				}
				return false;
			}
			//ranges ending in 00 considered always greater
			if ((this.hour_is_greater(range.from, new_range.to) && !this.is_null_time(new_range.to)) || this.hour_is_equal(range.from, new_range.to)) {
				index = i;
			}
			else {
				//no hay mas rangos que arranquen despues que yo termino...
				break;
			}
		}
		ranges.splice(index, 0, new_range);
		return true;
	};

	conf_form_schedule.prototype.range_overlap_behind = function(range1, range2)
	{
		return ((this.hour_is_greater(range1.to, range2.from) || this.is_null_time(range1.to)) &&
			(this.hour_is_greater(range2.to, range1.from) || this.is_null_time(range2.to)));
	};

	conf_form_schedule.prototype.ranges_overlap = function(range1, range2)
	{
		if (this.range_overlap_behind(range1, range2)) {
			return true;
		}
		if (this.range_overlap_behind(range2, range1)) {
			return true;
		}
		return false;
	};

	conf_form_schedule.prototype.validate_range_overlapping = function(range_list, new_range)
	{
		const self = this;
		let is_ok = true;
		$.each(range_list || [], function(_, range) {
			if (self.ranges_overlap(range, new_range)) {
				is_ok = false;
				return false; // break
			}
		});
		return is_ok;
	};

	/*
	 	Get selected days from simulated combo as an array of days
	 */
	conf_form_schedule.prototype.get_selected_days = function()
	{
		let selected_days = [];
		let selection = $("#" + this.prefix + "day_range_list input");
		for (let i = 0; i < selection.length; i++) {
			if ($(selection[i]).prop("checked")) {
				let day = $(selection[i]).attr("day");
				if (day !== "all") {
					selected_days.push(day);
				}
			}
		}
		return selected_days;
	};

	conf_form_schedule.prototype.__make_empty_range = function()
	{
		return {from: {Hours: "00", Minutes: "00"}, to: {Hours: "00", Minutes: "00"}};
	};

	conf_form_schedule.prototype.__make_range = function($from, $to, show_error_fn = $.noop)
	{
		const parse_time = function($hour)
		{
			let element_id = $hour.attr("id");
			let hour = $hour.val();
			let match = hour.match(/(\d\d):(\d\d)/);
			if (!match || match[1] > 23 ) {
				show_error_fn("<%=_T('Hour value must be a number between 0 and 23')%>", element_id);
				return;
			}
			if (!match[2] || match[2] > 59) {
				show_error_fn("<%=_T('Minutes value must be a number between 0 and 59')%>", element_id);
				return;
			}
			return {Hours: match[1], Minutes: match[2]};
		};

		let range = {};
		range.from = parse_time($from);
		if (!range.from) {
			return;
		}
		range.to = parse_time($to);
		if (!range.to) {
			return;
		}

		return range;
	};

	/*
	 	Get selected range validating it's valid
	*/
	conf_form_schedule.prototype.get_scheduled_range = function(show_error_fn)
	{
		const self = this;
		if ($("#" + this.prefix + "all_day_range").prop("checked")) {
			return this.__make_empty_range();
		}
		const $from = $("#" + this.prefix + "from_range");
		const $to = $("#" + this.prefix + "to_range");
		const range = this.__make_range($from, $to, function(msg, element_id) {
			if (typeof(show_error_fn) === "function") {
				show_error_fn(msg, element_id);
			}
			else {
				self.show_error(msg, element_id);
			}
		});
		return range;
	};

	conf_form_schedule.prototype.build_html_range = function(range)
	{
		let htmlAdditionalData = "";
		let additional_range_info;

		if (range.additionalData) {
			if (this.owner && this.owner.get_scheduler_additional_range_info) {
				additional_range_info = this.owner.get_scheduler_additional_range_info(range.additionalData) || "";
			}
			htmlAdditionalData = "<span additional_data='true' class='intervalList'></span>";
		}
		const style = range && range !== "" && this.is_null_range(range)? "style='width:100%; margin-right: 0px;'":"";
		let rangeAllDay="hourLapse";
		if (this.is_null_range(range)) {
			rangeAllDay="allDay";
		}
		let html = FORMAT("" +
			`<div class='scheduleIntervalItem intervalRangeClass`+rangeAllDay+`' ${style}>` +
				"<span class='intervalText'>" + this.range_as_string(range) + "</span>" +
				"{0}" +
				"<button butIntervalDelete='true' class='butIntervalDelete' type='button' style='display:none;'><i></i></button>" +
			"</div>", htmlAdditionalData);

		const $node = $(html);
		$node.data("range", range);

		if (additional_range_info) {
			const $additional_data = $node.find("[additional_data]");
			if ($additional_data.length > 0) {
				let text = "";
				if (additional_range_info.text) {
					text = additional_range_info.text;
				}
				let tooltip = "";
				if (additional_range_info.tooltip) {
					tooltip = additional_range_info.tooltip;
				}
				$additional_data.text(text);
				$additional_data.attr("tooltip", tooltip);
			}
		}
		$node.find("[tooltip]").inconcert_tooltip({
			className: "genericTooltip",
			alignment: "left-bottom",
			["remove-delay"]: 100000,
		});
		return $node;
	};

	conf_form_schedule.prototype.show_waiting = function(message)
	{
		let $waiting_container;
		if (this.waiting_container_id) {
			$waiting_container = $("#" + this.waiting_container_id);
		}
		this.frm.show_waiting(message, $waiting_container);
	};

	conf_form_schedule.prototype.save_scheduler = function()
	{
		const self = this;

		let $save = $("#" + this.prefix + "save");
		$save.prop("disabled", true);

		var save = function()
		{
			self.show_waiting("<%=_T('Please wait until scheduler are saved.')%>");

			let scheduler = self.get_scheduler();

			self.callbacks.save(scheduler, function(success, error)
			{
				let message;
				if (success) {
					message = "<%=_T('Scheduler have been saved successfully.')%>";
					const message_type = "Info";
					self.frm.show_status_message(message, message_type);
				}
				else
				{
					if (typeof error === "object")
					{
						if (typeof error.err === "object") {
							error = ( error.err.result || "").toUpperCase();
						}
						else if (error.result) {
							error = ( error.result || "").toUpperCase();
						}
					}
					
					switch (error)
					{
						case "INVALID_REQUEST":
							message = "<%=_T('Invalid request.')%>";
							break;
						case "UNABLE_TO_SAVE":
							message = "<%=_T('Unable to save scheduler, please try again in a few minutes....')%>";
							break;
						case "FORBIDDEN":
							message = "<%=_T('You dont have permissions for save schedule.')%>";
							break;
						case "ALREADY_EXIST":
							message = "<%=_T('Schedule Name is already in use.')%>";
							break;
						default:
							message = "<%=_T('Failed to save scheduler, please try again in a few minutes...')%>";
					}
					self.show_status_message(message);
				}

				$save.prop("disabled", false);
			});
		};

		this.validate_scheduler(function(success) {
			if (!success) {
				$save.prop("disabled", false);
				return;
			}
			save();
		});
	};

	conf_form_schedule.prototype.validate_scheduler = function(callback = $.noop)
	{
		this.hide_errors();

		let scheduler = this.get_scheduler();
		this.callbacks.validate(scheduler, function(success, err) {
			if (!success) {
				callback(false, err);
				return;
			}
			callback(true, scheduler);
		});
	};

	conf_form_schedule.prototype.__$get_err_msg_container = function()
	{
		let $err_msg_container;
		if (this.err_msg_container_id) {
			$err_msg_container = $("#" + this.err_msg_container_id);
		}
		return $err_msg_container;
	};

	conf_form_schedule.prototype.show_status_message = function(message, message_type, $popup_msg)
	{
		const self = this;
		message_type = message_type || "Error";
		let timeout_ms = 5000; // infinite
		let $err_msg_container = $popup_msg || this.__$get_err_msg_container();

		var callbacks = {
			on_hide: function() {
				self.__hide_fields_err();
			}
		};
		this.frm.show_status_message(message, message_type, timeout_ms, undefined, undefined, $err_msg_container, callbacks);
	};

	conf_form_schedule.prototype.__hide_fields_err = function()
	{
		const $container = $("#" + this.container_id);
		const $fields_err = $container.find(".formFieldValidation");
		$fields_err.hide().removeClass("formFieldValidationError"); // TODO:Realizar el selector de forma mas performance
	};

	conf_form_schedule.prototype.show_error = function(message, field, $popup_msg)
	{
		const message_type = "Error";
		this.show_status_message(message, message_type, $popup_msg);
		this.__hide_fields_err();
		if (field) {
			$("#" + field).focus().next().show().addClass("formFieldValidationError");
		}
	};

	conf_form_schedule.prototype.hide_errors = function()
	{
		const $err_msg_container = this.__$get_err_msg_container();
		this.frm.hide_messages(undefined, undefined, $err_msg_container);
		this.__hide_fields_err();
	};

	conf_form_schedule.prototype.clean_fields = function()
	{
		$("#" + this.prefix + "day_range_selector .formVisualComboValue").text("");
		$("#" + this.prefix + "day_range_list input").prop("checked", false);
		$("#" + this.prefix + "from_range").val("");
		$("#" + this.prefix + "to_range").val("");
	};

	conf_form_schedule.prototype.can_add_scheduled_range = function(show_error_fn, callback = $.noop)
	{
		let response = {
			success: false,
			msg    : "",
			ctrl_id: ""
		};
		let selected_days = this.get_selected_days();
		if (selected_days.length === 0) {
			response.msg = "<%=_T('Please select at least one day from the list')%>";
			response.ctrl_id = this.prefix + "day_selection";
			callback(response);
			return;
		}
		let range = this.get_scheduled_range(show_error_fn);
		if (!range) {
			callback(response);
			return;
		}
		if (!this.validate_range(range) && !this.is_null_range(range)) {
			response.msg = FORMAT("<%=_T('Invalid range {0}, end time must be greater than start time')%>", this.range_as_string(range));
			response.ctrl_id = this.prefix + "to_range";
			callback(response);
			return;
		}

		response.selected_days = selected_days;
		response.range = range;

		// quien me instancia determina si se agrea o no
		this.callbacks.can_add_scheduled_range(response, callback);
	};

	/*
	 	Adds current selected range as a new scheduled range
	*/
	conf_form_schedule.prototype.add_scheduled_range = function()
	{
		const self = this;
		const show_popup_err = function(msg, ctrl_id) {
			if (self.m_newRangePopup) {
				self.m_newRangePopup.show_status_message(msg, "Error", true, 5000);
			}
		};
		this.hide_errors();
		this.can_add_scheduled_range(show_popup_err,
			function(response) {
				if (!response.success) {
					if (response.msg) {
						show_popup_err(response.msg, response.ctrl_id);
					}
					return;
				}
				let selected_days = response.selected_days;
				let range = response.range;
				let count_added_ranges = 0;
				for (let i = 0; i < selected_days.length; i++) {
					let day = selected_days[i];
					if (!self.add_range(day, range, show_popup_err)) {
						break;
					}
					count_added_ranges++;
				}
				if (count_added_ranges === selected_days.length) {
					self.refresh_range_table();
					self.hide_range_popup();
				}
				self.on_added_scheduled_range();
			}
		);
	};

	conf_form_schedule.prototype.on_added_scheduled_range = function(callback = $.noop)
	{
		this.callbacks.on_added_scheduled_range(callback);
	};

	conf_form_schedule.prototype.editable = function()
	{
		$("#" + this.prefix + "save")
			.prop("disabled", false)
			.show();
		$("#" + this.prefix + "cancel").attr("value", "<%=_T('Cancel')%>");
		$("#" + this.prefix + "panel").show();
		$("#" + this.prefix + "interval_list .butIntervalDeleteDay").show(); 
	};

	conf_form_schedule.prototype.readonly = function()
	{
		$("#" + this.prefix + "save")
			.prop("disabled", true)
			.hide();
		$("#" + this.prefix + "cancel").attr("value", "<%=_T('Close')%>");
		$("#" + this.prefix + "panel").hide();
		$("#" + this.prefix + "interval_list .butIntervalDelete").hide();
		$("#" + this.prefix + "interval_list .butIntervalDeleteDay").hide();
	};

	conf_form_schedule.prototype.__get_html_special_days = function()
	{
		if (!this.__can_configure_special_days()) {
			return "";
		}
		let html = "" + 
			"<hr class='clear' />" +
			"<div id='" + this.prefix + "special_days_section' style='clear: both'>" +
					"<div class='card-header d-flex flex-row justify-content-between'>" +
						"<h5><%=_T('Special Days List')%>  <span class='fa fa-question-circle' tooltip='" + "<%=_T('Select a date, hours range and a reason for adding this exception.')%>" + "'></span></h5>" + 
						"<button id='" + this.prefix + "special_days_new' class='pageButtonGeneric buttonColorWhite pageButtonNew height-1'> <i class='far fa-plus'> </i> <%=_T('Add Special Day')%> </button>" +
					"</div>" +
					"<div class='card-block'>" +
						"<div id='" + this.prefix + "new_special_days_section' style='display:none;'>" +
							"<div id='" + this.prefix + "special_days_message' class='genericFormMessagesContainer messageError genericFormMessagesContainerTop' hidden>" +
								"<label class='messageText'></label>" +
							"</div>" +
							"<div class='row'>" +
								"<div class='col-3'>" +
									"<div class='form-group'>" +
										"<label for='" + this.prefix + "special_days_action_type'><%=_T('Action Type')%><%=_T(':')%></label>" +
										"<select id='" + this.prefix + "special_days_action_type' class='form-control'></select>" +
									"</div>" +
								"</div>" +
								"<div class='col-3'>" +
									"<div class='form-group'>" +
										"<label class='required'>"+ "<%=_T('Description')%>" + "<%=_T(':')%>" + "</label>" +
										"<input id='" + this.prefix + "special_days_description' class='form-control' placeholder='" + "<%=_T('Enter description')%>" + "...' type='text' />" +
										"<i id='" + this.prefix + "special_days_description_validation' class='formFieldValidation formFieldValidationError' hidden></i>" +
									"</div>" +
								"</div>" +
							"</div>" +
							"<div class='row'>" +
								"<div class='col-2'>" +
									"<div class='form-group'>" +
										"<label>"+ "<%=_T('Date')%>" + "<%=_T(':')%>" + "</label>" +
										"<input id='" + this.prefix + "special_days_date' class='form-control' type='text' datepicker='single' />" +
										"<i id='" + this.prefix + "special_days_date_validation' class='formFieldValidation formFieldValidationError' hidden ></i>" +
									"</div>" +
								"</div>" +
								"<div class='col-6 col-xl-4' id='" + this.prefix + "special_days_range_section'>" +
									"<div class='d-flex flex-row'>" +
										// Checkbox
										"<div class='form-group'>" +
											"<div class='form-check form-check-right-input'>" +
												"<label for='" + this.prefix + "all_days_special_days_range1' class='form-check-label form-check-label-title'>" +
													"<input id='" + this.prefix + "all_days_special_days_range1' class='form-check-input' type='checkbox'>" +
													"<%=_T('Set all day')%>" +
												"</label>" +
											"</div>" +
										"</div>" +
										// From
										"<div class='form-group flex-grow-1 mr-2'>" +
											"<label class='required' for='" + this.prefix + "special_days_range_from1'>" + "<%=_T('Time from')%>" + "<%=_T(':')%>" + "</label>" +
											"<input id='" + this.prefix + "special_days_range_from1' class='form-control formFieldHour' type='text' placeholder='00:00' hour='true' />" +
											"<i id='" + this.prefix + "special_days_range_from1_validation' class='formFieldValidation formFieldValidationError' hidden></i>" +
										"</div>" +
										// To
										"<div class='form-group flex-grow-1'>" +
											"<label class='required' for='" + this.prefix + "special_days_range_to1'>" + "<%=_T('Time to')%>" + "<%=_T(':')%>" + "</label>" +
											"<input id='" + this.prefix + "special_days_range_to1' class='form-control formFieldHour' type='text' placeholder='00:00' hour='true' />" +
											"<i id='" + this.prefix + "special_days_range_to1_validation' class='formFieldValidation formFieldValidationError' hidden></i>" +
										"</div>" +
									"</div>" +
								"</div>" +
								"<div class='col-4' id='" + this.prefix + "special_days_exclusion_section'>" +
									"<div class='form-group'>" +
										"<label for='" + this.prefix + "special_days_exclusion_repeat' class='required'><%=_T('Repeat')%><%=_T(':')%></label>" +
										"<select id='" + this.prefix + "special_days_exclusion_repeat' class='form-control'></select>" +
										"<i id='" + this.prefix + "special_days_exclusion_repeat_validation' class='formFieldValidation formFieldValidationError' hidden></i>" +
									"</div>" +
								"</div>" +
								"<div class='col-8'>"+
									"<div id='" + this.prefix + "special_days_range_override_section' hidden>" +
										"<div override_range='true' class='row'>" +
											"<div class='col-12 d-flex flex-row'>" +
												// Checkbox
												"<div class='form-group'>" +
													"<div class='form-check form-check-right-input'>" +
														"<label for='" + this.prefix + "all_days_special_days_override_range1' class='form-check-label form-check-label-title'>" +
															"<input id='" + this.prefix + "all_days_special_days_override_range1' class='form-check-input' type='checkbox'>" +
															"<%=_T('Set all day')%>" +
														"</label>" +
													"</div>" +
												"</div>" +
												// From
												"<div class='form-group flex-grow-1 mr-2'>" +
													"<label class='required' for='" + this.prefix + "special_days_range_override_from1'>" + "<%=_T('Time from')%>" + "<%=_T(':')%>" + "</label>" +
													"<input id='" + this.prefix + "special_days_range_override_from1' class='form-control formFieldHour' type='text' placeholder='00:00' hour='true' />" +
													"<i id='" + this.prefix + "special_days_range_override_from1_validation' class='formFieldValidation formFieldValidationError' hidden></i>" +
												"</div>" +
												// To
												"<div class='form-group flex-grow-1 mr-3'>" +
													"<label class='required' for='" + this.prefix + "special_days_range_override_to1'>" + "<%=_T('Time to')%>" + "<%=_T(':')%>" + "</label>" +
													"<input id='" + this.prefix + "special_days_range_override_to1' class='form-control formFieldHour' type='text' placeholder='00:00' hour='true' />" +
													"<i id='" + this.prefix + "special_days_range_override_to1_validation' class='formFieldValidation formFieldValidationError' hidden></i>" +
												"</div>" +
												// From
												"<div class='form-group flex-grow-1 mr-2'>" +
													"<label class='required' for='" + this.prefix + "special_days_range_override_from2'>" + "<%=_T('Time from')%>" + "<%=_T(':')%>" + "</label>" +
													"<input id='" + this.prefix + "special_days_range_override_from2' class='form-control formFieldHour' type='text' placeholder='00:00' hour='true' />" +
													"<i id='" + this.prefix + "special_days_range_override_from2_validation' class='formFieldValidation formFieldValidationError' hidden></i>" +
												"</div>" +
												// To
												"<div class='form-group flex-grow-1'>" +
													"<label class='required' for='" + this.prefix + "special_days_range_override_to2'>" + "<%=_T('Time to')%>" + "<%=_T(':')%>" + "</label>" +
													"<input id='" + this.prefix + "special_days_range_override_to2' class='form-control formFieldHour' type='text' placeholder='00:00' hour='true' />" +
													"<i id='" + this.prefix + "special_days_range_override_to2_validation' class='formFieldValidation formFieldValidationError' hidden></i>" +
												"</div>" +
											"</div>" +
										"</div>" +
									"</div>" +
								"</div>"+
							"</div>" +
							
							// buttons
							"<div class='row custom-form-buttons-container'>" +
								"<div class='col-12 d-flex justify-content-end'>" +
									"<button id='" + this.prefix + "special_days_close' class='pageButtonGeneric buttonColorWhite' ><%=_T('Cancel')%></button>" +
									"<button id='" + this.prefix + "special_days_create_and_continue' class='pageButtonGeneric buttonColorWhite'><%=_T('Confirm & continue')%></button>" +
									"<button id='" + this.prefix + "special_days_create' class='pageButtonGeneric buttonColorBlue'><%=_T('Confirm')%></button>" +
								"</div>" +
							"</div>" +
						"</div>" +
						"<div class='row'>" +
							"<div class='col-12'>" +
								"<div id='" + this.prefix + "special_days_not_results_found' class='inlineMessagesContainer inlineMessagesContainer-mt-0 messageInfo mt-0' style='display:none'></div>" +
								"<table id='" + this.prefix + "special_days_list' cellpadding='0' cellspacing='0' border='0' class='viewGrid mt-0'>" +
									"<thead class='viewGridHeader'></thead>" +
									"<tbody class='viewGridBody'></tbody>" +
								"</table>" +
								"<div id='" + this.prefix + "special_days_paginator'></div>" +
							"</div>" +
						"</div>" +
					"</div>" +
			"</div>";

		return html;
	};

	/*
		Este markup se reenderizara en la clase RangePopup
	*/
	conf_form_schedule.prototype.__render_add_range_popup = function()
	{
		const self = this;
		const $top_add_range = this.ctrls_customs?.$top_add_range || "";
		const get_ctrls = function() {
			return "" +
			"<div class='card card-block'>" +
				$top_add_range + 
				"<div class='row'>" +
					"<div class='col-12 d-flex flex-row'>" +
						"<div class='form-group w-100'>" +
							"<label for='" + self.prefix + "day_selection' class='required readonly'>" + "<%=_T('Week Days')%>" + "<%=_T(':')%>" + "</label>" +
							"<div id='" + self.prefix + "day_selection' class='formVisualCombo'>" +
								"<div id='" + self.prefix + "day_range_selector' class='form-control'>" +
									"<label class='formVisualComboValue pl-0'>" + "</label>" +
								"</div>" +
								"<div id='" + self.prefix + "day_range_list' class='formVisualComboList formVisualComboCheckboxList' style='display:none;'>" +
									"<ul>" +
										"<li>" + "<div class='form-check'>" +
											"<input id='" + self.prefix + "day_range_all_days' class='form-check-input' type='checkbox' day='all'>" +
											"<label for='" + self.prefix + "day_range_all_days' class='form-check-label form-check-label-title'>" +
												"<%=_T('All Week')%>" +
											"</label>" +
										"</div> </li> <hr>" +
										"<li>" + "<div class='form-check'>" +
											"<input id='" + self.prefix + "day_range_all_sunday' class='form-check-input' type='checkbox' day='Sunday'>" +
											"<label for='" + self.prefix + "day_range_all_sunday' class='form-check-label form-check-label-title'>" +
												"<%=_T('Sunday')%>" +
											"</label>" +
										"</div> </li>" +
										"<li>" + "<div class='form-check'>" +
											"<input id='" + self.prefix + "day_range_all_monday' class='form-check-input' type='checkbox' day='Monday'>" +
											"<label for='" + self.prefix + "day_range_all_monday' class='form-check-label form-check-label-title'>" +
												"<%=_T('Monday')%>" +
											"</label>" +
										"</div> </li>" +
										"<li>" + "<div class='form-check'>" +
											"<input id='" + self.prefix + "day_range_all_tuesday' class='form-check-input' type='checkbox' day='Tuesday'>" +
											"<label for='" + self.prefix + "day_range_all_tuesday' class='form-check-label form-check-label-title'>" +
												"<%=_T('Tuesday')%>" +
											"</label>" +
										"</div> </li>" +
										"<li>" + "<div class='form-check'>" +
											"<input id='" + self.prefix + "day_range_all_wednesday' class='form-check-input' type='checkbox' day='Wednesday'>" +
											"<label for='" + self.prefix + "day_range_all_wednesday' class='form-check-label form-check-label-title'>" +
												"<%=_T('Wednesday')%>" +
											"</label>" +
										"</div> </li>" +
										"<li>" + "<div class='form-check'>" +
											"<input id='" + self.prefix + "day_range_all_thursday' class='form-check-input' type='checkbox' day='Thursday'>" +
											"<label for='" + self.prefix + "day_range_all_thursday' class='form-check-label form-check-label-title'>" +
												"<%=_T('Thursday')%>" +
											"</label>" +
										"</div> </li>" +
										"<li>" + "<div class='form-check'>" +
											"<input id='" + self.prefix + "day_range_all_friday' class='form-check-input' type='checkbox' day='Friday'>" +
											"<label for='" + self.prefix + "day_range_all_friday' class='form-check-label form-check-label-title'>" +
												"<%=_T('Friday')%>" +
											"</label>" +
										"</div> </li>" +
										"<li>" + "<div class='form-check'>" +
											"<input id='" + self.prefix + "day_range_all_saturday' class='form-check-input' type='checkbox' day='Saturday'>" +
											"<label for='" + self.prefix + "day_range_all_saturday' class='form-check-label form-check-label-title'>" +
												"<%=_T('Saturday')%>" +
											"</label>" +
										"</div> </li>" +
									"</ul>" +
								"</div>" +
							"</div>" +
							"<i class='formFieldValidation formFieldValidationError' hidden></i>" +
						"</div>" +
					"</div>" +
				"</div>"+
				"<div class='row'>" +
					"<div class='col-6'>" +
						// Checkbox
						"<div class='form-group'>"+
							"<div class='form-radiobutton'>"+
								"<label for='"+ self.prefix + "customize_schedule' class='form-radiobutton-label mr-0'>"+
									"<input type='radio' name='" + self.prefix + "range' value='customize_schedule' id='" + self.prefix + "customize_schedule' class='form-radiobutton-input' checked>"+
									"<span><%=_T('Customize schedule')%></span>"+
								"</label>"+
							"</div>"+
						"</div>"+
					"</div>"+
					"<div class='col-6'>" +
						"<div class='form-group'>"+
							"<div class='form-radiobutton'>"+
								"<label for='" + self.prefix + "all_day_range' class='form-radiobutton-label mr-0'>"+
									"<input type='radio' name='" + self.prefix + "range' value='all_day_range' id='" + self.prefix + "all_day_range' class='form-radiobutton-input'>"+
									"<span><%=_T('All day')%> (24hrs)</span>"+
								"</label>"+
							"</div>"+
						"</div>"+
					"</div>" +
				"</div>" +
				"<div id='" + self.prefix + "customize_schedule_container' class='row'>" +
					"<div class='col-6'>" +
						// From
						"<div class='form-group'>" +
							"<label id='" + self.prefix + "from_label' for='" + self.prefix + "from_range' class='required'>" + "<%=_T('From:')%>" + "</label>" +
							"<input id='" + self.prefix + "from_range' for='" + self.prefix + "from_label' class='form-control' type='text' placeholder='00:00' hour='true' />" +
							"<i id='" + self.prefix + "from_range_validation' class='formFieldValidation formFieldValidationError' hidden></i>" +
						"</div>" +
					"</div>" +
					"<div class='col-6'>" +
						// To
						"<div class='form-group'>" +
							"<label id='" + self.prefix + "to_label' for='" + self.prefix + "to_range' class='required'>" + "<%=_T('To:')%>" + "</label>" +
							"<input id='" + self.prefix + "to_range' for='" + self.prefix + "to_label' class='form-control' type='text' placeholder='00:00' hour='true' />" +
							"<i id='" + self.prefix + "to_range_validation' class='formFieldValidation formFieldValidationError' hidden></i>" +
						"</div>" +
					"</div>" +
				"</div>" +
			"</div>";
		};

		let html_popup = `
				<div id='${this.prefix}range_popup' class='systemPopWindow windowContainer schedulePopupWindow lightPopUpWindow' style='display:none;'>
					<div id='${this.prefix}range_popup_waiting' class='windowWaitingContainer' hidden>
						<div message='true' class='windowWaitingMessage'></div>
						<div class='windowWaitingAnimation'></div>
						<div class='windowWaitingOverlay'></div>
					</div>
					<div class='windowTop'>
						<div class='windowTitle'><%=_T('New schedule')%></div>
					</div>
					<div id='${this.prefix}range_popup_message' class='genericFormMessagesContainer messageError' style='display:none'>
						<a id='${this.prefix}range_popup_message_close' class='windowMessagesClose' href='javascript:void(0);'><%=_T('Close')%></a>
						<label class='messageText'></label>
					</div>
					<div class='windowMiddle' style='display:none'>
						<div class=''></div>
					</div>
					<div class='windowMiddle'>
						${get_ctrls()}
					</div>
					<div class='windowBottom d-flex justify-content-end'>
						<button id='${this.prefix}_add_selected_cancel' class='pageButtonGeneric buttonColorWhite'><%=_T('Cancel')%></button>
						<button id='${this.prefix}_add_selected_interval' class='pageButtonGeneric buttonColorBlue'><%=_T('Confirm')%></button>
					</div>
				</div>
			`;
		// primero tengo que remover contenedores previos
		$(`#${this.prefix}range_popup`).remove();
		// ahora si agrego el contenido del popup al body.
		$("body").append(html_popup);

		$(`#${this.prefix}range_popup`).find("[tooltip]").inconcert_tooltip({
			className: "bigTooltip",
			alignment: "right-bottom",
			["remove-delay"]: 100000,
		});
	};

	conf_form_schedule.prototype.__render = function()
	{
		const self = this;

		this.__render_add_range_popup(); // primero realizo el render del popup (add range).

		let has_to_add_buttons_in_an_external_container = false;
		if (this.buttons_container_id) {
			has_to_add_buttons_in_an_external_container = true;
		}

		let html_buttons =  "<button id='" + this.prefix + "cancel' class='pageButtonGeneric buttonColorWhite'><%=_T('Cancel')%></button>" +
							"<button id='" + this.prefix + "save' class='pageButtonGeneric buttonColorBlue'><%=_T('Confirm')%></button>";

		const get_html_header_actions = function() {
			if (self.without_buttons_container) {
				return "";
			}
			return "<div class='topFormAbsoluteButtonContainer pageButtonContainer'>" +
				(has_to_add_buttons_in_an_external_container === false ? html_buttons : "") +
			"</div>";
		};

		let skipButIntervalAddDay, skipButIntervalDeleteDay;
		if (this.ctrls_customs) {
			skipButIntervalAddDay = this.ctrls_customs.skipButIntervalAddDay;
			skipButIntervalDeleteDay = this.ctrls_customs.skipButIntervalDeleteDay;
		}

		let $html = $("" +
			"<div id='" + this.prefix + "panel' class='scheduleFormDataContainer pageFormContainer'>" +
				"<div class='scheduleEveryDayButtonContainer'>" +
					"<button id='" + this.prefix + "new_range_every_days' class='pageButtonGeneric buttonColorWhite pageButtonNew' tooltip='<%=_T('Add schedule')%>'><i class='far fa-plus'></i><%=_T('Add same schedule for all days')%></button>" +
				"</div>" +
				"<ul id='" + this.prefix + "interval_list' class='list-unstyled viewScheduleAsTable schedule'>" +
					"<li day='Sunday'>" +
						"<label><%=_T('Sunday')%><%=_T(':')%></label>" +
						"<div class='scheduleIntervalContainer flex-grow-1'></div>" +
						(skipButIntervalAddDay?"":
						"<button class='buttonColorGray gridActionButton delete butIntervalAddDay' tooltip='<%=_T('Add')%>'><i class='buttons-icons-add'></i><%=_T('Add Interval')%></button>")+
						(skipButIntervalDeleteDay?"":
						"<button class='buttonColorGray gridActionButton delete butIntervalDeleteDay' hidden tooltip='<%=_T('Delete')%>'><i class='buttons-icons-delete'></i><%=_T('Delete All Intervals')%></button>") +
					"</li>" +
					"<li day='Monday'>" +
						"<label><%=_T('Monday')%><%=_T(':')%></label>" +
						"<div class='scheduleIntervalContainer flex-grow-1'></div>" +
						(skipButIntervalAddDay?"":
						"<button class='buttonColorGray gridActionButton delete butIntervalAddDay' tooltip='<%=_T('Add')%>'><i class='buttons-icons-add'></i><%=_T('Add Interval')%></button>") +
						(skipButIntervalDeleteDay?"":
						"<button class='buttonColorGray gridActionButton delete butIntervalDeleteDay' hidden tooltip='<%=_T('Delete')%>'><i class='buttons-icons-delete'></i><%=_T('Delete All Intervals')%></button>") +
					"</li>" +
					"<li day='Tuesday'>" +
						"<label><%=_T('Tuesday')%><%=_T(':')%></label>" +
						"<div class='scheduleIntervalContainer flex-grow-1'></div>" +
						(skipButIntervalAddDay?"":
						"<button class='buttonColorGray gridActionButton delete butIntervalAddDay' tooltip='<%=_T('Add')%>'><i class='buttons-icons-add'></i><%=_T('Add Interval')%></button>") +
						(skipButIntervalDeleteDay?"":
						"<button class='buttonColorGray gridActionButton delete butIntervalDeleteDay' hidden tooltip='<%=_T('Delete')%>'><i class='buttons-icons-delete'></i><%=_T('Delete All Intervals')%></button>") +
					"</li>" +
					"<li day='Wednesday'>" +
						"<label><%=_T('Wednesday')%><%=_T(':')%></label>" +
						"<div class='scheduleIntervalContainer flex-grow-1'></div>" +
						(skipButIntervalAddDay?"":
						"<button class='buttonColorGray gridActionButton delete butIntervalAddDay' tooltip='<%=_T('Add')%>'><i class='buttons-icons-add'></i><%=_T('Add Interval')%></button>") +
						(skipButIntervalDeleteDay?"":
						"<button class='buttonColorGray gridActionButton delete butIntervalDeleteDay' hidden tooltip='<%=_T('Delete')%>'><i class='buttons-icons-delete'></i><%=_T('Delete All Intervals')%></button>") +
					"</li>" +
					"<li day='Thursday'>" +
						"<label><%=_T('Thursday')%><%=_T(':')%></label>" +
						"<div class='scheduleIntervalContainer flex-grow-1'></div>" +
						(skipButIntervalAddDay?"":
						"<button class='buttonColorGray gridActionButton delete butIntervalAddDay' tooltip='<%=_T('Add')%>'><i class='buttons-icons-add'></i><%=_T('Add Interval')%></button>") +
						(skipButIntervalDeleteDay?"":
						"<button class='buttonColorGray gridActionButton delete butIntervalDeleteDay' hidden tooltip='<%=_T('Delete')%>'><i class='buttons-icons-delete'></i><%=_T('Delete All Intervals')%></button>") +
					"</li>" +
					"<li day='Friday'>" +
						"<label><%=_T('Friday')%><%=_T(':')%></label>" +
						"<div class='scheduleIntervalContainer flex-grow-1'></div>" +
						(skipButIntervalAddDay?"":
						"<button class='buttonColorGray gridActionButton delete butIntervalAddDay' tooltip='<%=_T('Add')%>'><i class='buttons-icons-add'></i><%=_T('Add Interval')%></button>") +
						(skipButIntervalDeleteDay?"":
						"<button class='buttonColorGray gridActionButton delete butIntervalDeleteDay' hidden tooltip='<%=_T('Delete')%>'><i class='buttons-icons-delete'></i><%=_T('Delete All Intervals')%></button>") +
					"</li>" +
					"<li day='Saturday'>" +
						"<label><%=_T('Saturday')%><%=_T(':')%></label>" +
						"<div class='scheduleIntervalContainer flex-grow-1'></div>" +
						(skipButIntervalAddDay?"":
						"<button class='buttonColorGray gridActionButton delete butIntervalAddDay' tooltip='<%=_T('Add')%>'><i class='buttons-icons-add'></i><%=_T('Add Interval')%></button>") +
						(skipButIntervalDeleteDay?"":
						"<button class='buttonColorGray gridActionButton delete butIntervalDeleteDay' hidden tooltip='<%=_T('Delete')%>'><i class='buttons-icons-delete'></i><%=_T('Delete All Intervals')%></button>" )+
					"</li>" +
				"</ul>" +
			"</div>" +
			this.__get_html_special_days() +
			get_html_header_actions()
		);

		$html.find("[tooltip]").inconcert_tooltip({
			className: "genericTooltip",
			alignment: "right-bottom",
			["remove-delay"]: 100000,
		});

		$("#" + this.container_id).html($html);

		if (!this.without_buttons_container && has_to_add_buttons_in_an_external_container) {
			$("#" + this.buttons_container_id).html($(html_buttons));
		}
	};

	conf_form_schedule.prototype.show_range_popup = function($parent, day)
	{
		const self = this;
		this.hide_range_popup();
		this.m_newRangePopup = new RangePopup({frm: this.frm, prefix: this.prefix, day: day});
		this.m_newRangePopup.show({
			parentNode  : $parent,
			owner_object: this,
			callbacks: {
				onOpen: self.callbacks.on_open_scheduled_range_popup,
				onClose: self.callbacks.on_close_scheduled_range_popup
			}
		});
	};

	conf_form_schedule.prototype.hide_range_popup = function()
	{
		this.clean_fields();
		if (!this.m_newRangePopup) {
			return;
		}
		this.m_newRangePopup.finalize();
		this.m_newRangePopup = null;
	};

	conf_form_schedule.prototype.disable_ctrl = function($input, isDisabled)
	{
		const lbl_dom_id = $input.attr("for");
		const $label = $(`#${lbl_dom_id}`);
		$label.removeClass("required formSubLabel-ds");
		if (isDisabled) {
			$input.prop("disabled", true);
			$label.addClass("formSubLabel-ds");
		}
		else {
			$input.removeAttr("disabled");
			$label.addClass("required");
		}
	};

	conf_form_schedule.prototype.__set_events = function()
	{
		const self = this;

		const $cancel = $("#" + this.prefix + "cancel");
		$cancel
			.off("click")
			.on("click", function() {
				self.callbacks.cancel();
			});

		const $new_range_every_days = $("#" + this.prefix + "new_range_every_days");
		$new_range_every_days
			.off("click")
			.on("click", function() {
				self.show_range_popup($(this), "all");
			});

		$("#" + this.prefix + "all_day_range")
			.off("click")
			.on("click", function() {
				// to
				const $to_range = $("#" + self.prefix + "to_range");
				self.disable_ctrl($to_range, true);
				// from
				const $from_range = $("#" + self.prefix + "from_range");
				self.disable_ctrl($from_range, true);
				$(`#${self.prefix}customize_schedule_container`).hide();
			});

			$("#" + this.prefix + "customize_schedule")
			.off("click")
			.on("click",function() {
				$(`#${self.prefix}customize_schedule_container`).show();
				// to
				const $to_range = $("#" + self.prefix + "to_range");
				self.disable_ctrl($to_range, false);
				// from
				const $from_range = $("#" + self.prefix + "from_range");
				self.disable_ctrl($from_range, false);
				$from_range.focus();
			});

		$("#" + this.prefix + "day_range_selector")
			.off("click")
			.on("click", function()
			{
				let list_id = self.prefix + "day_range_list";
				let $days_range_list = $("#" + list_id);
				if ($days_range_list.is(":visible")) {
					self.days_popup.hide();
				}
				else {
					// Show popup
					self.days_popup.show();
				}
			});

		$("#" + this.prefix + "day_range_list input")
			.off("click")
			.on("click", function()
			{
				let $this = $(this);
				let day = $this.attr("day");
				if ($this.prop("checked")) {
					if (day === "all") {
						$("#" + self.prefix + "day_range_list input").prop("checked", true);
					}
				}
				else {
					if (day === "all") {
						$("#" + self.prefix + "day_range_list input").prop("checked", false);
					}
					else {
						$("#" + self.prefix + "day_range_list input[day='all']").prop("checked", false);
					}
				}

				let selected_days = "";
				let selection = $("#" + self.prefix + "day_range_list").find(":checked");
				for (let i = 0; i < selection.length; i++) {
					let name = $(selection[i]).attr("day");
					if (name !== "all") {
						selected_days += (selected_days.length ? ", " : "") + $(selection[i]).next().text();
					}
				}
				$("#" + self.prefix + "day_range_selector .formVisualComboValue").text(selected_days);
			});

		$("#" + this.prefix + "_add_selected_interval")
			.off("click")
			.on("click", function() {
				$("#" + self.prefix + "day_range_list").hide();
				self.add_scheduled_range();
			});

		$("#" + this.prefix + "_add_selected_cancel")
			.off("click")
			.on("click", function() {
				self.hide_range_popup();
			});

		let event_selector = ".butIntervalDelete";
		$("#" + this.prefix + "interval_list")
			.off("click", event_selector)
			.on("click", event_selector, function()
			{
				let $node = $(this).parent();
				let range = $node.data("range");
				let $row = $node.parent().parent();
				let day = $row.attr("day");
				let ranges = self.scheduled_ranges[day].ranges;
				for (let i = 0; i < ranges.length; i++) {
					if (self.is_same_range(ranges[i], range)) {
						self.scheduled_ranges[day].ranges.splice(i, 1);
						break;
					}
				}
				//if no days left, disable the node
				if (self.scheduled_ranges[day].ranges.length === 0) {
					// $row.find(".formLabel").addClass("formLabel-ds");
					$row.find(".butIntervalDeleteDay").hide();
				}
				self.refresh_range_table();
			});

		$("#" + this.prefix + "interval_list .butIntervalAddDay")
			.off("click")
			.on("click", function()
			{
				let $this = $(this);
				let $row = $this.parent();
				let day = $row.attr("day");
				self.show_range_popup($this, day);
			});

		$("#" + this.prefix + "interval_list .butIntervalDeleteDay")
			.off("click")
			.on("click", function()
			{
				let $this = $(this);
				let $row = $this.parent();
				let day = $row.attr("day");
				$.inconcertPopup.Show(
					"<%=_T('Confirm')%>",
					FORMAT("<%=_T('Do you want to delete the schedule from {0} day ?')%>", _T(day)),
					$.inconcertPopup.ButtonSets.BS_YESNO,
					function(response)
					{
						if (response.toLowerCase() !== "yes") {
							return;
						}
						//$row gets disabled
						$this.hide();
						// $row.find(".formLabel").addClass("formLabel-ds");
						self.scheduled_ranges[day].ranges = [];
						self.refresh_range_table();
					},
					undefined,
					{
						popup_id        : "conf_inconcertPopup",
						container_class : "confirmationPopUp",
						overlay_class   : "confirmationOverlay"
					}
				);
			});

		$("#" + this.prefix + "save")
			.off("click")
			.on("click", function() {
				self.save_scheduler();
			});

		

		// seteo eventos a la seccion de dias especiales
		this.__set_events_special_days();
	};

	conf_form_schedule.prototype.__set_events_special_days = function()
	{
		const self = this;
		if (!this.__can_configure_special_days()) {
			return;
		}

		const $action_type = $("#" + this.prefix + "special_days_action_type");
		 $action_type
			.off("change")
			.on("change", function() {
				self.__change_special_days_action();
			});

		var disable_range = function (disable, $from, $to) {
			self.__hide_fields_err();
			if (disable) {
				$from.prop("disabled", true);
				$from.addClass("formSubLabel-ds");
				$to.prop("disabled", true);
				$to.addClass("formSubLabel-ds");
			}
			else {
				$from.removeAttr("disabled");
				$from.removeClass("formSubLabel-ds");
				$to.removeAttr("disabled");
				$to.removeClass("formSubLabel-ds");
				$from.focus();
			}
		};

		$("#" + this.prefix + "all_days_special_days_range1")
			.off("click")
			.on("click", function() {
				const $from1 = $("#" + self.prefix + "special_days_range_from1");
				const $to1 = $("#" + self.prefix + "special_days_range_to1");
				const disable = $(this).prop("checked");
				disable_range(disable, $from1, $to1);
			});

		$("#" + this.prefix + "all_days_special_days_override_range1")
			.off("click")
			.on("click", function() {
				const disable = $(this).prop("checked");
				// par from to numero2
				const $override_from2 = $("#" + self.prefix + "special_days_range_override_from2");
				const $override_to2 = $("#" + self.prefix + "special_days_range_override_to2");
				disable_range(disable, $override_from2, $override_to2);
				// par from to numero1
				const $override_from1 = $("#" + self.prefix + "special_days_range_override_from1");
				const $override_to1 = $("#" + self.prefix + "special_days_range_override_to1");
				disable_range(disable, $override_from1, $override_to1);
			});

		this.form_paginator_special_days.set_events();
	};

	conf_form_schedule.prototype.__change_special_days_action = function()
	{
		const $range_section = $("#" + this.prefix + "special_days_range_section");
		const $range_override_section = $("#" + this.prefix + "special_days_range_override_section");
		const $exclusion_section = $("#" + this.prefix + "special_days_exclusion_section");
		const action_type = $("#" + this.prefix + "special_days_action_type").val();
		let help;

		if (action_type === "AddRange") {
			$exclusion_section.hide();
			$range_section.show();
			$range_override_section.hide();
			help = "<%=_T('Select a date, hours range and a reason for adding this exception.')%>";
		}
		else if (action_type === "Override") {
			$exclusion_section.hide();
			$range_section.hide();
			$range_override_section.show();
			help = "<%=_T('Select date, hours range and a reason for overriding the day configuration.')%>";
		}
		else if (action_type === "Exclusion") {
			$range_section.hide();
			$range_override_section.hide();
			$exclusion_section.show();
			help = "<%=_T('Select a date and write a reason or comment for the exclusion.')%>";
		}
		else {
			throw("conf_form_schedule.prototype.__change_special_days_action - Unrecognized action: " + action_type);
		}

		const $help = $("#" + this.prefix + "special_days_help");
		$help.text(help);
	};

	conf_form_schedule.prototype.on_edit_special_days = function(_)
	{
		 $("#" + this.prefix + "special_days_action_type").val("AddRange").trigger("change");
		this.__cleanup_ctrls_special_days_popup();
		this.__disabled_special_days_actions(true);
		$("#" + this.prefix + "special_days_description").focus();
	};

	conf_form_schedule.prototype.on_closed_special_days_popup = function()
	{
		this.__disabled_special_days_actions(false);
		this.__hide_fields_err();
	};

	conf_form_schedule.prototype.__cleanup_ctrls_special_days_popup = function()
	{
		const $date = $("#" + this.prefix + "special_days_date");
		this.frm.datepicker_set_date($date, /*now*/);
		$("#" + this.prefix + "special_days_description").val("");

		const $all_days_special_days_range1 = $("#" + this.prefix + "all_days_special_days_range1");
		if ($all_days_special_days_range1.prop("checked")) {
			$all_days_special_days_range1.trigger("click");
		}

		$("#" + this.prefix + "special_days_range_from1").val("");
		$("#" + this.prefix + "special_days_range_to1").val("");

		const $all_days_special_days_override_range1 = $("#" + this.prefix + "all_days_special_days_override_range1");
		if ($all_days_special_days_override_range1.prop("checked")) {
			$all_days_special_days_override_range1.trigger("click");
		}

		$("#" + this.prefix + "special_days_range_override_from1").val("");
		$("#" + this.prefix + "special_days_range_override_to1").val("");
		$("#" + this.prefix + "special_days_range_override_from2").val("");
		$("#" + this.prefix + "special_days_range_override_to2").val("");
		$("#" + this.prefix + "special_days_exclusion_repeat").val("");
	};

	conf_form_schedule.prototype.__disabled_special_days_actions = function(disabled)
	{
		$("#" + this.prefix + "special_days_new").prop("disabled", disabled);
		this.form_paginator_special_days.disable_grid_actions(disabled);
	};

	conf_form_schedule.prototype.__show_special_day_ctrl_err = function(err_info)
	{
		if (!err_info) {
			return;
		}
		const $err_msg_container = $("#" + this.prefix + "special_days_message");
		const mustShowScrollingEffect = false;
		this.frm.show_validation_error(err_info.$ctrl, err_info.message, undefined, mustShowScrollingEffect, undefined, $err_msg_container);
	};

	conf_form_schedule.prototype.__validate_special_day_to_add = function(callback = $.noop)
	{
		const self = this;

		this.form_paginator_special_days.hide_popup_msg();
		let response = {success: false, $ctrl: null, item: null, message: "<%=_T('Unable to Add Special Day.')%>"};

		let $date = $("#" + this.prefix + "special_days_date");
		let current_date = $date.datepicker("getDate");
		let day = current_date.getDate();
		let month = current_date.getMonth() + 1;
		let year = current_date.getFullYear();
		let $description = $("#" + this.prefix + "special_days_description");
		let action_type = $("#" + this.prefix + "special_days_action_type").val();

		let special_day = {
			date  : this.__format_date(day, month, year),
			reason: $description.val(),
			ranges: [],
			action: action_type
		};

		let validation_result = inConcert.Utils.validate(special_day.reason, "required");
		if ( !validation_result.success ) {
			response.message = "<%=_T('Description is required.')%>";
			response.$ctrl = $description;
			this.__show_special_day_ctrl_err(response);
			callback(response);
			return;
		}

		let new_range, override_range, $from1;
		let must_validate_overlap = false;

		if (action_type === "AddRange") {
			$from1 = $("#" + this.prefix + "special_days_range_from1");

			if ($("#" + this.prefix + "all_days_special_days_range1").prop("checked")) {
				new_range = this.__make_empty_range();
			}
			else {
				const $to1 = $("#" + this.prefix + "special_days_range_to1");
				new_range = this.__make_range($from1, $to1, function(msg, element_id) {
					let $hour = $("#" + element_id);
					response.message = msg;
					response.$ctrl = $hour;
					self.__show_special_day_ctrl_err(response);
				});
			}

			if (!new_range) {
				callback(response);
				return;
			}

			if (!this.validate_range(new_range)) {
				response.message = "<%=_T('Cannot add an invalid range')%>";
				response.$ctrl = $from1;
				this.__show_special_day_ctrl_err(response);
				callback(response);
				return;
			}
		}
		else if (action_type === "Override") {
			$from1 = $("#" + this.prefix + "special_days_range_override_from1");

			const all_day = $("#" + this.prefix + "all_days_special_days_override_range1").prop("checked");
			if (all_day) {
				new_range = this.__make_empty_range();
				override_range = this.__make_empty_range();
				must_validate_overlap = false;
			}
			else {
				const $to1 = $("#" + this.prefix + "special_days_range_override_to1");
				new_range = this.__make_range($from1, $to1, function(msg, element_id) {
					let $hour = $("#" + element_id);
					response.message = msg;
					response.$ctrl = $hour;
					self.__show_special_day_ctrl_err(response);
				});
			}

			if (!new_range) {
				callback(response);
				return;
			}

			if(this.form_paginator_special_days.find_row_data(special_day.date)){
				response.message = response.message + " " + "<%=_T('The date to override already exists.')%>";
				response.$ctrl = $date;
				this.__show_special_day_ctrl_err(response);
				callback(response);
				return;
			}

			if (!this.validate_range(new_range)) {
				response.message = "<%=_T('Cannot add an invalid range')%>";
				response.$ctrl = $from1;
				this.__show_special_day_ctrl_err(response);
				callback(response);
				return;
			}

			let $override_from2 = $("#" + this.prefix + "special_days_range_override_from2");
			if (!override_range) {
				if ($override_from2.val().length === 0) {
					override_range = this.__make_empty_range();
					must_validate_overlap = false;
				}
				else {
					let $override_to2 = $("#" + this.prefix + "special_days_range_override_to2");
					override_range = this.__make_range($override_from2, $override_to2, function(msg, element_id) {
						let $hour = $("#" + element_id);
						response.message = msg;
						response.$ctrl = $hour;
						self.__show_special_day_ctrl_err(response);
					});
					must_validate_overlap = true;
				}
				if (!override_range) {
					callback(response);
					return;
				}
			}

			if (!this.validate_range(override_range)) {
				response.message = "<%=_T('Cannot add an invalid range')%>";
				response.$ctrl = $override_from2;
				this.__show_special_day_ctrl_err(response);
				callback(response);
				return;
			}

			if (must_validate_overlap && this.ranges_overlap(new_range, override_range)) {
				response.message = "<%=_T('Cannot add overlaping ranges')%>";
				response.$ctrl = $from1;
				this.__show_special_day_ctrl_err(response);
				callback(response);
				return;
			}
		}
		else if (action_type === "Exclusion") {
			let $exclusion_repeat = $("#" + this.prefix + "special_days_exclusion_repeat");
			special_day.type = $exclusion_repeat.val();
			validation_result = inConcert.Utils.validate(special_day.type, "required");
			if ( !validation_result.success ) {
				response.message = "<%=_T('Exclusion Repeat is required.')%>";
				response.$ctrl = $exclusion_repeat;
				this.__show_special_day_ctrl_err(response);

				callback(response);
				return;
			}

			if (special_day.type === "Always") {
				special_day.date = this.__format_date(day, month);
			}
		}
		else {
			throw("conf_form_schedule.prototype.__validate_special_day_to_add - Unrecognized action: " + action_type);
		}

		let raw_info;
		const make_raw_info = function()
		{
			raw_info = {
				day: day,
				month: month,
				year: year,
				description: special_day.reason,
				overrides: self.__make_override_value(0),
				[self.m_attrNameSpecialDayRanges]: [] // 'scheduleSpecialDayRanges' a esto hay que realizarlo asi ya que el OE Nativo almacena en una estructura diferente.
			};

			if (action_type === "AddRange" || action_type === "Override") {
				let new_day_range = {
					day: day,
					month: month,
					year: year
				};

				let start = self.format_initial_date(new_range.from);
				let end = self.format_initial_date(new_range.to);
				if (self.m_data_type === "ARRAY") {
					new_day_range.startTime = start.full;
					new_day_range.endTime = end.full;
				}
				else {
					new_day_range.startTime = start.hour_and_sec;
					new_day_range.endTime = end.hour_and_sec;
				}

				if (action_type === "AddRange") {
					let row_special_day = self.form_paginator_special_days.find_row_data(special_day.date);
					if (row_special_day) {
						const is_ok = self.validate_range_overlapping(row_special_day.ranges, new_range);
						if (!is_ok) {
							return false;
						}
						const special_day_ranges = row_special_day.__raw_info[self.m_attrNameSpecialDayRanges];
						raw_info[self.m_attrNameSpecialDayRanges] = special_day_ranges;
					}
				}

				raw_info[self.m_attrNameSpecialDayRanges].push(new_day_range);
				new_day_range = null;
				if (action_type === "Override") {
					raw_info.overrides = self.__make_override_value(1);

					if (must_validate_overlap) {
						let override_day_range = {
							day: day,
							month: month,
							year: year
						};

						let start = self.format_initial_date(override_range.from);
						let end = self.format_initial_date(override_range.to);
						if (self.m_data_type === "ARRAY") {
							override_day_range.startTime = start.full;
							override_day_range.endTime = end.full;
						}
						else {
							override_day_range.startTime = start.hour_and_sec;
							override_day_range.endTime = end.hour_and_sec;
						}

						raw_info[self.m_attrNameSpecialDayRanges].push(override_day_range);
						override_day_range = null;
					}
				}
			}
			else {
			// action_type === Exclusion
				//este es el unico caso donde relleno un ALLYEARS
				raw_info.overrides = self.__make_override_value(1);
				//esto se hace para evitar que el delta historico pise cambios todas las veces
				////raw_info.year = "1970";
			}

			return true;
		};

		const is_ok = make_raw_info();
		response.message = FORMAT("<%=_T('Invalid range {0}, it overlaps with existing definition')%>", this.range_as_string(new_range));

		if (!is_ok) {
			response.$ctrl = $from1;
			this.__show_special_day_ctrl_err(response);
			callback(response);
			return;
		}

		special_day.__raw_info = raw_info;
		$.each(special_day.__raw_info[self.m_attrNameSpecialDayRanges], function(_, range_day) {
			let created_range = self.create_range_from_date_time(range_day.startTime, range_day.endTime);
			special_day.ranges.push(created_range);
		});

		response.item = special_day;
		response.success = true;
		response.message = "";
		if (action_type === "AddRange") {
		// Solo para el caso de Add Range, se puede actualizar la row (sino la misma siempre se agrega),
		//  entonces tengo que buscarla, para que actualice el rango que se ha agregado.
			response.$current_row = this.form_paginator_special_days.$find_row(special_day.date);
		}

		callback(response);
	};

	conf_form_schedule.prototype.__add_special_day = function(callback, must_create_and_contiune)
	{
		const self = this;
		callback = callback || $.noop;

		this.__validate_special_day_to_add(function(response)
		{
			if (!response.success) {
				callback(false);
				return;
			}
			self.__cleanup_ctrls_special_days_popup();
			let schedule = response.item;
			let msg_response = {msg: "", type: ""};
			if (!must_create_and_contiune) {
				msg_response.$msg_container = self.__$get_err_msg_container();
			}
			if (!response.$current_row || response.$current_row.length === 0) {
				msg_response.msg = "<%=_T('Special Day was successfully added.')%>";
				self.form_paginator_special_days.cleanup_edited_row();
			}
			else {
				msg_response.msg = "<%=_T('Special Day was successfully updated.')%>";
				self.form_paginator_special_days.$set_edited_row(response.$current_row);
			}
			msg_response.type = "Info";

			callback(true, schedule, msg_response);
		});
	};

}());
