/*jshint quotmark:false, esversion: 6*/
/*global $, inConcert*/


if (!this.inConcert) {
	this.inConcert = {};
}

(function () {

	function conf_realtime() 
	{
		this.app_events = {};
		this.paused_app_events = null;
	}

	if ( typeof inConcert.conf_realtime !== "function" ) {
		inConcert.conf_realtime = conf_realtime;
	}

	conf_realtime.prototype.event_suscribe = function( app_id, event_id, config )
	{
		this.app_events[ app_id ] = this.app_events[ app_id ] || {};
		if ( this.app_events[ app_id ][ event_id ] ) {
			this.event_unsuscribe( app_id, event_id );
		}
		var pub_id = config.pub_id;
		this.app_events[ app_id ][ event_id ] = this.app_events[ app_id ][ event_id ] || {
			pub_id: pub_id,
			config: config
		};

		this.app_events[ app_id ][ event_id ].handle = inConcert.app.messagebus.subscribe( pub_id, config.callback );
	};

	conf_realtime.prototype.event_unsuscribe = function( app_id, event_id )
	{
		if ( this.app_events[ app_id ] && this.app_events[ app_id ][ event_id ] ) {
			var event = this.app_events[ app_id ][ event_id ];
			inConcert.app.messagebus.unsubscribe( event.handle );
			delete this.app_events[ app_id ][ event_id ];
		}
	};

	conf_realtime.prototype.events_unsuscribe_app = function( app_id )
	{
		var self = this;
		$.each( this.app_events[ app_id ] || {}, function( event_id ) {
			self.event_unsuscribe( app_id, event_id );
		});
	};

	conf_realtime.prototype.events_unsuscribe_all = function( )
	{
		var self = this;
		$.each( this.app_events || {}, function( app_id ) {
			self.events_unsuscribe_app( app_id );
		});
	};

	conf_realtime.prototype.resume = function( )
	{
		var self = this;
		if ( !this.paused_app_events ) {
			return;
		}

		$.each( this.paused_app_events || {}, function( app_id, events ) {
			$.each( events || {}, function( event_id, data ) {
				self.event_suscribe( app_id, event_id, data.config );
			});
		});

		this.paused_app_events = null;
	};

	conf_realtime.prototype.pause = function( )
	{
		this.paused_app_events = inConcert.Utils.cloneObject( this.app_events );
		this.events_unsuscribe_all();
	};
}());
