
local function MakeExecutable (stateName, activityId, data, aux)
	if aux.empty(data.code) then
		return aux.invalidParameterActivity(stateName, activityId, "invalid data")
	end
	local text = ''
	--makes _G readonly
	text = text .. '\nsetContext(true)'
	--call code block function
	text = text .. '\nlocal function codeBlock()\n' .. data.code .. '\nend'
	text = text .. '\nlocal _status, _result = pcall(codeBlock)'
	--makes _G editable
	text = text .. '\nsetContext()'
	--validates result
	text = text .. '\nif _status then'
		text = text .. '\nlocal ok, message = pcall(cjson.encode, _result)'
		text = text .. '\nif not ok then'
		text = text .. '\nerror("_result is not serializable - " .. message)'
		text = text .. '\nend'
		text = text .. '\nlogTrace("DEBUG", string.format("Processing activity (end) result: %s", message))'
	text = text .. '\nelse'
		text = text .. '\nlogTrace("ERROR", string.format("Failed to run code: %s", _result))'
	text = text .. '\nend'
	--process result
	if not aux.empty(data.result) then
		text = text .. string.format('\n%s = { status = _status, data = _result }', data.result)
	end
	return 200, text
end

return {
	MakeExecutable = MakeExecutable
}
