
local function MakeMetadataString (metadata)
	if type(metadata) ~= "table" or type(metadata.filters) ~= "table" then
		return "{}"
	end
	local metadataString = "{" .. "\n\t" ..
		string.format("operationType = '%s',", metadata.operationType or "OR") .. "\n\t" ..
		"filters = {"

	local filters = ""
	for i, field in pairs(metadata.filters) do
		if i > 1 then
			filters = filters .. ","
		end
		filters = filters .. string.format("\n\t\t{ name = '%s', value = %s }", field.name, field.value)
	end
	filters = filters .. "\n\t}"

	metadataString = metadataString .. filters .. "\n}"

	return metadataString
end

--[[
	Sample:
	------
		metadata = {
			filters = {
				{name = "ciudad", value = "colonia"},
				{name = "ciudad", value = "montevideo"}
			},
			operationType = "OR" -- OR o AND
		}
]]--
local function MakeExecutable (stateName, activityId, data, aux)
	if aux.empty(data.message) then
		return aux.invalidParameterActivity(stateName, activityId, "invalid data")
	end

	local metadataString = MakeMetadataString(data.metadata)
	local code = [[
local _metadata = %s
local _result = ExecuteApiQnAMaker(__vccName, %s, _metadata)
]]
	code = string.format(code, metadataString, data.message) .. "\n" ..
		'logTrace("DEBUG", string.format("Processing activity (end) result: %s", cjson.encode(_result)))'

	--process result
	if not aux.empty(data.result) then
		code = code .. "\n" .. string.format('%s = _result', data.result)
	end

	return 200, code
end

return {
	MakeExecutable = MakeExecutable
}
