local function MakeVariableAssignation(mapping)
	local text = ""
	for i, interface in ipairs(mapping) do 
		text = text .. string.format("\n%s = _result[\"result\"][\"%s\"]",interface.name, interface.name)
	end
	return text
end

local function MakeMustacheAssignation(data)
	local text = ""
	--Empezamos por la url
	if string.find(data.url, "{{[^{]*}}") then
		for m in string.gmatch(data.url,"{{[^{]*}}") do
			text = text .. string.format("\n_data.url = string.gsub(_data.url,[[%s]],%s)",m,string.gsub(m,"[{}]",""))
		end
	end

	--Seguimos por el body
	if string.find(data.metadata.body, "{{[^{]*}}") then
		for m in string.gmatch(data.metadata.body,"{{[^{]*}}") do
			text = text .. string.format("\n_data.metadata.body = string.gsub(_data.metadata.body,[[%s]],%s)",m,string.gsub(m,"[{}]",""))
		end
	end

	-- Seguimos por el body si es de tipo form
	if table.getn(data.metadata.bodyParameters) > 0 then
        for index, param in ipairs(data.metadata.bodyParameters) do
			--Key de parameter
			if string.find(param["key"], "{{[^{]*}}") then
				for m in string.gmatch(param["key"],"{{[^{]*}}") do
					text = text .. string.format("\n_data.metadata.bodyParameters[%d].key = string.gsub(_data.metadata.bodyParameters[%d].key,[[%s]],%s)",index,index, m,string.gsub(m,"[{}]",""))
				end
			end
			--value de parameter
			if string.find(param["value"], "{{[^{]*}}") then
				for m in string.gmatch(param["value"],"{{[^{]*}}") do
					text = text .. string.format("\n_data.metadata.bodyParameters[%d].value = string.gsub(_data.metadata.bodyParameters[%d].value,[[%s]],%s)",index,index, m,string.gsub(m,"[{}]",""))
				end
			end
        end
    end

	-- Seguimos por los headers
	if table.getn(data.metadata.headers) > 0 then
        for index, param in ipairs(data.metadata.headers) do
			--Key de headers
			if string.find(param["key"], "{{[^{]*}}") then
				for m in string.gmatch(param["key"],"{{[^{]*}}") do
					text = text .. string.format("\n_data.metadata.headers[%d].key = string.gsub(_data.metadata.headers[%d].key,[[%s]],%s)",index,index, m,string.gsub(m,"[{}]",""))
				end
			end
			--value de headers
			if string.find(param["value"], "{{[^{]*}}") then
				for m in string.gmatch(param["value"],"{{[^{]*}}") do
					text = text .. string.format("\n_data.metadata.headers[%d].value = string.gsub(_data.metadata.headers[%d].value,[[%s]],%s)",index,index, m,string.gsub(m,"[{}]",""))
				end
			end
        end
    end

	-- Por ultimo query parameters
	if table.getn(data.metadata.query) > 0 then
        for index, param in ipairs(data.metadata.query) do
			--Key de query
			if string.find(param["key"], "{{[^{]*}}") then
				for m in string.gmatch(param["key"],"{{[^{]*}}") do
					text = text .. string.format("\n_data.metadata.query[%d].key = string.gsub(_data.metadata.query[%d].key,[[%s]],%s)",index,index, m,string.gsub(m,"[{}]",""))
				end
			end
			--value de query
			if string.find(param["value"], "{{[^{]*}}") then
				for m in string.gmatch(param["value"],"{{[^{]*}}") do
					text = text .. string.format("\n_data.metadata.query[%d].value = string.gsub(_data.metadata.query[%d].value,[[%s]],%s)",index,index, m,string.gsub(m,"[{}]",""))
				end
			end
        end
    end
	return text
end

local function MakeExecutable (stateName, activityId, data, aux)
	local text = string.format('local _data = json.decode([[%s]])',json.encode(data))
	text = text .. MakeMustacheAssignation(data)
	text = text .. "\n _result = {}"
	text = text .. "\nlocal _status = activityHttpRestfull.processHttpAPIRequest(_data,_result)"
	text = text .. MakeVariableAssignation(data.metadata.mapping)
	if data.result then
		text = text .. string.format("\n%s = _status", data.result)
	end
	text =  text .. "\nlogTrace('DEBUG', 'Processing activity (end)')"

	return 200, text
end

return {
	MakeExecutable = MakeExecutable
}
