local function MakeExecutable (stateName, activityId, data, aux)
	if aux.empty(data.query) or aux.empty(data.result) or aux.empty(data.knowledgeFusionBases) then
		return aux.invalidParameterActivity(stateName, activityId, "invalid data")
	end

	local code = [[
        local _metadata = {
            version = 2,
            knowledgebases = '%s',
            words_limit = %s,
            number_of_words = %s
        }

        logTrace("DEBUG", json.encode(_metadata))

        local _result = ExecuteApiQnAMaker(__vccName, %s, _metadata)
    ]]
	code = string.format(code, json.encode(data.knowledgeFusionBases), data.words_limit and "true" or "false", tostring(data.number_of_words or 75), data.query) .. "\n" ..
		'logTrace("DEBUG", string.format("Processing activity (end) result: %s", cjson.encode(_result)))'

	--process result
	if not aux.empty(data.result) then
		code = code .. "\n" .. string.format('%s = _result', data.result)
	end

	return 200, code
end

return {
	MakeExecutable = MakeExecutable
}

