
local cjson = require "cjson"

local function makeFields (fields, aux)
	local code = "{"
	for _, field in pairs(fields) do
		code = code .. string.format("\n\t{ name = '%s', value = %s, hidden = %s },", 
			field.name, field.value, aux.booleanValue(field.hidden))
	end
	code = code .. "\n}"
	return code
end

local function MakeExecutable (stateName, activityId, data, aux)
	local text = [[
local _fields = %s
SetReportingData(__interactionId, 'process_flow_data', nil, _fields)
logTrace('DEBUG', 'Processing activity (end)')
]]
	text = string.format(text, makeFields(data.fields, aux))
	return 200, text
end

return {
	MakeExecutable = MakeExecutable
}
