local cjson = require "cjson"

local function MakeExecutable (stateName, activityId, data, aux)
	if aux.empty(data.message) or aux.empty(data.messageType) then
		return aux.invalidParameterActivity(stateName, activityId, "invalid data")
	end
	local message = data.message
	local text = ''
	if type(message) == "table" then
		message = cjson.encode(cjson.encode(message))
		text = text .. string.format('local _message = cjson.decode(%s)', message)
		text = text .. '\nprocessBrackets(_message)'
	else
		text = text .. string.format('local _message = %s', message)
	end
	text = text .. string.format('\nSetAutomaticMessage(__interactionId, "%s", _message)', data.messageType)
	return 200, text
end

return {
	MakeExecutable = MakeExecutable
}
