/* jshint forin:true, noarg:true, jquery:true, noempty:true, eqeqeq:true, bitwise:true,
	strict:true, undef:true, unused:vars, curly:true, browser:true, indent:false, maxerr:50, quotmark:double */

/* global inConcert */

if (!this.inConcert) {
	this.inConcert = {};
}

(function () {
	//"use strict";

	var actions = [
		{
			id : "properties",
			name : "<%=_T('Properties')%>",
			description : "<%=_T('Properties')%>",
			selection : true,
			singleSelection : true
		},
		{
			id : "copy",
			name : "<%=_T('Copy')%>",
			description : "<%=_T('Copy (Ctrl + C).')%>",
			selection : true,
			connectors : true
		},
		{
			id : "paste",
			name : "<%=_T('Paste')%>",
			description : "<%=_T('Paste (Ctrl + V).')%>",
			enabled : function(self) {
				return self.editor.CanPaste();
			}
		},
		{
			id : "delete",
			name : "<%=_T('Delete')%>",
			description : "<%=_T('Delete (delete).')%>",
			selection : true,
			connectors : true
		},
		{
			id : "undo",
			name : "<%=_T('Undo')%>",
			description : "<%=_T('Undo (Ctrl + Z).')%>",
			withoutText : true,
			sectionBegin : "flowDesignerUndoActions",
			enabled : function(self) {
				return self.editor.CanUndo();
			}
		},
		{
			id : "redo",
			name : "<%=_T('Redo')%>",
			description : "<%=_T('Redo (Ctrl + Y).')%>",
			withoutText : true,
			enabled : function(self) {
				return self.editor.CanRedo();
			}
		},
		{
			id : "zoom_in",
			name : "<%=_T('Zoom In')%>",
			description : "<%=_T('Zoom in.')%>",
			withoutText : true,
			sectionBegin : "flowDesignerZoomActions"
		},
		{
			id : "zoom_out",
			name : "<%=_T('Zoom Out')%>",
			description : "<%=_T('Zoom out.')%>",
			withoutText : true
		},
		{
			id : "zoom_actual",
			name : "<%=_T('Restore Zoom')%>",
			description : "<%=_T('Restore size.')%>",
			withoutText : true
		}
	];

	function adm_process_flow_state_actions_bar(main) {
		adm_process_flow_state_actions_bar.uber.constructor.call(this, main);
	}

	inConcert.Utils.inherit( adm_process_flow_state_actions_bar, inConcert.adm_process_flow_actions_bar );

	if (typeof inConcert.adm_process_flow_state_actions_bar !== "function") {
		inConcert.adm_process_flow_state_actions_bar = adm_process_flow_state_actions_bar;
	}

	adm_process_flow_state_actions_bar.prototype.GetActions = function() {
		return actions;
	};

}());
