/* jshint forin:true, noarg:true, jquery:true, noempty:true, eqeqeq:true, bitwise:true,
	strict:true, undef:true, unused:vars, curly:true, browser:true, indent:false, maxerr:50, quotmark:double, esversion: 9 */

/* global $, inConcert, Mustache */

if (!this.inConcert) {
	this.inConcert = {};
}

(function () {
	//"use strict";

	var format = inConcert.Utils.format;
	var templates = inConcert.templates.process_flows;

	var id = "dialer_contact_batch";

	function adm_process_flow_activity(editor, node) {
		adm_process_flow_activity.uber.constructor.call(this, editor, node);
		this.editor = editor;
		this.node = node;
		var data = editor.GetNodeData(node);
		this.isNew = !data;
		this.data = data || {outputs: []};
		this.frm = editor.main.frm;

		const self = this;
		this.focusFirst = true;

		this.actionType = {
			id : "actionType",
			name : "<%=_T('Action Type')%>",
			description : "<%=_T('Select action type')%>",
			required : true,
			not_extended : true,
			form_group: true,
			options : [
				{ 
					id : "reschedule_contact",
					name : "<%=_T('Reschedule Contact')%>"
				},
				{ 
					id : "add_to_batch",
					name : "<%=_T('Add Contact to Batch')%>"
				},
				{ 
					id : "cancel_contact",
					name : "<%=_T('Cancel Contact')%>"
				},
				{ 
					id : "pause_contact",
					name : "<%=_T('Pause Contact')%>"
				},
				{ 
					id : "resume_contact",
					name : "<%=_T('Resume Contact')%>"
				},
				{ 
					id : "recycle_contact",
					name : "<%=_T('Recycle Contact')%>"
				},
				{ 
					id : "finish_contact",
					name : "<%=_T('Finish Contact')%>"
				},
				{ 
					id : "remove_contact",
					name : "<%=_T('Remove Contact')%>"
				},
				{ 
					id : "change_priority",
					name : "<%=_T('Change Priority')%>"
				},
				{ 
					id : "agent_assign",
					name : "<%=_T('Agent Assign')%>"
				}
			],
			change : function () {
				self.__selectActionType($(this).val());
			}
		};

		this.contactId = {
			id: "contactId",
			name: "<%=_T('Contact Id')%>",
			description: "<%=_T('Contact Id')%>",
			required: true,
			not_extended: true,
			form_group: true,
			variable: true,
			controlContainerClass: "position-relative",
			span: true,
			spanClass: "ic_variable_icon_container",
			variableIconClass: "ic_variable_icon far fa-at",
		};

		this.campaignDefinition = {
			id: "campaign",
			name: "<%=_T('Campaign')%>",
			description: "<%=_T('Campaign')%>",
			required: true,
			not_extended: true,
			form_group: true,
			variable: true,
			controlContainerClass: "position-relative",
			span: true,
			spanClass: "ic_variable_icon_container",
			variableIconClass: "ic_variable_icon far fa-at",
		};

		this.lotDefinition = {
			id: "lot",
			name: "<%=_T('Batch')%>",
			description: "<%=_T('Batch')%>",
			required: true,
			not_extended: true,
			form_group: true,
			variable: true,
			controlContainerClass: "position-relative",
			span: true,
			spanClass: "ic_variable_icon_container",
			variableIconClass: "ic_variable_icon far fa-at",
		};

		this.scheduledDateDefinition = {
			id: "scheduledDate",
			name: "<%=_T('Scheduled Date/Time')%>",
			description: "<%=_T('Scheduled Date/Time')%>",
			// required: true,
			not_extended: true,
			form_group: true,
			variable: true,
			controlContainerClass: "position-relative",
			span: true,
			spanClass: "ic_variable_icon_container",
			variableIconClass: "ic_variable_icon far fa-at",
		};

		this.phoneDefinition = {
			id: "phone",
			name: "<%=_T('Phone')%>",
			description: "<%=_T('Phone')%>",
			// required: true,
			not_extended: true,
			form_group: true,
			variable: true,
			controlContainerClass: "position-relative flex-grow-1 w-100",
			span: true,
			spanClass: "ic_variable_icon_container",
			variableIconClass: "ic_variable_icon far fa-at",
		};

		this.agentDefinition = {
			id: "agent",
			name: "<%=_T('Agent')%>",
			description: "<%=_T('Agent')%>",
			// required: true,
			not_extended: true,
			form_group: true,
			variable: true,
			controlContainerClass: "position-relative",
			span: true,
			spanClass: "ic_variable_icon_container",
			variableIconClass: "ic_variable_icon far fa-at",
		};

		this.externalId = {
			id: "externalId",
			name: "<%=_T('External Id')%>",
			description: "<%=_T('External Id')%>",
			required: true,
			not_extended: true,
			form_group: true,
			variable: true,
			controlContainerClass: "position-relative",
			span: true,
			spanClass: "ic_variable_icon_container",
			variableIconClass: "ic_variable_icon far fa-at",
		};

		this.phoneTypeDefinition = {
			id: "phoneType",
			name: "<%=_T('Phone Type')%>",
			description: "<%=_T('Phone Type')%>",
			// required: true,
			not_extended: true,
			form_group: true,
			controlContainerClass: "position-relative  inputControl flex-grow-1 w-100",
			options : [
				{ 	
					id : "HOME",
					name : "<%=_T('Home Phone')%>" 
				},
				{ 
					id: "CELLULAR",
					name : "<%=_T('Mobile Phone')%>" 
				},
				{ 
					id: "OFFICE",
					name : "<%=_T('Office Phone')%>" 
				},
				{ 
					id: "FAX",
					name : "<%=_T('Fax')%>" 
				},
			],
		};

		this.nameDefinition = {
			id: "name",
			name: "<%=_T('Name')%>",
			description: "<%=_T('Contact name.')%>",
			required: true,
			not_extended: true,
			form_group: true,
		};

		this.restartAttempts = {
			id : "restartAttempts",
			name : "<%=_T('Restart attempts')%>",
			description : "<%=_T('Restart attempts')%>",
			with_dots: false,
			form_group: false,
			controlContainerClass: "form-check",
			envolving_label_class: "form-check-label form-check-label-title",
			checkBoxClass: "form-check-input",
			envolving_label: true,
			without_label: true
		};

		this.relativePriorityDefinition = { 
			id         : "priority_relativeNumber_input",
			name       : "<%=_T('Relative Priority value')%>", 
		};

		this.priorityAbsoluteNumber = {
			id: "priority_absoluteNumber",
			// required: true,
			not_extended: true,
			form_group: true,
			inverse_order: true
		};

		this.priorityType = {
			id: "priority_type",
			// required: true,
			not_extended: true,
			form_group: true,
			inverse_order: true
		};

	}

	inConcert.Utils.inherit(adm_process_flow_activity, inConcert.adm_process_flow_activities.base);

	if (typeof inConcert.adm_process_flow_activities[id] !== "function") {
		inConcert.adm_process_flow_activities[id] = adm_process_flow_activity;
	}

	adm_process_flow_activity.prototype.id = id;
	adm_process_flow_activity.prototype.name = "<%=_T('Manage Contact in Batch')%>";
	// adm_process_flow_activity.prototype.description = "<%=_T('Manage Contact in Batch')%>";
	adm_process_flow_activity.prototype.group = "dialer";
	adm_process_flow_activity.prototype.image = "ico-dialer.svg";

	adm_process_flow_activity.prototype.__getClassName = function() {
		return "popOver640w popOverFixedHeight flowDesignerGlobalModal botActivity_dialer_contact_batch";
	};

	adm_process_flow_activity.prototype.__makeContent = function () {
		let $content = this.__makeFormContent();
		return this.Make($content);
	};

	adm_process_flow_activity.prototype.Make = function($content) {
		// this.__makeTypes(this.data);
		return this.__makeQuickreplies(this.data, $content);
	};

	adm_process_flow_activity.prototype.__afterAppendBody = function() {
		const self = this;

		this.__selectActionType(this.data[this.actionType.id] || "dialer_contact_batch", true);

		if (this.data[this.actionType.id] === "add_to_batch") {
			$.each(this.data.contactAttributes, function (_, attribute) {
				let button = self.__addQuickreply(attribute, $("[contactattributes_list]"));
				button.find("[control=contactattr_name]").val(attribute.attrName);
				button.find("[control=contactattr_value]").val(attribute.attrValue);
				button.find("[control=contactattr_type]").val(attribute.attrType).change();
				button.find("[contactattr_title]").html(attribute.attrName);
			});

			let firstPhone = true;
			$.each(this.data.contactPhones, function (_, phone) {
				if (firstPhone) {
					self.$get("[phoneRow]").find("[control=phone]").val(phone.phoneNumber);
					self.$get("[phoneRow]").find("[control=phoneType]").val(phone.phoneType).change();
					firstPhone = false;
				} else {
					let phoneInput = self.__createPhoneInput();
					phoneInput.find("[control=phone]").val(phone.phoneNumber);
					phoneInput.find("[control=phoneType]").val(phone.phoneType).change();
					self.$get("[phoneRow]:last").after(phoneInput);
				}
			});
		}
		
		self.$get("input[type=radio][name=priority_type]").click(function(){
			
			const priorityType = self.$get("input[type=radio][name=priority_type]:checked").val();
			
			if (priorityType === "priority_relative") {
				self.$get("[scoringSlider]").show();
				self.__hideControl(self.priorityAbsoluteNumber);
			} else {
				self.$get("[scoringSlider]").hide();
				self.__showControl(self.priorityAbsoluteNumber);
			}
		});

		if (this.data[this.actionType.id] === "change_priority") {
			self.$get(`[value=${this.data.priorityType}]`).click();
		}

		const $inputs = self.$get("span[class=ic_variable_icon_container");
		self.__addAutocompleteToInput($inputs);
	};

	adm_process_flow_activity.prototype.__selectActionType = function (actionType, initial) {
		this.__clearErrors();
		switch (actionType) {
			case "reschedule_contact":
				this.__selectRescheduleContact(initial);
				break;
			case "add_to_batch":
				this.__selectAddToBatch(initial);
				break;
			case "cancel_contact":
			case "pause_contact":
			case "resume_contact":
			case "finish_contact":
			case "remove_contact":
				this.__selectContactStatus(actionType);
				break;
			case "recycle_contact":
				this.__selectRecycleContact(initial);
				break;
			case "change_priority":
				this.__selectChangePriority(initial);
				break;
			case "agent_assign":
				this.__selectAgentAssign(initial);
				break;
		}
	};

	adm_process_flow_activity.prototype.__selectRescheduleContact = function () {
		this.__showControl(this.contactId);
		this.__showControl(this.campaignDefinition);
		this.__showControl(this.lotDefinition);
		this.__showControl(this.scheduledDateDefinition);
		this.__showControl(this.agentDefinition);
		this.__showControl(this.phoneDefinition);
		this.__showControl(this.phoneTypeDefinition);
		
		this.__hideControl(this.externalId);
		this.__hideControl(this.nameDefinition);
		this.__hideControl(this.restartAttempts);
		this.__hideControl(this.priorityAbsoluteNumber);

		const scheduledDateInput = this.$get("[control_label=scheduledDate]");
		if (scheduledDateInput.hasClass("formLabel-rq")) {
			scheduledDateInput.removeClass("formLabel-rq");
		}
		this.scheduledDateDefinition.required = false;
		const phoneInput = this.$get("[control_label=phone]");
		if (phoneInput.hasClass("formLabel-rq")) {
			phoneInput.removeClass("formLabel-rq");
		}
		this.phoneDefinition.required = false;
		const phoneTypeInput = this.$get("[control_label=phoneType]");
		if (phoneTypeInput.hasClass("formLabel-rq")) {
			phoneTypeInput.removeClass("formLabel-rq");
		}
		this.phoneTypeDefinition.required = false;
		const agentInput = this.$get("[control_label=agent]");
		if (agentInput.hasClass("formLabel-rq")) {
			agentInput.removeClass("formLabel-rq");
		}
		this.agentDefinition.required = false;

		const phoneRow = this.$get("[phoneRow]");
		this.$get("[phoneRow]").remove();
		this.$get("[agentRow]").after(phoneRow);

		this.$get("#flowDesignerMessagesQuickrepliesListContainerId").hide();
		this.$get("[priorityRadioButtons]").hide();
		this.$get("[scoringSlider]").hide();
		this.$get("[extraPhones]").remove();
		this.$get("[contactattributes_list]").html("");
		this.$get("[disclaimer_flex]").hide();
	};

	adm_process_flow_activity.prototype.__selectAddToBatch = function () {
		this.__showControl(this.contactId);
		this.__showControl(this.campaignDefinition);
		this.__showControl(this.lotDefinition);
		this.__showControl(this.scheduledDateDefinition);
		this.__showControl(this.agentDefinition);
		this.__showControl(this.phoneDefinition);
		this.__showControl(this.phoneTypeDefinition);
		this.__showControl(this.nameDefinition);
		this.__showControl(this.externalId);
		
		this.__hideControl(this.restartAttempts);
		this.__hideControl(this.priorityAbsoluteNumber);
		
		const phoneRow = this.$get("[phoneRow]");
		this.$get("[phoneRow]").remove();
		this.$get("[externalIdRow]").after(phoneRow);

		const phoneInput = this.$get("[control_label=phone]");
		if (!phoneInput.hasClass("formLabel-rq")) {
			phoneInput.addClass("formLabel-rq");
		}
		this.phoneDefinition.required = true;
		
		const phoneTypeInput = this.$get("[control_label=phoneType]");
		if (!phoneTypeInput.hasClass("formLabel-rq")) {
			phoneTypeInput.addClass("formLabel-rq");
		}
		this.phoneTypeDefinition.required = true;

		const externalIdInput = this.$get("[control_label=externalId]");
		if (externalIdInput.hasClass("formLabel-rq")) {
			externalIdInput.removeClass("formLabel-rq");
		}
		this.externalId.required = false;

		const scheduledDateInput = this.$get("[control_label=scheduledDate]");
		if (scheduledDateInput.hasClass("formLabel-rq")) {
			scheduledDateInput.removeClass("formLabel-rq");
		}
		this.scheduledDateDefinition.required = false;

		const agentInput = this.$get("[control_label=agent]");
		if (agentInput.hasClass("formLabel-rq")) {
			agentInput.removeClass("formLabel-rq");
		}
		this.agentDefinition.required = false;

		this.$get("#flowDesignerMessagesQuickrepliesListContainerId").show();
		this.$get("[priorityRadioButtons]").hide();
		this.$get("[scoringSlider]").hide();
		this.$get("[extraPhones]").remove();
		this.$get("[contactattributes_list]").html("");
		this.$get("[disclaimer_flex]").hide();
	};

	adm_process_flow_activity.prototype.__selectContactStatus = function (actionType) {
		this.__showControl(this.campaignDefinition);
		this.__showControl(this.contactId);
		
		this.__hideControl(this.agentDefinition);
		this.__hideControl(this.lotDefinition);
		this.__hideControl(this.scheduledDateDefinition);
		this.__hideControl(this.externalId);
		this.__hideControl(this.phoneDefinition);
		this.__hideControl(this.phoneTypeDefinition);
		this.__hideControl(this.nameDefinition);
		this.__hideControl(this.restartAttempts);
		this.__hideControl(this.priorityAbsoluteNumber);

		this.$get("#flowDesignerMessagesQuickrepliesListContainerId").hide();
		this.$get("[priorityRadioButtons]").hide();
		this.$get("[scoringSlider]").hide();
		this.$get("[extraPhones]").remove();
		this.$get("[contactattributes_list]").html("");
		this.$get("[disclaimer_flex]").show();

		let disclaimerMessage;

		switch (actionType) {
			case "cancel_contact":
				disclaimerMessage  = "<%=_T('If you cancel the contact, it will no longer be in the batch list.')%>";
				break;
			case "pause_contact":
				disclaimerMessage  = "<%=_T('If you pause the contact, you will no longer be able to use it in the batch list.')%>";
				break;
			case "resume_contact":
				disclaimerMessage  = "<%=_T('If you resume the contact, you will be able to add it back to the batch list.')%>";
				break;
			case "finish_contact":
				disclaimerMessage  = "<%=_T('If you end the contact, it will no longer be in the batch list.')%>";
				break;
			case "remove_contact":
				disclaimerMessage  = "<%=_T('If you remove the contact, it will no longer be in the batch list.')%>";
				break;
		}

		this.$get("[disclaimer_flex]").html(disclaimerMessage);
	};

	adm_process_flow_activity.prototype.__selectRecycleContact = function () {
		this.__showControl(this.campaignDefinition);
		this.__showControl(this.contactId);
		this.__showControl(this.scheduledDateDefinition);
		this.__showControl(this.agentDefinition);
		this.__showControl(this.restartAttempts);

		this.__hideControl(this.lotDefinition);
		this.__hideControl(this.externalId);
		this.__hideControl(this.phoneDefinition);
		this.__hideControl(this.phoneTypeDefinition);
		this.__hideControl(this.nameDefinition);
		this.__hideControl(this.priorityAbsoluteNumber);

		const scheduledDateInput = this.$get("[control_label=scheduledDate]");
		if (scheduledDateInput.hasClass("formLabel-rq")) {
			scheduledDateInput.removeClass("formLabel-rq");
		}
		const agentInput = this.$get("[control_label=agent]");
		this.scheduledDateDefinition.required = false;
		if (agentInput.hasClass("formLabel-rq")) {
			agentInput.removeClass("formLabel-rq");
		}
		this.agentDefinition.required = false;

		this.$get("#flowDesignerMessagesQuickrepliesListContainerId").hide();
		this.$get("[priorityRadioButtons]").hide();
		this.$get("[scoringSlider]").hide();
		this.$get("[extraPhones]").remove();
		this.$get("[contactattributes_list]").html("");
		this.$get("[disclaimer_flex]").show();

		const disclaimerMessage  = "<%=_T('If you recycle the contact, you can reuse it in the batch list.')%>"; 

		this.$get("[disclaimer_flex]").html(disclaimerMessage);
	};

	adm_process_flow_activity.prototype.__selectChangePriority = function () {
		this.__showControl(this.campaignDefinition);
		this.__showControl(this.contactId);
		
		this.__hideControl(this.agentDefinition);
		this.__hideControl(this.lotDefinition);
		this.__hideControl(this.scheduledDateDefinition);
		this.__hideControl(this.externalId);
		this.__hideControl(this.phoneDefinition);
		this.__hideControl(this.phoneTypeDefinition);
		this.__hideControl(this.nameDefinition);
		this.__hideControl(this.restartAttempts);
		this.__showControl(this.priorityAbsoluteNumber);

		this.$get("#flowDesignerMessagesQuickrepliesListContainerId").hide();
		this.$get("[priorityRadioButtons]").show();
		this.$get("[extraPhones]").remove();
		this.$get("[contactattributes_list]").html("");
		this.$get("input[type=radio][value=priority_absolute]").click();
		this.$get("[disclaimer_flex]").hide();
	};

	adm_process_flow_activity.prototype.__selectAgentAssign = function () {
		this.__showControl(this.campaignDefinition);
		this.__showControl(this.contactId);
		this.__showControl(this.agentDefinition);
		
		this.__hideControl(this.lotDefinition);
		this.__hideControl(this.scheduledDateDefinition);
		this.__hideControl(this.externalId);
		this.__hideControl(this.phoneDefinition);
		this.__hideControl(this.phoneTypeDefinition);
		this.__hideControl(this.nameDefinition);
		this.__hideControl(this.restartAttempts);
		this.__hideControl(this.priorityAbsoluteNumber);

		const agentInput = this.$get("[control_label=agent]");
		if (!agentInput.hasClass("formLabel-rq")) {
			agentInput.addClass("formLabel-rq");
		}
		this.agentDefinition.required = true;

		this.$get("#flowDesignerMessagesQuickrepliesListContainerId").hide();
		this.$get("[priorityRadioButtons]").hide();
		this.$get("[scoringSlider]").hide();
		this.$get("[extraPhones]").remove();
		this.$get("[contactattributes_list]").html("");
		this.$get("[disclaimer_flex]").hide();
	};
	
	adm_process_flow_activity.prototype.__makeFormContent = function () {
		const self = this;
		const $content = adm_process_flow_activity.uber.__makeContent.call(this);
		
		$content.unshift(
			this.__makeDivFlex(
			  [
				this.__makeDivFlex(
				  [
					this.__makeDivFlex(
					  [
						this.__makeDivFlex(
						  this.__makeComboFlex(
							this.actionType,
							this.data[this.actionType.id]
						  ),
						  { class: "col-12" }
						),
					  ],
					  { class: "row" }
					),
					this.__makeDivFlex(
						[
						  this.__makeDivFlex(
							$(Mustache.render(templates.popup_disclaimer_flex, { hidden: true })),
							{ class: "col-12" }
						  ),
						],
						{ class: "row" }
					  ),
					this.__makeDivFlex(
					  [
						this.__makeDivFlex(
						  this.__makeInputFlex(
							this.contactId,
							this.data[this.contactId.id]
						  ),
						  { class: "col-12" }
						),
					  ],
					  { class: "row" }
					),
					this.__makeDivFlex(
					  [
						this.__makeDivFlex(
						  this.__makeInputFlex(
							this.nameDefinition,
							this.data[this.nameDefinition.id]
						  ),
						  { class: "col-12", hidden: true }
						),
					  ],
					  { class: "row" }
					),
					this.__makeDivFlex(
					  [
						this.__makeDivFlex(
						  this.__makeInputFlex(
							this.externalId,
							this.data[this.externalId.id]
						  ),
						  { class: "col-12", hidden: true }
						),
					  ],
					  { class: "row", persoTags: "externalIdRow" }
					),
					this.__makeDivFlex(
					  [
						this.__makeDivFlex(
						  this.__makeInputFlex(
							this.campaignDefinition,
							this.data[this.campaignDefinition.id]
						  ),
						  { class: "col-12" }
						),
					  ],
					  { class: "row", persoTags: "campaignRow" }
					),
					this.__makeDivFlex(
					  [
						this.__makeDivFlex(
						  this.__makeInputFlex(
							this.lotDefinition,
							this.data[this.lotDefinition.id]
						  ),
						  { class: "col-12" }
						),
					  ],
					  { class: "row" }
					),
					this.__makeDivFlex(
					  [
						this.__makeDivFlex(
						  this.__makeInputFlex(
							this.scheduledDateDefinition,
							this.data[this.scheduledDateDefinition.id]
						  ),
						  { class: "col-12" }
						),
					  ],
					  { class: "row" }
					),
					this.__makeDivFlex(
					  [
						this.__makeDivFlex(
						  this.__makeInputFlex(
							this.agentDefinition,
							this.data[this.agentDefinition.id]
						  ),
						  { class: "col-12" }
						),
					  ],
					  { class: "row", persoTags: "agentRow" }
					),
					this.__makeDivFlex(
						[
						  this.__makeDivFlex(
							[
								this.__makeInputFlex(
									this.phoneDefinition,
									this.data[this.phoneDefinition.id]
								  ),
								this.__makeComboFlex(
									this.phoneTypeDefinition,
									this.data[this.phoneTypeDefinition.id]
								),	
							],
						  { class: "col-12 d-flex" }
						),
					  ],
					  { class: "row", persoTags: "phoneRow" }
					),
	  
					this.__makeDivFlex(
					  [
						this.__makeDivFlex(
						  [
							this.__makeDivFlex(
							  [
								this.__makeCheckbox(
								  this.restartAttempts,
								  this.data[this.restartAttempts.id]
								),
							  ],
							  { class: "form-group", hidden: true }
							),
						  ],
						  { class: "col-12" }
						),
					  ],
					  { class: "row" }
					),
		  
					this.__makeDivFlex(
					  [
						this.__makeDivFlex(
						  $(
							Mustache.render(
							  inConcert.templates.process_flows
								.dialer_batch_priority_type_radiobuttons,
							  {
								guid: inConcert.Utils.generateGuid(),
							  }
							)
						  ),
						  { class: "col-12" }
						),
					  ],
					  { class: "row" }
					),
		  
					this.__makeDivFlex(
					  [
						this.__makeDivFlex(
						  [
							this.__makeDivFlex(
							  [
								self.__makePrioritySlider(
								  this.data[this.relativePriorityDefinition.id]
								),
							  ],
							  { class: "form-group" }
							),
						  ],
						  { class: "col-12" }
						),
					  ],
					  { class: "row", persoTags: "scoringSlider", style: "display:none;" }
					),
		  
					this.__makeDivFlex(
					  [
						this.__makeDivFlex(
						  this.__makeInputFlex(
							this.priorityAbsoluteNumber,
							this.data[this.priorityAbsoluteNumber.id]
						  ),
						  { class: "col-12", hidden: true }
						),
					  ],
					  { class: "row" }
					),
				  ],
				  { class: "card-block" }
				),
			  ],
			  { class: "card no-card" }
			)
		  ); 	  

		return $content;
	};

	adm_process_flow_activity.prototype.__makePrioritySlider = function(scoring) { 
		
		const $metadata = $(inConcert.templates.process_flows.dialer_batch_scoring_slider, {
			guid : this.guid
		});

		$metadata.find("[control=priority_relativeNumber]").slider({
			range: "min",
			min: -100,
			max: 100,
			value: scoring?scoring:0.50,
			step: 10,
			create: function() {
				$metadata.find(".ui-slider-scoring-input-value").val($(this).slider("value"));
			},
			slide: function(_, ui) {
				$metadata.find(".ui-slider-scoring-input-value").val(ui.value);
			}
		});
		
		return $metadata;
	};

	adm_process_flow_activity.prototype.__maxQuickreplies = function() {
		return 11;
	};

	adm_process_flow_activity.prototype.__addQuickreply = function(button, $buttonsList) {
		$buttonsList = $buttonsList || this.$get("[contactattributes_list]");
		$buttonsList.siblings("[contactattributes_list]").show();
		var editor = new adm_process_flow_add_contact_attribute(this, button, $buttonsList);
		this.quickreplies[editor.guid] = editor;
		return editor.Make();
	};

	adm_process_flow_activity.prototype.__makeQuickreplies = function(data, $content) {
		var self = this;
		if (!self.__maxQuickreplies()) {
			return;
		}
		var $body = $(Mustache.render(templates.add_contact_attribute_list, {
			style : "display:none"
		}));

		$body.find("[add_contact_attributes]").click(function() {
			var maxQuickreplies = self.__maxQuickreplies();
			if (self.$get("[template_quickreply]").length < maxQuickreplies) {
				self.__addQuickreply();
			}
			else {
				self.activity.__showError(format("El mensaje tiene un límite de {0} respuestas rápidas.", maxQuickreplies));
			}
		});

		$body.find("[add_phone]").click(function() {
			const phoneInput = self.__createPhoneInput(true);
			self.$get("[phoneRow]").after(phoneInput);
		});

		self.quickreplies = {};
		var $list = $body.find("[contactattributes_list]");
		$list.sortable({
			cursor : "move"
		});
		$.each(data.quickreplies || [], function(_, quickreply) {
			self.__addQuickreply(quickreply, $list);
		});
		
		$content[0].find("[campaignRow]").before($body);
        
		$list.siblings("[contactattributes_title]").toggle($list.children().length > 0);

		return $content;
	};

	adm_process_flow_activity.prototype.__createPhoneInput = function(emptyValue) {
		const self = this;
		let phoneInput = this.__makeDivFlex(
			[
			  this.__makeDivFlex(
				  [
					  this.__makeInputFlex(
						{ ...this.phoneDefinition, required: false },
						emptyValue ? null : this.data[this.phoneDefinition.id]
					  ),
					  this.__makeDivFlex(
						[
							this.__makeComboFlex(
								this.phoneTypeDefinition,
								emptyValue ? null : this.data[this.phoneTypeDefinition.id]
							),
							this.__makeDivFlex([
								this.__makeRemoveButton(undefined, { id: "delete_phone" })
							], { class: "form-group mr-0 align-self-end" })
						],
						{ class: "d-flex w-100" }
					  ),
				  ],
				{ class: "col-12 d-flex" }
			  ),
			],
			{ class: "row", persoTags: "extraPhones" }
		  );		
		

			
		phoneInput.find("[remove]").click(function () {
			self.__disableNextKeyboardEvent();
			var $row = $(this).parent().parent().parent();
			$row.remove();
		});
		  
		return phoneInput;
	};

	//Add Contact attribute

	function adm_process_flow_add_contact_attribute(parent, data, $list) {
		this.parent = parent;
		this.data = JSON.parse(JSON.stringify(data || {}));
		this.$list = $list;
		this.guid = inConcert.Utils.generateGuid();

		if (data) {
			if (data.port_id) {
				this.guid = data.port_id; 
			}			
		}

		this.types = [
			{
				id : "text",
				name : "<%=_T('Text')%>",
				description : "<%=_T('Suggests a text option.')%>"
			}
		];

		this.contactAttrTypeDefinition = {
			id: "contactattr_type",
			name: "<%=_T('Type')%>",
			required: true,
			not_extended: true,
			form_group: true,
		};

		this.contactAttrNameDefinition = {
			id: "contactattr_name",
			name: "<%=_T('Name')%>",
			required: true,
			not_extended: true,
			form_group: true,
		};

		this.contactAttrValueDefinition = {
			id: "contactattr_value",
			name: "<%=_T('Value')%>",
			required: true,
			not_extended: true,
			form_group: true,
		};

	}

	adm_process_flow_add_contact_attribute.prototype.Make = function() {
		var self = this;
		self.$button = $(Mustache.render(templates.add_contact_attribute_template, {
			guid : this.guid
		}));

		// self.__makeTypes();

		self.$button.find("[contactattr_view]").click(function() {
			if (self.$list.find(".editMode").length) {
				return;
			}
			self.__editMode();
		});
		self.$button.find("[contactattr_action=save]").click(function() {
			self.__saveEdit();
		});
		self.$button.find("[contactattr_action=cancel]").click(function() {
			self.__cancelEdit();
		});
		self.$button.find("[contactattr_action=delete]").click(function() {
			self.Delete();
		});

		self.$list.append(self.$button);

		if ($.isEmptyObject(self.data)) {
			self.__editMode();
		}
		else {
			self.__viewMode();
		}

        self.$list.siblings("[contactattr_title]").toggle(true);

		return self.$button;
	};

	adm_process_flow_add_contact_attribute.prototype.__viewMode = function() {
		this.parent.SelfOverlay(false);
		// var type = this.__currentType();
		var type = "text";
		var viewData = this["__" + type + "ViewData"]();
		this.$button.attr("quickreply_name", viewData.name);
		this.$button.find("[contactattr_title]").text(viewData.title);
		this.$button.find("[contactattr_view]")
			.removeClass(function (_, classNames) {
				var current_classes = classNames.split(" ");
				var classes_to_remove = [];
				$.each(current_classes, function (_, class_name) {
					if (/quickreplyType.*/.test(class_name)) {
						classes_to_remove.push(class_name);
					}
				});
				return classes_to_remove.join(" ");
			})
			.addClass("quickreplyType" + type);
		this.$button.removeClass("editMode");
	};

	adm_process_flow_add_contact_attribute.prototype.__editMode = function() {
		this.parent.SelfOverlay(true);
		this.$button.addClass("editMode");
		// this.__selectType(this.__currentType());
	};

	adm_process_flow_add_contact_attribute.prototype.__saveEdit = function() {

		this.parent.__clearErrors();
		let data = {
			// type : this.$button.find("[quickreply_type]:checked").attr("quickreply_type")
			type : "text"
		};
		this["__" + data.type + "AddData"](data);
		if (data.error) {
			return this.parent.__showError(data.error, this.$button);
		}
		this.data = data;
		this.__viewMode();
	};

	adm_process_flow_add_contact_attribute.prototype.__textAddData = function(data) {
		var activity = this.parent;
		activity.__addValue(data, this.contactAttrTypeDefinition, this.$button);
		activity.__addValue(data, this.contactAttrNameDefinition, this.$button);
		activity.__addValue(data, this.contactAttrValueDefinition, this.$button);
		// if (!data.error && this.$button.siblings(format("[quickreply_name=\"{0}\"]", data[this.contactAttrNameDefinition.id])).length) {
		// 	data.error = {
		// 		control : this.contactAttrNameDefinition.id,
		// 		message : "<%=_T('Already exists a quick reply with same title.')%>"
		// 	};
		// }
	};

	adm_process_flow_add_contact_attribute.prototype.__textViewData = function() {
		return {
			title : this.data[this.contactAttrNameDefinition.id],
			name : this.data[this.contactAttrNameDefinition.id]
		};
	};

	adm_process_flow_add_contact_attribute.prototype.__cancelEdit = function() {
		this.parent.__clearErrors();
		if ($.isEmptyObject(this.data)) {
			this.parent.SelfOverlay(false);
			this.Delete();
		}
		else {
			this.__viewMode();
		}
	};

	adm_process_flow_add_contact_attribute.prototype.Delete = function() {
		this.deleted = true;
		this.$button.remove();
		// this.onDeleted();
	};

	adm_process_flow_add_contact_attribute.prototype.GetData = function() {
		return (this.deleted || $.isEmptyObject(this.data))? null : this.data;
	};

	adm_process_flow_activity.prototype.__getAndValidate = function() {
		const data = adm_process_flow_activity.uber.__getAndValidate.call(this);

		this.__addValue(data, this.actionType);

		switch (data[this.actionType.id]) {
			case "reschedule_contact":
				this.__getAndValidateRescheduleContact(data);
				break;
			case "add_to_batch":
				this.__getAndValidateAddToBatch(data);
				break;
			case "cancel_contact":
			case "pause_contact":
			case "resume_contact":
			case "finish_contact":
			case "remove_contact":
				this.__getAndValidateContactStatus(data);
				break;
			case "recycle_contact":
				this.__getAndValidateRecycleContact(data);
				break;
			case "change_priority":
				this.__getAndValidateChangePriority(data);
				break;
			case "agent_assign":
				this.__getAndValidateAgentAssign(data);
				break;
		}
		
		return data;
	};

	adm_process_flow_activity.prototype.__getAndValidateRescheduleContact = function (data) {
		this.__addValue(data, this.contactId);
		this.__addValue(data, this.campaignDefinition);
		this.__addValue(data, this.lotDefinition);
		this.__addValue(data, this.scheduledDateDefinition);
		this.__addValue(data, this.agentDefinition);
		this.__addValue(data, this.phoneDefinition);
		this.__addValue(data, this.phoneTypeDefinition);
	};

	adm_process_flow_activity.prototype.__getAndValidateAddToBatch = function (data) {
		this.__addValue(data, this.contactId);
		this.__addValue(data, this.nameDefinition);
		this.__addValue(data, this.externalId);
		this.__addValue(data, this.phoneDefinition);
		this.__addValue(data, this.phoneTypeDefinition);
		this.__addValue(data, this.campaignDefinition);
		this.__addValue(data, this.lotDefinition);
		this.__addValue(data, this.scheduledDateDefinition);
		this.__addValue(data, this.agentDefinition);
		this.__addContactAttributeButtonsToData(data);
		this.__addPhonesToData(data);
	};

	adm_process_flow_activity.prototype.__getAndValidateContactStatus = function (data) {
		this.__addValue(data, this.contactId);
		this.__addValue(data, this.campaignDefinition);
	};

	adm_process_flow_activity.prototype.__getAndValidateRecycleContact = function (data) {
		this.__addValue(data, this.contactId);
		this.__addValue(data, this.campaignDefinition);
		this.__addValue(data, this.scheduledDateDefinition);
		this.__addValue(data, this.agentDefinition);
		this.__addValue(data, this.restartAttempts);
	};

	adm_process_flow_activity.prototype.__getAndValidateChangePriority = function (data) {
		this.__addValue(data, this.contactId);
		this.__addValue(data, this.campaignDefinition);
		
		const priorityType = this.$get("input[type=radio][name=priority_type]:checked").val();
		
		if (priorityType === "priority_relative") {
			this.__addValue(data, this.relativePriorityDefinition);
		}
		else {
			this.__addValue(data, this.priorityAbsoluteNumber);
		}
		
			data.priorityType = priorityType;
	};

	adm_process_flow_activity.prototype.__getAndValidateAgentAssign = function (data) {
		this.__addValue(data, this.contactId);
		this.__addValue(data, this.campaignDefinition);
		this.__addValue(data, this.agentDefinition);
	};

	adm_process_flow_activity.prototype.__addContactAttributeButtonsToData = function (data) {
		const $attrButtonsList = this.$get("[contactattr_edit_form]");
		let attrButtonsArray = [];

		$.each($attrButtonsList, function (_, button) {
			attrButtonsArray.push({
				attrType: $(button).find("[control=contactattr_type]").val(),
				attrName: $(button).find("[control=contactattr_name]").val(),
				attrValue: $(button).find("[control=contactattr_value]").val(),
			});
		});

		data.contactAttributes = attrButtonsArray;
	};

	
	adm_process_flow_activity.prototype.__addPhonesToData = function (data) {
		let phonesArray = [];

		const $obligatoryPhone = $("[phonerow]");
		if ($obligatoryPhone.find("[control=phone]").val()) {
			phonesArray.push({
				phoneNumber: $obligatoryPhone.find("[control=phone]").val(),
				phoneType: $obligatoryPhone.find("[control=phoneType]").val(),
			});
		} else if (this.phoneDefinition.required) {
			data.error = {
				control : this.phoneDefinition.id,
				message : format("<%=_T('Field {0} is required.')%>", this.phoneDefinition.name)
			};
		}

		const $extraPhonesList = $("[extraphones]");

		$.each($extraPhonesList, function (_, phone) {
			if (!$(phone).find("[control=phone]").val()) {
				return;
			} 
				

			phonesArray.push({
				phoneNumber: $(phone).find("[control=phone]").val(),
				phoneType: $(phone).find("[control=phoneType]").val(),
			});
		});

		data.contactPhones = phonesArray;
	};

	adm_process_flow_activity.prototype.htmlBody = function (data) {

		var image = "";

		if (data) {
			var type = data.message && data.message.msgtype || "text";
			if (type === "attachment") {
				type = data.message.fileType || "attachment";
			}
			image = id;
		}

		let cardDescription = data.description;
		if (data.description && data.description !== "" && 
			(data.description === "<%=_T('Manage Contact in Batch')%>" || 
			data.description === "<%=_T('Reschedule Contact')%>" || 
			data.description === "<%=_T('Add Contact to Batch')%>" || 
			data.description === "<%=_T('Cancel Contact')%>") ||
			data.description === "<%=_T('Pause Contact')%>" || 
			data.description === "<%=_T('Resume Contact')%>" || 
			data.description === "<%=_T('Recycle Contact')%>" || 
			data.description === "<%=_T('Finish Contact')%>" || 
			data.description === "<%=_T('Remove Contact')%>" || 
			data.description === "<%=_T('Change Priority')%>" || 
			data.description === "<%=_T('Agent Assign')%>" 
		) {
			let contactManagementOptionSelected = $("[control=actionType]").val();

			switch (contactManagementOptionSelected) {
				case "reschedule_contact":
					cardDescription = "<%=_T('Reschedule Contact')%>"; 
					break;
				case "add_to_batch":
					cardDescription = "<%=_T('Add Contact to Batch')%>"; 
					break;
				case "cancel_contact":
					cardDescription = "<%=_T('Cancel Contact')%>"; 
					break;
				case "pause_contact":
					cardDescription = "<%=_T('Pause Contact')%>"; 
					break;
				case "resume_contact":
					cardDescription = "<%=_T('Resume Contact')%>"; 
					break;
				case "recycle_contact":
					cardDescription = "<%=_T('Recycle Contact')%>"; 
					break;
				case "finish_contact":
					cardDescription = "<%=_T('Finish Contact')%>"; 
					break;
				case "remove_contact":
					cardDescription = "<%=_T('Remove Contact')%>"; 
					break;
				case "change_priority":
					cardDescription = "<%=_T('Change Priority')%>"; 
					break;
				case "agent_assign":
					cardDescription = "<%=_T('Agent Assign')%>"; 
					break;
			}
		}

		data.description = cardDescription;

		return Mustache.render(inConcert.templates.process_flows.activity_template, {
			image: `custom_icon_${image}`,
			description: data.description
		});
	};

	adm_process_flow_activity.prototype.ports = function(data, node) {
		

		let ports = [];

		// siempre hay que agregar este por defecto
		ports.push({
			direction : "in", // in/out
			type : "option", // error/success/option
			option_label : "Input" // error/success/option
		});

		// en algún lado el usuario debe decidir si quiere un puerto por defecto
		let puerto_por_defecto = true;

		// agrego un puerto por defecto si es necesario
		if (puerto_por_defecto) {
			let existe = node?node.children.find(c => c.id.includes("_default")):undefined;

			ports.push({
				direction : "out", // in/out
				type : "option", // error/success/option
				option_label : "<%=_T('Success')%>", // error/success/option
				channels: "n", // 0, 1 o n
				id: (existe?existe.id:inConcert.Utils.generateGuid() + "_default"),  // le asigno un id por defecto
				preset_value: {
					description: "", //"Error"
					conditions: [
						{ field: "_result.result", comparator: "==", value: "'OK'" }
					],
					port_id: (existe?existe.id:inConcert.Utils.generateGuid() + "_default")
				}
			});
		}

		let unificar_errores = true;
		
		if (unificar_errores) {

			let existe = node?node.children.find(c => c.id.includes("_" + "Error")):undefined;
			let portId = (existe?existe.id:inConcert.Utils.generateGuid() + "_" + "Error");
			ports.push({
				direction : "out", // in/out
				type : "error", // error/success/option
				option_label : "Error", // error/success/option
				channels: "1", // 0, 1 o n
				id: portId,  // le asigno un id por defecto
				preset_value: {
					description: "", //"Error"
					conditions: [
						{ field: "_result.result", comparator: "~=", value: "'OK'" }
					],
					port_id: portId
				}
			});

		} else {

			let errores_admitidos = ["Error"];
			errores_admitidos.forEach(error_type => {
				let existe = node?node.children.find(c => c.id.includes("_" + error_type)):undefined;
				let portId = (existe?existe.id:inConcert.Utils.generateGuid() + "_" + error_type);
				ports.push({
					direction : "out", // in/out
					type : "error", // error/success/option
					option_label : error_type, // error/success/option
					channels: "1", // 0, 1 o n
					id: portId,  // le asigno un id por defecto
					preset_value: {
						description: "", //error_type
						conditions: [
							{ field: data.result + ".eventname", comparator: "==", value: "\""+ error_type +"\"" }
						],
						port_id: portId
					}
				});
			});

		}
		
		return ports;
	};

	adm_process_flow_activity.prototype.__cancel = function(callback) {
		if (this.isNew) {
			this.editor.CancelConnection(this.connector);
		}
		callback();
	};

	adm_process_flow_activity.prototype.__save = function(data, callback) {
		this.editor.AddOrUpdateActivity(this.node, data);
		callback(true);
	};

}());
