/* jshint forin:true, noarg:true, jquery:true, noempty:true, eqeqeq:true, bitwise:true,
	strict:true, undef:true, unused:vars, curly:true, browser:true, indent:false, maxerr:50, quotmark:double, esversion: 9 */

/* global $, inConcert, Mustache */

if (!this.inConcert) {
	this.inConcert = {};
}

(function () {
	//"use strict";

	var format = inConcert.Utils.format;
	var templates = inConcert.templates.process_flows;

	var id = "dialer_contact";
	
	function adm_process_flow_activity(editor, node) {
		adm_process_flow_activity.uber.constructor.call(this, editor, node);
		this.editor = editor;
		this.node = node;
		var data = editor.GetNodeData(node);
		this.isNew = !data;
		this.data = data || {outputs: []};
		this.frm = editor.main.frm;

		this.focusFirst = true;
		const self = this;

		this.contactManagementMethod = {
			id : "contactManagementMethod",
			name : "<%=_T('Select contact management method')%>",
			description : "<%=_T('Select contact management method')%>",
			required : true,
			not_extended : true,
			form_group: true,
			options : [
				{ 	
					id : "search_contact",
					name : "<%=_T('Search Contact')%>" 
				},
				{ 
					id: "create_contact",
					name : "<%=_T('Create Contact')%>" 
				},
				{ 
					id: "edit_contact",
					name : "<%=_T('Edit Contact')%>"
				},
			],
			change : function () {
				self.__selectManagementMethod($(this).val());
			}
		};

		
		this.searchCriteria = {
			id : "searchCriteria",
			name : "<%=_T('Select search criteria')%>",
			description : "<%=_T('Select search criteria')%>",
			required : true,
			not_extended : true,
			form_group: true,
			options : [
				{ 	
					id : "contact_id",
					name : "<%=_T('Contact Id')%>" 
				},
				{ 
					id: "external_id",
					name : "<%=_T('External Id')%>" 
				},
				{ 
					id: "phone_number",
					name : "<%=_T('Phone Number')%>"
				},
			],
			change : function () {
				self.__selectSearchCriteria($(this).val());
			}
		};


		this.contactId = {
			id: "contactId",
			name: "<%=_T('Contact Id')%>",
			description: "<%=_T('Contact Id')%>",
			required: true,
			not_extended: true,
			form_group: true,
			variable: true,
			controlContainerClass: "position-relative",
			span: true,
			spanClass: "ic_variable_icon_container",
			variableIconClass: "ic_variable_icon far fa-at",
		};

		this.externalId = {
			id: "externalId",
			name: "<%=_T('External Id')%>",
			description: "<%=_T('External Id')%>",
			required: true,
			not_extended: true,
			form_group: true,
			variable: true,
			controlContainerClass: "position-relative",
			span: true,
			spanClass: "ic_variable_icon_container",
			variableIconClass: "ic_variable_icon far fa-at",
		};

		this.campaignDefinition = {
			id: "campaignDefinition",
			name: "<%=_T('Campaign')%>",
			description: "<%=_T('Campaign')%>",
			required: true,
			not_extended: true,
			form_group: true,
			variable: true,
			controlContainerClass: "position-relative",
			span: true,
			spanClass: "ic_variable_icon_container",
			variableIconClass: "ic_variable_icon far fa-at",
		};

		this.nameDefinition = {
			id: "name",
			name: "<%=_T('Name')%>",
			description: "<%=_T('Contact name.')%>",
			required: true,
			not_extended: true,
			form_group: true,
		};

		this.searchPhoneNumberDefinition = {
			id: "searchPhone",
			name: "<%=_T('Phone Number')%>",
			description: "<%=_T('Phone Number')%>",
			required: true,
			not_extended: true,
			form_group: true,
		};

		this.phoneDefinition = {
			id: "phone",
			name: "<%=_T('Phone')%>",
			description: "<%=_T('Phone')%>",
			controlContainerClass: "position-relative flex-grow-1 w-100",
			variable: true,
			span: true,
			spanClass: "ic_variable_icon_container",
			variableIconClass: "ic_variable_icon far fa-at",
			required: true,
			not_extended: true,
			form_group: true,
		};

		this.phoneTypeDefinition = {
			id: "phoneType",
			name: "<%=_T('Phone Type')%>",
			description: "<%=_T('Phone Type')%>",
			required: true,
			not_extended: true,
			form_group: true,
			controlContainerClass: "position-relative  inputControl flex-grow-1 w-100",
			options : [
				{ 	
					id : "HOME",
					name : "<%=_T('Home Phone')%>" 
				},
				{ 
					id: "CELLULAR",
					name : "<%=_T('Mobile Phone')%>" 
				},
				{ 
					id: "OFFICE",
					name : "<%=_T('Office Phone')%>" 
				},
				{ 
					id: "FAX",
					name : "<%=_T('Fax')%>" 
				},
			],
		};

		this.resultDefinition = {
			id: "result",
			name: "<%=_T('Result')%>",
			description: "<%=_T('Result')%>",
			// required: true,
			not_extended: true,
			form_group: true,
		};

		this.descriptionDefinition = {
			id : "description",
			name : "<%=_T('Description')%>",
			description : "<%=_T('Activity description.')%>",
			placeholder : "<%=_T('Enter description')%>..."
		};

		this.addAttributesButton = {
			id: "addAttributes",
			content: "<%=_T('Add contact attribute')%>",
			persoTags: "add_attribute",
			style: "display: none"
		};
	}

	inConcert.Utils.inherit(adm_process_flow_activity, inConcert.adm_process_flow_activities.base);

	if (typeof inConcert.adm_process_flow_activities[id] !== "function") {
		inConcert.adm_process_flow_activities[id] = adm_process_flow_activity;
	}

	adm_process_flow_activity.prototype.id = id;
	adm_process_flow_activity.prototype.name = "<%=_T('Manage Contact')%>";
	// adm_process_flow_activity.prototype.description = "<%=_T('Manage Contact')%>";
	adm_process_flow_activity.prototype.group = "dialer";
	adm_process_flow_activity.prototype.image = "ico-dialer.svg";

	adm_process_flow_activity.prototype.__getClassName = function() {
		return "popOver640w popOverFixedHeight flowDesignerGlobalModal botActivity_dialer_contact";
	};

	adm_process_flow_activity.prototype.__makeContent = function () {
		let $content = this.__makeFormContent();
		return this.Make($content);
	};

	adm_process_flow_activity.prototype.Make = function($content) {
		// this.__makeTypes(this.data);
		return this.__makeQuickreplies(this.data, $content);
	};

	adm_process_flow_activity.prototype.__afterAppendBody = function () {
		const self = this;
		this.__selectManagementMethod(this.data[this.contactManagementMethod.id] || "search_contact", true);


		if (this.data[this.contactManagementMethod.id] === "create_contact" || this.data[this.contactManagementMethod.id] === "edit_contact") {
			$.each(this.data.contactAttributes, function (_, attribute) {
				let button = self.__addQuickreply(attribute, $("[contactattributes_list]"));
				button.find("[control=contactattr_name]").val(attribute.attrName);
				button.find("[control=contactattr_value]").val(attribute.attrValue);
				button.find("[control=contactattr_type]").val(attribute.attrType).change();
				button.find("[contactattr_title]").html(attribute.attrName);
			});

			let firstPhone = true;
			$.each(this.data.contactPhones, function (_, phone) {
				if (firstPhone) {
					self.$get("[phoneRow]").find("[control=phone]").val(phone.phoneNumber);
					self.$get("[phoneRow]").find("[control=phoneType]").val(phone.phoneType).change();
					firstPhone = false;
				} else {
					let phoneInput = self.__createPhoneInput();
					phoneInput.find("[control=phone]").val(phone.phoneNumber);
					phoneInput.find("[control=phoneType]").val(phone.phoneType).change();
					self.$get("#flowDesignerMessagesQuickrepliesListContainerId").before(phoneInput);
				}
			});
		}

		if (this.data[this.searchCriteria.id]) {
			this.__selectSearchCriteria(this.data[this.searchCriteria.id] || "contact_id", true);
		}

		const $inputs = self.$get("span[class=ic_variable_icon_container");
		self.__addAutocompleteToInput($inputs);
	};

	adm_process_flow_activity.prototype.__selectManagementMethod = function (managementMethod, initial) {
		this.__clearErrors();
		switch (managementMethod) {
			case "search_contact":
				this.__selectSearchContact(initial);
				break;
			case "create_contact":
				this.__selectCreateContact(initial);
				break;
			case "edit_contact":
				this.__selectEditContact(initial);
				break;
		}
	};

	adm_process_flow_activity.prototype.__selectSearchContact = function () {
		this.__showControl(this.searchCriteria);
		this.__showControl(this.contactId);

		this.__hideControl(this.externalId);
		this.__hideControl(this.campaignDefinition);
		this.__hideControl(this.nameDefinition);
		this.__hideControl(this.phoneDefinition);
		this.__hideControl(this.phoneTypeDefinition);
		this.__hideControl(this.searchPhoneNumberDefinition);
		
		this.$get("#flowDesignerMessagesQuickrepliesListContainerId").hide();
		this.$get("[add_contact_attributes]").hide();
		this.$get("[add_phone]").hide();
		this.$get("[extraPhones]").remove();
		this.$get("[contactattributes_list]").html("");
	};

	adm_process_flow_activity.prototype.__selectCreateContact = function () {
		this.__showControl(this.nameDefinition);
		this.__showControl(this.phoneDefinition);
		this.__showControl(this.phoneTypeDefinition);
		this.__showControl(this.externalId);

		this.__hideControl(this.searchCriteria);
		this.__hideControl(this.contactId);
		this.__hideControl(this.campaignDefinition);
		this.__hideControl(this.searchPhoneNumberDefinition);

		const externalIdInput = this.$get("[control_label=externalId]");
		if (externalIdInput.hasClass("formLabel-rq")) {
			externalIdInput.removeClass("formLabel-rq");
		}
		this.externalId.required = false;

		const nameInput = this.$get("[control_label=name]");
		if (!nameInput.hasClass("formLabel-rq")) {
			nameInput.addClass("formLabel-rq");
		}
		this.nameDefinition.required = true;

		const phoneInput = this.$get("[control_label=phone]");
		if (!phoneInput.hasClass("formLabel-rq")) {
			phoneInput.addClass("formLabel-rq");
		}
		this.phoneDefinition.required = true;

		const phoneTypeInput = this.$get("[control_label=phoneType]");
		if (!phoneTypeInput.hasClass("formLabel-rq")) {
			phoneTypeInput.addClass("formLabel-rq");
		}
		this.phoneTypeDefinition.required = true;

		this.$get("#flowDesignerMessagesQuickrepliesListContainerId").show();
		this.$get("[add_contact_attributes]").show();
		this.$get("[add_phone]").show();
		this.$get("[extraPhones]").remove();
		this.$get("[contactattributes_list]").html("");
	};

	adm_process_flow_activity.prototype.__selectEditContact = function () {
		this.__showControl(this.externalId);
		this.__showControl(this.contactId);
		this.__showControl(this.nameDefinition);
		this.__showControl(this.phoneDefinition);
		this.__showControl(this.phoneTypeDefinition);

		const externalIdInput = this.$get("[control_label=externalId]");
		if (externalIdInput.hasClass("formLabel-rq")) {
			externalIdInput.removeClass("formLabel-rq");
		}
		this.externalId.required = false;

		const nameInput = this.$get("[control_label=name]");
		if (nameInput.hasClass("formLabel-rq")) {
			nameInput.removeClass("formLabel-rq");
		}
		this.nameDefinition.required = false;

		const phoneInput = this.$get("[control_label=phone]");
		if (phoneInput.hasClass("formLabel-rq")) {
			phoneInput.removeClass("formLabel-rq");
		}
		this.phoneDefinition.required = false;

		const phoneTypeInput = this.$get("[control_label=phoneType]");
		if (phoneTypeInput.hasClass("formLabel-rq")) {
			phoneTypeInput.removeClass("formLabel-rq");			
		}
		this.phoneTypeDefinition.required = false;

		this.__hideControl(this.searchPhoneNumberDefinition);
		this.__hideControl(this.searchCriteria);
		this.__hideControl(this.campaignDefinition);
		
		this.$get("#flowDesignerMessagesQuickrepliesListContainerId").show();
		this.$get("[add_contact_attributes]").show();
		this.$get("[add_phone]").show();
		this.$get("[extraPhones]").remove();
		this.$get("[contactattributes_list]").html("");
	};

	adm_process_flow_activity.prototype.__selectSearchCriteria = function (searchCriteria, initial) {
		switch (searchCriteria) {
			case "contact_id":
				this.__selectSearchContactId(initial);
				break;
			case "external_id":
				this.__selectSearchExternalId(initial);
				break;
			case "phone_number":
				this.__selectSearchPhoneNumber(initial);
				break;
		}
	};

	adm_process_flow_activity.prototype.__selectSearchContactId = function () {
		this.__showControl(this.contactId);

		this.__hideControl(this.externalId);
		this.__hideControl(this.campaignDefinition);
		this.__hideControl(this.phoneDefinition);
		this.__hideControl(this.phoneTypeDefinition);
		this.__hideControl(this.searchPhoneNumberDefinition);
	};

	adm_process_flow_activity.prototype.__selectSearchExternalId = function () {
		this.__showControl(this.externalId);
		this.__showControl(this.campaignDefinition);

		const campaignDefinitionInput = this.$get("[control_label=campaignDefinition]");
		if (campaignDefinitionInput.hasClass("formLabel-rq")) {
			campaignDefinitionInput.removeClass("formLabel-rq");
		}
		this.campaignDefinition.required = false;

		this.__hideControl(this.contactId);
		this.__hideControl(this.phoneDefinition);
		this.__hideControl(this.phoneTypeDefinition);
		this.__hideControl(this.searchPhoneNumberDefinition);
	};

	adm_process_flow_activity.prototype.__selectSearchPhoneNumber = function () {
		this.__showControl(this.searchPhoneNumberDefinition);
		this.__showControl(this.campaignDefinition);
		
		const campaignDefinitionInput = this.$get("[control_label=campaignDefinition]");
		if (campaignDefinitionInput.hasClass("formLabel-rq")) {
			campaignDefinitionInput.removeClass("formLabel-rq");
		}
		this.campaignDefinition.required = false;

		this.__hideControl(this.phoneDefinition);
		this.__hideControl(this.phoneTypeDefinition);
		this.__hideControl(this.contactId);
		this.__hideControl(this.externalId);
	};

	adm_process_flow_activity.prototype.__makeFormContent = function () {
		const $content = adm_process_flow_activity.uber.__makeContent.call(this);
		
		$content.unshift(
			this.__makeDivFlex(
			  [
				this.__makeDivFlex(
				  [
					this.__makeDivFlex(
					  [
						this.__makeDivFlex(
						  this.__makeComboFlex(
							this.contactManagementMethod,
							this.data[this.contactManagementMethod.id]
						  ),
						  { class: "col-12" }
						),
					  ],
					  { class: "row" }
					),
		  
					this.__makeDivFlex(
					  [
						this.__makeDivFlex(
						  this.__makeComboFlex(
							this.searchCriteria,
							this.data[this.searchCriteria.id]
						  ),
						  { class: "col-12" }
						),
					  ],
					  { class: "row" }
					),
		  
					this.__makeDivFlex(
					  [
						this.__makeDivFlex(
						  this.__makeInputFlex(
							this.contactId,
							this.data[this.contactId.id]
						  ),
						  { class: "col-12" }
						),
					  ],
					  { class: "row" }
					),
		  
					this.__makeDivFlex(
					  [
						this.__makeDivFlex(
						  this.__makeInputFlex(
							this.externalId,
							this.data[this.externalId.id]
						  ),
						  { class: "col-12", hidden: true }
						),
					  ],
					  { class: "row" }
					),
		  
					this.__makeDivFlex(
					  [
						this.__makeDivFlex(
						  this.__makeInputFlex(
							this.searchPhoneNumberDefinition,
							this.data[this.searchPhoneNumberDefinition.id]
						  ),
						  { class: "col-12", hidden: true }
						),
					  ],
					  { class: "row" }
					),
		  
					this.__makeDivFlex(
					  [
						this.__makeDivFlex(
						  this.__makeInputFlex(
							this.campaignDefinition,
							this.data[this.campaignDefinition.id]
						  ),
						  { class: "col-12", hidden: true }
						),
					  ],
					  { class: "row" }
					),
		  
					this.__makeDivFlex(
					  [
						this.__makeDivFlex(
						  this.__makeInputFlex(
							this.nameDefinition,
							this.data[this.nameDefinition.id]
						  ),
						  { class: "col-12", hidden: true }
						),
					  ],
					  { class: "row", persoTags: "nameRow" }
					),
		  
					this.__makeDivFlex(
						[
						  this.__makeDivFlex(
							[
								this.__makeInputFlex(
									this.phoneDefinition,
									this.data[this.phoneDefinition.id]
								  ),
								this.__makeComboFlex(
									this.phoneTypeDefinition,
									this.data[this.phoneTypeDefinition.id]
								),	
							],
						  { class: "col-12 d-flex"}
						),
					  ],
					  { class: "row", persoTags: "phoneRow" }
					),
					this.__makeDivFlex(
						[
						  this.__makeDivFlex(
							this.__makeInputFlex(
							  this.resultDefinition,
							  this.data[this.resultDefinition.id]
							),
							{ class: "col-12" }
						  ),
						],
						{ class: "row" }
					  ),
				  ],
				  { class: "card-block" }
				),
			  ],
			  { class: "card no-card" }
			)
		  );		  

		return $content;
	};

	adm_process_flow_activity.prototype.__maxQuickreplies = function() {
		return 11;
	};

	adm_process_flow_activity.prototype.__addQuickreply = function(button, $buttonsList) {
		$buttonsList = $buttonsList || this.$get("[contactattributes_list]");
		$buttonsList.siblings("[contactattributes_list]").show();
		var editor = new adm_process_flow_add_contact_attribute(this, button, $buttonsList);
		this.quickreplies[editor.guid] = editor;
		return editor.Make();
	};

	adm_process_flow_activity.prototype.__makeQuickreplies = function(data, $content) {
		var self = this;
		if (!self.__maxQuickreplies()) {
			return;
		}
		var $body = $(Mustache.render(templates.add_contact_attribute_list, {
			style : "display:none"
		}));

		$body.find("[add_contact_attributes]").click(function() {
			var maxQuickreplies = self.__maxQuickreplies();
			if (self.$get("[template_quickreply]").length < maxQuickreplies) {
				self.__addQuickreply();
			}
			else {
				self.activity.__showError(format("El mensaje tiene un límite de {0} respuestas rápidas.", maxQuickreplies));
			}
		});

		$body.find("[add_phone]").click(function() {
			const phoneInput = self.__createPhoneInput();
			$("#flowDesignerMessagesQuickrepliesListContainerId").before(phoneInput);
		});

		self.quickreplies = {};
		var $list = $body.find("[contactattributes_list]");
		$list.sortable({
			cursor : "move"
		});
		$.each(data.contactAttributes || [], function(_, contactAttr) {
			self.__addQuickreply(contactAttr, $list);
		});
		
		$content[0].find("[phoneRow]").after($body);
        
		$list.siblings("[contactattributes_title]").toggle($list.children().length > 0);

		return $content;
	};

	adm_process_flow_activity.prototype.__createPhoneInput = function() {
		const self = this;
		let phoneInput = this.__makeDivFlex(
			[
			  this.__makeDivFlex(
				[
					this.__makeInputFlex(
						{ ...this.phoneDefinition, required: false },
						this.data[this.phoneDefinition.id]
					),
					this.__makeDivFlex(
						[
							this.__makeComboFlex(
								this.phoneTypeDefinition,
								this.data[this.phoneTypeDefinition.id]
							),
							this.__makeDivFlex([
								this.__makeRemoveButton(undefined, { id: "delete_phone" })
							], { class: "form-group mr-0 align-self-end" }) 		
						],
						{ class: "d-flex w-100" }
					),
				],
				{ class: "col-12 d-flex" }
			  ), 
			],
			{ class: "row", persoTags: "extraPhones" }
		  );		
		

			
		phoneInput.find("[remove]").click(function () {
			self.__disableNextKeyboardEvent();
			var $row = $(this).parent().parent().parent();
			$row.remove();
		});
		  
		return phoneInput;
	};

	//Add Contact attribute

	function adm_process_flow_add_contact_attribute(parent, data, $list) {
		this.parent = parent;
		this.data = JSON.parse(JSON.stringify(data || {}));
		this.$list = $list;
		this.guid = inConcert.Utils.generateGuid();

		if (data) {
			if (data.port_id) {
				this.guid = data.port_id; 
			}			
		}

		this.types = [
			{
				id : "text",
				name : "<%=_T('Text')%>",
				description : "<%=_T('Suggests a text option.')%>"
			}
		];

		this.contactAttrTypeDefinition = {
			id: "contactattr_type",
			name: "<%=_T('Type')%>",
			// description: "<%=_T('Contact name.')%>",
			required: true,
			not_extended: true,
			form_group: true,
		};

		this.contactAttrNameDefinition = {
			id: "contactattr_name",
			name: "<%=_T('Name')%>",
			// description: "<%=_T('Contact name.')%>",
			required: true,
			not_extended: true,
			form_group: true,
		};

		this.contactAttrValueDefinition = {
			id: "contactattr_value",
			name: "<%=_T('Value')%>",
			// description: "<%=_T('Contact name.')%>",
			required: true,
			not_extended: true,
			form_group: true,
		};

	}

	adm_process_flow_add_contact_attribute.prototype.Make = function() {
		var self = this;
		self.$button = $(Mustache.render(templates.add_contact_attribute_template, {
			guid : this.guid
		}));

		// self.__makeTypes();

		self.$button.find("[contactattr_view]").click(function() {
			if (self.$list.find(".editMode").length) {
				return;
			}
			self.__editMode();
		});
		self.$button.find("[contactattr_action=save]").click(function() {
			self.__saveEdit();
		});
		self.$button.find("[contactattr_action=cancel]").click(function() {
			self.__cancelEdit();
		});
		self.$button.find("[contactattr_action=delete]").click(function() {
			self.Delete();
		});

		self.$list.append(self.$button);

		if ($.isEmptyObject(self.data)) {
			self.__editMode();
		}
		else {
			self.__viewMode();
		}

        self.$list.siblings("[contactattr_title]").toggle(true);

		return self.$button;
	};

	adm_process_flow_add_contact_attribute.prototype.__viewMode = function() {
		this.parent.SelfOverlay(false);
		// var type = this.__currentType();
		var type = "text";
		var viewData = this["__" + type + "ViewData"]();
		this.$button.attr("quickreply_name", viewData.name);
		this.$button.find("[contactattr_title]").text(viewData.title);
		this.$button.find("[contactattr_view]")
			.removeClass(function (_, classNames) {
				var current_classes = classNames.split(" ");
				var classes_to_remove = [];
				$.each(current_classes, function (_, class_name) {
					if (/quickreplyType.*/.test(class_name)) {
						classes_to_remove.push(class_name);
					}
				});
				return classes_to_remove.join(" ");
			})
			.addClass("quickreplyType" + type);
		this.$button.removeClass("editMode");
	};

	adm_process_flow_add_contact_attribute.prototype.__editMode = function() {
		this.parent.SelfOverlay(true);
		this.$button.addClass("editMode");
	};

	adm_process_flow_add_contact_attribute.prototype.__saveEdit = function() {

		this.parent.__clearErrors();
		let data = {
			type : "text"
		};
		this["__" + data.type + "AddData"](data);
		if (data.error) {
			return this.parent.__showError(data.error, this.$button);
		}
		this.data = data;
		this.__viewMode();
	};

	adm_process_flow_add_contact_attribute.prototype.__textAddData = function(data) {
		var activity = this.parent;
		activity.__addValue(data, this.contactAttrTypeDefinition, this.$button);
		activity.__addValue(data, this.contactAttrNameDefinition, this.$button);
		activity.__addValue(data, this.contactAttrValueDefinition, this.$button);
		// if (!data.error && this.$button.siblings(format("[quickreply_name=\"{0}\"]", data[this.contactAttrNameDefinition.id])).length) {
		// 	data.error = {
		// 		control : this.contactAttrNameDefinition.id,
		// 		message : "<%=_T('Already exists a quick reply with same title.')%>"
		// 	};
		// }
	};

	adm_process_flow_add_contact_attribute.prototype.__textViewData = function() {
		return {
			title : this.data[this.contactAttrNameDefinition.id],
			name : this.data[this.contactAttrNameDefinition.id]
		};
	};

	adm_process_flow_add_contact_attribute.prototype.__cancelEdit = function() {
		this.parent.__clearErrors();
		if ($.isEmptyObject(this.data)) {
			this.parent.SelfOverlay(false);
			this.Delete();
		}
		else {
			this.__viewMode();
		}
	};

	adm_process_flow_add_contact_attribute.prototype.Delete = function() {
		this.deleted = true;
		this.$button.remove();
	};

	adm_process_flow_activity.prototype.__getAndValidate = function () {
		var data = adm_process_flow_activity.uber.__getAndValidate.call(this);

		this.__addValue(data, this.contactManagementMethod);
		
		if (data[this.contactManagementMethod.id] === "search_contact") {
			this.__addValue(data, this.searchCriteria);

			if (data[this.searchCriteria.id] === "contact_id") {
				this.__addValue(data, this.contactId);
			} else if (data[this.searchCriteria.id] === "external_id") {
				this.__addValue(data, this.externalId);
				this.__addValue(data, this.campaignDefinition);

			} else { // phone_number
				this.__addValue(data, this.searchPhoneNumberDefinition);
				this.__addValue(data, this.campaignDefinition);
			}
	
		}  else if (data[this.contactManagementMethod.id] === "create_contact") {
			this.__addValue(data, this.nameDefinition);
			this.__addValue(data, this.externalId);
			this.__addContactAttributeButtonsToData(data);
			this.__addPhonesToData(data);
		} else { // edit_contact
			this.__addValue(data, this.contactId);
			this.__addValue(data, this.externalId);
			this.__addValue(data, this.nameDefinition);
			this.__addContactAttributeButtonsToData(data);
			this.__addPhonesToData(data);
		}
		this.__addValue(data, this.resultDefinition);
		
		return data;
	};
	
	adm_process_flow_activity.prototype.__addContactAttributeButtonsToData = function (data) {
		const $attrButtonsList = $("[contactattr_edit_form]");
		let attrButtonsArray = [];

		$.each($attrButtonsList, function (_, button) {
			attrButtonsArray.push({
				attrType: $(button).find("[control=contactattr_type]").val(),
				attrName: $(button).find("[control=contactattr_name]").val(),
				attrValue: $(button).find("[control=contactattr_value]").val(),
			});
		});

		data.contactAttributes = attrButtonsArray;
	};

	adm_process_flow_activity.prototype.__addPhonesToData = function (data) {
		let phonesArray = [];

		const $obligatoryPhone = $("[phonerow]");
		if ($obligatoryPhone.find("[control=phone]").val()) {
			phonesArray.push({
				phoneNumber: $obligatoryPhone.find("[control=phone]").val(),
				phoneType: $obligatoryPhone.find("[control=phoneType]").val(),
			});
		} else if (this.phoneDefinition.required) {
			data.error = {
				control : this.phoneDefinition.id,
				message : format("<%=_T('Field {0} is required.')%>", this.phoneDefinition.name)
			};
		}

		const $extraPhonesList = $("[extraphones]");

		$.each($extraPhonesList, function (_, phone) {
			if (!$(phone).find("[control=phone]").val()) {
				return;
			}

			phonesArray.push({
				phoneNumber: $(phone).find("[control=phone]").val(),
				phoneType: $(phone).find("[control=phoneType]").val(),
			});
		});

		data.contactPhones = phonesArray;
	};

	adm_process_flow_activity.prototype.htmlBody = function (data) {

		var image = "";

		if (data) {
			var type = data.message && data.message.msgtype || "text";
			if (type === "attachment") {
				type = data.message.fileType || "attachment";
			}
			image = id;
		}

		let cardDescription = data.description;
		if (data.description && data.description !== "" && 
			(data.description === "<%=_T('Manage Contact')%>" || 
			data.description === "<%=_T('Search Contact')%>" || 
			data.description === "<%=_T('Create Contact')%>" || 
			data.description === "<%=_T('Edit Contact')%>")
		) {
			let contactManagementOptionSelected = $("[control=contactManagementMethod]").val();

			switch (contactManagementOptionSelected) {
				case "search_contact":
					cardDescription = "<%=_T('Search Contact')%>"; 
					break;
				case "create_contact":
					cardDescription = "<%=_T('Create Contact')%>"; 
					break;
				case "edit_contact":
					cardDescription = "<%=_T('Edit Contact')%>"; 
					break;
			}
		}
		
		data.description = cardDescription;

		return Mustache.render(inConcert.templates.process_flows.activity_template, {
			image: `custom_icon_${image}`,
			description: data.description
		});
	};

	adm_process_flow_activity.prototype.ports = function(data, node) {
		

		let ports = [];

		// siempre hay que agregar este por defecto
		ports.push({
			direction : "in", // in/out
			type : "option", // error/success/option
			option_label : "Input" // error/success/option
		});

		// en algún lado el usuario debe decidir si quiere un puerto por defecto
		let puerto_por_defecto = true;

		// agrego un puerto por defecto si es necesario
		if (puerto_por_defecto) {
			let existe = node?node.children.find(c => c.id.includes("_default")):undefined;

			ports.push({
				direction : "out", // in/out
				type : "option", // error/success/option
				option_label : "<%=_T('Success')%>", // error/success/option
				channels: "n", // 0, 1 o n
				id: (existe?existe.id:inConcert.Utils.generateGuid() + "_default"),  // le asigno un id por defecto
				preset_value: {
					description: "", //"Error"
					conditions: [
						{ field: "_result.result", comparator: "==", value: "'OK'" }
					],
					port_id: (existe?existe.id:inConcert.Utils.generateGuid() + "_default")
				}
			});
		}

		let unificar_errores = true;
		
		if (unificar_errores) {

			let existe = node?node.children.find(c => c.id.includes("_" + "Error")):undefined;
			let portId = (existe?existe.id:inConcert.Utils.generateGuid() + "_" + "Error");
			ports.push({
				direction : "out", // in/out
				type : "error", // error/success/option
				option_label : "Error", // error/success/option
				channels: "1", // 0, 1 o n
				id: portId,  // le asigno un id por defecto
				preset_value: {
					description: "", //"Error"
					conditions: [
						{ field: "_result.result", comparator: "~=", value: "'OK'" }
					],
					port_id: portId
				}
			});

		} else {

			let errores_admitidos = ["Error"];
			errores_admitidos.forEach(error_type => {
				let existe = node?node.children.find(c => c.id.includes("_" + error_type)):undefined;
				let portId = (existe?existe.id:inConcert.Utils.generateGuid() + "_" + error_type);
				ports.push({
					direction : "out", // in/out
					type : "error", // error/success/option
					option_label : error_type, // error/success/option
					channels: "1", // 0, 1 o n
					id: portId,  // le asigno un id por defecto
					preset_value: {
						description: "", //error_type
						conditions: [
							{ field: data.result + ".eventname", comparator: "==", value: "\""+ error_type +"\"" }
						],
						port_id: portId
					}
				});
			});

		}
		
		return ports;
	};

	adm_process_flow_activity.prototype.__cancel = function(callback) {
		if (this.isNew) {
			this.editor.CancelConnection(this.connector);
		}
		callback();
	};

	adm_process_flow_activity.prototype.__save = function(data, callback) {
		this.editor.AddOrUpdateActivity(this.node, data);
		callback(true);
	};

}());
