/* jshint forin:true, noarg:true, jquery:true, noempty:true, eqeqeq:true, bitwise:true,
	strict:true, undef:true, unused:vars, curly:true, browser:true, indent:false, maxerr:50, quotmark:double, esversion: 9 */

/* global inConcert, Mustache */

if (!this.inConcert) {
	this.inConcert = {};
}

(function () {
	//"use strict";

	var id = "start_recording";

	function adm_process_flow_activity(editor, node) {
		adm_process_flow_activity.uber.constructor.call(this, editor, node);

		this.startDefinition = {
			id : "start",
			name : "<%=_T('Start/Stop recording')%>",
			checkedName : "<%=_T('Start recording')%>",
			uncheckedName : "<%=_T('Stop recording')%>",
			description : "<%=_T('Start or stop recording.')%>",
			defaultValue : true,
			controlContainerClass: "d-flex"
		};

		this.focusControl = this.startDefinition;
	}

	inConcert.Utils.inherit( adm_process_flow_activity, inConcert.adm_process_flow_activities.base );

	if (typeof inConcert.adm_process_flow_activities[id] !== "function") {
		inConcert.adm_process_flow_activities[id] = adm_process_flow_activity;
	}

	adm_process_flow_activity.prototype.id = id;
	adm_process_flow_activity.prototype.name = "<%=_T('Start/Stop recording')%>";
	adm_process_flow_activity.prototype.description = "<%=_T('Start or stop recording.')%>";
	adm_process_flow_activity.prototype.group = "interaction";
	adm_process_flow_activity.prototype.channels = { 
		"CALL" : true
	};
	adm_process_flow_activity.prototype.image = "ico-start-recording.svg";
	
	adm_process_flow_activity.prototype.dataStyle = function(data) {
		return data.start? "start_recording" : "stop_recording";
	};
	
	adm_process_flow_activity.prototype.dataStyles = function() {
		return [
			{ id : "start_recording", imageName : "ico-start-recording.svg" },
			{ id : "stop_recording", imageName : "ico-stop-recording.svg" }
		];
	};

	adm_process_flow_activity.prototype.__getClassName = function() {
		return "popOver380w flowDesignerGlobalModal botActivity_start_recording";
	};

	adm_process_flow_activity.prototype.__makeContent = function() {
		var $content = adm_process_flow_activity.uber.__makeContent.call(this);

		$content.unshift(
			this.__makeDivFlex(
			  [
				this.__makeDivFlex(
				  [
					this.__makeBooleanRadioButton(this.startDefinition, this.data[this.startDefinition.id])
				  ],
				  { class: "card-block" }
				),
			  ],
			  { class: "card no-card" }
			)
		  );

		return $content;
	};

	adm_process_flow_activity.prototype.__getAndValidate = function() {
		var data = adm_process_flow_activity.uber.__getAndValidate.call(this);
		this.__addValue(data, this.startDefinition);
		return data;
	};

	// adm_process_flow_activity.prototype.htmlBody = function(data) { 
	
		
	// 	return Mustache.render(inConcert.templates.process_flows.start_recording_activity_template, {
	// 		image: `custom_icon_${data.start? "start_recording" : "stop_recording"}`, 
	// 		description: ((data.description && data.description !== "")?data.description:"<%=_T('Start/Stop recording')%>") 
	// 	});
	// };

	adm_process_flow_activity.prototype.htmlBody = function (data) {

		var image = "";

		if (data) {
			var type = data.message && data.message.msgtype || "text";
			if (type === "attachment") {
				type = data.message.fileType || "attachment";
			}
			image = id + "_" + type;
		}

		return Mustache.render(inConcert.templates.process_flows.activity_template, {
			image: `custom_icon_${data.start? "start_recording" : "stop_recording"}`, 
			description: ((data.description && data.description !== "")?data.description:"<%=_T('Start/Stop recording')%>") 
		});
	};

	adm_process_flow_activity.prototype.ports = function(data, node) {
		

		let ports = [];

		// siempre hay que agregar este por defecto
		ports.push({
			direction : "in", // in/out
			type : "option", // error/success/option
			option_label : "Input" // error/success/option
		});

		// agrego puerto único por defecto
		let existe = node?node.children.find(c => c.id.includes("_default")):undefined;
		let portId = (existe?existe.id:inConcert.Utils.generateGuid() + "_default");
		ports.push({
			direction : "out", // in/out
			type : "option", // error/success/option/none
			option_label : "<%=_T('Default output')%>", // error/success/option
			channels: "n", // 0, 1 o n
			id: portId,  // le asigno un id por defecto
			preset_value: undefined,
			intern_value: undefined
		});

		return ports;
	};

}());
