/* jshint forin:true, noarg:true, jquery:true, noempty:true, eqeqeq:true, bitwise:true,
	strict:true, undef:true, unused:vars, curly:true, browser:true, indent:false, maxerr:50, quotmark:double */

/* global inConcert */

if (!this.inConcert) {
	this.inConcert = {};
}

(function () {
	//"use strict";

	function adm_process_flow_duplicate_class_popup(main, data) {
		adm_process_flow_duplicate_class_popup.uber.constructor.call(this);
		this.main = main;
		this.data = data;
		this.showEditTitleButton = false;
		
		var self = this;
		
		this.nameDefinition = {
			id : "Name",
			name : "<%=_T('Name')%>",
			description : "<%=_T('Class name.')%>",
			required : true,
			validate : {
				type : "variable",
				message : "<%=_T('Invalid class name.')%>",
				method : function(value) {
					if (self.main.GetClassFromName(value)) {
						return "<%=_T('Already exists a class with same name.')%>";
					}
				}
			}
		};
		
		this.focusControl = this.nameDefinition;
	}

	inConcert.Utils.inherit( adm_process_flow_duplicate_class_popup, inConcert.adm_process_flow_popup );

	if (typeof inConcert.adm_process_flow_duplicate_class_popup !== "function") {
		inConcert.adm_process_flow_duplicate_class_popup = adm_process_flow_duplicate_class_popup;
	}

	adm_process_flow_duplicate_class_popup.prototype.__getClassName = function() {
		// return "flowDesignerDuplicateClassPopup hybridDesignContainer";
		return "popUp380w flowDesignerGlobalModal flowDesignerOverlayModal";
	};

	adm_process_flow_duplicate_class_popup.prototype.__getTitle = function() {
		return "<%=_T('Duplicate Class')%>";
	};

	adm_process_flow_duplicate_class_popup.prototype.__makeContent = function() {
		var $content = [];
		$content.push(
			//this.__makeRowFlex(this.__makeInput(this.nameDefinition, this.data[this.nameDefinition.id]))
			this.__makeDivFlex(
				[
				  this.__makeDivFlex(
					[
					  this.__makeRowFlex([
						this.__makeDivFlex(
						  [
							this.__makeInput(this.nameDefinition, this.data[this.nameDefinition.id])
						  ],
						  { class: "form-group" }
						),
					  ]),
					],
					{ class: "card-block" }
				  ),
				],
				{ class: "card no-card" }
			)
			);
		return $content;
	};

	adm_process_flow_duplicate_class_popup.prototype.__getAndValidate = function() {
		var data = {
			Id : inConcert.Utils.generateGuid()
		};
		this.__addValue(data, this.nameDefinition);
		return data;
	};

	adm_process_flow_duplicate_class_popup.prototype.__save = function(data, callback) {
		var self = this;
		$.each(data, function(k, v) {
			self.data[k] = v;
		});
		self.main.AddClass(self.data, true, true);
		callback(true);
	};

}());
