/* jshint forin:true, noarg:true, jquery:true, noempty:true, eqeqeq:true, bitwise:true,
	strict:true, undef:true, unused:vars, curly:true, browser:true, indent:false, maxerr:50, quotmark:double */

/* global inConcert */

if (!this.inConcert) {
	this.inConcert = {};
}

(function () {
	//"use strict";

	function adm_process_flow_new_method_popup(main, classEditor) {
		adm_process_flow_new_method_popup.uber.constructor.call(this);
		this.main = main;
		this.classEditor = classEditor;
		this.showEditTitleButton = false;
		
		var self = this;
		
		this.nameDefinition = {
			id : "name",
			name : "<%=_T('Name')%>",
			description : "<%=_T('Method name.')%>",
			required : true,
			validate : {
				type : "variable",
				message : "<%=_T('Invalid method name.')%>",
				method : function(value) {
					return self.classEditor.ValidatePropertyName(value);
				}
			}
		};
		
		this.focusControl = this.nameDefinition;
	}

	inConcert.Utils.inherit( adm_process_flow_new_method_popup, inConcert.adm_process_flow_popup );

	if (typeof inConcert.adm_process_flow_new_method_popup !== "function") {
		inConcert.adm_process_flow_new_method_popup = adm_process_flow_new_method_popup;
	}

	adm_process_flow_new_method_popup.prototype.__getClassName = function() {
		// return "flowDesignerNewMethodPopup hybridDesignContainer";
		return "popUp380w flowDesignerGlobalModal flowDesignerOverlayModal";
	};

	adm_process_flow_new_method_popup.prototype.__getTitle = function() {
		return "<%=_T('New Method')%>";
	};

	adm_process_flow_new_method_popup.prototype.__makeContent = function() {
		var $content = [];
		$content.push(this.__makeDivFlex(
			[
			  this.__makeDivFlex(
				[
				  this.__makeRowFlex([
					this.__makeDivFlex(
					  [
						this.__makeInput(this.nameDefinition)
					  ],
					  { class: "form-group" }
					),
				  ]),
				],
				{ class: "card-block" }
			  ),
			],
			{ class: "card no-card flowDesignerClassesPopupNewMethod" }
		));
		return $content;
	};

	adm_process_flow_new_method_popup.prototype.__getAndValidate = function() {
		var data = {
			parameters : [],
			code : "",
			description : "",
			examples : ""
		};
		this.__addValue(data, this.nameDefinition);
		return data;
	};

	adm_process_flow_new_method_popup.prototype.__save = function(data, callback) {
		this.classEditor.AddMethod(inConcert.Utils.generateGuid(), data);
		callback(true);
	};

}());
