
/* jshint forin:true, noarg:true, jquery:true, noempty:true, eqeqeq:true, bitwise:true,
  strict:true, undef:true, unused:true, curly:true, browser:true, indent:false, maxerr:50 */

/* global inConcert*/

// Create an inConcert object only if one does not already exist. We create the
// methods in a closure to avoid creating global variables.
if ( !this.inConcert ) {
  this.inConcert = {};
}
if (!inConcert.templates) {
	inConcert.templates = {};
}

(function () {

'use strict';

var Templates = {
	//designer
	base: "".concat(
		"<div id='flowDesignerClassesContainer' class='flowDesignerClassesContainer'>",
				"<div class='flowDesignerClassesTitle  pageHeader'>",
					"<div class='pageButtonContainer ' style=''>",
						"<button  close_button  class='butBackToDashboardArrow d-flex mr-0'>", 
							"<i class='fas fa-chevron-left mr-0'></i>",
						"</button>",
					"</div>",
					"<div class='pageTitleContainer' style=''>",
						'<i class="far fa-brackets-curly"></i>',
						'<label class="flowDesignerClassesTitleText pageTitle d-flex">',
							'<%=_T("Classes IDE")%>',
						'</label>',
					"</div>",
					"<div class='pageButtonContainer ml-auto' style=''>",
						"<div global_actions class='flowDesignerClassesGlobalActions'>",
						"</div>",
					"</div>",
				"</div>",		
			"<div processing class='flowDesignerClassesProcessing' hidden>",
			"</div>",
			"<div class='row m-0'>",
				"<div editor_container class='flowDesignerClassesEditorContainer'>",
					"<div tool_bar class='flowDesignerClassesToolBar card'>",
						"<div class='flowDesignerDatasourcesTitleContainer'>",
							"<h5><%=_T('Classes')%></h5>",
							"<button action_button='new_class' class='actionAddButton'><i class='far fa-plus'></i></button>",
						"</div>",
						"<ul tool_bar_list_class class='flowDesignerClassesToolbarClassesList'>",
						"</ul>",
					"</div>",
					"<div class='flowDesignerClassesToolBar card'>",
						"<div class='flowDesignerDatasourcesTitleContainer'>",
							"<h5 context_name='true'></h5>",
						"</div>",
						"<div tool_bar_list_class_members class='flowDesignerClassesToolbarClassesList' style='display:block'>",
						"</div>",
					"</div>",
					"<div form_container class='flowDesignerClassesEditor card'>",
						"<div class='flowDesignerDatasourcesTitleContainer' >",
							"<h5 classes_editor_name='true' ></h5>",
							"<div classes_editor_system_name style='display:none' class='flowDesignerSystemDefaultLabel'>",
								"<span><%=_T('System Default')%></span>",
							"</div>",
						"</div>",
					"</div>",
				"</div>",
			"</div>",
		"</div>"
	),
	
	//actions bar
	action_button: "".concat(
		"<button action_button='{{ id }}' {{ #fixedButton }}fixed_button{{ /fixedButton }} class='pageButtonGeneric pageButtonNew buttonColorWhite pageButtonNoIcon flowDesignerClassesActionButton {{ id }}FlowClassesActionButton {{ #withoutText }}withoutText{{ /withoutText }}' title='{{ description }}' {{ #hidden }}style='display:none;' {{ /hidden }} {{ #disabled }}disabled{{ /disabled }}>",
			"{{ #withText }}{{ name }}{{ /withText }}",
		"</button>"
	),
	//actions bar
	class_action: "".concat(
		"<button class_action_button='{{ id }}' class='{{ id }}FlowDatasourcesActionButton' style='border:none' title='{{ description }}' {{ #hidden }}hidden{{ /hidden }}>",
			"<i class='{{action_icon_class}}'></i>",
		"</button>"
	),
	//tool bar
	toolbar_class: "".concat(
		"<li toolbar_class='{{ id }}' class_name='{{ name }}' class_selector='true' class='flowDesignerToolbarClass {{ #readonly }}readonlyClass{{ /readonly }} {{ #system }}systemClass{{ /system }}'>",
			"<div class_selector='true' class_selector_title class='flowDesignerToolbarClassTitle' title='{{ description }}'>",
				"<div class_selector='true' class='flowDesignerToolbarClassTitleItem' >",
					"<i class_selector='true' class='fas fa-brackets-curly mr-2'></i>",
					"<span toolbar_class_readonly_name>{{ name }}</span>",
					"<input toolbar_class_edit_name type='text' value='{{ name }}' hidden>",
				"</div>",
				"<div class='flowDesignerToolbarDatasourceTitleItem' editor_actions='true'>",
				"</div>",
			"</div>",
		"</li>"
	),
	//tool bar
	toolbar_class_members: "".concat(
		"<div toolbar_class_members='{{ id }}' class='flowDesignerToolbarClassesMainContainer'>",
			"<div class='flowDesignerToolbarClassesGroupContainer'>",
				"<div class_id='{{ id }}' toolbar_class_members_general class='flowDesignerToolbarClassesTopContainer generalGroup'>",
					"<label class='flowDesignerToolbarClassesTitleLabel'>",
						"<i class='far fa-info'></i>",
						"<%=_T('General')%>",
					"</label>",
				"</div>",
			"</div>",
			"<div class='flowDesignerToolbarClassesGroupContainer'>",
				"<div toolbar_class_members_head='attributes' class='flowDesignerToolbarClassesTopContainer'>",
					"<i class='far fa-chevron-down'></i>",
					"<label class='flowDesignerToolbarClassesTitleLabel'>",
						"<i class='far fa-at'></i>",
						"<%=_T('Attributes')%>",
					"</label>",
					"<button add_attribute='{{ id }}' class='actionAddButton'>",
						"<i class='far fa-plus' title='<%=_T('Add attribute')%>'></i>",
					"</button>",
				"</div>",
				"<ul attributes_list class='flowDesignerToolbarAttributesList' style='display:none;'>",
				"</ul>",
			"</div>",
			"<div class='flowDesignerToolbarClassesGroupContainer'>",
				"<div toolbar_class_members_head='methods' class='flowDesignerToolbarClassesTopContainer'>",
					"<i class='far fa-chevron-down'></i>",
					"<label class='flowDesignerToolbarClassesTitleLabel' >",
						"<i class='far fa-function'></i>",
						"<%=_T('Methods')%>",
					"</label>",
					"<button add_method='{{ id }}' class='actionAddButton'>",
						"<i class='far fa-plus' title='<%=_T('Add method')%>'></i>",
					"</button>",
				"</div>",
				"<ul methods_list class='flowDesignerToolbarMethodsList' style='display:none;'>",
					"<li class='flowDesignerToolbarAddAttribute'></li>",
				"</ul>",
			"</div>",
		"</div>"
	),
	toolbar_attribute: "".concat(
		"<li class_id ='{{ class_id }}' toolbar_attribute='{{ id }}' attribute_name='{{ name }}' class='flowDesignerToolbarAttribute' title='{{ description }}'>",
			"<div class='flowDesignerToolbarClassTitleItem' >",
				"<span toolbar_attribute_readonly_name>{{ name }}</span>",
				"<input toolbar_attribute_edit_name type='text' value='{{ name }}' hidden>",
			"</div>",
			"<div class='flowDesignerToolbarDatasourceTitleItem' attribute_editor_actions='true'>",
			"</div>",
		"</li>"
	),
	toolbar_method: "".concat(
		"<li class_id ='{{ class_id }}' toolbar_method='{{ id }}' {{ #method }}method_name='{{ name }}'{{ /method }} class='flowDesignerToolbarMethod' title='{{ description }}'>",
			"<i class='flowDesignerToolbarMethodIcon'></i>",
			"<div class='flowDesignerToolbarClassTitleItem' >",
				"<span toolbar_method_readonly_name>{{ name }}</span>",
				"<input toolbar_method_edit_name type='text' value='{{ name }}' hidden>",
			"</div>",
			"<div class='flowDesignerToolbarDatasourceTitleItem' method_editor_actions='true'>",
			"</div>",
		"</li>"
	),
	editor_container: "".concat(
		"<div class_editor_container='true' class='flowDesignerClassEditorContainer card-block {{ className }}'>",
		"</div>"
	),
	editor_description: "".concat(
		"<div class='row'>",
			"<div class='col-12'>",
				"<div class='card-header'>",
					"<h4 title='{{ description }}'>",
						"{{ name }}",
					"</h4>",
				"</div>",
			"</div>",
		"</div>",
		"<div class='row'>",
			"<div class='col-12'>",
				"<div class='form-group mb-1'>",
					"<textarea description class='form-control'>",
						"{{ text }}",
					"</textarea>",
				"</div>",
			"</div>",
		"</div>"
	),
	editor_examples: "".concat(
		"<div class='row'>",
			"<div class='col-12'>",
				"<div class='card-header'>",
					"<h4 title='{{ description }}'>",
						"{{ name }}",
					"</h4>",
				"</div>",
			"</div>",
			"<div examples class='flowDesignerClassExamplesEdit'>",
			"</div>",
		"</div>"
	),
	editor_params_container: "".concat(
		"<div class='row'>",
			"<div class='col-12'>",
				"<div class='card-header'>",
					"<h4 title='{{ description }}'>",
						"{{ name }}",
					"</h4>",
				"</div>",
			"</div>",
		"</div>",
		"<div class='row'>",
			"<div class='col-12 d-flex align-items-center justify-content-start mb-1'>",
				"<div class='flowDesignerClassParam selfParam'>",
					"<label param_label class='flowDesignerClassParameter' title='self'>",
						"self",
					"</label>",
				"</div>",
				"<ul parameters_list class='flowDesignerClassParameters'>",
				"</ul>",
				"<button parameters_add class='actionAddButton' title='", "<%=_T('Add parameter')%>" , "'>",
					"<i class='far fa-plus'></i>",
				"</button>",
			"</div>",
		"</div>",
		//"<hr/>"
	),
	editor_param: "".concat(
		"<li param='{{ id }}' param_name='{{ name }}' {{ #readonly }}readonly{{ /readonly }} class='flowDesignerClassParam modeView {{ #readonly }}readonly{{ /readonly }}'>",
			"<label param_label class='flowDesignerClassParameter' title='{{ name }}'>",
				"{{ name }}",
			"</label>",
			"<button param_edit='{{ id }}' class='buttonColorGray flowDesignerClassParamEditButton' title='", "<%=_T('Edit')%>" , "'>",
				"<i class='far fa-pencil'></i>",
			"</button>",
			"<button param_delete='{{ id }}' class='buttonColorGray flowDesignerClassParamDeleteButton' title='", "<%=_T('Remove')%>" , "'>",
				"<i class='far fa-trash-alt'></i>",
			"</button>",
			"<input param_value type='text' class='flowDesignerClassParamValue'>",
			"<button param_confirm='{{ id }}' class='buttonColorGray flowDesignerClassParamConfirmButton' title='", "<%=_T('Update')%>" , "'>",
				"<i class='far fa-check-circle'></i>",
			"</button>",
			"<button param_cancel='{{ id }}' class='buttonColorGray flowDesignerClassParamCancelButton' title='", "<%=_T('Cancel')%>" , "'>",
				"<i class='far fa-minus-circle'></i>",
			"</button>",
		"</li>"
	),
	editor_code_container: "".concat(
		"<div class='row'>",
			"<div class='col-12'>",
				"<div class='card-header'>",
					"<h4 class='flowDesignerClassCodeLabel' title='{{ description }}'>",
						"{{ name }}",
					"</h4>",
				"</div>",
			"</div>",
			"<div code_block class='flowDesignerClassCode'>",
			"</div>",
		"</div>",
		//"<hr/>"
	),
	editor_value_container: "".concat(
		"<div class='row'>",
			"<div class='col-12'>",
				"<div class='card-header'>",
					"<h4 title='{{ description }}'>",
						"{{ name }}",
					"</h4>",
				"</div>",
			"</div>",
		"</div>",
		"<div class='row'>",
			"<div class='col-12'>",
				"<div class='form-group'>",
					"<input attribute_value type='text' class='form-control'>",
				"</div>",
			"</div>",
		"</div>",
		//"<hr/>"
	)
};

	if ( !inConcert.templates.process_flow_classes ) {
		inConcert.templates.process_flow_classes = Templates;
	}
}());