/* jshint forin:true, noarg:true, jquery:true, noempty:true, eqeqeq:true, bitwise:true,
	strict:true, undef:true, unused:vars, curly:true, browser:true, indent:false, maxerr:50, quotmark:double */

/* global inConcert */

if (!this.inConcert) {
	this.inConcert = {};
}

(function () {
	//"use strict";
	
	var templates = inConcert.templates.process_flows;

	function adm_process_flow_classes_popup(main, data) {
		adm_process_flow_classes_popup.uber.constructor.call(this);
		this.main = main;
		this.data = data;
		this.showEditTitleButton = false;
		
		this.classesDefinition = {
			id : "Classes",
			name : "<%=_T('Classes')%>",
			subtitle : "<%=_T('Available clases')%>",
			description : "<%=_T('Classes to be used by process.')%>",
			sort : true,
			form_group: true 
		};
		
		this.focusFirst = true;
	}

	inConcert.Utils.inherit( adm_process_flow_classes_popup, inConcert.adm_process_flow_popup );

	if (typeof inConcert.adm_process_flow_classes_popup !== "function") {
		inConcert.adm_process_flow_classes_popup = adm_process_flow_classes_popup;
	}

	adm_process_flow_classes_popup.prototype.__getClassName = function() {
		return "popUp380w flowDesignerGlobalModal";

	};

	adm_process_flow_classes_popup.prototype.__getTitle = function() {
		return "<%=_T('Process Flow Classes')%>";
	};

	adm_process_flow_classes_popup.prototype.__load = function(callback) {
		var self = this;
		self.main.GetClasses(function(classes) {
			var classes_a = [];
			$.each(classes, function(_, classData) {
				var name = classData.Name;
				if (classData.System) {
					name += " (<%=_T('System')%>)";
				}
				classes_a.push({
					id : classData.Id,
					name : name
				});
			});
			self.classesDefinition.options = classes_a;
			callback();
		});
	};

	adm_process_flow_classes_popup.prototype.__makeContent = function() {
		var $content = [];

		$content.push(
			this.__makeDivFlex(
			  [
				this.__makeDivFlex(
				  [
					this.__makeCheckboxList(this.classesDefinition, this.data[this.classesDefinition.id])
				  ],
				  { class: "card-block" }
				),
			  ],
			  { class: "card no-card" }
			)
		  );

		return $content;
	};
	
	adm_process_flow_classes_popup.prototype.__makeActions = function() {
		const self = this;
		let $actionsArray = [];
		const $actions = adm_process_flow_classes_popup.uber.__makeActions.call(this);
		const $classesIdeButton = $(templates.popup_action_classesIde);
		$classesIdeButton.click(function() {
			if (self.IsProcessing()) {
				return;
			}
			self.Close(function() {
				self.main.ShowClassesEditor();
			});
		});
		$actionsArray.push($classesIdeButton);
		$actionsArray.push($actions);
		return $actionsArray;
	};

	adm_process_flow_classes_popup.prototype.__getAndValidate = function() {
		var data = {};
		this.__addValue(data, this.classesDefinition);
		return data;
	};

	adm_process_flow_classes_popup.prototype.__hasCloseButton = function() {
		return true;
	};

	adm_process_flow_classes_popup.prototype.__save = function(data, callback) {
		this.main.UpdateProperties(data, function(status, errorCode) {
			if (status) {
				callback(true);
			}
			else {
				var error = {
					message : "<%=_T('Error validating flow.')%>"
				};
				switch(errorCode) {
					case "FORBIDDEN":
						error.message = "<%=_T('Unable to save process flow. You dont have permission.')%>";
						break;
				}
				callback(false, error);
			}
		}, true);
	};

}());
