/* jshint forin:true, noarg:true, jquery:true, noempty:true, eqeqeq:true, bitwise:true,
	strict:true, undef:true, unused:vars, curly:true, browser:true, indent:false, maxerr:50, quotmark:double */

/* global inConcert */

if (!this.inConcert) {
	this.inConcert = {};
}

(function () {
	//"use strict";

	function adm_process_flow_export_datasources_popup(main) {
		adm_process_flow_export_datasources_popup.uber.constructor.call(this);
		this.main = main;
		this.showEditTitleButton = false;
		
		this.datasourcesDefinition = {
			id : "Datasources",
			name : "<%=_T('Datasources')%>",
			description : "<%=_T('Datasources to be exported.')%>",
			sort : true,
			selectAll : true,
			required : true
		};
		
		this.focusFirst = true;
	}

	inConcert.Utils.inherit( adm_process_flow_export_datasources_popup, inConcert.adm_process_flow_popup );

	if (typeof inConcert.adm_process_flow_export_datasources_popup !== "function") {
		inConcert.adm_process_flow_export_datasources_popup = adm_process_flow_export_datasources_popup;
	}

	adm_process_flow_export_datasources_popup.prototype.__getClassName = function() {
		return "popUp380w flowDesignerGlobalModal";
	};

	adm_process_flow_export_datasources_popup.prototype.__getTitle = function() {
		return "<%=_T('Export Datasources')%>";
	};

	adm_process_flow_export_datasources_popup.prototype.__makeContent = function() {
		var self = this;
		self.datasourcesDefinition.options = [];
		$.each(self.main.datasources, function(_, datasourceEditor) {
			if (datasourceEditor.IsReadonly()) {
				return;
			}
			self.datasourcesDefinition.options.push({
				id : datasourceEditor.data.Id,
				name : datasourceEditor.data.Name
			});
		});
		
		var $content = [];
		$content.push(self.__makeCheckboxList(self.datasourcesDefinition));
		return $content;
	};

	adm_process_flow_export_datasources_popup.prototype.__getAndValidate = function() {
		var data = {};
		this.__addValue(data, this.datasourcesDefinition);
		return data;
	};

	adm_process_flow_export_datasources_popup.prototype.__save = function(data, callback) {
		var self = this;
		var datasources = [];
		$.each(data[self.datasourcesDefinition.id], function(dsId) {
			datasources.push(dsId);
		});
		self.main.ExportDatasources(datasources, function(status, error) {
			callback(status, error);
		});
	};

}());
