/* jshint forin:true, noarg:true, jquery:true, noempty:true, eqeqeq:true, bitwise:true,
	strict:true, undef:true, unused:vars, curly:true, browser:true, indent:false, maxerr:50, quotmark:double */

/* global inConcert */

if (!this.inConcert) {
	this.inConcert = {};
}

(function () {
	//"use strict";
	
	var templates = inConcert.templates.process_flows;
	var format = inConcert.Utils.format;

	function adm_process_flow_datasources_popup(main, data) {
		adm_process_flow_datasources_popup.uber.constructor.call(this);
		this.main = main;
		this.data = data;
		this.showEditTitleButton = false;
		
		this.datasourcesDefinition = {
			id : "Datasources",
			name : "<%=_T('Datasources')%>",
			subtitle : "<%=_T('Available sources')%>",
			description : "<%=_T('Datasources to be used by process.')%>",
			sort : true,
			form_group: true
		};
		
		this.focusFirst = true;
	}

	inConcert.Utils.inherit( adm_process_flow_datasources_popup, inConcert.adm_process_flow_popup );

	if (typeof inConcert.adm_process_flow_datasources_popup !== "function") {
		inConcert.adm_process_flow_datasources_popup = adm_process_flow_datasources_popup;
	}

	adm_process_flow_datasources_popup.prototype.__getClassName = function() {
		return "popUp380w flowDesignerGlobalModal";
	};

	adm_process_flow_datasources_popup.prototype.__getTitle = function() {
		return "<%=_T('Process Flow Datasources')%>";
	};

	adm_process_flow_datasources_popup.prototype.__load = function(callback) {
		var self = this;
		self.main.GetDatasources(function(datasources) {
			var datasources_a = [];
			$.each(datasources, function(_, dsData) {
				var typeLabel = inConcert.flowDesignerDatasourcesTypesLabels[dsData.Type] || dsData.Type;
				datasources_a.push({
					id : dsData.Id,
					name : format("{0} - {1}", typeLabel, dsData.Name)
				});
			});
			self.datasourcesDefinition.options = datasources_a;
			callback();
		});
	};

	adm_process_flow_datasources_popup.prototype.__makeContent = function() {
		var $content = [];
		$content.push(
			this.__makeDivFlex(
			  [
				this.__makeDivFlex(
				  [
					this.__makeCheckboxList(this.datasourcesDefinition, this.data[this.datasourcesDefinition.id])
				  ],
				  { class: "card-block" }
				),
			  ],
			  { class: "card no-card" }
			)
		  );

		return $content;
	};
	
	adm_process_flow_datasources_popup.prototype.__makeActions = function() {
		const self = this;
		let $actionsArray = [];
		const $actions = adm_process_flow_datasources_popup.uber.__makeActions.call(this);
		const $datasourcesIdeButton = $(templates.popup_action_datasourcesIde);
		$datasourcesIdeButton.click(function() {
			if (self.IsProcessing()) {
				return;
			}
			self.Close(function() {
				self.main.ShowDatasourcesEditor();
			});
		});
		$actionsArray.push($datasourcesIdeButton);
		$actionsArray.push($actions);
		return $actionsArray;
	};

	adm_process_flow_datasources_popup.prototype.__getAndValidate = function() {
		var data = {};
		this.__addValue(data, this.datasourcesDefinition);
		return data;
	};

	adm_process_flow_datasources_popup.prototype.__hasCloseButton = function() {
		return true;
	};

	adm_process_flow_datasources_popup.prototype.__save = function(data, callback) {
		this.main.UpdateProperties(data, function(status, errorCode) {
			if (status) {
				callback(true);
			}
			else {
				var error = {
					message : "<%=_T('Error validating flow.')%>"
				};
				switch(errorCode) {
					case "FORBIDDEN":
						error.message = "<%=_T('Unable to save process flow. You dont have permission.')%>";
						break;
				}
				callback(false, error);
			}
		}, true);
	};

}());
