/* jshint forin:true, noarg:true, jquery:true, noempty:true, eqeqeq:true, bitwise:true,
	strict:true, undef:true, unused:vars, curly:true, browser:true, indent:false, maxerr:50, quotmark:double, esversion: 9*/

/* global inConcert */

if (!this.inConcert) {
	this.inConcert = {};
}

(function () {
	//"use strict";
	
	const format = inConcert.Utils.format;

//message types

	//text
	function adm_process_flow_messages_type_text(parent, options) {
		adm_process_flow_messages_type_text.uber.constructor.call(this, parent, options);
		
		this.textDefinition.emojipicker = false;
	}

	inConcert.Utils.inherit( adm_process_flow_messages_type_text, inConcert.adm_process_flow_messages_type.base.text );
	
	adm_process_flow_messages_type_text.prototype.__hasButtons = function() {
		return false;
	};

	//attachment
	function adm_process_flow_messages_type_attachment(parent, options) {
		adm_process_flow_messages_type_attachment.uber.constructor.call(this, parent, options);
		
		this.attachmentTypeDefinition.options = this.attachmentTypeDefinition.options.filter(function(option) {
			return option.id !== "url";
		});

		this.fileTypeDefinition.options = this.fileTypeDefinition.options.filter(function(option) {
			return option.id === "audio";
		});
	}

	inConcert.Utils.inherit( adm_process_flow_messages_type_attachment, inConcert.adm_process_flow_messages_type.base.attachment );

	adm_process_flow_messages_type_attachment.prototype.__getFileTypeDefinition = function() {
		return inConcert.FileUploaderTypes.asterisk_audio;
	};

	//menu
	function adm_process_flow_messages_type_menu(parent) {
		adm_process_flow_messages_type_menu.uber.constructor.call(this, parent);
		this.valueDefinition.hidden = true;
		this.optionsListDefinition.count = 12;
		this.optionsListDefinition.customIndexes[11] = "*";
		this.optionsListDefinition.customIndexes[12] = "#";
		this.messageOptions.message_types = [
			{
				id : "attachment",
				name : "<%=_T('Attachment')%>"
			}
		];
		if(parent.activity.isTtsEnabled)
		{
			this.messageOptions.message_types.push({id: "text", name: "<%=_T('Text')%>"});
		}
		let sample = "".concat(
			"{",
				"{",
					"message = {",
						"attachmentType = 'repository',",
						"msgtype = 'attachment',",
						"fileType = 'audio',",
						"options = {",
							"{type = 'file', sharedFile = '01Emma.wav'},",
							"{type = 'file', sharedFile = '25.wav'},",
							"{message = '{CAMPAIGN_DESCRIPTION}', type = 'file'},",
							"{__brackets_message = {'VARIABLE2'}, type = 'file', message = '{{VARIABLE2}}'}",
						"}",
					"},",
					 "index = '1',",
					 "value = '1',",
					 "id = '',",
					 "recognize = ''",
				"}",
			"}"
		);
		this.itemsDefinition.disclaimer = format("<%=_T('Example: {0}')%>", sample);
	}

	inConcert.Utils.inherit( adm_process_flow_messages_type_menu, inConcert.adm_process_flow_messages_type.base.menu );

	if (!inConcert.adm_process_flow_messages_type.call) {
		inConcert.adm_process_flow_messages_type.call = {
			text : adm_process_flow_messages_type_text,
			attachment : adm_process_flow_messages_type_attachment,
			menu : adm_process_flow_messages_type_menu
		};
	}

	if (!inConcert.adm_process_flow_messages_type.call_sorted) {
		inConcert.adm_process_flow_messages_type.call_sorted = [
			"attachment",
			"text"
		];
	}
	
//button types
	if (!inConcert.adm_process_flow_messages_button.call) {
		inConcert.adm_process_flow_messages_button.call = {
			list : inConcert.adm_process_flow_messages_button.base.base,
			gallery : inConcert.adm_process_flow_messages_button.base.base
		};
	}

//quick replies
	if (!inConcert.adm_process_flow_messages_quickreply.call) {
		inConcert.adm_process_flow_messages_quickreply.call = inConcert.adm_process_flow_messages_quickreply.base;
	}

//clase
	function adm_process_flow_messages(activity) {
		adm_process_flow_messages.uber.constructor.call(this, activity);
	}

	inConcert.Utils.inherit( adm_process_flow_messages, inConcert.adm_process_flow_messages.base );

	if (typeof inConcert.adm_process_flow_messages.call !== "function") {
		inConcert.adm_process_flow_messages.call = adm_process_flow_messages;
	}

	adm_process_flow_messages.prototype.__maxQuickreplies = function() {
		return 0;
	};

	adm_process_flow_messages.prototype.__hasWriting = function() {
		return false;
	};

}());
