/* jshint forin:true, noarg:true, jquery:true, noempty:true, eqeqeq:true, bitwise:true,
	strict:true, undef:true, unused:vars, curly:true, browser:true, indent:false, maxerr:50, quotmark:double */

/* global inConcert */

if (!this.inConcert) {
	this.inConcert = {};
}

(function () {
	//"use strict";
	
//message types
	
	function adm_process_flow_messages_type_gallery(parent) {
		adm_process_flow_messages_type_gallery.uber.constructor.call(this, parent);
		
		var self = this;
		
		//web url
		this.webviewDefinition = {
			id : "webview",
			name : "<%=_T('Webview')%>",
			description : "<%=_T('Indicates if url is open in a embedded webview.')%>",
			inverse_order : true,
			change : function() {
				self.__webviewChange($(this).closest("[gallery_item_form]"));
			},
            not_extended: true,
			form_group: false,
			envolving_label_class: "form-check-label form-check-label-title",
			envolving_label: true,
			without_label: true,
			controlContainerClass: "form-check",
			checkBoxClass: "form-check-input"
		};
		this.webviewSizeDefinition = {
			id : "webviewSize",
			name : "<%=_T('Webview size')%>",
			placeholder : "<%=_T('Webview size')%>",
			description : "<%=_T('Webview size.')%>",
			options : [
				{ id : "compact", name : "<%=_T('Compact')%>" },
				{ id : "tall", name : "<%=_T('Tall')%>" },
				{ id : "full", name : "<%=_T('Full')%>" }
			],
			required : true,
			without_label : true
		};
		this.webviewShareDefinition = { /* #12989 */
			id : "webviewShareButton",
			name : "<%=_T('Share')%>",
			description : "<%=_T('Indicates if webview share content button is shown.')%>",
			inverse_order : true,
			not_extended: true,
			form_group: false,
			envolving_label_class: "form-check-label form-check-label-title",
			envolving_label: true,
			without_label: true,
			controlContainerClass: "form-check",
			checkBoxClass: "form-check-input"
		};
	}

	inConcert.Utils.inherit( adm_process_flow_messages_type_gallery, inConcert.adm_process_flow_messages_type.base.gallery );
	
	adm_process_flow_messages_type_gallery.prototype.__webviewChange = function($form, value) {
		if (value === undefined) {
			var data = {};
			this.parent.activity.__addValue(data, this.webviewDefinition, $form);
			value = data[this.webviewDefinition.id];
		}
		$form.find("[webview_control]").toggleClass("forcedHidden", !value);
	};
	
	adm_process_flow_messages_type_gallery.prototype.__makeFixedOptionLinkOptions = function(option) { /* #12989 */

        let self = this;
		let $options = adm_process_flow_messages_type_gallery.uber.__makeFixedOptionLinkOptions.call(this, option);
		let activity = this.parent.activity;

        this.webviewDefinition.fieldClass = "col_3"; 
        this.webviewSizeDefinition.fieldClass = "col_6"; 
        this.webviewShareDefinition.fieldClass = "col_3"; 

		$options.push(activity.__makeDivFlex(activity.__makeCheckboxFlex(this.webviewDefinition, option[this.webviewDefinition.id]),{ class: "form-group d-flex align-items-center" }));
        
		let $webviewOptions = [];
		$webviewOptions.push(activity.__makeDivFlex(activity.__makeComboFlex(this.webviewSizeDefinition, option[this.webviewSizeDefinition.id]),{ class: "form-group flex-grow-1 comboControl" }));
		$webviewOptions.push(activity.__makeDivFlex(activity.__makeCheckbox(this.webviewShareDefinition, option[this.webviewShareDefinition.id]),{ class: "form-group d-flex align-items-center" }));
        
		$.each($webviewOptions, function(_, $option) {
			$option
				.attr("webview_control", true)
				.toggleClass("forcedHidden", !option[self.webviewDefinition.id]);
			$options.push($option);
		});
		return $options;
	};
	
	adm_process_flow_messages_type_gallery.prototype.__addFixedOptionLinkData = function(data, $option) {
		adm_process_flow_messages_type_gallery.uber.__addFixedOptionLinkData.call(this, data, $option);
		var activity = this.parent.activity;
		activity.__addValue(data, this.webviewDefinition, $option);
		if (data[this.webviewDefinition.id]) {
			activity.__addValue(data, this.webviewSizeDefinition, $option);
			activity.__addValue(data, this.webviewShareDefinition, $option);
		}
	};
	
	function adm_process_flow_messages_type_list(parent) {
		adm_process_flow_messages_type_list.uber.constructor.call(this, parent);
		
		var self = this;
		
		//web url
		this.webviewDefinition = {
			id : "webview",
			name : "<%=_T('Webview')%>",
			description : "<%=_T('Show url in a webview (domain must be in whitelist).')%>",
			inverse_order : true,
			change : function() {
				self.__webviewChange($(this).closest("[list_item_form]"));
			},
            not_extended: true,
			form_group: false,
			envolving_label_class: "form-check-label form-check-label-title",
			envolving_label: true,
			without_label: true,
			controlContainerClass: "form-check",
			checkBoxClass: "form-check-input"
		};
		this.webviewSizeDefinition = {
			id : "webviewSize",
			name : "<%=_T('Webview size')%>",
			placeholder : "<%=_T('Webview size')%>",
			description : "<%=_T('Webview size.')%>",
			options : [
				{ id : "compact", name : "<%=_T('Compact')%>" },
				{ id : "tall", name : "<%=_T('Tall')%>" },
				{ id : "full", name : "<%=_T('Full')%>" }
			],
			required : true,
			without_label : true
		};
		this.webviewShareDefinition = {
			id : "webviewShareButton",
			name : "<%=_T('Share Button')%>",
			description : "<%=_T('Indicates if webview share content button is shown.')%>",
			inverse_order : true,
            not_extended: true,
			form_group: false,
			envolving_label_class: "form-check-label form-check-label-title",
			envolving_label: true,
			without_label: true,
			controlContainerClass: "form-check",
			checkBoxClass: "form-check-input"
		};
	}

	inConcert.Utils.inherit( adm_process_flow_messages_type_list, inConcert.adm_process_flow_messages_type.base.list );
	
	adm_process_flow_messages_type_list.prototype.__webviewChange = function($form, value) {
		if (value === undefined) {
			var data = {};
			this.parent.activity.__addValue(data, this.webviewDefinition, $form);
			value = data[this.webviewDefinition.id];
		}
		$form.find("[webview_control]").toggleClass("forcedHidden", !value);
	};
	
	adm_process_flow_messages_type_list.prototype.__makeFixedOptionLinkOptions = function(option) {
		var self = this;
		var $options = adm_process_flow_messages_type_list.uber.__makeFixedOptionLinkOptions.call(this, option);
		var activity = this.parent.activity;
		
        $options.push(activity.__makeDivFlex(activity.__makeCheckboxFlex(this.webviewDefinition, option[this.webviewDefinition.id]),{ class: "form-group d-flex align-items-center" }));
        
        var $webviewOptions = [];
		$webviewOptions.push(activity.__makeDivFlex(activity.__makeComboFlex(this.webviewSizeDefinition, option[this.webviewSizeDefinition.id]),{ class: "form-group flex-grow-1 comboControl" }));
		$webviewOptions.push(activity.__makeDivFlex(activity.__makeCheckbox(this.webviewShareDefinition, option[this.webviewShareDefinition.id]),{ class: "form-group d-flex align-items-center" }));
       
        $.each($webviewOptions, function(_, $option) {
			$option
				.attr("webview_control", true)
				.toggleClass("forcedHidden", !option[self.webviewDefinition.id]);
			$options.push($option);
		});
		return $options;
	};
	
	adm_process_flow_messages_type_list.prototype.__addFixedOptionLinkData = function(data, $option) {
		adm_process_flow_messages_type_list.uber.__addFixedOptionLinkData.call(this, data, $option);
		var activity = this.parent.activity;
		activity.__addValue(data, this.webviewDefinition, $option);
		if (data[this.webviewDefinition.id]) {
			activity.__addValue(data, this.webviewSizeDefinition, $option);
			activity.__addValue(data, this.webviewShareDefinition, $option);
		}
	};
	
	if (!inConcert.adm_process_flow_messages_type.instagram_bot) {
		inConcert.adm_process_flow_messages_type.instagram_bot = {
			text : inConcert.adm_process_flow_messages_type.base.text,
			attachment : inConcert.adm_process_flow_messages_type.base.attachment,
			gallery : adm_process_flow_messages_type_gallery,
			list : adm_process_flow_messages_type_list
		};
	}
	
	if (!inConcert.adm_process_flow_messages_type.instagram_bot_sorted) {
		inConcert.adm_process_flow_messages_type.instagram_bot_sorted = [
			"text",
			"attachment",
			"gallery"
		];
	}
	
//button types
	
	function adm_process_flow_messages_button(parent, data, $list, $parent, onDeleted) {
		adm_process_flow_messages_button.uber.constructor.call(this, parent, data, $list, $parent, onDeleted);
		
		var self = this;
		
		//web url
		this.webviewDefinition = {
			id : "webview",
			name : "<%=_T('Webview')%>",
			description : "<%=_T('Indicates if url is open in a embedded webview.')%>",
			change : function() {
				self.__webviewChange();
			},
            inverse_order : true,
			not_extended: true,
			form_group: false,
			envolving_label_class: "form-check-label form-check-label-title",
			envolving_label: true,
			without_label: true,
			controlContainerClass: "form-check",
			checkBoxClass: "form-check-input"
		};
		this.webviewSizeDefinition = {
			id : "webviewSize",
			name : "<%=_T('Webview size')%>",
			description : "<%=_T('Webview size.')%>",
			options : [
				{ id : "compact", name : "<%=_T('Compact')%>" },
				{ id : "tall", name : "<%=_T('Tall')%>" },
				{ id : "full", name : "<%=_T('Full')%>" }
			],
			required : true
		};
		this.webviewShareDefinition = {
			id : "webviewShareButton",
			name : "<%=_T('Share Button')%>",
			description : "<%=_T('Indicates if webview share content button is shown.')%>",
            inverse_order : true,
			not_extended: true,
			form_group: false,
			envolving_label_class: "form-check-label form-check-label-title",
			envolving_label: true,
			without_label: true,
			controlContainerClass: "form-check",
			checkBoxClass: "form-check-input"
		};
		
	}

	inConcert.Utils.inherit( adm_process_flow_messages_button, inConcert.adm_process_flow_messages_button.base.base );
	
	adm_process_flow_messages_button.prototype.__webviewChange = function(value) {
		if (value === undefined) {
			var data = {};
			this.parent.activity.__addValue(data, this.webviewDefinition, this.$button);
			value = data[this.webviewDefinition.id];
		}
		value = !!value;
		$.each(this.$webviewControls, function(_, $control) {
			$control.toggle(value);
		});
	};
	
	adm_process_flow_messages_button.prototype.__web_urlMakeEditControls = function() {
		var $controls = adm_process_flow_messages_button.uber.__web_urlMakeEditControls.call(this);

		//En la API de envío de mensajes de instagram no está contemplado el poder elegir cómo se ve una url referenciada en un botón. Siempre se ve en modo full. Ocultamos el checkbox webview y controles asociados
		/*
		var activity = this.parent.activity;
		$controls.push(activity.__makeRow(activity.__makeCheckbox(this.webviewDefinition, this.data[this.webviewDefinition.id])));
		
		this.$webviewControls = [];
		this.$webviewControls.push(activity.__makeRow(activity.__makeCombo(this.webviewSizeDefinition, this.data[this.webviewSizeDefinition.id])));
		this.$webviewControls.push(activity.__makeRow(activity.__makeCheckbox(this.webviewShareDefinition, this.data[this.webviewShareDefinition.id])));
		$.each(this.$webviewControls, function(_, $control) {
			$controls.push($control);
		});
		this.__webviewChange(this.data[this.webviewDefinition.id]);
		*/
		return $controls;
	};
	
	adm_process_flow_messages_button.prototype.__web_urlAddData = function(data) {
		adm_process_flow_messages_button.uber.__web_urlAddData.call(this, data);
		var activity = this.parent.activity;
		activity.__addValue(data, this.webviewDefinition, this.$button);
		if (data[this.webviewDefinition.id]) {
			activity.__addValue(data, this.webviewSizeDefinition, this.$button);
			activity.__addValue(data, this.webviewShareDefinition, this.$button);
		}
	};
	
	if (!inConcert.adm_process_flow_messages_button.instagram_bot) {
		inConcert.adm_process_flow_messages_button.instagram_bot = {
			list : adm_process_flow_messages_button,
			gallery : adm_process_flow_messages_button
		};
	}
	
//quick replies
	
	if (!inConcert.adm_process_flow_messages_quickreply.instagram_bot) {
		inConcert.adm_process_flow_messages_quickreply.instagram_bot = inConcert.adm_process_flow_messages_quickreply.base;
	}
	
//clase

	function adm_process_flow_messages(activity) {
		adm_process_flow_messages.uber.constructor.call(this, activity);
	}

	inConcert.Utils.inherit( adm_process_flow_messages, inConcert.adm_process_flow_messages.base );

	if (typeof inConcert.adm_process_flow_messages.instagram_bot !== "function") {
		inConcert.adm_process_flow_messages.instagram_bot = adm_process_flow_messages;
	}

	adm_process_flow_messages.prototype.__hasWriting = function() {
		return false;
	};

}());
