/* jshint forin:true, noarg:true, jquery:true, noempty:true, eqeqeq:true, bitwise:true,
	strict:true, undef:true, unused:vars, curly:true, browser:true, indent:false, maxerr:50, quotmark:double */

/* global inConcert */

if (!this.inConcert) {
	this.inConcert = {};
}

(function () {
	//"use strict";
	
//message types
	
	function adm_process_flow_messages_type_text(parent) {
		adm_process_flow_messages_type_text.uber.constructor.call(this, parent);
	}

	inConcert.Utils.inherit( adm_process_flow_messages_type_text, inConcert.adm_process_flow_messages_type.base.text );
	
	adm_process_flow_messages_type_text.prototype.__hasButtons = function() {
		return false;
	};
	
	if (!inConcert.adm_process_flow_messages_type.whatsapp) {
		inConcert.adm_process_flow_messages_type.whatsapp = {
            text : inConcert.adm_process_flow_messages_type.base.text,
			attachment : inConcert.adm_process_flow_messages_type.base.attachment,
			template : inConcert.adm_process_flow_messages_type.base.template,
			reply_buttons : inConcert.adm_process_flow_messages_type.base.reply_buttons,
			list_messages : inConcert.adm_process_flow_messages_type.base.list_messages
		};
	}
	
	if (!inConcert.adm_process_flow_messages_type.whatsapp_sorted) {
		inConcert.adm_process_flow_messages_type.whatsapp_sorted = [
			"text",
			"attachment",
			"template"
		];
	}
	
//button types
	
	if (!inConcert.adm_process_flow_messages_button.whatsapp) {
		inConcert.adm_process_flow_messages_button.whatsapp = {
			list : inConcert.adm_process_flow_messages_button.base.base,
			gallery : inConcert.adm_process_flow_messages_button.base.base,
			reply_buttons : inConcert.adm_process_flow_messages_button.base.base,
			list_messages : inConcert.adm_process_flow_messages_button.base.base
		};
	}
	
//quick replies
	
	if (!inConcert.adm_process_flow_messages_quickreply.whatsapp) {
		inConcert.adm_process_flow_messages_quickreply.whatsapp = inConcert.adm_process_flow_messages_quickreply.base;
	}
	
//clase

	function adm_process_flow_messages(activity) {
		adm_process_flow_messages.uber.constructor.call(this, activity);

        if (activity.data.type === "ask_for_help") {
            inConcert.adm_process_flow_messages_type.whatsapp_sorted = [
                "text"
            ];
        } else {
            if (activity.quick_reply_name_prefix) {
                let existe = inConcert.adm_process_flow_messages_type.whatsapp_sorted.find(c => c === "reply_buttons");
                if (!existe) {
                    inConcert.adm_process_flow_messages_type.whatsapp_sorted.push("reply_buttons");
                    inConcert.adm_process_flow_messages_type.whatsapp_sorted.push("list_messages");
                }
            } else {
                let reply_buttons_index = inConcert.adm_process_flow_messages_type.whatsapp_sorted.indexOf("reply_buttons");
                if (reply_buttons_index > 0) {
                    inConcert.adm_process_flow_messages_type.whatsapp_sorted.splice(reply_buttons_index, 1);
                }            
                let list_messages_index = inConcert.adm_process_flow_messages_type.whatsapp_sorted.indexOf("list_messages");
                if (reply_buttons_index > 0) {
                    inConcert.adm_process_flow_messages_type.whatsapp_sorted.splice(list_messages_index, 1);
                }
            }
        }
	}

	inConcert.Utils.inherit( adm_process_flow_messages, inConcert.adm_process_flow_messages.base );

	if (typeof inConcert.adm_process_flow_messages.whatsapp !== "function") {
		inConcert.adm_process_flow_messages.whatsapp = adm_process_flow_messages;
	}

	adm_process_flow_messages.prototype.__maxQuickreplies = function() {
		return 0;
	};

	adm_process_flow_messages.prototype.__hasWriting = function() {
		return false;
	};

}());
