/* jshint forin:true, noarg:true, jquery:true, noempty:true, eqeqeq:true, bitwise:true,
	strict:true, undef:true, unused:vars, curly:true, browser:true, indent:false, maxerr:50, quotmark:double, esversion: 9 */

/* global inConcert */

if (!this.inConcert) {
	this.inConcert = {};
}

if (!this.inConcert.adm_process_flow_migrations) {
	this.inConcert.adm_process_flow_migrations = {};
}

(function () {
	//"use strict";

	const format = inConcert.Utils.format;

	function adm_process_flow_migration(main, data, overlay) {
		adm_process_flow_migration.uber.constructor.call(this);
		this.main = main;
		this.data = data;
        this.overlay = overlay;
	}

	inConcert.Utils.inherit( adm_process_flow_migration, inConcert.adm_process_flow_popup );

	if (typeof inConcert.adm_process_flow_migrations.base !== "function") {
		inConcert.adm_process_flow_migrations.base = adm_process_flow_migration;
	}

	adm_process_flow_migration.prototype.id = "";

	adm_process_flow_migration.prototype.__getClassName = function() {
		return format("flowDesignerMigration{0}Popup", this.id);
	};

	adm_process_flow_migration.prototype.__getTitle = function() {
		return format("<%=_T('Flow migration: {0}')%>", this.__getName());
	};

	adm_process_flow_migration.prototype.__getName = function() {
		return "";
	};

	adm_process_flow_migration.prototype.Process = function(callback) {
		const self = this;
		this.__checkTask(function(showPopup, err) {
			if (showPopup) {
				self.callback = callback;
				return self.Show();
			}
			if (!err) {
				callback(true);
			}
			else {
				callback(false, err);
			}
		});
	};

	adm_process_flow_migration.prototype.__cancel = function(callback) {
		callback();
		this.callback(false, format("<%=_T('Migration task {0} aborted.')%>", this.__getName()));
	};

	adm_process_flow_migration.prototype.__save = function(data, callback) {
		this.migrationData = data;
		callback(true);
	};

	adm_process_flow_migration.prototype.__afterSave = function() {
		this.callback(true, this.migrationData);
	};

	adm_process_flow_migration.prototype.__processFile = function(_, callback) {
		return callback(true);
	};

	adm_process_flow_migration.prototype.__processRepositoryFile = function(file, callback) {
		const repositoryApi = inConcert.app.getRepositoryAPI();
		repositoryApi.exists(file, function(exists) {
			if (exists) {
				return callback(true);
			}
			let params = {
				id : file.id,
				section : file.section,
				part : file.part,
				type : file.metadata.ContentType,
				format : file.metadata.Format,
				name : file.metadata.FileName
			};
			repositoryApi.addBase64(params, file.content, function(status) {
				if (status) {
					callback(true);
				}
				else {
					callback(false, format("<%=_T('Error uploading repository file: {0}')%>", params.name));
				}
			});
		});
	};

}());
