/* jshint forin:true, noarg:true, jquery:true, noempty:true, eqeqeq:true, bitwise:true,
	strict:true, undef:true, unused:vars, curly:true, browser:true, indent:false, maxerr:50, quotmark:double, esversion: 9 */

/* global inConcert */

if (!this.inConcert) {
	this.inConcert = {};
}

if (!this.inConcert.adm_process_flow_migrations) {
	this.inConcert.adm_process_flow_migrations = {};
}

(function () {
	//"use strict";

	const id = "cognitiveServicesApp";

	function adm_process_flow_migration(main, data, overlay) {
		adm_process_flow_migration.uber.constructor.call(this, main, data, overlay);
		this.overlay = overlay;
	}

	inConcert.Utils.inherit( adm_process_flow_migration, inConcert.adm_process_flow_migrations.base );

	if (typeof inConcert.adm_process_flow_migrations[id] !== "function") {
		inConcert.adm_process_flow_migrations[id] = adm_process_flow_migration;
	}

	adm_process_flow_migration.prototype.id = id;

	adm_process_flow_migration.prototype.__getName = function() {
		return "<%=_T('Cognitive Services App')%>";
	};

	adm_process_flow_migration.prototype.__checkTask = function(callback) {
		const self = this;
		this.main.LoadBotApps(function(services) {
			let services_byId = {};
			let services_byName = {};
			$.each(services, function(_, service) {
				services_byId[service.Id] = service;
				services_byName[service.Name] = service;
			});
			self.servicesToMigrate = [];
			$.each(self.data, function(serviceId, serviceName) {
				if (!services_byId[serviceId]) {
					let definition = {
						id : serviceId,
						name : serviceName,
						description : "<%=_T('Cognitive services app to be migrated.')%>",
						sort : true,
						required : true,
						options : services,
						defaultValue : services_byName[serviceName]? services_byName[serviceName].Id : null
					};
					self.servicesToMigrate.push(definition);
				}
			});
			callback(self.servicesToMigrate.length > 0);
		});
	};

	adm_process_flow_migration.prototype.__makeContent = function() {
		var self = this;
		var $content = [];
		$.each(self.servicesToMigrate, function(_, definition) {
			$content.push(self.__makeRow(self.__makeCombo(definition)));
		});
		return $content;
	};

	adm_process_flow_migration.prototype.__getAndValidate = function() {
		var self = this;
		var data = {};
		$.each(self.servicesToMigrate, function(_, definition) {
			self.__addValue(data, definition);
		});
		return data;
	};

}());
