/* jshint forin:true, noarg:true, jquery:true, noempty:true, eqeqeq:true, bitwise:true,
	strict:true, undef:true, unused:vars, curly:true, browser:true, indent:false, maxerr:50, quotmark:double */

/* global inConcert */

if (!this.inConcert) {
	this.inConcert = {};
}

(function () {
	//"use strict";
	
	var format = inConcert.Utils.format;

	function adm_process_flow_datasources_migration(main, data, callback, overlay) {
		adm_process_flow_datasources_migration.uber.constructor.call(this);
		this.main = main;
		this.callback = callback;
		this.focusFirst = true;
		this.overlay = overlay;
		this.editor = new inConcert.adm_process_flow_datasource_editor(null, data);
	}

	inConcert.Utils.inherit( adm_process_flow_datasources_migration, inConcert.adm_process_flow_popup );

	if (typeof inConcert.adm_process_flow_datasources_migration !== "function") {
		inConcert.adm_process_flow_datasources_migration = adm_process_flow_datasources_migration;
	}

	adm_process_flow_datasources_migration.prototype.__getClassName = function() {
		return "flowDesignerDatasourcesMigrationPopup";
	};

	adm_process_flow_datasources_migration.prototype.__getTitle = function() {
		return format("<%=_T('Import datasource {0}')%>", this.editor.data.Name);
	};

	adm_process_flow_datasources_migration.prototype.__makeContent = function() {
		var $content = [];
		this.editor.MakePropertiesContent($content);
		return $content;
	};
	
	adm_process_flow_datasources_migration.prototype.__afterAppendBody = function() {
		this.editor.SelectType();
	};

	adm_process_flow_datasources_migration.prototype.__getAndValidate = function() {
		var data = {
			Id : this.editor.data.Id,
			Name : this.editor.data.Name,
			Description : this.editor.data.Description
		};
		this.editor.GetProperties(data);
		return data;
	};

	adm_process_flow_datasources_migration.prototype.__save = function(data, callback) {
		callback(true);
		this.callback(true, data);
	};

	adm_process_flow_datasources_migration.prototype.__cancel = function(callback) {
		callback();
		this.callback(false);
	};

}());
