/* jshint forin:true, noarg:true, jquery:true, noempty:true, eqeqeq:true, bitwise:true,
	strict:true, undef:true, unused:vars, curly:true, browser:true, indent:false, maxerr:50, quotmark:double, esversion: 9 */

/* global inConcert */

if (!this.inConcert) {
	this.inConcert = {};
}

if (!this.inConcert.adm_process_flow_migrations) {
	this.inConcert.adm_process_flow_migrations = {};
}

(function () {
	//"use strict";

	let id = "repositoryFiles";

	function adm_process_flow_migration(main, data, overlay) {
		adm_process_flow_migration.uber.constructor.call(this, main, data, overlay);
        this.overlay = overlay;
	}

	inConcert.Utils.inherit( adm_process_flow_migration, inConcert.adm_process_flow_migrations.base );

	if (typeof inConcert.adm_process_flow_migrations[id] !== "function") {
		inConcert.adm_process_flow_migrations[id] = adm_process_flow_migration;
	}

	adm_process_flow_migration.prototype.id = id;

	adm_process_flow_migration.prototype.__getName = function() {
		return "<%=_T('Repository Files')%>";
	};

	adm_process_flow_migration.prototype.__checkTask = function(callback) {
		const self = this;
		inConcert.Utils.asyncIterate(self.data,
			function(file, onStepEnd) {
				self.__processFile(file, function(status, err) {
					if (status) {
						onStepEnd();
					}
					else {
						callback(false, err);
					}
				});
			},
			function() {
				callback();
			}
		);
	};

	adm_process_flow_migration.prototype.__processFile = function(file, callback) {
		this.__processRepositoryFile(file, callback);
	};
}());
