local json = require "cjson"
local utils = require "shared.apps.utils"
--local moses = require "moses"
--local interactionmanip = require "interactionmanip"
--local utf8 = require "icu.utf8"

module(..., package.seeall)

--json.encode_empty_table_as_array("on")

local m_datasource

function GetName ()
	return "Interactions"
end

function GetDefinition (datasource)
	m_datasource = datasource
	return _M
end

--retrieves a full interaction JSON from redis
function GetInteraction (id, datasource)
	assert(type(id) == "string")
	--LogDebug("[INTEGRATIONS.interactions:GetInteraction] Load ACTIVE id '%s'.", id)
	local redis = (datasource or m_datasource).redis
	if not redis then
		LogError("[INTEGRATIONS.interactions:GetInteraction] Unable to retrieve Interaction '%s'. REDIS uninitialized.", id)
		return false
	end
	local encodedInteraction = redis:get("InteractionDetail:"..id)
	if not encodedInteraction or encodedInteraction == "" then
		LogError("[INTEGRATIONS.interactions:GetInteraction] Interaction '%s' does not exist.", id)
		return false
	end
	local res, decodedInteraction = pcall(json.decode, encodedInteraction)
	if res and decodedInteraction then
		-- OK
		--LogDebug("[INTEGRATIONS.interactions:GetInteraction] Loaded Interaction '%s' data: '%s'", id, encodedInteraction)
		return decodedInteraction
	end
	-- Error
	LogError("[INTEGRATIONS.interactions:GetInteraction] Error loading Interaction '%s' detail is undecodable: '%s'", id, encodedInteraction)
	return false
end

