module(..., package.seeall)

local utils = require "shared.apps.utils"
local m_datasource
local m_modelName = "Users"

function GetName ()
	return m_modelName
end

function GetDefinition (datasource)
	m_datasource = datasource
	return _M
end

function GetDataSource ()
	if not m_datasource then
		local model = require "apps.integrations.model"
		model.BuildModels(true)
	end
	return m_datasource
end

function Get (vcc, simpleId, keyspace, columns)
	simpleId = simpleId:lower()
	local user       = utils.GetAllColumns({
		keyspace     = keyspace or "Agent",
		columnFamily = m_modelName,
		key          = utils.AppendVcc(simpleId, vcc),
		columns      = columns
	}) or {}
	return user
end
