/*jshint bitwise:true, browser:true, curly:true, eqeqeq:true, noarg:true, noempty:true, strict:true, undef:true, unused:true, esversion: 11 */
/*jshint quotmark:false */
/*global inConcert, inConcertApi, $*/

window.occIntegrations = window.occIntegrations || {};

(function () {
	"use strict";
	const FORMAT = inConcert.Utils.format;

	function IntegrationsMaster () {
		this.m_icApi = null;
		this.m_serverAddress = inConcert.Utils.MakeFnServiceAddressBuilder()("");
		this.m_integrationsUrl = FORMAT("https://{0}/inconcert/apps/integrations", this.m_serverAddress); // "https://testubu.i6.inconcertcc.com/inconcert/apps/integrations"
		this.initialize();
	}

	IntegrationsMaster.prototype.initialize = function() {
		this.api_agent_create_instance();
	};

	IntegrationsMaster.prototype.get_server_address = function() {
		return this.m_serverAddress;
	};

	IntegrationsMaster.prototype.get_integrations_url = function() {
		return this.m_integrationsUrl;
	};

	IntegrationsMaster.prototype.api_agent_create_instance = function() {
		this.m_icApi = new inConcertAgentApi(this.m_serverAddress);
	};

	IntegrationsMaster.prototype.api_agent_get_instance = function() {
		return this.m_icApi;
	};

	//-------------------------
	$(document).ready(function() {
		window.occIntegrations.master = new IntegrationsMaster();
	});
}());
