#!/bin/bash

#
# Note: This script is idempotent
#

# maintainer       "Ellio de Mello"
# description      "Crea el Model datos para el Widget en el keyspace Integrations"
# repo             "agent"
# dependencies     "cassandra"
# idempotent       "Yes"

. /etc/inconcert/inconcert.conf
. /etc/inconcert/network.conf
 

# 1 -------------------------------------------------
# -

launchCassandra_CreateColumnsFamilies() {
	cassandra-cli -h $CASSANDRA_IP -p $CASSANDRA_PORT << CASSANDRA_EOF

create keyspace Integrations;

use Integrations;

create column family SampleUser with comparator=UTF8Type;
create column family SampleOther with comparator=UTF8Type;

quit;

CASSANDRA_EOF
}

echo "Starting migration..."

launchCassandra_CreateColumnsFamilies| while read line; do
	echo " (lua stdout) $line";
done
