local apiRasa = require("shared.rasa.rasa").GetAPI() -- api rocka

module(..., package.seeall, inconcert.orbit.application.Decorate)

--LogDebug("[JOB.NODES] LOADING MODULE ..........................")

local function RasaListener (web)
--	LogDebug("[JOB.NODES:RasaListener] + (START))")

	local redis = inconcert.environment.apps.jobs.redis

	--LogDebug("[JOB.NODES:RasaListener] 1 - redis: %s", json.encode(redis))
	apiRasa.SetRedis(redis)

	-- la Config del Webhandler Actual que esta utilizando la Rocka
	local webhandlerConfig = inconcert.environment.apps.agent.config_server
	--LogDebug("[JOB.NODES:RasaListener] 2 - webhandlerConfig: %s", json.encode(webhandlerConfig or {}))
	apiRasa.SetServerConfig({
		webhandler = {
			IP   = webhandlerConfig.myIp or webhandlerConfig.ip,    -- "192.168.4.12",
			port = webhandlerConfig.myPort or webhandlerConfig.port --"8082"
		}
	})

	local ir = require "lua_iragentlink"
	require "json"
	local irLink = ir.IRAgentLink(inconcert.environment.apps.agent.cluster)
	local nodes = irLink:GetIRNodes()
	-- table.insert(nodes.nodes, {
	-- 	port = "48000",
	-- 	IP = "192.168.4.12" -- este es el test la supuesta ip del node actual que esta laburando.
	-- })
	--LogInfo("[JOB.NODES:RasaListener] 3 - irLink:GetIRNodes() '%s'", json.encode(nodes))
	apiRasa.SetNodes(nodes)

	-- local success, publications = apiRasa:LoadPublications()
	-- if success then
	-- 	--LogInfo("[JOB.NODES:RasaListener] 4 - publications '%s'", json.encode(publications or {}))
	-- end

	apiRasa:ListenerPublications()

	--LogDebug("[JOB.NODES:RasaListener] - (END)")
end

function MapUris (module, prefix)
	module:dispatch_post(RasaListener, prefix .. "/nodes/rasa/listener/(.*)")
	module:dispatch_get (RasaListener, prefix .. "/nodes/rasa/listener/(.*)")
end
