local smtp = require "socket.smtp"

local SmtpSettings

do
	local ok
	ok, SmtpSettings = pcall(function()
						return inconcert.environment.apps.logstorage.smtp
					end)
	if not ok then
		-- default settings
		SmtpSettings =
		{
			destination = "logStorage@inconcertcc.com",
			subjectLine = "An error occurred in application 'Agent'",
			server = "mail.inconcertcc.com",
		}
	end
end

module(..., package.seeall)

---
-- This function is the one that actually sends the email
-- @additional
function send_mail(params, additional)
	additional = additional or {}
	assert(params.body)
	assert(params.first_name)
	assert(params.email_address)
	
	local mesgt = {
		headers = {
			To = additional.destination or SmtpSettings.destination,
			Subject = additional.subjectline or SmtpSettings.subjectLine,
			From = string.format("%s <%s>", params.first_name, params.email_address), --from = "<john.doe@example.com>"
			["Content-Type"] = "text/plain; charset=UTF-8"
		},
		body = params.body
	}
	if params.last_name then
		mesgt.headers.From = string.format("%s %s <%s>", params.first_name, params.last_name, params.email_address) --from = "<john.doe@example.com>"
	else
		mesgt.headers.From = string.format("%s <%s>", params.first_name, params.email_address) --from = "<john.doe@example.com>"
	end
	
	local response, err = smtp.send{
		from = params.email_address,
		rcpt = string.format("<%s>", additional.destination or SmtpSettings.destination), --"<contact@inconcertcc.com>",	--rcpt = "<john.doe@example.com>",
		source = smtp.message(mesgt),
		user = SmtpSettings.username,
		pass = SmtpSettings.password,
		server = SmtpSettings.server,	--"mail.inconcertcc.com",
		domain = SmtpSettings.domain
	}
	if response ~= 1 then
		error(err)
	end
end
