module(..., package.seeall)
local utils = require "shared.apps.utils"
local m_datasource

local function MakeBatchId (processId, batchName)
	local m_outboundEngineClient = require "apps.outbound_engine.outboundengineclient"
	return m_outboundEngineClient.batches:MakeBatchId(processId, batchName)
end

function GetName ()
	return "OutboundProcessBatches"
end

function GetDefinition (datasource)
	m_datasource = datasource
	return _M
end

function GetBatch (vcc, processId, batchName, ksOE)
	assert(processId)
	assert(batchName)
	processId = utils.AppendVcc(utils.GetId(processId), vcc)
	local batchId = MakeBatchId(processId, batchName)
	local batchInfo = utils.GetAllColumns {
		keyspace = ksOE or "OutboundEngine",
		columnFamily = "OutboundProcessBatches",
		superColumns = true,
		key = processId,
		columns = {batchId}
	} or {}
	--LogDebug("[OUTBOUND_ENGINE.model.batches:GetBatch] 1 ----> vcc: '%s' processId: '%s', batchName: '%s', batchId: '%s', batchInfo: '%s'", vcc, processId, batchName, batchId, json.encode(batchInfo))
	local batch = {}
	if batchInfo[batchId] then
		batch = batchInfo[batchId]
		batch.id = batchId
	end
	--LogDebug("[OUTBOUND_ENGINE.model.batches:GetBatch] 2 ----> batchId: '%s', batch: '%s'", batchId, json.encode(batch))
	return batch
end

function LoadBatches (vcc, processId, ksOE)
	processId = utils.AppendVcc(utils.GetId(processId), vcc)
	local batches = utils.GetAllColumns {
		keyspace = ksOE or "OutboundEngine",
		columnFamily = "OutboundProcessBatches",
		superColumns = true,
		key = processId,
		columns = {}
	}
	return batches or {}
end

--[[

]]--
function SaveBatch (vcc, processId, batch, ksOE)
	assert(processId)
	assert(batch)
	--LogDebug("[OUTBOUND_ENGINE.processes:SaveBatch] -----------> oe.models.SaveBatch - processId: '%s', batch: %s", processId, json.encode(batch))
	local batchName = batch.configuration.name or batch.configuration.batchName
	assert(batchName)
	local fullProcessId = utils.AppendVcc(utils.GetId(processId), vcc)
	local batchId = MakeBatchId(fullProcessId, batchName)
	utils.SaveRows {
		keyspace = ksOE or "OutboundEngine",
		columnFamily = "OutboundProcessBatches",
		superColumns = true,
		rows = {
			[fullProcessId] = {
				[batchId] = batch
			}
		}
	}
	return true, {}
end