/* jshint forin:true, noarg:true, jquery:true, noempty:true, eqeqeq:true, bitwise:true,
	strict:true, undef:true, unused:vars, curly:true, browser:true, indent:false, maxerr:50, quotmark:double, esversion: 9 */

/* global inConcert */

if (!this.inConcert) {
	this.inConcert = {};
}

(function () {
	//"use strict";

	//---------------------------------------------------------------------
	// form exports layout class
	function form_outbound_engine_export_layout(params)
	{
		const success = form_outbound_engine_export_layout.uber.constructor.call(this, params);
		if (!success) {
			return;
		}

		this.new_title      = "<%=_T('New Layout')%>";
		this.update_title   = "<%=_T('Update Layout {0}')%>";
		this.view_title     = "<%=_T('View Export Layout {0}')%>";
		this.tagline        = "<%=_T('Tagline form Export Layout!!!')%>";

		this.html_file_name = "/inconcert/apps/outbound_engine/exports/layout/frm/render/";
		this.save_uri       = "/inconcert/apps/outbound_engine/exports/layout/save/";
		this.get_uri =        "/inconcert/apps/outbound_engine/exports/layout/get/";

		this.m_layout_mng = new inConcert.OutboundEngineExportLayout({
			owner: this,
			ids: {
				fields_container: "out_form_exp_layout_fields_container"
			}
		})

		return true;
	}

	inConcert.Utils.inherit(form_outbound_engine_export_layout, inConcert.conf_form);

	if (typeof inConcert.form_outbound_engine_export_layout !== "function") {
		inConcert.form_outbound_engine_export_layout = form_outbound_engine_export_layout;
	}

	form_outbound_engine_export_layout.prototype.initialize = function()
	{
		this.m_layout_mng.initialize();
	};

	form_outbound_engine_export_layout.prototype.get = function()
	{
		return this.m_layout_mng.get();
	};

	form_outbound_engine_export_layout.prototype.set = function(success, layout)
	{
		if (!success) {
			return;
		}
		this.m_layout_mng.set(layout);
	};

	form_outbound_engine_export_layout.prototype.empty_controls = function()
	{
		this.m_layout_mng.empty_controls();
	};

	form_outbound_engine_export_layout.prototype.err_save_messages = function(err)
	{
		form_outbound_engine_export_layout.uber.err_save_messages.call( this, err, false /* custom message*/ );  //invokes the base class method
	};

	form_outbound_engine_export_layout.prototype.get_validation_def = function()
	{
		return this.m_layout_mng.get_validation_def();
	};

	form_outbound_engine_export_layout.prototype.save_execute = function(after_save, layout)
	{
		const self = this;
		var callback = function(success, response) {
			self.on_saved(success, layout, after_save, response);
		};
		this.m_layout_mng.save(layout, callback);
	};

	form_outbound_engine_export_layout.prototype.err_save_messages = function(err)
	{
		let is_custom_message = false;
		if (typeof err === "object") {
			is_custom_message = true;
			let error_type = err.err ? err.err.result : "UNRECOGNIZED_ERR";
			switch(error_type) {
				case "ALREADY_EXIST":
					err = "<%=_T('Exportation Layout is already in use.')%>";
					const $exp_id = $("#txtId");
					this.show_validation_error($exp_id);
					break;

				default:
					err = "<%=_T('Error Saving Export Layout.')%>";
			}
		}
		form_outbound_engine_export_layout.uber.err_save_messages.call(this, err, is_custom_message); //invokes the base class method
	};

	form_outbound_engine_export_layout.prototype.ready = function()
	{
		form_outbound_engine_export_layout.uber.ready.call( this ); //invokes the base class method
		this.m_layout_mng.editable();
	};

	form_outbound_engine_export_layout.prototype.readonly = function()
	{
		form_outbound_engine_export_layout.uber.readonly.call(this); //invokes the base class method
		this.m_layout_mng.readonly();
	};

	form_outbound_engine_export_layout.prototype.set_events = function()
	{
		form_outbound_engine_export_layout.uber.set_events.call( this ); //invokes the base class method
		this.m_layout_mng.set_events();
	};

	form_outbound_engine_export_layout.prototype.load_data = function(callback_complete_requests)
	{
		this.requests = [];
		let format_requests = this.m_layout_mng.make_requests_list();
		this.requests = this.requests.concat(format_requests);
		form_outbound_engine_export_layout.uber.load_data.call(this, callback_complete_requests); //invokes the base class method
	};
}());
