/* jshint forin:true, noarg:true, jquery:true, noempty:true, eqeqeq:true, bitwise:true,
strict:true, undef:true, unused:vars, curly:false, browser:true, indent:false, maxerr:50, quotmark:double, esversion: 11 */

/* global inConcert, sqlParser */

if (!this.inConcert) {
	this.inConcert = {};
}

(function () {
	//"use strict";

	const FORMAT = inConcert.Utils.format;

	const m_dateFormats = {
		date    : {format: "YYYY-MM-DD"         },
		datetime: {format: "YYYY-MM-DD HH:mm:ss"}
	};

	//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	/**
	Class Summary Contacts Popup Detail.
	*/
	function SummaryPopupContactsDetail (params)
	{
		SummaryPopupContactsDetail.uber.constructor.call(this);
		this.clickEventName = this.clickEventName + "_batch_filter";
		this.ownerId = "out_batch_summary_popup_container";
		this.waitingId = this.ownerId + "_waitign_id";
		this.messageId = this.ownerId + "_message_id";
		this.closeMessageId = this.ownerId + "_close_message_id";
		this.batchId = this.ownerId + "_batch_id";
		this.statusContainerId = this.ownerId + "_status_container_id";
		this.gridContainerId = this.ownerId + "_status_list_container";
		this.gridContainerNotFoundId = this.ownerId + "_status_not_found";
		this.gridContainerDataId = this.ownerId + "_status_data";
		this.gridContainerPaginatorId = this.ownerId + "_status_paginator";
		this.params = params;
		this.query = null;
		this.frm = params.frm;
		this.canReposition = true;
		this.form_paginator_contacts = null;
		this.contact_query_result = null;
	}

	inConcert.Utils.inherit(SummaryPopupContactsDetail, inConcert.PopupWindow);

	/*******************************************************************
	 * Metodo que crea el markup contenedor de la ventana
	 */
	SummaryPopupContactsDetail.prototype.createMarkup = function() {
		$("#" + this.ownerId).remove();
		const $node = $(`
				<div id='${this.ownerId}' class='systemPopWindow windowContactStatusBatches windowContainer' style='display:none'>
					<div id='${this.waitingId}'class='windowWaitingContainer' hidden>
						<div message='true' class='windowWaitingMessage'></div>
						<div class='windowWaitingAnimation'></div>
						<div class='windowWaitingOverlay'></div>
					</div>
					<div class='windowTop'>
						<div class='windowTitle'>${this.get_contact_status_name()}</div>
					</div>
					<div id='${this.messageId}' class='windowContainerMessages messageError' style='display:none' hidden>
						<a id='${this.closeMessageId}' class='windowMessagesClose' href='javascript:void(0);'>"<%=_T('Close')%>"</a>
						<div class='windowMessagesText'>
							<label class='windowMessagesTextAux'></label>
						</div>
					</div>
					<div class='windowMiddle' style='display:none'>
						<div class=''></div>
					</div>
					<div class='windowMiddle'>
						<div id='${this.gridContainerId}' class='card-block'>
							<div class='row'>
								<div class='col-12'>
									<div id='${this.gridContainerNotFoundId}' class='inlineMessagesContainer messageInfo mt-0' style='display:none'></div>
								</div>
							</div>
							<div class='batchesContactsListContainer row'>
								<div class='col-12'>
									<div class='tableContainerBox'>
										<table id='${this.gridContainerDataId}' cellpadding='0' cellspacing='0' border='0' class='viewGrid mt-0'>
											<thead class='viewGridHeader'></thead>
											<tbody class='viewGridBody'></tbody>
										</table>
										<div id='${this.gridContainerPaginatorId}'></div>
									</div>
								</div>
							</div>
						</div>
					</div>
				</div>"
			`.trim()
		);
		$("body").append($node);
		return $node;
	};

	/*******************************************************************
	 *
	 */
	SummaryPopupContactsDetail.prototype.initialize = function()
	{
		this.data.container = this.createMarkup();
	};

	SummaryPopupContactsDetail.prototype.setData = function(data)
	{
		this.query = null;
		if (data && data.query) {
			this.query = $.extend(true, {includedStates: [data.query.status_id]}, data.query.query);
		}
		SummaryPopupContactsDetail.uber.setData.call(this, data);
	};

	SummaryPopupContactsDetail.prototype.show_waiting = function()
	{
		let message = "<%=_T('Loading, wait moment please')%>";
		const $waiting = $("#"  + this.waitingId);
		$waiting.find("[message='true']").text(message);
		$waiting.show();
	};

	/*******************************************************************
	* Metodo que xxx
	*/
	SummaryPopupContactsDetail.prototype.hide_waiting = function()
	{
		$("#" + this.waitingId).hide();
		this.setPosition();
	};

	SummaryPopupContactsDetail.prototype.show_status_message = function(text, type, closeDisabled, timeout_ms)
	{
		const $message = $("#" + this.messageId);
		$message.removeClass().addClass("windowContainerMessages").addClass("message" + type);
		$message.show().find(".windowMessagesTextAux").text(text);
		if (timeout_ms) {
			window.setTimeout(function() {
				$message.hide();
			}, timeout_ms);
		}
		const $messageClose = $("#" + this.closeMessageId);
		if (closeDisabled) {
			$messageClose.hide();
		}
		else {
			$messageClose.show();
		}
	};

	/*******************************************************************
	* funcion que oculta mensaje
	*/
	SummaryPopupContactsDetail.prototype.hide_status_message = function() {
		const $message = $("#" + this.messageId);
		$message.hide();
	};

	SummaryPopupContactsDetail.prototype.get_contact_status_name = function()
	{
		return this.params.status_name;
	};

	SummaryPopupContactsDetail.prototype.reset_values = function()
	{
		this.contact_query_result = null;
	};

	SummaryPopupContactsDetail.prototype.ready = function()
	{
		const self = this;

		this.initialize_ctrls();
		if (this.contact_query_result) {
			// si el popup de este status ya se ha abierto
			this.__on_executed_query_contacts(true);
			return;
		}
		this.show_waiting();
		const outbound_engine_api = inConcert.app.getOutboundEngineAPI();
		let info = {
			query: this.query
		};
		outbound_engine_api.processRunBatchContactsQuery(info,
			function(success, query_result) {
				if (success) {
					// OK
					self.contact_query_result = query_result;
					self.__on_executed_query_contacts(true);
					return;
				}
				// ERROR
				self.contact_query_result = null;
				self.__on_executed_query_contacts(false);
			}
		);
	};

	SummaryPopupContactsDetail.prototype.__on_executed_query_contacts = function(success) {
		const self = this;

		if (!success) {
			// TODO: Error
			this.hide_waiting();
			return;
		}

		let query_result = this.is_ok_contact_query_result();
		if (!query_result.success) {
			this.hide_waiting();
			//this.__show_ctrl_err(query_result);
			// TODO: ERROR
			return;
		}

		let is_initialized = false;
		this.__load_contacts_from_query(function(is_ok, contacts) {
			if (is_ok) {
				self.form_paginator_contacts.initialize(function() {
						if (!is_initialized) {
							window.setTimeout(function() {
								is_initialized = true;
								self.form_paginator_contacts.jump_to_first_page();
								self.hide_waiting();
							}, 200);
						}
					},
					contacts
				);
			}
			else {
				self.hide_waiting();
			}
		});
	};

	SummaryPopupContactsDetail.prototype.close = function(params) {
		if (this.data && this.data.container) {
			this.data.container.remove();
		}
		this.finalize(params);
	};

	SummaryPopupContactsDetail.prototype.is_ok_contact_query_result = function()
	{
		let result = {success: false, codeErr: "ERROR RETRIEVING CONTACTS", message: "<%=_T('There are no contacts.')%>"};
		if (!this.contact_query_result || !this.contact_query_result.contacts) {
			return result;
		}
		const limitRowsInfo = {};
		// is ok
		result.success = true;
		result.message = "IS OK";
		result.limitRowsInfo = limitRowsInfo;
		delete result.codeErr;
		return result;
	};

	SummaryPopupContactsDetail.prototype.__load_contacts_from_query = function(callback = $.noop)
	{
		let contacts = [];
		if (this.contact_query_result) {
			contacts = this.contact_query_result.contacts || contacts;
		}
		callback(true, contacts);
	};

	SummaryPopupContactsDetail.prototype.load_batches_contacts = function(_, callback = $.noop)
	{
		this.__load_contacts_from_query(function(success, contacts) {
			callback(success, contacts);
		});
	};

	/*******************************************************************
	 * Metodo que setea eventos de los controles
	 */
	SummaryPopupContactsDetail.prototype.setEvents = function()
	{
		this.form_paginator_contacts.set_events();
	};

	SummaryPopupContactsDetail.prototype.initialize_ctrls = function()
	{
		const self = this;
		// La cantidad de rows que se deben de visualizar en el paginador.
		// El paginado se realiza client side, ya que server side se obtienen una unica pagina con N "server_side_contacts_rows_per_page" registros.
		let client_side_rows_per_page = 10;

		this.form_paginator_contacts = new inConcert.conf_form_paginator({
			paginator_name: "OUTBOUND_BATCHES_CONTACTS",
			owner: this,
			frm: this.frm,
			row_id: "Name",
			display_name: "Name",
			rows_per_page: client_side_rows_per_page,
			show_at_least: client_side_rows_per_page - 1,
			paginator_type: "ALL_ROWS_CLIENT_SIDE",
			paged_text_format: "row_count",
			//loading_waiting_msg: "<%=_T('Please wait, loading Contacts ...')%>",
			ids: {
				grid             : this.gridContainerDataId,
				paginator        : this.gridContainerPaginatorId,
				not_results_found: this.gridContainerNotFoundId
			},
			strings: {
				not_results_found: "<%=_T('No Contacts found.')%>"
			},
			columns: [
				{id: "_number"   , name: "", type: "counter"    },
				{id: "Id"        , name: "<%=_T('Identifier')%>"},
				{id: "Name"      , name: "<%=_T('Name')%>"      }
			],
			callbacks: {
				load_items: function(page, callback = $.noop) {
					//console.log("2 - grid load_items -> form_paginator_contacts");
					self.load_batches_contacts(page, callback);
				},
				must_shown_loading_msg: function() {
					return false; // El propio de las grillas, el de los formularios NO el del popup.
				}
			}
		});
		this.form_paginator_contacts.initialize();
		this.setEvents();
	};

	//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	/**
	Class Summary.
	*/
	function Summary (params)
	{
		const self = this;
		this.params = params;
		this.owner = params.owner;
		this.frm = params.frm;
		this.m_container_id = params.container_id;
		this.m_dom_items_id = `${this.m_container_id}_items`;
		this.m_dom_not_result_found_id = `${this.m_container_id}_not_result_found`;
		this.m_values = null;
		this.m_query = null;
		this.m_statuses_popups_details = {};
		const value_fn = function(value) {
			return value || 0;
		};
		this.m_statuses = {
			"TOTAL": {
				class_name   : "totalCSSClass_CAMBIAME",
				value        : function() {
					return self.calculate_total();
				},
				label        : "<%=_T('SUMMARY ALL CONTACTS')%>",
			},
			"FREE": {
				class_name   : "newContactsCSSClass_CAMBIAME",
				value        : value_fn,
				label        : "<%=_T('SUMMARY NEW CONTACTS')%>",
			},
			"SCHEDULED": {
				class_name   : "scheduledCSSClass_CAMBIAME",
				value        : value_fn,
				label        : "<%=_T('SUMMARY SCHEDULED')%>",
			},
			"ACTIVE": {
				class_name   : "activeCSSClass_CAMBIAME",
				value        : value_fn,
				label        : "<%=_T('SUMMARY ACTIVE')%>",
			},
			"FINISHED": {
				class_name   : "finishedCSSClass_CAMBIAME",
				value        : value_fn,
				label        : "<%=_T('SUMMARY FINISHED')%>",
			},
			"CANCELED": {
				class_name   : "canceledCSSClass_CAMBIAME",
				value        : value_fn,
				label        : "<%=_T('SUMMARY CANCELED')%>",
			},
			"PENDING": {
				class_name   : "pendingCSSClass_CAMBIAME",
				value        : value_fn,
				label        : "<%=_T('SUMMARY PENDINGS')%>",
			},
			"PROCESS": {
				class_name   : "processCSSClass_CAMBIAME",
				value        : value_fn,
				label        : "<%=_T('SUMMARY IN PROCESS')%>",
			},
			"PAUSED": {
				class_name   : "pausedCSSClass_CAMBIAME",
				value        : value_fn,
				label        : "<%=_T('SUMMARY PAUSED')%>",
			}
		};
	}

	Summary.prototype.get_statuses_def = function()
	{
		return this.m_statuses;
	};

	/*******************************************************************
	 * Metodo que crea el markup contenedor de la ventana
	 */
	Summary.prototype.createMarkup = function()
	{
		const self = this;
		const makeMarkupSummaryItems = function() {
			let html_thead_items = "";
			let html_tbody_items = "";
			for (let status_id in self.m_statuses) {
				if (self.m_statuses.hasOwnProperty(status_id)) {
					let status = self.m_statuses[status_id];
					//thead
					let html_head_item = `
						<th>
							<label>${status.label}</label>
						</th>
					`.trim();
					html_thead_items = html_thead_items + html_head_item;
					//tbody
					let dom_item_id = self.m_container_id + status_id;
					let html_tbody_item = `
						<td id='${dom_item_id}'>
							${
								status_id === "TOTAL" ?
								`<label status_value='${status_id}'></label>` :
								`<a show_detail='${status_id}' staus_name='${status.label}' status_value='${status_id}' class='ic-text-link' href='javascript:void(0);'>${status.value()}</a>`
							}
						</td>
					`.trim();
					html_tbody_items = html_tbody_items + html_tbody_item;
				}
			}
			let html_thead = `<thead class="viewGridHeader">${html_thead_items}</thead>`;
			let html_body =`<tbody class="viewGridBody"><tr>${html_tbody_items}</tr></tbody>`;
			return html_thead + html_body;
		};
		// Al markup lo crea una unica vez por clase.
		if ($("#" + this.m_dom_items_id).length === 0) {
			const $node = $(`
				<div class='row'>
					<div class='col-12'>
						<div id='${this.m_dom_not_result_found_id}' class='inlineMessagesContainer messageInfo mt-0'><%=_T('No data to preview')%></div>
					</div>
				</div>
				<table id='${this.m_dom_items_id}' class='viewGrid summaryGridContainer' cellpadding='0' cellspacing='0' border='0' style='display:none;'>
					${makeMarkupSummaryItems()}
				</table>
			`.trim());
			$("#" + this.m_container_id).html($node);
		}
	};

	/*******************************************************************
	 *
	 */
	Summary.prototype.initialize = function()
	{
		this.createMarkup();
		this.set_events();
	};

	Summary.prototype.set_values = function(query, values = {})
	{
		const $container = $("#" + this.m_container_id);
		this.m_query = query;
		this.m_values = values;
		for (let status_id in this.m_statuses) {
			if (this.m_statuses.hasOwnProperty(status_id)) {
				let status = this.m_statuses[status_id];
				let value = this.m_values[status_id];
				let calculated_value = status.value(value);
				const $status_value = $container.find(`[status_value='${status_id}']`);
				$status_value.text(calculated_value);
				this.popup_reset_values(status_id);
			}
		}
		this.show_or_hide_summary_values();
	};

	Summary.prototype.reset_values = function()
	{
		this.m_query = null;
		this.m_values = null;
		for (let status_id in this.m_statuses) {
			if (this.m_statuses.hasOwnProperty(status_id)) {
				let status = this.m_statuses[status_id];
				status.value();
				this.popup_reset_values(status_id);
			}
		}
		this.show_or_hide_summary_values();
	};

	Summary.prototype.show_or_hide_summary_values = function()
	{
		const $items = $(`#${this.m_dom_items_id}`);
		const $not_result_found = $(`#${this.m_dom_not_result_found_id}`);
		const total = this.calculate_total();
		if (total > 0) {
			$not_result_found.hide();
			$items.show();
			return;
		}
		$not_result_found.show();
		$items.hide();
	};

	Summary.prototype.popup_reset_values = function(status_id)
	{
		if (this.m_statuses_popups_details[status_id]) {
			this.m_statuses_popups_details[status_id].reset_values();
		}
	};

	Summary.prototype.calculate_total = function()
	{
		let total = 0;
		for (let status_id in this.m_values || {}) {
			if (this.m_statuses.hasOwnProperty(status_id)) {
				let value = this.m_values[status_id];
				total = total + value;
			}
		}
		return total;
	};

	Summary.prototype.set_events = function()
	{
		const self = this;
		let event_selector = "[show_detail]";
		$("#" + this.m_container_id)
			.off("click", event_selector)
			.on("click", event_selector, function() {
				const $this = $(this);
				let status_id = $this.attr("show_detail");
				let status_name = $this.attr("staus_name");
				self.show_popup_contacts_detail(status_id, status_name, $this);
			});
	};

	Summary.prototype.can_show_popup_contacts_detail = function()
	{
		if (!this.owner.can_show_summary_popup_contacts_detail()) {
			return false;
		}
		return true;
	};

	Summary.prototype.show_popup_contacts_detail = function(status_id, status_name, $parent)
	{
		if (!this.can_show_popup_contacts_detail()) {
			return;
		}
		if (!this.m_statuses_popups_details[status_id]) {
			this.m_statuses_popups_details[status_id] = new SummaryPopupContactsDetail({status_id: status_id, status_name: status_name, frm: this.frm});
		}
		this.m_statuses_popups_details[status_id].show({
			parentNode  : $parent,
			owner_object: this,
			query       : {status_id: status_id, status_name: status_name, query: this.m_query}
		});
	};

	//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

	/**
	Class SaveFilterPopup.
	*/
	function SaveFilterPopup (params)
	{
		SaveFilterPopup.uber.constructor.call( this );
		this.clickEventName = this.clickEventName + "_batch_filter";
		this.ownerId = "out_batch_filter_popup_container";
		this.filterId = this.ownerId + "_filter_id";
		this.saveId = this.ownerId + "_save";
		this.closeId = this.ownerId + "_close";
		this.params = params;
		this.canReposition = true;
	}

	inConcert.Utils.inherit(SaveFilterPopup, inConcert.PopupWindow);

	/*******************************************************************
	 * Metodo que crea el markup contenedor de la ventana
	 */
	SaveFilterPopup.prototype.createMarkup = function()
	{
		$("#" + this.ownerId).remove();

		//create the markup everytime
		const $node = $("".concat(
			"<div id='" + this.ownerId + "' class='systemPopWindow windowContainer' style='display:none'>",
				"<div class='windowTop'>",
					"<div class='windowTitle'>", "<%=_T('Save Filter')%>", "</div>",
				"</div>",
				"<div class='windowMiddle' style='display:none'>",
					"<div class=''></div>",
				"</div>",
				"<div class='windowMiddle'>",
					"<div class='card-block'>",
						"<div class='row'>",
							"<div class='col-12'>",
								"<div class='form-group'>",
									"<label for='", this.filterId, "' class=''>", "<%=_T('Filter Name')%>", "<%=_T(':')%>", "</label>",
									"<input id='", this.filterId, "' class='form-control' type='text' />",
								"</div>",
							"</div>",
						"</div>",
					"</div>",
				"</div>",
				"<div class='windowBottom d-flex justify-content-end'>",
					"<button id='", this.closeId, "' class='pageButtonGeneric buttonColorWhite mr-3'>",
						"<%=_T('Close')%>",
					"</button>",
					"<button id='", this.saveId, "' class='pageButtonGeneric buttonColorBlack'>",
						"<%=_T('Save')%>",
					"</button>",
				"</div>",
			"</div>"));
		$("body").append($node);

		return $node;
	};

	/*******************************************************************
	 *
	 */
	SaveFilterPopup.prototype.initialize = function()
	{
		this.data.container = this.createMarkup();
		this.parent_save = this.data.callbacks.save || $.noop;
		this.setEvents();
	};

	SaveFilterPopup.prototype.ready = function()
	{
		const current_filter = this.params.current_filter;
		$("#" + this.filterId).val(current_filter).focus();
	};

	SaveFilterPopup.prototype.close = function(params) {
		if (this.data && this.data.container) {
			this.data.container.remove();
		}
		this.finalize(params);
	};

	/*******************************************************************
	 * Metodo que setea eventos de los controles
	 */
	SaveFilterPopup.prototype.setEvents = function()
	{
		const self = this;

		const $filter_id =  $("#" + this.filterId);
		//---------------
		$("#" + this.saveId)
			.unbind("click")
			.click(function() {
				let filter_id = $filter_id.val();
				self.parent_save(filter_id, function(success) {
					if (!success) {
						$filter_id.focus();
						return;
					}
					self.close();
				});
			});
		//---------------
		$("#" + this.closeId).unbind("click").click(function() {
			self.close();
		});
	};

	//---------------------------------------------------------------------
	// form process batches class
	function form_outbound_engine_processes_batches(params)
	{
		this.frm = params.frm;

		this.is_new_filter_condition = null;
		this.current_filter_condition = null;

		this.cached_fields_by_desc = null;
		this.cached_fields_by_field = null;
		this.contact_query_result = null;
		this.m_current_query = null;

		// El paginado se realiza un unico request de rows por paginas, ya que el paginado se realiza client side.
		this.server_side_contacts_rows_per_page = 200;
		this.form_paginator_contacts = null;
		this.form_paginator_filters = null;

		// Instancia de la clase de los TABs
		this.main_tabs = new inConcert.conf_form_tab({
			parent        : this,
			frm           : this.frm,
			container_id  : "out_form_process_batches_tabs",
			container_class : "formTabsContainer formTabsContainerWizard",
			must_intialize: false,
			tabs_list   : {
				datasource: {
					id              : "datasource",
					name            : "<span class='formTabsMenuItemStepNum'>1</span><%=_T('Data Source and Filters')%>",
					tab_container_id: "out_form_process_batches_tab_datasource_container",
					selected        : true
				},
				actions: {
					id              : "actions",
					name            : "<span class='formTabsMenuItemStepNum'>2</span><%=_T('Actions')%>",
					tab_container_id: "out_form_process_batches_tab_actions_container",
					initial_state   : "disabled"
				}
			}
		});

		this.__initialize();

		this.operators = [
			{id: "="   , name: "<%=_T('equal')%>"           },
			{id: "<>"  , name: "<%=_T('distinct')%>"        },
			{id: "<"   , name: "<%=_T('less')%>"            },
			{id: ">"   , name: "<%=_T('greater')%>"         },
			{id: "<="  , name: "<%=_T('less or equal')%>"   },
			{id: ">="  , name: "<%=_T('greater or equal')%>"},
			{id: "Like", name: "<%=_T('contains')%>"        }
		];

		this.logical_operators = [
			{id: "OR" , name: "<%=_T('OR')%>" },
			{id: "AND", name: "<%=_T('AND')%>"}
		];

		this.left_parenths  = [{id: "("}, {id: "(("}, {id: "((("}, {id: "(((("}];
		this.right_parenths = [{id: ")"}, {id: "))"}, {id: ")))"}, {id: "))))"}];
		this.filter_popup = null;
		// summary del tab "datasource"
		this.summary_info_datasource_detail = new Summary({
			container_id: "out_form_process_batches_tab_datasource_detail_container",
			owner       : this,
			frm         : this.frm
		});
		// summary del tab "actions"
		this.summary_info_actions_detail = new Summary({
			container_id: "out_form_process_batches_tab_actions_detail_container",
			owner       : this,
			frm         : this.frm
		});
	}

	if (typeof inConcert.form_outbound_engine_processes_batches !== "function") {
		inConcert.form_outbound_engine_processes_batches = form_outbound_engine_processes_batches;
	}

	form_outbound_engine_processes_batches.prototype.__initialize = function()
	{
		this.__new_grids();
	};

	form_outbound_engine_processes_batches.prototype.dispose = function()
	{
		this.contact_query_result = null;
		this.m_current_query = null;
		this.__update_summary(false);
	};

	form_outbound_engine_processes_batches.prototype.can_show_summary_popup_contacts_detail = function()
	{
		if (!this.contact_query_result) {
			return false;
		}
		return true;
	};

	form_outbound_engine_processes_batches.prototype.ready_for_create = function()
	{
		this.main_tabs.initialize();
		this.main_tabs.show_tabs_container();
		this.summary_info_datasource_detail.initialize();
		this.summary_info_actions_detail.initialize();
		if (this.m_is_ok_executed_query) {
			this.__disableSummaryTab(false);
		}
		else {
			this.__disableSummaryTab(true);
		}
		$("#out_form_process_batches_data_source").trigger("change");
	};

	form_outbound_engine_processes_batches.prototype.ready_for_update = function()
	{
		this.ready_for_create();
		this.load_update_information();
	};

	form_outbound_engine_processes_batches.prototype.initialize_ctrls = function()
	{
		$("#out_form_process_batches_data_source").val("").trigger("change");
		const dom_container_id = "out_form_process_batches_section";
		this.frm.create_datepickers(dom_container_id);
		this.frm.create_spinners(dom_container_id);
		this.frm.create_hours("out_form_process_batches_tab_actions_container");
		const $filters = $("#out_form_process_batches_filters");
		$filters.val("");
		this.__change_filter();
		this.form_paginator_contacts.initialize();
		this.__initial_ctrls_values();
	};

	form_outbound_engine_processes_batches.prototype.__new_grids = function()
	{
		const self = this;

		const get_field_name = function(item) {
			if (!item || !item.field) {
				return "";
			}
			let field = self.cached_fields_by_field ? self.cached_fields_by_field[item.field] : null;
			if (field) {
				return self.get_grid_filter_value(field, "Id");
			}
			return self.get_grid_filter_value(item, "field");
		};

		this.form_paginator_filters = new inConcert.conf_form_paginator({
			paginator_name: "OUTBOUND_BATCHES_FILTERS",
			owner: this,
			frm: this.frm,
			display_name: function(item) {
				let displayItem = get_field_name(item);
				return displayItem.value;
			},
			rows_per_page: 500,
			show_at_least: 499,
			paginator_type: "ALL_ROWS_SERVER_SIDE",
			without_paginator: true,
			loading_waiting_msg: "<%=_T('Please wait, loading Filters ...')%>",
			//use_instance_of_inconcert_popup: true, // con este flag el popup se instancia desde el popup inconcert popup window.
			html: {
				popup: {
					actions: {
						html_type: "BUTTON"
					}
				}
			},
			ids: {
				grid                      : "out_form_process_batches_filters_list",
				paginator                 : "out_form_process_batches_filters_paginator",
				not_results_found         : "out_form_process_batches_filters_not_results_found",
				container_new_btn         : "out_form_process_batches_filters_new_condition_button_container",
				new_item                  : "out_form_process_batches_filters_new_condition",
				//popup
				popup                     : "out_form_process_batches_filters_popup",
				popup_msg                 : "out_form_process_batches_filters_popup_message",
				popup_create              : "out_form_process_batches_filters_popup_create",
				popup_create_and_continue : "out_form_process_batches_filters_popup_create_and_continue",
				popup_title               : "out_form_process_batches_filters_popup_title",
				popup_close               : "out_form_process_batches_filters_popup_close"
			},
			strings: {
				not_results_found         : "<%=_T('No Filters found.')%>",
				can_remove                : "<%=_T('Do you want to delete Filter Condition: {0} ?')%>",
				title_new                 : "<%=_T('New Condition')%>",
				title_update              : "<%=_T('Update Condition')%>",
				button_create             : "<%=_T('Confirm')%>",
				button_create_and_continue: "<%=_T('Confirm & continue')%>",
				button_update             : "<%=_T('Update')%>",
				button_close              : "<%=_T('Cancel')%>"
			},
			columns: [
				{id: "_number"     , name: "", type: "counter"   },
				{id: "logicalOp"   , name: "<%=_T('Operator')%>" },
				{id: "leftParenth" , name: "<%=_T('(')%>"        },
				{id: "field"       , name: "<%=_T('Field')%>"    , get_value: function(item) {
					return get_field_name(item);
				}},
				{id: "conditionOp" , name: "<%=_T('Condition')%>", get_value: function(item) {
					return self.get_grid_filter_value(item, "Condition");
				}},
				{id: "value"       , name: "<%=_T('Value')%>", get_value: function(item) {
					return self.get_grid_filter_value(item, "value");
				}},
				{id: "rightParenth", name: "<%=_T(')')%>"        },
				{id: "_action", name: "",
					system_action: { edit: true, erase: true }
				}
			],
			callbacks: {
				save: function(callback, must_create_and_contiune) {
					self.add_or_update_filter_condition(callback, must_create_and_contiune);
				},
				edit: function(condition) {
					self.on_edit_filter_condition(condition);
				},
				on_added_row: (row, callback = $.noop) => {
					self.__filter_on_added_row(row, callback);
				},
				on_updated_row: (row, callback = $.noop) => {
					self.__filter_on_updated_row(row, callback);
				},
				on_removed_row: function() {
					self.__on_removed_filter_row();
				},
				on_closed_popup: function() {
					self.on_closed_filter_condition_popup();
				},
				load_items: function(page, callback = $.noop) {
					//console.log("1 - grid load_items -> form_paginator_filters");
					self.frm.count_pending_grid = self.frm.count_pending_grid + 1;
					self.load_batches_filters(page, callback);
				},
				on_loaded_items: function(callback = $.noop) {
					self.__on_loaded_filter_grid(callback);
				}
			}
		});

		// La cantidad de rows que se deben de visualizar en el paginador.
		// El paginado se realiza client side, ya que server side se obtienen una unica pagina con N "server_side_contacts_rows_per_page" registros.
		let client_side_rows_per_page = 10;

		this.form_paginator_contacts = new inConcert.conf_form_paginator({
			paginator_name: "OUTBOUND_BATCHES_CONTACTS",
			owner: this,
			frm: this.frm,
			row_id: "Name",
			display_name: "Name",
			rows_per_page: client_side_rows_per_page,
			show_at_least: client_side_rows_per_page - 1,
			paginator_type: "ALL_ROWS_CLIENT_SIDE",
			paged_text_format: "row_count",
			loading_waiting_msg: "<%=_T('Please wait, loading Contacts ...')%>",
			ids: {
				grid: "out_form_process_batches_contacts_list",
				paginator: "out_form_process_batches_contacts_paginator",
				not_results_found: "out_form_process_batches_contacts_not_results_found"
			},
			strings: {
				not_results_found: "<%=_T('No Contacts found.')%>"
			},
			columns: [
				{id: "_number" , name: "", type: "counter"     },
				{id: "Id"      , name: "<%=_T('Identifier')%>", get_value: function(item) {
					const value = inConcert.app.get_id(item.Id);
					return {
						original_value: item.Id,
						value         : value,
						search_value  : value
					};
				}},
				{id: "Name"    , name: "<%=_T('Name')%>"       },
				{id: "ImportId", name: "<%=_T('Last Import')%>"}
			],
			callbacks: {
				load_items: function(page, callback = $.noop) {
					//console.log("2 - grid load_items -> form_paginator_contacts");
					self.frm.count_pending_grid = self.frm.count_pending_grid + 1;
					self.load_batches_contacts(page, callback);
				},
				on_loaded_items: function(callback = $.noop) {
					self.frm.__on_loaded_grid(callback);
				}
			}
		});
	};

	form_outbound_engine_processes_batches.prototype.get_grid_filter_value = function(item, field_id)
	{
		let value = {
			original_value: "",
			value         : "",
			search_value  : ""
		};

		let item_value = item[field_id] || "";
		if (item_value === undefined) {
			return value;
		}

		value.original_value = item_value;
		value.value = item_value;
		value.search_value = item_value;

		if (field_id === "Condition") {
			value.value = this.__operator_as_string(item.conditionOp);
			value.search_value = value.value;
		}
		else if (field_id === "value") {
			const fieldInfo = this.cached_fields_by_field ? this.cached_fields_by_field[item.field] : null;
			if (fieldInfo) {
				for (let i = 0; i < (fieldInfo.values || []).length; i++) {
					let fieldValueInfo = fieldInfo.values[i];
					if (fieldValueInfo.Value && fieldValueInfo.Value === item_value) {
						item_value = fieldValueInfo.Name || item_value;
					}
				}
			}
			value.value = item_value;
			value.search_value = item_value;
		}
		return value;
	};

	form_outbound_engine_processes_batches.prototype.__operator_as_string = function(condition)
	{
		let condition_string;
		$.each(this.operators, function(_, operator) {
			if (operator.id === condition) {
				condition_string = operator.name;
				return false; //break
			}
		});
		return condition_string || condition;
	};

	form_outbound_engine_processes_batches.prototype.on_closed_filter_condition_popup = function()
	{
		this.is_new_filter_condition = null;
		this.current_filter_condition = null;
		this.__disabled_filter_actions(false);
	};

	form_outbound_engine_processes_batches.prototype.load_batches_filters = function(_, callback = $.noop)
	{
		const $filters = $("#out_form_process_batches_filters");
		let filter = this.frm.combo_get_selected_item_data($filters);
		let query = [];
		if (filter) {
			//cargo el filtro seleccionado
			query = filter.query || [];
		}
		callback(true, query);
	};

	form_outbound_engine_processes_batches.prototype.load_batches_contacts = function(_, callback = $.noop)
	{
		this.__load_contacts_from_query(function(success, contacts) {
			callback(success, contacts);
		});
	};

	form_outbound_engine_processes_batches.prototype.load_information = function()
	{
		const self = this;
		this.__fill_sources();
		const outbound_engine_api = inConcert.app.getOutboundEngineAPI();
		outbound_engine_api.processLoadBatchFilters(function(success, list) {
			if (!success) {
				self.frm.show_status_message("<%=_T('Error Retrieving Filters Batch')%>", "Error", 5000);
				return;
			}
			self.__fill_filters(list);
			self.initialize_ctrls();
		});
	};

	form_outbound_engine_processes_batches.prototype.load_update_information = function()
	{
		const self = this;

		const outbound_engine_api = inConcert.app.getOutboundEngineAPI();
		const process = this.get_entity_instance();
		/*
		*/
		const sortFieldValues = (values = []) => {
			const firstItem = values[0];
			if (!firstItem) return values;
			const sortedValues = [...values];
			if (typeof firstItem === "object")
				return sortedValues.sort((a, b) => (a.Name || "").localeCompare((b.Name || "")));
			return sortedValues.sort();
		};

		outbound_engine_api.processLoadBatchFields(process.id, function(success, list)
		{
			if (!success) {
				self.frm.show_status_message("<%=_T('Error Retrieving Fields Batch')%>", "Error", 5000);
				return;
			}
			self.cached_fields_by_desc = {};
			self.cached_fields_by_field = {};

			$.each(list, function(_, field)
			{
				let full_field_name = field.Field;
				let field_id = field.Name;
				let cached_field = {
					id              : field_id,
					name            : field.Name,
					field           : full_field_name,
					values          : sortFieldValues(field.Values),
					type            : field.Type,
					table           : field.Table,
					AllowedOperators: field.AllowedOperators
				};
				self.cached_fields_by_desc[field_id] = cached_field;
				self.cached_fields_by_field[full_field_name] = cached_field;
			});

			self.__fill_filters_fields();
		});

		let campaign_id = process.configuration ? process.configuration.campaign : false;
		if (campaign_id) {
			outbound_engine_api.systemLoadCampaignMembers(campaign_id, function(success, list) {
				if (!success) {
					self.frm.show_status_message("<%=_T('Error Retrieving Members of Campaign')%>", "Error", 5000);
					return;
				}
				self.__fill_campaign_members(list);
			});
		}
	};

	form_outbound_engine_processes_batches.prototype.get_entity_instance = function()
	{
		return this.frm.get_entity_instance() || {};
	};

	form_outbound_engine_processes_batches.prototype.__fill_sources = function()
	{
		const $combo = $("#out_form_process_batches_data_source");
		let list = [
			{id: "contact_query", name: "<%=_T('Contacts Database')%>"      },
			{id: "batch_query"  , name: "<%=_T('Current Process Batches')%>"}
		];
		this.frm.fill_combo($combo, true /* is_blank_first_item */, list, "id" /* attr_id */, "name" /* attr_name */);
	};

	form_outbound_engine_processes_batches.prototype.__fill_filters = function(list)
	{
		const $combo = $("#out_form_process_batches_filters");
		this.frm.fill_combo($combo, true /* is_blank_first_item */, list, "id" /* attr_id */, "id" /* attr_name */, true /*sorted*/);
	};

	form_outbound_engine_processes_batches.prototype.__fill_actions = function(source)
	{
		let list = [];

		if (source === "contact_query") {
			list.push({id: "createbatch", name: "<%=_T('Create New Batch')%>"});
		}
		else if (source === "batch_query") {
			list.push({id: "cancelcontacts"         , name: "<%=_T('Cancel Contacts')%>"        });
			list.push({id: "removecontacts"         , name: "<%=_T('Remove Contacts')%>"        });
			list.push({id: "pausecontactsquery"     , name: "<%=_T('Pause Contacts')%>"         });
			list.push({id: "resumecontactsquery"    , name: "<%=_T('Resume Contacts')%>"        });
			list.push({id: "activatecontacts"       , name: "<%=_T('Recycle Contacts')%>"       });
			list.push({id: "changepriority"         , name: "<%=_T('Change Priority')%>"        });
			list.push({id: "changeisprogressivetype", name: "<%=_T('Change Progressive Type')%>"});
		}
		const $combo = $("#out_form_process_batches_actions");
		this.frm.fill_combo($combo, true /* is_blank_first_item */, list, "id" /* attr_id */, "name" /* attr_name */);
	};

	form_outbound_engine_processes_batches.prototype.__fill_filters_fields = function()
	{
		const self = this;

		const $logical_operator = $("#out_form_process_batches_filters_field_logical_operator");
		this.frm.fill_combo($logical_operator, true /* is_blank_first_item */, this.logical_operators, "id" /* attr_id */, "name" /* attr_name */);

		this.__fill_operators();

		const $left_parentheses = $("#out_form_process_batches_filters_field_left_parentheses");
		this.frm.fill_combo($left_parentheses, true /* is_blank_first_item */, this.left_parenths, "id" /* attr_id */, "id" /* attr_name */);

		const $rigth_parentheses = $("#out_form_process_batches_filters_field_rigth_parentheses");
		this.frm.fill_combo($rigth_parentheses, true /* is_blank_first_item */, this.right_parenths, "id" /* attr_id */, "id" /* attr_name */);

		// combo autocomplete
		const $field_name = $("#out_form_process_batches_filters_field_name");
		let arr_fields = inConcert.Utils.hash_to_sorted_array(this.cached_fields_by_desc, null, null, {only_key: true});
		this.frm.make_autocomplete(
			$field_name,
			arr_fields,
			function(/*_, value*/) {
				self.__change_filter_field_name();
			},
			"SELECT"   // initial state (SELECT (combo) default, o INPUT)
		);
	};

	form_outbound_engine_processes_batches.prototype.__fill_operators = function(filterOperators = function() {return true;})
	{
		const $operator = $("#out_form_process_batches_filters_field_operator");
		let existCurrentOperator = false;
		const currentOperator = $operator.val();
		// filtra los operadores invocando a la funcion recibida por parametros.
		let operators = [];
		this.operators.forEach(operator => {
			if (filterOperators(operator)) {
				operators.push(operator);
				if (currentOperator === operator.id) {
					existCurrentOperator = true;
				}
			}
		});
		// llena el combo
		this.frm.fill_combo($operator, true /* is_blank_first_item */, operators, "id" /* attr_id */, "name" /* attr_name */);
		// 
		if (existCurrentOperator) {
			$operator.val(currentOperator);
		}
	};

	form_outbound_engine_processes_batches.prototype.__fill_campaign_members = function(list)
	{
		const $combo = $("#out_form_process_batches_action_activate_assign_agent");
		this.frm.fill_combo($combo, true /* is_blank_first_item */, list, "UserId" /* attr_id */, "UserId" /* attr_name */);
	};

	form_outbound_engine_processes_batches.prototype.__change_filter_field_name = function()
	{
		const $field_name = $("#out_form_process_batches_filters_field_name");
		const field_name = $field_name.val();
		let fieldDef;
		let list = [];
		if (this.cached_fields_by_desc !== undefined && this.cached_fields_by_desc[field_name] !== undefined) {
			fieldDef = this.cached_fields_by_desc[field_name];
			$.each(fieldDef.values || [], function(_, field) {
				let item = "";
				if (typeof(field) === "object") {
					item = {
						label: field.Name,
						value: field.Value
					};
				}
				else {
					item = field;
				}
				list.push(item);
			});
		}
		// combo autocomplete
		const $field_value = $("#out_form_process_batches_filters_field_value");
		this.frm.make_autocomplete(
			$field_value,
			list,
			undefined, // callback
			list.length === 0 ? "INPUT" : "SELECT", // tipo de control (textbox o combo)
			list.length > 100 ? 100: undefined // topear a 100 los items a mostrar
		);
		// operadores
		this.__fill_operators(function(operator) {
			if (!fieldDef) {
				return true;
			}
			if (!fieldDef.AllowedOperators) {
				return true;
			}
			let operatorId = operator.id.toUpperCase();
			let allowedOperator = fieldDef.AllowedOperators[operatorId];
			if (allowedOperator && allowedOperator.enabled) {
				return true;
			}
			return false;
		});
		// placeholder
		let placeholder = "";
		if (fieldDef) {
			let dateFormat = m_dateFormats[fieldDef.type];
			if (dateFormat) {
				placeholder = dateFormat.format;
			}
			if (fieldDef.type === "integer" || fieldDef.type === "double") {
				placeholder = "<%=_T('Enter a number')%>";
			}
		}
		$field_value.attr("placeholder", placeholder);
	};

	form_outbound_engine_processes_batches.prototype.hide_all_errors = function()
	{
		this.frm.hide_messages();
	};

	form_outbound_engine_processes_batches.prototype.__show_ctrl_err = function(err_info, focus = true)
	{
		if (!err_info) {
			return;
		}
		this.frm.show_validation_error(err_info.$ctrl, err_info.message, 5000, false, false, false, focus);
	};

	form_outbound_engine_processes_batches.prototype.mark_ctrl_error = function($ctrl)
	{
		if (!$ctrl || $ctrl.length === 0) {
			return;
		}
		this.frm.mark_ctrl_error($ctrl);
	};

	form_outbound_engine_processes_batches.prototype.validate_filter_condition_to_update = function()
	{
		this.form_paginator_filters.hide_popup_msg();

		let response = {success: false, $ctrl: null, item: null, msg: "<%=_T('Unable to Add or Update Filter Condition.')%>"};

		const $logical_operator = $("#out_form_process_batches_filters_field_logical_operator");
		const $left_parentheses = $("#out_form_process_batches_filters_field_left_parentheses");
		const $field_operator = $("#out_form_process_batches_filters_field_operator");
		const $rigth_parentheses = $("#out_form_process_batches_filters_field_rigth_parentheses");

		// field name - autocomplete
		let $field_name = $("#out_form_process_batches_filters_field_name");
		let field_name = this.frm.autocomplete_get_value($field_name);
		let field_description = field_name.label;
		let filed_info = this.__get_field_id_by_desc(field_description);

		// field value - autocomplete
		let $field_value = $("#out_form_process_batches_filters_field_value");
		let field_value = this.frm.autocomplete_get_value($field_value);

		let filter_condition = {
			logicalOp    : $logical_operator.val(),
			leftParenth  : $left_parentheses.val(),
			field        : filed_info.id,
			conditionOp  : $field_operator.val(),
			value        : field_value.value,
			rightParenth : $rigth_parentheses.val()//,
		//	isCustomField: filed_info.is_custom_field
		};

		let validation_result;

		let count_lines = this.form_paginator_filters.count_rows();

		if (this.is_new_filter_condition) {
			// Si estoy creando y NO es la primera linea, el logical operator es requerido.
			if (count_lines > 0) {
				validation_result = inConcert.Utils.validate(filter_condition.logicalOp, "required");
				if ( !validation_result.success ) {
					response.msg = "<%=_T('Logical Operator is required.')%>";
					response.$ctrl = $logical_operator;
					return response;
				}
			}
		}
		else {
			// Si estoy editando y NO es la primera linea, el logical operator es requerido.
			if (this.current_filter_condition.__number > 1) {
				validation_result = inConcert.Utils.validate(filter_condition.logicalOp, "required");
				if ( !validation_result.success ) {
					response.msg = "<%=_T('Logical Operator is required.')%>";
					response.$ctrl = $logical_operator;
					return response;
				}
			}
			// El ID interno que genera el paginador. Esto sirve para que el paginador pueda actualizar la row en la grilla
			filter_condition.id = this.current_filter_condition.id;
		}

		validation_result = inConcert.Utils.validate(filter_condition.field, "required");
		if ( !validation_result.success ) {
			response.msg = "<%=_T('Field Name is required.')%>";
			response.$ctrl = $field_name;
			return response;
		}

		validation_result = inConcert.Utils.validate(filter_condition.conditionOp, "required");
		if ( !validation_result.success ) {
			response.msg = "<%=_T('Operator is required.')%>";
			response.$ctrl = $field_operator;
			return response;
		}

		if (filed_info.type) {
			if (filed_info.type !== "keyword" && filed_info.type !== "text") {
				validation_result = inConcert.Utils.validate(filter_condition.value, "required");
				if (!validation_result.success) {
					response.msg = "<%=_T('Field value is required.')%>";
					response.$ctrl = $field_value;
					return response;
				}
				if (filed_info.type === "integer" || filed_info.type === "double") {
					let is_digits = inConcert.Utils.validate(filter_condition.value, "number");
					if (!is_digits.success) {
						response.msg = "<%=_T('Field value is not a number.')%>";
						response.$ctrl = $field_value;
						return response;
					}
				}
				else if (filed_info.type === "date" || filed_info.type === "datetime") {
					const options = {
						dateFormat: m_dateFormats[filed_info.type] ? m_dateFormats[filed_info.type].format : null
					};
					let isOk = inConcert.Utils.isValid(filter_condition.value, "date", options);
					if (!isOk) {
						response.msg = FORMAT("<%=_T('Field value is a invalid date. Allowed format {0}.')%>", options.dateFormat);
						response.$ctrl = $field_value;
						return response;
					}
				}
			}
		}

		response.success = true;
		response.msg = "";
		response.item = filter_condition;

		return response;
	};

	form_outbound_engine_processes_batches.prototype.show_filter_save_actions = function()
	{
		const count_lines = this.form_paginator_filters.count_rows();
		if (count_lines === 0) {
			this.hide_filter_save_actions();
			return;
		}
		const $new_condition_button_container = $("#out_form_process_batches_filters_new_condition_button_container");
		$new_condition_button_container.show();
	};

	form_outbound_engine_processes_batches.prototype.hide_filter_save_actions = function()
	{
		const $new_condition_button_container = $("#out_form_process_batches_filters_new_condition_button_container");
		let selectedFilter = $("#out_form_process_batches_filters").val();
		if (selectedFilter) {
			$new_condition_button_container.show();
			return;
		}
		$new_condition_button_container.hide();
	};

	form_outbound_engine_processes_batches.prototype.add_or_update_filter_condition = function(callback = $.noop)
	{
		let msg_response = {msg: "", type: ""};
		const response = this.validate_filter_condition_to_update();

		if (!response.success) {
			this.mark_ctrl_error(response.$ctrl);
			msg_response.type = "Error";
			msg_response.msg = response.msg;
			callback(false, response.item, msg_response, undefined, undefined, 3000);
			return;
		}

		this.show_filter_save_actions();

		const $restore = $("#out_form_process_batches_filters_restore");
		$restore.prop("disabled", false);

		this.__cleanup_ctrls_popup();
		this.current_filter_condition = null;

		msg_response.msg = this.is_new_filter_condition ? "<%=_T('Filter Condition was successfully added.')%>" : "<%=_T('Filter Condition was successfully updated.')%>";
		msg_response.type = "Info";

		callback(true, response.item, msg_response);
	};

	form_outbound_engine_processes_batches.prototype.__disableSummaryTab = function(isDisabled)
	{
		const $go_to_summary_and_actions = $("#out_form_process_batches_filters_go_to_summary_and_actions");
		$go_to_summary_and_actions.removeAttr("disabled");
		if (isDisabled) {
			this.main_tabs.disable_tab("actions");
			$go_to_summary_and_actions.attr("disabled", "disabled");
			$("#out_form_process_batches_action_execute").prop("disabled", true);
			return;
		}
		this.main_tabs.enable_tab("actions");
		$("#out_form_process_batches_action_execute").prop("disabled", false);
	};

	/*
		valida si tiene que deshabilitar el tab "summary"
	*/
	form_outbound_engine_processes_batches.prototype.__haveToDisableSummaryTab = function()
	{
		if (!this.m_current_query || !this.m_current_query.query) {
			return true;
		}
		const source = $("#out_form_process_batches_data_source").val();
		if (this.m_current_query.query.source !== source) {
			return true;
		}
		const response = this.__validate_expression();
		if (!response.query) {
			return true;
		}
		const excludeContacted = $("#out_form_process_batches_filters_exclude_already").prop("checked");
		if (this.m_current_query.query.excludeContacted !== excludeContacted) {
			return true;
		}
		if (excludeContacted) {
			const $starting_on = $("#out_form_process_batches_filters_starting_on");
			if ($starting_on.prop("checked")) {
				const contactedDate = $("#out_form_process_batches_filters_contacted_date").val();
				if (this.m_current_query.query.contactedDate !== contactedDate) {
					return true;
				}
			}
		}
		const areEquals = inConcert.Utils.compareArrays(this.m_current_query.query.lines, response.query.lines);
		if (!areEquals) {
			return true;
		}
		// se habilita
		return false;
	};

	form_outbound_engine_processes_batches.prototype.__change_source = function(source)
	{
		this.__fill_actions(source);
		const $actions = $("#out_form_process_batches_actions");
		$actions.val("").trigger("change");
		const isDisabledSummaryTab = this.__haveToDisableSummaryTab();
		this.__disableSummaryTab(isDisabledSummaryTab);
		const $retrieve = $("#out_form_process_batches_filters_retrieve");
		$retrieve.removeAttr("disabled");
		if (source === "") {
			$retrieve.attr("disabled", "disabled");
		}
	};

	form_outbound_engine_processes_batches.prototype.__change_starting_on_date = function()
	{
		const $starting_on = $("#out_form_process_batches_filters_starting_on");
		const enabled = $starting_on.prop("checked");
		const $contacted_date = $("#out_form_process_batches_filters_contacted_date");
		const is_required = enabled;
		this.frm.disable_control($contacted_date, !enabled, is_required);
		if (!enabled) {
			$starting_on.val("");
			$contacted_date.val("");
		}
	};

	form_outbound_engine_processes_batches.prototype.__change_exclude_already = function()
	{
		const $exclude_already = $("#out_form_process_batches_filters_exclude_already");
		const enabled = $exclude_already.prop("checked");
		const $exclude_already_container = $("#out_form_process_batches_filters_exclude_already_container");
		const $starting_on = $("#out_form_process_batches_filters_starting_on");
		if (!enabled) {
			$starting_on.prop("checked", false);
			$exclude_already_container.hide();
		}
		else {
			$exclude_already_container.show();
		}
		this.frm.disable_control($starting_on, !enabled);
		this.__change_starting_on_date();
	};

	form_outbound_engine_processes_batches.prototype.__filter_disable_enable_first_logical_operator = function()
	{
		const $logical_operator = $("#out_form_process_batches_filters_field_logical_operator");
		let count_lines = this.form_paginator_filters.count_rows();
		let disabled = count_lines === 0;
		this.frm.disable_control($logical_operator, disabled, true, true, false);
	};

	form_outbound_engine_processes_batches.prototype.__on_loaded_filter_grid = function(callback = $.noop)
	{
		this.frm.__on_loaded_grid(callback);
		// edicion del filtro (Create)
		this.__filter_disable_enable_first_logical_operator();
	};

	form_outbound_engine_processes_batches.prototype.__on_removed_filter_row = function()
	{
		this.__filter_disable_enable_first_logical_operator();
		this.__disabled_filter_actions(false);
		this.show_filter_save_actions();
		const $restore = $("#out_form_process_batches_filters_restore");
		$restore.prop("disabled", false);
		this.__filter_update_restore_button_label();
		const isDisabledSummaryTab = this.__haveToDisableSummaryTab();
		this.__disableSummaryTab(isDisabledSummaryTab);
		let count_lines = this.form_paginator_filters.count_rows();
		if (count_lines === 0) {
			// si ya no quedan filas en el filtro y esta creando uno, tiene que volver a visualizar el boton "new filter"
			const select_filter = $("#out_form_process_batches_filters").val();
			if (select_filter.length === 0) {
				const $new_filter = $("#out_form_process_batches_filters_new");
				$new_filter.prop("disabled", false).show();
			}
		}
	};

	form_outbound_engine_processes_batches.prototype.__change_filter = function()
	{
		this.form_paginator_filters.initialize();

		const $new_filter = $("#out_form_process_batches_filters_new");
		const $filters = $("#out_form_process_batches_filters");
		let filter = this.frm.combo_get_selected_item_data($filters);
		const $exclude_already = $("#out_form_process_batches_filters_exclude_already");
		const $delete_filter = $("#out_form_process_batches_filters_delete");
		const $save = $("#out_form_process_batches_filters_save");
		const $restore = $("#out_form_process_batches_filters_restore");
		this.hide_filter_save_actions();
		this.__filter_update_restore_button_label();

		this.__disableSummaryTab(true);

		$restore.prop("disabled", true);
		this.frm.disable_control($exclude_already, !filter);

		if (!filter) {
			$save.prop("disabled", true);
			$exclude_already.prop("checked", false);
			this.__change_exclude_already();
			$delete_filter.prop("disabled", true).hide();
			$new_filter.prop("disabled", false).show();
			return;
		}
		
		$save.prop("disabled", false);
		$delete_filter.prop("disabled", false).show();
		//$new_filter.prop("disabled", true);

		const $starting_on = $("#out_form_process_batches_filters_starting_on");
		const $contacted_date = $("#out_form_process_batches_filters_contacted_date");

		//cargo el filtro seleccionado
		if (filter.excludeContacted) {
			$exclude_already.prop("checked", true);
			if (filter.contactedDate) {
				$starting_on.prop("checked", true);
				this.frm.datepicker_set_date($contacted_date, filter.contactedDate);
			}
			else {
				$starting_on.prop("checked", false);
				$contacted_date.val("");
			}
		}
		else {
			$exclude_already.prop("checked", false);
			$starting_on.prop("checked", false);
			$contacted_date.val("");
		}

		this.__change_exclude_already();
	};

	form_outbound_engine_processes_batches.prototype.__change_action = function(action)
	{
		const $create_batch_container = $("#out_form_process_batches_action_create_batch_container");
		const $activate_contacts_container = $("#out_form_process_batches_action_activate_contacts_container");
		const $activate_contacts_container_retries = $("#out_form_process_batches_action_activate_contacts_container_retries");
		const $change_priority_container = $("#out_form_process_batches_action_change_priority_container");
		const $change_progressive_type_container = $("#out_form_process_batches_action_change_progressive_type_container");

		$create_batch_container.hide();
		$activate_contacts_container.hide();
		$activate_contacts_container_retries.hide();
		$change_priority_container.hide();
		$change_progressive_type_container.hide();

		switch(action) {
			case "createbatch":
				$create_batch_container.show();
			break;
			case "activatecontacts":
				$activate_contacts_container.show();
				$activate_contacts_container_retries.show();
			break;
			case "changepriority":
				$change_priority_container.show();
			break;
			case "changeisprogressivetype":
					$change_progressive_type_container.show();
			break;
		}
	};

	form_outbound_engine_processes_batches.prototype.__initial_ctrls_values = function()
	{
		// Create New Batch section
		$("#out_form_process_batches_action_create_batch_id").val("");
		$("#out_form_process_batches_action_create_batch_priority").val("1");
		$("#out_form_process_batches_action_create_batch_contact_base_priority").val("100");
		this.frm.datepicker_set_date($("#out_form_process_batches_action_create_batch_start_date"));
		this.frm.datepicker_set_date($("#out_form_process_batches_action_create_batch_end_date"), "");
		$("#out_form_process_batches_action_create_batch_percentage").val("");
		// Recycle Contacts section
		$("#out_form_process_batches_action_activate_schedule").prop("checked", false).trigger("change");
		$("#out_form_process_batches_action_activate_assign").prop("checked", false).trigger("change");
		$("#out_form_process_batches_action_activate_assign_agent").val("");
		$("#out_form_process_batches_action_activate_reset_retries").prop("checked", true);
		// Change Priority section
		$("#out_form_process_batches_action_change_priority_new").val("");
	};

	form_outbound_engine_processes_batches.prototype.__cleanup_ctrls_popup = function()
	{
		$("#out_form_process_batches_filters_field_left_parentheses").val("");
		$("#out_form_process_batches_filters_field_name").val("");
		$("#out_form_process_batches_filters_field_operator").val("");
		// field value - autocomplete
		let $field_value = $("#out_form_process_batches_filters_field_value");
		this.frm.autocomplete_set_value($field_value, "");
		$("#out_form_process_batches_filters_field_rigth_parentheses").val("");
		$("#out_form_process_batches_filters_field_logical_operator").val("").focus();
	};

	form_outbound_engine_processes_batches.prototype.__filter_on_added_row = function(/*row, callback = $.noop]*/)
	{
		this.__filter_disable_enable_first_logical_operator();
		this.frm.disable_control($("#out_form_process_batches_filters_exclude_already"), false);
		const isDisabledSummaryTab = this.__haveToDisableSummaryTab();
		this.__disableSummaryTab(isDisabledSummaryTab);
		this.show_filter_save_actions();
	};

	form_outbound_engine_processes_batches.prototype.__filter_on_updated_row = function(/*row, callback = $.noop]*/)
	{
		const isDisabledSummaryTab = this.__haveToDisableSummaryTab();
		this.__disableSummaryTab(isDisabledSummaryTab);
	};

	form_outbound_engine_processes_batches.prototype.__filter_update_restore_button_label = function()
	{
		const current_filter = $("#out_form_process_batches_filters").val();
		let label = "<%=_T('Restore Original')%>";
		if (current_filter === "") {
			label = "<%=_T('Cancel')%>";
		}
		$("#out_form_process_batches_filters_restore").text(label);
	};

	form_outbound_engine_processes_batches.prototype.__disabled_filter_actions = function(disabled)
	{
		$("#out_form_process_batches_filters_new").prop("disabled", disabled);
		$("#out_form_process_batches_filters_retrieve").prop("disabled", disabled);
		const $save = $("#out_form_process_batches_filters_save");
		const $restore = $("#out_form_process_batches_filters_restore");
		const $filters = $("#out_form_process_batches_filters");
		this.frm.disable_control($filters, disabled, false, true, true); //$control, disabled, is_required, is_disable_lbl, keep_value
		const $delete_filter = $("#out_form_process_batches_filters_delete");
		if (disabled) {
			$save.prop("disabled", true);
			$restore.prop("disabled", true);
			$delete_filter.prop("disabled", true).hide();
		}
		else {
			let filter = this.frm.combo_get_selected_item_data($filters);
			if (!filter) {
				$delete_filter.prop("disabled", true).hide();
			}
			else {
				$delete_filter.prop("disabled", false).show();
			}
			let filter_lines = this.form_paginator_filters.count_rows();
			if (filter_lines === 0) {
				$save.prop("disabled", true);
			}
			else {
				$save.prop("disabled", false);
			}
		}
		this.__filter_update_restore_button_label();
		this.form_paginator_filters.disable_grid_actions(disabled);
	};

	form_outbound_engine_processes_batches.prototype.on_edit_filter_condition = function(condition)
	{
		const self = this;

		this.is_new_filter_condition = condition ? false: true;
		this.current_filter_condition = condition;
		this.__cleanup_ctrls_popup();
		const is_disabled_filter_actions = true;
		this.__disabled_filter_actions(is_disabled_filter_actions);

		let logical_op = "", left_parenth = "", condition_op = "", right_parenth = "", field = "", value = "";
		const $logical_operator = $("#out_form_process_batches_filters_field_logical_operator");

		let disable_logical_operator = true;

		if (!this.is_new_filter_condition) {
			logical_op = condition.logicalOp;
			left_parenth = condition.leftParenth;
			condition_op = condition.conditionOp;
			right_parenth = condition.rightParenth;
			let cached_field = this.cached_fields_by_field[condition.field];
			field = cached_field ? cached_field.Id : condition.field;
			value = condition.value;
			if (this.current_filter_condition.__number > 1 || (this.current_filter_condition.__number === 1 && logical_op.length > 0)) {
				disable_logical_operator = false;
			}
		}
		else {
			let count_lines = this.form_paginator_filters.count_rows();
			if (count_lines > 0) {
				disable_logical_operator = false;
			}
		}

		if (disable_logical_operator) {
			this.frm.disable_control($logical_operator, true);
		}
		else {
			this.frm.disable_control($logical_operator, false, true);
		} 

		$logical_operator.val(logical_op);
		$("#out_form_process_batches_filters_field_left_parentheses").val(left_parenth);
		$("#out_form_process_batches_filters_field_operator").val(condition_op);
		$("#out_form_process_batches_filters_field_rigth_parentheses").val(right_parenth);
		/*
			Aca se debe de implementar esta funcion(callack) directamente sobre la clase "conf_form" asi podemos tener el evento "change"
			del "autocomplete" field name.
			Despues de esto recien podes asignar el valor al "autocomplete" field value, ya que sino la lista de este ultimo no queda cargada a tiempo y el valor no queda asignado en el combo.
		*/
		this.frm.autocomplete_custom_change_callback = function() {
			// field value - autocomplete
			let $field_value = $("#out_form_process_batches_filters_field_value");
			self.frm.autocomplete_set_value($field_value, value);
			window.setTimeout(function() {
				self.frm.autocomplete_custom_change_callback = $.noop;
			});
		};
		// field name - autocomplete
		let $field_name = $("#out_form_process_batches_filters_field_name");
		this.frm.autocomplete_set_value($field_name, field);

		$logical_operator.focus();
	};

	form_outbound_engine_processes_batches.prototype.__get_field_id_by_desc = function(field_description)
	{
		let info = {
			id: null,
			is_custom_field: null
		};
		let field = this.cached_fields_by_desc[field_description];
		if (field !== undefined) {
			info.is_custom_field = false;
			info.id = field.field;
			info.type = field.type;
		}
		else {
			info.is_custom_field = true;
			info.id = field_description;
			info.type = null;
		}
		return info;
	};

	form_outbound_engine_processes_batches.prototype.__validate_expression = function()
	{
		const self = this;

		let response = {
			success: true,
			message: null
		};

		let expression = "";
		let query = {};
		query.values = [];
		query.lines = [];

		let totalLeft = 0;
		let totalRight = 0;

		let filter_lines = this.form_paginator_filters.get_items();

		const get_field_value = function(value, field = {type: "keyword"}) {
			let field_type = (field.type || "").toLowerCase();
			if (field_type === "keyword" || field_type === "text" || field_type === "date" || field_type === "datetime") {
				return `'${value}'`;
			}
			return value;
		};

		// TODO: Reserved Words.
		$.each(filter_lines, function(i, filter_line)
		{
			let logicalOp = filter_line.logicalOp;
			let leftParenth = filter_line.leftParenth;
			let fieldId = filter_line.field;
			let conditionOp = filter_line.conditionOp;
			let value = filter_line.value;
			let rightParenth = filter_line.rightParenth;

			if (logicalOp.length > 0 && i === 0) {
				response.success = false;
				response.message = "<%=_T('The first condition line cannot start with a logical operator.')%>";
				return false; // break
			}

			let missing_data = "";
			if (logicalOp.length === 0 && i > 0) {
				missing_data = "<%=_T('logical operator.')%>";
				return false; // break
			}
			if (fieldId.length === 0) {
				missing_data = "<%=_T('matching field.')%>";
				return false; // break
			}
			if (conditionOp.length === 0) {
				missing_data = "<%=_T('condition operator.')%>";
				return false; // break
			}
			if (missing_data.length) {
				response.success = false;
				response.message = FORMAT("<%=_T('Please review condition line {0}, you must enter {1}.')%>", i + 1, missing_data);
				return false; // break
			}

			totalLeft += parseInt(leftParenth.length, 10);
			totalRight += parseInt(rightParenth.length, 10);

			let field = self.cached_fields_by_field[fieldId];
			// TODO: validar si esta validacion tiene que existir ???
			let line = {
				logicalOp   : logicalOp,
				leftParenth : leftParenth,
				field       : fieldId,
				conditionOp : conditionOp,
				value       : value,
				rightParenth: rightParenth
			};
			query.lines.push(line);
			query.values.push(value);
			let field_value =  get_field_value(value, field);
			let field_name = fieldId;
			expression += logicalOp + " " + leftParenth + " " + field_name + " " + conditionOp + " " + field_value + " " + rightParenth;
		});

		if (!response.success) {
			console.error("OE Batches: validate expression error: " + JSON.stringify(response));
			return response;
		}
		if (totalLeft !== totalRight) {
			response.success = false;
			response.message = "<%=_T('Left and right parenthesis do not match.')%>";
			console.error("OE Batches: validate expression error: " + JSON.stringify(response));
			return response;
		}

		// valido la setencia SQL
		let sqlSentence = `SELECT * FROM TBL ${expression ? `WHERE ${expression}` : ``}`;
		query.sqlSentence = sqlSentence;
		let sqlParsed;
		try {
			sqlParsed = sqlParser.parse(query.sqlSentence);
			query.sqlParsed = {
				value: {
					where: sqlParsed.value.where
				}
			};
			response.success = true;
		} catch (error) {
			const translateTokenErr = function(token) {
				const defaultMsg = "<%=_T('unrecognized')%>";
				if (!token) {
					return defaultMsg;
				}
				const translated = {
					//EOF    : "<%=_T('end of file')%>",
					INVALID: "<%=_T('invalid')%>"
				};
				return translated[token] || defaultMsg;
			};
			const makeMsgErr = function() {
				let msg = "";
				let hash = error ? error.hash : null;
				if (hash) {
					msg = FORMAT("<%=_T('type: {0}, value: {1}.')%>", translateTokenErr(hash.token), hash.text);
				}
				return msg;
			};
			response.success = false;
			response.message = FORMAT("<%=_T('Error parsing filter. {0}')%>", makeMsgErr());
			console.error("OE Batches: validate expression error: SQL Parser Error: " + error.message);
		}

		if (!response.success) {
			return response;
		}

		response.success = true;
		response.query = query;
		return response;
	};

	form_outbound_engine_processes_batches.prototype.is_ok_contact_query_result = function()
	{
		let result = {success: false, codeErr: "ERROR RETRIEVING CONTACTS", message: "<%=_T('There are no contacts.')%>"};
		if (!this.contact_query_result || (this.contact_query_result.contacts || []).length === 0) {
			return result;
		}
		const limitRowsInfo = {};
		// is ok
		result.success = true;
		result.message = "IS OK";
		result.limitRowsInfo = limitRowsInfo;
		delete result.codeErr;
		return result;
	};

	form_outbound_engine_processes_batches.prototype.__load_contacts_from_query = function(callback = $.noop)
	{
		let contacts = [];
		if (this.contact_query_result) {
			contacts = this.contact_query_result.contacts || contacts;
		}
		callback(true, contacts);
	};

	form_outbound_engine_processes_batches.prototype.__on_executed_query_contacts = function(success, callback = $.noop)
	{
		const self = this;

		if (!success) {
			// TODO: Error
			this.frm.hide_waiting();
			callback(false);
			return;
		}

		let query_result = this.is_ok_contact_query_result();
		if (!query_result.success) {
			let err = query_result;
			this.frm.hide_waiting();
			this.__show_ctrl_err(query_result);
			callback(false, err);
			return;
		}

		this.__load_contacts_from_query(function(is_ok, contacts) {
			if (is_ok) {
				self.form_paginator_contacts.initialize(function() {
						self.frm.hide_waiting();
						callback(true);
					},
					contacts
				);
			}
			else {
				self.frm.hide_waiting();
				callback(false);
			}
		});
	};

	form_outbound_engine_processes_batches.prototype.__execute_query_contacts = function()
	{
		const self = this;

		this.hide_all_errors();
		this.__disableSummaryTab(true);
		//
		const $source = $("#out_form_process_batches_data_source");
		let source = $source.val();
		let validation_result = inConcert.Utils.validate(source, "required");
		let err;
		if ( !validation_result.success ) {
			err = validation_result;
			err.message = "<%=_T('Data Source is required.')%>";
			err.$ctrl = $source;
			this.__show_ctrl_err(err);
			return;
		}

		let response = this.__validate_expression();
		if (!response.success) {
			err = response;
			err.$ctrl = $("#out_form_process_batches_filters_list"); // el header de la lista de filtros
			this.__show_ctrl_err(err);
			return;
		}

		let query = response.query;
		let process = this.get_entity_instance();
		query.processId = process.id;
		query.excludeContacted = $("#out_form_process_batches_filters_exclude_already").prop("checked");
		query.rows_per_page = this.server_side_contacts_rows_per_page;
		query.source = source;

		if ($("#out_form_process_batches_filters_starting_on").prop("checked")) {
			const $contacted_date = $("#out_form_process_batches_filters_contacted_date");
			const contacted_date = $contacted_date.val();
			const validation_result = inConcert.Utils.validate(contacted_date, "required");
			if (!validation_result.success) {
				const err = validation_result;
				err.message = "<%=_T('Start date for excluded contacts is required.')%>";
				err.$ctrl = $contacted_date;
				const foucs = false;
				this.__show_ctrl_err(err, foucs);
				return;
			}
			query.contactedDate = contacted_date;
		}

		this.frm.show_waiting("<%=_T('Please wait, Retrieving Contacts....')%>");

		this.m_is_ok_executed_query = false;
		const outbound_engine_api = inConcert.app.getOutboundEngineAPI();
		let info = {
			query: query
		};
		this.m_current_query = info;
		outbound_engine_api.processRunBatchContactsQuery(info,
			function(success, query_result) {
				if (success) {
					// OK
					self.contact_query_result = query_result;
					self.__execute_summary_contacts(info,
						function(_) {
							self.__on_executed_query_contacts(true, function(success/*, response*/) {
								if (success) {
									self.m_is_ok_executed_query = true;
									self.__disableSummaryTab(false);
									return;
								}
								self.contact_query_result = null;
								self.__disableSummaryTab(true);
							});
						}
					);
					return;
				}
				// ERROR
				self.contact_query_result = null;
				self.__on_executed_query_contacts(false, function(/*success, response*/) {
					self.__disableSummaryTab(true);
				});
			}
		);
	};

	form_outbound_engine_processes_batches.prototype.__update_summary = function(success, values, query)
	{
		if (success) {
			this.summary_info_datasource_detail.set_values(query, values);
			this.summary_info_actions_detail.set_values(query, values);
			return;
		}
		this.summary_info_datasource_detail.reset_values();
		this.summary_info_actions_detail.reset_values();
	};

	form_outbound_engine_processes_batches.prototype.__execute_summary_contacts = function(info, callback = $.noop)
	{
		const self = this;
		this.frm.show_waiting("<%=_T('Please wait, Retrieving Summary Contacts....')%>");
		const outbound_engine_api = inConcert.app.getOutboundEngineAPI();
		outbound_engine_api.processRunBatchContactsSummary(info,
			function(success, result) {
				if (success) {
					// OK
					self.__update_summary(true, result.summary, info.query);
					callback(true);
					return;
				}
				// ERROR
				// TODO: HACER ALGO
				self.__update_summary(false);
				callback(false);
			}
		);
	};

	form_outbound_engine_processes_batches.prototype.__clear_filter = function()
	{
		window.alert("TODO: IMPLEMENT-> form_outbound_engine_processes_batches.prototype.__clear_filter");
	};

	form_outbound_engine_processes_batches.prototype.__validate_filter = function(filter_id)
	{
		this.hide_all_errors();

		let response = {
			success: true,
			message: null
		};

		let validation_result = inConcert.Utils.validate(filter_id, "required");
		if ( !validation_result.success ) {
			response.success = false;
			response.message = "<%=_T('Filter Name is required.')%>";
			return response;
		}

		validation_result = this.__validate_expression();
		if (!validation_result.success) {
			return validation_result;
		}

		let filter_lines = validation_result.query.lines;
		if (filter_lines.length === 0) {
			response.success = false;
			response.message = "<%=_T('Filter conditions are required.')%>";
			return response;
		}

		let contacted_date;
		const exclude_contacted = $("#out_form_process_batches_filters_exclude_already").prop("checked");
		if ($("#out_form_process_batches_filters_starting_on").prop("checked")) {
			contacted_date = $("#out_form_process_batches_filters_contacted_date").val();
		}

		response.success = true;
		response.filter = {
			id              : filter_id,
			query           : filter_lines,
			excludeContacted: exclude_contacted,
			contactedDate   : contacted_date
		};

		return response;
	};

	form_outbound_engine_processes_batches.prototype.__save_filter = function(filter_id, callback = $.noop)
	{
		const self = this;

		const validation_result = this.__validate_filter(filter_id);

		if (!validation_result.success) {
			callback(false);
			this.__show_ctrl_err(validation_result);
			return;
		}

		this.frm.show_waiting(FORMAT("<%=_T('Please wait, Saving {0} Filter')%>", filter_id));

		const outbound_engine_api = inConcert.app.getOutboundEngineAPI();
		outbound_engine_api.processSaveFilter(
			validation_result.filter,
			function(success, result) {
				// Este timeout es solo visual para darle feedback.
				// Se agrega para poder ver el waiting un momento, sino es muy rapido y hace un parpadeo loco.
				window.setTimeout(function() {
					let msg, type;
					if (success) {
						const $filter = $("#out_form_process_batches_filters");
						if (result.action === "CREATED FILTER") {
							self.frm.combo_add_value($filter, filter_id, filter_id, true, undefined, validation_result.filter);
							msg = "<%=_T('Successfully Saved {0} Filter.')%>";
						}
						else {
							self.frm.combo_update_value($filter, filter_id, filter_id, filter_id, undefined, validation_result.filter);
							msg = "<%=_T('Successfully Updated {0} Filter.')%>";
						}
						type = "Info";
						self.hide_filter_save_actions();
						//self.__disableSummaryTab(true);
					}
					else {
						msg = "<%=_T('Error Saving {0} Filter.')%>";
						type = "Error";
					}
					self.frm.hide_waiting();
					self.frm.show_status_message(FORMAT(msg, filter_id), type, 5000);
					callback(success);
				}, 500);
			}
		);
	};

	form_outbound_engine_processes_batches.prototype.__restore_filter_values = function()
	{
		this.__change_filter();
	};

	form_outbound_engine_processes_batches.prototype.__open_save_filter_popup = function(btn_parent)
	{
		const self = this;

		if (this.filter_popup) {
			this.filter_popup.close();
			this.filter_popup = null;
		}

		const $filter = $("#out_form_process_batches_filters");
		let filter_id = $filter.val();

		this.filter_popup = new SaveFilterPopup({current_filter: filter_id});
		this.filter_popup.show({
			parentNode: $(btn_parent),
			owner_object: this,
			callbacks: {
				save: function(filter_id, callback = $.noop) {
					self.__save_filter(filter_id, callback);
				}
			}
		});
	};

	form_outbound_engine_processes_batches.prototype.__new_filter = function()
	{
		$("#out_form_process_batches_filters").val("").trigger("change");
		$("#out_form_process_batches_filters_new_condition").trigger("click");
		$("#out_form_process_batches_filters_field_name").focus();
	};

	form_outbound_engine_processes_batches.prototype.__delete_filter = function()
	{
		const self = this;

		const $filter = $("#out_form_process_batches_filters");
		let filter_id = $filter.val();

		if (!filter_id) {
			return;
		}

		const remove = function()
		{
			self.frm.show_waiting(FORMAT("<%=_T('Please wait, Deleting {0} Filter')%>", filter_id));

			const outbound_engine_api = inConcert.app.getOutboundEngineAPI();
			outbound_engine_api.processDeleteFilter({
					filterId: filter_id
				},
				function(success) {
					// Este timeout es solo visual para darle feedback.
					// Se agrega para poder ver el waiting un momento, sino es muy rapido y hace un parpadeo loco.
					window.setTimeout(function() {
						let msg, type;
						if (success) {
							msg = "<%=_T('Successfully Deleted {0} Filter.')%>";
							type = "Info";
							self.frm.combo_remove_value($filter, filter_id);
						}
						else {
							msg = "<%=_T('Error Deleting {0} Filter.')%>";
							type = "Error";
						}
						self.frm.hide_waiting();
						self.frm.show_status_message(FORMAT(msg, filter_id), type, 5000);
					}, 500);
				}
			);
		};

		$.inconcertPopup.Show(
			"<%=_T('Confirm')%>",
			FORMAT("<%=_T('Do you want to delete Filter {0} ?')%>", filter_id),
			$.inconcertPopup.ButtonSets.BS_YESNO,
			function(response) {
				if (response.toLowerCase() !== "yes") {
					return;
				}
				remove();
			},
			undefined,
			{
				popup_id       : "conf_inconcertPopup",
				container_class: "confirmationPopUp",
				overlay_class  : "confirmationOverlay"
			}
		);
	};

	form_outbound_engine_processes_batches.prototype.__validate_action_to_execute = function()
	{
		const self = this;
		this.hide_all_errors();

		let response = {
			success: true,
			message: null,
			$ctrl  : null
		};

		const showErrorInDataSourceTab = function(response) {
			self.main_tabs.switch_tab("datasource");
			return response;
		};
		const showErrorInActionsTab = function(response) {
			self.main_tabs.switch_tab("actions");
			return response;
		};

		const $actions = $("#out_form_process_batches_actions");
		let action = $actions.val();
		let validation_result = inConcert.Utils.validate(action, "required");
		if ( !validation_result.success ) {
			response.success = false;
			response.message = "<%=_T('Action is required.')%>";
			response.$ctrl = $actions;
			return showErrorInActionsTab(response);
		}

		let query_result = this.is_ok_contact_query_result();
		if (!query_result.success) {
			response.success = false;
			response.message = query_result.message;
			response.$ctrl = null;
			return showErrorInActionsTab(response);
		}

		let process = this.get_entity_instance();
		response.action = {
			processId        : process.id,
			configuration    : {},
			query            : {},
			excludeDuplicates: $("#out_form_process_batches_contacts_duplicated_exclude").prop("checked")
		};

		if ($("#out_form_process_batches_filters_exclude_already").prop("checked")) {
			response.action.excludeContacted = true;
			if ($("#out_form_process_batches_filters_starting_on").prop("checked")) {
				response.action.contactedDate = $("#out_form_process_batches_filters_contacted_date").val();
			}
		}

		const validate_priority = function($ctrl, range) {
			let value = $ctrl.val();
			let result = inConcert.Utils.validate(value, "required");
			if ( !result.success ) {
				result.message = "<%=_T('Priority is required.')%>";
				return result;
			}
			result = inConcert.Utils.validate(value, "digits");
			if ( !result.success ) {
				result.message = "<%=_T('Priority must be a number.')%>";
				return result;
			}
			result = inConcert.Utils.validate(value, "range", range);
			if ( !result.success ) {
				result.message = FORMAT("<%=_T('Contact base priority must be a number between {0} and {1}')%>", range.between.from, range.between.to);
				return result;
			}
			return result;
		};

		const $source = $("#out_form_process_batches_data_source");
		let source = $source.val();
		if (source === "contact_query") {
			const $create_batch_id = $("#out_form_process_batches_action_create_batch_id");
			const $create_batch_priority = $("#out_form_process_batches_action_create_batch_priority");
			const $create_batch_start_date = $("#out_form_process_batches_action_create_batch_start_date");
			const $create_batch_end_date = $("#out_form_process_batches_action_create_batch_end_date");
			const $create_batch_contact_base_priority = $("#out_form_process_batches_action_create_batch_contact_base_priority");
			const $create_batch_percentage = $("#out_form_process_batches_action_create_batch_percentage");

			response.action.configuration.batchName = $create_batch_id.val();
			response.action.configuration.batchPriority =  $create_batch_priority.val();
			response.action.configuration.startDate = $create_batch_start_date.val();
			response.action.configuration.endDate = $create_batch_end_date.val();
			response.action.configuration.basePriority = $create_batch_contact_base_priority.val();
			response.action.configuration.percentage = $create_batch_percentage.val();

			validation_result = inConcert.Utils.validate(response.action.configuration.batchName, "required");
			if ( !validation_result.success ) {
				response.success = false;
				response.message = "<%=_T('Batch Name is required.')%>";
				response.$ctrl = $create_batch_id;
				return showErrorInActionsTab(response);
			}

			validation_result = inConcert.Utils.validate(response.action.configuration.batchName, "id");
			if (!validation_result.success) {
				response.success = false;
				response.message = "<%=_T('Only letters, numbers, dashes and dots are allowed in the Batch Name.')%>";
				response.$ctrl = $create_batch_id;
				return showErrorInActionsTab(response);
			}

			validation_result = validate_priority($create_batch_priority, { between: {from: 1, to: 100} });
			if ( !validation_result.success ) {
				response.success = false;
				response.message = validation_result.message;
				response.$ctrl = $create_batch_priority;
				return showErrorInActionsTab(response);
			}

			validation_result = validate_priority($create_batch_contact_base_priority, { between: {from: 1, to: 1000000} });
			if ( !validation_result.success ) {
				response.success = false;
				response.message = validation_result.message;
				response.$ctrl = $create_batch_contact_base_priority;
				return showErrorInActionsTab(response);
			}

			this.frm.datepicker_validate_date_and_range($create_batch_start_date, validation_result);
			if (!validation_result.success) {
				response.success = false;
				response.message = validation_result.message;
				response.$ctrl = $create_batch_start_date;
				return showErrorInActionsTab(response);
			}
		}
		else {
			response.action.id = action;

			switch(action) {
				case "activatecontacts":
					if ($("#out_form_process_batches_action_activate_schedule").prop("checked")) {
						// la fecha
						const $action_activate_schedule_date = $("#out_form_process_batches_action_activate_schedule_date");
						let schedule_date = $action_activate_schedule_date.val();
						validation_result = inConcert.Utils.validate(schedule_date, "required");
						if (!validation_result.success) {
							response.success = false;
							response.message = "<%=_T('Activate Date is required.')%>";
							response.$ctrl = $action_activate_schedule_date;
							return showErrorInActionsTab(response);
						}
						response.action.configuration.scheduleDate = schedule_date;
						// la hora
						const $action_activate_schedule_hour = $("#out_form_process_batches_action_activate_schedule_hour");
						let schedule_hour = $action_activate_schedule_hour.val();
						validation_result = inConcert.Utils.validate(schedule_hour, "required");
						if (!validation_result.success) {
							response.success = false;
							response.message = "<%=_T('Activate Hour is required.')%>";
							response.$ctrl = $action_activate_schedule_hour;
							return showErrorInActionsTab(response);
						}
						validation_result = inConcert.Utils.validate(schedule_hour, "hour");
						if (!validation_result.success) {
							if (validation_result.message === "HOUR_ERROR") {
								response.message = "<%=_T('Please enter activate hour between 0 and 23.')%>";
							}
							else if (validation_result.message === "MINUTES_ERROR") {
								response.message = "<%=_T('Please enter activate minutes between 0 and 59.')%>";
							}
							response.success = false;
							response.$ctrl = $action_activate_schedule_hour;
							return showErrorInActionsTab(response);
						}
						response.action.configuration.scheduleHour = schedule_hour; // la hora debe ir sin segundos.
					}
					if ($("#out_form_process_batches_action_activate_assign").prop("checked")) {
						const $action_activate_assign_agent = $("#out_form_process_batches_action_activate_assign_agent");
						response.action.configuration.agent = $action_activate_assign_agent.val();
						validation_result = inConcert.Utils.validate(response.action.configuration.agent, "required");
						if ( !validation_result.success ) {
							response.success = false;
							response.message = "<%=_T('Agent is required.')%>";
							response.$ctrl = $action_activate_assign_agent;
							return showErrorInActionsTab(response);
						}
					}
					response.action.configuration.restartRetries = $("#out_form_process_batches_action_activate_reset_retries").prop("checked");

				break;

				case "changepriority":
					const $action_change_priority_new = $("#out_form_process_batches_action_change_priority_new");
					response.action.configuration.batchPriority = $action_change_priority_new.val();

					validation_result = validate_priority($action_change_priority_new, { between: {from: 1, to: 1000000} });
					if ( !validation_result.success ) {
						response.success = false;
						response.message = validation_result.message;
						response.$ctrl = $action_change_priority_new;
						return showErrorInActionsTab(response);
					}
				break;

				case "changeisprogressivetype":
					const $action_change_progressive_type = $("#out_form_process_batches_action_change_progressive_type");
					response.action.configuration.IsProgressiveType = $action_change_progressive_type.prop("checked");
				break;
			}
		}

		let query_response = this.__validate_expression();
		if (!query_response.success) {
			response.success = false;
			response.message = "<%=_T('Error in filter expression.')%>";
			response.$ctrl = $source;
			return showErrorInDataSourceTab(response);
		}

		response.action.query = query_response.query;

		return response;
	};

	form_outbound_engine_processes_batches.prototype.__run_action = function()
	{
		const self = this;
		let response = this.__validate_action_to_execute();

		if (!response.success) {
			this.__show_ctrl_err(response);
			return;
		}

		const callback = function(success, response) {
			self.frm.hide_waiting();
			if (success) {
				self.frm.show_status_message("<%=_T('Action completed successfully!')%>", "Info", 5000);
				// Dejo que se visualice un instante el mensaje en esta pantalla, y regreso a la pantalla de procesos.
				window.setTimeout(function() {
					let current_process = self.frm.get_entity_instance();
					if (current_process) {
						current_process.batches = response.batches;
						self.frm.set_entity_instance(current_process);
					}
					self.frm.form_paginator_batches.initialize();
					self.__show_process_section();
				}, 500);
				return;
			}
			const err = response;
			let errMsg = "<%=_T('Unable to execute the batch operation, please contact your administrator.')%>";
			if (err.subType === "ADMIN_ACTIONS_RUNNING") {
				errMsg = "<%=_T('Unable to execute the batch action. Process has admin actions running.')%>";
			}
			else if (err.subType === "NETWORK_ERROR") {
				errMsg = "<%=_T('Unable to execute the batch action. Unknown network error.')%>";
			}
			else {
				if (err.type === "UNABLE TO CREATE BATCH") {
					if (err.subType === "BATCH_ALREADY_EXISTS") {
						errMsg = "<%=_T('Unable to create batch. Batch already exists.')%>";
					}
					else if (err.subType === "PERCENTAGE_INVALID") {
						errMsg = "<%=_T('The total percentage of active batches in the process cannot exceed 100%.')%>";
					}
					else if (err.subType === "DATE_INVALID") {
						errMsg = "<%=_T('Unable to create batch. Batch dates are invalid.')%>";
					}
					else if (err.subType === "ACTIVE_IMPORT") {
						errMsg = "<%=_T('Filtered import is already running.')%>";
					}
				}
			}
			self.frm.show_status_message(errMsg, "Error", 5000);
		};

		const outbound_engine_api = inConcert.app.getOutboundEngineAPI();
		let source = $("#out_form_process_batches_data_source").val();
		this.frm.show_waiting( "<%=_T('Please wait, Executing Action....')%>" );
		response.action.source = source;

		if (source === "contact_query") {
			outbound_engine_api.processCreateBatch(
				null,
				response.action,
				function(success, result) {
					// pequeno waiting para dar feedback
					window.setTimeout(function() {
						callback(success, result);
					}, 500);
				}
			);
		}
		else if (source === "batch_query") {
			let api_methods = {
				"pausecontactsquery"     : "processPauseBatch",
				"cancelcontacts"         : "processCancelBatch",
				"removecontacts"         : "processRemoveBatch",
				"resumecontactsquery"    : "processResumeBatch",
				"changepriority"         : "processChangePriorityContactsBatch",
				"activatecontacts"       : "processRecyleContactsBatch",
				"changeisprogressivetype": "processeSetEngineTypeContactsBatch"
			};
			let method_name = api_methods[response.action.id];
			if (!method_name) {
				throw("Unrecognized Api method: " + method_name);
			}
			outbound_engine_api[method_name](
				response.action,
				function(success, result) {
					// pequeno waiting para dar feedback
					window.setTimeout(function() {
						callback(success, result);
					}, 500);
				}
			);
		}
		else {
			throw("form_outbound_engine_processes_batches.prototype.__run_action -> Unrecognized '" + source + "'");
		}
	};

	form_outbound_engine_processes_batches.prototype.__show_process_section = function()
	{
		const self = this;
		this.dispose();
		this.m_is_ok_executed_query = false;
		this.frm.show_process_section(function() {
			self.form_paginator_filters.hide_popup();
		});
	};

	form_outbound_engine_processes_batches.prototype.set_events = function()
	{
		const self = this;

		this.form_paginator_filters.set_events();
		this.form_paginator_contacts.set_events();

		const $source = $("#out_form_process_batches_data_source");
		$source
			.off("change")
			.on("change", function() {
				let source = $(this).val();
				self.__change_source(source);
			});

		const $filters = $("#out_form_process_batches_filters");
		$filters
			.off("change")
			.on("change", function() {
				self.__change_filter();
			});

		const $actions = $("#out_form_process_batches_actions");
		$actions
			.off("change")
			.on("change", function() {
				let action = $(this).val();
				self.__change_action(action);
			});

		const $exclude_already = $("#out_form_process_batches_filters_exclude_already");
		$exclude_already
			.off("change")
			.on("change", function() {
				self.__change_exclude_already();
				self.show_filter_save_actions();
			});

		const $starting_on = $("#out_form_process_batches_filters_starting_on");
		$starting_on
			.off("change")
			.on("change", function() {
				self.__change_starting_on_date();
				self.show_filter_save_actions();
			});

		const $retrieve = $("#out_form_process_batches_filters_retrieve");
		$retrieve
			.off("click")
			.on("click", function() {
				self.__execute_query_contacts();
			});

		const $go_to_summary_and_actions = $("#out_form_process_batches_filters_go_to_summary_and_actions");
		$go_to_summary_and_actions
			.off("click")
			.on("click", function() {
				self.main_tabs.switch_tab("actions");
			});

		const $clear = $("#out_form_process_batches_filters_clear");
		$clear
			.off("click")
			.on("click", function() {
				self.__clear_filter();
			});

		const $save = $("#out_form_process_batches_filters_save");
		$save
			.off("click")
			.on("click", function() {
				self.__open_save_filter_popup(this);
			});

		const $restore = $("#out_form_process_batches_filters_restore");
		$restore
			.off("click")
			.on("click", function() {
				self.__restore_filter_values();
			});

		const $new_filter = $("#out_form_process_batches_filters_new");
		$new_filter
			.off("click")
			.on("click", function() {
				self.__new_filter();
			});

		const $delete = $("#out_form_process_batches_filters_delete");
		$delete
			.off("click")
			.on("click", function() {
				self.__delete_filter();
			});

		const $action_execute = $("#out_form_process_batches_action_execute");
		$action_execute
			.off("click")
			.on("click", function() {
				self.__run_action();
			});

		this.frm.$get_dom_element_by_id("form_back_btn_container")
			.off("click")
			.on("click", function() {
				self.__show_process_section();
				$(this).hide();
			});

		const $action_activate_schedule = $("#out_form_process_batches_action_activate_schedule");
		$action_activate_schedule
			.off("change")
			.on("change", function() {
				const $schedule_date = $("#out_form_process_batches_action_activate_schedule_date");
				const $schedule_hour = $("#out_form_process_batches_action_activate_schedule_hour");
				let enabled = $(this).prop("checked");
				if (enabled) {
					self.frm.disable_control($schedule_date, false, true);
					self.frm.disable_control($schedule_hour, false, true);
				}
				else {
					self.frm.disable_control($schedule_date, true);
					self.frm.disable_control($schedule_hour, true);
				}
			});

		const $action_activate_assign = $("#out_form_process_batches_action_activate_assign");
		$action_activate_assign
			.off("change")
			.on("change", function() {
				const $assign_agent = $("#out_form_process_batches_action_activate_assign_agent");
				let enabled = $(this).prop("checked");
				if (enabled) {
					self.frm.disable_control($assign_agent, false, true);
				}
				else {
					self.frm.disable_control($assign_agent, true);
				}
			});
	};

	form_outbound_engine_processes_batches.prototype.get_summary_statuses_def = function()
	{
		if (this.summary_info_actions_detail) {
			return this.summary_info_actions_detail.get_statuses_def();
		}
		return {};
	};
}());
