/* jshint forin:true, noarg:true, jquery:true, noempty:true, eqeqeq:true, bitwise:true,
strict:true, undef:true, unused:vars, curly:true, browser:true, indent:false, maxerr:50, quotmark:double, esversion: 11 */

/* global inConcert */

if (!this.inConcert) {
	this.inConcert = {};
}

(function () {
	//"use strict";

	const _T = inConcert.i18n.getString;
	const FORMAT = inConcert.Utils.format;

	//---------------------------------------------------------------------
	// form process rules class
	function form_outbound_engine_processes_rules(params)
	{
		this.frm = params.frm;
		this.edited_rule = null;
		this.is_new_action = false;
		this.is_new_destination = false;
		this.current_action = null;
		this.current_destination = null;

		this.form_paginator_destinations = null;
		this.form_paginator_actions = null;

		this.m_channels = null;

		this.period_list = {
			1: {id: "1", name: "<%=_T('Seconds')%>"},
			2: {id: "2", name: "<%=_T('Minutes')%>"},
			3: {id: "3", name: "<%=_T('Days')%>"   }
		};

		this.priority_type = {
			"NUMBER"    : {id: "NUMBER"    , name: "<%=_T('Number')%>" },
			"PERCENTAGE": {id: "PERCENTAGE", name: "<%=_T('Percent')%>"}
		};

		this.m_invalidate_address_scope = {
			"BATCH" : {id: "BATCH" , name: "<%=_T('Batch')%>" },
			"GLOBAL": {id: "GLOBAL", name: "<%=_T('Global')%>"}
		};

		this.m_invalidate_address_channel = {
			"CURRENT" : {id: "CURRENT" , name: "<%=_T('Current')%>"},
			"ALL"     : {id: "ALL"     , name: "<%=_T('All')%>"    }
		};

		this.builtin_destinations = {
			ANY_CHANNEL     : "<%=_T('ANY_CHANNEL')%>",
			ANY             : "<%=_T('ANY_DESTINATION')%>",
			NEXT            : "<%=_T('KEEP_TRYING')%>",
			NEXT_ADDRESS    : "<%=_T('NEXT_ON_LIST')%>",
			SAME_ADDRESS    : "<%=_T('SAME_ADDRESS')%>",
			SAME            : "<%=_T('SAME_DESTINATION')%>",
			SAME_CHANNEL    : "<%=_T('SAME_CHANNEL')%>",
			NEXT_CHANNEL    : "<%=_T('NEXT_CHANNEL')%>",
		};

		// en el combo: 3 "", 1 "PROGRESIVE", 2 "PREDICTIVE"
		this.change_contact_types_list = {
			PROGRESIVE: {id: "PROGRESIVE", name: "<%=_T('Progressive')%>"},
			PREDICTIVE: {id: "PREDICTIVE", name: "<%=_T('Predictive')%> "}
		};

		this.m_system_actions = null;

		this.seconds_in_a_day = 24 * 60 * 60;

		// Instancia de la clase de los TABs
		this.main_tabs = new inConcert.conf_form_tab({
			parent        : this,
			frm           : this.frm,
			container_id  : "out_form_process_rules_tabs",
			must_intialize: false,
			tabs_list     : {
				scheduler: {
					id              : "scheduler",
					name            : "<%=_T('Schedule')%>",
					tab_container_id: "out_form_process_rules_tab_scheduler_container",
					selected        : true
				},
				destination: {
					id              : "destination",
					name            : "<%=_T('Destination')%>",
					tab_container_id: "out_form_process_rules_tab_destination_container"
				},
				actions: {
					id              : "actions",
					name            : "<%=_T('Actions')%>",
					tab_container_id: "out_form_process_rules_tab_actions_container"
				}
			}
		});

		this.__initialize();

		return true;
	}

	if (typeof inConcert.form_outbound_engine_processes_rules !== "function") {
		inConcert.form_outbound_engine_processes_rules = form_outbound_engine_processes_rules;
	}

	form_outbound_engine_processes_rules.prototype.__initialize = function()
	{
		this.__new_grids();
	};

	form_outbound_engine_processes_rules.prototype.set_channels = function(channels)
	{
		this.m_channels = channels;
	};

	form_outbound_engine_processes_rules.prototype.set_system_actions = function(system_actions)
	{
		this.m_system_actions = system_actions;
	};

	form_outbound_engine_processes_rules.prototype.get_parent_process_rules = function()
	{
		return this.frm.__get_rules();
	};

	form_outbound_engine_processes_rules.prototype.set = function(rule)
	{
		let caption_add_button;
		let rule_name = "";

		if (!$.isEmptyObject(rule || {})) {
			rule_name = rule.name || "";
			this.edited_rule = rule;
			caption_add_button = "<%=_T('Update Rule')%>";
		}
		else {
			this.edited_rule = null;
			caption_add_button = "<%=_T('Add Rule')%>";
		}
		$("#out_form_process_rules_add_update_rule_to_process").val(caption_add_button);

		this.form_paginator_destinations.initialize();
		this.form_paginator_actions.initialize();

		$("#out_form_process_rules_name").val(rule_name);
		$("#out_form_process_rules_desc").val(rule.description || "");

		this.__show_schedule_section(rule.schedule);
	};

	form_outbound_engine_processes_rules.prototype.__new_grids = function()
	{
		const self = this;

		this.form_paginator_destinations = new inConcert.conf_form_paginator({
			paginator_name: "OUTBOUND_RULES_DESTINATIONS",
			owner: this,
			frm: this.frm,
			row_id: "id",
			display_name: "kind",
			rows_per_page: 500,
			show_at_least: 499,
			sortable: true,
			without_paginator: true,
			loading_waiting_msg: "<%=_T('Please wait, loading Rules Destination ...')%>",
			ids: {
				grid                      : "out_form_process_rules_destinations_list",
				paginator                 : "out_form_process_rules_destinations_paginator",
				not_results_found         : "out_form_process_rules_destinations_not_results_found",
				new_item                  : "out_form_process_rules_destinations_new",
				container_new_btn         : "out_form_process_rules_destinations_list_container",
				//popup
				popup                     : "out_form_process_rules_destinations_popup",
				popup_msg                 : "out_form_process_rules_destinations_popup_message",
				popup_create              : "out_form_process_rules_destinations_popup_create",
				popup_create_and_continue : "out_form_process_rules_destinations_popup_create_and_continue",
				popup_title               : "out_form_process_rules_destinations_popup_title",
				popup_close               : "out_form_process_rules_destinations_popup_close"
			},
			strings: {
				not_results_found         : "<%=_T('No Rules Destinations found.')%>",
				can_remove                : "<%=_T('Do you want to delete Rule Destination: {0} ?')%>",
				title_new                 : "<%=_T('New Destination')%>",
				title_update              : "<%=_T('Update Destination')%>",
				button_create             : "<%=_T('Create')%>",
				button_create_and_continue: "<%=_T('Create & Continue')%>"
			},
			columns: [
				{id: "_number"    , name: "", type: "counter"},
				{id: "channel", name: "<%=_T('Channel')%>", get_value: function(item) {
					return self.get_grid_destination_value(item, "channel");
				}},
				{id: "kind", name: "<%=_T('Destination Name')%>", get_value: function(item) {
					return self.get_grid_destination_value(item, "kind");
				}},
				{id: "max_retries", name: "<%=_T('Max Retries Per Day')%>",
					get_value: function(item) {
						return self.get_grid_destination_value(item, "max_retries");
					}
				},
				{id: "_action", name: "",
					system_action: { edit: true, erase: true }
				}
			],
			callbacks: {
				save: function(callback, must_create_and_contiune) {
					self.add_or_update_destination(callback, must_create_and_contiune);
				},
				edit: function(destination) {
					self.on_edit_destination(destination);
				},
				load_items: function(page, callback) {
					//console.log("3 - grid load_items -> form_paginator_destinations");
					self.load_rules_destinations(page, callback);
				}
			}
		});

		this.form_paginator_actions = new inConcert.conf_form_paginator({
			paginator_name: "OUTBOUND_RULES_ACTIONS",
			owner: this,
			frm: this.frm,
			row_id: "id",
			display_name: "DisplayValue",
			rows_per_page: 500,
			show_at_least: 499,
			without_paginator: true,
			loading_waiting_msg: "<%=_T('Please wait, loading Rule Actions ...')%>",
			no_merge_row_data: true,
			ids: {
				grid                      : "out_form_process_rules_actions_list",
				paginator                 : "out_form_process_rules_actions_paginator",
				not_results_found         : "out_form_process_rules_actions_not_results_found",
				new_item                  : "out_form_process_rules_actions_new",
				container_new_btn         : "out_form_process_rules_actions_list_container",
				//popup
				popup                     : "out_form_process_rules_actions_popup",
				popup_msg                 : "out_form_process_rules_actions_popup_message",
				popup_create              : "out_form_process_rules_actions_popup_create",
				popup_create_and_continue : "out_form_process_rules_actions_popup_create_and_continue",
				popup_title               : "out_form_process_rules_actions_popup_title",
				popup_close               : "out_form_process_rules_actions_popup_close",
				// search
				search_builtin_panel      : "out_form_process_rules_actions_search_panel",
				search_container          : "out_form_process_rules_actions_search_container",
				search_text               : "out_form_process_rules_actions_search_text",
				search_reset              : "out_form_process_rules_actions_reset_text",
				search_apply              : "out_form_process_rules_actions_apply_text"
			},
			strings: {
				not_results_found         : "<%=_T('No Rule Actions found.')%>",
				can_remove                : "<%=_T('Do you want to delete Rule Action: {0} ?')%>",
				title_new                 : "<%=_T('New Action')%>",
				title_update              : "<%=_T('Update Action')%>",
				button_create             : "<%=_T('Create')%>",
				button_create_and_continue: "<%=_T('Create & Continue')%>"
			},
			columns: [
				{id: "_number"     , name: "", type: "counter"         },
				{id: "channel"     , name: "<%=_T('Channel')%>", type: "icon", image_type: "image_with_text", get_value: function(item) {
					return self.get_grid_actions_value(item, "channel");
				}},
				{id: "kind"        , name: "<%=_T('Destination')%>", type: "icon", image_type: "image_with_text", get_value: function(item) {
					return self.get_grid_actions_value(item, "kind");
				}},
				{id: "DisplayValue", name: "<%=_T('Current Actions')%>", sanitize: false},
				{id: "_action", name: "",
					system_action: { edit: true, erase: true }
				}
			],
			callbacks: {
				save: function(callback, must_create_and_contiune) {
					self.add_or_update_action(callback, must_create_and_contiune);
				},
				edit: function(action) {
					self.on_edit_action(action);
				},
				on_closed_popup: function() {
					self.on_closed_action_popup();
				},
				load_items: function(page, callback) {
					//console.log("4 - grid load_items -> form_paginator_actions");
					self.load_rules_actions(page, callback);
				}
			}
		});
	};

	form_outbound_engine_processes_rules.prototype.on_closed_action_popup = function()
	{
		this.is_new = null;
		this.current_item = null;
	};

	form_outbound_engine_processes_rules.prototype.__cleanup_destinations_popup_ctrls = function()
	{
		$("#out_form_process_rules_destinations_max_retries").val("");
		$("#out_form_process_rules_destinations_channel").val("").focus().trigger("change");
	};

	form_outbound_engine_processes_rules.prototype.__cleanup_actions_popup_ctrls = function()
	{
		$("#out_form_process_rules_actions_contacting_result").val("");
		$("#out_form_process_rules_action_next_channel").val();
		$("#out_form_process_rules_action_next_destination").val("");
		$("#out_form_process_rules_action_call_next_time").val("");
		$("#out_form_process_rules_action_call_next_period").val("");
		$("#out_form_process_rules_action_change_contact_priority").prop("checked", false);
		$("#out_form_process_rules_action_change_contact_priority_value").val("");
		$("#out_form_process_rules_action_change_contact_priority_type").val("");
		$("#out_form_process_rules_action_invalidte_address").prop("checked", false).trigger("change");
		$("#out_form_process_rules_action_invalidte_address_scope").val("");
		$("#out_form_process_rules_action_invalidte_address_channel").val("");
		$("#out_form_process_rules_action_affect_retries").prop("checked", false);
		$("#out_form_process_rules_actions").val("cancel").trigger("change");
		$("#out_form_process_rules_action_change_contact_type").val("");
		$("#out_form_process_rules_actions_return_result").val("");
		$("#out_form_process_rules_actions_channel").val("").trigger("change").focus();
		/*
		NO BORRAR !!!!
		(**) Por el momento en i6 NO se utiliza el ejecutar otros procesos, por lo que queda comentado
			Revisar en el HTML "frm_processes_content.html" que tabien se ha comentado.
		*/
		// $("#out_form_process_rules_action_execute_process").prop("checked", false);
		// $("#out_form_process_rules_action_process").val("");
		// $("#out_form_process_rules_action_arguments").val("");
	};

	/*
	*/
	form_outbound_engine_processes_rules.prototype.__make_display_last_destination_attr = function(action)
	{
		let last_destination = action.last_address.kind;
		if (last_destination === "") {
			last_destination = "ANY";
		}
		return last_destination;
	};

	form_outbound_engine_processes_rules.prototype.__get_original_last_destination_attr = function(action)
	{
		let last_destination = action.last_address.kind;
		if (last_destination === "ANY") {
			last_destination = "";
		}
		return last_destination;
	};

	form_outbound_engine_processes_rules.prototype.__make_display_next_destination_attr = function(action)
	{
		let next_destination = action.next_address.kind;
		if (next_destination === "") {
			next_destination = "NEXT";
		}
		return next_destination;
	};

	form_outbound_engine_processes_rules.prototype.__get_original_next_destination_attr = function(action)
	{
		let next_destination = action.next_address.kind;
		if (next_destination === "NEXT") {
			next_destination = "";
		}
		return next_destination;
	};

	form_outbound_engine_processes_rules.prototype.on_edit_destination = function(destination)
	{
		this.is_new_destination = destination ? false: true;
		this.current_destination = destination;
		this.__cleanup_destinations_popup_ctrls();

		const $channel = $("#out_form_process_rules_destinations_channel");
		const $kind = $("#out_form_process_rules_destinations_kind");
		const $max_retries = $("#out_form_process_rules_destinations_max_retries");

		if (!this.is_new_destination) {
			this.frm.disable_control($channel, true);
			this.frm.disable_control($kind, true);

			$channel.val(destination.channel).trigger("change");
			$kind.val(destination.kind);
			$max_retries.val(destination.max_retries).focus();
		}
		else {
			this.frm.disable_control($channel, false, true);
			this.frm.disable_control($kind, false, true);
			$max_retries.focus();
		}
	};

	form_outbound_engine_processes_rules.prototype.on_edit_action = function(action)
	{
		this.is_new_action = action ? false: true;
		this.current_action = action;
		this.__cleanup_actions_popup_ctrls();

		const $channel =  $("#out_form_process_rules_actions_channel");
		const $return_result = $("#out_form_process_rules_actions_return_result");
		const $contacting_result = $("#out_form_process_rules_actions_contacting_result");
		const $actions = $("#out_form_process_rules_actions");
		const $next_actions_channel = $("#out_form_process_rules_action_next_channel");
		const $next_destination = $("#out_form_process_rules_action_next_destination");
		const $next_time = $("#out_form_process_rules_action_call_next_time");
		const $next_period = $("#out_form_process_rules_action_call_next_period");
		const $contact_priority = $("#out_form_process_rules_action_change_contact_priority");
		const $contact_priority_value = $("#out_form_process_rules_action_change_contact_priority_value");
		const $contact_priority_type = $("#out_form_process_rules_action_change_contact_priority_type");
		const $invalidte_address = $("#out_form_process_rules_action_invalidte_address");
		const $invalidte_address_scope = $("#out_form_process_rules_action_invalidte_address_scope");
		const $invalidte_address_channel = $("#out_form_process_rules_action_invalidte_address_channel");
		const $affect_retries = $("#out_form_process_rules_action_affect_retries");
		const $change_contact_type = $("#out_form_process_rules_action_change_contact_type");
		/*
		NO BORRAR !!!!
		(**) Por el momento en i6 NO se utiliza el ejecutar otros procesos, por lo que queda comentado
			Revisar en el HTML "frm_processes_content.html" que tabien se ha comentado.
		*/
		// const $execute_process = $("#out_form_process_rules_action_execute_process");
		// const $action_process = $("#out_form_process_rules_action_process");
		// const $action_arguments = $("#out_form_process_rules_action_arguments");

		if (!this.is_new_action) {
			this.frm.disable_control($channel, true);
			this.frm.disable_control($return_result, true);
			this.frm.disable_control($contacting_result, true);

			let channel = action.last_address ? action.last_address.channel : action.channel;
			$channel.val(channel).trigger("change");
			$return_result.val(action.result);
			$contacting_result.val(this.__make_display_last_destination_attr(action));

			if (action.cancel) {
				$actions.val("cancel").trigger("change");
			}
			else if (parseInt(action.schedule_seconds, 10) === 0) {
				$actions.val("postpone").trigger("change");
			}
			else {
				if (action.next_address) {
					$next_actions_channel.val(action.next_address.channel).trigger("change");
					let kind = action.next_address.kind || "";
					if (kind === "SAME" && action.next_address.same_address) {
						kind = "SAME_ADDRESS";
					}
					$next_destination.val(kind); // this.__make_display_next_destination_attr(action));
				}
				$actions.val("next").trigger("change");
				let time = parseInt(action.schedule_seconds, 10);
				let period = 1;
				if (time >= this.seconds_in_a_day && (time % this.seconds_in_a_day === 0)) {
					period = 3;
					time = (((time / 60) /60) / 24);
				}
				else if (time >= 60 && (time % 60 === 0)) {
					//segundos multiplos de 60 va en minutos
					period = 2;
					time = time / 60;
				}
				$next_time.val(time);
				$next_period.val(period);
			}

			if (action.change_priority && action.change_priority.type) {
				$contact_priority.prop("checked", true).trigger("change");
				$contact_priority_value.val(action.change_priority.value);
				$contact_priority_type.val(action.change_priority.type); // TODO: Revisar por que el + 1
			}
			else {
				$contact_priority.prop("checked", false).trigger("change");
			}

			if (action.disable_address) {
				$invalidte_address.prop("checked", true).trigger("change");
				$invalidte_address_scope.val(action.disable_address.scope);
				$invalidte_address_channel.val(action.disable_address.channel);
			}
			else {
				$invalidte_address.prop("checked", false).trigger("change");
			}

			$affect_retries.prop("checked", action.affect_retries ? true : false);

			/*
			NO BORRAR !!!!
			(**) Por el momento en i6 NO se utiliza el ejecutar otros procesos, por lo que queda comentado
				Revisar en el HTML "frm_processes_content.html" que tabien se ha comentado.
			*/
			// if (action.execute_process && action.execute_process.process_id) {
			// 	$execute_process.prop("checked", true).trigger("change");
			// 	$action_process.val(action.execute_process.process_id);
			// 	$action_arguments.val(action.execute_process.arguments);
			// }

			if (action.set_process_type) {
				$change_contact_type.val(action.set_process_type);
			}
			else {
				$change_contact_type.val("");
			}

			$actions.focus();
		}
		else {
			this.frm.disable_control($channel, false, true);
			this.frm.disable_control($return_result, false, true);
			this.frm.disable_control($contacting_result, false, true);
			$channel.trigger("change").focus();
		}
	};

	/*
		Si se cambia el formato del action ID, tambien hay que modificarlo server side en los migrations de VCCs de Allegro.
			archivo: \usr\lib\inconcert\agent\inconcert\apps\provisioning\controllers\migrations\oeProcesses.lua
			funcion: m_oeProcessesStep.MakeNativeOEProcessRulesActions->MakeActionId.

		El formato debe de quedar igual.
	*/
	form_outbound_engine_processes_rules.prototype.__make_action_id = function(action)
	{
		return `CHANNEL:${action.channel}-RESULT:${action.result}-LAST_ADDRESS_CHANNEL:${action.last_address.channel}-LAST_ADDRESS_KIND:${action.last_address.kind}`.toUpperCase();
	};

	form_outbound_engine_processes_rules.prototype.validate_action_to_update = function()
	{
		this.form_paginator_actions.hide_popup_msg();

		let response = {success: false, $ctrl: null, item: null, message: "<%=_T('Unable to Add or Update Action.')%>"};

		const $channel = $("#out_form_process_rules_actions_channel");
		const $return_result = $("#out_form_process_rules_actions_return_result");
		const $contacting_result = $("#out_form_process_rules_actions_contacting_result");

		let action = {
			channel     : $channel.val(),
			result      : $return_result.val(),
			last_address: {
				channel: $channel.val(),
				kind   : $contacting_result.val(),
			},
			change_priority: {
				type : null,
				value: null
			},
			disable_address: {
				scope  : null,
				channel: null
			}
			/*
			NO BORRAR !!!!
			(**) Por el momento en i6 NO se utiliza el ejecutar otros procesos, por lo que queda comentado
				Revisar en el HTML "frm_processes_content.html" que tabien se ha comentado.
			*/
			// execute_process: {
			// 	process_id: null,
			// 	arguments : null
			// }
		};
		action.id = this.__make_action_id(action);

		let validation_result = inConcert.Utils.validate(action.channel, "required");
		if ( !validation_result.success ) {
			response.message = "<%=_T('Channel is required.')%>";
			response.$ctrl = $channel;
			this.__show_popup_ctrl_err(response);
			return response;
		}

		validation_result = inConcert.Utils.validate(action.result, "required");
		if ( !validation_result.success ) {
			response.message = "<%=_T('Return result is required.')%>";
			response.$ctrl = $return_result;
			this.__show_popup_ctrl_err(response);
			return response;
		}

		validation_result = inConcert.Utils.validate(action.last_address.kind, "required");
		if ( !validation_result.success ) {
			response.message = "<%=_T('Contacting is required.')%>";
			response.$ctrl = $contacting_result;
			this.__show_popup_ctrl_err(response);
			return response;
		}

		if (this.is_new_action) {
			let current_action = this.form_paginator_actions.find_row_data(action.id);
			if (current_action) {
				response.message = FORMAT("<%=_T('Rule action already defined for response {0} and destination {1}.')%>", this.__make_html_semantic_response(action.result), action.last_address.kind);
				response.$ctrl = $return_result;
				this.__show_popup_ctrl_err(response);
				return response;
			}
		}

		const $actions = $("#out_form_process_rules_actions");
		let action_type = $actions.val();

		if (action_type === "cancel") {
			action.cancel = true;
		}
		else if (action_type === "postpone") {
			//para postponer la interaccion simplemente seteo seconds to next action en cero
			action.cancel = false;
			action.schedule_seconds = 0;
		}
		else if (action_type === "next") {
			const $next_actions_channel = $("#out_form_process_rules_action_next_channel");
			validation_result = inConcert.Utils.validate($next_actions_channel.val(), "required");
			if ( !validation_result.success ) {
				response.message = "<%=_T('Channel next destination is required.')%>";
				response.$ctrl = $next_actions_channel;
				this.__show_popup_ctrl_err(response);
				return response;
			}
			const $next_destination = $("#out_form_process_rules_action_next_destination");
			validation_result = inConcert.Utils.validate($next_destination.val(), "required");
			if ( !validation_result.success ) {
				response.message = "<%=_T('Call next destination is required.')%>";
				response.$ctrl = $next_destination;
				this.__show_popup_ctrl_err(response);
				return response;
			}

			const $next_time = $("#out_form_process_rules_action_call_next_time");
			validation_result = inConcert.Utils.validate($next_time.val(), "required");
			if ( !validation_result.success ) {
				response.message = "<%=_T('Call next destination time is required.')%>";
				response.$ctrl = $next_time;
				this.__show_popup_ctrl_err(response);
				return response;
			}

			const $next_period = $("#out_form_process_rules_action_call_next_period");
			validation_result = inConcert.Utils.validate($next_period.val(), "required");
			if ( !validation_result.success ) {
				response.message = "<%=_T('Call next destination period is required.')%>";
				response.$ctrl = $next_period;
				this.__show_popup_ctrl_err(response);
				return response;
			}

			action.cancel = false;
			action.next_address = {
				channel: $next_actions_channel.val(),
				kind   : $next_destination.val()
			};
			if (action.next_address.kind === "SAME_ADDRESS") {
				action.next_address.kind = "SAME";
				action.next_address.same_address = true;
			}
 			let period = parseInt($next_period.val(), 10);
			let time = parseInt($next_time.val(), 10);
			action.original_time_period = time;
			switch (period) {
				case 1: //seconds
				break;
				case 2: //minutes
					time = time * 60;
				break;
				case 3: //days
					time = time * this.seconds_in_a_day;
				break;
			}
			action.period = period;
			action.schedule_seconds = time;
		}
		else {
			throw("error");
		}

		const $invalidte_address = $("#out_form_process_rules_action_invalidte_address");
		if ($invalidte_address.prop("checked")) {
			const $invalidte_address_scope = $("#out_form_process_rules_action_invalidte_address_scope");
			validation_result = inConcert.Utils.validate($invalidte_address_scope.val(), "required");
			if ( !validation_result.success ) {
				response.message = "<%=_T('The scope to invalidate the address is required.')%>";
				response.$ctrl = $invalidte_address_scope;
				this.__show_popup_ctrl_err(response);
				return response;
			}

			const $invalidte_address_channel = $("#out_form_process_rules_action_invalidte_address_channel");
			validation_result = inConcert.Utils.validate($invalidte_address_channel.val(), "required");
			if ( !validation_result.success ) {
				response.message = "<%=_T('The channel to invalidate the address is required.')%>";
				response.$ctrl = $invalidte_address_channel;
				this.__show_popup_ctrl_err(response);
				return response;
			}
			action.disable_address.scope = $invalidte_address_scope.val();
			action.disable_address.channel = $invalidte_address_channel.val();
		}
		else {
			delete action.disable_address; // TODO: Revisar si se puede borrar o tiene que estar con valores en NULL
		}

		const $contact_priority = $("#out_form_process_rules_action_change_contact_priority");
		if ((action_type === "cancel" || action_type === "next") && $contact_priority.prop("checked")) {
			const $contact_priority_value = $("#out_form_process_rules_action_change_contact_priority_value");
			validation_result = inConcert.Utils.validate($contact_priority_value.val(), "required");
			if ( !validation_result.success ) {
				response.message = "<%=_T('Change contact priority value is required.')%>";
				response.$ctrl = $contact_priority_value;
				this.__show_popup_ctrl_err(response);
				return response;
			}

			const $contact_priority_type = $("#out_form_process_rules_action_change_contact_priority_type");
			validation_result = inConcert.Utils.validate($contact_priority_type.val(), "required");
			if ( !validation_result.success ) {
				response.message = "<%=_T('Change contact priority type is required.')%>";
				response.$ctrl = $contact_priority_type;
				this.__show_popup_ctrl_err(response);
				return response;
			}
			action.change_priority.type = $contact_priority_type.val();
			action.change_priority.value = parseInt($contact_priority_value.val(), 10); // - 1; // TODO: Revisar por que el - 1
		}
		else {
			delete action.change_priority; // TODO: Revisar si se puede borrar o tiene que estar con valores en NULL
		}

		const $affect_retries = $("#out_form_process_rules_action_affect_retries");
		action.affect_retries = $affect_retries.prop("checked");

		/*
		NO BORRAR !!!!
		(**) Por el momento en i6 NO se utiliza el ejecutar otros procesos, por lo que queda comentado
			Revisar en el HTML "frm_processes_content.html" que tabien se ha comentado.
		*/
		// const $execute_process = $("#out_form_process_rules_action_execute_process");
		// if ($execute_process.prop("checked")) {
		// 	const $action_process = $("#out_form_process_rules_action_process");
		// 	validation_result = inConcert.Utils.validate($action_process.val(), "required");
		// 	if (!validation_result.success) {
		// 		response.message = "<%=_T('Process to execute is required.')%>";
		// 		response.$ctrl = $action_process;
		// 		this.__show_popup_ctrl_err(response);
		// 		return response;
		// 	}
		// 	const $action_arguments = $("#out_form_process_rules_action_arguments");
		// 	action.execute_process = {
		// 		process_id: $action_process.val(),
		// 		arguments : $action_arguments.val()
		// 	}
		// }
		// else {
		// 	delete action.execute_process; // TODO: Revisar si se puede borrar o tiene que estar con valores en NULL
		// }

		//en el combo: "", "PROGRESIVE", "PREDICTIVE"
		const $change_contact_type = $("#out_form_process_rules_action_change_contact_type");
		let process_type = $change_contact_type.val();

		if (process_type === "") {
			action.set_process_type = null;
		}
		else {
			action.set_process_type = process_type;
		}

		action = this.__make_semantic_action(action);

		response.success = true;
		response.message = "";
		response.item = action;

		return response;
	};

	form_outbound_engine_processes_rules.prototype.__make_destination_id = function(destination)
	{
		return`CHANNEL:${destination.channel}-KIND:${destination.kind}`.toUpperCase();
	};

	form_outbound_engine_processes_rules.prototype.validate_destination_to_update = function()
	{
		this.form_paginator_destinations.hide_popup_msg();

		let response = {success: false, $ctrl: null, item: null, message: "<%=_T('Unable to Add or Update Destination.')%>"};

		const $channel = $("#out_form_process_rules_destinations_channel");
		const $kind = $("#out_form_process_rules_destinations_kind");
		const $max_retries = $("#out_form_process_rules_destinations_max_retries");

		let destination = {
			channel    : $channel.val(),
			kind       : $kind.val(),
			max_retries: $max_retries.val()
		};
		destination.id = this.__make_destination_id(destination);

		const $err_msg_container =  $("#out_form_process_rules_destinations_popup_message");
		let validation_result = inConcert.Utils.validate(destination.channel, "required");
		if (!validation_result.success) {
			response.message = "<%=_T('Channel is required.')%>";
			response.$ctrl = $channel;
			this.__show_popup_ctrl_err(response, $err_msg_container);
			return response;
		}

		validation_result = inConcert.Utils.validate(destination.kind, "required");
		if (!validation_result.success) {
			response.message = "<%=_T('Destination Name is required.')%>";
			response.$ctrl = $kind;
			this.__show_popup_ctrl_err(response, $err_msg_container);
			return response;
		}

		validation_result = inConcert.Utils.validate(destination.max_retries, "required");
		if (!validation_result.success) {
			response.message = "<%=_T('Max Retries is required.')%>";
			response.$ctrl = $max_retries;
			this.__show_popup_ctrl_err(response, $err_msg_container);
			return response;
		}

		const range = {between: {from: 1, to: 100}};
		validation_result = inConcert.Utils.validate(destination.max_retries, "range", range);
		if (!validation_result.success) {
			response.message = FORMAT("<%=_T('Max Retries is out of range. Please enter a value between {0} and {1}.')%>", range.between.from, range.between.to);
			response.$ctrl = $max_retries;
			this.__show_popup_ctrl_err(response, $err_msg_container);
			return response;
		}
		destination.max_retries = parseInt(destination.max_retries, 10);

		if (this.is_new_destination) {
			let current_destination = this.form_paginator_destinations.find_row_data(destination.id);
			if (current_destination) {
				response.message = "<%=_T('Rule Destination already exist.')%>";
				response.$ctrl = $channel;
				this.__show_popup_ctrl_err(response, $err_msg_container);
				return response;
			}
		}

		response.success = true;
		response.message = "";
		response.item = destination;

		return response;
	};

	form_outbound_engine_processes_rules.prototype.add_or_update_destination = function(callback = $.noop)
	{
		let response = this.validate_destination_to_update();
		if (!response.success) {
			callback(false);
			return;
		}

		this.__cleanup_destinations_popup_ctrls();
		this.current_destination = null;

		let item = response.item;
		let msg_response = {msg: "", type: ""};

		msg_response.msg = this.is_new_destination ? "<%=_T('Destination was successfully added.')%>" : "<%=_T('Destination was successfully updated.')%>";
		msg_response.type = "Info";

		callback(true, item, msg_response);
	};

	form_outbound_engine_processes_rules.prototype.add_or_update_action = function(callback = $.noop)
	{
		let response = this.validate_action_to_update();
		if (!response.success) {
			callback(false);
			return;
		}

		this.__cleanup_actions_popup_ctrls();
		this.current_action = null;

		let item = response.item;
		let msg_response = {msg: "", type: ""};

		msg_response.msg = this.is_new_action ? "<%=_T('Action was successfully added.')%>" : "<%=_T('Action was successfully updated.')%>";
		msg_response.type = "Info";

		callback(true, item, msg_response);
	};

	form_outbound_engine_processes_rules.prototype.get_grid_destination_value = function(item, field_id)
	{
		let value = {
			original_value: "",
			value         : "",
			search_value  : ""
		};

		let item_value = item[field_id] || "";
		if (item_value === undefined) {
			return value;
		}

		value.original_value = item_value;
		value.value = item_value;
		value.search_value = item_value;

		if (field_id === "kind") {
			value.value = _T(item.kind);
			value.search_value = value.value;
		}
		else if (field_id === "channel") {
			value.value = inConcert.app.getTranslatedChannel(item_value);
			value.search_value = value.value;
		}
		else if (field_id === "max_retries") {
			value.value = item.max_retries || "3";
			value.search_value = value.value;
		}

		return value;
	};

	form_outbound_engine_processes_rules.prototype.get_grid_actions_value = function(item, field_id)
	{
		let value = {
			original_value: "",
			value         : "",
			search_value  : ""
		};

		let item_value = item[field_id] || "";
		if (item_value === undefined) {
			return value;
		}

		if (field_id === "channel" || field_id === "kind") {
			let last_address = item.last_address || {};
			if (field_id === "channel") {
				value.original_value = last_address.channel;
				// TODO : Agregar tooltip
				// class img
				let channels_class = {
					ANY     : {column_class_name: "actionChannelANY"     },
					CALL    : {column_class_name: "actionChannelCALL"    },
					MAIL    : {column_class_name: "actionChannelMAIL"    },
					SMS     : {column_class_name: "actionChannelSMS"     },
					WHATSAPP: {column_class_name: "actionChannelWHATSAPP"}
				};
				let def = channels_class[value.original_value];
				if (def) {
					value.class_name = "actionConditionChannelIcon";
					value.column_class_name = def.column_class_name;
				}
			}
			else {
				value.original_value = last_address.kind;
				value.value = _T(last_address.kind);
				// class img
				let kinds_class = {
					ANY     : {column_class_name: "actionKindAny"   },
					CELLULAR: {column_class_name: "actionKindCel"   },
					FAX     : {column_class_name: "actionKindFax"   },
					HOME    : {column_class_name: "actionKindHome"  },
					OFFICE  : {column_class_name: "actionKindOffice"},
					SAME    : {column_class_name: "actionKindSame"  },
					WORK    : {column_class_name: "actionKindWork"  }
				};
				let def = kinds_class[value.original_value];
				if (def) {
					value.class_name = "actionConditionKindIcon";
					value.column_class_name = def.column_class_name;
				}
			}
			value.search_value = value.value;
		}
		else  {
			value.original_value = item_value;
			value.value = item_value;
			value.search_value = item_value;
		}

		return value;
	};

	form_outbound_engine_processes_rules.prototype.__make_html_semantic = function(name)
	{
		return `<span class="gridActionHighlightText">${name.toUpperCase()}</span>`;
	};

	//devuelve la traduccion de un destino tanto sea builtin (ANY) como dado de alta por el usuario
	form_outbound_engine_processes_rules.prototype.__make_html_semantic_destination = function(destination = "")
	{
		destination = destination.toUpperCase();
		if (this.builtin_destinations[destination]) {
			let name = this.builtin_destinations[destination];
			return this.__make_html_semantic(_T(name));
		}
		let list = this.m_cached_destinations_result || [];
		for (let i = 0; i < list.length; i++) {
			let item = list[i];
			if ((item.id || "").toUpperCase() === destination) {
				return this.__make_html_semantic(_T(item.name));
			}
		}
		return destination;
	};

	form_outbound_engine_processes_rules.prototype.__make_html_semantic_response = function(responseCode = "")
	{
		responseCode = responseCode.toUpperCase();
		let list = this.m_cached_actions_result || [];
		for (let i = 0; i < list.length; i++) {
			let item = list[i];
			if ((item.id || "").toUpperCase() === responseCode) {
				return this.__make_html_semantic(item.name);
			}
		}
		return "";
	};

	form_outbound_engine_processes_rules.prototype.__period_as_string = function(periodid)
	{
		let period = this.period_list[periodid.toString()];
		if (period) {
			return period.name;
		}
		return period;
	};

	form_outbound_engine_processes_rules.prototype.__make_semantic_action = function(action)
	{
		let conditionString;
		let actionString = "";

		if (!action.cancel) {
			if (action.schedule_seconds === 0) {
				conditionString = FORMAT("<%=_T('When the interaction returns {0} while contacting {1}, postpone the contact.')%>",
					this.__make_html_semantic_response(action.result),
					this.__make_html_semantic_destination(action.last_address.kind)
				);
			}
			else {
				//quiso llamar
				if (action.last_address.channel === "ANY") {
					conditionString = FORMAT("<%=_T('When the interaction returns {0}, call {1} in {2} {3}.')%>",
						this.__make_html_semantic_response(action.result),
						this.__make_html_semantic_destination(action.next_address.kind),
						action.original_time_period,
						this.__period_as_string(action.period)
					);
				}
				else {
					conditionString = FORMAT("<%=_T('When the interaction returns {0} while contacting {1}, call {2} in {3} {4}.')%>",
						this.__make_html_semantic_response(action.result),
						this.__make_html_semantic_destination(action.last_address.kind),
						this.__make_html_semantic_destination(action.next_address.kind),
						action.original_time_period,
						this.__period_as_string(action.period)
					);
				}
			}
		}
		else {
			//quiso cancelar
			if (action.last_address.channel === "ANY") {
				conditionString = FORMAT("<%=_T('When the interaction returns {0}, cancel interaction.')%>", this.__make_html_semantic_response(action.result));
			}
			else {
				conditionString = FORMAT("<%=_T('When the interaction returns {0} while contacting {1}, cancel interaction.')%>",
					this.__make_html_semantic_response(action.result),
					this.__make_html_semantic_destination(action.last_address.kind)
				);
			}
		}

		/*
		NO BORRAR !!!!
		(**) Por el momento en i6 NO se utiliza el ejecutar otros procesos, por lo que queda comentado
			Revisar en el HTML "frm_processes_content.html" que tabien se ha comentado.
		*/
		// if (action.disable_address ) {
		// 	if (action.execute_process && action.execute_process.process_id) {
		// 		if (action.execute_process.arguments) {
		// 			actionString = FORMAT("<%=_T('Invalidate address and call process {0} with arguments {1}.')%>", action.execute_process.process_id, action.execute_process.arguments);
		// 		}
		// 		else {
		// 			actionString = FORMAT("<%=_T('Invalidate address and call process {0} with no arguments.')%>", action.execute_process.process_id);
		// 		}
		// 	}
		// 	else {
		// 		actionString = "<%=_T('Address will be invalidated.')%>";
		// 	}
		// }
		// else {
		// 	if (action.execute_process && action.execute_process.process_id) {
		// 		if (action.execute_process.arguments) {
		// 			actionString = FORMAT("<%=_T('Call process {0} with arguments {1}.')%>", action.execute_process.process_id, action.execute_process.arguments);
		// 		}
		// 		else {
		// 			actionString = FORMAT("<%=_T('Call process {0} with no arguments.')%>", action.execute_process.process_id);
		// 		}
		// 	}
		// }

		// esto va en lugar de lo que esta comentado arriba!!
		if (action.disable_address ) {
			actionString = "<%=_T('Address will be invalidated.')%>";
		}


		let ruleString = conditionString + actionString;

		action.id = this.__make_action_id(action);
		action.DisplayValue = ruleString;

		return action;
	};

	form_outbound_engine_processes_rules.prototype.load_rules_actions = function(_, callback = $.noop)
	{
		const self = this;

		const filter = function() {
			let filtered_list = [];

			const add = function(action) {
				action = self.__make_semantic_action(action);
				filtered_list.push(action);
			};

			let rule_actions = self.edited_rule ? self.edited_rule.actions : self.m_system_actions;
			rule_actions = inConcert.Utils.cloneArray(rule_actions || []);

			$.each(rule_actions, function(_, response) {
				if (response.schedule_seconds > 0) {
					//tengo que pasar los segundos a humano que es lo que originalmente el flaco especifico
					//aca parto de la base que si es multiplo de dias o de minutos especifico eso (puede pasar que si especifico 120 segundos se le levante despues como 2 minutos)
					let period, originalTimePeriod;
					if (parseInt(response.schedule_seconds % self.seconds_in_a_day, 10) === 0) {
						originalTimePeriod = parseInt(response.schedule_seconds / self.seconds_in_a_day, 10);
						period = 3;
					}
					else {
						if (parseInt(response.schedule_seconds % 60, 10) === 0) {
							originalTimePeriod = parseInt(response.schedule_seconds / 60, 10);
							period = 2;
						}
						else {
							originalTimePeriod = parseInt(response.schedule_seconds, 10);
							period = 1;
						}
					}
					response.original_time_period = originalTimePeriod;
					response.period = period;
				}
				add(response);
			});

			return filtered_list;
		};

		let list = filter();
		callback(true, list);
	};

	form_outbound_engine_processes_rules.prototype.load_rules_destinations = function(_, callback)
	{
		const self = this;
		let process_rule_addresses = [];
		if (this.edited_rule) {
			process_rule_addresses = inConcert.Utils.cloneArray(this.edited_rule.addresses || []);
			for (let i = 0; i < process_rule_addresses.length; i++) {
				let destination = process_rule_addresses[i];
				destination.id = self.__make_destination_id(destination);
				process_rule_addresses[i] = destination;
			}
		}
		callback(true, process_rule_addresses);
	};

	form_outbound_engine_processes_rules.prototype.__update_kinds_by_channels = function(destinations)
	{
		const self = this;
		destinations.forEach(d => {
			for (let channel in d.channels || {}) {
				if (d.channels.hasOwnProperty(channel)) {
					let is_enabled = d.channels[channel];
					if (is_enabled) {
						channel = channel.toUpperCase();
						if (self.m_channels[channel]) {
							self.m_channels[channel].kinds = self.m_channels[channel].kinds || {};
							let destination_id = d.id.toUpperCase();
							if (!self.m_channels[channel].kinds[destination_id]) {
								let destination_name = d.name.toUpperCase();
								self.m_channels[channel].kinds[destination_id] = {
									id  : destination_id,
									name: _T(destination_name)
								};
							}
						}
					}
				}
			}
		});
	};

	form_outbound_engine_processes_rules.prototype.attach_load_request = function(request)
	{
		const self = this;

		this.__fill_invalidate_address_scope();
		this.__fill_invalidate_address_channel();
		this.__fill_period();
		this.__fill_priority_value();
		this.__fill_priority_type();
		this.__fill_change_contact_types();

		const outbound_engine_api = inConcert.app.getOutboundEngineAPI();

		// xxxxx
		request.push(
			{
				request_function: function(success) {
					return outbound_engine_api.systemRulesLoadDestinations(success);
				},
				success: function(list) {
					self.__cache_destinations_result(list);
					self.__update_kinds_by_channels(list);
					self.__fill_channels();
					self.__fill_channels_for_actions();
				}
			},
			{
				request_function: function(success) {
					return outbound_engine_api.systemRulesLoadResponsesByChannel(success);
				},
				success: function(list) {
					self.__cache_actions_result(list);
				}
			},
			/*
			NO BORRAR !!!!
			(**) Por el momento en i6 NO se utiliza el ejecutar otros procesos, por lo que queda comentado
				Revisar en el HTML "frm_processes_content.html" que tabien se ha comentado.
			*/
			// {
			// 	request_function: function(success) {
			// 		return outbound_engine_api.processLoadAdministrationProcessess(success);
			// 	},
			// 	success: function(list) {
			// 		self.__fill_administration_processes(list);
			// 	}
			// },
			{
				request_function: function(success) {
					const fn = function(result_fn) {
						result_fn(true, [
							{Name: "cancel"  , DisplayName: "<%=_T('Cancel')%>"               },
							{Name: "next"    , DisplayName: "<%=_T('Call Next Destination')%>"},
							{Name: "postpone", DisplayName: "<%=_T('Postpone Contact')%>"     }
						]);
					};
					return fn(success);
				},
				success: function(list) {
					self.__fill_actions_options(list);
				}
			}
		);
	};

	form_outbound_engine_processes_rules.prototype.__fill_channels = function()
	{
		//destinations popup
		const $destinations_channel = $("#out_form_process_rules_destinations_channel");
		this.frm.fill_combo($destinations_channel, true /* is_blank_first_item */, this.m_channels, "id" /* attr_id */, "name" /* attr_name */, true /*sorted*/);
	};

	form_outbound_engine_processes_rules.prototype.__fill_channels_for_actions = function()
	{
		//actions popup (main)
		let template_actions_channel = {
			ANY: {id: "ANY", name: this.builtin_destinations.ANY_CHANNEL}
		};
		let channels_for_actions = {};
		channels_for_actions = inConcert.Utils.cloneObject(template_actions_channel);
		$.extend(true, channels_for_actions, this.m_channels);
		const $actions_channel = $("#out_form_process_rules_actions_channel");
		this.frm.fill_combo($actions_channel, true /* is_blank_first_item */, channels_for_actions, "id" /* attr_id */, "name" /* attr_name */, true /*sorted*/);
		//actions popup (next)
		let template_for_next = {
			SAME: {id: "SAME", name: this.builtin_destinations.SAME_CHANNEL},
			NEXT: {id: "NEXT", name: this.builtin_destinations.NEXT_CHANNEL}
		};
		let channels_for_next = {};
		channels_for_next = inConcert.Utils.cloneObject(template_for_next);
		$.extend(true, channels_for_next, this.m_channels);
		const $next_actions_channel = $("#out_form_process_rules_action_next_channel");
		this.frm.fill_combo($next_actions_channel, true /* is_blank_first_item */, channels_for_next, "id" /* attr_id */, "name" /* attr_name */);
	};

	form_outbound_engine_processes_rules.prototype.__fill_destinations_kinds = function(channel)
	{
		let list = {};
		if (this.m_channels[channel] && this.m_channels[channel].kinds) {
			list = this.m_channels[channel].kinds;
		}
		const $combo = $("#out_form_process_rules_destinations_kind");
		this.frm.fill_combo($combo, true /* is_blank_first_item */, list, "id" /* attr_id */, "name" /* attr_name */, true /*sorted*/);
	};

	form_outbound_engine_processes_rules.prototype.__fill_actions_kinds = function(channel)
	{
		const self = this;
		let template_for_result = {
			ANY: {id: "ANY", name: this.builtin_destinations.ANY}
		};
		let kinds_for_result = null;
		const fill = function(current_channel) {
			if (self.m_channels[current_channel] && self.m_channels[current_channel].kinds) {
				if (!kinds_for_result) {
					kinds_for_result = inConcert.Utils.cloneObject(template_for_result);
				}
				$.extend(true, kinds_for_result, self.m_channels[current_channel].kinds);
			}
		};
		if (channel !== "ANY") {
			fill(channel);
		}
		else {
			for (let current_channel in this.m_channels) {
				if (this.m_channels.hasOwnProperty(current_channel)) {
					fill(current_channel);
				}
			}
		}
		kinds_for_result = kinds_for_result || {};
		const $contacting_result = $("#out_form_process_rules_actions_contacting_result");
		this.frm.fill_combo($contacting_result, true /* is_blank_first_item */, kinds_for_result, "id" /* attr_id */, "name" /* attr_name */);
	};

	form_outbound_engine_processes_rules.prototype.__fill_next_actions_kinds = function(channel)
	{
		const self = this;

		if (channel === "NEXT" || channel === "SAME") {
			// Si el valor que ha seleccionado en el combo "out_form_process_rules_action_next_channel" no es un canal tengo que obtener el canal que se ha configurado en el combo "out_form_process_rules_actions_channel";
			channel = $("#out_form_process_rules_actions_channel").val();
		}
		let template_for_next = {
			SAME        : {id: "SAME", name: this.builtin_destinations.SAME},
			SAME_ADDRESS: {id: "SAME_ADDRESS", name: this.builtin_destinations.SAME_ADDRESS},
			NEXT_ADDRESS: {id: "NEXT_ADDRESS", name: this.builtin_destinations.NEXT_ADDRESS},
			NEXT        : {id: "NEXT", name: this.builtin_destinations.NEXT}
		};
		let kinds_for_next = null;
		const fill = function(current_channel) {
			if (self.m_channels[current_channel] && self.m_channels[current_channel].kinds) {
				if (!kinds_for_next) {
					kinds_for_next = inConcert.Utils.cloneObject(template_for_next);
				}
				$.extend(true, kinds_for_next, self.m_channels[current_channel].kinds);
			}
		};
		if (channel !== "ANY") {
			fill(channel);
		}
		else {
			for (let current_channel in this.m_channels) {
				if (this.m_channels.hasOwnProperty(current_channel)) {
					fill(current_channel);
				}
			}
		}
		kinds_for_next = kinds_for_next || {};
		const $next_destination = $("#out_form_process_rules_action_next_destination");
		this.frm.fill_combo($next_destination, true /* is_blank_first_item */, kinds_for_next, "id" /* attr_id */, "name" /* attr_name */);
	};

	form_outbound_engine_processes_rules.prototype.__cache_actions_result = function(list)
	{
		this.m_cached_actions_result = list;
	};

	form_outbound_engine_processes_rules.prototype.__cache_destinations_result = function(list)
	{
		this.m_cached_destinations_result = list;
	};

	form_outbound_engine_processes_rules.prototype.__fill_actions_result = function(channel)
	{
		channel = channel.toUpperCase();
		let list = [];
		this.m_cached_actions_result.forEach(action_result => {
			if (channel === "ANY" || action_result.channels[channel]) {
				list.push(action_result);
			}
		});
		const $combo = $("#out_form_process_rules_actions_return_result");
		this.frm.fill_combo($combo, true /* is_blank_first_item */, list, "id" /* attr_id */, "name" /* attr_name */);
	};

	form_outbound_engine_processes_rules.prototype.__fill_actions_options = function(list)
	{
		const $combo = $("#out_form_process_rules_actions");
		this.frm.fill_combo($combo, false /* is_blank_first_item */, list, "Name" /* attr_id */, "DisplayName" /* attr_name */);
	};

	form_outbound_engine_processes_rules.prototype.__fill_period = function()
	{
		const $combo = $("#out_form_process_rules_action_call_next_period");
		this.frm.fill_combo($combo, true /* is_blank_first_item */, this.period_list, "id" /* attr_id */, "name" /* attr_name */);
	};

	form_outbound_engine_processes_rules.prototype.__fill_change_contact_types = function()
	{
		const $combo = $("#out_form_process_rules_action_change_contact_type");
		this.frm.fill_combo($combo, true /* is_blank_first_item */, this.change_contact_types_list, "id" /* attr_id */, "name" /* attr_name */);
	};

	form_outbound_engine_processes_rules.prototype.__fill_priority_value = function()
	{
		const $combo = $("#out_form_process_rules_action_change_contact_priority_value");
		let list = [];
		//de -100 a 100 saltando de a 10
		for (let i = -100; i <= 100; i += 10) {
			if (i !== 0) {
				list.push({id: i, name: i});
			}
		}
		this.frm.fill_combo($combo, true /* is_blank_first_item */, list, "id" /* attr_id */, "name" /* attr_name */);
	};

	form_outbound_engine_processes_rules.prototype.__fill_priority_type = function()
	{
		const $combo = $("#out_form_process_rules_action_change_contact_priority_type");
		this.frm.fill_combo($combo, true /* is_blank_first_item */, this.priority_type, "id" /* attr_id */, "name" /* attr_name */);
	};

	form_outbound_engine_processes_rules.prototype.__fill_invalidate_address_scope = function()
	{
		const $combo = $("#out_form_process_rules_action_invalidte_address_scope");
		this.frm.fill_combo($combo, true /* is_blank_first_item */, this.m_invalidate_address_scope, "id" /* attr_id */, "name" /* attr_name */, true /*sorted*/);
	};

	form_outbound_engine_processes_rules.prototype.__fill_invalidate_address_channel = function()
	{
		const $combo = $("#out_form_process_rules_action_invalidte_address_channel");
		this.frm.fill_combo($combo, true /* is_blank_first_item */, this.m_invalidate_address_channel, "id" /* attr_id */, "name" /* attr_name */, true /*sorted*/);
	};

	/*
	NO BORRAR !!!!
	(**) Por el momento en i6 NO se utiliza el ejecutar otros procesos, por lo que queda comentado
		Revisar en el HTML "frm_processes_content.html" que tabien se ha comentado.
	*/
	// form_outbound_engine_processes_rules.prototype.__fill_administration_processes = function(list)
	// {
	// 	const $combo = $("#out_form_process_rules_action_process");
	// 	this.frm.fill_combo($combo, true /* is_blank_first_item */, list, "id" /* attr_id */, "name" /* attr_name */);
	// };

	form_outbound_engine_processes_rules.prototype.__get_schedule = function()
	{
		if (!this.schedule_hnd) {
			return {};
		}
		let schedule = this.schedule_hnd.get_scheduler();
		return schedule;
	};

	form_outbound_engine_processes_rules.prototype.__get_addresses = function()
	{
		let destinations = this.form_paginator_destinations.get_items();
		return destinations;
	};

	form_outbound_engine_processes_rules.prototype.__get_actions = function()
	{
		let rule_actions = this.form_paginator_actions.get_items();
		rule_actions.forEach(action => {
			delete action.DisplayValue;
			if (action.set_process_type === null) {
				delete action.DisplayValue;
			}
		});
		return rule_actions;
	};

	form_outbound_engine_processes_rules.prototype.__get = function()
	{
		let rule = {
			name       : $("#out_form_process_rules_name").val(),
			description: $("#out_form_process_rules_desc").val(),
			schedule   : this.__get_schedule(),
			addresses  : this.__get_addresses(),
			actions    : this.__get_actions()
		};
		if (this.is_new_rule()) {
			rule.id = inConcert.Utils.generateGuid();
		}
		else {
			rule.id = this.edited_rule.id; // el id interno que genera la grilla.
		}
		return rule;
	};

	form_outbound_engine_processes_rules.prototype.hide_all_errors = function()
	{
		this.frm.hide_messages();
	};

	form_outbound_engine_processes_rules.prototype.__validate = function()
	{
		this.hide_all_errors();
		let rule = this.__get();

		let response = inConcert.Utils.validate(rule.name, "required");
		if (!response.success) {
			response.message = "<%=_T('Unable to add or update Rule. You must add a name to rule.')%>";
			response.$ctrl = $("#out_form_process_rules_name");
			this.main_tabs.switch_tab("scheduler");
			return response;
		}

		response = inConcert.Utils.validate(rule.description, "required");
		if (!response.success) {
			response.message = "<%=_T('Unable to add or update Rule. Description is required.')%>";
			response.$ctrl = $("#out_form_process_rules_desc");
			this.main_tabs.switch_tab("scheduler");
			return response;
		}

		if (!rule.schedule || !rule.schedule.scheduleDays || Object.keys(rule.schedule.scheduleDays).length === 0) {
			response.success = false;
			response.message = "<%=_T('At least one day needs to be set in the schedule.')%>";
			//response.$ctrl = $("#out_form_process_rules_destinations_list");
			this.main_tabs.switch_tab("scheduler");
			return response;
		}

		if (rule.addresses.length === 0) {
			response.success = false;
			response.message = "<%=_T('Unable to add or update Rule. You must select at least one destination for the rule.')%>";
			response.$ctrl = $("#out_form_process_rules_destinations_list");
			this.main_tabs.switch_tab("destination");
			return response;
		}

		if (rule.actions.length === 0) {
			response.success = false;
			response.message = "<%=_T('You must configure at least one response action for the rule.')%>";
			response.$ctrl = $("#out_form_process_rules_actions_list");
			this.main_tabs.switch_tab("actions");
			return response;
		}

		response.rule = rule;
		return response;
	};

	form_outbound_engine_processes_rules.prototype.__show_ctrl_err = function(err_info)
	{
		if (!err_info) {
			return;
		}
		this.frm.show_validation_error(err_info.$ctrl, err_info.message);
	};

	form_outbound_engine_processes_rules.prototype.__show_popup_ctrl_err = function(err_info, $err_msg_container)
	{
		if (!err_info) {
			return;
		}
		$err_msg_container = $err_msg_container || $("#out_form_process_rules_actions_popup_message");
		this.frm.show_validation_error(err_info.$ctrl, err_info.message, undefined, undefined, undefined, $err_msg_container);
	};

	form_outbound_engine_processes_rules.prototype.__add_update_rule = function()
	{
		const self = this;
		this.frm.hide_messages();
		let result = this.__validate();
		if (!result.success) {
			this.__show_ctrl_err(result);
			return;
		}
		let rule = result.rule;
		this.frm.add_update_rule(rule, function() {
			self.__dispose();
		});
	};

	form_outbound_engine_processes_rules.prototype.is_new_rule = function()
	{
		return this.edited_rule === null;
	};

	form_outbound_engine_processes_rules.prototype.__dispose = function()
	{
		this.edited_rule = null;
	};

	form_outbound_engine_processes_rules.prototype.ready_for_create = function()
	{
		this.main_tabs.initialize();
		this.main_tabs.show_tabs_container();
	};

	form_outbound_engine_processes_rules.prototype.ready_for_update = function()
	{
		this.ready_for_create();
	};

	form_outbound_engine_processes_rules.prototype.__on_change_rule_destination = function(channel)
	{
		this.__fill_destinations_kinds(channel);
	};

	form_outbound_engine_processes_rules.prototype.__on_change_rule_action = function(action)
	{
		const $call_section = $("#out_form_process_rules_action_call_section");
		const $contact_priority = $("#out_form_process_rules_action_change_contact_priority");

		switch(action) {
			case "cancel":
				$contact_priority.prop("disabled", false);
				$call_section.hide();
			break;
			case "next":
				$contact_priority.prop("disabled", false);
				$call_section.show();
			break;
			case "postpone":
				$contact_priority.prop("checked", false);
				$contact_priority.prop("disabled", true);
				$call_section.hide();
			break;
		}

		this.__change_rule_change_contact_priority();

		/*
		NO BORRAR !!!!
		(**) Por el momento en i6 NO se utiliza el ejecutar otros procesos, por lo que queda comentado
			Revisar en el HTML "frm_processes_content.html" que tabien se ha comentado.
		*/
		//this.__change_rule_execute_process();
	};

	/*
	NO BORRAR !!!!
	(**) Por el momento en i6 NO se utiliza el ejecutar otros procesos, por lo que queda comentado
		Revisar en el HTML "frm_processes_content.html" que tabien se ha comentado.
	*/
	// form_outbound_engine_processes_rules.prototype.__change_rule_execute_process = function()
	// {
	// 	const $action_process = $("#out_form_process_rules_action_process");
	// 	const $action_arguments = $("#out_form_process_rules_action_arguments");
	// 	const $execute_process = $("#out_form_process_rules_action_execute_process");

	// 	if ($execute_process.prop("checked")) {
	// 		this.frm.disable_control($action_process, false, true);
	// 		this.frm.disable_control($action_arguments, false, false);
	// 	}
	// 	else {
	// 		this.frm.disable_control($action_process, true);
	// 		this.frm.disable_control($action_arguments, true);
	// 	}
	// };

	form_outbound_engine_processes_rules.prototype.__change_rule_change_contact_priority = function()
	{
		const $contact_priority_value = $("#out_form_process_rules_action_change_contact_priority_value");
		const $contact_priority_type = $("#out_form_process_rules_action_change_contact_priority_type");
		const $contact_priority = $("#out_form_process_rules_action_change_contact_priority");

		if ($contact_priority.prop("checked") && !$contact_priority.is(":disabled")) {
			this.frm.disable_control($contact_priority_value, false, true);
			this.frm.disable_control($contact_priority_type, false, true);
		}
		else {
			this.frm.disable_control($contact_priority_value, true);
			this.frm.disable_control($contact_priority_type, true);
		}
	};

	form_outbound_engine_processes_rules.prototype.__change_rule_change_invalidate_address = function()
	{
		const $invalidte_address = $("#out_form_process_rules_action_invalidte_address");
		const $invalidte_address_scope = $("#out_form_process_rules_action_invalidte_address_scope");
		const $invalidte_address_channel = $("#out_form_process_rules_action_invalidte_address_channel");

		if ($invalidte_address.prop("checked") && !$invalidte_address.is(":disabled")) {
			this.frm.disable_control($invalidte_address_scope, false, true);
			this.frm.disable_control($invalidte_address_channel, false, true);
		}
		else {
			this.frm.disable_control($invalidte_address_scope, true);
			this.frm.disable_control($invalidte_address_channel, true);
		}
	};

	form_outbound_engine_processes_rules.prototype.set_events = function()
	{
		const self = this;

		// eventos de la grilla con paginado
		this.form_paginator_destinations.set_events();
		this.form_paginator_actions.set_events();

		$("#out_form_process_rules_add_update_rule_to_process")
			.off("click")
			.on("click", function() {
				self.__add_update_rule();
			});

		$("#out_form_process_rules_back_process_section")
			.off("click")
			.on("click", function() {
				self.frm.show_process_section();
			});

		// eventos del popup de edicion de DESTINOS de la regla
		const $out_form_process_rules_destinations_channel = $("#out_form_process_rules_destinations_channel");
		$out_form_process_rules_destinations_channel
			.off("change")
			.on("change", function() {
				let channel = $(this).val();
				self.__on_change_rule_destination(channel);
			});

		// eventos del popup de edicion de acciones de la regla
		$("#out_form_process_rules_actions")
			.off("change")
			.on("change", function() {
				let action = $(this).val();
				self.__on_change_rule_action(action);
			});

		/*
		NO BORRAR !!!!
		(**) Por el momento en i6 NO se utiliza el ejecutar otros procesos, por lo que queda comentado
			Revisar en el HTML "frm_processes_content.html" que tabien se ha comentado.
		*/
		// $("#out_form_process_rules_action_execute_process")
		// 	.off("change")
		// 	.on("change", function() {
		// 		self.__change_rule_execute_process();
		// 	});

		$("#out_form_process_rules_action_change_contact_priority")
			.off("change")
			.on("change", function() {
				self.__change_rule_change_contact_priority();
			});

		$("#out_form_process_rules_action_invalidte_address")
			.off("change")
			.on("change", function() {
				self.__change_rule_change_invalidate_address();
			});

		$("#out_form_process_rules_actions_channel")
			.off("change")
			.on("change", function() {
				let channel = $(this).val();
				self.__on_change_rule_channel_action(channel);
			});

		$("#out_form_process_rules_action_next_channel")
			.off("change")
			.on("change", function() {
				let channel = $(this).val();
				self.__on_change_rule_next_channel_action(channel);
			});

	};

	form_outbound_engine_processes_rules.prototype.__on_change_rule_channel_action = function(channel)
	{
		this.__fill_actions_result(channel);
		this.__fill_actions_kinds(channel);
	};

	form_outbound_engine_processes_rules.prototype.__on_change_rule_next_channel_action = function(channel)
	{
		this.__fill_next_actions_kinds(channel);
	};

	form_outbound_engine_processes_rules.prototype.__show_schedule_section = function(current_scheduler)
	{
		const self = this;

		const show = function(schedule_info)
		{
			self.schedule_hnd = new inConcert.conf_form_schedule({
				frm                 : self.frm,
				owner               : self,
				prefix              : "out_form_process_schedule",
				container_id        : "out_form_process_schedule_container",
				without_buttons_container: true,
				//buttons_container_id: "out_form_process_schedule_popup_buttons",
				data_type           : "MAP",
				callbacks: {
					cancel: function() {
						self.frm.__show_rules_section();
					},
					can_configure_special_days: function() {
						return true;
					}
				}
			});
			self.schedule_hnd.initialize();
			if (schedule_info) {
				// EDITANDO
				self.schedule_hnd.set(schedule_info);
			}
		};

		// new or edit
		show(current_scheduler);
	};
}());
