local m_queries = require "outboundengineclient_queries"
local outboundEngine = require "lua_outboundengineclient"
local json = require "json"

local m_client
local function GetClient()
    if not m_client then
        m_client = outboundEngine.LuaOutboundEngineClient("MiniClusterUbuntu", "webhandler")
    end
    return m_client
end

GetClient()
local port = os.getenv("OUTBOUND_ENGINE_SERVICE_LOCAL_PORT") or "9033"
m_client:AddKnownOutboundEngine("192.168.4.11", port)

function GetJsonRawConditions ()
	---------------------------
	-- SIN FILTRO
	---------------------------
	local jsonRawConditions = [[
		{
			"values": [],
			"condition": " Name Like ? OR Id = ? ",
			"lines": [],
			"processId": "borrame1",
			"excludeContacted": 0
		}
	]]

	---------------------------
	-- IGUAL (1 SOLO)
	---------------------------
	-- local jsonRawConditions = [[
	-- 	{
	-- 		"values": [
	-- 			"id0001@vcc1"
	-- 		],
	-- 		"condition": "  Id = ?  ",
	-- 		"lines": [
	-- 			{
	-- 				"logicalOp": "",
	-- 				"leftParenth": "",
	-- 				"field": "Id",
	-- 				"conditionOp": "=",
	-- 				"value": "a",
	-- 				"rightParenth": "",
	-- 				"isCustomField": false
	-- 			}
	-- 		],
	-- 		"processId": "borrame1",
	-- 		"excludeContacted": 0
	-- 	}
	-- ]]
	-----------------------------------

	-- ---------------------------
	-- -- DISTINITO (1 SOLO)
	-- ---------------------------
	-- local jsonRawConditions = [[
	-- 	{
	-- 		"values": [
	-- 			"id0001@vcc1"
	-- 		],
	-- 		"condition": "  Id <> ?  ",
	-- 		"lines": [
	-- 			{
	-- 				"logicalOp": "",
	-- 				"leftParenth": "",
	-- 				"field": "Id",
	-- 				"conditionOp": "<>",
	-- 				"value": "a",
	-- 				"rightParenth": "",
	-- 				"isCustomField": false
	-- 			}
	-- 		],
	-- 		"processId": "borrame1",
	-- 		"excludeContacted": 0
	-- 	}
	-- ]]
	-----------------------------------

	-- ---------------------------
	-- -- Id = ? OR Id = ?
	-- ---------------------------
	-- local jsonRawConditions = [[
	-- 	{
	-- 		"values": [
	-- 			"id0001@vcc1",
	-- 			"id0002@vcc1"
	-- 		],
	-- 		"condition": "  Id = ? OR Id = ? ",
	-- 		"lines": [
	-- 			{
	-- 				"logicalOp": "",
	-- 				"leftParenth": "",
	-- 				"field": "Id",
	-- 				"conditionOp": "=",
	-- 				"value": "a",
	-- 				"rightParenth": "",
	-- 				"isCustomField": false
	-- 			},
	-- 			{
	-- 				"logicalOp": "OR",
	-- 				"leftParenth": "",
	-- 				"field": "Id",
	-- 				"conditionOp": "=",
	-- 				"value": "a",
	-- 				"rightParenth": "",
	-- 				"isCustomField": false
	-- 			}
	-- 		],
	-- 		"processId": "borrame1",
	-- 		"excludeContacted": 0
	-- 	}
	-- ]]

	-- ---------------------------
	-- -- Id = ? AND Name = ?
	-- ---------------------------
	-- local jsonRawConditions = [[
	-- 	{
	-- 		"values": [
	-- 			"id0001@vcc1",
	-- 			"emma01_nombre_59824111115"
	-- 		],
	-- 		"condition": "  Id = ? AND Id = ? ",
	-- 		"lines": [
	-- 			{
	-- 				"logicalOp": "",
	-- 				"leftParenth": "",
	-- 				"field": "Id",
	-- 				"conditionOp": "=",
	-- 				"value": "a",
	-- 				"rightParenth": "",
	-- 				"isCustomField": false
	-- 			},
	-- 			{
	-- 				"logicalOp": "AND",
	-- 				"leftParenth": "",
	-- 				"field": "Name",
	-- 				"conditionOp": "=",
	-- 				"value": "a",
	-- 				"rightParenth": "",
	-- 				"isCustomField": false
	-- 			}
	-- 		],
	-- 		"processId": "borrame1",
	-- 		"excludeContacted": 0
	-- 	}
	-- ]]

	-- ---------------------------
	-- -- (Range) AccountOfficer > ? (> >= < <=)
	-- ---------------------------
	-- local jsonRawConditions = [[
	-- 	{
	-- 		"values": [
	-- 			"4"
	-- 		],
	-- 		"condition": "  AccountOfficer > ?",
	-- 		"lines": [
	-- 			{
	-- 				"logicalOp": "",
	-- 				"leftParenth": "",
	-- 				"field": "AccountOfficer",
	-- 				"conditionOp": ">",
	-- 				"value": "a",
	-- 				"rightParenth": "",
	-- 				"isCustomField": false
	-- 			}
	-- 		],
	-- 		"processId": "borrame1",
	-- 		"excludeContacted": 0
	-- 	}
	-- ]]

	-- ---------------------------
	-- -- (Range) AccountOfficer > ? AND AccountOfficer < ?
	-- ---------------------------
	-- local jsonRawConditions = [[
	-- 	{
	-- 		"values": [
	-- 			"3",
	-- 			"5"
	-- 		],
	-- 		"condition": "  AccountOfficer > ? AND AccountOfficer < ? ",
	-- 		"lines": [
	-- 			{
	-- 				"logicalOp": "",
	-- 				"leftParenth": "",
	-- 				"field": "AccountOfficer",
	-- 				"conditionOp": ">",
	-- 				"value": "a",
	-- 				"rightParenth": "",
	-- 				"isCustomField": false
	-- 			},
	-- 			{
	-- 				"logicalOp": "AND",
	-- 				"leftParenth": "",
	-- 				"field": "AccountOfficer",
	-- 				"conditionOp": "<",
	-- 				"value": "a",
	-- 				"rightParenth": "",
	-- 				"isCustomField": false
	-- 			}
	-- 		],
	-- 		"processId": "borrame1",
	-- 		"excludeContacted": 0
	-- 	}
	-- ]]

	-- ---------------------------
	-- -- (Match / like) Name Like ? AND Id = ?
	-- ---------------------------
	-- local jsonRawConditions = [[
	-- 	{
	-- 		"values": [
	-- 			"de Mello",
	-- 			"id0001@vcc1"
	-- 		],
	-- 		"condition": " Name Like ? OR Id = ? ",
	-- 		"lines": [
	-- 			{
	-- 				"logicalOp": "",
	-- 				"leftParenth": "",
	-- 				"field": "Name",
	-- 				"conditionOp": "Like",
	-- 				"value": "de Mello",
	-- 				"rightParenth": "",
	-- 				"isCustomField": false
	-- 			},
	-- 			{
	-- 				"logicalOp": "OR",
	-- 				"leftParenth": "",
	-- 				"field": "Id",
	-- 				"conditionOp": "=",
	-- 				"value": "id0001@vcc1",
	-- 				"rightParenth": "",
	-- 				"isCustomField": false
	-- 			}
	-- 		],
	-- 		"processId": "borrame1",
	-- 		"excludeContacted": 0
	-- 	}
	-- ]]

	-----------------------------------
	print("1--> jsonRawConditions: " .. jsonRawConditions)
	return jsonRawConditions
end


local jsonRawConditions = GetJsonRawConditions()
local rawConditions = json.decode(jsonRawConditions)
local query = m_queries.queries.queries:MakeQuery("vcc1", rawConditions)
local encodedQuery = json.encode(query)
print("2--> encodedQuery: " .. encodedQuery)
print("----")
local result = m_client:SearchContacts(encodedQuery)
print('RESULT: ', json.encode(result))

------------------------------------------------------------------------

local function HardCodeExecute ()
	------------------------
	--ALL -
	------------------------
	--
 	local result = m_client:SearchContacts(json.encode(
		{
			vcc = "vcc1",
		--	size = 3, -- rows per page
			conditions = {
				type = "must",
				conditions = {}
			}
		}
	))

	-- ------------------------
	-- -- id = ?
	-- ------------------------
	-- local result = m_client:SearchContacts(json.encode(
	-- 	{
	-- 		vcc = "vcc1",
	-- 		conditions = {
	-- 			type = "must",
	-- 			conditions = {
	-- 				{
	-- 					---term---------
	-- 					type = "term",
	-- 					name = "Id",
	-- 					value = "id0001@vcc1"
	-- 				}
	-- 			}
	-- 		}
	-- 	}
	-- ))

	-- ------------------------
	-- --(DISTINTO) id <> ?
	-- ------------------------
	-- local result = m_client:SearchContacts(json.encode(
	-- 	{
	-- 		vcc = "vcc1",
	-- 		conditions = {
	-- 			type = "must_not",
	-- 			conditions = {
	-- 				{
	-- 					---term---------
	-- 					type = "term",
	-- 					name = "Id",
	-- 					value = "id0001@vcc1"
	-- 				}
	-- 			}
	-- 		}
	-- 	}
	-- ))

	-- -- ------------------------
	-- -- -- id = ? OR id = ?
	-- -- ------------------------
	-- local result = m_client:SearchContacts(json.encode(
	-- 	{
	-- 		vcc = "vcc1",
	-- 		conditions = {
	-- 			type = "or",
	-- 			conditions = {
	-- 				{
	-- 					---term---------
	-- 					type = "term",
	-- 					name = "Id",
	-- 					value = "id0001@vcc1"
	-- 				},
	-- 				{
	-- 					---term---------
	-- 					type = "term",
	-- 					name = "Id",
	-- 					value = "id0002@vcc1"
	-- 				}
	-- 			}
	-- 		}
	-- 	}
	-- ))

	-- -- ------------------------
	-- -- -- id = ? OR (id = ? AND name = ?)
	-- -- ------------------------
	-- local result = m_client:SearchContacts(json.encode(
	-- 	{
	-- 		vcc = "vcc1",
	-- 		conditions = {
	-- 			type = "or",
	-- 			conditions = {
	-- 				{
	-- 					---term---------
	-- 					type = "term",
	-- 					name = "Id",
	-- 					value = "id0001@vcc1"
	-- 				},
	-- 				{
	-- 					type = "must",
	-- 					conditions = {
	-- 						{
	-- 							---term---------
	-- 							type = "term",
	-- 							name = "Id",
	-- 							value = "id0002@vcc1"
	-- 						},
	-- 						{
	-- 							---term---------
	-- 							type = "term",
	-- 							name = "Name",
	-- 							value = "emma02_nombre_59824111115"
	-- 						}
	-- 					}
	-- 				}
	-- 			}
	-- 		}
	-- 	}
	-- ))

	-- ------------------------
	-- -- id = ? AND name = ?
	-- ------------------------
	-- local result = m_client:SearchContacts(json.encode(
	-- 	{
	-- 		vcc = "vcc1",
	-- 		conditions = {
	-- 			type = "must",
	-- 			conditions = {
	-- 				{
	-- 					---term---------
	-- 					type = "term",
	-- 					name = "Id",
	-- 					value = "id0002@vcc1"
	-- 				},
	-- 				{
	-- 					---term---------
	-- 					type = "term",
	-- 					name = "Name",
	-- 					value = "emma02_nombre_59824111115"
	-- 				}
	-- 			}
	-- 		}
	-- 	}
	-- ))

	-- ------------------------
	-- -- id = ? AND name = ?
	-- ------------------------
	-- local result = m_client:SearchContacts(json.encode(
	-- 	{
	-- 		vcc = "vcc1",
	-- 		conditions = {
	-- 			type = "or",
	-- 			conditions = {
	-- 				{
	-- 					---term---------
	-- 					type = "match",
	-- 					name = "Name",
	-- 					value = "de mello"
	-- 				},
	-- 				{
	-- 					---term---------
	-- 					type = "term",
	-- 					name = "Name",
	-- 					value = "emma02_nombre_59824111115"
	-- 				}
	-- 			}
	-- 		}
	-- 	}
	-- ))


	print('HardCodeExecute--> RESULT: ', json.encode(result))
end


--HardCodeExecute()


-- 		---term---------
-- 		-- type = "term",
-- 		-- name = "Id",
-- 		-- value = "id1@vcc1"
-- 		--

-- 		---terms---------
-- 		-- type = "terms",
-- 		-- name = "Id",
-- 		-- terms = {
-- 		-- 	"id1@vcc1",
-- 		-- 	"12ef7b97-f15c-4989-bbf3-cecf1c9788d3@vcc1"
-- 		-- },

-- 		-- ---must -> terms---------
-- 		-- type = "must",
-- 		-- --type = "must_not",
-- 		-- conditions = {
-- 		-- 	{
-- 		-- 		type = "term",
-- 		-- 		name = "Id",
-- 		-- 		term = 
-- 		-- 			"id1@vcc1",
				-- conditions = {
                --      {
				-- 		 type = "or"

				-- 	 },
				-- 	 {

				-- 	 }

--				}
-- 		-- 	}
-- 		-- },

-- 		-- ---match ---------
-- 		-- type = "match",
-- 		-- name = "Id",
-- 		-- value = "id1@vcc1"
-- 		-- --

-- 		---exists ---------
-- 		type = "exists",
-- 		name = "Id",
-- 	--	value = "idasdfasdfds1"
-- 		--

-- 		--type = "or",
-- 		--type = "must",
-- 		--type = "must_not",
-- 		-- conditions = {
-- 		-- 	-- {
-- 		-- 	-- 	type = "term",
-- 		-- 	-- 	name = "Id",
-- 		-- 	-- 	--value = "12ef7b97-f15c-4989-bbf3-cecf1c9788d3@vcc1"
-- 		-- 	-- 	value = "id1@vcc1"
-- 		-- 	-- }
-- 		-- }
-- 		------------
-- 		-- type = "term",
-- 		-- conditions = {
-- 		-- 	{
-- 		-- 		type = "term",
-- 		-- 		name = "Id",
-- 		-- 		--value = "12ef7b97-f15c-4989-bbf3-cecf1c9788d3@vcc1"
-- 		-- 		value = "id1@vcc1"
-- 		-- 	}
-- 		-- }

-- 	}
-- }))

-- local result = m_client:SearchContacts(json.encode({
-- 	vcc = "vcc1",
-- 	conditions = {
-- 		type = "must",
-- 		conditions = {
-- 			{
-- 				type = "term",
-- 				name = "Name",
-- 				value = "emma01_nombre_59824111115"
-- 				--value = "Emma01_nombre_59824111115"
-- 				--value = "ellio alejandro de mello pena"
-- 			},

-- 			-- {
-- 			-- 	type = "range",
-- 			-- 	name = "AccountOfficer",
-- 			-- 	value ="4",
-- 			-- 	operator = "gt"
-- 			-- },


-- 			-- {
-- 			-- 	type = "term",
-- 			-- 	name = "Id",
-- 			-- 	value ="id0002@vcc1"
-- 			-- },
-- 			-- {
-- 			-- 	type = "must",
-- 			-- 	conditions = {
-- 			-- 		{
-- 			-- 			type = "term",
-- 			-- 			name = "Id",
-- 			-- 			value ="id0003@vcc1"
-- 			-- 		},
-- 			-- 		{
-- 			-- 			type = "term",
-- 			-- 			name = "Name",
-- 			-- 			value ="emma03_nombre_59824111115"
-- 			-- 			-- name = "Name",
-- 			-- 			-- value ="Nombre_59824000000"
-- 			-- 		},
-- 			-- 		-- {
-- 			-- 		-- 	type = "term",
-- 			-- 		-- 	name = "Name",
-- 			-- 		-- 	value ="emma03_nombre_59824111115"
-- 			-- 		-- 	-- name = "Name",
-- 			-- 		-- 	-- value ="Nombre_59824000000"
-- 			-- 		-- },
-- 			-- 	}
-- 			-- },
-- 			-- {
-- 			-- 	type = "match",
-- 			-- 	name = "Name",
-- 			-- 	value ="de Mello"
-- 			-- }
-- 		}

