local m_definitions = {
	basic = {
		isSimple = true,
		--GetEntity = nil, -- custom function con la cual podemos obtener la entidad segun el JSON.
		fields   = {
			{
				field_id = "Id",
				validations = {
					id_without_dots     = "Only letters, numbers and dashes are allowed in the vcc Id.",
					html_malicious_code = "Possible malicious code in the vcc Id.",
					maxLength = {
						max    = 20,
						reason = "Allowed %s characters max length in vcc Id. Current length is %s characters."
					}
				}
			}
		}
	}
}

local function FindFiledValidation (fieldType, fieldName)
	local definitionType = m_definitions[fieldType]
	if not definitionType then return end
	local fieldValidation
	for _, def in ipairs(definitionType.fields or {}) do
		if def.field_id == fieldName then
			fieldValidation = def
			break
		end
	end
	return fieldValidation, definitionType
end

return {
	FindFiledValidation = FindFiledValidation,
	GetDefinitions      = function() return m_definitions end
}
