/* jshint forin:true, noarg:true, jquery:true, noempty:true, eqeqeq:true, bitwise:true,
	strict:true, undef:true, unused:vars, curly:true, browser:true, indent:false, maxerr:50, quotmark:double, esversion: 9 */

/* global $, inConcert */

if (!this.inConcert) {
	this.inConcert = {};
}

(function () {
	//"use strict";

	//---------------------------------------------------------------------
	// form ice server class
	function form_provisioning_ice_servers(params)
	{
		const success = form_provisioning_ice_servers.uber.constructor.call(this, params);
		if (!success) {
			return;
		}

		this.new_title = "<%=_T('Create ICE Server')%>";
		this.update_title = "<%=_T('Edit ICE Server')%>";
		this.view_title = "<%=_T('View ICE Server')%>";
		this.tagline = "<%=_T('Tagline form Ice Server!!!')%>";

		this.html_file_name = "/inconcert/apps/provisioning/ice_servers/frm/render/";
		this.save_uri =       "/inconcert/apps/provisioning/ice_servers/save/";
		this.get_uri =        "/inconcert/apps/provisioning/ice_servers/get/";

		return true;
	}

	inConcert.Utils.inherit(form_provisioning_ice_servers, inConcert.conf_form);

	if (typeof inConcert.form_provisioning_ice_servers !== "function") {
		inConcert.form_provisioning_ice_servers = form_provisioning_ice_servers;
	}

	form_provisioning_ice_servers.prototype.get = function()
	{
		let iceServer = {
			user    : $("#prov_form_iceserver_user").val(),
			password: $("#prov_form_iceserver_password").val(),
			domain  : $("#prov_form_iceserver_domain").val(),
			port    : $("#prov_form_iceserver_port").val()
		};

		if ($("#prov_form_iceserver_id").val()) {
			iceServer.id = $("#prov_form_iceserver_id").val()
		}

		return iceServer;
	};

	form_provisioning_ice_servers.prototype.set = function(success, iceServer)
	{
		if (!success) {
			return;
		}
		$("#prov_form_iceserver_id").val(iceServer.serverId);
		$("#prov_form_iceserver_user").val(iceServer.user);
		$("#prov_form_iceserver_password").val(iceServer.password);
		$("#prov_form_iceserver_domain").val(iceServer.domain);
		$("#prov_form_iceserver_port").val(iceServer.port);
	};

	form_provisioning_ice_servers.prototype.empty_controls = function()
	{
		$("#prov_form_iceserver_id").val("");
		$("#prov_form_iceserver_user").val("").focus();
		$("#prov_form_iceserver_password").val("");
		$("#prov_form_iceserver_domain").val("");
		$("#prov_form_iceserver_port").val("");
	};

	form_provisioning_ice_servers.prototype.err_save_messages = function(err, is_custom_message)
	{
		var get_error_description = function(err_type/*, raw_data = {}*/)
		{
			is_custom_message = true;
			let message;
			switch (err_type)
			{
				case "E_INVALID_PARAM":
					message = "<%=_T('The data provided is invalid.')%>";
				break;

				case "E_NOT_EXISTS":
					message = "<%=_T('The ICE Server does not exists.')%>";
				break;

				case "E_EXISTS":
					message = "<%=_T('The ICE Server information provided already exists.')%>";
				break;

				default:
					is_custom_message = false;
					message = "<%=_T('Server error!!')%>";
			}
			return message;
		};

		switch (typeof err) {
			case "object":
				const error_type = err.result.toUpperCase();
				err = get_error_description(error_type, err.rawData);
			break;

			case "string":
				err = get_error_description(err.toUpperCase());
			break;
		}

		form_provisioning_ice_servers.uber.err_save_messages.call(this, err, is_custom_message); //invokes the base class method
	};

	form_provisioning_ice_servers.prototype.get_validation_def = function()
	{
		const definitions = [
			{
				control_id: "prov_form_iceserver_domain",
				messages: {
					required: "<%=_T('Please enter the Server URL.')%>"
				}
			},
			{
				control_id: "prov_form_iceserver_port",
				messages: {
					required: "<%=_T('Please enter the Port.')%>",
					range: {
						type   : "range",
						between: {from: 0, to: 65535},
						message: "<%=_T('Ice Server Port allowed values between {0} to {1}.')%>"
					}
				}
			},
			{
				control_id: "prov_form_iceserver_user",
				messages: {
					required: "<%=_T('Please enter the User.')%>",
				}
			},
			{
				control_id: "prov_form_iceserver_password",
				messages: {
					required: "<%=_T('Please enter the Password.')%>"
				}
			}
		];
		return definitions;
	};

	form_provisioning_ice_servers.prototype.ready = function()
	{
		form_provisioning_ice_servers.uber.ready.call(this); //invokes the base class method
		$("#prov_form_iceserver_domain").focus();
	};
}());
