/* jshint forin:true, noarg:true, jquery:true, noempty:true, eqeqeq:true, bitwise:true,
	strict:true, undef:true, unused:vars, curly:true, browser:true, indent:false, maxerr:50, quotmark:double, esversion: 11 */

/* global inConcert */

if (!this.inConcert) {
	this.inConcert = {};
}

(function () {
	//"use strict";

	const FORMAT = inConcert.Utils.format;
	const _T = inConcert.i18n.getString;

	//---------------------------------------------------------------------
	// form VCCs class
	function prov_form_vccs(params)
	{
		const self = this;
		const success = prov_form_vccs.uber.constructor.call(this, params);
		if (!success) {
			return;
		}

		this.new_title    = "<%=_T('New Contact Center')%>";
		this.update_title = "<%=_T('Update Contact Center {0}')%>";
		this.view_title   = "<%=_T('View Contact Center {0}')%>";
		this.tagline      = "<%=_T('Tagline form Contact Center!!!')%>";

		this.html_file_name = "/inconcert/apps/provisioning/vccs/frm/render/";
		this.get_uri        = "/inconcert/apps/provisioning/vccs/get/";

		this.include_save_and_continue = false;
		this.requests = [];
		this.m_vcc = null;

		var __can_view_section = function (section) {
			if (!section.custom_can_show) {
				return true;
			}
			return section.custom_can_show();
		};

		var __custom_can_show_i6_section = function ()
		{
			const vcc = self.get_entity_instance();
			if (vcc && vcc.HasAllegroIntegration) {
				return false;
			}
			return true;
		};

		var __get_instance = function (section_id)
		{
			switch(section_id)
			{
				case "basic":
					return inConcert.prov_form_vccs_basic;
				case "cognitive_services":
					 return inConcert.prov_form_vccs_cognitive_services;
				case "omnichannel_telephony":
					return inConcert.form_provisioning_vccs_section_omnichannel_telephony;
				default:
					throw "prov_form_vccs.__get_instance. Unrecognized instance: " + section_id;
			}
		};

		// definicion de las secciones del formulario.
		this.sections = {
			"basic": {
				name               : "<%=_T('Basic Information')%>",
				action_id          : "view_vccs",
				instance           : function(entity_id) { return __get_instance("basic", entity_id);                 },
				initial_state      : "enabled",
				selected           : true,
				can_show           : function(section) { return __can_view_section(section);                          }
			},
			"cognitive_services"   : {
				name               : "<%=_T('Cognitive Services')%>",
				action_id          : "view_vccs",
				instance           : function(entity_id) { return __get_instance("cognitive_services", entity_id);    },
				can_show           : function(section) { return __can_view_section(section);                          }
			},
			"omnichannel_telephony": {
				name               : "<%=_T('Telephony Resources')%>",
				action_id          : "view_vccs",
				instance           : function(entity_id) { return __get_instance("omnichannel_telephony", entity_id); },
				can_show           : function(section) { return __can_view_section(section);                          },
				custom_can_show    : function() { return __custom_can_show_i6_section();                              }
			}
		};
		this.create_sections(this);

		return true;
	}

	inConcert.Utils.inherit(prov_form_vccs, inConcert.conf_form);

	if (typeof inConcert.form_provisioning_vccs !== "function") {
		inConcert.form_provisioning_vccs = prov_form_vccs;
	}

	prov_form_vccs.prototype.get = function()
	{
		let vcc_object;
		if (this.is_new) {
			const vcc_def = this.sections.basic.frm.get();
			vcc_object = this.new_entity(vcc_def);
		}
		else {
			vcc_object = this.m_vcc;
			$.each(this.sections, function(_, section)
			{
				if (!section.frm) {
					return true; // continue
				}
				section.frm.get(vcc_object);
			});
		}
		return vcc_object;
	};

	prov_form_vccs.prototype.new_entity = function(vcc)
	{
		if (typeof vcc !== "object") {
			return;
		}
		this.m_vcc = vcc || {};
		return this.m_vcc;
	};

	prov_form_vccs.prototype.get_entity = function()
	{
		return this.m_vcc;
	};

	prov_form_vccs.prototype.get_entity_id = function()
	{
		if (this.m_vcc) {
			return this.m_vcc.Id;
		}
	};

	prov_form_vccs.prototype.get_entity_display_name = function()
	{
		let display_name = "";
		if (this.m_vcc) {
			display_name = this.m_vcc.Description || this.m_vcc.Id;
		}
		return display_name;
	};

	prov_form_vccs.prototype.get_entity_instance = function()
	{
		return this.m_vcc;
	};

	prov_form_vccs.prototype.set = function(success, vcc_info)
	{
		if (!success || !vcc_info) {
			return;
		}
		this.new_entity(vcc_info);
	};

	prov_form_vccs.prototype.switch_tab_section_basic = function(tab_id)
	{
		if (this.current_section !== "basic") {
			return;
		}
		const section = this.sections[this.current_section];
		if (!section || !section.frm) {
			return;
		}
		section.frm.switch_tab(tab_id);
	};

	prov_form_vccs.prototype.err_save_messages = function(err)
	{
		const self = this;

		if (typeof err !== "object") {
			prov_form_vccs.uber.err_save_messages.call(this, err, false /* custom message*/);  //invokes the base class method
			return;
		}

		const tranlate_resource_type_fn = function (resource_type) {
			resource_type = (resource_type || "").toUpperCase();
			const translated = {
				"LOW"         : "<%=_T('LOW')%>",
				"MEDIUM_LIGHT": "<%=_T('MEDIUM_LIGHT')%>",
				"MEDIUM"      : "<%=_T('MEDIUM')%>",
				"HIGH"        : "<%=_T('HIGH')%>"
			};
			return translated[resource_type] || resource_type;
		};

		let is_custom_message = false;
		const get_error_description = function(err_type)
		{
			is_custom_message = true;
			let message;
			switch (err_type)
			{
				case "ALLEGRO_INTEGRATION_ERROR":
					message = "<%=_T('Allegro integration error.')%>";
				break;

				case "FORBIDDEN":
					message = "<%=_T('Unable to save Contact Center. You not has permissions.')%>";
				break;

				case "API SDK - RATE LIMIT HAS EXCEEDED WHAT IS ALLOWED IN THE SYSTEM":
					message = FORMAT("<%=_T('API SDK - Bad Configuration. {0} Rate Limit has exceeded what is allowed in the system. Max Requests: {1}, Time {2} (sec).')%>",
						tranlate_resource_type_fn(err.info.resourceType), err.info.systemRateLimits.maxRequests, err.info.systemRateLimits.timeLimitSec);
					// me muevo al tab others en la section basic
					self.switch_tab_section_basic("others");
				break;

				case "API SDK - RATE LIMIT OF ALL VCSS HAS EXCEEDED WHAT IS ALLOWED IN THE SYSTEM":
					message = FORMAT("<%=_T('API SDK - Bad Configuration. {0} Rate Limit of all VCCs has exceeded what is allowed in the system. Available Max Requests: {1} in Time {2} (sec).')%>",
					tranlate_resource_type_fn(err.info.resourceType), err.info.available, err.info.systemRateLimits.timeLimitSec);
					// me muevo al tab others en la section basic
					self.switch_tab_section_basic("others");
				break;

				case "INVALID_VCC_NAME":
					message = "<%=_T('Invalid Contact Center Name.')%>";
					// me muevo al tab basic en la section basic
					self.switch_tab_section_basic("basic");
				break;

				case "INVALID_CHARS_ON_VCC_NAME":
					message = "<%=_T('Only letters, numbers and dashes are allowed in the Contact Center Name.')%>";
					// me muevo al tab basic en la section basic
					self.switch_tab_section_basic("basic");
				break;
				case "INVALID_ALL_NUMBER_ON_VCC_NAME":
					message = "<%=_T('The contact center name cannot be all numbers.')%>";
					self.switch_tab_section_basic("basic");
				break;

				case "INVALID_VCC_NAME_LEN":
					let contactCenterNameOptions = self.get_contact_center_name_options();
					message = FORMAT("<%=_T('The Contact Center Name length must be between {0} and {1}.')%>", contactCenterNameOptions.min_length, contactCenterNameOptions.max_length );
					// me muevo al tab basic en la section basic
					self.switch_tab_section_basic("basic");
				break;

				case "S3_NO_REPOSITORY_DATA":
					message = "<%=_T('Internal Error. Unable to retrieving repository data for the vcc.')%>";
					// me muevo al tab others en la section basic
					self.switch_tab_section_basic("others");
				break;

				case "S3_BUCKET_NOT_EXISTS":
					message = "<%=_T('The provided predefined bucket does not exist or the provided credentials are invalid. Check if the selected region is the region where the bucket is.')%>";
					// me muevo al tab others en la section basic
					self.switch_tab_section_basic("others");
				break;

				case "S3_BUCKET_CREATION_FAILED":
					message = "<%=_T('The provided AWS S3 credentials are not valid or the selected region is not available in your location.')%>";
					// me muevo al tab others en la section basic
					self.switch_tab_section_basic("others");
				break;

				case "S3_BUCKET_LIFECYCLE_FAILED":
					message = "<%=_T('Data saved but unable to apply lifecycle rule to the S3 storage.')%>";
					// me muevo al tab others en la section basic
					self.switch_tab_section_basic("others");
				break;

				case "S3_LIFECYLE_MAX_RATE_FAILED":
					message = "<%=_T('Data saved but unable to apply lifecycle rule to the S3 storage and unable to apply maximum manual rate to some processes.')%>";
					// me muevo al tab others en la section basic
					self.switch_tab_section_basic("others");
				break;

				case "MANUAL_RATE_CHANGE_FAILED":
					message = "<%=_T('Data saved but unable to apply maximum manual rate to some processes.')%>";
					// me muevo al tab others en la section basic
					self.switch_tab_section_basic("others");
				break;

				case "ERROR_FIELDS_VALIDATION":
					message = err.reason;
					// me muevo al tab basic
					self.switch_tab_section_basic("basic");
				break;
		
				default:
					// TODO: para traducir estos tipos de mensajes de error hay que conocer cuales son y traducirlos en los .PO del repo "Agent", JS "language.js"
					message = _T(err.result);
				break;
			}
			return message || "<%=_T('Unable to save Contact Center. Server error.')%>";
		};

		const error_type = err.result.toUpperCase();
		if (error_type === "MUST_HAVE_A_NAME" || error_type === "MUST_HAVE_UNIQUE_NAME") {
			$("#prov_form_vcc_basic_name").focus();
		}
		else if (error_type === "MUST_HAVE_A_DESCRIPTION") {
			$("#prov_form_vcc_basic_desc").focus();
		}
		else {
			err = get_error_description(error_type, err.raw_error);
		}

		prov_form_vccs.uber.err_save_messages.call(this, err, is_custom_message); //invokes the base class method
	};

	prov_form_vccs.prototype.get_validation_def = function()
	{
		const definitions = [];
		$.each(this.sections, function(_, section)
		{
			if (!section.frm) {
				return true; //continue
			}
			section.frm.get_validation_def(definitions);
		});
		return definitions;
	};

	prov_form_vccs.prototype.load_data = function(callback_complete_requests, vcc_id)
	{
		const self = this;
		this.requests = [];

		$.each(this.sections, function(_, section)
		{
			if (!section.frm) {
				return true; // continue
			}
			section.frm.attach_load_request(self.requests, vcc_id);
		});

		prov_form_vccs.uber.load_data.call(this, callback_complete_requests, vcc_id); //invokes the base class method
	};

	prov_form_vccs.prototype.save_execute = function(after_save, entity/*, hash_id */)
	{
		const self = this;
		const is_created = this.is_new;

		var callback_response = function(success, response)
		{
			if (self.is_new) {
				after_save = "SAVE_AND_NOT_EXIT";
			}
			else {
				after_save = "SAVE_WITHOUT_ACTION";
			}
			self.on_saved(success, entity, after_save, response, is_created);
		};

		const provisioning_api = inConcert.app.getProvisioningAPI();
		provisioning_api.saveVcc(entity,
			function(success, err) {
				callback_response(success, err);
			}
		);
	};

	prov_form_vccs.prototype.save = function()
	{
		if (this.current_section === "basic") {
			prov_form_vccs.uber.save.call(this); //invokes the base class method
			return;
		}
		let section = this.sections[this.current_section];
		if (section && section.frm) {
			if (this.current_section === "cognitive_services") {
				section.frm.save_execute();
			}
			else if (this.current_section === "omnichannel_telephony") {
				section.frm.save_execute();
			}
			else {
				throw("prov_form_vccs.prototype.save - Unrecognized section: " + this.current_section);
			}
		}
		else {
			throw("prov_form_vccs.prototype.save - There is no instance of the section: " + this.current_section);
		}
	};

	prov_form_vccs.prototype.on_saved = function(success, entity, after_save, response, is_created)
	{
		const self = this;

		var on_saved = function() {
			prov_form_vccs.uber.on_saved.call(self, success, entity, after_save, response); //invokes the base class method
			if (!self.is_new) {
				self.enable_all_sections();
			}
		};
		on_saved();

		if (!success) {
			return;
		}

		const section = this.sections[this.current_section];
		if (section && section.frm && section.frm.only_modified) {
			section.frm.only_modified(entity, is_created, response);
		}
	};

	prov_form_vccs.prototype.dispose = function()
	{
		prov_form_vccs.uber.dispose.call( this ); //invokes the base class method
		this.m_vcc = null;
	};

	prov_form_vccs.prototype.enable_all_sections = function()
	{
		this.disabled_all_sub_menus(false);
		if (!this.current_section) {
			return;
		}
		this.mark_sub_menu_option(this.current_section);
	};

	prov_form_vccs.prototype.can_save = function(entity)
	{
		const section = this.sections[this.current_section];
		if (section.frm.on_before_save) {
			return section.frm.on_before_save(entity);
		}

		return true;
	};

	prov_form_vccs.prototype.get_contact_center_name_options = function()
	{
		return {
			max_length : 20,
			min_length : 3
		};
	};
}());
