/* jshint forin:true, noarg:true, jquery:true, noempty:true, eqeqeq:true, bitwise:true,
	strict:true, undef:true, unused:vars, curly:true, browser:true, indent:false, maxerr:50, esversion: 9 */

/* global $, inConcert */

if (!this.inConcert) {
	this.inConcert = {};
}

(function () {
	//"use strict";

	//---------------------------------------------------------------------
	// Peers Management
	function ProvisioningPeersMng(params)
	{
		if (!params) {
			throw("ProvisioningPeersMng - 'params' is required");
		}
		if (!params.frm) {
			throw("ProvisioningPeersMng - 'params.frm' is required");
		}
		if (!params.prefix) {
			throw("ProvisioningPeersMng - 'params.prefix' is required");
		}
		if (!params.container_id) {
			throw("ProvisioningPeersMng - 'params.container_id' is required");
		}

		this.frm = params.frm;
		this.prefix = params.prefix + "_";
		this.container_id = params.container_id;
		this.codecs_mng = null;
		this.tech_specific_mng = null;
		this.m_frm_type = null; //"RANGE-NEW";
		this.m_must_update_owner_frm_title = typeof(params.must_update_owner_frm_title) === "boolean" ? params.must_update_owner_frm_title : false;

		return true;
	}

	if (typeof inConcert.ProvisioningPeersMng !== "function") {
		inConcert.ProvisioningPeersMng = ProvisioningPeersMng;
	}

	ProvisioningPeersMng.prototype.initialize = function()
	{
		this.__make_html();

		this.codecs_mng = new inConcert.ProvisioningCodecsMng({
			owner         : this.frm,
			prefix        : this.prefix,
			container_id  : this.prefix + "codecs_panel",
			fields_per_row: 7,
			codecs_list   : [
				{id: "alaw" , name: "alaw" },
				{id: "ulaw" , name: "ulaw" },
				{id: "opus" , name: "opus" },
				{id: "g729" , name: "g729" },
				{id: "speex", name: "speex"},
				{id: "vp8"  , name: "vp8"  }
			]
		});
		this.codecs_mng.initialize();

		this.tech_specific_mng = new inConcert.ProvisioningTechSpecificMng({
			owner       : this.frm,
			prefix      : this.prefix + "tech_specific_data",
			container_id: this.prefix + "tech_specific_data_panel"
		});
		this.tech_specific_mng.initialize();
	};

	ProvisioningPeersMng.prototype.__make_html = function()
	{
		let html = '' +
			// Peers Basic Information -->
			'<div id="'+ this.prefix + 'basic_data_panel" class="card">' +
				'<div class="card-block">' +
					// 1- Range New Peers Container
					'<div id="'+ this.prefix + 'range_new_container" class="row" style="display:none;">' +
						'<div class="col-3">' +
							'<div class="form-group">' +
								'<label for="'+ this.prefix + 'range_first_new_peer_number" class="required"><%=_T([[First IP Phone Number]])%><%=_T([[:]])%></label>' +
								'<input id="'+ this.prefix + 'range_first_new_peer_number" class="form-control" type="text" placeholder="<%=_T([[Enter the value]])%><%=_T([[...]])%>" />' +
								'<i id="'+ this.prefix + 'range_first_new_peer_number_validation" class="formFieldValidation formFieldError" hidden></i>' +
							'</div>' +
						'</div>' +
						'<div class="col-3">' +
							'<div class="form-group">' +
								'<label for="'+ this.prefix + 'range_new_peer_count" class="required"><%=_T([[IP Phone Count]])%><%=_T([[:]])%></label>' +
								'<input id="'+ this.prefix + 'range_new_peer_count" class="form-control" type="text" placeholder="<%=_T([[Enter the value]])%><%=_T([[...]])%>" />' +
								'<i id="'+ this.prefix + 'range_new_peer_count_validation" class="formFieldValidation formFieldError" hidden></i>' +
							'</div>' +
						'</div>' +
						'<div class="col-3">' +
							'<div class="form-group">' +
								'<label for="'+ this.prefix + 'range_new_peer_tech" class="required"><%=_T([[Technology]])%><%=_T([[:]])%></label>' +
								'<select id="'+ this.prefix + 'range_new_peer_tech" class="form-control" placeholder="<%=_T([[Select technology]])%><%=_T([[...]])%>"></select>' +
								'<i id="'+ this.prefix + 'range_new_peer_tech_validation" class="formFieldValidation formFieldError" hidden></i>' +
							'</div>' +
						'</div>' +
					'</div>' +
					// 2- Range Update Peers Container
					'<div id="'+ this.prefix + 'range_update_container" class="row" style="display:none;">' +
						'<div class="col-3">' +
							'<div class="form-group">' +
								'<label for="'+ this.prefix + 'range_first_update_peer_number" class="required"><%=_T([[First IP Phone Number]])%><%=_T([[:]])%></label>' +
								'<select id="'+ this.prefix + 'range_first_update_peer_number" class="form-control" placeholder="<%=_T([[Select technology]])%><%=_T([[...]])%>"></select>' +
								'<i id="'+ this.prefix + 'range_first_update_peer_number_validation" class="formFieldValidation formFieldError" hidden></i>' +
							'</div>' +
						'</div>' +
						'<div class="col-3">' +
							'<div class="form-group">' +
								'<label for="'+ this.prefix + 'range_update_peer_count" class="required"><%=_T([[IP Phone Count]])%><%=_T([[:]])%></label>' +
								'<input id="'+ this.prefix + 'range_update_peer_count" class="form-control" type="text" placeholder="<%=_T([[Enter the value]])%><%=_T([[...]])%>" />' +
								'<i id="'+ this.prefix + 'range_update_peer_count_validation" class="formFieldValidation formFieldError" hidden></i>' +
							'</div>' +
						'</div>' +
						'<div class="col-3">' +
							'<div class="form-group">' +
								'<label for="'+ this.prefix + 'range_update_peer_tech" class="required"><%=_T([[Technology]])%><%=_T([[:]])%></label>' +
								'<select id="'+ this.prefix + 'range_update_peer_tech" class="form-control" placeholder="<%=_T([[Select technology]])%><%=_T([[...]])%>"></select>' +
								'<i id="'+ this.prefix + 'range_update_peer_tech_validation" class="formFieldValidation formFieldError" hidden></i>' +
							'</div>' +
						'</div>' +
					'</div>' +
					// 3 - Only One Peer Container
					'<div id="'+ this.prefix + 'only_one_container" class="row" style="display:none;">' +
						'<div class="col-3">' +
							'<div class="form-group">' +
								'<label for="'+ this.prefix + 'only_one_peer_number"><%=_T([[IP Phone Number]])%><%=_T([[:]])%></label>' +
								'<input id="'+ this.prefix + 'only_one_peer_number" class="form-control" type="text" />' +
								'<i id="'+ this.prefix + 'only_one_number_validation" class="formFieldValidation formFieldError" hidden></i>' +
							'</div>' +
						'</div>' +
						'<div class="col-3">' +
							'<div class="form-group">' +
								'<label for="'+ this.prefix + 'only_one_tech"><%=_T([[Technology]])%><%=_T([[:]])%></label>' +
								'<select id="'+ this.prefix + 'only_one_tech" class="form-control"></select>' +
								'<i id="'+ this.prefix + 'only_one_tech_validation" class="formFieldValidation formFieldError" hidden></i>' +
							'</div>' +
						'</div>' +
					'</div>' +
					// 4 - Others ctrls
					'<div class="row">' +
						'<div class="col-3">' +
							'<div class="form-group">' +
								'<label for="'+ this.prefix + 'pwd" class="required"><%=_T([[Password]])%><%=_T([[:]])%></label>' +
								'<input id="'+ this.prefix + 'pwd" class="form-control" type="text" placeholder="<%=_T([[Enter the password]])%><%=_T([[...]])%>" />' +
								'<i id="'+ this.prefix + 'pwd_validation" class="formFieldValidation formFieldError" hidden></i>' +
							'</div>' +
						'</div>' +
						'<div class="col-3">' +
							'<div class="form-group">' +
								'<label for="'+ this.prefix + 'host" class="required"><%=_T([[Node]])%><%=_T([[:]])%></label>' +
								'<select id="'+ this.prefix + 'host" class="form-control" placeholder="<%=_T([[Select node]])%><%=_T([[...]])%>"></select>' +
								'<i id="'+ this.prefix + 'host_validation" class="formFieldValidation formFieldError" hidden></i>' +
							'</div>' +
						'</div>' +
					'</div>' +
				'</div>' +
			'</div>' +

			// codecs
			'<div class="card">' +
				'<div id="'+ this.prefix + 'codecs_panel" class="card-block">' +
					// Este markup se genera en el javascript "codecs_mng.js"
				'</div>' +
			'</div>' +

			// codecs Tech specific data
			'<div id="'+ this.prefix + 'tech_specific_data_panel" class="card">' +
				// Este markup se genera en el javascript "tech_specific_mng.js" -->
			'</div>';

		const $container = $("#" + this.container_id);
		$container.html(html);
	};

	ProvisioningPeersMng.prototype.get = function(force_new)
	{
		let is_new = this.frm.is_creating() || force_new;
		let peer = {
			hostId      : $("#" + this.prefix + "host").val(),
			password    : $("#" + this.prefix + "pwd").val()
		};
		// tech dependiendo del tipo de actualizacion (range / only one)
		if (is_new) {
			// range
			peer.tech = $("#" + this.prefix + "range_new_peer_tech").val();
		}
		else {
			// only one
			if (this.m_frm_type === "UPDATE ONLY ONE") {
				peer.tech = $("#" + this.prefix + "only_one_tech").val();
				peer.name = $("#" + this.prefix + "only_one_peer_number").val();
			}
			else {
				peer.tech = $("#" + this.prefix + "range_update_peer_tech").val();
			}
		}

		// optionals codecs
		this.codecs_mng.get(peer);
		// tech specific data
		this.tech_specific_mng.get(peer);

		if (!is_new) {
			const action = this.frm.dashboard.get_current_action_obj();
			const id = action.view.row_id;
			peer[id] = this.frm.$current_row.attr("row_id");
		}

		return peer;
	};

	ProvisioningPeersMng.prototype.set = function(success, peer, not_set_peer_name_in_update_by_range)
	{
		if (!success) {
			return;
		}
		// tech de la seccion new range
		$("#" + this.prefix + "range_new_peer_tech").val(peer.tech);
		// tech de la seccion update range
		$("#" + this.prefix + "range_update_peer_tech").val(peer.tech);
		if (!not_set_peer_name_in_update_by_range) {
			$("#" + this.prefix + "range_first_update_peer_number").val(peer.name);
		}
		// tech de la seccion only
		$("#" + this.prefix + "only_one_tech").val(peer.tech);
		$("#" + this.prefix + "only_one_peer_number").val(peer.name);
		// otros
		$("#" + this.prefix + "host").val(peer.hostId);
		$("#" + this.prefix + "pwd").val(peer.password);
		// codecs
		this.codecs_mng.set(peer);
		// tech specific data
		this.tech_specific_mng.set(peer);
	};

	ProvisioningPeersMng.prototype.empty_controls = function()
	{
		// tech de la seccion new range
		$("#" + this.prefix + "range_new_peer_tech").val("SIP"); // default value
		$("#" + this.prefix + "range_new_peer_count").val(1); // default value
		$("#" + this.prefix + "range_first_new_peer_number").val("");
		// tech de la seccion update range
		$("#" + this.prefix + "range_update_peer_tech").val("SIP"); // default value
		$("#" + this.prefix + "range_update_peer_count").val(1); // default value
		$("#" + this.prefix + "range_first_update_peer_number").val("");
		// tech de la seccion only
		$("#" + this.prefix + "only_one_tech").val("SIP"); // default value
		$("#" + this.prefix + "only_one_peer_number").val("");
		// otros
		$("#" + this.prefix + "host").val("");
		$("#" + this.prefix + "pwd").val("");
		// codecs
		this.codecs_mng.empty_controls();
		// tech specific data
		this.tech_specific_mng.empty_controls();
	};

	ProvisioningPeersMng.prototype.load_data = function()
	{
		const self = this;
		const provisioning_api = inConcert.app.getProvisioningAPI();
		this.__fill_technology([
			{id: "SIP", desc: "<%=_T('SIP')%>"}
		]);
		let requests = [
			// Hosts
			{
				request_function: function(success) {
					return provisioning_api.hostsLoadAll(success);
				},
				success: function(list) {
					self.__fill_hosts(list);
				}
			}
		];

		if (this.m_frm_type) {
			// Peers (usados para la actualizacion por rango (combo peers))
			requests.push({
				request_function: function(success) {
					return provisioning_api.peersLoadAll(success);
				},
				success: function(list) {
					self.__fill_peers(list);
				}
			});
		}
		return requests;
	};

	ProvisioningPeersMng.prototype.__fill_technology = function(list)
	{
		// 1 - el combo de tech de la seccion new range
		const $new_range_tech = $("#" + this.prefix + "range_new_peer_tech");
		this.frm.fill_combo($new_range_tech, false /* is_blank_first_item */, list, "id" /* attr_id */, "desc" /* attr_name */, false /* sorted */, undefined /*can_add_item*/, "trunk_type", /* data_id */);

		// 2 - el combo de tech de la seccion update range
		const $update_range_tech = $("#" + this.prefix + "range_update_peer_tech");
		this.frm.fill_combo($update_range_tech, false /* is_blank_first_item */, list, "id" /* attr_id */, "desc" /* attr_name */, false /* sorted */, undefined /*can_add_item*/, "trunk_type", /* data_id */);

		// 3 -el combo de tech de la seccion only one
		const $only_one_tech = $("#" + this.prefix + "only_one_tech");
		this.frm.fill_combo($only_one_tech, false /* is_blank_first_item */, list, "id" /* attr_id */, "desc" /* attr_name */, false /* sorted */, undefined /*can_add_item*/, "trunk_type", /* data_id */);
	};

	ProvisioningPeersMng.prototype.__fill_hosts = function(list)
	{
		const $combo = $("#" + this.prefix + "host");
		this.frm.fill_combo($combo, true /* is_blank_first_item */, list, "hostId" /* attr_id */, "hostId" /* attr_name */, true /* sorted */, undefined /*can_add_item*/, "host", /* data_id */);
	};

	ProvisioningPeersMng.prototype.__fill_peers = function(list)
	{
		const $combo = $("#" + this.prefix + "range_first_update_peer_number");
		this.frm.fill_combo($combo, false /* is_blank_first_item */, list, "name" /* attr_id */, "name" /* attr_name */, true /* sorted */, undefined /*can_add_item*/);
		this.m_peersList = list;
	};

	ProvisioningPeersMng.prototype.err_save_messages = function(err, is_custom_message)
	{
		var get_error_description = function(err_type/*, raw_data = {}*/)
		{
			is_custom_message = true;
			let message;
			switch (err_type)
			{
			// provisioning manager errors
				case "HOST DOES NOT EXIST":
					message = "<%=_T('Host does not exist.')%>";
				break;

				case "PEER RESOURCE_ADDRESS IS NOT IN IP:PORT FORMAT":
					message = "<%=_T([[Peer\'s resource_address is not in IP:Port format.]])%>";
				break;

				case "ALREADY EXIST ALL PEERS":
					message = "<%=_T('Could not add any IP Phone, they already exist.')%>";
				break;

				case "THERE ARE NO SPECIFIED PEERS":
					message = "<%=_T('Could not update any IP Phone. They do not exist.')%>";
				break;

			// app provisioning errors
				case "MUST_HAVE_A_NAME":
					message = "<%=_T('Unable to save. Number already taken, choose another one.')%>";
				break;

				case "MUST_HAVE_UNIQUE_NAME":
					message = "<%=_T('Unable to save. Number already taken, choose another one.')%>";
				break;

				case "HOST_ID_IS_REQUIRED":
					message = "<%=_T('Host Id is required.')%>";
				break;

				case "PASSWORD_IS_REQUIRED":
					message = "<%=_T('Password is required.')%>";
				break;

				default:
					is_custom_message = false;
					message = "<%=_T('Server error!!')%>";
			}
			return message;
		};

		switch (typeof err) {
			case "object":
				const error_type = err.result.toUpperCase();
				err = get_error_description(error_type, err.rawData);
			break;

			case "string":
				err = get_error_description(err.toUpperCase());
			break;
		}

		return {err: err, is_custom_message: is_custom_message};
	};

	ProvisioningPeersMng.prototype.get_validation_def = function()
	{
		const self = this;

		const can_validate_range_info = function(type) {
			return self.m_frm_type === type;
		};

		const definitions = [
			// 1 - range new section
			{
				control_id: this.prefix + "range_first_new_peer_number",
				can_validate: function() {
					return can_validate_range_info("RANGE-NEW");
				},
				messages: {
					required: "<%=_T('Please enter First IP Phone Number.')%>",
					range: {
						type   : "range",
						between: {from: 1, to: 99999},
						message: "<%=_T('First IP Phone Number allowed values between {0} to {1}.')%>"
					}
				}
			},
			{
				control_id: this.prefix + "range_new_peer_count",
				can_validate: function() {
					return can_validate_range_info("RANGE-NEW");
				},
				messages: {
					required: "<%=_T('Please enter IP Phone Count.')%>",
					range: {
						type   : "range",
						between: {from: 1, to: 1000},
						message: "<%=_T('IP Phone Count allowed values between {0} to {1}.')%>"
					}
				}
			},
			{
				control_id: this.prefix + "range_new_peer_tech",
				can_validate: function() {
					return can_validate_range_info("RANGE-NEW");
				},
				messages: {
					required: "<%=_T('Please select Technology.')%>"
				}
			},
			// 2 - range update section
			{
				control_id: this.prefix + "range_first_update_peer_number",
				can_validate: function() {
					return can_validate_range_info("RANGE-UPDATE");
				},
				messages: {
					required: "<%=_T('Please enter First IP Phone Number.')%>",
					range: {
						type   : "range",
						between: {from: 1, to: 99999},
						message: "<%=_T('First IP Phone Number allowed values between {0} to {1}.')%>"
					}
				}
			},
			{
				control_id: this.prefix + "range_update_peer_count",
				can_validate: function() {
					return can_validate_range_info("RANGE-UPDATE");
				},
				messages: {
					required: "<%=_T('Please enter IP Phone Count.')%>",
					range: {
						type   : "range",
						between: {from: 1, to: 1000},
						message: "<%=_T('IP Phone Count allowed values between {0} to {1}.')%>"
					}
				}
			},
			{
				control_id: this.prefix + "range_update_peer_tech",
				can_validate: function() {
					return can_validate_range_info("RANGE-UPDATE");
				},
				messages: {
					required: "<%=_T('Please select Technology.')%>"
				}
			},
			// 3 - only one section
			{
				control_id: this.prefix + "only_one_peer_number",
				can_validate: function() {
					return can_validate_range_info("UPDATE ONLY ONE");
				},
				messages: {
					required: "<%=_T('Please enter IP Phone Number.')%>",
					range: {
						type   : "range",
						between: {from: 1, to: 99999},
						message: "<%=_T('IP Phone Number allowed values between {0} to {1}.')%>"
					}
				}
			},
			{
				control_id: this.prefix + "only_one_tech",
				can_validate: function() {
					return can_validate_range_info("UPDATE ONLY ONE");
				},
				messages: {
					required: "<%=_T('Please select Technology.')%>"
				}
			},
			// otros
			{
				control_id: this.prefix + "pwd",
				messages: {
					required: "<%=_T('Please enter Password.')%>"
				}
			},
			{
				control_id: this.prefix + "host",
				messages: {
					required: "<%=_T('Please select Host.')%>"
				}
			}
		];
		return definitions;
	};

	ProvisioningPeersMng.prototype.ready = function(force_new)
	{
		this.only_modified(force_new);
	};

	ProvisioningPeersMng.prototype.only_modified = function(force_new)
	{
		const $range_new_container = $("#" + this.prefix + "range_new_container");
		const $range_update_container = $("#" + this.prefix + "range_update_container");
		const $only_one_container = $("#" + this.prefix + "only_one_container");

		$range_new_container.hide();
		$range_update_container.hide();
		$only_one_container.hide();

		let is_new = this.frm.is_creating() || force_new;

		if (is_new) {
			this.m_frm_type = "RANGE-NEW";

			$range_new_container.show();

			const $range_new_peer_tech = $("#" + this.prefix + "range_new_peer_tech");
			this.frm.readonly_control($range_new_peer_tech, true /* disabled */);

			const $range_first_new_peer_number = $("#" + this.prefix + "range_first_new_peer_number");
			if (this.m_must_update_owner_frm_title) {
				this.frm.set_title("<%=_T('Create IP Phone/s')%>");
			}
			$range_first_new_peer_number.focus();

			this.tech_specific_mng.set(); // tengo que iniciarlo en vacio
			this.empty_controls();
		}
		else {
			if (this.m_frm_type === null) {
				this.m_frm_type = "UPDATE ONLY ONE";
			}
			// si no es NULL el valor es "RANGE-UPDATE" y el mismo viene actualizado desde el frm "form_provisioning_peers"

//const peer = this.frm.get_entity_instance();

			if (this.m_frm_type === "UPDATE ONLY ONE") {
				$only_one_container.show();
				const $only_one_peer_number = $("#" + this.prefix + "only_one_peer_number");
				this.frm.readonly_control($only_one_peer_number, true /* disabled */);

				const $only_one_tech = $("#" + this.prefix + "only_one_tech");
				this.frm.readonly_control($only_one_tech, true /* disabled */);
			}
			else {
				$range_update_container.show();

				$("#" + this.prefix + "range_update_peer_count").val(1); // default value

				const $range_update_peer_tech = $("#" + this.prefix + "range_update_peer_tech");
				this.frm.readonly_control($range_update_peer_tech, true /* disabled */);
	
				const $range_first_update_peer_number = $("#" + this.prefix + "range_first_update_peer_number");
				$range_first_update_peer_number.focus();
			}
		}
	};

	ProvisioningPeersMng.prototype.set_events = function()
	{
		const self = this;
		// tech specific
		this.tech_specific_mng.set_events();
		// eventos de range update
		if (this.m_frm_type === "RANGE-UPDATE") {
			const $cbo = $("#" + this.prefix + "range_first_update_peer_number");
			$cbo.off("change")
				.on("change", function() {
					let peer_num = $(this).val();
					let peer_id = "SIP_" + peer_num;
					if (self.m_peersList || !self.m_peersList[peer_id]) {
						let peer = self.m_peersList[peer_id];
						self.set(true, peer, true);
					}
				});
		}
	};

	ProvisioningPeersMng.prototype.get_peers_range = function()
	{
		if (this.m_frm_type === "RANGE-NEW") {
			return {
				peer_start: $("#" + this.prefix + "range_first_new_peer_number").val(),
				peer_count: $("#" + this.prefix + "range_new_peer_count").val()
			};
		}
		else if (this.m_frm_type === "RANGE-UPDATE") {
			return {
				peer_start: $("#" + this.prefix + "range_first_update_peer_number").val(),
				peer_count: $("#" + this.prefix + "range_update_peer_count").val()
			};
		}
		throw("ProvisioningPeersMng.prototype.get_peers_range - Unrecognized type " + this.m_frm_type);
	};

	ProvisioningPeersMng.prototype.save_execute = function(peer, force_new, callback_save = $.noop)
	{
		const callback = function(success, response, action_after_save) {
			callback_save(success, response, action_after_save);
		};
		const provisioning_api = inConcert.app.getProvisioningAPI();
		if (this.m_frm_type === "UPDATE ONLY ONE") {
			// only one update
			let data = {};
			let peer_id = peer.address_id;
			data[peer_id] = peer;
			provisioning_api.peerUpdate(data, function(success, response) {
				if (!success) {
					callback(false, response);
					return;
				}
				let action_after_save = "SAVE_AND_REFRESH_VIEW"; // accion de "conf_form"
				callback(true, response, action_after_save);
			});
			return;
		}
		// range update
		const is_new = this.frm.is_creating() || force_new;
		let data = {
			range: this.get_peers_range(),
			peer : peer
		};
		if (is_new) {
			// add range
			provisioning_api.peersAddRange(data, callback);
			return;
		}
		// update range
		provisioning_api.peersUpdateRange(data, callback);
	};

}());
