/* jshint forin:true, noarg:true, jquery:true, noempty:true, eqeqeq:true, bitwise:true,
	strict:true, undef:true, unused:vars, curly:true, browser:true, indent:false, maxerr:50, esversion: 9 */

/* global $, inConcert */

if (!this.inConcert) {
	this.inConcert = {};
}

(function () {
	//"use strict";

//	const FORMAT = inConcert.Utils.format;

	//---------------------------------------------------------------------
	// Tech Specific Data Management
	function ProvisioningTechSpecificMng(params)
	{
		if (!params) {
			throw("ProvisioningTechSpecificMng - 'params' is required");
		}
		if (!params.owner) {
			throw("ProvisioningTechSpecificMng - 'params.owner' is required");
		}
		if (!params.prefix) {
			throw("ProvisioningTechSpecificMng - 'params.prefix' is required");
		}
		if (!params.container_id) {
			throw("ProvisioningTechSpecificMng - 'params.container_id' is required");
		}

		this.owner = params.owner;
		this.owner_name = params.owner_name || "";
		this.prefix = params.prefix + "_";
		this.container_id = params.container_id;
		this.m_grid = null;

		return true;
	}

	if (typeof inConcert.ProvisioningTechSpecificMng !== "function") {
		inConcert.ProvisioningTechSpecificMng = ProvisioningTechSpecificMng;
	}

	ProvisioningTechSpecificMng.prototype.initialize = function()
	{
		this.__make_popup_html();
		this.__init_grid();
	};

	ProvisioningTechSpecificMng.prototype.__make_popup_html = function()
	{
		let html = '' +
			'<div id="' + this.prefix + 'new_container" class="">' +
				'<div class="card-header d-flex flex-row justify-content-between align-items-center mb-3">' +
					'<h5 class="mb-0"><%=_T([[Tech Specific Config]])%></h5>' +
					'<i id="' + this.prefix + 'new_list_validation" class="formFieldValidation formFieldError" hidden></i>' +
					'<button id="' + this.prefix + 'new" class="pageButtonGeneric buttonColorWhite pageButtonNew mb-0">' +
						 '<%=_T([[Add data]])%>' +
					'</button>' +
				'</div>' +
				'<div class="card-block">' +
					'<div id="' + this.prefix + 'container">' +
						'<div id="' + this.prefix + 'not_results_found" class="inlineMessagesContainer messageInfo" style="display:none"></div>' +
						'<table id="' + this.prefix + 'list" cellpadding="0" cellspacing="0" border="0" class="viewGrid">' +
							'<thead class="viewGridHeader"></thead>' +
							'<tbody class="viewGridBody"></tbody>' +
						'</table>' +
					'</div>' +
					'<div id="' + this.prefix + 'paginator"></div>' +
				'</div>' +
			'</div>' +
			'<div id="' + this.prefix + 'popup" class="internalPopUpContainer addSpecificTechonlogyPopUp" style="display:none;">' +
				'<div class="internalPopUpOverlay"></div>' +
				'<div class="internalPopUp">' +
					'<div id="' + this.prefix + 'popup_waiting" class="internalWaitingContainer" style="display:none;">' +
						'<div waiting_message="true" class="internalWaitingMessage"></div>' +
						'<div class="internalWaitingAnimation"></div>' +
						'<div class="internalWaitingOverlay"></div>' +
					'</div>' +
					'<div id="' + this.prefix + 'popup_title" class="internalPopUpTitle">' +
						'<span popup_title_text>...</span>' +
						'<button popup_close class="internalPopUpCloseButton"><i class="far fa-times"></i></button>' +
					'</div>' +
					'<div class="internalPopUpMiddle">' +
						'<div id="' + this.prefix + 'popup_message" class="genericFormMessagesContainer messageError" style="display:none;">FIELD ERROR MESSAGE</div>' +
						'<div class="card no-card">' +
							'<div class="card-block">' +
								'<div class="row">' +
									'<div class="col-6">' +
										'<div class="form-group">' +
											'<label for="' + this.prefix + 'popup_name" class="required"><%=_T([[Name]])%><%=_T([[:]])%></label>' +
											'<input id="' + this.prefix + 'popup_name" class="form-control" type="text" placeholder="<%=_T([[Enter the name]])%><%=_T([[...]])%>" />' +
											'<i id="' + this.prefix + 'popup_name_validation" class="formFieldValidation formFieldError" hidden></i>' +
										'</div>' +
									'</div>' +
									'<div class="col-6">' +
										'<div class="form-group">' +
											'<label for="' + this.prefix + 'popup_value" class="required"><%=_T([[Value]])%><%=_T([[:]])%></label>' +
											'<input id="' + this.prefix + 'popup_value" class="form-control" type="text" placeholder="<%=_T([[Enter the value]])%><%=_T([[...]])%>" />' +
											'<i id="' + this.prefix + 'popup_value_validation" class="formFieldValidation formFieldError" hidden></i>' +
										'</div>' +
									'</div>' +
								'</div>' +
							'</div>' +
						'</div>' +
					'</div>' +
					'<div class="internalPopUpButtons">' +
						'<input id="' + this.prefix + 'popup_close" class="pageButtonGeneric buttonColorWhite float-right" type="button" value="<%=_T([[Close]])%>" />' +
						'<input id="' + this.prefix + 'popup_create_and_continue" class="pageButtonGeneric buttonColorBlue float-right" type="button" value="<%=_T([[Confirm & continue]])%>" />' +
						'<input id="' + this.prefix + 'popup_create" class="pageButtonGeneric buttonColorBlue float-right" type="button" value="<%=_T([[Confirm]])%>" />' +
					'</div>' +
				'</div>' +
			'</div>';

		const $container = $("#" + this.container_id);
		$container.html(html);
	};

	ProvisioningTechSpecificMng.prototype.__init_grid = function()
	{
		const self = this;

		this.m_grid = new inConcert.conf_form_paginator({
			owner: this.owner,
			frm: this.owner,
			row_id: "UUID",
			display_name: "Name",
			rows_per_page: 2000,
			show_at_least: 1999,
			paginator_type: "ALL_ROWS_CLIENT_SIDE",
			without_paginator: true,
			loading_waiting_msg: "<%=_T('Please wait, loading Tech Specific Data ...')%>",
			ids: {
				paginator: this.prefix + "paginator",
				grid: this.prefix + "list",
				not_results_found: this.prefix + "not_results_found",
				container_new_btn: this.prefix + "new_container",
				new_item: this.prefix + "new",
			//popup0
				popup: this.prefix + "popup",
				popup_msg: this.prefix + "popup_message",
				popup_create: this.prefix + "popup_create",
				popup_create_and_continue: this.prefix + "popup_create_and_continue",
				popup_title: this.prefix + "popup_title",
				popup_close: this.prefix + "popup_close",
				popup_input_id: this.prefix + "popup_question",
				popup_waiting: this.prefix + "popup_waiting",

			},
			strings: {
				not_results_found: "<%=_T('No Tech Specific Data found.')%>",
				can_remove       : "<%=_T('Do you want to delete Tech Specific Data: {0} ?')%>",
				title_new        : "<%=_T('Specific configuration data')%>"
			},
			columns: [
				{id: "_number", name: "", type: "counter"},
				{id: "Name"   , name: "<%=_T('Name')%>"  },
				{id: "Value"  , name: "<%=_T('Value')%>" },
				{
					id: "_action",
					name: "",
					system_action: {
						edit: true,
						erase: true
					}
				}
			],
			callbacks: {
				save: function(callback, must_create_and_contiune, current_popup) {
					callback = callback || $.noop;
					self.add_or_update_tech_specific_data(callback, must_create_and_contiune, current_popup);
				},
				edit: function(row_data) {
					self.on_open_tech_specific_data_popup(row_data);
				},
				on_removed_row: function(/*row, callback = $.noop*/) {
//					self.m_layout_has_changed = true;
				},
 				on_closed_popup: function() {
 					self.on_closed_popup();
 				}
			}
		});
	};

	ProvisioningTechSpecificMng.prototype.on_closed_popup = function(/*current_popup*/)
	{
		this.m_is_new_tech_specific_data = null;
		this.m_current_tech_specific_data = null;
	};

	ProvisioningTechSpecificMng.prototype.add_or_update_tech_specific_data = function(callback, _, current_popup)
	{
		callback = callback || $.noop;

		let response = this.validate_tech_specific_data_to_add_or_update(current_popup);
		if (!response.success) {
			callback(false);
			return;
		}

		let msg_response = {
			msg : "",
			type: "Info"
		};

		if (this.m_is_new_tech_specific_data) {
			msg_response.msg = "<%=_T('Tech specific data was successfully added.')%>";
			let must_add_many = false;
			callback(true, response.item, msg_response, must_add_many);
		}
		else {
			msg_response.msg = "<%=_T('Tech specific data was successfully updated.')%>";
			this.m_current_tech_specific_data =inConcert.Utils.cloneObject(response.item);
			callback(true, this.m_current_tech_specific_data, msg_response);
		}

		this.clean_up_controls_tech_specific_data();
	};

	ProvisioningTechSpecificMng.prototype.clean_up_controls_tech_specific_data = function()
	{
		const $name = $("#" + this.prefix + "popup_name");
		const $value = $("#" + this.prefix + "popup_value");
		$name.val("").focus();
		$value.val("");
	};

	ProvisioningTechSpecificMng.prototype.on_open_tech_specific_data_popup = function(item)
	{
		this.m_is_new_tech_specific_data = item ? false: true;
		this.m_current_tech_specific_data = item;

		this.clean_up_controls_tech_specific_data();
		if (this.m_is_new_tech_specific_data) {
			// nuevo
			return;
		}
		// editando
		const $name = $("#" + this.prefix + "popup_name");
		$name.val(item.Name);

		const $value = $("#" + this.prefix + "popup_value");
		$value.val(item.Value);

		$name.focus();
	};

	ProvisioningTechSpecificMng.prototype.validate_tech_specific_data_to_add_or_update = function()
	{
		const self = this;

		this.hide_all_errors();
		let response = {success: false, $ctrl: null, item: null, msg: "<%=_T('Unable to Add Tech specific data.')%>"};

		let item = {};
		let is_new = false;
		if (this.m_current_tech_specific_data) {
			item = this.m_current_tech_specific_data;
		}
		else {
			item.UUID =  inConcert.Utils.generateGuid();
			is_new = true;
		}

		// NAME validation -----
		//
		// Required validation
		const $name = $("#" + this.prefix + "popup_name");
		let name = $name.val();
		let validation_result = inConcert.Utils.validate(name, "required");
		if (!validation_result.success) {
			// valida que el name tenga al menos un caracter
			response.msg = "<%=_T('Name is required.')%>";
			response.$ctrl = $name;
			this.show_ctrl_err(response);
			return response;
		}

		// Already exist validation
		let current_all_tech_specific_data = this.m_grid.get_items();
		current_all_tech_specific_data = inConcert.Utils.arrayToMap(current_all_tech_specific_data || [],
			function(tech) {
				return tech.Value;
			},
			function(tech) {
				// el ID
				return (tech.Name || "").toLowerCase();
			}
		);
		var show_already_error = function() {
			response.msg = "<%=_T('Name already exist.')%>";
			response.$ctrl = $name;
			self.show_ctrl_err(response);
			return response;
		};
		let lower_name = name.toLowerCase();
		if (is_new) {
			const already = current_all_tech_specific_data[lower_name];
			if (already) {
				return show_already_error();
			}
		}
		else {
			if (item.Name.toLowerCase() !== lower_name) {
				const already = current_all_tech_specific_data[lower_name];
				if (already) {
					return show_already_error();
				}
			}
		}

		// VALUE validation -----
		//
		// Required validation
		const $value = $("#" + this.prefix + "popup_value");
		let value = $value.val();
		validation_result = inConcert.Utils.validate(value, "required");
		if (!validation_result.success) {
			// valida que el name tenga al menos un caracter
			response.msg = "<%=_T('Value is required.')%>";
			response.$ctrl = $value;
			this.show_ctrl_err(response);
			return response;
		}

		item.Name = name;
		item.Value = value;

		response.success = true;
		response.msg = "";
		response.item = item;

		return response;
	};

	ProvisioningTechSpecificMng.prototype.hide_all_errors = function()
	{
		this.m_grid.hide_popup_msg();
	};

	ProvisioningTechSpecificMng.prototype.show_ctrl_err = function(err_info)
	{
		if (!err_info) {
			return;
		}
		const $control = err_info.$ctrl;
		if ($control) {
			const error_id = $control.attr("id") + "_validation";
			const $error_indicator = $("#" + error_id);
			if ($error_indicator) {
				$error_indicator.show();
			}
			$control.focus();
		}
		this.m_grid.show_popup_msg(err_info.msg, "Error"); //, ERROR_TIMEOUT_MS);
	};

	ProvisioningTechSpecificMng.prototype.dispose = function()
	{
		//TODO: implementar, si es necesario
	};

	ProvisioningTechSpecificMng.prototype.get = function(entity)
	{
		if (!entity) {
			return;
		}
		let tech_specific_data = this.m_grid.get_items();
		tech_specific_data = inConcert.Utils.arrayToMap(tech_specific_data || [],
			function(tech) {
				return tech.Value;
			},
			function(tech) {
				return tech.Name;
			}
		);
		entity.techSpecific = tech_specific_data;
	};

	ProvisioningTechSpecificMng.prototype.set = function(entity)
	{
		let tech_specific_data = [];

		if (entity) {
			for (let name in entity.techSpecific || {}) {
				if (entity.techSpecific.hasOwnProperty(name)) {
					let value = entity.techSpecific[name];
					tech_specific_data.push({
						UUID : inConcert.Utils.generateGuid(),
						Name : name,
						Value: value 
					});
				}
			}
		}

		this.m_grid.initialize($.noop, tech_specific_data);
	};

	ProvisioningTechSpecificMng.prototype.empty_controls = function()
	{
		this.m_grid.remove_all_rows();
	};

	ProvisioningTechSpecificMng.prototype.set_events = function()
	{
		this.m_grid.set_events();
	};
}());
