local monitoringUtils = require("apps.provisioning.system_monitoring.utils")

module(..., package.seeall, inconcert.orbit.application.Decorate)

local m_definition = {
    category = "outbound_engine",
    name = "Contact State",
    description = "Number of contacts per process, state and cause",
    filters = {
        monitoringUtils.GetField("Vcc", { required = true }),
        monitoringUtils.GetField("OutboundProcessId"),
        monitoringUtils.GetField("ImportId"),
        monitoringUtils.GetField("BatchId"),
    },
    columns = {
        monitoringUtils.GetField("OutboundProcessId"),
        monitoringUtils.GetField("OutboundContactState"),
        monitoringUtils.GetField("OutboundContactStateCause"),
        monitoringUtils.GetField("Number"),
    }
}

function GetDefinition(_T)
    return monitoringUtils.GetViewDefinition(m_definition, _T)
end

function Run(request, _T)
    return monitoringUtils.RunSummaryOutboundContacts(m_definition, request, _T)
end

function GetDetails(itemId)
    return { result = "FAIL", reason = "Not supported" }
end
