local monitoringUtils = require("apps.provisioning.system_monitoring.utils")

module(..., package.seeall, inconcert.orbit.application.Decorate)

local m_definition = {
    category = "outbound_engine",
    name = "Results By Batch",
    description = "Interaction Results by Batch",
    filters = {
        monitoringUtils.GetField("Vcc"),
        monitoringUtils.GetField("OutboundProcessId"),
        monitoringUtils.GetField("BatchId"),
        monitoringUtils.GetField("Slice"),
        monitoringUtils.GetField("ShowPercentage"),
    },
    columns = {
        monitoringUtils.GetField("SliceDate"),
        monitoringUtils.GetField("Vcc"),
        monitoringUtils.GetField("OutboundProcessId"),
        monitoringUtils.GetField("BatchId"),
    },
    sortByColumns = {
        monitoringUtils.GetField("SliceDate", { desc = true }),
        monitoringUtils.GetField("Vcc"),
        monitoringUtils.GetField("OutboundProcessId"),
        monitoringUtils.GetField("BatchId"),
    }
}
monitoringUtils.AddEnumToColumns(m_definition.columns, monitoringUtils.GetField("InteractionCode"))

function GetDefinition(_T)
    return monitoringUtils.GetViewDefinition(m_definition, _T)
end

function Run(request, _T)
    return monitoringUtils.RunRedisDialerBatchView(m_definition, request, _T, "InteractionCode")
end

function GetDetails(itemId)
    return { result = "FAIL", reason = "Not supported" }
end
