local monitoringUtils = require("apps.provisioning.system_monitoring.utils")

module(..., package.seeall, inconcert.orbit.application.Decorate)

local m_definition = {
    category = "outbound_engine",
    name = "Results By Trunk",
    description = "Interaction Results by Trunk",
    filters = {
        monitoringUtils.GetField("HostId", { id = "hostId" }),
        monitoringUtils.GetField("GatewayId", { id = "gateway" }),
        monitoringUtils.GetField("TrunkId", { id = "id" }),
        monitoringUtils.GetField("SliceTrunk"),
        monitoringUtils.GetField("ShowPercentage"),
    },
    columns = {
        monitoringUtils.GetField("SliceDate"),
        monitoringUtils.GetField("HostId", { id = "hostId" }),
        monitoringUtils.GetField("GatewayId", { id = "gateway" }),
        monitoringUtils.GetField("TrunkId", { id = "id" }),
    },
    sortByColumns = {
        monitoringUtils.GetField("SliceDate", { desc = true }),
        monitoringUtils.GetField("HostId", { id = "hostId" }),
        monitoringUtils.GetField("GatewayId", { id = "gateway" }),
        monitoringUtils.GetField("TrunkId", { id = "id" }),
    }
}
monitoringUtils.AddEnumToColumns(m_definition.columns, monitoringUtils.GetField("InteractionCode"))

function GetDefinition(_T)
    return monitoringUtils.GetViewDefinition(m_definition, _T)
end

function Run(request, _T)
    return monitoringUtils.RunRedisDialerTrunkView(m_definition, request, _T, "Codes")
end

function GetDetails(itemId)
    return { result = "FAIL", reason = "Not supported" }
end
