local monitoringUtils = require("apps.provisioning.system_monitoring.utils")

module(..., package.seeall, inconcert.orbit.application.Decorate)

local m_definition = {
    category = "outbound_engine",
    name = "Process Infrastructure",
    description = "Status of process infrastructure (trunks, packages)",
    filters = {
        monitoringUtils.GetField("Vcc"),
        monitoringUtils.GetField("OutboundProcessId"),
    },
    columns = {
        monitoringUtils.GetField("Vcc"),
        monitoringUtils.GetField("OutboundProcessId"),
        monitoringUtils.GetField("CampaignId"),
        monitoringUtils.GetField("TrunksStatus"),
        monitoringUtils.GetField("AssignedPackagesCapability"),
        monitoringUtils.GetField("EffectiveCapability"),
        monitoringUtils.GetField("BusyCapabilityPercentage"),
        monitoringUtils.GetField("BusyPackagesCapabilityPercentage"),
        monitoringUtils.GetField("BusyTrunksCapabilityPercentage"),
        monitoringUtils.GetField("FailedTrunksCapabilityPercentage"),
        monitoringUtils.GetField("HasOverbusyTrunks"),
        monitoringUtils.GetField("OverbusyTrunks"),
        monitoringUtils.GetField("OverbusyTrunksPercentage"),
        monitoringUtils.GetField("RejectedDidsPercentage"),
    },
    downloadDetails = true,
}

function GetDefinition(_T)
    return monitoringUtils.GetViewDefinition(m_definition, _T)
end

function Run(request, _T)
    return monitoringUtils.RunAnalyticsCampaignsListView(m_definition, request, _T)
end

function GetDetails(itemId)
    return monitoringUtils.GetAnalyticsCampaignsDetailsView(itemId, "process")
end
