local monitoringUtils = require("apps.provisioning.system_monitoring.utils")

module(..., package.seeall, inconcert.orbit.application.Decorate)

local m_definition = {
    category = "outbound_engine",
    name = "Process Slice Summary",
    description = "Process indicators by slice",
    filters = {
        monitoringUtils.GetField("Vcc"),
        monitoringUtils.GetField("OutboundProcessId"),
        monitoringUtils.GetField("Slice"),
    },
    columns = {
        monitoringUtils.GetField("Vcc"),
        monitoringUtils.GetField("OutboundProcessId"),
        monitoringUtils.GetField("CampaignId"),
        monitoringUtils.GetField("Tries", { bySlice = true }),
        monitoringUtils.GetField("Connected", { bySlice = true }),
        monitoringUtils.GetField("NotConnected", { bySlice = true }),
        monitoringUtils.GetField("Abandoned", { bySlice = true }),
        monitoringUtils.GetField("AnsweringMachine", { bySlice = true }),
        monitoringUtils.GetField("TriesUnique", { bySlice = true }),
        monitoringUtils.GetField("RetriesPerContact", { bySlice = true }),
        monitoringUtils.GetField("ContactRate", { bySlice = true }),
        monitoringUtils.GetField("AbandonRate", { bySlice = true }),
        monitoringUtils.GetField("AbandonedByTimeoutRate", { bySlice = true }),
        monitoringUtils.GetField("AbandonedByAgentRate", { bySlice = true }),
        monitoringUtils.GetField("BadServiceLevelRate", { bySlice = true }),
        monitoringUtils.GetField("Goal", { bySlice = true }),
        monitoringUtils.GetField("GoalsPerHour", { bySlice = true }),
        monitoringUtils.GetField("RetriesPerGoal", { bySlice = true }),
        monitoringUtils.GetField("ConfigError", { bySlice = true }),
        monitoringUtils.GetField("LinkDown", { bySlice = true }),
    },
    downloadDetails = true,
}

function GetDefinition(_T)
    return monitoringUtils.GetViewDefinition(m_definition, _T)
end

function Run(request, _T)
    return monitoringUtils.RunAnalyticsCampaignsListView(m_definition, request, _T)
end

function GetDetails(itemId)
    return monitoringUtils.GetAnalyticsCampaignsDetailsView(itemId, "process")
end
