module(..., package.seeall)
local stp = require "StackTracePlus"

-- helper
local function pack(...)
	return { n = select("#", ...), ... }
end

-- helper
local function safeInvokeHelper(fun, ok, ...)
	if ok then
		return fun(...)
	end
	return false, ...
end

--[[!
-- Calls function @c function2call in protected mode
-- @param callback A function receiving the results of @c function2call as
-- parameters. Called only if the protected call succeeds
--]]
function safeInvoke(function2call, callback, ...)
	local args = pack(...)

	return safeInvokeHelper(callback, xpcall(function()
			return function2call(unpack(args, 1, args.n))
		end, function(err)
			LogError("pcall error: %s", stp.stacktrace(err, 2));
		end)
	)
end
