/* jshint forin:true, noarg:true, jquery:true, noempty:true, eqeqeq:true, bitwise:true,
	strict:true, undef:true, unused:vars, curly:true, browser:true, indent:false, maxerr:50, esversion: 9 */

/* global $, inConcert, _ */

if (!this.inConcert) {
	this.inConcert = {};
}

(function () {
	//"use strict";

	const _T = inConcert.i18n.getString;
	const FORMAT = inConcert.Utils.format;
	const SELECT_FILTER_MSG = "<%=_T('You can set filters, after select the report you want.')%>";
	const SELECT_RANGE_MSG = "<%=_T('You can set ranges, after select the report you want.')%>";

	var str_to_int = function( s ) {
		let n = parseInt( s, 10 );
		if ( isNaN( n ) ) {
			return undefined;
		}
		return n;
	};

	var get_difference_days = function( date1, date2 ) {
		const _MS_PER_DAY = 1000 * 60 * 60 * 24;
		let diff_days = parseInt( ( date1 - date2 ) / _MS_PER_DAY , 10 );
		return diff_days;
	};

	//---------------------------------------------------------------------
	// form schedule class
	function rd_form_schedule( params )
	{
		const self = this;
		let success = rd_form_schedule.uber.constructor.call( this, params );
		if ( !success ) {
			return;
		}

		this.new_title    = "<%=_T('New Schedule')%>";
		this.update_title = "<%=_T('Update Schedule {0}')%>";
		this.view_title   = "<%=_T('View Schedule {0}')%>";
		this.tagline      = "<%=_T('Tagline form Schedule!!!')%>";

		this.html_file_name = "/inconcert/apps/reports/pages/forms/edit_schedule.<%=_L%>.html#grunt-cache-bust";
		this.save_uri       = "/inconcert/apps/reports/schedules/save/";
		this.get_uri        = "/inconcert/apps/reports/schedules/get/";

		this.include_save_and_continue = false;

		this.container_id                      = "reports_design_form_schedule_wizard";
		this.schedule_state_message            = "reports_design_form_schedule_state";

	// ids page 1
		var prefix_p1                          = this.get_prefix( 1 );
		//report
		this.p1_rpt_type                       = prefix_p1 + "rpt_type";
		this.p1_rpt_id                         = prefix_p1 + "rpt_id";
		//filters
		this.p1_filters_section                = prefix_p1 + "filters_section";
		this.p1_rpt_filters                    = prefix_p1 + "filters";
		this.p1_rpt_filters_msg                = prefix_p1 + "filters_msg";
		// range
		this.p1_range_section                  = prefix_p1 + "range_section";
		this.p1_range                          = prefix_p1 + "range";
		this.p1_range_exact_from               = prefix_p1 + "range_exact_from";
		this.p1_range_exact_to                 = prefix_p1 + "range_exact_to";
		this.p1_range_last_n_hours             = prefix_p1 + "range_last_n_hours";
		this.p1_range_last_n_days              = prefix_p1 + "range_last_n_days";
		this.p1_rpt_range_msg                  = prefix_p1 + "range_msg";
		this.p1_range_options                  = prefix_p1 + "range_options";
		// export format
		this.p1_rpt_export_format_section      = prefix_p1 + "export_format_section";
		this.p1_rpt_export_format              = prefix_p1 + "export_format";
		// export
		this.p1_rpt_export_section             = prefix_p1 + "export_section";
		this.p1_rpt_export                     = prefix_p1 + "export";
		this.p1_rpt_export_days_to_keep_cont   = prefix_p1 + "export_days_to_keep_content";
		this.p1_rpt_export_content_type        = prefix_p1 + "export_format_content_type";

	// ids page 2
		var prefix_p2                          = this.get_prefix( 2 );
		// common
		this.p2_common_section                 = prefix_p2 + "common_section";
		this.p2_common_require_starts_on_date  = prefix_p2 + "common_require_starts_on_date";
		this.p2_common_starts_on_date          = prefix_p2 + "common_starts_on_date";
		this.p2_common_starts_on_hour          = prefix_p2 + "common_starts_on_hour";
		//frequency
		this.p2_frequency_section              = prefix_p2 + "frequency_section";
		this.p2_frequency                      = prefix_p2 + "frequency";
		this.p2_frequency_every_n_hours        = prefix_p2 + "frequency_every_n_hours";
		this.p2_frequency_daily_hour           = prefix_p2 + "frequency_daily_hour";
		this.p2_frequency_weekly_day           = prefix_p2 + "frequency_weekly_day";
		this.p2_frequency_weekly_hour          = prefix_p2 + "frequency_weekly_hour";
		this.p2_frequency_monthly_day          = prefix_p2 + "frequency_monthly_day";
		this.p2_frequency_monthly_hour         = prefix_p2 + "frequency_monthly_hour";
		this.p2_frequency_onetime_date         = prefix_p2 + "frequency_onetime_date";
		this.p2_frequency_onetime_hour         = prefix_p2 + "frequency_onetime_hour";
		this.p2_frequency_custom_interval      = prefix_p2 + "frequency_custom_interval";
		this.p2_frequency_custom_hour          = prefix_p2 + "frequency_custom_hour";
		//validity
		this.p2_validity_section               = prefix_p2 + "validity_section";
		this.p2_validity                       = prefix_p2 + "validity";
		this.p2_validity_limit_rep             = prefix_p2 + "validity_limit_rep";
		this.p2_validity_limit_rep_message     = prefix_p2 + "validity_limit_rep_message";
		this.p2_validity_until_date            = prefix_p2 + "validity_until_date";
		this.p2_validity_until_hour            = prefix_p2 + "validity_until_hour";

	// ids page 3
		var prefix_p3                          = this.get_prefix( 3 );
		this.p3_send_type                      = prefix_p3 + "send_type";

		// DataBase
		this.p3_panel_db                       = prefix_p3 + "panel_db";
		this.p3_db_type                        = prefix_p3 + "db_type";
		this.p3_db_server                      = prefix_p3 + "db_server";
		this.p3_db_port                        = prefix_p3 + "db_port";
		this.p3_db_user                        = prefix_p3 + "db_user";
		this.p3_db_pwd                         = prefix_p3 + "db_pwd";
		this.p3_db_name                        = prefix_p3 + "db_name";
		this.p3_db_sp_sample                   = prefix_p3 + "db_sp_sample";
		this.p3_db_error_mail_to               = prefix_p3 + "db_error_mail_to";
		this.p3_db_error_mail_from             = prefix_p3 + "db_error_mail_from";
		this.p3_db_sp_transaction_sample       = prefix_p3 + "db_sp_transaction_sample";
		this.p3_db_sp_threaded_sample          = prefix_p3 + "db_sp_threaded_sample";

		// ftp
		this.p3_panel_ftp                      = prefix_p3 + "panel_ftp";
		this.p3_ftp_host                       = prefix_p3 + "ftp_host";
		this.p3_ftp_port                       = prefix_p3 + "ftp_port";
		this.p3_ftp_user                       = prefix_p3 + "ftp_user";
		this.p3_ftp_pwd                        = prefix_p3 + "ftp_pwd";
		this.p3_ftp_filename                   = prefix_p3 + "ftp_filename";
		this.p3_ftp_directory                  = prefix_p3 + "ftp_directory";
		this.p3_ftp_error_mail_to              = prefix_p3 + "ftp_error_mail_to";
		this.p3_ftp_error_mail_from            = prefix_p3 + "ftp_error_mail_from";

		// sftp
		this.p3_panel_sftp                     = prefix_p3 + "panel_sftp";
		this.p3_sftp_host                      = prefix_p3 + "sftp_host";
		this.p3_sftp_port                      = prefix_p3 + "sftp_port";
		this.p3_sftp_user                      = prefix_p3 + "sftp_user";
		this.p3_sftp_pwd                       = prefix_p3 + "sftp_pwd";
		this.p3_sftp_filename                  = prefix_p3 + "sftp_filename";
		this.p3_sftp_directory                 = prefix_p3 + "sftp_directory";
		this.p3_sftp_error_mail_to             = prefix_p3 + "sftp_error_mail_to";
		this.p3_sftp_error_mail_from           = prefix_p3 + "sftp_error_mail_from";

		// e-mail
		this.p3_panel_mail                     = prefix_p3 + "panel_mail";
		this.p3_mail_to                        = prefix_p3 + "mail_to";
		this.p3_mail_attach                    = prefix_p3 + "mail_attach";
		this.p3_mail_subject                   = prefix_p3 + "mail_subject";
		this.p3_mail_body                      = prefix_p3 + "mail_body";
		this.p3_mail_from                      = prefix_p3 + "mail_from";

		this.report_controller = new inConcert.reports.ReportsController( inConcert.app.getBaseDomain() );
		this.wizard = null;

		this.user_timezone = null;
		inConcert.app.loadTimezones(
			function( success, timezones ) {
				if ( !success ) {
					return;
				}
				var user_timezone_id = inConcert.app.getTimezone();
				self.user_timezone = timezones[ user_timezone_id ];
			});
		return true;
	}

	inConcert.Utils.inherit( rd_form_schedule, inConcert.conf_form );

	if ( typeof inConcert.rd_form_schedule !== "function" ) {
		inConcert.rd_form_schedule = rd_form_schedule;
	}

	rd_form_schedule.prototype.get_prefix = function( page_number )
	{
		return this.container_id + "_page" + page_number + "_";
	};

	rd_form_schedule.prototype.err_save_messages = function( err )
	{
		var is_custom_message = false;
		var get_error_description = function( err_type )
		{
			is_custom_message = true;
			var message;
			switch ( err_type )
			{
				case "CURRENT_SCHEDULE_IS_RUNNING":
					message = "<%=_T('Unable to save schedule. Current schedule is running.')%>";
				break;

				case "ONLY_ALLOWED_A_ONE_SCHEDULER_OF_THIS_TYPE":
					message = "<%=_T('Unable to save schedule. Only allowed a one scheduler of this type.')%>";
				break;

				default:
					is_custom_message = false;
					message = "<%=_T('Unable to save schedule')%>";
			}
			return message;
		};

		switch ( typeof err )
		{
			case "object":
				var error_type = err.result.toUpperCase();
				err = get_error_description(error_type);
			break;

			case "string":
				err = get_error_description(err.toUpperCase());
			break;
		}

		rd_form_schedule.uber.err_save_messages.call( this, err, is_custom_message ); //invokes the base class method
	};

	rd_form_schedule.prototype.load_reports_list = function( callback )
	{
		var self = this;
		callback = callback || $.noop;

		var reports_types = [
			{ id: "custom"				},
			{ id: "detail"				},
			{ id: "realtime"			},
			{ id: "summary"				},
			{ id: "dialerbatch"			},
			{ id: "dialercontacts"		},
			{ id: "livedetail"			}
		];

		var values = {};

		// funcion recursiva que va obtiendo uno por uno los datos de los reportes. Cuando termina un request, realiza el otro
		var load = function()
		{
			if ( reports_types.length === 0 ) {
				callback( true, values );
				return;
			}
			var rpt_type = reports_types[ 0 ];
			reports_types.shift();

			self.report_controller.listReports( rpt_type.id ).done(function( reports ) {
				values[ rpt_type.id ] = {
					list: reports
				};
				load();
			}).fail(function( error_thrown ) {
				var message = FORMAT( "<%=_T('Failed to list reports type {0}: {1}')%>", rpt_type.id, error_thrown || "");
				self.show_status_message( message, "error" );
				callback( false );
			});
		};

		load();
	};

	rd_form_schedule.prototype.initialize_wizard = function()
	{
		var self = this;
		var all_visited_page = false;
		var container_id = this.container_id;

		this.wizard = new inConcert.conf_form_wizard( {
			frm            : this,
			container_id   : container_id,
			wizard_options : {
				all_visited: all_visited_page, 
				pages : {
					page1: {
						name: "<%=_T('General')%>",
						content: function() {
							return self.get_html_page1();
						}
					},
					page2: {
						name: "<%=_T('Frequency')%>",
						content: function() {
							return self.get_html_page2();
						}
					},
					page3: {
						name: "<%=_T('Sendings')%>",
						content: function() {
							return self.get_html_page3();
						}
					}
				},
				onCreate: function() {
				// metodos de la clase base "conf_form"
					self.oncreated_wizard();
				},
				onLeavePage: function( page_number, _, direction )
				{
					var success = true;
					if ( direction === "forward" ) {
						var definition_page;
						switch( page_number ) {
							case 1:
								definition_page = self.get_page1_validation_def();
								break;
							case 2:
								definition_page = self.get_page2_validation_def();
								break;
							case 3:
								definition_page = self.get_page3_validation_def();
								break;
							default:
								throw "Unconfigured page number " + page_number;
						}
						self.validation.start( definition_page || [], function( is_ok ) {
							success = is_ok;
							if ( success ) {
								self.hide_messages();
							}
						});
					}
					return success;
				},
				onEnterPage: function( page_number, old_page )
				{
					if ( page_number !== old_page ) {
						var ctrl_id = "";
						switch( page_number ) {
							case 1:
								ctrl_id = self.p1_rpt_type;
								break;
							case 2:
								ctrl_id = self.p2_frequency;
								break;
							case 3:
								ctrl_id = self.p3_send_type;
								break;
							default:
								throw "Unconfigured page number " + page_number;
						}
						$( "#" + ctrl_id ).focus();
					}
				}
			}
		});
	};

	rd_form_schedule.prototype.oncreated_wizard = function()
	{
		var container_id = this.container_id;
		this.create_datepickers( container_id );
		this.create_hours( container_id );
		this.create_spinners( container_id );

		this.disable_control( $( "#" + this.p2_common_starts_on_date ), true /* disabled */ );
		this.disable_control( $( "#" + this.p2_common_starts_on_hour ), true /* disabled */ );

		rd_form_schedule.uber.oncreated_wizard.call( this ); //invokes the base class method
	};

	rd_form_schedule.prototype.get_html_page1 = function()
	{
		return "".concat(
			"<!-- REPORT -->",
			"<div class='card'>",
				"<div class='card-header'>",
					"<h5>",
						"<%=_T('Report')%>",
					"</h5>",
				"</div>",
				"<div class='card-block'>",
					"<div class='row'>",
						"<div class='col-3'>",
							"<div class='form-group'>",
								"<label for='", this.p1_rpt_type, "' class='required'>", "<%=_T('Type')%>", "<%=_T(':')%>", "</label>",
								"<select id='", this.p1_rpt_type, "' class='form-control'></select>",
								"<i id='", this.p1_rpt_type, "_validation' class='formFieldValidation formFieldError' hidden ></i>",
							"</div>",
						"</div>",
						
						"<!-- EXPORT FORMAT -->",
						"<div id='", this.p1_rpt_export_format_section, "' class='col-3'>",
							"<div class='form-group'>",
								"<label for='", this.p1_rpt_export_format, "' class='required'>", "<%=_T('Export Format')%>", "<%=_T(':')%>", "</label>",
								"<select id='", this.p1_rpt_export_format, "' class='form-control'>",
									'<option value=""></option>',
									'<option value="csv">', '<%=_T("CSV")%>', '</option>',
									'<option value="database">', '<%=_T("DB")%>' , '</option>',
									'<option value="pdf">', '<%=_T("PDF")%>', '</option>',
								"</select>",
								"<i id='", this.p1_rpt_export_format, "_validation' class='formFieldValidation formFieldError' hidden ></i>",
							"</div>",
						"</div>",
						"<div class='col-3'>",
							"<div class='form-group'>",
								"<label for='", this.p1_rpt_id, "' class='formLabel-ds'>", "<%=_T('Report')%>", "<%=_T(':')%>", "</label>",
								"<select id='", this.p1_rpt_id, "' class='form-control' disabled='true'></select>",
								"<i id='", this.p1_rpt_id, "_validation' class='formFieldValidation formFieldError' hidden ></i>",
							"</div>",
						"</div>",
					"</div>",
				"</div>",
			"</div>",

			"<!-- FILTERS -->",
			"<div id='", this.p1_filters_section, "' class='card'>",
				"<div class='card-block'>",
					"<div class='card-header'>",
						"<h5>",
							"<%=_T('Filters')%>",
						"</h5>",
					"</div>",
					"<div id='", this.p1_rpt_filters_msg, "' class='inlineMessagesContainer messageInfo'>",
						"<label waiting-message='false' class='formFieldsetDisclaimerText'>", SELECT_FILTER_MSG, "</label>",
						"<label waiting-message='true' class='formFieldsetDisclaimerText' hidden>", "<%=_T('Retrieving data from server...')%>", "</label>",
					"</div>",
					"<div class='card-block report-filters'>",
						"<!-- los fitros disponibles dependen del reporte seleccionado -->",
						"<div id='", this.p1_rpt_filters, "' class='row' hidden >",
							// el contenido de los filtros del reporte se genera de forma dinamica en la funcion "fill_report_filters"
						"</div>",
					"</div>",
				"</div>",
			"</div>",

			"<!-- DAYS RANGE -->",
			"<div id='", this.p1_range_section, "' class='card'>",
			"<div class='card-block'>",
				"<div class='card-header'>",
					"<h5>",
						"<%=_T('Time interval')%>",
					"</h5>",
				"</div>",

				/*"<div id='", this.p1_rpt_range_msg, "' class='inlineMessagesContainer messageInfo'>",
					"<label waiting-message='false' class='formFieldsetDisclaimerText'>", SELECT_RANGE_MSG, "</label>",
				"</div>",*/

				"<div class='card-block' >",

					"<div id='", this.p1_range_options, "' class='row' hidden>",
						"<div class='col-3'>",
							"<div class='form-group'>",
								"<label for='", this.p1_range, "' class='required'>", "<%=_T('Range')%>", "<%=_T(':')%>", "</label>",
								"<select id='", this.p1_range, "' class='form-control'>",
								/*
									"<option></option>",
									"<option>Last 'n' Days</option>",
									"<option>Since last execution (first ejecution explaine??).</option>",
									"<option>Exact Interval</option>",
									"<option>Last Day</option>",
									"<option>Last Week</option>",
									"<option>Last Month</option>",
								*/
								"</select>",
								"<i id='", this.p1_range, "_validation' class='formFieldValidation formFieldError' hidden ></i>",
							"</div>",									
						"</div>",
					/*"</div>",*/

					"<!-- LAST HOURS -->",
					"<div range_panel='HoursBefore' class='col-3' hidden>",
						/*"<div class='card-block'>",*/
							"<div class='row'>",
								"<div class='col-12'>",
									"<div class='form-group spinner-hidden'>",
										"<label for='", this.p1_range_last_n_hours, "' class='required'>", "<%=_T('Hours')%>", "<%=_T(':')%>", "</label>",
										"<input id='", this.p1_range_last_n_hours, "' placeholder='", "<%=_T('Enter value')%> ","' class='form-control' type='text' spinner='true' spinner-min-value='1' spinner-max-value='24' spinner-step='1' spinner-overflow='true' />",
										"<span class='form-check-label-disclaimer'>", 
											"<%=_T('Valid range 1 - 24 hours')%>",
										"</span>",
										"<i id='", this.p1_range_last_n_hours, "_validation' class='formFieldValidation formFieldError' hidden ></i>",
									"</div>",
								"</div>",
							"</div>",
						/*"</div>",*/
					"</div>",

					"<!-- LAST DAYS -->",
					"<div range_panel='DaysBefore'class='col-3'  hidden>",
						/*"<div class='card-block'>",*/
							"<div class='row'>",
								"<div class='col-12'>",
									"<div class='form-group spinner-hidden'>",
										"<label for='", this.p1_range_last_n_days, "' class='required'>", "<%=_T('Days')%>", "<%=_T(':')%>", "</label>",
										"<input id='", this.p1_range_last_n_days, "' placeholder='", "<%=_T('Enter value')%> ","' class='form-control input-spinner' type='text' spinner='true' spinner-min-value='1' spinner-max-value='180' spinner-step='1' spinner-overflow='true' />",
										"<span id='", this.p1_range_last_n_days, "_disclaimer' class='form-check-label-disclaimer'>", 
											FORMAT("<%=_T('Valid range {0} - {1} days')%>", 1, 180),
										"</span>",
										"<i id='", this.p1_range_last_n_days, "_validation' class='formFieldValidation formFieldError' hidden ></i>",
									"</div>",
								"</div>",
							"</div>",
						/*"</div>",*/
					"</div>",

					"<!-- RANGE (Exact Interval)-->",
					"<div range_panel='Range' class='col-6'  hidden>", 
					/*"<div class='card-block'>",*/
							"<div class='row'>",
								"<div class='col-6'>",
									"<div class='form-group'>",
										"<label class='required'>", "<%=_T('Date from')%>", "<%=_T(':')%>", "</label>",
										"<input id='", this.p1_range_exact_from, "' class='form-control' type='text' readonly='true' datepicker='pair' datepicker-type='from' datepicker-rel='", this.p1_range_exact_to, "' />",
										"<i id='", this.p1_range_exact_from, "_validation' class='formFieldValidation formFieldError' hidden ></i>",
									"</div>",
								"</div>",
								"<div class='col-6'>",
									"<div class='form-group'>",
										"<label class='required'>", "<%=_T('Date to')%>", "<%=_T(':')%>", "</label>",
										"<input id='", this.p1_range_exact_to, "' class='form-control' type='text' readonly='true' datepicker='pair' datepicker-type='to' datepicker-rel='", this.p1_range_exact_from, "' />",
										"<i id='", this.p1_range_exact_to, "_validation' class='formFieldValidation formFieldError' hidden ></i>",
									"</div>",
								"</div>",
							"</div>",
						"</div>",
					/*"</div>",*/

				"</div>",

			"</div>",
			"</div>",
			"</div>",


			
			"<!-- EXPORT -->",
			"<div id='", this.p1_rpt_export_section, "' class='card' hidden>",
				"<div class='card-header'>",
					"<h5>",
						"<%=_T('Conversations')%>",
					"</h5>",
				"</div>",
				"<div class='card-block'>",
					"<div class='row'>",
						"<div class='col-12'>",
							"<div class='form-group'>",
								"<div class='form-check form-switch'>",
									"<label for='", this.p1_rpt_export, "' class='form-check-label'>",
										"<input id='", this.p1_rpt_export, "' class='form-check-input' type='checkbox' />",
										"<span>",
											"<%=_T('Export Conversations')%>", 
										"</span>",
									"</label>",
								"</div>",
							"</div>",
						"</div>",
					"</div>",
					"<div class='row'>",
						"<div class='col-3'>",
							"<div class='form-group'>",
								"<label for='", this.p1_rpt_export_content_type, "' class='formLabel-ds'>", "<%=_T('Content Type')%>", "<%=_T(':')%>", "</label>",
								"<select id='", this.p1_rpt_export_content_type, "' class='form-control' disabled>",
									'<option selected value="html">HTML</option>',
									'<option value="html_and_json">HTML & JSON</option>',
									'<option value="json">JSON</option>',
								"</select>",
								"<i id='", this.p1_rpt_export_content_type, "_validation' class='formFieldValidation formFieldError' hidden ></i>",
							"</div>",
						"</div>",
						"<div class='col-3'>",
							"<div class='form-group'>",
								"<label for='", this.p1_rpt_export_days_to_keep_cont, "' class='formLabel-ds'>", "<%=_T('Days to keep content')%>", "<%=_T(':')%>", "</label>",
								"<input id='", this.p1_rpt_export_days_to_keep_cont, "' class='form-control' type='text' spinner='true' spinner-min-value='1' spinner-max-value='90' spinner-step='1' spinner-overflow='true' spinner-initial-state='disabled' />",
								"<i id='", this.p1_rpt_export_days_to_keep_cont, "_validation' class='formFieldValidation formFieldError' hidden ></i>",
							"</div>",
						"</div>",
					"</div>",
				"</div>",
			"</div>"
		);
	};

	rd_form_schedule.prototype.get_html_page2 = function()
	{
		return "".concat(
			"<div id='", this.p2_frequency_section, "'class='card' >",
				"<div class='card-header'>",
					"<h5>",
						"<%=_T('Repetition')%>",
					"</h5>",
				"</div>",
				"<!-- FREQUENCY -->",
				"<div class='card-block'>",
					"<div  class='row'>",

						"<div class='col-3'>",
							"<div class='form-group'>",
								"<label for='", this.p2_frequency, "' class='required'>", "<%=_T('Type')%>", "<%=_T(':')%>", "</label>",
								"<select id='", this.p2_frequency, "' class='form-control'>",
								/*
									"<option></option>",
									"<option>Daily</option>",
									"<option>Weekly</option>",
									"<option>Monthly</option>",
									"<option>OneTime</option>",
									"<option>Custom Repeat</option>",
								*/
								"</select>",
								"<i id='", this.p2_frequency, "_validation' class='formFieldValidation formFieldError' hidden ></i>",
							"</div>",
						"</div>",

						"<!-- every N hours -->",
						"<div frequency_panel='EveryNHours' class='col-3' hidden>",
							"<div class='form-group'>",
								"<label for='", this.p2_frequency_every_n_hours, "' class='required'>", "<%=_T('Interval')%>", "<%=_T(':')%>", "</label>",
								"<select id='", this.p2_frequency_every_n_hours, "' class='form-control'>",
									'<option value="1">1</option>',
									'<option value="2">2</option>',
									'<option value="4">4</option>',
									'<option value="8">8</option>',
									'<option value="12">12</option>',
								"</select>",
								"<i id='", this.p2_frequency_every_n_hours, "_validation' class='formFieldValidation formFieldError' hidden ></i>",
								"<label for='", this.p2_frequency_every_n_hours, "' class='labelAfter'>", "<%=_T('Maximum 12 hours')%>","</label>",
							"</div>",
						"</div>",

						"<!-- daily -->",
						"<div frequency_panel='Daily' class='col-3' hidden>",
							"<div class='form-group'>",
								"<label for=='", this.p2_frequency_daily_hour, "' class='required'>", "<%=_T('Hour')%>", "<%=_T(':')%>", "</label>",
								"<input id='", this.p2_frequency_daily_hour, "' class='form-control' type='text' hour='true' />",
								"<i id='", this.p2_frequency_daily_hour, "_validation' class='formFieldValidation formFieldError' hidden ></i>",
								"<label for='", this.p2_frequency_daily_hour, "' class='labelAfter'>", "<%=_T('24-hour format')%>","</label>",
							"</div>",
						"</div>",

						"<!-- weekly -->",
						"<div frequency_panel='Weekly' class='col-6' hidden>",
							"<div class='row'>",
								"<div class='col-6'>",
									"<div class='form-group'>",
										"<label for='", this.p2_frequency_weekly_day, "' class='required'>", "<%=_T('Day of the week')%>", "<%=_T(':')%>", "</label>",
										"<select id='", this.p2_frequency_weekly_day, "' class='form-control'>",
										/*
											"<option></option>",
											"<option>Sunday</option>",
											"<option>Monday</option>",
											"<option>Tuesday</option>",
											"<option>Wednesday</option>",
											"<option>Thursday</option>",
											"<option>Friday</option>",
											"<option>Saturday</option>",
										*/
										"</select>",
										"<i id='", this.p2_frequency_weekly_day, "_validation' class='formFieldValidation formFieldError' hidden ></i>",
									"</div>",
								"</div>",
								"<div class='col-6'>",
									"<div class='form-group'>",
										"<label for='", this.p2_frequency_weekly_hour, "' class='required'>", "<%=_T('Hour')%>", "<%=_T(':')%>", "</label>",
										"<input id='", this.p2_frequency_weekly_hour, "' class='form-control' type='text' hour='true' />",
										"<i id='", this.p2_frequency_weekly_hour, "_validation' class='formFieldValidation formFieldError' hidden ></i>",
										"<label for='", this.p2_frequency_weekly_hour, "' class='labelAfter'>", "<%=_T('24-hour format')%>","</label>",
									"</div>",
								"</div>",
							"</div>",
						"</div>",

						"<!-- Monthly -->",
						"<div frequency_panel='Monthly' class='col-6' hidden>",
							"<div class='row'>",
								"<div class='col-6'>",
									"<div class='form-group mb-0'>",
										"<label for='" + this.p2_frequency_monthly_day + "' class='required'>", "<%=_T('Day Numbers')%>", "<%=_T(':')%>", "</label>",
										"<input id='" + this.p2_frequency_monthly_day + "' class='form-control' type='text' spinner='true' spinner-min-value='1' spinner-max-value='31' spinner-step='1' spinner-overflow='true' />",
										"<i id='" + this.p2_frequency_monthly_day + "_validation' class='formFieldValidation formFieldError' hidden ></i>",
										//"<label for='", this.p2_frequency_monthly_day, "' class='labelAfter'>", "<%=_T('Range valid from 1 to 31 days')%>","</label>",
									"</div>",
								"</div>",
								"<div class='col-6'>",
									"<div class='form-group'>",
										"<label for='", this.p2_frequency_monthly_hour, "' class='required'>", "<%=_T('Hour')%>", "<%=_T(':')%>", "</label>",
										"<input id='", this.p2_frequency_monthly_hour, "' class='form-control' type='text' hour='true' />",
										"<i id='", this.p2_frequency_monthly_hour, "_validation' class='formFieldValidation formFieldError' hidden ></i>",
										"<label for='", this.p2_frequency_monthly_hour, "' class='labelAfter'>", "<%=_T('24-hour format')%>","</label>",
									"</div>",
								"</div>",
							"</div>",
						"</div>",

						"<!-- One time -->",
						"<div frequency_panel='onetime' class='col-6' hidden>",
							"<div class='row'>",
								"<div class='col-6'>",
									"<div class='form-group'>",
										"<label class='required'>", "<%=_T('Date')%>", "<%=_T(':')%>", "</label>",
										"<input id='", this.p2_frequency_onetime_date, "' class='form-control' type='text' readonly='true' datepicker='true' />",
										"<i id='", this.p2_frequency_onetime_date, "_validation' class='formFieldValidation formFieldError' hidden ></i>",
									"</div>",
								"</div>",
								"<div class='col-6'>",
									"<div class='form-group'>",
										"<label for='", this.p2_frequency_onetime_hour, "' class='required'>", "<%=_T('Hour')%>", "<%=_T(':')%>", "</label>",
										"<input id='", this.p2_frequency_onetime_hour, "' class='form-control' type='text' hour='true' />",
										"<i id='", this.p2_frequency_onetime_hour, "_validation' class='formFieldValidation formFieldError' hidden ></i>",
										"<label for='", this.p2_frequency_onetime_date, "' class='labelAfter'>", "<%=_T('24-hour format')%>","</label>",
									"</div>",
								"</div>",
							"</div>",
						"</div>",

						"<!-- CustomRepeat -->",
						"<div frequency_panel='CustomRepeat' class='col-6' hidden>",
							"<div class='row'>",
								"<div class='col-6'>",
									"<div class='form-group'>",
										"<label for='" + this.p2_frequency_custom_interval + "' class='required'>", "<%=_T('Interval')%>", "<%=_T(':')%>", "</label>",
										"<input id='" + this.p2_frequency_custom_interval + "' class='form-control mb-0' type='text' spinner='true' spinner-min-value='2' spinner-max-value='50' spinner-step='1' spinner-overflow='true' />",
										"<i id='" + this.p2_frequency_custom_interval + "_validation' class='formFieldValidation formFieldError' hidden ></i>",
										"<label for='", this.p2_frequency_custom_interval, "' class='labelAfter'>", "<%=_T('Range valid from 2 to 50 days')%>","</label>",
									"</div>",
								"</div>",
								"<div class='col-6'>",
									"<div class='form-group'>",
										"<label for='", this.p2_frequency_custom_hour, "' class='required'>", "<%=_T('Hour')%>", "<%=_T(':')%>", "</label>",
										"<input id='", this.p2_frequency_custom_hour, "' class='form-control' type='text' hour='true' />",
										"<i id='", this.p2_frequency_custom_hour, "_validation' class='formFieldValidation formFieldError' hidden ></i>",
										"<label for='", this.p2_frequency_custom_hour, "' class='labelAfter'>", "<%=_T('24-hour format')%>","</label>",
									"</div>",
								"</div>",
							"</div>",
						"</div>",
					"</div>",
				"</div>",
			
			"</div>",
			"<!--  -->",

			"<!-- COMMON -->",
			"<div id='", this.p2_common_section, "' class='card'>",
				"<div class='card-header'>",
					"<h5>",
						"<%=_T('Start date')%>",
					"</h5>",
					"<div class='form-group form-group-header'>",
						"<div class='form-check form-switch'>",
							"<label for='", this.p2_common_require_starts_on_date, "' class='form-check-label'>",
								"<input id='", this.p2_common_require_starts_on_date, "' class='form-check-input' type='checkbox' />",
								"<span>",
									"<%=_T('Start Date')%>", 
								"</span>",
							"</label>",
						"</div>",
					"</div>",
				"</div>",
				"<div class='card-block'>",
					"<div class='row'>",
						"<div class='col-3'>",
							"<div class='form-group check-input-disabled'>",
								"<label for='", this.p2_common_starts_on_date, "' class=''>", "<%=_T('Date')%>", "<%=_T(':')%>", "</label>",
								"<input id='", this.p2_common_starts_on_date, "' class='form-control ' type='text' readonly='true' datepicker='true' />",
								"<i id='", this.p2_common_starts_on_date, "_validation' class='formFieldValidation formFieldError' hidden ></i>",
							"</div>",
						"</div>",
						"<div class='col-3'>",
							"<div class='form-group check-input-disabled'>",
								"<label for='", this.p2_common_starts_on_hour, "' class='required'>", "<%=_T('Hour')%>", "<%=_T(':')%>", "</label>",
								"<input id='", this.p2_common_starts_on_hour, "' class='form-control' type='text' hour='true' hour-default-value='00:00' />",
								"<i id='", this.p2_common_starts_on_hour, "_validation' class='formFieldValidation formFieldError' hidden ></i>",
								"<label for='", this.p2_frequency_monthly_hour, "' class='labelAfter'>", "<%=_T('24-hour format')%>","</label>",
							"</div>",
						"</div>",
					"</div>",

				"</div>",
			"</div>",

			"<!--  -->",
			"<!-- VALIDITY -->",
			"<div id='", this.p2_validity_section, "' class='card'>",			
				"<div class='card-header'>",
					"<h5>",
						"<%=_T('End date')%>",
					"</h5>",
				"</div>",
				"<div class='card-block'>",
					"<div class='row'>",
						"<div class='col-3'>",
							"<div class='form-group'>",
								"<label for='", this.p2_validity, "' class='required'>", "<%=_T('Validity')%>", "<%=_T(':')%>", "</label>",
								"<select id='", this.p2_validity, "' class='form-control' >",
								/*
									"<option></option>",
									"<option>Undefined (forever).</option>",
									"<option>Limited repetitions.</option>",
									"<option>Until Date.</option>",
								*/
								"</select>",
								"<i id='", this.p2_validity, "_validation' class='formFieldValidation formFieldError' hidden ></i>",
							"</div>",
						"</div>",
 
						"<!-- limited -->",						
						"<div validity_panel='limited' class='col-9' hidden>",
							"<div class='row'>",
								"<div class='col-4'>",
									"<div class='form-group spinner-hidden'>",
										"<label for='", this.p2_validity_limit_rep, "' class='required'>", "<%=_T('Repetitions')%>", "<%=_T(':')%>", "</label>",
										"<input id='", this.p2_validity_limit_rep, "' placeholder='", "<%=_T('Enter value')%> ", "' class='form-control' type='text' spinner='true' spinner-min-value='1' spinner-max-value='50' spinner-step='1' spinner-overflow='true' />",
										"<i id='", this.p2_validity_limit_rep, "_validation' class='formFieldValidation formFieldError' hidden ></i>",
										"<span class='form-check-label-disclaimer pl-0'>", 
											"<%=_T('Valid range 1 - 50 repetitions')%>",
										"</span>",
										"<label id='", this.p2_validity_limit_rep_message, "' class='formTextAux d-none' hidden></label>",
									"</div>",
								"</div>",
							"</div>",
						"</div>",
						
						"<div validity_panel='until' class='col-9' hidden>",
							"<!-- until date -->",
							"<div class='row'>",
								"<div class='col-4'>",
									"<div class='form-group'>",
										"<label class='required'>", "<%=_T('Date')%>", "<%=_T(':')%>", "</label>",
										"<input id='", this.p2_validity_until_date, "' class='form-control' type='text' readonly='true' datepicker='true' start-date-increment='1' />",
										"<i id='", this.p2_validity_until_date, "_validation' class='formFieldValidation formFieldError' hidden ></i>",
									"</div>",
								"</div>",
								"<div class='col-4'>",
									"<div class='form-group'>",
										"<label for='", this.p2_validity_until_hour, "' class='required'>", "<%=_T('Hour')%>", "<%=_T(':')%>", "</label>",
										"<input id='", this.p2_validity_until_hour, "' class='form-control' type='text' hour='true' hour-default-value='23:59' />",
										"<i id='", this.p2_validity_until_hour, "_validation' class='formFieldValidation formFieldError' hidden ></i>",
										"<label for='", this.p2_validity_until_hour, "' class='labelAfter'>", "<%=_T('24-hour format')%>","</label>",
									"</div>",
								"</div>",
							"</div>",
						"</div>",
					
					"</div>",

					
					"</div>",
				"</div>",			
			"</div>",
		);
	};

	rd_form_schedule.prototype.get_html_page3 = function()
	{
		// html DataBase
		const html_db = "".concat(
			"<div class='card'>",
			"<div class='card-header'>",
				"<h5>",
					"<%=_T('Sendings')%>",
				"</h5>",
			"</div>",
				"<div class='card-block'>",
					"<div class='row'>",
						"<div class='col-3'>",
							"<div class='form-group'>",
								"<label for='", this.p3_db_type, "' class='required'>", "<%=_T('Type')%>", "<%=_T(':')%>", "</label>",
								"<select id='", this.p3_db_type, "' class='form-control'></select>",
								"<i id='", this.p3_db_type, "_validation' class='formFieldValidation formFieldError' hidden ></i>",
							"</div>",
						"</div>",
					"</div>",
				"</div>",
			"</div>",
				
			"<div class='card'>",
				"<div class='card-header'>",
					"<h5>",
						"<%=_T('Sending data')%>",
					"</h5>",
				"</div>",
				"<div class='card-block'>",
					"<div class='row'>",
						"<div class='col-3'>",
							"<div class='form-group'>",
								"<label for='", this.p3_db_server, "' class='required'>", "<%=_T('Server')%>", "<%=_T(':')%>", "</label>",
								"<input id='", this.p3_db_server, "' class='form-control' type='text'/>",
								"<i id='", this.p3_db_server, "_validation' class='formFieldValidation formFieldError' hidden ></i>",
							"</div>",
						"</div>",
						"<div class='col-3'>",
							"<div class='form-group'>",
								"<label for='", this.p3_db_port, "' class='required'>", "<%=_T('Port')%>", "<%=_T(':')%>", "</label>",
								"<input id='", this.p3_db_port, "' class='form-control' type='text'/>",
								"<i id='", this.p3_db_port, "_validation' class='formFieldValidation formFieldError' hidden ></i>",
							"</div>",
						"</div>",
						"<div class='col-3'>",
							"<div class='form-group'>",
								"<label for='", this.p3_db_user, "' class='required'>", "<%=_T('User')%>", "<%=_T(':')%>", "</label>",
								"<input id='", this.p3_db_user, "' class='form-control' type='text' />",
								"<i id='", this.p3_db_user, "_validation' class='formFieldValidation formFieldError' hidden ></i>",
							"</div>",
						"</div>",
						"<div class='col-3'>",
							"<div class='form-group'>",
								"<label for='", this.p3_db_pwd, "' class='required'>", "<%=_T('Password')%>", "<%=_T(':')%>", "</label>",
								"<input id='", this.p3_db_pwd, "' class='form-control' type='password' autocomplete='new-password' />",
								"<i id='", this.p3_db_pwd, "_validation' class='formFieldValidation formFieldError' hidden ></i>",
							"</div>",
						"</div>",
					"</div>",
					"<div class='row'>",
						"<div class='col-3'>",
							"<div class='form-group'>",
								"<label for='", this.p3_db_name, "' class='required'>", "<%=_T('DataBase Name')%>", "<%=_T(':')%>", "</label>",
								"<input id='", this.p3_db_name, "' class='form-control' type='text'/>",
								"<i id='", this.p3_db_name, "_validation' class='formFieldValidation formFieldError' hidden ></i>",
							"</div>",
						"</div>",
					"</div>",
				"</div>",				
			"</div>",				

			// Configuracion del e-mail de notificacion ante una evenutal error.
			//
			"<div class='card'>",
				"<div class='card-header'>",
					"<h5>",
						"<%=_T('Notification Error Configuration')%>",
					"</h5>",
				"</div>",
				"<div class='card-block'>",
					"<div class='row'>",
						"<div class='col-3'>",
							"<div class='form-group'>",
								"<label for='", this.p3_db_error_mail_to, "' class=''>", "<%=_T('Recipient mailing address')%>", "<%=_T(':')%>", "</label>",
								"<input id='", this.p3_db_error_mail_to, "' class='form-control' type='text'/>",
								"<i id='", this.p3_db_error_mail_to, "_validation' class='formFieldValidation formFieldError' hidden ></i>",
							"</div>",
						"</div>",
						"<div class='col-3'>",
							"<div class='form-group'>",
								"<label for='", this.p3_db_error_mail_from, "' class=''>", "<%=_T('Outgoing e-mail address')%>", "<%=_T(':')%>", "</label>",
								"<select id='", this.p3_db_error_mail_from, "' class='form-control'></select>",
								"<i id='", this.p3_ftp_db_mail_from, "_validation' class='formFieldValidation formFieldError' hidden ></i>",
							"</div>",
						"</div>",
/* 						"<div class='col-3'>",
							"<div class='form-group'>",
								"<label for='", this.p3_db_sp_sample, "' class=''>", "<%=_T('Example')%>", "<%=_T(':')%>", "</label>",
								"<textarea id='", this.p3_db_sp_sample, "' class='form-control rowsBased' rows='8'> readonly='true'></textarea>",
							"</div>",
						"</div>", */
					"</div>",

					"<div class='row'>",
						"<div class='col-6'>",
							"<div class='form-group'>",
								"<label for='", this.p3_db_sp_sample, "' class=''>", "<%=_T('Example')%>", "<%=_T(':')%>", "</label>",
								"<textarea id='", this.p3_db_sp_sample, "' class='form-control rowsBased' rows='8'> readonly='true'></textarea>",
							"</div>",
						"</div>",
					"</div>",

				"</div>",

				"<div id='", this.p3_db_sp_threaded_sample, "_panel' class='card-block'>",
					"<div class='row'>",
						"<div class='col-6'>",
							"<div class='form-group'>",
								"<label for='", this.p3_db_sp_threaded_sample, "' class=''>", "<%=_T('Example')%>", "<%=_T(':')%>", "</label>",
								"<textarea id='", this.p3_db_sp_threaded_sample, "' class='form-control rowsBased' rows='8'> readonly='true'></textarea>",
							"</div>",
						"</div>",
					"</div>",
				"</div>",

				"<div class='card-block'>",
					"<div class='row'>",
						"<div class='col-6'>",
							"<div class='form-group'>",
								"<label for='", this.p3_db_sp_transaction_sample, "' class=''>", "<%=_T('Example')%>", "<%=_T(':')%>", "</label>",
								"<textarea id='", this.p3_db_sp_transaction_sample, "' class='form-control rowsBased'  rows='8'> readonly='true'></textarea>",
							"</div>",
						"</div>",
					"</div>",
				"</div>",
			"</div>",
		);

		// html ftp
		var html_ftp = "".concat(
			"<div class='card'>",
				"<div class='card-header'>",
					"<h5>",
						"<%=_T('Sending data')%>",
					"</h5>",
				"</div>",
				"<div class='card-block'>",				
					"<div class='row'>",
						"<div class='col-3'>",
							"<div class='form-group'>",
								"<label for='", this.p3_ftp_filename, "' class='required'>", "<%=_T('File Name')%>", "<%=_T(':')%>", "</label>",
								"<input id='", this.p3_ftp_filename, "' class='form-control' placeholder='<%=_T('Enter name')%>...' type='text'/>",
								"<i id='", this.p3_ftp_filename, "_validation' class='formFieldValidation formFieldError' hidden ></i>",
							"</div>",
						"</div>",
						"<div class='col-3'>",
							"<div class='form-group'>",
								"<label for='", this.p3_ftp_directory, "' class=''>", "<%=_T('Directory')%>", "<%=_T(':')%>", "</label>",
								"<input id='", this.p3_ftp_directory, "' class='form-control' placeholder='<%=_T('Enter directory')%>...' type='text'/>",
								"<i id='", this.p3_ftp_directory, "_validation' class='formFieldValidation formFieldError' hidden ></i>",
							"</div>",
						"</div>",
					"</div>",
					"<div class='row'>",
						"<div class='col-3'>",
							"<div class='form-group'>",
								"<label for='", this.p3_ftp_host, "' class='required'>", "<%=_T('Host')%>", "<%=_T(':')%>", "</label>",
								"<input id='", this.p3_ftp_host, "' class='form-control' placeholder='<%=_T('Enter host')%>...' type='text'/>",
								"<i id='", this.p3_ftp_host, "_validation' class='formFieldValidation formFieldError' hidden ></i>",
							"</div>",
						"</div>",
						"<div class='col-3'>",
							"<div class='form-group'>",
								"<label for='", this.p3_ftp_port, "' class=''>", "<%=_T('Port')%>", "<%=_T(':')%>", "</label>",
								"<input id='", this.p3_ftp_port, "' class='form-control' placeholder='<%=_T('Enter port')%>...' type='text'/>",
								"<i id='", this.p3_ftp_port, "_validation' class='formFieldValidation formFieldError' hidden ></i>",
							"</div>",
						"</div>",
						"<div class='col-3'>",
							"<div class='form-group'>",
								"<label for='", this.p3_ftp_user, "' class='required'>", "<%=_T('User')%>", "<%=_T(':')%>", "</label>",
								"<input id='", this.p3_ftp_user, "' class='form-control' placeholder='<%=_T('Enter user')%>...' type='text' />",
								"<i id='", this.p3_ftp_user, "_validation' class='formFieldValidation formFieldError' hidden ></i>",
							"</div>",
						"</div>",
						"<div class='col-3'>",
							"<div class='form-group'>",
								"<label for='", this.p3_ftp_pwd, "' class='required'>", "<%=_T('Password')%>", "<%=_T(':')%>", "</label>",
								"<input id='", this.p3_ftp_pwd, "' class='form-control' placeholder='<%=_T('Enter password')%>...' type='password'autocomplete='new-password' />",
								"<i id='", this.p3_ftp_pwd, "_validation' class='formFieldValidation formFieldError' hidden ></i>",
							"</div>",
						"</div>",
					"</div>",
				"</div>",
			"</div>",

			"<div class='card'>",
				// Configuracion del e-mail de notificacion ante una evenutal error.
				//
				"<div class='card-block'>",
					"<div class='card-header'>",
						"<h5>",
							"<%=_T('Notification Error Configuration')%>",
						"</h5>",
					"</div>",

					"<div class='row'>",
						"<div class='col-3'>",
							"<div class='form-group'>",
								"<label for='", this.p3_ftp_error_mail_to, "' class=''>", "<%=_T('Recipient mailing address')%>", "<%=_T(':')%>", "</label>",
								"<input id='", this.p3_ftp_error_mail_to, "' class='form-control' placeholder='<%=_T('Enter e-mail')%>...' type='text'/>",
								"<i id='", this.p3_ftp_error_mail_to, "_validation' class='formFieldValidation formFieldError' hidden ></i>",
							"</div>",
						"</div>",
						"<div class='col-3'>",
							"<div class='form-group'>",
								"<label for='", this.p3_ftp_error_mail_from, "' class=''>", "<%=_T('Outgoing e-mail address')%>", "<%=_T(':')%>", "</label>",
								"<select id='", this.p3_ftp_error_mail_from, "' class='form-control' placeholder='<%=_T('Select outgoing account')%>...'></select>",
								"<i id='", this.p3_ftp_error_mail_from, "_validation' class='formFieldValidation formFieldError' hidden ></i>",
							"</div>",
						"</div>",
					"</div>",
				"</div>",
			"</div>"
		);

		// html sftp
		var html_sftp = "".concat(
			"<div class='card'>",
				"<div class='card-header'>",
					"<h5>",
						"<%=_T('Sending data')%>",
					"</h5>",
				"</div>",
				"<div class='card-block'>",				
					"<div class='row'>",
						"<div class='col-3'>",
							"<div class='form-group'>",
								"<label for='", this.p3_sftp_filename, "' class='required'>", "<%=_T('File Name')%>", "<%=_T(':')%>", "</label>",
								"<input id='", this.p3_sftp_filename, "' class='form-control' placeholder='<%=_T('Enter name')%>...' type='text'/>",
								"<i id='", this.p3_sftp_filename, "_validation' class='formFieldValidation formFieldError' hidden ></i>",
							"</div>",
						"</div>",
						"<div class='col-3'>",
							"<div class='form-group'>",
								"<label for='", this.p3_sftp_directory, "' class=''>", "<%=_T('Directory')%>", "<%=_T(':')%>", "</label>",
								"<input id='", this.p3_sftp_directory, "' class='form-control' placeholder='<%=_T('Enter directory')%>...' type='text'/>",
								"<i id='", this.p3_sftp_directory, "_validation' class='formFieldValidation formFieldError' hidden ></i>",
							"</div>",
						"</div>",
					"</div>",
					"<div class='row'>",
						"<div class='col-3'>",
							"<div class='form-group'>",
								"<label for='", this.p3_sftp_host, "' class='required'>", "<%=_T('Host')%>", "<%=_T(':')%>", "</label>",
								"<input id='", this.p3_sftp_host, "' class='form-control' placeholder='<%=_T('Enter host')%>...' type='text'/>",
								"<i id='", this.p3_sftp_host, "_validation' class='formFieldValidation formFieldError' hidden ></i>",
							"</div>",
						"</div>",
						"<div class='col-3'>",
							"<div class='form-group'>",
								"<label for='", this.p3_sftp_port, "' class=''>", "<%=_T('Port')%>", "<%=_T(':')%>", "</label>",
								"<input id='", this.p3_sftp_port, "' class='form-control' placeholder='<%=_T('Enter port')%>...' type='text'/>",
								"<i id='", this.p3_sftp_port, "_validation' class='formFieldValidation formFieldError' hidden ></i>",
							"</div>",
						"</div>",
						"<div class='col-3'>",
							"<div class='form-group'>",
								"<label for='", this.p3_sftp_user, "' class='required'>", "<%=_T('User')%>", "<%=_T(':')%>", "</label>",
								"<input id='", this.p3_sftp_user, "' class='form-control' placeholder='<%=_T('Enter user')%>...' type='text' />",
								"<i id='", this.p3_sftp_user, "_validation' class='formFieldValidation formFieldError' hidden ></i>",
							"</div>",
						"</div>",
						"<div class='col-3'>",
							"<div class='form-group'>",
								"<label for='", this.p3_sftp_pwd, "' class='required'>", "<%=_T('Password')%>", "<%=_T(':')%>", "</label>",
								"<input id='", this.p3_sftp_pwd, "' class='form-control' placeholder='<%=_T('Enter password')%>...' type='password' autocomplete='new-password' />",
								"<i id='", this.p3_sftp_pwd, "_validation' class='formFieldValidation formFieldError' hidden ></i>",
							"</div>",
						"</div>",
					"</div>",
				"</div>",
			"</div>",
				
			"<div class='card'>",
				// Configuracion del e-mail de notificacion ante una evenutal error.
				//
				"<div class='card-block'>",
					"<div class='card-header'>",
						"<h5>",
							"<%=_T('Notification Error Configuration')%>",
						"</h5>",
					"</div>",
					"<div class='row'>",
						"<div class='col-3'>",
							"<div class='form-group'>",
								"<label for='", this.p3_sftp_error_mail_to, "' class=''>", "<%=_T('Recipient mailing address')%>", "<%=_T(':')%>", "</label>",
								"<input id='", this.p3_sftp_error_mail_to, "' class='form-control' placeholder='<%=_T('Enter e-mail')%>...' type='text'/>",
								"<i id='", this.p3_sftp_error_mail_to, "_validation' class='formFieldValidation formFieldError' hidden ></i>",
							"</div>",
						"</div>",
						"<div class='col-3'>",
							"<div class='form-group'>",
								"<label for='", this.p3_sftp_error_mail_from, "' class=''>", "<%=_T('Outgoing e-mail address')%>", "<%=_T(':')%>", "</label>",
								"<select id='", this.p3_sftp_error_mail_from, "' class='form-control' placeholder='<%=_T('Select outgoing account')%>...'></select>",
								"<i id='", this.p3_sftp_error_mail_from, "_validation' class='formFieldValidation formFieldError' hidden ></i>",
							"</div>",
						"</div>",
					"</div>",
				"</div>",
			"</div>"
		);

		// html e-mail
		var html_mail = "".concat(
			"<div class='card'>",
				"<div class='card-header'>",
					"<h5>",
						"<%=_T('Sending data')%>",
					"</h5>",
				"</div>",
				"<div class='card-block'>",
				
				
					"<div class='row'>",
						"<div class='col-6'>",
							"<div class='row'>",
								"<div class='col-6'>",								
									"<div class='form-group'>",
										"<label for='", this.p3_mail_to, "' class='required'>", "<%=_T('Recipient mailing address')%>", "<%=_T(':')%>", "</label>",
										"<input id='", this.p3_mail_to, "' class='form-control' placeholder='<%=_T('Enter e-mail')%>...' type='text'/>",
										"<i id='", this.p3_mail_to, "_validation' class='formFieldValidation formFieldError' hidden ></i>",
									"</div>",
								"</div>",
								"<div class='col-6'>",								
									"<div class='form-group'>",
										"<label for='", this.p3_mail_from, "' class='required'>", "<%=_T('Outgoing e-mail address')%>", "<%=_T(':')%>", "</label>",
										"<select id='", this.p3_mail_from, "' class='form-control' placeholder='<%=_T('Select outgoing account')%>...'>></select>",
										"<i id='", this.p3_mail_from, "_validation' class='formFieldValidation formFieldError' hidden ></i>",
									"</div>",
								"</div>",
								"<div class='col-6'>",								
									"<div class='form-group'>",
										"<label for='", this.p3_mail_attach, "' class='required'>", "<%=_T('Name attached')%>", "<%=_T(':')%>", "</label>",
										"<input id='", this.p3_mail_attach, "' class='form-control' placeholder='<%=_T('Enter name')%>...' type='text'/>",
										"<i id='", this.p3_mail_attach, "_validation' class='formFieldValidation formFieldError' hidden ></i>",
									"</div>",
								"</div>",
								"<div class='col-6'>",
									"<div class='form-group'>",
										"<label for='", this.p3_mail_subject, "' class='required'>", "<%=_T('Subject')%>", "<%=_T(':')%>", "</label>",
										"<input id='", this.p3_mail_subject, "' class='form-control' placeholder='<%=_T('Enter subject')%>...' type='text' />",
										"<i id='", this.p3_mail_subject, "_validation' class='formFieldValidation formFieldError' hidden ></i>",
									"</div>",
								"</div>",
							"</div>",
						"</div>",
						"<div class='col-6'>",						
							"<div class='form-group h-100'>",
								"<label for='", this.p3_mail_body, "' class='required'>", "<%=_T('E-Mail body')%>", "<%=_T(':')%>", "</label>",
								"<textarea id='", this.p3_mail_body, "' class='form-control rowsBased h-100' rows='6' placeholder='<%=_T('Enter body')%>...'></textarea>",
								"<i id='", this.p3_mail_body, "_validation' class='formFieldValidation formFieldError' hidden ></i>",
							"</div>",
						"</div>",
					"</div>",
				"</div>",
			"</div>"
		);

		return "".concat(
			"<div class='card'>",
				"<div class='card-header'>",
					"<h5>",
						"<%=_T('Sendings')%>",
					"</h5>",
				"</div>",
				"<div class='card-block'>",
					"<div class='row'>",
						"<div class='col-3'>",
							"<div class='form-group'>",
								"<label for='", this.p3_send_type, "' class='required'>", "<%=_T('Type')%>", "<%=_T(':')%>", "</label>",
								"<select id='", this.p3_send_type, "' class='form-control' placeholder='<%=_T('Select send type')%>...'></select>",
								"<i id='", this.p3_send_type, "_validation' class='formFieldValidation formFieldError' hidden ></i>",
							"</div>",
						"</div>",
					"</div>",
				"</div>",
			"</div>",
			
			"<div id='", this.p3_panel_db, "' class='' hidden>",
				html_db,
			"</div>",

			"<div id='", this.p3_panel_ftp, "' class='' hidden>",
				html_ftp,
			"</div>",

			"<div id='", this.p3_panel_sftp, "' class='' hidden>",
				html_sftp,
			"</div>",

			"<div id='", this.p3_panel_mail, "' class='' hidden>",
				html_mail,
			"</div>"
		);
	};

	rd_form_schedule.prototype.fill_common_cbo = function( cbo_id, list, attr_id, attr_name )
	{
		const $cbo = $( "#" + cbo_id );
		$cbo.html("");
		const is_blank_first_item = true;
		attr_id = attr_id || "id";
		attr_name = attr_name || "name";
		this.fill_combo( $cbo, is_blank_first_item, list, attr_id, attr_name );
	};

	rd_form_schedule.prototype.fill_reports_type = function()
	{
		var list = [
			{ id: "detail"        , name: "<%=_T('Detail')%>"          },
			{ id: "realtime"      , name: "<%=_T('Realtime')%>"        },
			{ id: "summary"       , name: "<%=_T('Summary')%>"         },
			{ id: "dialerbatch"   , name: "<%=_T('Dialer Batches')%>"  },
			{ id: "dialercontacts", name: "<%=_T('Dialer Contacts')%>" },
			{ id: "livedetail"    , name: "<%=_T('Live Details')%>"    }
		];
		var cbo_id = this.p1_rpt_type;
		this.fill_common_cbo( cbo_id, list );
	};

	rd_form_schedule.prototype.fill_range = function()
	{
		var list = [
			{ id: "SinceLastReport", name: "<%=_T('Since Last Execution')%>" },
			{ id: "Range"          , name: "<%=_T('Exact Interval')%>"       },
			{ id: "LastDay"        , name: "<%=_T('Last Day')%>"             },
			{ id: "LastWeek"       , name: "<%=_T('Last Week')%>"            },
			{ id: "LastMonth"      , name: "<%=_T('Last Month')%>"           },
			{ id: "DaysBefore"     , name: "<%=_T('Last n Days')%>"          },
			{ id: "HoursBefore"    , name: "<%=_T('Last n Hours')%>"         }
		];
		var cbo_id = this.p1_range;
		this.fill_common_cbo( cbo_id, list );
	};

	rd_form_schedule.prototype.fill_frequency = function()
	{
		const list = [
			{ id: "EveryNHours" , name: "<%=_T('Every N hours')%>" },
			{ id: "Daily"       , name: "<%=_T('Daily')%>"         },
			{ id: "Weekly"      , name: "<%=_T('Weekly')%>"        },
			{ id: "Monthly"     , name: "<%=_T('Monthly')%>"       },
			{ id: "CustomRepeat", name: "<%=_T('Custom Repeat')%>" },
			{ id: "onetime"     , name: "<%=_T('One Time')%>"      }
		];
		const cbo_id = this.p2_frequency;
		this.fill_common_cbo(cbo_id, list);
	};

	rd_form_schedule.prototype.fill_frequency_days = function()
	{
		const list = [
			{ id: "1", name: "<%=_T('Sunday')%>"    },
			{ id: "2", name: "<%=_T('Monday')%>"    },
			{ id: "3", name: "<%=_T('Tuesday')%>"   },
			{ id: "4", name: "<%=_T('Wednesday')%>" },
			{ id: "5", name: "<%=_T('Thursday')%>"  },
			{ id: "6", name: "<%=_T('Friday')%>"    },
			{ id: "7", name: "<%=_T('Saturday')%>"  }
		];
		const cbo_id = this.p2_frequency_weekly_day;
		this.fill_common_cbo( cbo_id, list );
	};

	rd_form_schedule.prototype.fill_validity = function()
	{
		const list = [
			{ id: "undefined", name: "<%=_T('Undefined (forever)')%>" },
			{ id: "limited"  , name: "<%=_T('Limited repetitions')%>" },
			{ id: "until"    , name: "<%=_T('Until Date')%>"          }
		];
		const cbo_id = this.p2_validity;
		this.fill_common_cbo( cbo_id, list );
	};

	rd_form_schedule.prototype.fill_vcc_mail_addresses = function(vcc_mail_addresses)
	{
		this.fill_common_cbo(this.p3_mail_from           , vcc_mail_addresses, "uid" , "uid");
		this.fill_common_cbo(this.p3_ftp_error_mail_from , vcc_mail_addresses, "uid" , "uid");
		this.fill_common_cbo(this.p3_sftp_error_mail_from, vcc_mail_addresses, "uid" , "uid");
		this.fill_common_cbo(this.p3_db_error_mail_from  , vcc_mail_addresses, "uid" , "uid");
	};

	rd_form_schedule.prototype.fill_db_types = function()
	{
		const list = [
			{ id: "my_sql"    , name: "<%=_T('MYSQL')%>"      },
			{ id: "sql_server", name: "<%=_T('SQL SERVER')%>" }
		];
		const cbo_id = this.p3_db_type;
		this.fill_common_cbo(cbo_id, list);
	};

	rd_form_schedule.prototype.fill_send_type_options = function(send_type = "mail_ftp")
	{
		let list = [];

		if (send_type === "mail_ftp") {
			list.push({ id: "mail"    , name: "<%=_T('E-MAIL')%>"     });
			list.push({ id: "ftp"     , name: "<%=_T('FTP')%>"      });
			list.push({ id: "sftp"    , name: "<%=_T('SFTP')%>"     });
		}

		if (send_type === "database") {
			list.push({ id: "database", name: "<%=_T('DATABASE')%>" });
		}

		const cbo_id = this.p3_send_type;
		this.fill_common_cbo(cbo_id, list);
	};

	rd_form_schedule.prototype.load_data = function( callback_complete_requests )
	{
		const self = this;

		// page 1
		this.fill_reports_type();

		// page 2
		this.fill_range();
		this.fill_frequency();
		this.fill_frequency_days();
		this.fill_validity();

		// page 3
		this.fill_send_type_options();
		this.fill_db_types();

		this.requests = [];
		// request para cargar los outgoing mails
		var base_uri = inConcert.app.getBaseDomain() + "/inconcert/apps/administration/";
		this.requests.push(
			{
				url: base_uri + "vccs/accounts/search/",
				type: "POST",
				data: { columns: ["uid"], special_values: { accountType: "MAIL" } },
				success: function( vcc_accounts )
				{
					self.fill_vcc_mail_addresses( vcc_accounts.rows );
				},
				error: function() {
					var message = "<%=_T('Error retrieving vcc addresses.')%>";
					var timeout_ms = 5000;
					self.show_status_message( message, "Error", timeout_ms );
				}
			}
		);

		rd_form_schedule.uber.load_data.call( this, callback_complete_requests ); //invokes the base class method
	};

	rd_form_schedule.prototype.get_filters = function()
	{
		const self = this;

		let filters = {};
		const must_validate_required = !this.__filters_are_not_required();

		const $filters = $( "#" + this.p1_rpt_filters ).find( "[filter_field]" );

		$.each( $filters, function( _, filter )
		{
			const $filter = $( filter );
			var is_required   = must_validate_required && $filter.data( "required" );
			var filter_type   = $filter.data( "filter_type" );
			var filter_id     = $filter.data( "filter_id" );
			var dom_filter_id = self.make_dom_filter_id( filter_id );
			var $input        = $( "#" + dom_filter_id );
			var filter_value  = null;

			switch ( filter_type )
			{
				case "boolean":
					filter_value = $input.prop( "checked" );
					break;

				case "string":
					filter_value = $input.val();
					break;

				case "enum": // cbo
					filter_value = $input.val();
					break;

				// case "date":
				// LOS DATES NO SE INCLUYEN EN EL FILTRO. SOLO LO DEJO ACA COMO REFERENCIA.
				//	break;

				default:
					throw "Don't know how to represent filter type " + filter_type;
			}

			filter_value = filter_value || "";
			if ( !is_required && filter_value.trim().length === 0 ) {
			// si no es requerido y no se ha ingresado ningun valor, el campo no se agrega al filtro de datos.
				return true; // continue
			}

			filters [ filter_id ] = self.current_report.processFilterValue(filter_id, filter_value);
		});

		filters.withContent = false;
		if ( this.can_export() ) {
			filters.withContent = $( "#" + this.p1_rpt_export ).prop( "checked" );
		}

		return filters;
	};

	rd_form_schedule.prototype.get_range = function()
	{
		let range = {
			enabled: this.__has_range_section(),
			type   : $("#" + this.p1_range).val()
		};

		if (range.enabled && range.type === "") {
			const range_are_not_required = this.__range_are_not_required();
			if (range_are_not_required) {
				range.enabled = false;
			}
		}

		return range;
	};

	rd_form_schedule.prototype.get_data_page1 = function()
	{
		var $report = $( "#" + this.p1_rpt_id );

		var data = {
			report_type : $( "#" + this.p1_rpt_type ).val(),
			report      : $report.val(),
			filters     : this.get_filters(), // aca viaja tambien el attr de exportacion (withContent)
			range       : this.get_range(),
			export_format: $( "#" + this.p1_rpt_export_format ).val()
		};

		if ( data.range.type === "Range" ) {
			data.range.from = $( "#" + this.p1_range_exact_from ).val();
			data.range.to = $( "#" + this.p1_range_exact_to ).val();
		}
		else if ( data.range.type === "DaysBefore" ) {
			data.range.days = str_to_int( $( "#" + this.p1_range_last_n_days ).val() );
		}
		else if ( data.range.type === "HoursBefore" ) {
			data.range.hours = str_to_int( $( "#" + this.p1_range_last_n_hours ).val() );
		}

		// dias que se mantiene el contenido en el repo, va de la mano con el attr "withContent" de los filtros
		if ( data.filters.withContent ) {
			data.days_to_keep_content = $( "#" + this.p1_rpt_export_days_to_keep_cont ).val();
			data.export_content_type  = $( "#" + this.p1_rpt_export_content_type ).val() || "HTML";
		}

		// Datos adicionales, solo se utilizan en la grilla del lado del cliente. Del lado del server son eliminados, si es que llegan.
		var report_name = $( "option:selected", $report ).text();
		data.__report_info = {
			id          : data.report,
			description : report_name,
			label       : report_name,
			name        : report_name,
			type        : data.report_type,
			typeLabel   : data.report_type
		};

		// state
		var editing_sch = this.get_entity_instance();
		if ( editing_sch ) {
			data.State = "active"; // siempre que se actualiza, se activa
		}

		return data;
	};

	rd_form_schedule.prototype.get_data_page2 = function()
	{
		var data = { common: {}, frequency: {}, validity: {} };

		// frequency ----------------------
		var repeat_policy = $( "#" + this.p2_frequency ).val();

		var format_hour = function( ctrl_id ) {
			var hour = $( "#" + ctrl_id ).val();
			return hour + ":00"; // tienen que ir los segundos
		};

		switch ( repeat_policy )
		{
			case "EveryNHours":
				data.frequency.repetition_every_n_hour = $( "#" + this.p2_frequency_every_n_hours ).val();
				break;
			
			case "Daily":
				data.frequency.repetition_hour = format_hour( this.p2_frequency_daily_hour );
				break;

			case "Weekly":
				data.frequency.repeat_weekday = $( "#" + this.p2_frequency_weekly_day ).val();
				data.frequency.repetition_hour = format_hour( this.p2_frequency_weekly_hour );
				break;

			case "Monthly":
				data.frequency.repeat_day = $( "#" + this.p2_frequency_monthly_day ).val();
				data.frequency.repetition_hour = format_hour( this.p2_frequency_monthly_hour );
				break;

			case "CustomRepeat":
				data.frequency.custom_repeat_days = $( "#" + this.p2_frequency_custom_interval ).val();
				data.frequency.repetition_hour = format_hour( this.p2_frequency_custom_hour );
				break;

			case "onetime":
				repeat_policy = undefined;
				data.frequency.one_time_date = $( "#" + this.p2_frequency_onetime_date ).val();
				data.frequency.one_time_hour = format_hour( this.p2_frequency_onetime_hour );
				break;

			default:
				throw "Don't know repeat policy " + repeat_policy;
		}

		data.frequency.repeat_policy = repeat_policy;

		//common ----------------------
		if ( $( "#" + this.p2_common_require_starts_on_date ).prop( "checked" ) ) {
			data.common.starts_on_date = $( "#" + this.p2_common_starts_on_date ).val();
			data.common.starts_on_hour = format_hour( this.p2_common_starts_on_hour );
		}

		//validity ----------------------
		var validity_type;
		if ( repeat_policy !== "onetime" ) {
			validity_type = $( "#" + this.p2_validity ).val();

			if ( validity_type === "limited" ) {
				var $validity_limit_rep = $( "#" + this.p2_validity_limit_rep );
				var ends_after = str_to_int( $validity_limit_rep.val() );
				var previous_data = $validity_limit_rep.data( "previous_data" );
				if ( previous_data ) {
					var remaining = previous_data.total - previous_data.executed;
					var difference = ends_after - remaining;
					ends_after = previous_data.total + difference;
				}
				data.validity.ends_after = ends_after;
			}
			else if ( validity_type === "until" ) {
				data.validity.ends_on_date = $( "#" + this.p2_validity_until_date ).val();
				data.validity.ends_on_hour = format_hour( this.p2_validity_until_hour );
			}
		}
		data.validity.type = validity_type || "none";
		//---------------
		return data;
	};

	rd_form_schedule.prototype.get_data_page3 = function()
	{
		let data = {
			send_type: $("#" + this.p3_send_type).val(),
			mail     : {},
			ftp      : {},
			sftp     : {},
			database : {}
		};

		switch(data.send_type) {
			case "database":
				data.database.type            = $("#" + this.p3_db_type).val();
				data.database.server          = $("#" + this.p3_db_server).val();
				data.database.port            = $("#" + this.p3_db_port).val();
				data.database.user            = $("#" + this.p3_db_user).val();
				data.database.pwd             = $("#" + this.p3_db_pwd).val();
				data.database.name            = $("#" + this.p3_db_name).val();
				data.database.error_mail_to   = $("#" + this.p3_db_error_mail_to).val();
				data.database.error_mail_from = $("#" + this.p3_db_error_mail_from).val();
			break;

			case "ftp":
				data.ftp.host                 = $("#" + this.p3_ftp_host).val();
				data.ftp.port                 = $("#" + this.p3_ftp_port).val();
				data.ftp.user                 = $("#" + this.p3_ftp_user).val();
				data.ftp.pwd                  = $("#" + this.p3_ftp_pwd).val();
				data.ftp.filename             = $("#" + this.p3_ftp_filename).val();
				data.ftp.directory            = $("#" + this.p3_ftp_directory).val();
				data.ftp.error_mail_to        = $("#" + this.p3_ftp_error_mail_to).val();
				data.ftp.error_mail_from      = $("#" + this.p3_ftp_error_mail_from).val();
			break;

			case "sftp":
				data.sftp.host                = $("#" + this.p3_sftp_host).val();
				data.sftp.port                = $("#" + this.p3_sftp_port).val();
				data.sftp.user                = $("#" + this.p3_sftp_user).val();
				data.sftp.pwd                 = $("#" + this.p3_sftp_pwd).val();
				data.sftp.filename            = $("#" + this.p3_sftp_filename).val();
				data.sftp.directory           = $("#" + this.p3_sftp_directory).val();
				data.sftp.error_mail_to       = $("#" + this.p3_sftp_error_mail_to).val();
				data.sftp.error_mail_from     = $("#" + this.p3_sftp_error_mail_from).val();
			break;

			case "mail":
				data.mail.to                  = $("#" + this.p3_mail_to ).val();
				data.mail.attach_name         = $("#" + this.p3_mail_attach ).val();
				data.mail.subject             = $("#" + this.p3_mail_subject ).val();
				data.mail.body                = $("#" + this.p3_mail_body ).val();
				data.mail.from                = $("#" + this.p3_mail_from ).val();
			break;

			default:
				throw("rd_form_schedule.prototype.get_data_page3 - Unrecognized send type: " + data.send_type);
		}

		return data;
	};

	rd_form_schedule.prototype.get = function()
	{
		const p1 = this.get_data_page1();
		const p2 = this.get_data_page2();
		const p3 = this.get_data_page3();

		let sch = {
		// page1
			// report
			ReportType          : p1.report_type,
			Report              : p1.report,
			// parametros del reporte y aca tambien viaja el attr "withContent" para exportacion
			Params              : p1.filters,
			// days range
			QueryRange          : p1.range,
			// dias que se mantiene el contenido en el repo (va de la mano con el attr "withContent" de los filtros)
			DaysToKeepContent   : p1.days_to_keep_content,
			// datos adicionales, solo se utilizan en la grilla, del lado del server, son eliminados si es que llegan
			__report_info       : p1.__report_info,
			// state dato adicional
			State               : p1.State,
			// export format
			ExportFormat        : p1.export_format,
			// export content type
			ExportContentType   : p1.export_content_type,

		// page2
			// frequency
			RepeatPolicy        : p2.frequency.repeat_policy,
			RepeatEveryNHours   : str_to_int( p2.frequency.repetition_every_n_hour ),
			RepeatWeekday       : str_to_int( p2.frequency.repeat_weekday ),
			RepeatDay           : str_to_int( p2.frequency.repeat_day ),
			RepeatHour          : p2.frequency.repetition_hour,
			CustomRepeatDays    : str_to_int( p2.frequency.custom_repeat_days ),
			OneTimeDate         : p2.frequency.one_time_date,
			OneTimeHour         : p2.frequency.one_time_hour,
			// common
			StartsOnDate        : p2.common.starts_on_date,
			StartsOnHour        : p2.common.starts_on_hour,

			// validity
			ValidityType        : p2.validity.type,
			EndsOnDate          : p2.validity.ends_on_date,
			EndsOnHour          : p2.validity.ends_on_hour,
			EndsAfter           : p2.validity.ends_after,

		// page3
			SendType            : p3.send_type
		};

		// page3
		switch(sch.SendType) {
			case "database":
				sch.database = {
					Type  : p3.database.type,
					Server: p3.database.server,
					Port  : p3.database.port,
					User  : p3.database.user,
					Pwd   : p3.database.pwd,
					Name  : p3.database.name
				};
				if (p3.database.error_mail_to) {
					sch.MailTo = p3.database.error_mail_to;
				}
				if (p3.database.error_mail_from) {
					sch.EmailFrom = p3.database.error_mail_from;
				}
			break;

			case "ftp":
				sch.ftp = {
					Host     : p3.ftp.host,
					Port     : p3.ftp.port.length > 0 ? p3.ftp.port : undefined, // no es requerido, server side el default es el puerto 21
					User     : p3.ftp.user,
					Pwd      : p3.ftp.pwd,
					FileName : p3.ftp.filename,
					Directory: p3.ftp.directory
				};
				if (p3.ftp.error_mail_to) {
					sch.MailTo = p3.ftp.error_mail_to;
				}
				if (p3.ftp.error_mail_from) {
					sch.EmailFrom = p3.ftp.error_mail_from;
				}
			break;

			case "sftp":
				sch.sftp = {
					Host     : p3.sftp.host,
					Port     : p3.sftp.port.length > 0 ? p3.sftp.port : undefined, // no es requerido, server side el default es el puerto 21
					User     : p3.sftp.user,
					Pwd      : p3.sftp.pwd,
					FileName : p3.sftp.filename,
					Directory: p3.sftp.directory
				};
				if (p3.sftp.error_mail_to) {
					sch.MailTo = p3.sftp.error_mail_to;
				}
				if (p3.sftp.error_mail_from) {
					sch.EmailFrom = p3.sftp.error_mail_from;
				}
			break;

			case "mail":
				sch.MailTo         = p3.mail.to;
				sch.AttachmentName = p3.mail.attach_name;
				sch.EmailSubject   = p3.mail.subject;
				sch.EmailBody      = p3.mail.body;
				sch.EmailFrom      = p3.mail.from;
			break;

			default:
				throw("rd_form_schedule.prototype.get - Unrecognized send type: " + sch.send_type);
		}


		const action = this.dashboard.get_current_action_obj();
		const id = action.view.row_id;
		if ( !this.is_new ) {
			sch[ id ] = this.$current_row.attr( "row_id" );
		}

		return sch;
	};

	rd_form_schedule.prototype.set_filters = function( filters )
	{
		var self = this;
		if ( !filters ) {
			return;
		}
		var $filters = $( "#" + this.p1_rpt_filters ).find( "[filter_field]" );

		$.each( $filters || {}, function( _, filter )
		{
			var $filter = $( filter );
			var filter_type   = $filter.data( "filter_type" );
			var filter_id     = $filter.data( "filter_id" );
			var dom_filter_id = self.make_dom_filter_id( filter_id );
			var $input        = $( "#" + dom_filter_id );
			var filter_value  = null;

			switch ( filter_type )
			{
				case "boolean":
					filter_value = filters[ filter_id ];
					break;

				case "string":
					filter_value = filters[ filter_id ];
					break;

				case "enum": // cbo
					filter_value = filters[ filter_id ];
					break;

				// case "date":
				// LOS DATES NO SE INCLUYEN EN EL FILTRO. SOLO LO DEJO ACA COMO REFERENCIA.
				//	break;

				default:
					throw "Don't know how to represent filter type " + filter_type;
			}

			filter_value = self.current_report.processFilterLabel(filter_id, filter_value || "");
			$input.val( filter_value );
		});
		// en los filtros llega el atributo de exportacion.
		$( "#" + this.p1_rpt_export ).prop( "checked", filters.withContent || false );
	};

	rd_form_schedule.prototype.set_data_page1 = function( sch )
	{
		var self = this;

		$( "#" + this.p1_rpt_type ).val( sch.ReportType ).change();
		this.fill_reports( sch.ReportType, function() {
			$( "#" + self.p1_rpt_id ).val( sch.Report );
			self.fill_report_filters( sch.ReportType, sch.Report, undefined, function() {
				self.set_filters( sch.Params );
				self.toggle_export_section();
			});
		});

		// range --------------------------
		if ( sch.QueryRange ) {
			$( "#" + this.p1_range ).val( sch.QueryRange.type ).trigger( "change" );

			if ( sch.QueryRange.type === "Range" ) {
				this.datepicker_set_date( $( "#" + this.p1_range_exact_from ), sch.QueryRange.from );
				this.datepicker_set_date( $( "#" + this.p1_range_exact_to ), sch.QueryRange.to );
			}
			else if ( sch.QueryRange.type === "DaysBefore" ) {
				$( "#" + this.p1_range_last_n_days ).val( sch.QueryRange.days );
			}
			else if ( sch.QueryRange.type === "HoursBefore" ) {
				$( "#" + this.p1_range_last_n_hours ).val( sch.QueryRange.hours );
			}
		}

		// dias que se mantiene el contenido en el repo, va de la mano con el attr "withContent" de los filtros
		if ( sch.Params && sch.Params.withContent ) {
			$( "#" + this.p1_rpt_export ).trigger( "click" );
			$( "#" + this.p1_rpt_export_days_to_keep_cont ).val( sch.DaysToKeepContent || "1" );
			// export content type
			$( "#" + this.p1_rpt_export_content_type ).val( sch.ExportContentType );
		}

		// export format
		$( "#" + this.p1_rpt_export_format ).val( sch.ExportFormat ).trigger("change");
	};

	rd_form_schedule.prototype.set_data_page2 = function( sch )
	{
		var get_truncated_hour = function( hour ) {
			if ( !hour ) {
				return "";
			}
			if ( hour.length > 0 ) {
				hour = hour.substring( 0, 5 );
			}
			return hour;
		};

		// frequency ----------------------
		var repeat_policy = sch.RepeatPolicy || "onetime"; // si viene undefined es "onetime"

		$( "#" + this.p2_frequency ).val( repeat_policy ).trigger( "change" );
		switch ( repeat_policy )
		{
			case "EveryNHours":
				$( "#" + this.p2_frequency_every_n_hours ).val( sch.RepeatEveryNHours );
				break;
			
			case "Daily":
				$( "#" + this.p2_frequency_daily_hour ).val(
					get_truncated_hour( sch.RepeatHour )
				);
				break;

			case "Weekly":
				$( "#" + this.p2_frequency_weekly_day ).val( sch.RepeatWeekday );
				$( "#" + this.p2_frequency_weekly_hour ).val(
					get_truncated_hour( sch.RepeatHour )
				);
				break;

			case "Monthly":
				$( "#" + this.p2_frequency_monthly_day ).val( sch.RepeatDay );
				$( "#" + this.p2_frequency_monthly_hour ).val(
					get_truncated_hour( sch.RepeatHour )
				);
				break;

			case "CustomRepeat":
				$( "#" + this.p2_frequency_custom_interval ).val( sch.CustomRepeatDays );
				$( "#" + this.p2_frequency_custom_hour ).val(
					get_truncated_hour( sch.RepeatHour )
				);
				break;

			case "onetime":
				this.datepicker_set_date(
					$( "#" + this.p2_frequency_onetime_date ), sch.OneTimeDate );

				$( "#" + this.p2_frequency_onetime_hour ).val(
					get_truncated_hour( sch.OneTimeHour )
				);
				break;
		}

		//common ----------------------
		if ( sch.StartsOnDate ) {
			$( "#" + this.p2_common_require_starts_on_date ).trigger( "click" ).prop( "checked", true );
			this.datepicker_set_date( $( "#" + this.p2_common_starts_on_date ), sch.StartsOnDate );
			$( "#" + this.p2_common_starts_on_hour ).val(
				get_truncated_hour( sch.StartsOnHour )
			);
		}

		//validity ----------------------
		var validity = ( sch.ValidityType === "none" || !sch.ValidityType ) ? "" : sch.ValidityType ;
		$( "#" + this.p2_validity ).val( validity ).trigger( "change" );

		if ( validity.length > 0 ) {
			if ( validity === "limited" ) {
				this.remaining_message( sch );
			} else if( validity === "until" ) {
				this.datepicker_set_date( $( "#" + this.p2_validity_until_date ), sch.EndsOnDate );
				$( "#" + this.p2_validity_until_hour ).val(
					get_truncated_hour( sch.EndsOnHour )
				);
			}
		}
	};

	rd_form_schedule.prototype.remaining_message = function( sch )
	{
		if ( !sch ) {
			return;
		}
		var executed = parseInt( sch.ExecutionCount || 0 );
		var total = parseInt( sch.EndsAfter || executed, 10 );

		var remaining = total - executed;
		if ( remaining < 0 ) {
			remaining = 0;
		}
		var previous_data = {
			total    : total,
			executed : executed
		};
		$( "#" + this.p2_validity_limit_rep ).val( remaining ).data( "previous_data", previous_data );
		var $message = $( "#" + this.p2_validity_limit_rep_message );
		$message.text( FORMAT( "Remaining of {0}.", total ) ).show();
	};

	rd_form_schedule.prototype.set_data_page3 = function( sch )
	{
		var send_type = sch.SendType || "mail";

		$("#" + this.p3_send_type).val(send_type).trigger("change");

		if (send_type === "mail") {
			$("#" + this.p3_mail_to).val(sch.MailTo);
			$("#" + this.p3_mail_attach).val(sch.AttachmentName);
			$("#" + this.p3_mail_subject).val(sch.EmailSubject);
			$("#" + this.p3_mail_body).val(sch.EmailBody);
			$("#" + this.p3_mail_from).val(sch.EmailFrom);
		}
		else if (send_type === "ftp") {
			$("#" + this.p3_ftp_host).val(sch.ftp.Host);
			$("#" + this.p3_ftp_port).val(sch.ftp.Port);
			$("#" + this.p3_ftp_user).val(sch.ftp.User);
			$("#" + this.p3_ftp_pwd).val(sch.ftp.Pwd);
			$("#" + this.p3_ftp_filename).val(sch.ftp.FileName);
			$("#" + this.p3_ftp_directory).val(sch.ftp.Directory);
			$("#" + this.p3_ftp_error_mail_to).val(sch.MailTo);
			$("#" + this.p3_ftp_error_mail_from).val(sch.EmailFrom);
		}
		else if (send_type === "sftp") {
			$("#" + this.p3_sftp_host).val(sch.sftp.Host);
			$("#" + this.p3_sftp_port).val(sch.sftp.Port);
			$("#" + this.p3_sftp_user).val(sch.sftp.User);
			$("#" + this.p3_sftp_pwd).val(sch.sftp.Pwd);
			$("#" + this.p3_sftp_filename).val(sch.sftp.FileName);
			$("#" + this.p3_sftp_directory).val(sch.sftp.Directory);
			$("#" + this.p3_sftp_error_mail_to).val(sch.MailTo);
			$("#" + this.p3_sftp_error_mail_from).val(sch.EmailFrom);
		}
		else if (send_type === "database") {
			$("#" + this.p3_db_type).val(sch.database.Type);
			$("#" + this.p3_db_server).val(sch.database.Server);
			$("#" + this.p3_db_port).val(sch.database.Port);
			$("#" + this.p3_db_user).val(sch.database.User);
			$("#" + this.p3_db_pwd).val(sch.database.Pwd);
			$("#" + this.p3_db_name).val(sch.database.Name);
			$("#" + this.p3_db_error_mail_to).val(sch.MailTo);
			$("#" + this.p3_db_error_mail_from).val(sch.EmailFrom);
		}
		else {
			throw("rd_form_schedule.prototype.set_data_page3. Unrecognized send type " + send_type);
		}
	};

	rd_form_schedule.prototype.set = function( success, sch )
	{
		if ( !success ) {
			return;
		}
// TODO: #4636 y #5357 - Esto no debe de estar aca!!. ( ARRREGLAME POR FAVOR )
//   Este set events, NO se tiene que invocar aca; a esto lo realiza de forma automatica
//   la clase base "conf_form", pero si ahora no lo realizo asi, tengo un problema en el formulario de campanas.
//   Entonces, hasta que esto se encuentre en el ultimo build de mcwarren queda aca, y lo arreglo ahi,
//   en el ultimo build de mcwarren.
//   Como esta se esta tocando en el buil 1962, el ultimo congelado a la fecha, prefiero tocar puntal y que esto funcione, para lo que se necesita, y luego que este en mcwarren, revisar y arreglar correctamente.
//   Revisar en "conf_form.prototype.ready", donde se realiza el set(..) del frm.
		this.set_events();

		this.set_data_page1( sch );
		this.set_data_page2( sch );
		this.set_data_page3( sch );
		this.show_state_message( sch );
	};

	rd_form_schedule.prototype.get_page1_validation_filters_def = function()
	{
		const self = this;
		let definitions = [];

		// si los filtros no son requeridos no realizo validaciones (ej: en los live detail)
		const filters_are_not_required = this.__filters_are_not_required();
		if (filters_are_not_required) {
			return definitions;
		}

		var on_error = function() {
			self.wizard.jump_to_page( 1 );
		};

		const $filters = $( "#" + this.p1_rpt_filters ).find( "[filter_field]" );

		$.each( $filters, function( _, filter )
		{
			var $filter = $( filter );
			var is_required   = $filter.data( "required" );
			if ( !is_required ) {
				return true; // continue
			}

			var filter_id     = $filter.data( "filter_id" );
			var filter_type   = $filter.data( "filter_type" );
			var required_message;
			switch ( filter_type )
			{
				case "boolean":
					return true; // continue

				case "date":
					return true; // continue

				case "string":
					required_message = FORMAT( "<%=_T('Please enter the Filter {0} value.')%>", filter_id );
					break;

				case "enum": // cbo
					required_message = FORMAT( "<%=_T('Please select the Filter {0} value.')%>", filter_id );
					break;
			}

			var dom_filter_id = self.make_dom_filter_id( filter_id );

			definitions.push({
				control_id: dom_filter_id,
				messages: {
					required: required_message || "<%=_T('Please enter the Filter value.')%>"
				},
				on_error: on_error
			});
		});

		return definitions;
	};

	rd_form_schedule.prototype.get_page1_validation_range_def = function()
	{
		const self = this;

		var on_error = function() {
			self.wizard.jump_to_page( 1 );
		};

		var can_validate = function( ctrl_id, key ) {
			const has_range_section = self.__has_range_section();
			if (!has_range_section) {
				// si el scheduler no tiene ningun rango disponible (ej: realtime, agentes conectados)
				return false;
			}
			const range_are_not_required = self.__range_are_not_required();
			if (range_are_not_required) {
				// si el rango no es requerido no realizo validaciones (ej: en los live detail)
				return false;
			}
			// ahora valido el valor seleccionado el combo rango
			const $ctrl = $( "#" + ctrl_id );
			let value = $ctrl.val();
			if (value === key) {
				return true;
			}
			return false;
		};

		const $range_last_n_days  = $( "#" + this.p1_range_last_n_days );
		const $range_last_n_hours = $( "#" + this.p1_range_last_n_hours );

		let definitions = [
		// range -------------
			{
				control_id: this.p1_range,
				messages: {
					required: "<%=_T('Please select the Days Range.')%>"
				},
				can_validate: function() {
					return can_validate(self.p1_range, "");
				},
				on_error: on_error
			},
			//--- range Exact Interval
			{
				control_id: this.p1_range_exact_from,
				messages: {
					required: "<%=_T('Please enter the Days Range, Exact Interval, Date From.')%>"
				},
				can_validate: function() {
					return can_validate( self.p1_range, "Range" );
				},
				on_error: on_error
			},
			{
				control_id: this.p1_range_exact_to,
				messages: {
					required: "<%=_T('Please enter the Days Range, Exact Interval, Date To.')%>",
					custom: {
						type:  "custom",
						valid: function()
						{
							var response = {
								success: true
							};
							if ( !self.can_export() ) {
								return response;
							}
							if ( !$( "#" + self.p1_rpt_export ).prop( "checked" ) ) {
								return response;
							}

							var from = $( "#" + self.p1_range_exact_from ).datepicker( "getDate" );
							var to = $( "#" + self.p1_range_exact_to ).datepicker( "getDate" );
							var diff_days = get_difference_days( to, from );

							if ( diff_days > 7 ) {
								response.success = false;
								response.message = "<%=_T('Please enter Days Range, Exact Interval, between 1 and 7 days.')%>";
							}

							return response;
						}
					}
				},
				can_validate: function() {
					return can_validate( self.p1_range, "Range" );
				},
				on_error: on_error
			},
			//--- range Last n Days
			{
				control_id: this.p1_range_last_n_days,
				messages: {
					required: "<%=_T('Please enter the Days Range, Last n Days.')%>",
					range: {
						between: function() {
							var between = {
								from : $range_last_n_days.attr( "spinner-min-value" ),
								to   : $range_last_n_days.attr( "spinner-max-value" )
							};
							if ( self.can_export() ) {
								if ( $( "#" + self.p1_rpt_export ).prop( "checked" ) ) {
									between.from = 1;
									between.to = 7;
								}
							}
							return between;
						},
						message: "<%=_T('Please enter the Days Range, Last n Days, between {0} to {1}.')%>"
					}
				},
				can_validate: function() {
					return can_validate( self.p1_range, "DaysBefore" );
				},
				on_error: on_error
			},
			//--- range Last n Hours
			{
				control_id: this.p1_range_last_n_hours,
				messages: {
					required: "<%=_T('Please enter the Hours Range, Last n Hours.')%>",
					range: {
						between: function() {
							var between = {
								from : $range_last_n_hours.attr( "spinner-min-value" ),
								to   : $range_last_n_hours.attr( "spinner-max-value" )
							};
							if ( self.can_export() ) {
								if ( $( "#" + self.p1_rpt_export ).prop( "checked" ) ) {
									between.from = 1;
									between.to = 7;
								}
							}
							return between;
						},
						message: "<%=_T('Please enter the Hours Range, Last n Hours, between {0} to {1}.')%>"
					}
				},
				can_validate: function() {
					return can_validate( self.p1_range, "HoursBefore" );
				},
				on_error: on_error
			}
		];

		return definitions;
	};

	rd_form_schedule.prototype.get_page1_validation_def = function()
	{
		var self = this;

		var on_error = function() {
			self.wizard.jump_to_page( 1 );
		};

		var definitions = [
			{
				control_id: this.p1_rpt_type,
				messages: {
					required: "<%=_T('Please select the Report Type.')%>"
				},
				on_error: on_error
			},
			{
				control_id: this.p1_rpt_id,
				messages: {
					required: "<%=_T('Please select the Report.')%>"
				},
				on_error: on_error
			}
		];

		// filter validation
		var filters_definitions = this.get_page1_validation_filters_def();
		definitions = definitions.concat( filters_definitions );

		// range validation
		var range_definitions = this.get_page1_validation_range_def();
		definitions = definitions.concat( range_definitions );

		// export format validation
		var export_format_definitions = [
			{
				control_id: this.p1_rpt_export_format,
				messages: {
					required: "<%=_T('Please select the Export Format.')%>"
				},
				on_error: on_error
			}
		];
		definitions = definitions.concat( export_format_definitions );

		var $days_to_keep_cont = $( "#" + this.p1_rpt_export_days_to_keep_cont );
		//--- export validation ( dias que se mantiene el contenido en el repo ) 
		var export_definitions =  [
			{
				control_id: this.p1_rpt_export_content_type,
				messages: {
					required: "<%=_T('Please select a type of content for export.')%>"
				},
				can_validate: function() {
					if ( !self.can_export() ) {
						return false;
					}
					return $( "#" + self.p1_rpt_export ).prop( "checked" );
				},
				on_error: on_error
			},
			{
				control_id: this.p1_rpt_export_days_to_keep_cont,
				messages: {
					required: "<%=_T('Please enter the Days To Keep Content.')%>",
					range: {
						between: {
							from : $days_to_keep_cont.attr( "spinner-min-value" ),
							to   : $days_to_keep_cont.attr( "spinner-max-value" )
						},
						message: "<%=_T('Please enter the Days To Keep Content, between {0} to {1}.')%>"
					}
				},
				can_validate: function() {
					if ( !self.can_export() ) {
						return false;
					}
					return $( "#" + self.p1_rpt_export ).prop( "checked" );
				},
				on_error: on_error
			}
		];

		definitions = definitions.concat( export_definitions );

		return definitions;
	};

	rd_form_schedule.prototype.get_page2_validation_def = function()
	{
		var self = this;

		var on_error = function() {
			self.wizard.jump_to_page( 2 );
		};

		var can_validate = function( ctrl_id, key ) {
			var $ctrl = $( "#" + ctrl_id );
			if ( $ctrl.val() === key ) {
				return true;
			}
			return false;
		};

		var hour_valid = function( hour_ctrl_id, date_ctrl_id, message, comparation_type )
		{
			var $hour = $( "#" + hour_ctrl_id );
			var hour = $hour.val();
			var response = inConcert.Utils.validate( hour, "hour" );
			if ( !response.success ) {
				if ( response.message === "HOUR_ERROR" ) {
					response.message = FORMAT( "<%=_T('Please enter {0} hour between 0 and 23.')%>", message || "" );
				}
				else if ( response.message === "MINUTES_ERROR" ) {
					response.message = FORMAT( "<%=_T('Please enter {0} minutes between 0 and 59.')%>", message || "" );
				}
				return response;
			}

			if ( date_ctrl_id ) {
				var date_time_string = $( "#" + date_ctrl_id ).val() + " " + hour;
				var date_time = new Date( date_time_string );

				var now_date = new Date();
				now_date = inConcert.Utils.convertLocalDateToTimezoneDate( now_date, self.user_timezone );

				// este parametro indica que tipo de comparacion debe realizar contra la fecha actual.
				comparation_type = comparation_type || "major";

				if ( comparation_type === "major" ) {
					if ( date_time <= now_date  ) {
						response.success = false;
						response.message = FORMAT( "<%=_T('Please enter {0} higher than to the your timezone configuration.')%>", message || "" );
					}
				}
				else {
					if ( date_time >= now_date  ) {
						response.success = false;
						response.message = FORMAT( "<%=_T('Please enter {0} minor that to the your timezone configuration.')%>", message || "" );
					}
				}
			}

			return response;
		};

		var set_hour = function( date_object, string_hour ) {
			var match_hour = string_hour.match( /(\d\d):(\d\d)/ );
			var hour = 0, min = 0;
			if ( match_hour !== null ) {
				hour = parseInt( match_hour[ 1 ], 10 );
				min  = parseInt( match_hour[ 2 ], 10 );
			}
			date_object.setHours( hour, min, 0, 0 );
		};

		var $frequency_monthly_day = $( "#" + this.p2_frequency_monthly_day );
		var $frequency_custom_interval = $( "#" + this.p2_frequency_custom_interval );
		var $validity_limit_rep = $( "#" + this.p2_validity_limit_rep );
		var $validity_until_date = $( "#" + this.p2_validity_until_date );
		var $validity_until_hour = $( "#" + this.p2_validity_until_hour );

		var $chk_starts_on_date = $( "#" + this.p2_common_require_starts_on_date );
		var $starts_on_date = $( "#" + this.p2_common_starts_on_date );
		var $starts_on_hour = $( "#" + this.p2_common_starts_on_hour );

		// retorna las fechas. la hora la deja en 00:00:00
		// sirve para saber si los dias han cambiado
		var convertNowDateToTimezoneNowDate = function() {
			// el now de la configuracion regional de sistema operativo
			var now_date = new Date();
			// le setea horas en 00:00
			now_date.setHours( 0,0,0,0 );
			// calcula la diferencia segun el timezone del usuario
			now_date = inConcert.Utils.convertLocalDateToTimezoneDate( now_date, self.user_timezone );
			// vuelve a setear en 00:00 la hora, ya que no me interesa para la futura comparacion
			now_date.setHours( 0,0,0,0 );
			return now_date;
		};

		var validate_execution_day = function( hour_exec )
		{
			// valido si se puede ejecutar hoy.
			var today_exec = convertNowDateToTimezoneNowDate();
			set_hour( today_exec , hour_exec );
			today_exec = inConcert.Utils.convertLocalDateToTimezoneDate( today_exec, self.user_timezone );

			var now = inConcert.Utils.convertLocalDateToTimezoneDate( new Date(), self.user_timezone );

			var has_start_on_date = $chk_starts_on_date.prop( "checked" );
			if ( !has_start_on_date ) {
				if ( now < today_exec ) {
					// si se puede ejecutar hoy
					return true;
				}
			}
			else {
				// la fecha y hr start date es la que me ha seleccionado
				var starts_on_date = $starts_on_date.datepicker( "getDate" );
				set_hour( starts_on_date, $starts_on_hour.val() );

				if ( now < today_exec && starts_on_date <= today_exec ) {
					// si se puede ejecutar hoy
					return true;
				}
			}

			// valido si se puede ejecutar manana
			var tomorrow_exec = convertNowDateToTimezoneNowDate();
			set_hour( tomorrow_exec , hour_exec );
			tomorrow_exec = inConcert.Utils.convertLocalDateToTimezoneDate( tomorrow_exec, self.user_timezone );
			tomorrow_exec.setDate( tomorrow_exec.getDate() + 1 ); // incrementa uno para llegar a manana

			var until_date = $validity_until_date.datepicker( "getDate" );
			until_date.setHours( 0,0,0,0 );
			set_hour( until_date, $validity_until_hour.val() );
			until_date = inConcert.Utils.convertLocalDateToTimezoneDate( until_date, self.user_timezone );

			if ( tomorrow_exec <= until_date ) {
				// si se puede ejecutar manana
				return true;
			}

			// no es posible ejecutar ni hoy ni manana
			return false;
		};

		var definitions = [

		// frequency -------------
			{
				control_id: this.p2_frequency,
				messages: {
					required: "<%=_T('Please select the Frequency.')%>"
				},
				on_error: on_error
			},
			//--- frequency Daily
			{
				control_id: this.p2_frequency_daily_hour,
				messages: {
					required: "<%=_T('Please enter the Frequency Daily Hour.')%>",
					custom: {
						type:  "custom",
						valid: function()
						{
							var response = {
								success: true
							};

							response = hour_valid( self.p2_frequency_daily_hour, undefined, "Frequency Daily" );
							if ( !response.success ) {
								return response;
							}

							if ( !can_validate( self.p2_validity, "until" ) ) {
								return response;
							}

							var has_start_on_date = $chk_starts_on_date.prop( "checked" );
							var starts_on_date;
							if ( has_start_on_date ) {
							// la fecha y hr start date es la que me ha seleccionado
								starts_on_date = $starts_on_date.datepicker( "getDate" );
								set_hour( starts_on_date, $starts_on_hour.val() );
							}
							else {
							// la fecha y hr start date es la fecha actual segun el timezone del usuario
								starts_on_date = convertNowDateToTimezoneNowDate();
							}

							var until_date = $validity_until_date.datepicker( "getDate" );
							until_date.setHours( 0,0,0,0 );

							var diff_days = get_difference_days( until_date, starts_on_date );

							if ( diff_days <= 1 ) {

								var hour_exec = $( "#" + self.p2_frequency_daily_hour ).val();
								var success = validate_execution_day( hour_exec );
								if ( success ) {
									// si se puede ejecutar manana
									return response;
								}

								response.success = false;
								response.message = "<%=_T('Please enter Frequency Daily hour between Now Date Hour and End Date Hour.')%>";
							}

							return response;
						}
					}
				},
				can_validate: function() {
					return can_validate( self.p2_frequency, "Daily" );
				},
				on_error: on_error
			},
			//--- frequency Weekly
			{
				control_id: this.p2_frequency_weekly_day,
				messages: {
					required: "<%=_T('Please select the Frequency Weekly Day.')%>",
					custom: {
						type:  "custom",
						valid: function()
						{
							var response = {
								success: true
							};

							if ( !can_validate( self.p2_validity, "until" ) ) {
								return response;
							}

							var until_date = $validity_until_date.datepicker( "getDate" );
							until_date.setHours( 0,0,0,0 );

							var now_date = convertNowDateToTimezoneNowDate();

							var diff_days = get_difference_days( until_date, now_date );

							if ( diff_days < 7 ) {
								var weekly_day = parseInt( $( "#" + self.p2_frequency_weekly_day ).val(), 10 );
								var now_day = now_date.getDay() + 1;
								var until_day = until_date.getDay() + 1;

								if (
										( weekly_day === now_day ) ||
										( weekly_day === until_day ) ||

										( now_day <= until_day &&
											( weekly_day > now_day && weekly_day < until_day )
										) ||
										( now_day > until_day &&
											( weekly_day > now_day || weekly_day < until_day )
										)
									)
								{
									return response; // ok
								}
								else {
									response.success = false;
									response.message = "<%=_T('Please select Frequency Weekly Day between Now Date Day and End Date Day.')%>";
									return response;
								}
							}

							return response;
						}
					}
				},
				can_validate: function() {
					return can_validate( self.p2_frequency, "Weekly" );
				},
				on_error: on_error
			},
			{
				control_id: this.p2_frequency_weekly_hour,
				messages: {
					required: "<%=_T('Please enter the Frequency Weekly Hour.')%>",
					custom: {
						type:  "custom",
						valid: function()
						{
							var response = {
								success: true
							};

							response = hour_valid( self.p2_frequency_weekly_hour, undefined, "Frequency Weekly" );
							if ( !response.success ) {
								return response;
							}

							if ( !can_validate( self.p2_validity, "until" ) ) {
								return response;
							}

							var until_date = $validity_until_date.datepicker( "getDate" );
							until_date.setHours( 0,0,0,0 );

							var now_date = convertNowDateToTimezoneNowDate();

							var diff_days = get_difference_days( until_date, now_date );

							// si ha seleccionado una semana o menos
							if ( diff_days < 7 ) {

								var weekly_day = parseInt( $( "#" + self.p2_frequency_weekly_day ).val(), 10 );
								var until_day = until_date.getDay() + 1;

								var execute_date;
								if ( weekly_day === until_day ) {
								//aca valido contra la fecha de fin
									execute_date = new Date( until_date );
									set_hour( execute_date , $( "#" + self.p2_frequency_weekly_hour ).val() );
									set_hour( until_date   , $validity_until_hour.val() );

									if ( until_date <= execute_date ) {
										response.success = false;
										response.message = "<%=_T('Please enter Frequency Weekly hour minor than End Date Hour.')%>";
										return response;
									}
								}
								else {
								// valido contra la fecha de start
									var has_start_on_date = $chk_starts_on_date.prop( "checked" );
									var starts_on_date;
									if ( has_start_on_date ) {
									// la fecha y hr start date es la que me ha seleccionado
										starts_on_date = $starts_on_date.datepicker( "getDate" );
										set_hour( starts_on_date, $starts_on_hour.val() );
									}
									else {
									// la fecha y hr start date es la fecha actual segun el timezone del usuario
										starts_on_date = inConcert.Utils.convertLocalDateToTimezoneDate( new Date(), self.user_timezone );
									}

									var from_day = starts_on_date.getDay() + 1;
									if ( weekly_day === from_day ) {
										execute_date = new Date( starts_on_date );
										set_hour( execute_date   , $( "#" + self.p2_frequency_weekly_hour ).val() );

										if ( starts_on_date >= execute_date ) {
											response.success = false;
											response.message = "<%=_T('Please enter Frequency Weekly hour higher than Now Date Hour')%>";
											return response;
										}
									}
								}
							}

							return response;
						}
					}
				},
				can_validate: function() {
					return can_validate( self.p2_frequency, "Weekly" );
				},
				on_error: on_error
			},
			//--- frequency Monthly
			{
				control_id: this.p2_frequency_monthly_day,
				messages: {
					required: "<%=_T('Please select the Frequency Monthly Day Number.')%>",
					range: {
						between: {
							from : $frequency_monthly_day.attr( "spinner-min-value" ),
							to   : $frequency_monthly_day.attr( "spinner-max-value" )
						},
						message: "<%=_T('Please enter the Frequency Monthly Day Number, between {0} to {1}.')%>"
					},
					custom: {
						type:  "custom",
						valid: function()
						{
							var response = {
								success: true
							};

							if ( !can_validate( self.p2_validity, "until" ) ) {
								return response;
							}

							var until_date = $validity_until_date.datepicker( "getDate" );
							until_date.setHours( 0,0,0,0 );

							var now_date = convertNowDateToTimezoneNowDate();

							var diff_days = get_difference_days( until_date, now_date );

							if ( diff_days <= 31 ) {
								var monthly_day = parseInt( $( "#" + self.p2_frequency_monthly_day ).val(), 10 );
								var now_day = now_date.getDate();
								var until_day = until_date.getDate();

								if (
										( monthly_day === now_day ) ||
										( monthly_day === until_day ) ||

										( now_day <= until_day &&
											( monthly_day > now_day && monthly_day < until_day )
										) ||
										( now_day > until_day &&
											( monthly_day > now_day || monthly_day < until_day )
										)
									)
								{
									return response; // ok
								}
								else {
									var from_day = inConcert.Utils.getStringFromDate( now_date   , false , "day" );
									var to_day   = inConcert.Utils.getStringFromDate( until_date , false , "day" );
									response.success = false;
									response.message = FORMAT( "<%=_T('Please enter the Frequency Monthly Day Number, between {0} to {1}.')%>", from_day, to_day );
									return response;
								}
							}

							return response;
						}
					}
				},
				can_validate: function() {
					return can_validate( self.p2_frequency, "Monthly" );
				},
				on_error: on_error
			},
			{
				control_id: this.p2_frequency_monthly_hour,
				messages: {
					required: "<%=_T('Please enter the Frequency Monthly Hour.')%>",
					custom: {
						type:  "custom",
						valid: function()
						{
							var response = {
								success: true
							};

							response = hour_valid( self.p2_frequency_monthly_hour, undefined, "Frequency Monthly" );
							if ( !response.success ) {
								return response;
							}

							if ( !can_validate( self.p2_validity, "until" ) ) {
								return response;
							}

							var until_date = $validity_until_date.datepicker( "getDate" );
							until_date.setHours( 0,0,0,0 );

							var now_date = convertNowDateToTimezoneNowDate();

							var diff_days = get_difference_days( until_date, now_date );

							if ( diff_days <= 31 ) {
								var monthly_day = parseInt( $( "#" + self.p2_frequency_monthly_day ).val(), 10 );

								var execute_date;
								if ( diff_days < 31 ) {
									var now_day = now_date.getDate();
									if ( monthly_day === now_day ) {
										execute_date = new Date( now_date );
										set_hour( execute_date , $( "#" + self.p2_frequency_monthly_hour ).val() );
									// valido contra la fecha de start
										var has_start_on_date = $chk_starts_on_date.prop( "checked" );
										if ( has_start_on_date ) {
										// la fecha y hr start date es la que me ha seleccionado
											now_date = $starts_on_date.datepicker( "getDate" );
											set_hour( now_date, $starts_on_hour.val() );
										}
										else {
										// la fecha y hr start date es la fecha actual segun el timezone del usuario
											now_date = inConcert.Utils.convertLocalDateToTimezoneDate( new Date(), self.user_timezone );
										}

										if ( execute_date < now_date ) {
											response.success = false;
											response.message = "<%=_T('Please enter Frequency Monthly hour higher than Now Date Hour.')%>";
											return response;
										}
									}
								}

								var until_day = until_date.getDate();

								if ( monthly_day === until_day ) {
									execute_date = new Date( until_date );
									set_hour( execute_date , $( "#" + self.p2_frequency_monthly_hour ).val() );
									set_hour( until_date   , $validity_until_hour.val() );

									if ( until_date <= execute_date ) {
										response.success = false;
										response.message = "<%=_T('Please enter Frequency Monthly hour minor than End Date Hour.')%>";
										return response;
									}
								}
							}

							return response;
						}
					}
				},
				can_validate: function() {
					return can_validate( self.p2_frequency, "Monthly" );
				},
				on_error: on_error
			},
			//--- frequency Custom
			{
				control_id: this.p2_frequency_custom_interval,
				messages: {
					required: "<%=_T('Please enter the Frequency Custom Interval.')%>",
					range: {
						between: {
							from : $frequency_custom_interval.attr( "spinner-min-value" ),
							to   : $frequency_custom_interval.attr( "spinner-max-value" )
						},
						message: "<%=_T('Please enter the Frequency Custom Interval, between {0} to {1}.')%>"
					}
				},
				can_validate: function() {
					return can_validate( self.p2_frequency, "CustomRepeat" );
				},
				on_error: on_error
			},
			{
				control_id: this.p2_frequency_custom_hour,
				messages: {
					required: "<%=_T('Please enter the Frequency Custom Hour.')%>",
					custom: {
						type:  "custom",
						valid: function() {

							var response = {
								success: true
							};

							response = hour_valid( self.p2_frequency_custom_hour, undefined, "Frequency Custom" );
							if ( !response.success ) {
								return response;
							}

							if ( !can_validate( self.p2_validity, "until" ) ) {
								return response;
							}

							var has_start_on_date = $chk_starts_on_date.prop( "checked" );
							var starts_on_date;
							if ( has_start_on_date ) {
							// la fecha y hr start date es la que me ha seleccionado
								starts_on_date = $starts_on_date.datepicker( "getDate" );
								set_hour( starts_on_date, $starts_on_hour.val() );
							}
							else {
							// la fecha y hr start date es la fecha actual segun el timezone del usuario
								starts_on_date = convertNowDateToTimezoneNowDate();
							}

							var until_date = $validity_until_date.datepicker( "getDate" );
							until_date.setHours( 0,0,0,0 );

							var diff_days = get_difference_days( until_date, starts_on_date );

							if ( diff_days <= 1 ) {

								var hour_exec = $( "#" + self.p2_frequency_custom_hour ).val();
								var success = validate_execution_day( hour_exec );
								if ( success ) {
									// si se puede ejecutar manana
									return response;
								}

								response.success = false;
								response.message = "<%=_T('Please enter Frequency Custom hour between Now Date Hour and End Date Hour.')%>";
							}

							return response;
						}
					}
				},
				can_validate: function() {
					return can_validate( self.p2_frequency, "CustomRepeat" );
				},
				on_error: on_error
			},
			//--- frequency OneTime
			{
				control_id: this.p2_frequency_onetime_date,
				messages: {
					required: "<%=_T('Please select the Frequency One Time Date.')%>",
					custom: {
						type:  "custom",
						valid: function()
						{
							var response = {
								success: true
							};

							if (self.__has_range_section()) {
								var range_exact_to_date = $( "#" + self.p1_range_exact_to ).datepicker( "getDate" );
								range_exact_to_date.setHours( 0,0,0,0 );

								var onetime_date = $( "#" + self.p2_frequency_onetime_date ).datepicker( "getDate" );
								onetime_date.setHours( 0,0,0,0 );

								if ( onetime_date <= range_exact_to_date ) {
									response.success = false;
									response.message = "<%=_T('Please select Frequency One Time Date higher to the to date Days Range .')%>";
									return response;
								}

								var now_date = new Date();
								now_date.setHours( 0,0,0,0 );

								if ( onetime_date < now_date  ) {
									response.success = false;
									response.message = "<%=_T('Please select Frequency One Time Date higher than or equal to the current date.')%>";
								}
							}

							return response;
						}
					}
				},
				can_validate: function() {
					return can_validate( self.p2_frequency, "onetime" );
				},
				on_error: on_error
			},
			{
				control_id: this.p2_frequency_onetime_hour,
				messages: {
					required: "<%=_T('Please enter the Frequency One Time Hour.')%>",
					custom: {
						type:  "custom",
						valid: function() {
							return hour_valid( self.p2_frequency_onetime_hour, self.p2_frequency_onetime_date, "Frequency One Time Hour", "major" );
						}
					}
				},
				can_validate: function() {
					return can_validate( self.p2_frequency, "onetime" );
				},
				on_error: on_error
			},

		// common starts on date -------------
			{
				control_id: this.p2_common_starts_on_date,
				messages: {
					required: "<%=_T('Please select the Start Date.')%>",
					custom: {
						type:  "custom",
						valid: function()
						{
							var response = {
								success: true
							};

							var custom_start_date = $starts_on_date.datepicker( "getDate" );
							custom_start_date.setHours( 0,0,0,0 );

							var now_date = convertNowDateToTimezoneNowDate();

							if ( custom_start_date < now_date  ) {
								response.success = false;
								response.message = "<%=_T('Please select Start Date higher or equal to the current date, by your timezone configuration.')%>";
							}

							return response;
						}
					}
				},
				can_validate: function() {
					return $chk_starts_on_date.prop( "checked" );
				},
				on_error: on_error
			},
			//--- common starts on hour
			{
				control_id: this.p2_common_starts_on_hour,
				messages: {
					required: "<%=_T('Please select the Start Hour.')%>",
					custom: {
						type:  "custom",
						valid: function() { return hour_valid( self.p2_common_starts_on_hour, self.p2_common_starts_on_date, "Start Hour", "major" ); }
					}
				},
				can_validate: function() {
					return $chk_starts_on_date.prop( "checked" );
				},
				on_error: on_error
			},

		// validity -------------
			{
				control_id: this.p2_validity,
				messages: {
					required: "<%=_T('Please select the Validity.')%>"
				},
				can_validate: function() {
					var not_configurable = can_validate( self.p2_frequency, "onetime" );
					if ( not_configurable ) {
						return false;
					}
					return true;
				},
				on_error: on_error
			},
			//--- validity Limited repetitions
			{
				control_id: this.p2_validity_limit_rep,
				messages: {
					required: "<%=_T('Please select the Validity Repetitions.')%>",
					range: {
						between: {
							from : $validity_limit_rep.attr( "spinner-min-value" ),
							to   : $validity_limit_rep.attr( "spinner-max-value" )
						},
						message: "<%=_T('Please enter the Validity Repetitions, between {0} to {1}.')%>"
					}
				},
				can_validate: function() {
					var not_configurable = can_validate( self.p2_frequency, "onetime" );
					if ( not_configurable ) {
						return false;
					}
					return can_validate( self.p2_validity, "limited" );
				},
				on_error: on_error
			},
			//--- validity Until date
			{
				control_id: this.p2_validity_until_date,
				messages: {
					required: "<%=_T('Please select the Validity Until Date.')%>",
					custom: {
						type:  "custom",
						valid: function()
						{
							var response = {
								success: true
							};

							var until_date = $validity_until_date.datepicker( "getDate" );
							until_date.setHours( 0,0,0,0 );

							var now_date = convertNowDateToTimezoneNowDate();

							if ( until_date <= now_date ) {
								response.success = false;
								response.message = "<%=_T('Please select Validity Until Date higher than current date, by your timezone configuration.')%>";
							}

							if ( $chk_starts_on_date.prop( "checked" ) ) {
								var starts_on_date = $starts_on_date.datepicker( "getDate" );
								set_hour( starts_on_date , $starts_on_hour.val()      );
								set_hour( until_date     , $validity_until_hour.val() );

								if ( until_date <= starts_on_date  ) {
									response.success = false;
									response.message = "<%=_T('Please select Validity Until Date higher than Start Date.')%>";
								}
							}

							return response;
						}
					}
				},
				can_validate: function() {
					var not_configurable = can_validate( self.p2_frequency, "onetime" );
					if ( not_configurable ) {
						return false;
					}
					return can_validate( self.p2_validity, "until" );
				},
				on_error: on_error
			},
			//--- validity Until hour
			{
				control_id: this.p2_validity_until_hour,
				messages: {
					required: "<%=_T('Please select the Validity Until Hour.')%>",
					custom: {
						type:  "custom",
						valid: function() { return hour_valid( self.p2_validity_until_hour, self.p2_validity_until_date, "Validity Until Hour", "major" ); }
					}
				},
				can_validate: function() {
					var not_configurable = can_validate( self.p2_frequency, "onetime" );
					if ( not_configurable ) {
						return false;
					}
					return can_validate( self.p2_validity, "until" );
				},
				on_error: on_error
			}
		];

		return definitions;
	};

	rd_form_schedule.prototype.get_page3_validation_def = function()
	{
		const self = this;

		var on_error = function() {
			self.wizard.jump_to_page( 3 );
		};

		var can_validate = function(send_type) {
			const current_send_type = $("#" + self.p3_send_type).val();
			return send_type === current_send_type;
		};

		var mail_validation = function(addresses) {
			let response = {
				success: true
			};

			var truncate = function( word, max_length )
			{
				if ( typeof word !== "string" || word.length === 0 ) {
					return "";
				}
				max_length = max_length || 50;
				if ( word.length > max_length ) {
					word = word.substring( 0, max_length ) + " ...";
				}
				return word;
			};

			var mail_list = {
				to: {
					addresses : addresses,
					get_error : function( result )
					{
						let message_error;
						let address = truncate( result.address );
						switch( result.error_type )
						{
							case "invalid_mail":
								message_error = FORMAT( "<%=_T('TO e-mail account must be a valid e-mail address: {0}.')%>", address );
								break;

							case "invalid_mail_list":
								message_error = FORMAT("<%=_T('TO e-mail account list must be a valid: {0}. Must use the separator ;. Example: Contact Name <sample@sample.com>; ... OR sample@sample.com; ...')%>", address );

								break;
							default:
								throw "Invalid validation mail message type";
						}
						return message_error;
					}
				}
			};

			var validationError = function( result ) {
				response.success = false;
				const email_type = mail_list[ result.type ];
				response.message = email_type.get_error( result );
			};

			inConcert.Utils.validateEmails( mail_list, validationError );

			return response;
		};

		var definitions = [
		// send type validations
			{
				control_id: this.p3_send_type,
				messages: {
					required: "<%=_T('Please select Send Type.')%>"
				},
				on_error: on_error
			},

		// database validations
			{
				control_id: this.p3_db_type,
				messages: {
					required: "<%=_T('Please select DataBase Type.')%>"
				},
				can_validate: function() {
					return can_validate("database");
				},
				on_error: on_error
			},
			{
				control_id: this.p3_db_server,
				messages: {
					required: "<%=_T('Please enter DataBase Server.')%>"
				},
				can_validate: function() {
					return can_validate("database");
				},
				on_error: on_error
			},
			{
				control_id: this.p3_db_port,
				messages: {
					required: "<%=_T('Please enter DataBase Port.')%>",
					digits: "<%=_T('DataBase Port is not a number.')%>"
				},
				can_validate: function() {
					return can_validate("database");
				},
				on_error: on_error
			},
			{
				control_id: this.p3_db_user,
				messages: {
					required: "<%=_T('Please enter DataBase User.')%>"
				},
				can_validate: function() {
					return can_validate("database");
				},
				on_error: on_error
			},
			{
				control_id: this.p3_db_pwd,
				messages: {
					required: "<%=_T('Please enter DataBase Password.')%>"
				},
				can_validate: function() {
					return can_validate("database");
				},
				on_error: on_error
			},
			{
				control_id: this.p3_db_name,
				messages: {
					required: "<%=_T('Please enter DataBase Name.')%>"
				},
				can_validate: function() {
					return can_validate("database");
				},
				on_error: on_error
			},
			{
				control_id: this.p3_db_error_mail_to,
				messages: {
					custom: {
						type:  "custom",
						valid: function() {
							var addresses = $( "#" + self.p3_db_error_mail_to ).val().trim();
							return mail_validation(addresses);
						}
					}
				},
				can_validate: function() {
					return can_validate("database");
				},
				on_error: on_error
			},
			{
				control_id: this.p3_db_error_mail_from,
				messages: {
					required: "<%=_T('Please enter the E-mail FROM.')%>"
				},
				can_validate: function() {
					if (!can_validate("database")) {
						return false;
					}
					var addresses = $( "#" + self.p3_db_error_mail_to ).val().trim();
					if (addresses.length === 0) {
						return false;
					}
					return true;
				},
				on_error: on_error
			},

		// ftp validations
			{
				control_id: this.p3_ftp_host,
				messages: {
					required: "<%=_T('Please enter FTP Host.')%>"
				},
				can_validate: function() {
					return can_validate("ftp");
				},
				on_error: on_error
			},
			{
				control_id: this.p3_ftp_port,
				messages: {
					digits: "<%=_T('FTP Port is not a number.')%>"
				},
				can_validate: function() {
					return can_validate("ftp");
				},
				on_error: on_error
			},
			{
				control_id: this.p3_ftp_user,
				messages: {
					required: "<%=_T('Please enter FTP User.')%>"
				},
				can_validate: function() {
					return can_validate("ftp");
				},
				on_error: on_error
			},
			{
				control_id: this.p3_ftp_pwd,
				messages: {
					required: "<%=_T('Please enter FTP Password.')%>",
					custom: {
						type:  "custom",
						valid: function() {
							const regex_password_format = /[\u00F1#?=&]/;
							const ftpPassword               = $( "#" + self.p3_ftp_pwd ).val();
							let response                    = { success: true };

							if (regex_password_format.test(ftpPassword)) {
								response.success = false;
								response.message = FORMAT("<%=_T('The FTP Password cannot contain the characters {0}.')%>", "(#,?,=,&,ñ)");
							}

							return response;
						}
					}
				},
				can_validate: function() {
					return can_validate("ftp");
				},
				on_error: on_error
			},
			{
				control_id: this.p3_ftp_filename,
				messages: {
					required: "<%=_T('Please enter the File Name.')%>",
					filesystem : "<%=_T('Invalid File Name. Please enter only letters, numbers, dashes and dots are allowed.')%>"
				},
				can_validate: function() {
					return can_validate("ftp");
				},
				on_error: on_error
			},
			{
				control_id: this.p3_ftp_error_mail_to,
				messages: {
					custom: {
						type:  "custom",
						valid: function() {
							var addresses = $( "#" + self.p3_ftp_error_mail_to ).val().trim();
							return mail_validation(addresses);
						}
					}
				},
				can_validate: function() {
					return can_validate("ftp");
				},
				on_error: on_error
			},
			{
				control_id: this.p3_ftp_error_mail_from,
				messages: {
					required: "<%=_T('Please enter the E-mail FROM.')%>"
				},
				can_validate: function() {
					if (!can_validate("ftp")) {
						return false;
					}
					var addresses = $( "#" + self.p3_ftp_error_mail_to ).val().trim();
					if (addresses.length === 0) {
						return false;
					}
					return true;
				},
				on_error: on_error
			},

		// sftp validations
		{
			control_id: this.p3_sftp_host,
			messages: {
				required: "<%=_T('Please enter SFTP Host.')%>"
			},
			can_validate: function() {
				return can_validate("sftp");
			},
			on_error: on_error
		},
		{
			control_id: this.p3_sftp_port,
			messages: {
				digits: "<%=_T('SFTP Port is not a number.')%>"
			},
			can_validate: function() {
				return can_validate("sftp");
			},
			on_error: on_error
		},
		{
			control_id: this.p3_sftp_user,
			messages: {
				required: "<%=_T('Please enter SFTP User.')%>"
			},
			can_validate: function() {
				return can_validate("sftp");
			},
			on_error: on_error
		},
		{
			control_id: this.p3_sftp_pwd,
			messages: {
				required: "<%=_T('Please enter SFTP Password.')%>",
				custom: {
					type:  "custom",
					valid: function() {
						const regex_password_format = /[\u00F1#?=&]/;
						const ftpPassword               = $( "#" + self.p3_sftp_pwd ).val();
						let response                    = { success: true };

						if (regex_password_format.test(ftpPassword)) {
							response.success = false;
							response.message = FORMAT("<%=_T('The SFTP Password cannot contain the characters {0}.')%>", "(#,?,=,&,ñ)");
						}

						return response;
					}
				}
			},
			can_validate: function() {
				return can_validate("sftp");
			},
			on_error: on_error
		},
		{
			control_id: this.p3_sftp_filename,
			messages: {
				required: "<%=_T('Please enter the File Name.')%>",
				filesystem : "<%=_T('Invalid File Name. Please enter only letters, numbers, dashes and dots are allowed.')%>"
			},
			can_validate: function() {
				return can_validate("sftp");
			},
			on_error: on_error
		},
		{
			control_id: this.p3_sftp_error_mail_to,
			messages: {
				custom: {
					type:  "custom",
					valid: function() {
						var addresses = $( "#" + self.p3_sftp_error_mail_to ).val().trim();
						return mail_validation(addresses);
					}
				}
			},
			can_validate: function() {
				return can_validate("sftp");
			},
			on_error: on_error
		},
		{
			control_id: this.p3_sftp_error_mail_from,
			messages: {
				required: "<%=_T('Please enter the E-mail FROM.')%>"
			},
			can_validate: function() {
				if (!can_validate("sftp")) {
					return false;
				}
				var addresses = $( "#" + self.p3_sftp_error_mail_to ).val().trim();
				if (addresses.length === 0) {
					return false;
				}
				return true;
			},
			on_error: on_error
		},

		// e-mail validations
			{
				control_id: this.p3_mail_to,
				messages: {
					required: "<%=_T('Please enter the E-mail TO.')%>",
					custom: {
						type:  "custom",
						valid: function() {
							var addresses = $( "#" + self.p3_mail_to ).val().trim();
							return mail_validation(addresses);
						}
					}
				},
				can_validate: function() {
					return can_validate("mail");
				},
				on_error: on_error
			},
			{
				control_id: this.p3_mail_attach,
				messages: {
					required: "<%=_T('Please enter the E-mail Attach Name.')%>",
					filesystem : "<%=_T('Invalid E-mail attach name. Please enter only letters, numbers, dashes and dots are allowed.')%>"
				},
				can_validate: function() {
					return can_validate("mail");
				},
				on_error: on_error
			},
			{
				control_id: this.p3_mail_subject,
				messages: {
					required: "<%=_T('Please enter the E-mail Subject.')%>"
				},
				can_validate: function() {
					return can_validate("mail");
				},
				on_error: on_error
			},
			{
				control_id: this.p3_mail_body,
				messages: {
					required: "<%=_T('Please enter the E-mail Body.')%>"
				},
				can_validate: function() {
					return can_validate("mail");
				},
				on_error: on_error
			},
			{
				control_id: this.p3_mail_from,
				messages: {
					required: "<%=_T('Please enter the E-mail FROM.')%>"
				},
				can_validate: function() {
					return can_validate("mail");
				},
				on_error: on_error
			}
		];

		return definitions;
	};

	rd_form_schedule.prototype.get_validation_def = function()
	{

		var definitions = [];

		var page1_def = this.get_page1_validation_def();
		definitions = definitions.concat( page1_def ) ;

		var page2_def = this.get_page2_validation_def();
		definitions = definitions.concat( page2_def ) ;

		var page3_def = this.get_page3_validation_def();
		definitions = definitions.concat( page3_def ) ;

		return definitions;
	};

	rd_form_schedule.prototype.enable_page1_reports_opts = function()
	{
		var $report = $("#" + this.p1_rpt_id );
		this.disable_control( $report, false /*disable*/ , true /*required*/ );
	};

	rd_form_schedule.prototype.disable_page1_reports_opts = function()
	{
		var $report = $("#" + this.p1_rpt_id );
		this.disable_control( $report, true /*disable*/ , false /*required*/ );
		this.hide_report_filters();
	};

	rd_form_schedule.prototype.fill_reports = function( type, callback_finished )
	{
		var self = this;

		callback_finished = callback_finished || $.noop;

		var start_fill = function()
		{
			var $report = $( "#" + self.p1_rpt_id );
			self.show_waiting_combo( $report );

			$report.html("");

			var is_blank_first_item = true;
			var attr_id = "id";
			var attr_name = "full_name";

			var fill = function( list ) {
				list.sort(function(a, b) {
					return (a.full_name || "").localeCompare(b.full_name || "");
				});
				self.fill_combo( $report, is_blank_first_item, list, attr_id, attr_name );
			};

			self.load_reports_list(
				function( success, reports ) {
					self.hide_waiting_combo( $report );
					if ( success ) {
						var list = reports[ type ].list;
						fill( list );
						self.enable_page1_reports_opts();
						callback_finished();
					}
				});
		};

		// Este timeout es agregado para que no quede la opcion del combo congelada
		//	mientras se realizan las operaciones cuando se cambia de opcion en el combo
		window.setTimeout(function()
		{
			self.disable_page1_reports_opts();
			if ( type.length > 0 ) {
			// si no selecciono algun report type
				start_fill( type );
			}
		}, 50);
	};

	rd_form_schedule.prototype.make_dom_filter_id = function( filter_id )
	{
		var prefix_p1 = this.get_prefix( 1 );
		return inConcert.Utils.getNormalizedId(prefix_p1 + filter_id);
	};

	rd_form_schedule.prototype.toggle_filter_section = function()
	{
		const has_filter = this.__has_filter_section();
		if (has_filter) {
			this.show_report_filters();
		}
		else {
			const msg = "<%=_T('The report does not contain filters.')%>";
			this.hide_report_filters(false, msg);
		}
	};

	rd_form_schedule.prototype.toggle_range_section = function()
	{
		const has_range = this.__has_range_section();
		if (has_range) {
			// si el rango no requerido, quito el requerido al label (ej: en los live detail)
			const range_are_not_required = this.__range_are_not_required();
			const is_required = !range_are_not_required;
			const $range = $("#" + this.p1_range);
			this.required_label($range, is_required);

			this.show_report_range();
		}
		else {
			const msg = "<%=_T('The report does not contain ranges.')%>";
			this.hide_report_range(false, msg);
		}
		const $range = $("#" + this.p1_range );
		$range.trigger("change");
	};

	rd_form_schedule.prototype.show_report_range = function()
	{
		$("#" + this.p1_range_options ).show();
		$("#" + this.p1_rpt_range_msg ).hide();
	};

	rd_form_schedule.prototype.hide_report_range = function(show_waiting, msg)
	{
		msg = msg || SELECT_RANGE_MSG;

		$("#" + this.p1_range_options ).hide();
		const $range_msg = $("#" + this.p1_rpt_range_msg );

		$range_msg.removeClass( "formControlLoading" );
		$range_msg.find( "label[waiting-message]" ).hide();

		if ( show_waiting ) {
			$range_msg.addClass( "formControlLoading" );
			$range_msg.find( "label[waiting-message='true']" ).show();
		}
		else {
			$range_msg.find( "label[waiting-message='false']" ).show();
		}

		$range_msg.text(msg).show();
	};

	rd_form_schedule.prototype.on_change_report = function(success, report_id)
	{
		// page 1 - filter section
		this.toggle_filter_section();
		// page 1 - range section
		this.toggle_range_section();
		// page 3 - samples db sps (mysql, sql server)
		this.__p3_show_sample_db_sps(success, report_id);
	};

	rd_form_schedule.prototype.__p3_show_sample_db_sps = function(success, report_id)
	{
		report_id = report_id || $("#" + this.p1_rpt_id).val();
		// report transaction
		const $db_store_procedure_transaction = $("#" + this.p3_db_sp_transaction_sample);
		$db_store_procedure_transaction.text("");
		// report
		const $db_store_procedure = $("#" + this.p3_db_sp_sample);
		$db_store_procedure.text("");
		// report threaded
		const $db_store_procedure_threaded = $("#" + this.p3_db_sp_threaded_sample);
		$db_store_procedure_threaded.text("");
		const $db_store_procedure_threaded_panel = $("#" + this.p3_db_sp_threaded_sample + "_panel");
		$db_store_procedure_threaded_panel.hide();

		if (!success) {
			return;
		}
		if (!this.reports_definition) {
			return;
		}
		const report_definition = this.reports_definition[report_id];
		if (!report_definition) {
			return;
		}
		const $db_type = $("#" + this.p3_db_type);
		const db_type = $db_type.val();
		if (db_type === "") {
			return;
		}

		const SANITIZE_NAME = function(name) {
			if (!name) {
				return "";
			}
			name = inConcert.Utils.removeSpecialChars(name);
			name = name.replace(/ /g, "_");     // espacio en blanco
			name = name.replace(/-/g, "_");     // singo de menos
			name = name.replace(/\//g, "_");    // barra hacia la derecha
			name = name.replace(/\\/g, "_");    // barra hacia la izquierda
			name = name.replace(/\./g, "");     // puntuacion
			name = name.replace(/\%/g, "Porc"); // porcentaje
			return name;
		};

		let sp_params_prefix = "";
		let sp_start_code = "";
		let sp_middle_code = "";
		let sp_end_code = "";

		if ("sql_server" === db_type) {
		// Si es el Driver de SQL Server:
			/// los parametros SI llevan @ al principio
			sp_params_prefix = "@";
			// NO lleva nada al inicio del SP
			sp_start_code = "";
			// El comienzo del codigo (despues de los parametros)
			sp_middle_code = "AS";
			// El fin del codigo (el fin del sp)
			sp_end_code = "GO";
		}
		else if ("my_sql" === db_type) {
		// Si es el Driver MySQL:
			/// los parametros NO llevan @ al principio, ni en ningun lado
			sp_params_prefix = "";
			// SI lleva codigo al inicio del SP
			sp_start_code = "DELIMITER $$" + "\n";
			// El comienzo del codigo (despues de los parametros)
			sp_middle_code = "BEGIN";
			// El fin del codigo (el fin del sp)
			sp_end_code = "END$$";
		}
		else {
			throw("rd_form_schedule.__p3_show_sample_db_sps - Not implemented " + db_type);
		}

		const default_varchar_len = 500;
		var field_type = function(type, len) {
			type = (type || "VARCHAR") + "({0})";
			len = len || default_varchar_len;
			return FORMAT(type, len);
		};

		// El SP de Transaction -------------------------
		let sp_transaction_template = "" +
			sp_start_code +
			"CREATE PROCEDURE sp_ReportTransaction (" + "\n" +
				"    " + sp_params_prefix + "VCC         " + field_type(null, 50)  + "," + "\n" +
				"    " + sp_params_prefix + "ScheduleId  " + field_type(null, 50)  + "," + "\n" +
				"    " + sp_params_prefix + "ReportId    " + field_type(null, 50)  + "," + "\n" +
				"    " + sp_params_prefix + "RunId       " + field_type(null, 50)  + "," + "\n" +
				"    " + sp_params_prefix + "State       " + field_type(null, 50)  + "," + "\n" +
				"    " + sp_params_prefix + "TotalRows   " + field_type(null, 50)  + "," + "\n" +
				"    " + sp_params_prefix + "UpdatedRows " + field_type(null, 50)  + "," + "\n" +
				"    " + sp_params_prefix + "Err         " + field_type(null, 500) +       "\n" +
			")" + "\n" +
			sp_middle_code + "\n" +
				"    " + '<%=_T("-- YOUR CODE ...")%>' + "\n" +
			sp_end_code;

		$db_store_procedure_transaction.text(sp_transaction_template);

		// Variables utilizada para saber si el Reporte de tipo "threaded" incluye el ID y el VCC de la interaction.
		let has_id_interaction_the_main_report = false;
		let has_vcc_interaction_the_main_report = false;

		// Los parametros de los SPs -------------------------
		let param_template = "    " + sp_params_prefix + "{0} " + field_type();

		var get_parameters = function(fields, is_main_sp = true) {
			let added_parameters = {}; // aca llevamos la lista de parametros que se han agregado, asi validamos que el mismo ya no haya sido agregado.
			let parameters = "";

			if (!fields) {
				return parameters;
			}
			for (let i = 0; i < fields.length; i++) {
				let field = fields[i];

				if (parameters.length > 0) {
					// si no es el primer parametro
					parameters = parameters + "," + "\n";
				}

				let field_name = typeof(field) === "object" ? field.name : field;
				let sanitized_parma_name = SANITIZE_NAME(field_name); // sanitizo el parametro (quito los caracteres NO permitidos)
				let param_name = sanitized_parma_name;
				let lower_param_name = param_name.toLowerCase();
				// En este loop se va validando que el nombre del parametro ya no haya sido agregado. Si el mismo ya existe, se le agrega un numero correlativo al final.
				//  Ej: Total, Total1, Total2, etc
				for (let j = 1; j < 1000; j++) {
					if (!added_parameters[lower_param_name]) {
						break;
					}
					param_name = sanitized_parma_name + j.toString();
					lower_param_name = param_name.toLowerCase();
				 }
				added_parameters[lower_param_name] = param_name; // lo agrego en la lista de parametros agregados.
				// bueno por fin, ahora si agrego el parametro al string de parametros.
				parameters = parameters + FORMAT(param_template, param_name);
				// si es el sp principal en un reporte de threaded, y las fields/columns que se estan procesando es la columna que hace referencia al ID o al VCC de la interaction.
				if (is_main_sp) {
					if (field_name === "ID") {
						has_id_interaction_the_main_report = true;
					}
					if (field_name === "VCC") {
						has_vcc_interaction_the_main_report = true;
					}
				}
			}

			return parameters;
		};

		/*
			Ej:
				create PROCEDURE sp_ReportDetailMailsByAgent (
					@ScheduleId varchar(50),
					@ReportId varchar(50),
					@RunId varchar(50),
					@StartDate varchar(50),
					@Campaign varchar(50),
					..
				)
				AS
					-- YOUR CODE ..
				GO
		*/
		var get_sp = function(sp_name, sp_parameters, custom_default_params = "") {
			let sp_template = "" +
					// El Nombre del reporte con el prefijo "sp_"
				sp_start_code +
				"CREATE PROCEDURE sp_{0} (" + "\n" +
					// Los parametros por defecto, que tienen que ir en todos los reportes
				"    " + sp_params_prefix +  "ScheduleId " + field_type(null, 50) + "," +  "\n" +
				"    " + sp_params_prefix +  "ReportId   " + field_type(null, 50) + "," +  "\n" +
				"    " + sp_params_prefix +  "RunId      " + field_type(null, 50) + "," +  "\n" +
				"    " + sp_params_prefix +  "RowNumber  " + field_type(null, 50) + "," +  "\n" +

				custom_default_params +
					// Los parametros (cada columna del reporte)
				"{1}" + "\n" +
				")" + "\n" +
				sp_middle_code + "\n" +
				"    " + '<%=_T("-- YOUR CODE ...")%>' + "\n" +
				sp_end_code;

			sp_template = FORMAT(sp_template, sp_name, sp_parameters);
			return sp_template;
		};

		// El SP del Reporte -------------------------
		let source_params = [];
		if (report_definition.type === "summary") {
			// 1 - columnas segun cut (filtro)
			// los summary proyectan los filtros como columnas, por ende hay que agregarlos.
			if (report_definition.cutInfo) {
				for (let i = 0; i < (report_definition.cutInfo.columns || []).length; i++) {
					let cut_column_name = report_definition.cutInfo.columns[i];
					source_params.push(cut_column_name);
				}
			}
			// 2 - columnas segun indicadores
			// Summary proyecta las columnas desde este atributo "indicators"
			for (let i = 0; i < (report_definition.indicators || []).length; i++) {
				let indicator = report_definition.indicators[i];
				let column_id = indicator.id;
				source_params.push(column_id);
			}
		}
		else {
			// cualquier otro tipo de reporte que NO sea summary, proyecta los campos en este atributo "projectFields"
			for (let i = 0; i < (report_definition.projectFields || []).length; i++) {
				let field = report_definition.projectFields[i];
				source_params.push(field.name);
			}
			if (report_definition.type === "dialerbatch") {
				// 2 - columnas segun indicadores
				// En el caso de los dialerbatch tambien hay que proyectar la informacion de los indicadores que llegan aca:
				if (report_definition.summary) {
					let indicators = report_definition.summary.indicators;
					for (let i = 0; i < (indicators || []).length; i++) {
						let column_id = indicators[i];
						source_params.push(column_id);
					}
				}
			}
		}

		let sp_name = report_definition.id;
		if ((report_definition.vcc || "").toLowerCase() !== "system") {
			let name = (report_definition.name || report_definition.label || sp_name);
			sp_name = FORMAT("Custom_{0}", name);
		}
		sp_name = SANITIZE_NAME(sp_name);

		let is_main_sp = true;
		let main_sp_parameters = get_parameters(source_params, is_main_sp);
		let sp_template = get_sp(sp_name, main_sp_parameters);
		$db_store_procedure.text(sp_template);

		// El SP del Threaded del Reporte
		if (report_definition.threadedFields) {
			let custom_default_params = "" +
				"    " + "@ParentRowNumber  " + field_type(null, 50) + "," + "\n";
			if (has_id_interaction_the_main_report) {
				// Si es el sp principal del reporte de threaded contiene el ID de la interaction, tengo que incluir el ID de interaction en los parametros del reporte hijo "_threaded".
				//   Esto para que se pueda hacer referencia de un SP al otro por medio del ID de la interaction.
				custom_default_params = custom_default_params +
					"    " + "@ParentID  " + field_type(null, 500) + "," + "\n";
			}
			if (has_vcc_interaction_the_main_report) {
				// Si es el sp principal del reporte de threaded contiene el VCC de la interaction, tengo que incluir el VCC de interaction en los parametros del reporte hijo "_threaded".
				custom_default_params = custom_default_params +
					"    " + "@VCC  " + field_type(null, 500) + "," + "\n";
			}
			is_main_sp = false;
			let threaded_sp_parameters = get_parameters(report_definition.threadedFields, is_main_sp);
			sp_template = get_sp(sp_name + "_Threaded", threaded_sp_parameters, custom_default_params);
			$db_store_procedure_threaded.text(sp_template);
			$db_store_procedure_threaded_panel.show();
		}
	};

	rd_form_schedule.prototype.fill_report_filters = function(rpt_type, report_id, cached_filters, callback = $.noop)
	{
		const self = this;

		this.wizard.disable_navigation();
		this.hide_report_filters( true /* with waiting */ );

		var return_filters = function( success, filters ) {
			callback( success, filters );
			var disabled = false;
			self.wizard.disable_navigation_buttons( disabled, "next" );
			if ( !self.is_new ) {
				self.wizard.disable_all_navigation_tabs( disabled );
			}
			if ( success ) {
				self.show_report_filters();
			}
			else {
				self.hide_report_filters( false /* without waiting */ );
			}

			self.on_change_report(success, report_id);
		};

		if ( !rpt_type || rpt_type.length === 0 ) {
			return_filters( false );
			return;
		}
		if ( !report_id || report_id.length === 0 ) {
			return_filters( false );
			return;
		}

		var $report_filters = $("#" + this.p1_rpt_filters );
		$report_filters.empty();

		var prefix_p1 = this.get_prefix( 1 );

		var can_add_filter = function( filter ) {
			var type = ( filter.type || "" ).toLowerCase();
			if ( type === "date" ) {
			// los filtros de tipo fecha no se agregan
				return false;
			}
			return true;
		};

		var fill = function( filters )
		{
			$report_filters.empty();

			$.each( filters, function( filter_id, filter )
			{
				if ( !can_add_filter( filter ) ) {
					return true; // continue
				}

				// si los filtros no son requeridos dejo los labels sin la clase de requeridos (ej: en los live detail)
				let filters_are_not_required = self.__filters_are_not_required();
				let is_required;
				if (filters_are_not_required) {
					is_required = false;
				}
				else {
					is_required = filter.required;
				}
				// ---
				var $input;
				var dom_filter_id = self.make_dom_filter_id( filter_id );

				switch ( filter.type )
				{
					case "boolean":
						$input = $("<input type='checkbox'></input>")
							.attr("id", dom_filter_id )
							.addClass("form-control") //filterField
							.prop("checked", true)
							.data("get_value", function($this) {
								return $this.prop("checked");
							});
						break;

					case "string":
						$input = $("<input></input>")
							.attr("id", dom_filter_id )
							.addClass("form-control"); //filterField
						if (filter.options) {
							filter.options.sort();
							$input
								.autocomplete({
									source: filter.options,
									minLength: 0
								})
								.focus(function(){
									$(this).data("uiAutocomplete").search($(this).val());
								});
						}
						break;

					case "date":
						var date_format = "yy-mm-dd";
						var current_date = $.datepicker.formatDate(date_format, new Date());

						$input = $("<input></input>")
							.attr("id", dom_filter_id )
							.addClass("form-control") //filterField
							.datepicker({ dateFormat: date_format, maxDate: 0 })
							.datepicker("setDate", current_date)
							.text(current_date);

						if (filter.time) {
							$input.data("get_value", function($this) {
								return $this.val() === "" ? "" : $this.val() + " " + filter.time;
							});
						}
						if (filter.before_than || filter.after_than) {
						// setup a custom validation function in order to check date order
							$input.data("custom_validator", function($this) {
								var validation_result = { success: true };

								var check_date_order = function($before, $after) {
									if ($before.datepicker("getDate") > $after.datepicker("getDate")) {
										validation_result = {
											success: false,
											error  : FORMAT("<%=_T('{0} must be higher than {1}')%>", _T($after.data("name")), _T($before.data("name")))
										};
									}
									return validation_result.success;
								};

								if (filter.before_than && !check_date_order($this, $("#" + prefix_p1 + filter.before_than)) ) {
									return validation_result;
								}
								if (filter.after_than && !check_date_order($("#" + prefix_p1 + filter.after_than), $this) ) {
									return validation_result;
								}

								return validation_result;
							});

							var bind_date_pickers = function($before, $after) {
								$before.datepicker("option", "onClose", function(selectedDate) {
									$after.datepicker( "option", "minDate", selectedDate );
								});
								$after.datepicker("option", "onClose", function(selectedDate) {
									$before.datepicker( "option", "maxDate", selectedDate );
								});
							};

							if (filter.after_than) {
								var $before = $("#" + prefix_p1 + filter.after_than);
								if ( $before.length > 0 ) {
									bind_date_pickers($before, $input);
								}
							}
							if ( filter.before_than ) {
								var $after = $("#" + prefix_p1 + filter.before_than);
								if ( $after.length > 0 ) {
									bind_date_pickers($input, $after);
								}
							}
						}
						break;

					case "enum":
						$input = $("<select></select>")
							.attr("id", dom_filter_id )
							.addClass("form-control"); //filterCombo

						if ( !is_required ) {
							$input.append("<option value=''>" + "<%=_T('All')%>" + '</option>');
						}
						else {
							$input.append("<option value=''></option>"); // opcion en blanco
						}
						_.each(filter.domain, function(option) {
							$input.append(
								$("<option></option>")
									.attr( "value", option.value)
									.text(option.label || option.value)
							);
							// si se quiere marcar por defecto alguna opcion, seria algoa asi. (por ahora lo dejo, despues lo elimino)
							//if ( option.selected ) {
							//	$input.val(option.value);
							//}
						});
						break;

					default:
						throw "Don't know how to represent filter type " + filter.type;
				}

				$input
					.addClass("reportFilterFieldInput") // reportFilterFieldInput
					.attr("filter_field", true)
					.data("filter_type", filter.type)
					.data("filter_id", filter_id)
					.data("required", filter.required)
					.data("name", filter.name);

				var $label = $( "<label class=''>" + filter.label + "<%=_T(':')%>" + "</label>" );
				$label.attr("for", dom_filter_id);
				if ( is_required ) {
					$label.addClass( "required" );
				}

				var $field = $("<div class='form-group'></div>")
					.append( $label )
					.append( $input );

				if ( is_required ) {
					var $err = $( "<i class='formFieldValidation formFieldError' hidden ></i>" );
					var dom_filter_validation_id = dom_filter_id + "_validation";
					$err.attr( "id", dom_filter_validation_id );
					$field.append( $err );
				}

				var $row = $("<div class='col-3'></div>");
				$row.append( $field );

				if ( filter.preset ) { // It would be awesome to show them two but like a navigation toolbar
					$input.val( filter.value );
					self.readonly_control( $input, true /* disabled */ );
					$field.hide();
					$row.hide();
				}

				if ( self.is_readonly() ) {
					self.readonly_control( $input, true );
				}

				$report_filters.append( $row );
			});

			self.show_report_filters();
		};

		if ( cached_filters ) {
			fill( cached_filters );
			return_filters( true, cached_filters );
			return;
		}

		this.report_controller.loadReport( rpt_type, report_id )
			.done(function( report )
			{
				self.reports_definition = self.reports_definition || {};
				self.reports_definition[report_id] = report;
				self.current_report = report;

				report.update_filters(function() {
					var filters = report.getFilters();
					fill( filters );
					return_filters( true, filters ); // cache filters
				});
			}
			).fail(function( error_thrown )
			{
				return_filters( false );
				var message = FORMAT( "<%=_T('Failed to load {0} report detail : {1}')%>", report_id, error_thrown || "" );
				self.show_status_message( message, "error" );
			});
	};

	rd_form_schedule.prototype.show_report_filters = function()
	{
		$("#" + this.p1_rpt_filters ).show();
		$("#" + this.p1_rpt_filters_msg ).hide();
	};

	rd_form_schedule.prototype.hide_report_filters = function(show_waiting, msg)
	{
		msg = msg || SELECT_FILTER_MSG;

		$("#" + this.p1_rpt_filters ).hide();
		var $filter_msg = $("#" + this.p1_rpt_filters_msg );

		$filter_msg.removeClass( "formControlLoading" );
		$filter_msg.find( "label[waiting-message]" ).hide();

		if ( show_waiting ) {
			$filter_msg.addClass( "formControlLoading" );
			$filter_msg.find( "label[waiting-message='true']" ).show();
		}
		else {
			$filter_msg.find( "label[waiting-message='false']" ).show();
		}

		$filter_msg.text(msg).show();
	};

	rd_form_schedule.prototype.can_export = function()
	{
		const $current_report = $("option:selected", $("#" + this.p1_rpt_id));
		let report = $current_report.data( "item" );

		if (!report) {
			return false;
		}
		if ((report.type || "").toLowerCase() !== "detail") {
			return false;
		}
		if (( report.category || "").toLowerCase() !== "interactions") {
			return false;
		}
		const $export_format = $("#" + this.p1_rpt_export_format);
		let export_format = $export_format.val();
		if (typeof(export_format) === "string" && (export_format === "" || export_format.toLowerCase() === "database")) {
			return false;
		}
		return true;
	};

	rd_form_schedule.prototype.toggle_export_section = function()
	{
		const $export_section = $("#" + this.p1_rpt_export_section);
		if (this.can_export()) {
			$export_section.show();
		}
		else {
			$export_section.hide();
		}
	};

	/*
		Nos retorna la definicion "schedulerInfo" del reporte que se encuentra en el summarizer (ej: ReportRealTimeAgentLoggedIn.lua)
	*/
	rd_form_schedule.prototype.__get_report_def_scheduler_info = function()
	{
		const $reports = $("#" + this.p1_rpt_id);
		const report_id = $reports.val();
		const report_definition = (this.reports_definition || {})[report_id];
		if (!report_definition) {
			return;
		}
		return report_definition.schedulerInfo;
	};

	rd_form_schedule.prototype.__has_filter_section = function()
	{
		const scheduler_info = this.__get_report_def_scheduler_info();
		if (!scheduler_info) {
			return true;
		}
		if (scheduler_info.filter) {
			if (scheduler_info.filter.withoutFilters === true) {
				return false;
			}
		}
		return true;
	};

	rd_form_schedule.prototype.__filters_are_not_required = function()
	{
		const scheduler_info = this.__get_report_def_scheduler_info();
		if (!scheduler_info) {
			return false;
		}
		if (scheduler_info.filter) {
			if (scheduler_info.filter.areNotRequired === true) {
				return true;
			}
		}
		return false;
	};

	rd_form_schedule.prototype.__has_range_section = function()
	{
		const $reports_type = $("#" + this.p1_rpt_type );
		const rpt_type = $reports_type.val();

		const sectionsWithRange = {
			detail        : true,
			realtime      : true,
			summary       : true,
			dialerbatch   : false,
			dialercontacts: false,
			livedetail    : true
		};

		let has_range_section = sectionsWithRange[rpt_type];
		if (!has_range_section) {
			return false;
		}

		const scheduler_info = this.__get_report_def_scheduler_info();
		if (!scheduler_info) {
			return true;
		}
		if (scheduler_info.range) {
			if (scheduler_info.range.withoutRange === true) {
				return false;
			}
		}
		return true;
	};

	rd_form_schedule.prototype.__range_are_not_required = function()
	{
		const scheduler_info = this.__get_report_def_scheduler_info();
		if (!scheduler_info) {
			return false;
		}
		if (scheduler_info.range) {
			if (scheduler_info.range.areNotRequired === true) {
				return true;
			}
		}
		return false;
	};

	rd_form_schedule.prototype.set_events_page1 = function()
	{
		var self = this;

		// evento change del combo de reports types
		var $reports_type = $("#" + this.p1_rpt_type );
		$reports_type
			.off("change keyup")
			.on("change keyup", function(e)
			{
				if ( e.type.toLowerCase() === "keyup" ) {
					var key = e.keyCode;
					//teclas del cursor
					if ( key < 37 && key > 40 ) {
						return;
					}
				}

				var rpt_type = $reports_type.val();
				self.fill_reports( rpt_type );
				$("#" + self.p1_range_section).toggle(self.__has_range_section());
			});

		// evento change del combo de reports
		var report_timeout;
		var $reports = $("#" + this.p1_rpt_id );
		$reports
			.off("change keyup")
			.on("change keyup", function(e)
			{
				if ( e.type.toLowerCase() === "keyup" ) {
					var key = e.keyCode;
					//teclas del cursor
					if ( key < 37 && key > 40 ) {
						return;
					}
				}

				var $option_selected = $( "option:selected", this );

				if ( report_timeout ) {
					window.clearTimeout( report_timeout );
					report_timeout = undefined;
				}

				// Este timeout es agregado para que la carga de los filters del report (request/cached/markup) lo genere una vez seleccionado.
				// para que no realice esto mientras se mueve con el teclado dentro del combo.
				report_timeout = window.setTimeout( function()
				{
					window.clearTimeout( report_timeout );
					report_timeout = undefined;
					var rpt_type = $reports_type.val();
					var report_id = $reports.val();
					var cached_filters = $option_selected.data( "filters" );
					var callback = function( success, filters ) {
						if ( !success ) {
							return;
						}
						$option_selected.data( "filters", filters );
						self.toggle_export_section();
					};
					self.fill_report_filters( rpt_type, report_id, cached_filters, callback );
				}, 50 );
			});

		// evento del cbo range
		var $range = $("#" + this.p1_range );
		var $frequency = $("#" + this.p2_frequency );

		var filter_frequency = function( range_id )
		{
			let show_frec;
			const scheduler_info = self.__get_report_def_scheduler_info();
			if (scheduler_info && scheduler_info.frequency && scheduler_info.frequency.list) {
				// filtra las frecuencias segun la informacion del reporte en el servidor.
				let list = scheduler_info.frequency.list;
				show_frec = {show_only_opts: list};
			}
			else {
				// filtra las frecuencias client side, segun el rango seleccionado.
				const show_frequencies = {
					// range id                frec id
					SinceLastReport : { hide_opts      : [ "onetime" ]     } ,
					Range           : { show_only_opts : [ "onetime" ]     } ,
					LastDay         : { hide_opts      : [ "EveryNHours" ] } ,
					LastWeek        : { hide_opts      : [ "EveryNHours" ] } ,
					LastMonth       : { hide_opts      : [ "EveryNHours" ] } ,
					DaysBefore      : { hide_opts      : [ "EveryNHours" ] } ,
					HoursBefore     : { hide_opts      : [ "onetime" ]     }
				};
				show_frec = show_frequencies[ range_id ];
			}

			if (!show_frec) {
				$frequency.find( "option" ).show();
				return;
			}

			var selected_frequency = $( "option:selected", $frequency ).val();

			if ( show_frec.hide_opts ) {
				$frequency.find( "option" ).show();
				$.each( show_frec.hide_opts || [], function( _, frec_id ) {
					var $option = $frequency.find( "option[value='" + frec_id + "']" );
					if ( $option.length > 0 ) {
						$option.hide();
						if ( selected_frequency === frec_id ) {
							$frequency.val( "" ).trigger( "change" );
						}
					}
				});
			}
			else {
				$frequency.find( "option[value!='']" ).hide();
				$.each( show_frec.show_only_opts || [], function( _, frec_id ) {
					var $option = $frequency.find( "option[value='" + frec_id + "']" );
					if ( $option.length > 0 ) {
						$option.show();
						if ( selected_frequency !== frec_id ) {
							$frequency.val( frec_id ).trigger( "change" );
						}
					}
				});
			}
		};

		$range
			.off("change keyup")
			.on("change keyup", function()
			{
				var panel_id = $( this ).val();
				var $section = $( "#" + self.p1_range_section );
				$section.find( "[range_panel]" ).hide();
				if (self.__has_range_section()) {
					$section.find( "[range_panel='" + panel_id + "']" ).show();
				}
				filter_frequency( panel_id );
			});

		var filter_range = function( exportaion )
		{
			var show_ranges = {
				with_export    : { hide_opts      : [ "LastMonth" ] }
			};

			var show_range = show_ranges[ exportaion ];
			if ( !show_range ) {
				$range.find( "option" ).show();
				return;
			}

			var selected_range = $( "option:selected", $range ).val();

			if ( show_range.hide_opts ) {
				$range.find( "option" ).show();
				$.each( show_range.hide_opts || [], function( _, range_id ) {
					var $option = $range.find( "option[value='" + range_id + "']" );
					if ( $option.length > 0 ) {
						$option.hide();
						if ( selected_range === range_id ) {
							$range.val( "" ).trigger( "change" );
						}
					}
				});
			}
			// else {
				// $range.find( "option[value!='']" ).hide();
				// $.each( show_range.show_only_opts || [], function( _, range_id ) {
					// var $option = $range.find( "option[value='" + range_id + "']" );
					// if ( $option.length > 0 ) {
						// $option.show();
						// if ( selected_range !== range_id ) {
							// $range.val( range_id ).trigger( "change" );
						// }
					// }
				// });
			// }
		};

		const $export_days_to_keep_cont = $( "#" + this.p1_rpt_export_days_to_keep_cont );
		const $export_content_type = $( "#" + this.p1_rpt_export_content_type );

		$( "#" + this.p1_rpt_export )
			.off("click")
			.on("click", function()
			{
				var $chk = $( this );
				var disabled = false;
				var required = true;
				var exportation = "with_export";
				if ( !$chk.prop( "checked" ) ) {
					disabled = true;
					required = false;
					exportation = "without_export";
				}
				self.disable_control($export_content_type, disabled, false);
				if ( !disabled ) {
					$export_content_type.focus();
				}
				self.disable_control( $export_days_to_keep_cont, disabled, required );
				filter_range( exportation );

				$(`#${this.p1_range_last_n_days}_disclaimer`).html(FORMAT("<%=_T('Valid range {0} - {1} days')%>", 1, required? 7: 180));
			});

		const $export_format = $( "#" + this.p1_rpt_export_format );
		$export_format
			.off("change")
			.on("change", function() {
				self.on_change_export_format();
			});
	};

	rd_form_schedule.prototype.on_change_export_format = function()
	{
		this.toggle_export_section();

		const $send_type = $("#" + this.p3_send_type);
		const $export_format = $("#" + this.p1_rpt_export_format);

		if ($export_format.val() === "database") {
			this.fill_send_type_options("database");
			$send_type.val("database").trigger("change");
			$send_type.prop("disabled", true);
		}
		else {
			const previous_send_type = $send_type.val();
			this.fill_send_type_options("mail_ftp");
			let select_send_type = previous_send_type === "database" ? "" : previous_send_type;
			$send_type.val(select_send_type).trigger("change");
			$send_type.prop("disabled", false);
		}
	};

	rd_form_schedule.prototype.set_events_page2 = function()
	{
		var self = this;

		var $frequency = $("#" + this.p2_frequency );
		var $validity = $("#" + this.p2_validity );

		var $chk_starts_on_date = $( "#" + this.p2_common_require_starts_on_date );
		var $starts_on_date = $( "#" + this.p2_common_starts_on_date );
		var $starts_on_hour = $( "#" + this.p2_common_starts_on_hour );

		var filter_validicity = function( frec_id )
		{
			var disabled = false;
			var required = true;
			if ( frec_id === "onetime" ) {
				disabled = true;
				required = false;
				$validity.val( "" ).trigger( "change" );
				self.hide_messages(); // por si dio error una validacion anterior y se visualiza la cruz, tiene que ocultarla
			}
			self.disable_control( $validity, disabled, required );
		};

		var required_starts_on_date = function( frec_id )
		{
			var disabled = false;
			if ( frec_id === "CustomRepeat" || frec_id === "EveryNHours" ) {
				$chk_starts_on_date.prop( "checked", true );
				self.disable_control( $starts_on_date, disabled, true /* required */ );
				self.disable_control( $starts_on_hour, disabled, true /* required */ );
				disabled = true;
			}
			self.disable_control( $chk_starts_on_date, disabled );
		};

		// start set events
		$frequency
			.off("change keyup")
			.on("change keyup", function()
			{
				// controles de la frecuencia
				var panel_id = $( this ).val();
				var $section = $( "#" + self.p2_frequency_section );
				$section.find( "[frequency_panel]" ).hide();
				$section.find( "[frequency_panel='" + panel_id + "']" ).show();
				// common section
				required_starts_on_date( panel_id );
				// validicity section
				filter_validicity( panel_id );
			});

		$chk_starts_on_date
			.off("click")
			.on("click", function()
			{
				var $chk = $( this );
				var disabled = false;
				var required = true;
				if ( !$chk.prop( "checked" ) ) {
					disabled = true;
					required = false;
				}
				self.disable_control( $starts_on_date, disabled, required );
				self.disable_control( $starts_on_hour, disabled, required );
			});

		$validity
			.off("change keyup")
			.on("change keyup", function()
			{
				var panel_id = $( this ).val();
				var $section = $( "#" + self.p2_validity_section );
				$section.find( "[validity_panel]" ).hide();
				$section.find( "[validity_panel='" + panel_id + "']" ).show();
				if ( !self.is_new && panel_id === "limited" ) {
					var editing_sch = self.get_entity_instance();
					self.remaining_message( editing_sch );
				}
			});
	};

	rd_form_schedule.prototype.set_events_page3 = function()
	{
		const self = this;
		const $send_type = $("#" + this.p3_send_type);
		const $db_panel = $("#" + this.p3_panel_db);
		const $ftp_panel = $("#" + this.p3_panel_ftp);
		const $sftp_panel = $("#" + this.p3_panel_sftp);
		const $mail_panel = $("#" + this.p3_panel_mail);

		$send_type
			.off("change keyup")
			.on("change keyup", function() {
				$db_panel.hide();
				$ftp_panel.hide();
				$sftp_panel.hide();
				$mail_panel.hide();

				const panel_id  = $(this).val();
				if (!panel_id) {
					return;
				}
				if (panel_id === "database") {
					$db_panel.show();
				}
				else if (panel_id === "ftp") {
					$ftp_panel.show();
				}
				else if (panel_id === "sftp") {
					$sftp_panel.show();
				}
				else if (panel_id === "mail") {
					$mail_panel.show();
				}
				else {
					throw "rd_form_schedule.prototype.set_events_page3 - Unrecognized send type: " + panel_id;
				}
			});

		const $db_type = $("#" + this.p3_db_type);
		$db_type
			.off("change keyup")
			.on("change keyup", function() {
				// page 3 - samples db sps (mysql, sql server)
				self.__p3_show_sample_db_sps(true);
			});
	};

	rd_form_schedule.prototype.set_events = function()
	{
		rd_form_schedule.uber.set_events.call( this ); //invokes the base class method

		this.set_events_page1();
		this.set_events_page2();
		this.set_events_page3();
	};

	rd_form_schedule.prototype.show_state_message = function( sch )
	{
		if ( !sch ) {
			this.hide_state_message();
			return;
		}

		var messages = {
			active   : {
				text       : "",
				class_name : ""
			},
			expired   : {
				text       : "<%=_T('Schedule is Expired.')%>",
				class_name : "expired"
			},
			inactive   : {
				text       : "<%=_T('Schedule is Deactivated')%>",
				class_name : "deactivated"
			},
			running   : {
				text       : "<%=_T('Schedule is Running.')%>",
				class_name : "running"
			}
		};

		var state = ( sch.State || "" ).toLowerCase();
		var message = messages[ state ];
		if ( !message || message.text.length === 0 ) {
			this.hide_state_message();
			return;
		}

		var $message = $( "#" + this.schedule_state_message );
		$.each( messages, function( _, def ) {
			$message.removeClass( def.class_name );
		});

		$message.addClass( message.class_name ).text( message.text ).show();
	};

	rd_form_schedule.prototype.hide_state_message = function()
	{
		var $message = $( "#" + this.schedule_state_message );
		$message.hide();
	};

	rd_form_schedule.prototype.initialize = function()
	{
		this.hide_state_message();
		this.initialize_wizard();
	};

	rd_form_schedule.prototype.apply_initial_config = function()
	{
		// esta funcion hoy es util para cuando se abre el frm desde otra app (reports->viewer),
		// pero tambien se podria utilizar para otras necesidades. 
		var conf = this.instance_config;
		if ( !conf ) {
			return;
		}

		// aca viene la data del schedule cuando se invoca desde el rpt viewer (con los datos prefijados de la solapa 1 del wizard)
		var sch = conf.data;
		if ( !sch ) {
			return;
		}
		this.set( true, sch );
	};

}());