local json = require "cjson"
local utils = require "shared.apps.utils"

module(..., package.seeall)

json.encode_empty_table_as_array("on")

local m_datasource

function GetName()
	return "Repository"
end

function GetDefinition(datasource)
	m_datasource = datasource
	return _M
end

function HasPublicFile(id)
	return m_datasource.redis:exists("PublicRepositoryFile:" .. id)
end

function getVcc(params)	
	local params_p = params and params.p and params.p ~= "" and json.decode(params.p) or {}
	local vccId = params.vcc or params_p.vcc
	if not vccId and params.proxyType == "CHAT" and params_p.interactionID then
		local interaction_str = m_datasource.redis:get("InteractionDetail:" .. params_p.interactionID)
		local interaction = interaction_str and json.decode(interaction_str) or {}
		vccId = interaction.VCC
		vccId = vccId and md5.sumhexa(vccId):upper()
	end
	return vccId
end