print("Bootstrap START")

local inconcert_devel = os.getenv("INCONCERT_DEVEL")
local is_windows

if package.cpath:match("%.so") then
	package.cpath = inconcert_devel..[[/bin/?.so;]]..package.cpath
	is_windows = false
else
	package.cpath = inconcert_devel..[[/bin/?.dll;]]..package.cpath
	is_windows = true
end

-- para encontrar webHandler.path
package.path = ([[%s/sources/inconcertwebhandler/lib/?.lua;%s]]):format(inconcert_devel, package.path)

local path = require "webHandler.path"

package.path = path.normalize(([[%s\sources\inconcertwebhandler\data\lua\?.lua;%s]]):format(inconcert_devel, package.path))

if is_windows then
	webHandler.platform = "windows"
else
	webHandler.platform = "linux"
end

require "lualiblogger"

scriptLogger = lualiblogger.new("webhandler")
for _, name in pairs{"Debug", "Info", "Warning", "Error", "Fatal"} do
	scriptLogger["Log" .. name] = scriptLogger[name]
	webHandler["Log" .. name] = scriptLogger[name]
end

function Server(t)
	return t
end
function Instance(t)
	return t
end

webHandler.CollectTraceback = debug.traceback

local config = {
	["Display Name"] = "inconcert-6",
	["Code Path"] = path.normalize(inconcert_devel.."/sources/inconcertwebhandler/data/lua"),
	["Config Path"] = path.normalize(inconcert_devel.."/sources/agent/inconcert/apps/repository/unittest"),
	["WebRoot Path"] = path.normalize(inconcert_devel.."/sources/agent/inconcert"),
	["Listen Port"] = 8080,
	["Log Requests"] = false,
	["Lua Bin Paths"] = {[[.]]},
	["Lua Source Paths"] = {[[.]]},
	["Lua Special Paths"] = {},
	["Lua States Initial Pool Size"] = 1,
	["Lua States Pool Size"] = 60,
	["Lua States Pool Can Grow"] = false,
	["LuaRocks Path"] = [[.]],
	["Read Buffer Size"] = 8192,
	["POST threshold"] = 64,
	["VM Allocation Timeout"] = 10000
}

KEPLER_CONF = config["Config Path"]
KEPLER_LUA = config["Code Path"]
KEPLER_WEB = config["WebRoot Path"]
KEPLER_LIB = KEPLER_WEB
LUA_PACKAGES_SOURCES = {}

KEPLER_LISTEN_PORT = config["Listen Port"]

LUA_ROCKS_PATH = config["LuaRocks Path"]

LUA_PACKAGES_BINARIES = config["Lua Bin Paths"]

LUA_PACKAGES_SOURCES = config["Lua Source Paths"]
LUA_PACKAGES_WITH_SPECIAL_PATH = config["Lua Special Paths"]


inconcert = {
	environment = {
		apps = {}
	}
}

local filename = path.normalize(config["Config Path"] .. "/bootstrapVM.lua")
local code = assert(loadfile(filename))
assert(code)

code()
