--
-- Slower than /dev/null
-- Less reliable than mongodb
--
-- It's...
--
--
--
-- ... wait for it...
--
--
-- Cachandra
--
-- (c) 2013 Crap-a-stax
--



module(..., package.seeall)

local keyspaces = {}

---
-- helper function for ensure_keys
local function ensure_keys_helper (t, index, ...)
	local key = select(index, ...)
	if not key then
		return t
	end
	t[key] = t[key] or {}
	return ensure_keys_helper(t[key], index + 1, ...)
end

---
-- Makes sure that for keys k1...kn, the following is true: t[k1][k2]...[kn] = {}
local function ensure_keys (t, ...)
	assert(type(t == "table"))
	local key = assert(select(1, ...), "Must supply at least a key")
	t[key] = t[key] or {}
	return ensure_keys_helper(t[key], 2, ...)
end

---
-- Sucky way to see if a given value belongs to a given set
local function belongs (value, set)
	if not set then return false end
	for _, v in pairs(set) do
		if v == value then
			return true
		end
	end
	return false
end


local Connection_mt = {}
Connection_mt.__index = Connection_mt


local Keyspace_mt = {}
Keyspace_mt.__index = Keyspace_mt

function Keyspace_mt:InsertColumn (row_id, column_family, column_id, value)
	--print("InsertColumn", row_id, column_family, column_id, value)
	local column = ensure_keys(keyspaces, self.keyspace, column_family, column_id)
	column[row_id] = value

	return true
end

function Keyspace_mt:BatchInsert (elements)
	for _, el in ipairs(elements) do
		self:InsertColumn(el.column_key, el.column_family, el.column_name, el.column_value)
	end
end

function Keyspace_mt:InsertColumnWithSize (row_id, column_family, column_id, value, length)
	--print("InsertColumnWithSize", row_id, column_family, column_id, value, length)
	local column = ensure_keys(keyspaces, self.keyspace, column_family, column_id)
	column[row_id] = value

	return true
end

function Keyspace_mt:GetSliceRange (row_id, column_family, super_column, predicate)
	--print("GetSliceRange", row_id, column_family, super_column, predicate)

	local ks = assert(keyspaces[self.keyspace])
	local cf = assert(ks[column_family])
	local columns = {}
	local check_column_name = next(predicate.column_names) ~= nil
	for k,v in pairs(cf) do
		if not check_column_name or belongs(k, predicate.column_names) then
			if v[row_id] then
				table.insert(columns, {name = k, value = v[row_id]})
			end
		end
	end
	return columns
end

function Keyspace_mt:RemoveColumn (row_id, column_family)
	local ks = assert(keyspaces[self.keyspace])
	local cf = assert(ks[column_family])
	
	for k, v in pairs(cf) do
		if v[row_id] then
			cf[k] = nil
		end
	end
	cf[row_id] = nil
end

function Keyspace_mt:Close ()
end


function CassandraConnection(self, keyspace)
	local ks = setmetatable({}, Keyspace_mt)
	ks.keyspace = keyspace
	return ks
end
