/*jshint quotmark:false*/
/*global inConcert*/

if (!this.inConcert) {
	this.inConcert = {};
}

if (!inConcert.snPostsCreate) {
	inConcert.snPostsCreate = {};
}

(function () {
/*jshint validthis:true*/
"use strict";

	function CreatePopup (account)
	{
		CreatePopup.uber.constructor.call(this, account);
	}
	
	inConcert.Utils.inherit(CreatePopup, inConcert.snPostsCreate.base);
	if (typeof inConcert.snPostsCreate.facebook !== "function") {
		inConcert.snPostsCreate.facebook = CreatePopup;
	}
	
	CreatePopup.prototype.HasScheduledDate = function() {
		return true;
	};
	
	CreatePopup.prototype.HasBackdatedTime = function() {
		return true;
	};
	
	CreatePopup.prototype.__getScheduleDateLimits = function() {
		var now = new Date();
		var limits = {
			min : this.__makeDateLimit({
				up : true,
				unity : "minutes",
				value: 10
			}, now),
			max : this.__makeDateLimit({
				up : true,
				unity : "months",
				value: 6
			}, now)
		};
		limits["default"] = limits.min;
		return limits;
	};
	
	CreatePopup.prototype.__getBackdatedTimeLimits = function() {
		var date = new Date();
		date.setMilliseconds(0);
		date.setSeconds(0);
		date.setMinutes(0);
		date.setHours(0);
		return {
			max : date,
			"default" : date
		};
	};
	
	CreatePopup.prototype.__getAvailableContentTypes = function() {
		return {
			link : true,
			image : {
				link : true,
				disk : true
			}
		};
	};
	
	CreatePopup.prototype.__getMaxFileSizeMB = function() {
		return 10;
	};
	
	CreatePopup.prototype.__getClassName = function() {
		return "fbPost";
	};
	
	CreatePopup.prototype.__addText = function(data) {
		var text = this.__getText();
		data.message = text;
	};
	
	CreatePopup.prototype.__addLinkToData = function(data, link, isImage) {
		data.link = link;
		if (isImage) {
			data.image = true;
		}
	};
	
	CreatePopup.prototype.__addScheduleDate = function(data) {
		var date = this.__getScheduledDate();
		if (date === null) {
			return;
		}
		if (!this.__validateDatetime(date, this.__getScheduleDateLimits())) {
			return "<%=_T('Scheduled date must be bigger than 10 minutes and less than 6 months.')%>";
		}
		data.scheduled_publish_time = "" + Math.floor(date.getTime() / 1000);
	};

	CreatePopup.prototype.__addBackdatedTime = function(data) {
		var date = this.__getBackdatedTime();
		if (date === null) {
			return;
		}
		if (!this.__validateDatetime(date, this.__getBackdatedTimeLimits())) {
			return "<%=_T('Backdated time must be less than now.')%>";
		}
		//esto es por un bug de facebook
		date.setHours(date.getHours() + 4);
		data.backdated_time = inConcert.Utils.getStringFromDate(date, true, "iso");
		data.backdated_time_granularity = "min";
	};
	
	CreatePopup.prototype.__isScheduled = function(data) {
		return !!data.scheduled_publish_time;
	};

}());