/*jshint quotmark:false*/
/*global inConcert*/

if (!this.inConcert) {
	this.inConcert = {};
}

if (!inConcert.snPostsData) {
	inConcert.snPostsData = {};
}

(function () {
/*jshint validthis:true*/
"use strict";

	function PostsData () {}

	inConcert.Utils.inherit(PostsData, inConcert.snPostsData.base);
	if (typeof inConcert.snPostsData.facebook !== "function") {
		inConcert.snPostsData.facebook = PostsData;
	}

	PostsData.prototype.GetText = function(data, quoted) {
		data = data || {};
		return data.message || "";
	};

	PostsData.prototype.GetContent = function(data, quoted) {
		data = data || {};
		var result = {
			text : this.GetText(data, quoted),
			multimedia : []
		};
		switch(data.type) {
			case "photo":
				var picture = data.picture || data.link;
				if (picture) {
					result.multimedia.push({
						type : "image",
						image : picture,
						caption : data.caption || "",
						name : data.name || "",
						description : data.description || ""
					});
				}
				break;
			case "video":
			case "link":
				var link = data.source || data.link;
				if (link) {
					if (data.picture) {
						result.multimedia.push({
							type : data.type,
							image : data.picture,
							link : link,
							caption : data.caption || "",
							name : data.name || "",
							description : data.description || ""
						});
					}
					else {
						result.text += " " + link;
					}
				}
				break;
		}
		return result;
	};

}());