/*jshint quotmark:false*/
/*global $, inConcert*/

if (!this.inConcert) {
	this.inConcert = {};
}

if (!inConcert.snPostsData) {
	inConcert.snPostsData = {};
}

(function () {
/*jshint validthis:true*/
"use strict";

	var format = inConcert.Utils.format;

	function PostsData ()
	{
		
	}
	
	inConcert.Utils.inherit(PostsData, inConcert.snPostsData.base);
	if (typeof inConcert.snPostsData.youtube !== "function") {
		inConcert.snPostsData.youtube = PostsData;
	}
	
	PostsData.prototype.GetScreenName = function(data) {
		return data && data.user && data.user.screen_name || "";
	};
	
	PostsData.prototype.GetText = function(data) {
		data = data || {};
		return data.text || "";
	};
	
	PostsData.prototype.GetContent = function(data) {
		data = data || {};
		var result = {
			text : this.GetText(data),
			multimedia : []
		};
		
		switch(data.msgtype || "text") {
			case "attachment":
				let media = {};
				media.type = data.fileType;
				//link
				if (data.url) {
					media.link = data.url;
				}
				else {
					media.link = "https://www.youtube.com/watch?v=" + data.id;
				}
				//image
				if (data.previewFileId) {
					media.image = inConcert.app.getBaseDomain() + "/inconcert/apps/repository/download/?id=" +
						encodeURIComponent(data.previewFileId) + "&section=-1&part=-1";
				}
				else if (data.previewUrl) {
					media.image = data.previewUrl;
				}
				result.multimedia.push(media);
				break;
		}
		
		return result;
	};

}());