/*jshint quotmark:false*/
/*global $, inConcert, FB*/

if (!this.inConcert) {
	this.inConcert = {};
}

(function () {
/*jshint validthis:true*/
"use strict";
	
	var format = inConcert.Utils.format;

	var actions = $.extend({}, inConcert.snPostsActions.base, {
		HIDE	: { 
			name			: "<%=_T('Hide')%>",
			description		: "<%=_T('Hide post from pages wall.')%>",
			permission		: "sn_hide",
			method			: "hide_posts/",
			order			: 6
		},
		SHOW	: { 
			name			: "<%=_T('Show')%>",
			description		: "<%=_T('Show post in pages wall.')%>",
			permission		: "sn_hide",
			method			: "show_posts/",
			order			: 6
		}
	});
	if (!inConcert.snPostsActions.facebook) {
		inConcert.snPostsActions.facebook = actions;
		$.each(actions, function(actionId, action) {
			inConcert.snPostsActions.all[actionId] = inConcert.snPostsActions.all[actionId] || action;
		});
	}

	function FacebookPost (rawData)
	{
		FacebookPost.uber.constructor.call(this, rawData);
	}

	inConcert.Utils.inherit(FacebookPost, inConcert.snPosts.base);
	if (typeof inConcert.snPosts.facebook !== "function") {
		inConcert.snPosts.facebook = FacebookPost;
	}
	
	FacebookPost.prototype.GetAccountName = function() {
		var campaign = inConcert.app.getCampaign(this.campaign);
		if (campaign) {
			var account  = campaign.getAccount(this.account);
			if (account) {
				var pages = account.pagesNames;
				if (typeof pages === "string") {
					pages = JSON.parse(pages);
				}
				if (pages[this.page]) {
					return this.page;
				}
			}
		}
		return FacebookPost.uber.GetAccountName.call(this);
	};
	
	FacebookPost.prototype.GetIdString = function() {
		var id_a = this.id.split("_");
		return id_a.length === 2? id_a[1] : this.id;
	};
	
	FacebookPost.prototype.GetNativeProperties = function() {
		let properties = FacebookPost.uber.GetNativeProperties.call(this);
		if (!this.IsDeleted()) {
			if (this.IsHidden()) {
				properties.push({ className : "hidden", tooltip : "<%=_T('Hidden post')%><%=_T('.')%>" });
			}
		}
		return properties;
	};
	
	FacebookPost.prototype.IsHidden = function() {
		return this.data && this.data.timeline_visibility === "hidden";
	};
	
	FacebookPost.prototype.__can_hide = function() {
		return !this.IsDeleted() && !this.IsHidden();
	};
	
	FacebookPost.prototype.__can_show = function() {
		return !this.IsDeleted() && this.IsHidden();
	};
	
	FacebookPost.prototype.GetScheduledDate = function() {
		return (this.data && this.data.scheduled_publish_time)? 
			new Date(this.data.scheduled_publish_time * 1000) : null;
	};
	
	FacebookPost.prototype.LoadApi = function(callback = $.noop) {
		let check = function() {
			if (!window.hasOwnProperty("fbAsyncInit")) {
				window.fbAsyncInit = function() {
					FB.init({
						appId            : window.fbAppId,
						autoLogAppEvents : true,
						xfbml            : true,
						version          : 'v2.10'
					});
					FB.AppEvents.logPageView();
					window.fbIsReady = true;
				};
			}
			return window.hasOwnProperty("fbIsReady");
		};
		inConcert.Utils.loadJsResource("//connect.facebook.net/en_US/sdk.js", check, function(status) {
			callback(status);
		}, "facebookSdkScript");
	};
	
	FacebookPost.prototype.GetEmbedHtml = function(callback, properties) {
		let self = this;
		self.LoadApi(function(status) {
			if (!status) {
				return callback(null);
			}
			let url = format("https://www.facebook.com/{0}/posts/{1}/", self.page, self.id.split("_")[1]);
			let result = {
				html : format("<fb:post href='{0}' width='370'></fb:post></div>", url)
			};
			callback(result);
		});
	};

}());