
/* jshint forin:true, noarg:true, jquery:true, noempty:true, eqeqeq:true, bitwise:true,
	strict:true, undef:true, unused:true, curly:true, browser:true, indent:false, maxerr:50, esversion: 11 */

/* global inConcert*/

// Create an inConcert object only if one does not already exist. We create the
// methods in a closure to avoid creating global variables.
if ( !this.inConcert ) {
	this.inConcert = {};
  }
  if (!inConcert.templates) {
	  inConcert.templates = {};
  }
  
  (function () {
  
  'use strict';
  
	  const FORMAT = inConcert.Utils.format;
  
	  const templates = {
		  //search bar
		  search_bar : ''.concat(
			  '<div search_bar class="snPostsSearchArea assignedInteractionSearch"',
			  '</div>'),
		  //menu
		  menu_category_item : ''.concat(
			  '<li category="{{ id }}" category_selector="true" class="postCategoryItem {{ className }}">',
				  '<div id="snPostsTitleIcon" category_selector="true" class="categoryItemTitle" title="{{ description }}">',
					  '<i category_selector="true" class="fad categoryItemIcon"></i>',
					  '<label category_selector="true" class="categoryItemText">{{ name }}</label>',
				  '</div>',
				  '<ul id="snPostsAccountList" accountsList class="postAccountList" ></ul>',
			  '</li>'),
		  menu_account_item : ''.concat(
			  '<li campaign="{{ campaign }}" account="{{ account }}" page="{{ page }}" class="postAccountItem {{ className }}">',
				  '<label title="{{ name }}" class="listItemText">{{ name }}</label>',
			  '</li>'),
		  //list header
		  list_header_column : ''.concat(
			  '<div column="{{ name }}" class="interactionListColumn interactionColumnTitle {{ className }}">',
				  '{{{ content }}}',
			  '</div>'),
		  list_header_column_text : ''.concat(
			  '<div class="interactionColumnTitleText">',
				  '{{ label }}',
			  '</div>'),
		  list_header_column_icon : ''.concat(
			  '<i class="interactionColumnTitleIco"></i>'),
		  //list row
		  list_row : ''.concat(
			  '<div post_id="{{ id }}" class="interactionListRow interactionOutbound interactionType{{ type }} {{ className }}">',
				  '<div post_waiting post_id="{{ id }}" class="interactionWaitingContainer" style="display:none">',
					  '<i class="interactionWaitingAnima"></i>',
					  '<div class="interactionWaitingOverlay"></div>',
				  '</div>',
			  '</div>'),
		  list_row_selector : ''.concat(
			  '<div class="interactionListColumn columnBatch">',
				  '<div class="selectionTriggerContainer">',
					  '<input post_id="{{ id }}" row_selector="true" class="selectionTriggerCheck" type="checkbox">',
				  '</div>',
			  '</div>'),
		  list_column : ''.concat(
			  '<div column="{{ name }}" class="interactionListColumn {{ className }}">',
				  '{{{ content }}}',
			  '</div>'),
		  list_column_text : ''.concat(
			  '<label class="{{ className }}">{{ text }}</label>'),
		  list_column_abstract : ''.concat(
			  '<div class="{{ className }}" title="{{ text }}">',
				  '{{ text }}',
			  '</div>'),
		  list_column_icon : ''.concat(
			  '<i class="interactionType"></i>'),
		  list_column_actions : ''.concat(
			  '<input post_actions="true" post_id="{{ id }}" type="button" value="..." class="menuActionButton buttonColorGray" style="display: inline-block;">'),
		  //batch actions
		  batch_action_select_all : ''.concat(
		  '<input id="snPostsBatchSelect" select-all="true" class="selectAllTriggerCheck" type="checkbox" />'),
		  batch_action_select_all_search : ''.concat(
		  '<input select_all_tweets class="selectAllTriggerCheck" type="checkbox" disabled/>'),
		  batch_action_button : ''.concat(
			  '<a action="{{ action }}" class="pageButtonGeneric buttonColorWhite"  title="{{ description }}" style="display: none;">',
				  '{{ name }}', 
			  '</a>'),
		  pagination: function() {
			  return ''.concat(
				  '<div id="snPostsPagination" class="interactionListPager">',
					  '<div class="listPager">',
						  '<div class="pagerTextsContainer">',
							  '<label pagination_label class="pagerText"></label>','<label id="snPostsPaginationDisclaimer" class="pagerDisclaimer">' +
								  FORMAT('<%=_T("The Panel allows you to display up to {0} rows. If you need to view more rows, you must perform a more specific search.")%>', inConcert.social_networks.maxAllowedRows()),
							  '</label>',
						  '</div>',	
						  '<div class="pagerButtonsContainer">',
							  '<button first class="pg-button butPagerFirst"></button>',
							  '<button prev class="pg-button butPagerPrev"></button>',
							  '<button next class="pg-button butPagerNext"></button>',
							  '<button last class="pg-button butPagerLast"></button>',
						  '</div>',
					  '</div>',
				  '</div>'
			  );
		  },
		  batch_action_pagination_tweet_search : ''.concat(
			  '<div class="interactionsCounter">',
				  '<label pagination_label class="counterLabel"></label>',
			  '</div>'),
		  //menu actions
		  post_actions_menu : ''.concat(
			  '<div id="{{ id }}" class="interactionMenuBlind">',
			  '</div>'
		  ),
		  post_actions_menu_item : ''.concat(
			  '<div post_id="{{ id }}" action="{{ action }}" class="interactionMenuItem {{ className }}" title="{{ tooltip }}" >',
				  '{{ name }}',
			  '</div>'
		  ),
		  //create post
		  create_popup_container: ''.concat(
			  '<div id="snCreatePopup" class="snPopup snCreatePopup {{ className }}">',
			  '</div>'
		  ),
		  create_popup: ''.concat(
			  '<div class="snPopupTitle">',
				  '<label class="snPopupTitleText">',
					  '{{ title }} {{ name }}',
				  '</label>',
				  '<button id="snPopupCreateButtonClose" statsbuttonClose class="snPopupCloseButton">',
						  "<i class='far fa-times'></i>",
					  '</button>',
			  '</div>',
			  '<div message_container class="popupMessage" style="display:none">',
				  '<label message_text>',
				  '</label>',
			  '</div>',
			  '<div loading class="popupLoading" style="display:none">',
				  '<i class="popupWaitingAnimation"></i>',
				  '<div class="popupWaitingOverlay"></div>',
			  '</div>',
			  '<div content_container class="card-block">',
			  '</div>',
			  '<div class="card-block">',
				  '<div class="row">',
					  '<div class="col-12">',
						  '<div class="form-group mb-0">',
							  '<label for="snCreatePopup_textarea">',
								  '<%=_T("Text")%><%=_T(":")%>',
							  '</label>',
							  '<textarea post_text id="snCreatePopup_textarea" class="form-control">',
							  '</textarea>',
							  '<div text_limit class="textLimit" style="display:none">',
							  '</div>',
						  '</div>',
					  '</div>',
				  '</div>',
			  '</div>',
			  '<div advanced_options class="card-block mb-3">',
			  '</div>',
			  '<div class="editActions d-flex justify-content-end">',
				  '<label character_counter class="characterCounter">',
				  '</label>',
				  '<button cancel class="pageButtonGeneric buttonColorWhite" >',
					  '<%=_T("Cancel")%>',
				  '</button>',
				  '<button create class="pageButtonGeneric buttonColorBlue" disabled>',
					  '<%=_T("Confirm")%>',
				  '</button>',
			  '</div>'
		  ),
		  //create post
		  create_popup_content: ''.concat(
			  '<div class="row">',
					  '<div class="col-6 d-flex flex-column">',
						  '<div class="form-group pt-3 mb-0">',
							  '<label style="display: none;">',
								  '<%=_T("Content:")%>',
							  '</label>',
							  '<select id="contentSelectOption" class="form-control">',
							  '</select>',
						  '</div>',
					  '</div>',
				  '</div>',
			  '</div>',
			  '<hr/>',
			  '<div content_data="link" class="row">',
				  '<div class="col-12">',
					  '<div class="form-group">',
						  '<label>',
							  '<%=_T("URL")%><%=_T(":")%>',
						  '</label>',
						  '<input link_text type="text" id="post_create_content_link_text" class="form-control" placeholder="<%=_T("Enter the url")%><%=_T("...")%>">',
					  '</div>',
				  '</div>',
			  '</div>',
			   '<div content_data="image" class="card-block m-0" content_data_image="true">',
				   '<div class="row">',
					   '<div class="col-12 d-flex flex-column">',
						  '<div class="form-group">',
						  '<div image_content="link" class="form-radiobutton">',
								   '<label class="form-radiobutton-label" for="post_create_content_image_link">',
									   '<input value="link" image_selector="link" type="radio" class="form-radiobutton-input" id="post_create_content_image_link" name="post_create_image_selector">',
									   '<span>',
										   '<%=_T("Image from link")%>',
									   '</span>',
								   '</label>',
							   '</div>',
							   '<div image_content="disk" class="form-radiobutton">',
								   '<label class="form-radiobutton-label" for="post_create_content_image_disk">',
									   '<input value="disk" image_selector="disk" type="radio" class="form-radiobutton-input" id="post_create_content_image_disk" name="post_create_image_selector">',
									   '<span>',
										   '<%=_T("Upload an image")%>',
									   '</span>',
								   '</label>',
							   '</div>',
						   '</div>',
					   '</div>',
				  '</div>',
				  '<div class="row" image_content_data image_link_text id="postCreateContentImageLink" style="display:none;">',
					   '<div class="col-12">',
						  '<div class="form-group mb-0">',
							  '<label>',
								  '<%=_T("URL")%><%=_T(":")%>',
							  '</label>',
							  '<input type="text" id="post_create_content_image_link_text" class="form-control" placeholder="<%=_T("Enter the url")%><%=_T("...")%>">',
						  '</div>',
					  '</div>',
				  '</div>',
				   '<div class="row" image_content_data id="postCreateContentImageDisk" style="display:none;">',
					   '<div class="col-12">',
						   '<div class="pageButtonGeneric buttonColorWhite butFormUploadFile">',
							  '<i class="far fa-upload mr-2"></i>',
							  '<%=_T("Upload a file")%>',
							  '<input id="post_create_content_image_disk_upload" type="file" hidden accept="image/*" />',
						  '</div>',
					   '</div>',
				   '</div>',
				   '<div image_preview class="row pt-2" style="display:none;">',
					   '<div class="col-6">',
						  '<div class="form-group">',
							   '<label>',
								   '<%=_T("Preview:")%>',
							   '</label>',
							   '<div class="postContentPreview" id="post_create_content_image_preview">',
							   '</div>',
						   '</div>',
					   '</div>',
				   '</div>',
			   '</div>'
		  ),
		  create_popup_advanced: ''.concat(
			  '<hr/>',
			  '<div class="row">',
				  '<div schedule_date class="col-6">',
					  '<div class="row">',
						  '<div class="col-12">',
							  '<div class="form-group">',
								  '<div class="form-check">',
									  '<label class="form-check-label form-check-label-title" for="post_create_schedule_date">',
										  '<input class="form-check-input" type="checkbox" id="post_create_schedule_date">',
										  '<%=_T("Schedule date")%>',
									  '</label>',
								  '</div>',
							  '</div>',
						  '</div>',
					  '</div>',
					  '<div class="row">',
						  '<div class="col-6">',
							  '<input date type="text" class="form-control hasDate">',
						  '</div>',
						  '<div class="col-6 pl-0">',
							  '<input hour type="text" class="form-control hourPicker">',
						  '</div>',
					  '</div>',
				  '</div>',
				  '<div backdated_time class="col-6">',
					  '<div class="row">',
						  '<div class="col-12">',
							  '<div class="form-group">',
								  '<div class="form-check">',
									  '<label class="form-check-label form-check-label-title" for="post_create_backdated_time">',
										  '<input class="form-check-input" type="checkbox" id="post_create_backdated_time">',
										  '<%=_T("Assign a previous date")%>',
									  '</label>',
								  '</div>',
							  '</div>',
						  '</div>',
					  '</div>',
					  '<div class="row">',
						  '<div class="col-6">',
							  '<input date type="text" class="form-control hasDate">',
						  '</div>',
						  '<div class="col-6 pl-0">',
							  '<input hour type="text" class="form-control hourPicker">',
						  '</div>',
					  '</div>',
				  '</div>',
			  '</div>'
		  ),
		  //set attributes post
		  set_attributes_popup_container: ''.concat(
			  '<div id="snSetAttributesPopup" class="snPopup snSetAttributesPopup {{ className }}">',
			  '</div>'
		  ),
		  set_attributes_popup: ''.concat(
			  '<div class="snPopupTitle">',
				  '<label class="snPopupTitleText">',
					  '<%=_T("Set Attributes on")%> {{ name }}',
				  '</label>',
				  //'<button id="snPopupSetAttributeButtonClose" statsbuttonClose class="snPopupCloseButton" >',
						  //"<i class='far fa-times'></i>",
				  //'</button>',
			  '</div>',
			  '<div message_container class="popupMessage" style="display:none">',
				  '<label message_text>',
				  '</label>',
			  '</div>',
			  '<div loading class="popupLoading" style="display:none">',
				  '<i class="popupWaitingAnimation"></i>',
				  '<div class="popupWaitingOverlay"></div>',
			  '</div>',
			  '<div class="card">',
				  '<div class="card-block">',
					  '<div class="row">',
						  '<div class="col-12">',
							  '<div class="form-group">',
								  '<label for="snSetAttributesPopup_textarea">',
									  '<%=_T("Attributes")%><%=_T(":")%>',
								  '</label>',
								  '<textarea post_attributes id="snSetAttributesPopup_textarea" class="form-control">',
								  '</textarea>',
							  '</div>',
						  '</div>',
					  '</div>',
				  '</div>',
			  '</div>',
			  '<div class="editActions d-flex justify-content-end">',
				  '<button cancel class="pageButtonGeneric buttonColorWhite" >',
					  '<%=_T("Cancel")%>',
				  '</button>',
				  '<button update class="pageButtonGeneric buttonColorBlue">',
				  '<%=_T("Update")%>',
			  '</button>',
			  '</div>'
		  ),
		  //edit post
		  edit_popup_container: ''.concat(
			  '<div id="snEditPopup" class="snPopup snEditPopup {{ className }}">',
			  '</div>'
		  ),
		  edit_popup: ''.concat(
			  '<div class="snPopupTitle">',
				  '<label class="snPopupTitleText">',
					  '<%=_T("Edit Post on")%> {{ name }}',
				  '</label>',
			  '</div>',
			  '<div message_container class="popupMessage" style="display:none">',
				  '<label message_text>',
				  '</label>',
			  '</div>',
			  '<div loading class="popupLoading" style="display:none">',
				  '<i class="popupWaitingAnimation"></i>',
				  '<div class="popupWaitingOverlay"></div>',
			  '</div>',
			  '<div class="card">',
				  '<div class="card-block">',
					  '<div class="row">',
						  '<div class="col-12">',
							  '<div class="form-group">',
								  '<textarea post_text id="snEditPopup_textarea" class="form-control">',
								  '</textarea>',
							  '</div>',
						  '</div>',
					  '</div>',
				  '</div>',
			  '</div>',
			  '<div class="editActions d-flex justify-content-end">',
				  '<label character_counter class="characterCounter">',
				  '</label>',
				  '<button cancel class="pageButtonGeneric buttonColorWhite" >',
					  '<%=_T("Cancel")%>',
				  '</button>',
				  '<button update class="pageButtonGeneric buttonColorBlue"  disabled>',
					  '<%=_T("Update")%>',
				  '</button>',
			  '</div>'
		  ),
		  //reschedule post
		  reschedule_popup_container: ''.concat(
			  '<div id="snReschedulePopup" class="snPopup snReschedulePopup {{ className }}">',
			  '</div>'
		  ),
		  reschedule_popup: ''.concat(
			  '<div class="snPopupTitle">',
				  '<label class="snPopupTitleText">',
					  '<%=_T("Reschedule Post on")%> {{ name }}',
				  '</label>',
				  '<button id="snPopuButtonRescheduleClose" statsbuttonClose class="snPopupCloseButton" >',
						  "<i class='far fa-times'></i>",
					  '</button>',
			  '</div>',
			  '<div message_container class="popupMessage" style="display:none">',
				  '<label message_text>',
				  '</label>',
			  '</div>',
			  '<div loading class="popupLoading" style="display:none">',
				  '<i class="popupWaitingAnimation"></i>',
				  '<div class="popupWaitingOverlay"></div>',
			  '</div>',
			  '<div schedule_date class="card">',
				  '<div class="card-block">',
					  '<div class="row">',
						  '<div class="col-6">',
							  '<div class="form-group">',
								  '<label for="post_create_schedule_date">',
									  '<%=_T("Schedule date")%><%=_T(":")%>',
								  '</label>',
								  '<input date type="text" class="form-control hasDate">',
							  '</div>',
						  '</div>',
						  '<div class="col-6">',
							  '<div class="form-group">',
								  '<label>',
									  '<%=_T("Schedule time")%><%=_T(":")%>',
								  '</label>',
								  '<input hour type="text" class="form-control">',
							  '</div>',
						  '</div>',
					  '</div>',
				  '</div>',
			  '</div>',
			  '<div class="editActions d-flex justify-content-end">',
				  '<label character_counter class="characterCounter">',
				  '</label>',
				  '<button cancel class="pageButtonGeneric buttonColorWhite" >',
					  '<%=_T("Cancel")%>',
				  '</button>',
				  '<button update class="pageButtonGeneric buttonColorBlue" >',
					  '<%=_T("Update")%>',
				  '</button>',
			  '</div>'
		  ),
		  //statistics view
		  statistics_preview : ''.concat(
			  '<div class="statsTitleContainer">',
				 	'<label post_name class="statsTitleText"><%=_T("Detail")%></label>',
					 '<button id="snStatsPreviewTitle" statsbuttonClose class="statsCloseButton">',
					 "<i class='far fa-times'></i>",
			   '</button>',
			  '</div>',
			  '<div stats_body class="statsContentContainer">',
			  		'<div class="card">',
						'<div class="statsRange">',
							'<div class="card-block">',
								'<div class="row align-items-end">',
									'<div class="col-6 d-flex justify-content-start align-items-center">',
										'<i class="far fa-signal-3">',
										'</i>',
										'<label class="selectLabel"><%=_T("Stats:")%></label>',
									'</div>',
									'<div class="col-6 d-flex justify-content-end pl-0">',
										'<select range class="form-control">',
										'</select>',
										'<button view_details class="pageButtonGeneric buttonColorWhite p-maximize" >',
										'<i class="far fa-expand mr-0">',
										'</i>',
									'</button>',
									'</div>',
								'</div>',
							'</div>',
						'</div>',
						'<div list class="statsContent">',
						'</div>',
					'</div>',


				  '<div class="statsBottom">',
					  '<div class="card-block">',
						  '<div class="row">',
							  '<div class="col-12">',
								  '<div class="form-group mb-0 mt-2 text-right">',
									  '<label><%=_T("Last Update:")%></label>',
									  '<label class="pl-1" update_date></label>',
								  '</div>',
							  '</div>',
						  '</div>',
					  '</div>',
				  '</div>',
			  '</div>'
		  ),
		  statistics_popup_container: ''.concat(
			  '<div id="snStatsPopup" class="snPopup statsPopup {{ className }}">',
			  '</div>'
		  ),
		  statistics_popup: ''.concat(
			  '<div stats_body class="statsContentContainer">',
				  '<div class="snPopupTitle">',
					  '<label class="snPopupTitleText">',
						  '{{ name }} <%=_T("Details")%> ',
					  '</label>',
					  '<button id="snPopupButtonClose" snPopupButtonClose class="snPopupCloseButton">',
						  "<i class='far fa-times'></i>",
					  '</button>',
				  '</div>',
				  '<div class="statsBodyContent">',
					  '<div class="card">',
						  '<div class="card-block">',
							  '<div class="row">',
								  '<div class="col-6">',
									  '<div class="form-group">',
										  '<label>',
											  '<%=_T("Stats:")%>',
										  '</label>',
										  '<select range class="form-control">',	
									  '</select>',
								  '</div>',
							  '</div>',
							  
						  '</div>',
						  
						  '<div class="row">',
								  '<div class="col-12">',
									  '<div list class="statsContent">',
									  '</div>',
								  '</div>',
							  '</div>',
						  '</div>',
					  '</div>',
				  '</div>',
				  '<div class="editActions d-flex justify-content-between">',
					  '<div class="statsUpdateDate">',
						  '<label class="statsUpdateDateTitle"><%=_T("Last Update:")%></label>',
						  '<label update_date class="statsUpdateDateValue"></label>',
					  '</div>',
					  '<button close_popup class="pageButtonGeneric buttonColorWhite">',
						  '<%=_T("Close")%>',
					  '</button>',
				  '</div>',
			  '</div>'
		  ),
		  statistics_post_content : ''.concat(
			  '<div post_content class="statsPostContent">',
			  '</div>'
		  ),
		  statistics_post_quoted_content : ''.concat(
			  '<div post_content class="statsPostQuotedContent">',
				  '<label class="statsPostQuotedUsername">',
					  '{{ name }}',
				  '</label>',
				  '<div class="statsPostQuotedAvatar">',
					  '<img src="{{ avatar }}">',
				  '</div>',
			  '</div>'
		  ),
		  statistics_post_text : ''.concat(
			  '<div post_text class="statsPostText truncated">',
				  '<label title="{{ text }}">',
				  '</label>',
				  '<a view_more href="#"><%=_T("View more")%></a>',
			  '</div>'
		  ),
		  statistics_post_image : ''.concat(
			  '<div class="statsPostImage">',
				  '<img class="archivedPostImage" src="{{ image }}">',
				  '<label class="archivedPostName">{{ name }}</label>',
				  '<label class="archivedPostDescription">{{ description }}</label>',
				  '<label class="archivedPostCaption">{{ caption }}</label>',
			  '</div>'
		  ),
		  statistics_post_image_link : ''.concat(
			  '<div class="statsPostImage">',
				  '<a href="{{ link }}">',
					  '<img class="archivedPostImage" src="{{ image }}">',
					  '<label class="archivedPostName">{{ name }}</label>',
					  '<label class="archivedPostDescription">{{ description }}</label>',
					  '<label class="archivedPostCaption">{{ caption }}</label>',
				  '</a>',
			  '</div>'
		  ),
		  statistics_post_video : ''.concat(
			  '<div class="statsPostImage video">',
				  '<a href="{{ link }}">',
					  '<img class="archivedPostImage" src="{{ image }}">',
					  '<label class="archivedPostName">{{ name }}</label>',
					  '<label class="archivedPostDescription">{{ description }}</label>',
					  '<label class="archivedPostCaption">{{ caption }}</label>',
				  '</a>',
			  '</div>'
		  ),

		  statistics_item : ''.concat(
			  '<div class="statsItem">',
				  '<div statistic="{{ id }}" class="statsItemData">',
					  '<div class="row align-items-center">',
						  '<div class="col">',
							  '<i class="statsItemIcon {{ iconClass }}" title="{{ description }}">',
							  '</i>',
							  '<label name class="statsItemName" title="{{ description }}">',
								  '{{ name }}',
							  '</label>',
						  '</div>',
						  /*'<div class="col-4 text-right">',
							  '<label total class="statsItemTotal" title="{{ totalDescription }}">',
								  '{{ total }}',
							  '</label>',
							  '<label trend class="statsItemTrend">',
							  '</label>',
						  '</div>',
						  '<div class="col statsLineChart" line_chart>',
						  '</div>',*/
					  '</div>',
					  '<div class="row d-flex justify-content-between align-items-center">',
							'<div class="col-7 text-left">',
								'<label total class="statsItemTotal" title="{{ totalDescription }}">',
									'{{ total }}',
								'</label>',
								'<label trend class="statsItemTrend">',
								'</label>',
							'</div>',
							'<div class="col statsLineChart" line_chart>',
						    '</div>',
					  '</div>',
					  '<button view_details class="viewStatsDetailsButton buttonToggle border-0" >',
						  '<i class="far fa-chevron-down"></i>',
					  '</button>',
				  '</div>',
				  '<div details class="statsItemDetails" style="display:none;">',
					  '<div sub_list class="statsSubContent">',
					  '</div>',
					  '<div compare_chart>',
					  '</div>',
					  '<div multiline_chart class="statsMultiLineChart">',
					  '</div>',
				  '</div>',
			  '</div>'
		  ),
			
		  //search tweets menu
		  search_tweets_menu_item : ''.concat(
			  '<li class="searchTweetsMenuItem {{ className }}">',
				  '<label box_name class="searchMenuText">',
					  '{{ name }}',
				  '</label>', 
			  '</li>'
		  ),
		  //search tweets box
		  search_tweets_box : ''.concat(
			  '<div class="postSearchColumn">',
				  //filter
				  '<div filter class="postSearchFilter">',
					  //basic
					  '<div class="postSearchFilterBasic">',
						  '<div class="row">',
							  '<div class="col-12 d-flex flex-row">',
								  '<div class="form-group flex-grow-1 mb-0 position-relative">',
									  '<select filter="account" class="form-control">',
										  '{{{ accounts }}}',
									  '</select>',
								  '</div>',
								  '<div class="form-group pl-2 pr-0 mb-0">',
									  '<input filter="basic" type="text" class="form-control">',
								  '</div>',
								  '<div class="form-group d-flex align-items-center mb-0">',
									  '<button refresh_button class="buttonToggle buttonToggleOutlined" >',
										  '<i class="far fa-sync"></i>',
									  '</button>',
									  '<button filter_button class="buttonToggle buttonToggleOutlined" >',
										  '<i class="far fa-filter"></i>',
									  '</button>',
									  '<span class="vertical-divider">',
									  '</span>',
									  '<button close_button class="buttonToggle buttonToggleOutlined" >',
										  '<i class="far fa-trash-alt"></i>',
									  '</button>',
								  '</div>',
							  '</div>',
						  '</div>',
					  '</div>',
					  //advanced
					  '<div advanced_filter class="postSearchFilterAdvance" hidden>',
						  '<div class="row">',
							  '<div class="col-12">',
								  '<div class="card-header px-3">',
									  '<h5>',
										  '<%=_T("Filter")%>',
									  '</h5>',
									  '<button advanced_filter_button class="pageButtonGeneric buttonColorWhite" >',
										  '<%=_T("Clean")%>',
									  '</button>',
								  '</div>',
							  '</div>',
						  '</div>',
						  //message
						  '<div class="row">',
							  '<div class="col-12">',
								  '<div message class="genericFormMessagesContainer messageError" hidden>',
									  '<label>',
									  '</label>',
								  '</div>',
							  '</div>',
						  '</div>',
						  '<div advanced_filter_list class="card-block">',
						  '</div>',
						  '<div class="float-right m-3">',
							  '<button cancel_button class="pageButtonGeneric buttonColorWhite" >',
								  '<%=_T("Cancel")%>',
							  '</button>',
							  '<button update_button class="pageButtonGeneric buttonColorBlue" >',
								  '<%=_T("Update")%>',
							  '</button>',
						  '</div>',
					  '</div>',
				  '</div>',
				  //loading
				  '<div loading class="postSearchLoading" hidden>',
					  '<div class="postSearchLoadingAnimation"></div>',
					  '<div class="postSearchLoadingOverlay"></div>',
				  '</div>',
				  //results
				  '<div results class="postSearchResults">',
				  '</div>',
				  //actions
				  '<div actions class="postSearchActions">',
				  '</div>',
			  '</div>'
		  ),
		  search_tweets_advanced_group : ''.concat(
			  '<div advanced_filter_group="{{ id }}" class="postFilterAdvanceGroup">',
				  '<div advanced_filter_group_title class="postFilterAdvanceGroupTitle">',
					  '<label>',
						  '{{ name }}',
					  '</label>',
				  '</div>',
				  '<div advanced_filter_group_list class="postFilterAdvanceGroupList" hidden>',
				  '</div>',
			  '</div>'
		  ),
		  search_tweets_text : ''.concat(
			  '<div class="row" title="{{ description }}">',
				  '<div class="col-12">',
					  '<div class="form-group">',
						  '<label>',
							  '{{ name }}:',
						  '</label>',
						  '<input filter="{{ id }}" type="text" class="form-control">',
					  '</div>',
				  '</div>',
			  '</div>'
		  ),
		  search_tweets_date : ''.concat(
			  '<div {{ id }} class="row" title="{{ description }}">',
				  '<div class="col-6">',
					  '<div class="form-group">',
						  '<label>',
							  '{{ name }}:',
						  '</label>',
						  '<input filter="{{ id }}" type="text" class="form-control hasDate">',
					  '</div>',
				  '</div>',
			  '</div>'
		  ),
		  search_tweets_number : ''.concat(
			  '<div class="row" title="{{ description }}">',
				  '<div class="col-12">',
					  '<div class="form-group">',
						  '<label>',
							  '{{ name }}:',
						  '</label>',
						  '<input filter="{{ id }}" type="text" class="form-control">',
					  '</div>',
				  '</div>',
			  '</div>'
		  ),
		  search_tweets_select : ''.concat(
			  '<div class="row" title="{{ description }}">',
				  '<div class="col-12">',
					  '<div class="form-group">',
						  '<label>',
							  '{{ name }}:',
						  '</label>',
						  '<select filter="{{ id }}" class="form-control">',
							  '{{{ options }}}',
						  '</select>',
					  '</div>',
				  '</div>',
			  '</div>'
		  ),
		  search_tweets_select_text : ''.concat(
			  '<div class="row" title="{{ description }}">',
				  '<div class="col-12">',
					  '<div class="form-group">',
						  '<label>',
							  '<%=_T("Matching Criteria:")%>',
							  //'{{ name }}:', nachom: comento por ahora imagino algo hay que cambiar
						  '</label>',
						  '<select filter="{{ id }}" class="form-control">',
							  '{{{ options }}}',
						  '</select>',
						  //'<input filter="{{ id }}" type="text" class="twitterSearchFormField" hidden>', comento y paso para abajo
					  '</div>',
				  '</div>',
			  '</div>',
  
			  // nachom: agregue esto:
			  '<div class="row">',
				  '<div class="col-12">',
					  '<div class="form-group">',
						  '<label>',
							  '<%=_T("Matching Text:")%>',
							  //'{{ name }}:', nachom: comento por ahora imagino algo hay que cambiar
						  '</label>',
						  '<input filter="{{ id }}" type="text" class="form-control">',
					  '</div>',
				  '</div>',
			  '</div>'
		  ),
		  search_tweets_check : ''.concat(
			  '<div class="row" title="{{ description }}">',
				  '<div class="col">',
						  '<div class="form-group">',
							  '<div class="form-check">',
								  '<label class="form-check-label form-check-label-title" for="{{ id }}">',
									  '<input id="{{ id }}" filter="{{ id }}" type="checkbox" class="form-check-input">',
									  '{{ name }}',
								  '</label>',
							  '</div>',
						  '</div>',
					  '</div>',
				  '</div>',
			  '</div>'
		  ),
		  //search tweets items
		  search_tweets_limit : ''.concat(
			  '<div limits class="twitterSearchLimits" hidden>',
				  '<label limit_label class="limitLabel">',
				  '</label>',
				  '<label limit_refresh_label class="limitRefresh">',
				  '</label>',
			  '</div>'
		  ),
		  search_tweets_load_more : ''.concat(
			  '<div load_more class="twitterSearchLoadMore">',
				  '<button class="pageButtonGeneric buttonColorWhite m-auto float-none" >',
					  '<%=_T("Load more")%>',
				  '</button>',
			  '</div>'
		  ),
		  search_tweets_empty_search : ''.concat(
			  '<div empty_search class="inlineMessagesContainer messageInfo m-3">',
				  '<%=_T("No tweets found.")%>',
			  '</div>'
		  ),
		  search_tweets_item : ''.concat(
			  '<div tweet="{{ id }}" class="twitterSearchListItem">',
			  '</div>'
		  ),
		  search_tweets_item_disclaimer : ''.concat(
			  '<label disclaimer class="genericFormMessagesContainer messageInfo m-3">',
				  '{{ text }}',
			  '</label>'
		  ),
		  search_tweets_batch_selector : ''.concat(
			  '<div row_selector_container class="twitterSearchListItemBatchSelector">',
				  '<input row_selector="{{ id }}" type="checkbox">',
			  '</div>'
		  ),
		  search_tweets_action : ''.concat(
			  '<div class="twitterSearchListItemAction">',
				  '<input action type="button" value="..." class="menuActionButton buttonColorGray">',
			  '</div>'
		  ),
		  search_tweets_content : ''.concat(
			  '<div class="twitterSearchListItemContent {{ className }}">',
				  '<div avatar class="twitterSearchListItemAvatar">',
					  '<img src="{{ avatar }}">',
				  '</div>',
				  '<label class="twitterSearchListItemUser">',
					  '{{ user }}',
				  '</label>',
				  '<label class="twitterSearchListItemDate">',
					  '{{ date }}',
				  '</label>',
			  '</div>'
		  ),
		  search_tweets_content_text : ''.concat(
			  '<label class="twitterSearchListItemText">',
				  '{{ text }}',
			  '</label>'
		  ),
		  search_tweets_content_image : ''.concat(
			  '<div class="twitterSearchListItemImage">',
				  '<img src="{{ image }}">',
			  '</div>'
		  ),
		  search_tweets_content_image_link : ''.concat(
			  '<div class="twitterSearchListItemImage">',
				  '<a href="{{ link }}">',
					  '<img src="{{ image }}">',
				  '</a>',
			  '</div>'
		  ),
		  search_tweets_content_video : ''.concat(
			  '<div class="twitterSearchListItemImage video">',
				  '<a href="{{ link }}">',
					  '<img src="{{ image }}">',
				  '</a>',
			  '</div>'
		  )
	  };
  
	  if ( !inConcert.templates.social_networks ) {
		  inConcert.templates.social_networks = templates;
	  }
  }());
  
  