
-- TODO: Dejar de acceder a la aplicacion agent asi a lo loco
local apps = { agent = { controllers = { interactions = require "apps.agent.controllers.interactions" } } }
local utils = require "shared.apps.utils"

module(..., package.seeall, inconcert.orbit.application.Decorate)
m_htmlRender = nil


---
-- Delegate the search to the agent. (TODO: fix this in the future)
-- The supervisor sees interactions from all attention levels.
--
local function SearchMonitorInteractions (web)
	local user_name, vcc = inconcert.authUser.userName, inconcert.authUser.virtualContactCenter
	LogInfo("[Supervisor.SearchMonitorInteractions] User '%s' on vcc '%s' is searching MONITOR interactions with request '%s'", user_name, vcc, web.input["post_data"])
	web.request.appId = "supervisor"
	local status, response = apps.agent.controllers.interactions.SearchInteractionsHelper(web.request)
	web.status = status
	return response
end

---
-- Delegate the search to the agent. (TODO: fix this in the future)
-- The supervisor sees interactions from all attention levels.
--
local function SearchOpenInteractions (web)
	local user_name, vcc = inconcert.authUser.userName, inconcert.authUser.virtualContactCenter
	LogInfo("[Supervisor.SearchOpenInteractions] User '%s' on vcc '%s' is searching OPEN interactions with request '%s'", user_name, vcc, web.input["post_data"])
	web.request.appId = "supervisor"
	local status, response = apps.agent.controllers.interactions.SearchInteractionsHelper(web.request)
	web.status = status
	return response
end

---
-- Delegate the search to the agent. (TODO: fix this in the future)
-- The supervisor sees interactions from all attention levels.
--
local function SearchArchiveInteractions (web)
	local user_name, vcc = inconcert.authUser.userName, inconcert.authUser.virtualContactCenter
	LogInfo("[Supervisor.SearchArchiveInteractions] User '%s' on vcc '%s' is searching ARCHIVE interactions with request '%s'", user_name, vcc, web.input["post_data"])
	if web.request.query then
		web.request.query.state = "FINISHED"
	end
	web.request.appId = "supervisor"
	local status, response = apps.agent.controllers.interactions.SearchInteractionsHelper(web.request)
	web.status = status
	return response
end

---
-- Delegate the search to the agent. (TODO: fix this in the future)
-- The supervisor sees interactions from all attention levels.
--
local function SearchQueuedInteractions (web)
	local user_name, vcc = inconcert.authUser.userName, inconcert.authUser.virtualContactCenter
	LogInfo("[Supervisor.SearchQueuedInteractions] User '%s' on vcc '%s' is searching QUEUED interactions with request '%s'", user_name, vcc, web.input["post_data"])
	if web.request.query then
		web.request.query.state = { "TRANSFER QUEUED", "QUEUED" }
	end
	web.request.appId = "supervisor"
	local status, response = apps.agent.controllers.interactions.SearchInteractionsHelper(web.request)
	web.status = status
	return response
end

---
-- Delegate the search to the agent. (TODO: fix this in the future)
-- The supervisor sees interactions from all attention levels.
--
local function SearchWaitingInteractions (web)
	local user_name, vcc = inconcert.authUser.userName, inconcert.authUser.virtualContactCenter
	LogInfo("[Supervisor.SearchWaitingInteractions] User '%s' on vcc '%s' is searching WAITING interactions with request '%s'", user_name, vcc, web.input["post_data"])
	if web.request.query then
		web.request.query.state = "WAITING"
	end
	web.request.appId = "supervisor"
	local status, response = apps.agent.controllers.interactions.SearchInteractionsHelper(web.request)
	web.status = status
	return response
end

local function SearchBotInteractions (web)
	local user_name, vcc = inconcert.authUser.userName, inconcert.authUser.virtualContactCenter
	LogInfo("[Supervisor.SearchBotInteractions] User '%s' on vcc '%s' is searching BOT interactions with request '%s'", user_name, vcc, web.input["post_data"])
	web.request.appId = "supervisor"
	local status, response = apps.agent.controllers.interactions.SearchBotInteractions(web.request)
	web.status = status
	return response
end

---
-- Delegate the search to the agent. (TODO: fix this in the future)
-- The supervisor sees interactions from all attention levels.
--
local function SearchAbandonedInteractions (web)
	local user_name, vcc = inconcert.authUser.userName, inconcert.authUser.virtualContactCenter
	LogInfo("[Supervisor.SearchAbandonedInteractions] User '%s' on vcc '%s' is searching ABANDONED interactions with request '%s'", user_name, vcc, web.input["post_data"])
	if web.request.query then
		web.request.query.state = "ABANDONED"
	end
	web.request.appId = "supervisor"
	local status, response = apps.agent.controllers.interactions.SearchInteractionsHelper(web.request)
	web.status = status
	return response
end

---
-- busqueda global
--
local function SearchGlobalInteractions (web)
	local user_name, vcc = inconcert.authUser.userName, inconcert.authUser.virtualContactCenter
	LogInfo("[Supervisor.SearchGlobalInteractions] User '%s' on vcc '%s' is searching GLOBAL interactions with request '%s'", user_name, vcc, web.input["post_data"])

	local request = web.request
	--if request and (not request.query or not request.query.campaign) then
	--	LogError("[Supervisor.SearchGlobalInteractions] Campaign is required. User '%s' on vcc '%s' is searching GLOBAL interactions.", user_name, vcc)
	--	web.status = 200
	--	return { interactions = {}, last = 0, total_interactions = 0 }
	--end
	web.request.appId = "supervisor"
	local status, response = apps.agent.controllers.interactions.SearchInteractionsHelper(web.request)
	web.status = status
	return response
end

function MapUris ( m, prefix, htmlRender)

	local Log = require("apps.agent.requestFilters").LogRequest
	local vr = utils.JsonValidatorReply
	--search
	m:dispatch_post( Log .. vr .. SearchMonitorInteractions   , prefix .. "/search_monitor/(.*)"   )
	m:dispatch_post( Log .. vr .. SearchOpenInteractions      , prefix .. "/search_open/(.*)"      )
	m:dispatch_post( Log .. vr .. SearchArchiveInteractions   , prefix .. "/search_archive/(.*)"   )
	m:dispatch_post( Log .. vr .. SearchQueuedInteractions    , prefix .. "/search_queued/(.*)"    )
	m:dispatch_post( Log .. vr .. SearchWaitingInteractions   , prefix .. "/search_waiting/(.*)"   )
	m:dispatch_post( Log .. vr .. SearchBotInteractions       , prefix .. "/search_bot/(.*)"       )
	m:dispatch_post( Log .. vr .. SearchAbandonedInteractions , prefix .. "/search_abandoned/(.*)" )
	m:dispatch_post( Log .. vr .. SearchGlobalInteractions    , prefix .. "/global_search/(.*)"    )

	m_htmlRender = htmlRender
end
