local utils = require "shared.apps.utils"

module(..., package.seeall)

function GetName ()
	return "Campaigns"
end

function GetDefinition (datasource)
	m_datasource = datasource
	return _M
end

function GetCampaignMembers (vcc, campaignId, keyspace)
	vcc = vcc or inconcert.authUser.virtualContactCenter
	local simpleCampaignId = utils.GetId(campaignId)
	local fullCampaignId = utils.AppendVcc(simpleCampaignId, vcc)

	return utils.GetAllColumns {
		keyspace = keyspace or "Agent",
		columnFamily = "CampaignMembers",
		key = fullCampaignId
	} or {}
end

function GetMemberCampaigns (fullMember, keyspace)
local userCampaigns = utils.GetAllColumns({
	keyspace     = keyspace,
	columnFamily = "UserCampaigns",
	key          = fullMember
}) or {}

return userCampaigns
end
