module(..., package.seeall)

local utils = require "shared.apps.utils"
local m_datasource

function GetName()
	return "Workgroups"
end

function GetDefinition(datasource)
	m_datasource = datasource
	return _M
end

function GetWorkgroups(vcc, workgroupId, keyspace)
	vcc = (vcc or ""):lower()
	local vccWorkGroups = utils.GetAllColumns({
		keyspace = keyspace or "Agent",
		columnFamily = "Workgroup",
		superColumns = true,
		key = vcc,
		columns = {}
	}) or {}
	--LogDebug("1=========> Vcc '%s' WorkGroups: %s", vcc, json.encode(vccWorkGroups))
	if workgroupId then
		-- un workgroup especifico del vcc
		local workGroupInfo = {}
		workgroupId = workgroupId:lower()
		for vccWorkGroupId, vccWorkGroup in pairs(vccWorkGroups) do
			if vccWorkGroupId:lower() == workgroupId then
				workGroupInfo = vccWorkGroup
				break
			end
		end
		--LogDebug("2=========> Vcc '%s' WorkgroupId: '%s', WorkGroup Info: %s", vcc, workgroupId, json.encode(workGroupInfo))
		return workGroupInfo
	end
	-- todos los workgroups del VCC
	return vccWorkGroups
end
