/* jshint forin:true, noarg:true, jquery:true, noempty:true, eqeqeq:true, bitwise:true,
  strict:true, undef:true, curly:true, browser:true, indent:false, maxerr:50, esversion: 9 */

/* global inConcert, $ */

// Create an inConcert object only if one does not already exist. We create the
// methods in a closure to avoid creating global variables.
if (!this.inConcert) {
	this.inConcert = {};
}

/**
 * @namespace
 * @name DashboardGlobalSearch
 */
(function () {
	"use strict";

	function DashboardGlobalSearch (dashboard_instance)
	{
		DashboardGlobalSearch.uber.constructor.call(this, 'global_search', "<%=_T('Global search')%>", dashboard_instance);
		this.permission_id = 'sup_view_global_search';
		this.m_dashboard = dashboard_instance ? dashboard_instance : null;
		this.m_config = dashboard_instance.get_config_manager();
		this.navigation_folder_id = 'global_search';
		this.m_view_classes_name = 'global_searchViewer';
	}

	inConcert.Utils.inherit(DashboardGlobalSearch, inConcert.sup_dashboard_interactions_view);

	if (typeof inConcert.sup_dashboard_global_search !== 'function') {
		inConcert.sup_dashboard_global_search = DashboardGlobalSearch;
	}

	DashboardGlobalSearch.prototype.setup = $.noop;

	DashboardGlobalSearch.prototype.__get_interaction_gui_config = function()
	{
		const self = this;

		let config = DashboardGlobalSearch.uber.__get_interaction_gui_config.call(this);

		config.get_specifics_interaction_classes = function( interaction, $interaction ) {
			return self.get_specifics_interaction_classes( interaction, $interaction );
		};

		config.callbacks = {
			can_open_client_window: function(interaction, callback = $.noop) {
				//prevent opening the interaction if its queued. Issue #5336
				if ( interaction.isQueued() ) {
					callback(false);
					return;
				}
				if ( interaction.belongsToMe() ) {
					callback(false);
					return;
				}
				callback(true);
			}
		};

		return config;
	};

}());
