/* jshint forin:true, noarg:true, jquery:true, noempty:true, eqeqeq:true, bitwise:true,
  strict:true, undef:true, unused:true, curly:true, browser:true, indent:false, maxerr:50, esversion: 11 */

/* global inConcert*/

// Create an inConcert object only if one does not already exist. We create the
// methods in a closure to avoid creating global variables.
if ( !this.inConcert ) {
	this.inConcert = {};
}

(function () {

	'use strict';

	const m_translated = {
		categories                   : "<%=_T([[Categories]])%>",
		creation_date                : "<%=_T([[Creation Date]])%>",
		content                      : "<%=_T([[Subject]])%>",
		global                       : "<%=_T([[Global]])%>",
		name                         : "<%=_T([[Name]])%>",
		contact_address              : "<%=_T([[Address]])%>",
		contact_id                   : "<%=_T([[Contact ID]])%>",
		owner                        : "<%=_T([[Owner]])%>",
		select_all_conversations     : "<%=_T([[Select all conversations]])%>",
		state                        : "<%=_T([[Status]])%>",
		state_date                   : "<%=_T([[State Date]])%>",
		transfer                     : "<%=_T([[Transfer]])%>",
		transfer_conversations       : "<%=_T([[Transfer conversations]])%>",
		type                         : "<%=_T([[Type]])%>",
		indicators                   : "<%=_T([[Indicators]])%>",
		charts                        : "<%=_T([[Charts]])%>",
		campaign                     : "<%=_T([[Campaign]])%>",
		account                      : "<%=_T([[Account]])%>",
		attention_time               : "<%=_T([[Attention Time]])%>",
		duration	                 : "<%=_T([[Duration]])%>",
		without_filters              : "<%=_T([[Without Filters]])%>",
		agent_state                  : "<%=_T([[Agent State]])%>",
		agent_state_time             : "<%=_T([[State Time (min)]])%>",
		agent_name                   : "<%=_T([[Agent]])%>",
		agent_interactions_state     : "<%=_T([[Conversation State]])%>",
		agent_interactions_state_time: "<%=_T([[Conversation Time (min)]])%>",
		paginated_message            : "<%=_T([[The Panel allows you to display up to {0} conversations. If you need to view more conversations, you must perform a more specific search.]]):gsub([[{0}]], m_utils.GetElasticSearchInstance():GetMaxAllowedRowsInES())%>",

		two_points                   : "<%=_T([[:]])%>",
		slice: {
			label: "<%=_T([[Slice]])%>",
			data: {
				'15_min': "<%=_T([[15 minutes]])%>",
				'30_min': "<%=_T([[30 minutes]])%>",
				'1_hour': "<%=_T([[1 hour]])%>",
				'1_day' : "<%=_T([[1 day]])%>"
			}
		},
		time_ago: {
			label: "<%=_T([[Time Ago]])%>",
			data: {
				'2_hours': "<%=_T([[2 hours]])%>",
				'4_hours': "<%=_T([[4 hours]])%>",
				'8_hours': "<%=_T([[8 hours]])%>",
				'1_week' : "<%=_T([[1 week]])%>"
			}
		}
	};

// The whole purpose of this file is to have separated templates from code.

			// TO-DO: Find a way to not expose this template.
				var __campaign_detail_account_tpl =
					'<div id="sup_dash_detail_account_status_{{ normalized_id }}_{{ account_id }}" {{ hidden }} class="row campaignDetailData extended campaignAccount{{ status }}">' +
						'<div class="col-12">' +
							'<div class="campaignDetailDataAccountsRowType"><i class="campaignDetailAccountImg campaignAccountType{{ account_type }}"></i></div>' +
							'<div class="campaignDetailDataAux">' +
								'<div class="campaignDetailDataAccountsRowName"><label class="campaignDetailItemText"><span id="sup_dash_detail_account_name_{{ normalized_id }}_{{ account_id }}">{{ account_name }}<span></label></div>' +
								'<div class="campaignDetailDataAccountsRowDist"><label class="campaignDetailItemText"><span id="sup_dash_detail_account_distribution_{{ normalized_id }}_{{ account_id }}" >{{ distribution }}</span></label></div>' +
								'<div class="campaignDetailDataAccountsRowStatus"><label class="campaignDetailItemText"><span id="sup_dash_detail_account_status_detail_{{ normalized_id }}_{{ account_id }}">{{ status_detail }}</span></label></div>' +
								'<div class="campaignDetailDataAccountsRowLevels"><label class="campaignDetailItemText"><span id="sup_dash_detail_account_status_attention_level_{{ normalized_id }}_{{ account_id }}">{{ attention_level_list }}</span></label></div>' +
							'</div>' +
						'</div>' +
					'</div>';

				var Templates = {

					// GENERAL CONTAINER
					main :
						'<div class="supervisorContentContainer">' +
							// USERS/MEMBER SELECTOR
							'<div id="sup_members_selector_container" class="supervisorMembersPopUpContainer" hidden></div>' +

							// WAITING
							'<div id="sup_dash_main_waiting" class="supervisorWaitingContainer" style="display:none">' +
								'<div waiting_message="true" class="supervisorWaitingMessage"></div>' +
								'<div class="supervisorWaitingAnimation"></div>' +
								'<div class="supervisorWaitingOverlay"></div>' +
							'</div>' +
							//waiting

							// TOP CONTAINER: HEADER
							'<div id="sup_container_left_menu" class="supervisorContentTop">' +
								'<div class="headerNavigationGlobalMenu" type="button">' + 
									'<button class="mr-1" data-toggle="dropdown">' +
										'<i class="far fa-bars"></i>' +
									'</button>' +
									'<div class="dropdown-menu">'+
										'<a class="panelOptionItem dropdow-item-icon iconDashboard" type="button" action_id="control_panel" show_in_dashboard_panel="BOTH">{{ dashboard_tooltip }} </a>'+
										'<a class="panelOptionItem dropdown-item-icon iconMultipleCampaigns" type="button" action_id="campaign_hide_full_screen" show_in_dashboard_panel="BOTH"><%=_T("Multiple campaigns")%></a>'+
									'</div>'+
								'</div>' +
								// right border / visual
								'<div id="sup_title_container" class="pageTitleContainer">' +
									'<i class="far fa-bullhorn"></i>' +
									'<h1 class="pageTitle">' +
										'<%=_T([[Multiple campaigns]])%>' +
									'</h1>' +
									//'<button action_id="campaign_refresh" tooltip="{{ refresh_tooltip }}" class="supervisorRefreshButton btnStates"><i class="far fa-sync"></i></button>' +
								'</div>' +
								'<div id="sup_dashboard_title_container" class="pageTitleContainer" style="display:none">' +
										'<i class="iconNavigationSupervisor far fa-tachometer-alt-fast"></i>' +
										'<h1 class="pageTitle">' +
											'<%=_T([[Dashboard]])%>' +
										'</h1>' +
								'</div>' +
									'<ul id="sup_toolbar_options" class="supervisorOptionsMenu">' +
										'<li action_id="campaign_supervise" class="supervisorOptionsItem optionSelected itemSupervise btnStates" style="display: none;"><i class="buttons-icons-home"></i></li>' +
										'<li class="sep-vertical"></li>'+
										'<li action_id="campaign_selector" class="supervisorOptionsItem itemCampaigns btnDropdownStates"><%=_T([[Campaigns]])%><i class="far fa-angle-down"></i></li>' +
										//'<li action_id="campaign_refresh" tooltip="{{ refresh_tooltip }}" class="supervisorOptionsItem itemRefresh"><i class="far fa-sync"></i></li>' +
										'<li action_id="campaign_alarms" tooltip="{{ alarms_tooltip }}" class="supervisorOptionsItem itemAlarms btnStates"><i class="far fa-bell-exclamation"></i>' +
											'<div alarm_number_container="true" class="notifyNumberContainer" style="display:none;">' +
												'<span alarm_unread_number="0" class="notifyLiveUnreadNumber"></span>' +
												'<span alarm_live_number="0" class="notifyLiveNumber"></span>' +
											'</div>' +
										'</li>' +
										'<li action_id="campaign_refresh" tooltip="{{ refresh_tooltip }}" class="supervisorOptionsItem supervisorRefreshButtonNew btnStates"><i class="far fa-sync"></i></li>' +
										// '<li class="supervisorOptionsItem itemSettings"></li>' +
										// '<li class="supervisorOptionsItem itemOverview"></li>' +
									'</ul>' +
								'</div>' +
							'</div>' +

							// left container: menu
							// RIGHT CONTAINER: FORMS & VIEWS
							'<div id="sup_container" class="row flex-lg-nowrap supervisorContentRight panels">' +

								'<div id="sup_content_message_container" class="supervisorContentMessageContainer genericFormMessagesContainer" hidden style="z-index:2051!important;">' +
									'<a id="sup_message_close" class="messageClose" href="javascript:void(0);"><%=_T("close")%></a>' +
									'<div class="messageContent">' +
										'<label id="sup_content_message"></label>' +
									'</div>' +
								'</div>' +

								// Top Container -> Tabs + Options
								'<div sup_full_screen_header_container="true" id="sup_full_screen_header_container" class="supervisorTopContainerFullScreenMode" hidden>' +
								
									'<div class="formTabsContainer">'+
											'<div class="headerNavigationGlobalMenu" type="button">' + 
												'<button class="mr-1" data-toggle="dropdown">' +
													'<i class="far fa-bars"></i>' +
												'</button>' +
												'<div class="dropdown-menu">'+
													'<a class="panelOptionItem dropdown-item-icon iconDashboard" type="button" action_id="control_panel" show_in_dashboard_panel="BOTH">{{ dashboard_tooltip }} </a>'+
													'<a class="panelOptionItem dropdown-item-icon iconMultipleCampaigns" type="button" action_id="campaign_hide_full_screen" show_in_dashboard_panel="BOTH"><%=_T("Multiple campaigns")%></a>'+
												'</div>'+
											'</div>' +
										//Dropdown campigns
										'<div id="sup_full_screen_header_navigation_container" class="boxNavigationSupervisor">'+
											'<i id="sup_full_screen_header_navigation_icon" class="iconNavigationSupervisor far fa-bullhorn"></i>' +
											'<label class="campaignDetailTitle"><%=_T("Campaign detail")%></label>' +
											'<div class="btn-group btnDropDownContainer">' + 
												'<button id="sup_full_screen_header_navigation_btn" class="form-control mr-1 buttonCampaign" data-toggle="dropdown">' +
													'<label></label>'+
												'</button>' +
												'<div id="sup_full_screen_header_navigation_menu" class="dropdown-menu"></div>'+
											'</div>' +
										'</div>' +
										'<div id="sup_full_screen_header_navigation_campaign_name_container" style="display: flex; align-items: center;">'+
											'<label id="sup_full_screen_header_navigation_campaign_workgroups" class="campaignWorkgroup"></label>' +
											'<label id="sup_full_screen_header_navigation_campaign_name" class="campaignName"></label>' +
											'<label id="sup_full_screen_header_navigation_campaign_child" class="campaignChild"></label>'+
										'</div>' +
										// Tabs -> Lista de campanas, en modo Full Screen
										'<div id="sup_campaigns_tabs_container" style="display:none"></div>' +
									'</div>' +
									// La botonera de acciones
									'<div full_screen_header_buttons="true" class="panelOptions">' +
										// Botones visibles en Modo Full Screen
										'<div class="campaignActionsContainer">' +
											'<button id="sup_dash_full_screen_panel_bots_filter" class="" type="button" action_id="campaign_bots_filter" style="display:none;"><%=_T("VIENDO")%>' +
											'</button>' +
											'<button id="sup_full_screen_header_navigation_campaign_accounts_btn" class="butPanelAccounts" action_id="campaign_accounts" show_in_dashboard_panel="BOTH" show_in_tab="CAMPAIGNS" type="button" ><i class="far fa-sliders-h"></i><span><%=_T([[Filter_2]])%></span>' +
											'</button>' +
											'<button id="sup_dash_full_screen_panel_detail_{{ normalized_id }}" tooltip="{{ detail_tooltip }}" action_id="campaign_detail" class="butCampaignDetail" type="button" show_in_dashboard_panel="BOTH" show_in_tab="CAMPAIGNS"><i class="far fa-info-circle"></i></button>' +
											'<button id="sup_dash_full_screen_panel_menu_config_view_{{ normalized_id }}" tooltip="{{ menu_config_view_tooltip }}" action_id="campaign_menu_config_view" class="butPanelMenu" type="button" show_in_dashboard_panel="ONLY_CAMPAIGNS" show_in_tab="CAMPAIGNS"><i class="far fa-cog"></i></button>' +											
											'<button id="sup_dash_full_screen_panel_menu_{{ normalized_id }}" tooltip="{{ menu_tooltip }}" action_id="campaign_menu" class="butPanelMenu butPanelMenuText" type="button" show_in_dashboard_panel="BOTH" show_in_tab="CAMPAIGNS"><%=_T([[Menu]])%></button>' +
											'<span class="sep-vertical"></span>'+
											'<button id="sup_dash_full_screen_panel_selector_{{ normalized_id }}" action_id="campaign_selector" class="butPanelSelector btnDropdownStates" type="button" show_in_dashboard_panel="BOTH" show_in_tab="BOTH"><%=_T([[Campaigns]])%><i class="far fa-angle-down"></i></button>' +
											'<button id="sup_dash_full_screen_panel_alarms_{{ normalized_id }}" tooltip="{{ alarms_tooltip }}" action_id="campaign_alarms" class="butPanelAlarms" type="button" show_in_dashboard_panel="BOTH" show_in_tab="BOTH">'+
												'<i class="far fa-bell-exclamation"></i>' +
												// EL markup con los contadores de las alarmas, se genera de forma dinamica en el archivo sup_full_screen.js
											'</button>' +
											'<button id="sup_dash_full_screen_panel_refresh_{{ normalized_id }}" tooltip="{{ refresh_tooltip }}" action_id="campaign_refresh" class="butPanelRefresh" type="button" show_in_dashboard_panel="BOTH" show_in_tab="CAMPAIGNS" ><i class="far fa-sync"></i></button>' +
											// Botones visibles en Modo Vista de Conversaciones
										'</div>' +
									'</div>' +
								'</div>' +
								// El contenedor del TAB "Dashboard"
								'<div id="sup_dashboard_container" class="col-12 supervisorDashboardContainer" style="display:none">' +
									'<div class="row h-100">' +
										'<div id="sup_dashboard_campaigns_list_container" class="col supervisorDashboardLeftContainer">' +
											'<div id="sup_dashboard_campaigns_container" class="supervisorDashboardCampaignsContainer">' +
												'<div id="sup_dashboard_campaigns_not_results_found" class="inlineMessagesContainer messageInfo mt-2" style="display:none"></div>' +
												'<table id="sup_dashboard_campaigns_list" cellpadding="0" cellspacing="0" border="0" class="viewGrid">' +
													'<thead class="viewGridHeader"></thead>' +
													'<tbody class="viewGridBody"></tbody>' +
												'</table>' +
											'</div>' +
											'<div id="sup_dashboard_campaigns_paginator"></div>' +
										'</div>' +// COLUMN / INDICATORS
										'<div id="sup_dashboard_campaigns_list_charts_container" class="col-3 supervisorDashboardRightContainer panelBodyColumn indicators" hidden>' +
											'<div class="supervisorDashboardRightInternalContainer">' +
												'<div class="supervisorDashboardRightTitleContainer">' +
													'<h4>' + m_translated.indicators + '</h4>' +
												'</div>' +
												'<div class="supervisorDashboardRightBodyContainer">' +
													'<label style="display: none;" class="chartSliceLabel">' + m_translated.campaign + m_translated.two_points + '</label>' +
													'<label style="display: none;" id="sup_dashboard_campaigns_list_charts_campaign_name" class="chartSliceLabel"></label>' +
													'<div style="display: none;" class="columnTitle">' +
														'<label class="columnTitleText">' + m_translated.indicators + '</label>' +
													'</div>' +
													// CHART
													// '<div class="columnContent">'+
														// '<div id="sup_dashboard_campaigns_list_charts_series_{{ normalized_id }}" class="seriesConfiguration"></div>' +
													// '</div>' +
													'<div id="sup_dashboard_campaigns_list_charts" class="supervisorDashboardChartsContainer"></div>' +
												'</div>' +
												'<div id="sup_dashboard_campaigns_list_charts_legend" class="chartsLegendContainer" style="display:none"></div>' +
													'<div class="sliceConfiguration">' +
														// Slice
														'<label class="chartSliceLabel">' + m_translated.slice.label + m_translated.two_points + '</label>' +
														'<input id="sup_dash_full_screen_indicators_slice" class="chartSliceCombo" readonly="true" />' +
														// Time Ago
														'<label class="chartSliceSeparator"> | </label>' +
														'<label class="chartSliceLabel">' + m_translated.time_ago.label + m_translated.two_points + '</label>' +
														'<input id="sup_dash_full_screen_indicators_time_ago" class="chartSliceCombo" readonly="true" />' +
													'</div>' +
											'</div>' +
										'</div>' +
									'</div>' +
								'</div>' +
							'</div>' +
						// right container: forms & views
						'</div>',

					dashboard :
					{
						members_channel_msg_tpl : '<div class="teamInteractionDetail">' +
							'<label total_interactions_msg="true" class="teamText {{ type_class }}"></label>' +
							'<label capability_msg="true" class="channelCapabilityDisclaimer" hidden></label>' +
						'</div>',

						members_tpl :
						'<li id="sup_member_{{ id }}" campaign_id="{{ campaign_id }}" member_item="true">' +
							'<div class="teamListItemBoxNewInside">'+
								'<div class="teamListItemBoxNew">'+

									'<div class="kickTime">'+
										'<div class="kickoutStatus {{ kickout_class }}"></div>' +
										'<div teamTime class="teamTime" style="{{ show_state_time }}"> {{ state_time }} </div>' +
									'</div>'+

									'<div class="avatarStatusIndicator">'+								
										'<div class="memberAvatarContainer" style="{{ show_avatars }}">' +
											'<img src="{{ avatar_uri }}" class="memberAvatar"/> ' +	
										'</div> ' +
										'<div memberStatusIndicator style="{{ show_state_visual_indicator }}" class="memberStatusContainer">' +
											'<img src="/inconcert/apps/agent/images/blank.png" class="memberStatus {{ status_class }}"/>' +
										'</div>' +
									'</div>'+

									'<label teamName class="teamName" style="{{ show_agent_name }}">{{ agent_name }}</label>' +							

									'<label teamNameId class="teamNameId" style="{{ show_agent_id }}">{{ agent_id }}</label>' +

									'<label teamStateName class="teamStateName" style="{{ show_state_name }}">{{ state_name }}</label>' +
									
									'<label teamWorkgroup class="teamWorkgroup" style="{{ show_workgroups }}" >{{ workgroup }}</label>' +			

									'<label teamTotalNumInteractions class="teamTotalNumInteractions"  style="{{ show_total_conversations }}"><%=_T([[Interactions]])%>: {{ total_conversations }}</label>' +

									'<label class="teamAttentionLevel" attention_level_id hidden></label>' +

									'<div member_channels_interactions="true" class="memberInteractionsContainer" style="{{ show_total_conversations_by_channel }}">' +
									// Ejemplo del markup que se genera en "DashboardMembers.__update_member_channels"
										// '<label class="memberInteractions busyChannel CHAT"><span>4</span>/99</label>' +
										// '<label class="memberInteractions availableChannel MAIL">57</label>' +
									'</div>' +

									'<div member_missing_skills="true" class="memberMissingSkills">'+
										'<i class="fa fa-star-exclamation" title=""></i>' +
									'</div>'+

								'</div>'+

							'</div>' +

						'</li>',

						group_summary_tpl :
						'<div id="sup_dash_group_summary_{{ full_group_id }}" class="summaryFieldset" simple_group_id="{{ simple_group_id }}">' +
							'<div class="summaryFieldsetTitleBefore">{{ group_name }}</div>'+
							'<div class="summaryFieldsetTitle">' +
								'<input summaryGroupCheck="true" id="sup_dash_summary_group_option_{{ full_group_id }}" class="summaryGroupCheck" type="checkbox" {{ #checked }}checked="true"{{ /checked }} style="display:none"/>' +
								'<label for="sup_dash_summary_group_option_{{ full_group_id }}" class="fieldsetTitleText"><%=_T([[Show all]])%></label>' +
							'</div>'+
						'</div>',

						row_summary_tpl :
							'<div id="sup_dash_summary_indicator_{{ id }}" class="summaryFieldsetRow">' +
								'<div>' +
									'<input indicatorRowCheck="true" id="sup_dash_summary_row_option_{{ id }}" class="summaryRowCheck" type="checkbox" checked="true" style="display:none"/>' +
									'<label for="sup_dash_summary_row_option_{{ id }}" class="summaryName">{{ row_name }}</label>' +
								'</div> ' +
								'<label class="summaryNumber">' +
									'<span class="summaryNumberTotal">{{ row_value }}</span>' +
								'</label>' +
							'</div>',

						group_interactions_node_tpl: '<div group_interaction_id="{{ group_interaction_id }}" class="asociatedInteractionsGroup" node_type="group_interactions"></div>',

						popup_attention_level_item :
							'<li class="attentionLevelListItem" attention_level_item_type="al">' +
								'<input id="sup_dash_attention_level_selector_item_{{ normalized_id }}" class="attentionLevelRowRadio" name="sup_dash_attention_level_selector_item_{{ normalized_account_id }}" attention_level_id="{{ attention_level_id }}" attention_level_name="{{ attention_level_name }}" campaign_id="{{ campaign_id }}" account_id="{{ account_id }}" attention_level_selector="true" type="radio" />' +
								'<label for="sup_dash_attention_level_selector_item_{{ normalized_id }}" class="attentionLevelRowName">{{ attention_level_name }}</label>' +
							'</li>',

						popup_account_item :
							'<li class="accountListItem" account_item_type="account">' +
								'<input id="sup_dash_account_selector_item_{{ id }}" account_id="{{ account_id }}" account_name="{{ account_name }}" channel="{{ channel }}" class="accountRowRadio" campaign_id="{{ campaign_id }}" account_selector="true" type="radio" />' +
								'<label for="sup_dash_account_selector_item_{{ id }}" class="accountRowName"><span>{{ account_desc }}</span></label>' +
								'<ul attention_levels_list="true" account_id="{{ account_id }}" class="attentionLevelArea" style="display:none;"></ul>' +
							'</li>',

						popup_header_campaign_accounts_item :
							'<li class="accountListItem" account_item_type="header">' +
								'<input id="sup_dash_header_campaign_accounts_selector_item_{{ id }}" class="accountRowRadio" campaign_id="{{ campaign_id }}" account_selector="true" type="radio" />' +
								'<label for="sup_dash_header_campaign_accounts_selector_item_{{ id }}" class="accountRowName accountRowAll">{{ header_title }}</label>' +
							'</li>',

						popup_campaign_item :
							'<li selector_campaign_id="{{ campaign_id }}" class="campaignListItem">' +
								'<div class="campaignRowName">' +
									'<i class="far fa-bullhorn"></i>' +
									'<label for="sup_dash_campaign_selector_item_{{ id }}" class="summaryName">{{ campaign_name }}</label>' +
									'<input id="sup_dash_campaign_selector_item_{{ id }}" campaign_id="{{ campaign_id }}" class="summaryRowCheck campaignRowCheck" {{ #checked }}checked="true"{{ /checked }} type="checkbox"/>' +
								'</div>' +
							'</li>',

						popup_campaigns_accounts_container :
							'<h3><%=_T("Select options")%></h3>'+
							'<div class="campaignListItem">' +
								'<ul accounts_list="true" class="accountArea"></ul>' +
							'</div>',

						popup_campaigns :
							'<div id="sup_dash_campaign_selector_popup" class="campaignPopup" style="display:none">' +
								'<div class="card-block">' +
									'<ul id="sup_dash_campaign_selector_list" class="campaignArea"></ul>' +
								'</div>' +
								'<div class="internalPopUpButtons d-flex justify-content-end">' +
									'<input id="sup_dash_campaign_selector_ok" type="button" class="pageButtonGeneric buttonColorBlue" value="{{ ok_message }}"/>' +
								'</div>' +
							'</div>',

						full_screen_indicator_chart_tpl :
							'<div id="sup_dash_full_screen_indicators_{{ id }}" class="trendContainer">' +
								'<div id="sup_dash_full_screen_indicators_container_{{ id }}" class="trendChartContainer"></div>' +
							'</div>',

						indicator_chart_tpl:
							'<div id="sup_dash_indicators_{{ id }}" class="trendContainer">' +
								'<input id="sup_dash_indicators_option_{{ id }}" class="chartOptionCheck" type="checkbox" checked="true" style="display:none"/>' +
								'<div id="sup_dash_indicators_container_{{ id }}" class="trendChartContainer"></div>' +
							'</div>',

						full_screen_indicator_chart_legend :
							'<div id="sup_dash_full_screen_indicators_legend_item_{{channel}}" class="legendItem legend{{ channel }}">' +
								'<i class="legendIcon" title="{{ name }}"></i>' +
								'<label class="legendName" title="{{ name }}">{{ name }}</label>' +
							'</div>',

						indicator_chart_legend :
							'<div id="sup_dash_indicators_legend_item_{{ campaign_id}}_{{channel}}" class="legendItem legend{{ channel }}">' +
								'<i class="legendIcon" title="{{ name }}"></i>' +
								'<label class="legendName" title="{{ name }}">{{ name }}</label>' +
							'</div>',

						indicator_slice_configuration_tpl :
							'<div id="sup_dash_indicators_slice_{{ id }}" class="card-block px-2">' +
								'<div class="row">' +
									'<div class="col-12 col-formcontrol">' +
										'<div class="row">' +
											'<div class="col-6">' +
												'<div class="form-group">' +
													// Slice
													'<label>{{ slice.label }}{{ two_points }}</label>' +
													'<select class="form-control" id="sup_dash_indicators_slice_select_{{ id }}">' +
														'<option value="15Min">{{ slice.data.15_min }}</option>'+
														'<option value="30Min">{{ slice.data.30_min }}</option>'+
														'<option value="Hour">{{ slice.data.1_hour }}</option>'+
														'<option value="Day">{{ slice.data.1_day }}</option>'+
													'</select>'+
												'</div>'+
											'</div>'+
											'<div class="col-6">' +
												'<div class="form-group">' +
													// Time Ago
													'<label>{{ time_ago.label }}{{ two_points }}</label>' +
													'<select class="form-control" id="sup_dash_indicators_time_ago_select_{{ id }}">' +
														'<option value="2Hour">{{ time_ago.data.2_hours }}</option>'+
														'<option value="4Hour">{{ time_ago.data.4_hours }}</option>'+
														'<option value="8Hour">{{ time_ago.data.8_hours }}</option>'+
														'<option value="Week">{{ time_ago.data.1_week }}</option>'+
													'</select>'+
												'</div>'+
											'</div>'+
										'</div>'+
									'</div>'+
								'</div>'+
							'</div>',

						indicator_no_data_tpl :
							'<div class="trendChartMessageContainer">' +
								'<label class="trendChartMessage">{{ message }}</label>' +
							'</div>',

						agent_statuses_list_tpl :
							'<label class="statusListTitle">{{ title }}</label>' +
							'<ul class="statusList">' +
								'{{#list}} ' +
									'<li status="{{ status_id }}" class="statusItem {{ status_class }}">'+
										'<img src="/inconcert/apps/agent/images/blank.png" class="statusList {{ status_class }}"/> ' +
										'<label class="statusItemText" >{{ status_name }}</label> ' +
									'</li>' +
								'{{/list}} ' +
							'</ul>',

						no_interactions_msg : '<div id="sup_dash_campaign_{{ normalized_id }}_views_no_interactions_msg" class="boxContentListMessages">{{ message }}</div>',

						chart_serie_selector_tpl :
							'<div class="serieItem serie{{ serie }}">' +
								'<input serie_id="{{ serie }}" id="sup_dash_indicators_serie_option_{{ campaign_id }}_{{ serie }}" class="showLegendOption" type="checkbox" checked="true"/>' +
			//					'<img src="/inconcert/apps/agent/images/blank.png" class="serieColor"/>' +
								'<label for="sup_dash_indicators_serie_option_{{ campaign_id }}_{{ serie }}" class="chartSerieLabel">{{ label }}</label>' +
							'</div>',

						campaign_detail_account_tpl : __campaign_detail_account_tpl,

						// TO-DO: Partir esto en mas templates
						campaign_panel_tpl :
						// START CAMPAIGN NODE
							'<div id="sup_dash_campaign_{{ normalized_id }}" campaign_id="{{ campaign_id }}" class="col-4 col-sm-12 col-md-6 pr-md-0 supervisorPanelContainer threePanels">' +
								// TITLE
								'<div class="container-fluid">' +
									'<div class="row">' +
										'<div id="sup_dash_campaign_title_{{ normalized_id }}" class="col-12 panelTitle normal_panelTitle" campaign_title="true" campaign_box_title>' +
											'<button id="sup_dash_back_dashboard_{{ normalized_id }}" tooltip="{{ back_tooltip }}" class="butBackToDashboardArrow btnDropdownStates" type="button" style="display:none"><i class="fas fa-chevron-left"></i></button>' +
											'<label id="sup_dash_panel_name_{{ normalized_id }}" class="campaignName"></label>' +
											'<label id="sup_dash_panel_child_{{ normalized_id }}" class="campaignChild"></label>'+
											'<div header_buttons="true" class="panelOptions">' +
												// Botones visibles en Modo Simple Screen (SIMPLE_SCREEN or BOTH)
												'<div class="campaignActionsContainer">' +
													'<div cLass="mLeftAuto d-flex">' +
														'<button id="sup_dash_panel_campaign_bots_filter_{{ normalized_id }}" class="butPanelMenu butPanelMenuText" type="button" style="display:none;"></button>'+
														'<button campaign_accounts_btn id="sup_dash_panel_campaign_accounts_{{ normalized_id }}" class="butPanelAccounts" type="button"><i class="far fa-sliders-h"></i><span><%=_T([[Filter_2]])%></span></button>'+
														'<button id="sup_dash_panel_detail_{{ normalized_id }}" tooltip="{{ detail_tooltip }}" class="butCampaignDetail" type="button"><i class="far fa-info-circle"></i></button>' +
														'<button id="sup_dash_panel_menu_{{ normalized_id }}" campaign_id="{{ campaign_id }}" tooltip="{{ menu_tooltip }}" class="butPanelMenu butPanelMenuText" type="button"><i class="far fa-bars"></i><%=_T([[Menu]])%></button>' +
														'<button id="sup_dash_panel_menu_config_view_{{ normalized_id }}" campaign_id="{{ campaign_id }}" tooltip="{{ menu_config_view_tooltip }}" class="butPanelMenu" type="button"><i class="far fa-cog"></i></button>' +
													'</div>' +
												'</div>' +
												'<div class="genericActionsContainer">' +
													'<button id="sup_dash_panel_show_full_screen_{{ normalized_id }}" tooltip="{{ full_screen_tooltip }}" class="butPanelShowFullScreen" type="button"><i class="far fa-expand"></i></button>' +
												'</div>' +
												// Botones visibles en Modo Vista de Conversaciones
												'<button id="sup_dash_back_dashboard_{{ normalized_id }}" tooltip="{{ back_tooltip }}" class="butBackToDashboard" type="button" style="display:none"><i class="buttons-icons-arrow-back"></i>{{ back }}</button>' +
												'</div>' +
										'</div>' + // END TITLE
					
										// MENU TOOLBAR OPTIONS
										'<div class="col-12">' +
											'<div class="campaignDetailContainer">' +
												// CAMPAIGN DETAIL
												'<div id="sup_dash_panel_detail_container_{{ normalized_id }}" class="campaignDetail" style="display:none">' +
													'<div class="row campaignDetailData">' +
														'<div class="col-12 campaignDetailDataInfo">' +
															// VALID UNTIL
															'<label class="campaignDetailLabel">{{ valid_until_label }}{{ two_points }} </label>' +
															'<label id="sup_dash_detail_valid_until_{{ normalized_id }}" class="campaignDetailInfo">{{ valid_until }}</label>' +
															'|' +
															// SCHEDULE
															'<label class="campaignDetailLabel">{{ schedule_label }}{{ two_points }} </label>' +
															'<label class="campaignDetailInfo">{{ ^on_schedule }}<%=_T([[NO]])%>{{ /on_schedule }}{{ #on_schedule }}<%=_T([[YES]])%>{{ /on_schedule }}</label>' +
			//												'<i id="sup_dash_detail_schedule_{{ normalized_id }}" class=""></i>' +
															'|' +
															// TIMEZONE
															'<label class="campaignDetailLabel">{{ timezone_label }}{{ two_points }}</label>' +
															'<label id="sup_dash_detail_timezone_{{ normalized_id }}" class="campaignDetailInfo">{{ timezone }}</label>' +
														'</div>' +
													'</div>' +
													// WORKGROUP
													'<div class="row campaignDetailData">' +
														'<div class="col-12 campaignDetailDataInfo">' +
															'{{ #workgroups }}' +
																'<label class="campaignDetailLabel">{{ workgroups_label }}{{ two_points }}</label>' +
																'<label id="sup_dash_detail_workgroups_{{ normalized_id }}" class="campaignDetailInfo">{{ workgroups_names }}</label>' +
															'{{ /workgroups }}' +
														'</div>' +
													'</div>' +
													// ACCOUNTS
													'<div class="campaignDetailDataAccountsTitle">' +
														'<div class="campaignDetailDataAccountsTitleType">Tipo</div>'+
														'<div class="campaignDetailDataAccountsTitleName">Nombre</div>'+
														'<div class="campaignDetailDataAccountsTitleDist">Distribución</div>'+
														'<div class="campaignDetailDataAccountsTitleStatus">Estado</div>'+
														'<div class="campaignDetailDataAccountsTitleLevels">Niveles de atención</div>'+
													'</div>' +
													'<div class="boxScroll">' +
														'{{ #accounts }}' + __campaign_detail_account_tpl + '{{ /accounts }}' +
													'</div>' +
												'</div>' + // END CAMPAIGN DETAIL
											'</div>' + 
											// View Panel Options
											'<div panelOptionsNavegation class="panelOptionsContainer" style="display:none">' +
												'<ul class="panelOptionsList dropdownLikeNavigation">' +
													'<li class="panelOptionItem panelOptionItemWithImage iconDashboard">' +
														'<label id="sup_dash_show_main_dashboard_{{ normalized_id }}" option_type="main_dashboard" class="closePanel">{{ show_main_dashboard }}</label>' +
													'</li>' +
													'<li class="panelOptionItem panelOptionItemWithImage iconInteractions">' +
														'<label view_id="interactions" id="sup_dash_show_view_conversations_{{ normalized_id }}" option_type="view" class="closePanel">{{ show_all_interactions }}</label>' +
													'</li>' +
													'<li class="panelOptionItem panelOptionItemWithImage iconGlobalSearch">' +
														'<label view_id="global_search" id="sup_dash_show_view_global_search_{{ normalized_id }}" option_type="view" class="closePanel">{{ show_global_search }}</label>' +
													'</li>' +
													'<li class="panelOptionItem panelOptionItemWithImage iconBots">' +
														'<label id="sup_dash_show_bots_{{ normalized_id }}" option_type="bots" class="closePanel"></i> {{ show_main_bots }}</label>' +
													'</li>' +
													'<li class="panelOptionItem panelOptionItemWithImage iconAlarms">' +
														'<label id="sup_dash_show_alarm_config_{{ normalized_id }}" option_type="alarms_config" class="closePanel">{{ show_alarm_management }}</label>' +
													'</li>' +
													'<li class="panelOptionItem panelOptionItemWithImage iconMembers">' +
														'<label id="sup_dash_show_update_members_{{ normalized_id }}" option_type="update_members" class="closePanel">{{ show_agent_configuration }}</label>' +
													'</li>' +
												'</ul>' +
											'</div>' + // END View Panel Options
											// PANEL OPTIONS
											'<div panelOptionsConfigView class="panelOptionsContainer panelViewsConfig" id="panelViewsConfig" style="display:none">' +
												'<h4><%=_T("Panel display")%></h4>'+
												'<ul class="panelOptionsList">' +
													'<li class="panelOptionItem">' +
														'<label for="sup_dash_show_view_summary_{{ normalized_id }}" class="panelOptionText">{{ summary }}</label>' +
														'<input id="sup_dash_show_view_summary_{{ normalized_id }}" option_type="panel" panel_option_id="summary" class="panelOptionCheck" type="checkbox" checked="true"/>' +
													'</li>' +
													'<li class="panelOptionItem">' +
													'<label for="sup_dash_show_view_indicators_{{ normalized_id }}" class="panelOptionText">{{ indicators }}</label>' +
														'<input id="sup_dash_show_view_indicators_{{ normalized_id }}" option_type="panel" panel_option_id="indicators" class="panelOptionCheck" type="checkbox" checked="true"/>' +
													'</li>' +
													'<li class="panelOptionItem">' +
													'<label for="sup_dash_show_view_members_{{ normalized_id }}" class="panelOptionText">{{ team }}</label>' +
														'<input id="sup_dash_show_view_members_{{ normalized_id }}" option_type="panel" panel_option_id="members" class="panelOptionCheck" type="checkbox" checked="true"/>' +
													'</li>' +
													'<h4><%=_T("Disposition")%></h4>' +
													'<li id="sup_dash_show_main_dashboard_layout_{{ normalized_id }}" class="panelOptionItem panelOptionItemViews">' +
														'<span><input option_type="layout" class="row2-radio" value="layout3" type="radio" /></span>' +
														'<span><input option_type="layout" class="row2-radio" value="layout2" type="radio" /></span>' +
														'<span><input option_type="layout" class="row2-radio" value="layout1" type="radio" /></span>' +
													'</li>' +
												'</ul>' +
											'</div>' + // END PANEL OPTIONS
										'</div>' + // END MENU TOOLBAR OPTIONS

										// BODY - interactions
										'<div id="sup_dash_interaction_viewer_{{ normalized_id }}" viewer_type="interactions" class="panelBody interactionsViewer col-12 px-0" style="display:none">' +
					
											'<div id="iFramesWindowsDailogsContainerForSuperviorAppCampaign_{{ normalized_id }}" class="supervisorIframeContainer"></div>' +
											// NAVIGATION - (FOLDERS & LABELS)
											'<div id="sup_dash_interaction_viewer_navigation_{{ normalized_id }}" class="supervisionContentInteractionsMenu genericInteractionsListMenu">' +
												'<ul folders="true" class="interactionNavigationFolders"></ul>' +
											'</div>' +
					
											// INTERACCIONES DINAMICAS - (MONITORING, ARCHIVE, QUEUED, WAITING)
											'<div id="sup_dash_interaction_viewer_dynamic_{{ normalized_id }}" class="panelBodyColumnAux panelBodyColumnInteractionList">' +
												//QUERYBUILDER
												'<div class="interactionQueryBuilderContainer card" style="display: none;">' +
													'<div class="card-header">' +
														'<h5>' + '<%=_T("Filter")%>' + '</h5>' +
														'<button query_builder_close_times=true class="filterCloseBtn"><i class="far fa-times"></i></button>' +
													'</div>' +
													'<div class="card-body">' +
														'<div query_builder=true class="query-builder"></div>' +
													'</div>' +
													'<div class="card-footer">' +
														'<div class="btn-group d-flex justify-content-end">' +
															'<button query_builder_clean=true class="queryBuilderFooterBtn pageButtonGeneric buttonColorWhite" data-target="basic">' + '<%=_T("Clean")%>' + '</button>' +
															'<button query_builder_refresh=true id="query_builder_refresh" class="queryBuilderFooterBtn pageButtonGeneric buttonColorWhite ml-1 parse-json" data-target="basic">' + '<%=_T("Apply")%>' + '</button>' +
														'</div>' +
													'</div>' +
												'</div>' +
												'<div class="panelBodyColumn interaction" style="left:250px;">' +
													'<div class="boxContentListWaiting" style="display:none">' +
														'<div class="listWaitingMessage"></div>' +
														'<div class="listWaitingOverlay"></div>' +
													'</div>' +
													// FILTER
													'<div class="boxContentTitleArea querySearchContainer">'+
														'<div class="boxContentFilterArea boxContentGlobalFilterArea">'+
															'<h5 id="sup_dash_panel_interaction_title_{{ normalized_id }}"></h5>' +
															'<div filter_search="true" class="assignedInteractionSearch">'+
																'<div class="card-outlined-internal form-group-pill-card-outlined flex-grow-1">'+
																	// '<div class="inlineMessagesContainer messageInfo" style="display: none;"><label>' + '<%=_T("Click to start filtering.")%>' + '</label></div>'+
																	'<div class="form-group-pill-container" style=""></div>'+
																'</div>	'+
															'</div>'+
															'<button query_builder_close_times=true class="butFormSearch buttonColorLightOrange" type="button" title=' + '<%=_T("Filter")%>' + '><i class=" fas fa-sliders-h"></i><span><%=_T("Filter")%></span></button>' +
														'</div>'+
													'</div>'+
													// WAITING
													'<div id="sup_dash_interactions_waiting_{{ normalized_id }}" class="columnWaiting" style="display:none">' +
														'<div class="columnWaitingAnimation"></div>' +
														'<div class="columnWaitingOverlay"></div>' +
														'<div id="sup_dash_interactions_waiting_msg_{{ normalized_id }}" class="supervisorWaitingMessage"></div>' +
													'</div>' +
													// TABLE HEADER
													'<div interactions_table_headers="true" class="boxContenTableHeaderArea">' +
														'<div class="boxContenTableHeaderAreaAux">' +
															'<div class="interactionListColumn interactionColumnTitle columnBatch">' +
																'<input batch_actions_mark_all="true" tooltip="' + m_translated.select_all_conversations + '" class="selectAllTriggerCheck ml-0" type="checkbox" />' +
															'</div>' +
															'<div class="interactionListColumn interactionColumnTitle columnType">' +
																'<div class="interactionColumnTitleText">' + m_translated.type + '</div>' +
															'</div>' +
															'<div class="interactionListColumn interactionColumnTitle columnState">' +
																'<div class="interactionColumnTitleText">' + m_translated.state + '</div>' +
															'</div>' +
															'<div class="interactionListColumn interactionColumnTitle columnName">' +
																'<div class="interactionColumnTitleText">' + m_translated.name + '</div>' +
															'</div>' +
															'<div class="interactionListColumn interactionColumnTitle columnContactAddress">' +
																'<div class="interactionColumnTitleText">' + m_translated.contact_address + '</div>' +
															'</div>' +
					
															'<div class="interactionListColumn interactionColumnTitle columnContactId" style="display:none;">' +
																'<div class="interactionColumnTitleText">' + m_translated.contact_id + '</div>' +
															'</div>' +
															'<div class="interactionListColumn interactionColumnTitle columnCampaign" style="display:none;">' +
																'<div class="interactionColumnTitleText">' + m_translated.campaign + '</div>' +
															'</div>' +
															'<div class="interactionListColumn interactionColumnTitle columnAccount">' +
																'<div class="interactionColumnTitleText">' + m_translated.account + '</div>' +
															'</div>' +
															'<div header_column_name="attention_time" class="interactionListColumn interactionColumnTitle columnAttentionTime" style="display:none;">' +
																'<div class="interactionColumnTitleText">' + m_translated.duration + '</div>' +
															'</div>' +
															'<div class="interactionListColumn interactionColumnTitle columnOwner">' +
																'<div class="interactionColumnTitleText">' + m_translated.owner + '</div>' +
															'</div>' +
															'<div class="interactionListColumn interactionColumnTitle columnNumber">' +
																'<i class="interactionColumnTitleIco"></i>'+
															'</div>' +
															'<div header_column_name="events_unanswered" class="interactionListColumn interactionColumnTitle columnNumber">' +
															'<div class="interactionColumnTitleIco"></div>' +
															'</div>' +
															'<div class="interactionListColumn interactionColumnTitle columnAbstract">' +
																'<div class="interactionColumnTitleText">' + m_translated.content + '</div>' +
															'</div>' +
															'<div class="interactionListColumn interactionColumnTitle columnDate">' +
																'<div class="interactionColumnTitleText">' + m_translated.creation_date + '</div>' +
															'</div>' +
															'<div class="interactionListColumn interactionColumnTitle columnDate">' +
																'<div class="interactionColumnTitleText">' + m_translated.state_date + '</div>' +
															'</div>' +
															'<div class="interactionListColumn interactionColumnTitle columnComments" title="' + '<%=_T("Comments")%>' + '">' +
																'<i class="interactionColumnTitleIco"></i>' +
															'</div>' +
															'<div class="interactionListColumn interactionColumnTitle columnActions">' +
																'<i class="interactionColumnTitleIco"></i>' +
															'</div>' +
														'</div>' +
													'</div>' +
					
													// CONTENT
													'<div id="sup_dash_static_interactions_container_{{ normalized_id }}" class="columnContentAux">' + 
														'<div id="sup_dash_interaction_viewer_container_{{ normalized_id }}" class="columnContent forDetach"></div>' +
													'</div>' +
					
													'<div batch_actions_container="true" class="boxContentOptionsArea" {{ hidden_batch_actions }} style="display: none;" >' +
														'<label class="transfer_conversations_selected">'+
															'<span batch_actions_container_number="true" class="circleNum"></span>'+
															'<span><%=_T([[Selected item/s]])%></span>'+
														'</label>' +
														'<button batch_action_id="TRANSFER" tooltip="' + m_translated.transfer_conversations + '" class="butBatchTransfer btnDropDownButton ml-auto" disabled="true">' + m_translated.transfer + '<i class="far fa-angle-down"></i></button>' +
													'</div>' +
					
													'<div class="interactionListPager" id="interactions_list_pager_{{ normalized_id }}">' +
														'<div class="listPager">' +
															'<div class="pagerButtonsContainer">' +
																'<button id="interactions_page_first_{{ normalized_id }}" class="pg-button butPagerFirst"></button>' +
																'<button id="interactions_page_prev_{{ normalized_id }}"  class="pg-button butPagerPrev" ></button>' +
																'<button id="interactions_page_next_{{ normalized_id }}"  class="pg-button butPagerNext" ></button>' +
																'<button id="interactions_page_last_{{ normalized_id }}"  class="pg-button butPagerLast" ></button>' +
															'</div>' +
															'<div class="pagerTextsContainer">' +
																'<label id="interactions_page_text_{{ normalized_id }}" class="pagerText"></label>' +
																'<label class="pagerDisclaimer">' + m_translated.paginated_message + '</label>' +
															'</div>' +
														'</div>' +
													'</div>' +
												'</div>' +
											'</div>' +
					
											// INTERACCIONES ESTATICAS - (GLOBAL SEARCH)
												'<div id="sup_dash_interaction_viewer_static_container_{{ normalized_id }}" class="w-100">' +
													'<div id="sup_dash_interaction_viewer_static_{{ normalized_id }}" class="panelBodyColumnAux supervisorGlobalSearch" >GLOBAL SEARCH!!</div>' +
													'<div class="supervisorIframeContainer">' +
													'</div>' +
													//QUERYBUILDER
													'<div class="interactionQueryBuilderContainer card" style="display: none;">' +
														'<div class="card-header">' +
															'<h5>' + '<%=_T("Filter")%>' + '</h5>' +
															'<button query_builder_close_times=true class="filterCloseBtn"><i class="far fa-times"></i></button>' +
														'</div>' +
														'<div class="card-body">' +
															'<div query_builder=true class="query-builder"></div>' +
														'</div>' +
														'<div class="card-footer">' +
															'<div class="btn-group d-flex justify-content-end">' +
																'<button query_builder_clean=true class="queryBuilderFooterBtn pageButtonGeneric buttonColorWhite" data-target="basic">' + '<%=_T("Clean")%>' + '</button>' +
																'<button query_builder_refresh=true id="query_builder_refresh" class="queryBuilderFooterBtn pageButtonGeneric buttonColorWhite ml-1 parse-json" data-target="basic">' + '<%=_T("Apply")%>' + '</button>' +
															'</div>' +
														'</div>' +
													'</div>' +
												'</div>' +

											'</div>' +
								// BODY - operation
											'<div id="sup_dash_operations_viewer_{{ normalized_id }}" viewer_type="operations" class="col-12 panelBody operationViewer">' +
											// BROADCAST
											'<div class="broadcastPopup" style="display:none">' +
											'<div class="card no-card">' +
												'<div class="card-block">' +
												'<label class="broadcastTitle">{{ broadcast_message }}</label>' +
													'<div class="row">' +
														'<div class="col-12">' +
															'<div class="form-group">' +
																'<textarea class="form-control broadcastArea" placeholder="<%=_T([[Write a message]])%>..."></textarea>' +
															'</div>' +
														'</div>' +
													'</div>' +
												'</div>' +
											'</div>' +
											'<div class="internalPopUpButtons d-flex justify-content-end">' +
											'<input class="butBroadcastCancel pageButtonGeneric buttonColorWhite float-right" type="button" value="{{ broadcast_cancel }}"/>' +
											'<input class="butBroadcastSend pageButtonGeneric buttonColorBlue float-right" type="button" value="{{ broadcast_send }}"/>' +
											'</div>' +
										'</div>' +
									// ROW COLUMNs
									'<div class="row h-100">' +
										'<div panel_id="sup_dash_summary_panel" id="sup_dash_summary_panel_{{ normalized_id }}" class="col panelBodyColumnAux">' +
											'<div class="panelBodyColumn summary">' +
												// TITLE
												'<div class="columnTitle">' +
													'<label class="columnTitleText">{{ summary }}</label>' +
													'<button id="sup_dash_column_edit_summary_{{ normalized_id }}" class="butColumnEdit beforeIconVerticalDots btnStates" title="{{ configview_tooltip }}" type="button"><i></i></button>' +
													// SUMMARY COLUMN OPTIONS
													'<div class="columnOptionsContainer" style="display:none">' +
														'<ul class="columnOptionsList"></ul>' +
													'</div>' +
												'</div>' +
												// WAITING
												'<div class="columnWaiting" style="display:none">' +
													'<div class="columnWaitingAnimation"></div>' +
													'<div class="columnWaitingOverlay"></div>' +
												'</div>' +
												// CONTENT
												'<div class="columnContentAux">' +
													'<div class="columnContent forDetach">' +
														'<div class="card-block px-2 pt-1 sliceConfiguration" style="display:none">' +
															'<div class="row w-100 mx-0">' +
																'<div class="col-12 p-0">' +
																	'<div class="form-group mb-1">' +
																		'<label>{{ time_ago.label }}{{ two_points }}</label>' +
																		'<select id="sup_dash_summary_time_ago_select_{{ normalized_id }}" class="form-control">' +
																			'<option value="Last15Minutes">{{ time_ago.data.Last15Minutes }}</option>' +
																			'<option value="LastHour">{{ time_ago.data.LastHour }}</option>' +
																			'<option value="Daily">{{ time_ago.data.Daily }}</option>' +
																		'</select>' +
																	'</div>' +
																'</div>' +
															'</div>' +
														'</div>' +
													'</div>' +
												'</div>' +
											'</div>' +
										'</div>' +
				
										// COLUMN / INDICATORS
										'<div panel_id="sup_dash_indicators_panel" id="sup_dash_indicators_panel_{{ normalized_id }}" class="col panelBodyColumnAux">' +
											'<div class="panelBodyColumn indicators">' +
												'<div class="columnTitle">' +
													'<label class="columnTitleText">{{ indicators }}</label>' +
													'<button id="sup_dash_column_edit_indicators_{{ normalized_id }}" class="butColumnEdit beforeIconVerticalDots btnStates" title="{{ configview_tooltip }}" type="button"><i></i></button>' +
												'</div>' +
												// WAITING
												'<div class="columnWaiting" style="display:none">' +
													'<div class="columnWaitingAnimation"></div>' +
													'<div class="columnWaitingOverlay"></div>' +
												'</div>' +
												// CONTENT
												'<div class="columnContent">'+
													'<div id="sup_dash_indicators_series_{{ normalized_id }}" class="seriesConfiguration" style="display:none"></div>' +
												'</div>' +
												'<div id="sup_dash_indicators_legend_{{ normalized_id }}" class="chartsLegendContainer" style="display:none"></div>' +
											'</div>' +
										'</div>' +
				
										// COLUMN / MEMBERS
										'<div panel_id="sup_dash_members_panel" id="sup_dash_members_panel_{{ normalized_id }}" class="col panelBodyColumnAux team hideFilter">' +
											'<div class="panelBodyColumn">' +
												'<div class="columnTitle panelColumnLineTitle">' +
													'<label class="columnTitleText">{{ team }}</label>' +
													'<div>' +
														'<button id="sup_dash_members_broadcast_{{ normalized_id }}" class="butColumnBroadcast btnStates" title="{{ broadcast_message }}" type="button"><i class="far fa-broadcast-tower"></i></button>' +
														'<button id="sup_dash_members_panel_switch_colapse_mode_{{ normalized_id }}" title="{{ filter_tooltip }}" class="butColumnFilter btnStates" type="button"><i class="far fa-sliders-h"></i></button>' +
														'<button id="sup_dash_column_edit_members_{{ normalized_id }}" class="butColumnEdit beforeIconVerticalDots btnStates" title="{{ configview_tooltip }}" type="button"><i></i></button>' +
														// MEMBERS COLUMN OPTIONS
														'<div id="sup_dash_members_options_container" class="columnOptionsContainer optionsViewAgents" style="display:none">' +
															
															'<ul class="columnOptionsList">' +
																'<li>' +
																	'<div class="custom-control">' +
																		'<h4><%=_T("Set view")%></h4>' +
																	'</div>' +
																'</li>' +
																'<li class="columnListSep pt-0">' +
																	'<div class="custom-control">' +
																		'<div class="form-check form-switch form-switch-right">'+
																			'<label for="sup_dash_show_offline_members_{{ normalized_id }}" class="columnOptionText">'+
																				'<input action_show_option id="sup_dash_show_offline_members_{{ normalized_id }}" class="form-check-input" type="checkbox"/>' +
																				'<span></span>'+
																				'{{ show_offline_agents }}'+
																			'</label>' +																		
																		'</div>'+																	
																	'</div>'+
																	'<div class="custom-control">' +
																		'<div class="form-check form-switch form-switch-right">'+
																			'<label for="sup_dash_show_kickouts_{{ normalized_id }}" class="columnOptionText">'+
																				'<input action_show_option id="sup_dash_show_kickouts_{{ normalized_id }}" class="form-check-input" type="checkbox"/>' +
																				'<span></span>'+
																				'{{ show_kickouts }}'+
																			'</label>' +																		
																		'</div>'+
																	'</div>' +
																'</li>' +
																'<li class="columnListSep lineTop">' +
																	'<div class="custom-control columnListSepTitle">' +
																		'<label class="columnOptionText"><%=_T("List options")%></label>' + 
																	'</div>' +
																	'<div class="custom-control">' +
																		'<label for="sup_dash_show_all_{{ normalized_id }}" class="columnOptionText"><%=_T("Show all")%></label>' +
																		'<input action_show_option id="sup_dash_show_all_{{ normalized_id }}" class="columnOptionCheck" type="checkbox"/>' +
																	'</div>' +
																'</li>' +
																'<li class="columnListSep">' +
																	'<div class="custom-control columnListSepTitle">' +
																		'<label class="columnOptionText"><%=_T("Identify with")%></label>' + 
																	'</div>' +
																	'<div class="custom-control">' +
																		'<label for="sup_dash_show_names_members_{{ normalized_id }}" class="columnOptionText">{{ show_names }}</label>' +
																		'<input action_show_option action_option_all id="sup_dash_show_names_members_{{ normalized_id }}" class="columnOptionCheck" type="checkbox" />' +
																	'</div>' +
																	'<div class="custom-control">' +
																		'<label for="sup_dash_show_id_members_{{ normalized_id }}" class="columnOptionText">{{ show_id }}</label>' +
																		'<input action_show_option action_option_all id="sup_dash_show_id_members_{{ normalized_id }}" class="columnOptionCheck" type="checkbox"/>' +
																	'</div>' +
																	'<div class="custom-control">' +
																		'<label for="sup_dash_show_avatars_members_option_{{ normalized_id }}" class="columnOptionText">{{ show_avatars }}</label>' +
																		'<input action_show_option action_option_all id="sup_dash_show_avatars_members_option_{{ normalized_id }}" class="columnOptionCheck" type="checkbox"/>' +
																	'</div>' +
																'</li>' +
																'<li class="columnListSep">' +
																	'<div class="custom-control columnListSepTitle">' +
																		'<label class="columnOptionText"><%=_T("State")%></label>' +
																	'</div>' +
																	'<div class="custom-control">' +
																		'<label for="sup_dash_show_state_visual_indicator_members_option_{{ normalized_id }}" class="columnOptionText">{{ show_state_visual_indicator }}</label>' +
																		'<input action_show_option action_option_all id="sup_dash_show_state_visual_indicator_members_option_{{ normalized_id }}" class="columnOptionCheck" type="checkbox"/>' +
																	'</div>' +
																	'<div class="custom-control">' +
																		'<label for="sup_dash_show_state_name_members_option_{{ normalized_id }}" class="columnOptionText">{{ show_state_description }}</label>' +
																		'<input action_show_option action_option_all id="sup_dash_show_state_name_members_option_{{ normalized_id }}" class="columnOptionCheck" type="checkbox"/>' +
																	'</div>' +
																	'<div class="custom-control">' +
																		'<label for="sup_dash_show_state_time_members_option_{{ normalized_id }}" class="columnOptionText">{{ show_state_time }}</label>' +
																		'<input action_show_option action_option_all id="sup_dash_show_state_time_members_option_{{ normalized_id }}" class="columnOptionCheck" type="checkbox"/>' +
																	'</div>' +
																'</li>' +
																'<li class="columnListSep">' +
																	'<div class="custom-control columnListSepTitle">' +
																		'<label class="columnOptionText"><%=_T("Operation")%></label>' +
																	'</div>' +
																	'<div class="custom-control">' +
																		'<label for="sup_dash_show_workgroups_option_{{ normalized_id }}" class="columnOptionText">{{ show_workgroups }}</label>' +
																		'<input action_show_option action_option_all id="sup_dash_show_workgroups_option_{{ normalized_id }}" class="columnOptionCheck" type="checkbox"/>' +
																	'</div>' +
																	'<div class="custom-control">' +
																		'<label for="sup_dash_show_total_conversations_option_{{ normalized_id }}" class="columnOptionText">{{ show_total_conversations }}</label>' +
																		'<input action_show_option action_option_all id="sup_dash_show_total_conversations_option_{{ normalized_id }}" class="columnOptionCheck" type="checkbox"/>' +
																	'</div>' +
																	'<div class="custom-control">' +
																		'<label for="sup_dash_show_total_conversations_by_channel_option_{{ normalized_id }}" class="columnOptionText">{{ show_total_conversations_by_channels }}</label>' +
																		'<input action_show_option action_option_all id="sup_dash_show_total_conversations_by_channel_option_{{ normalized_id }}" class="columnOptionCheck" type="checkbox"/>' +
																	'</div>' +
																'</li>' +
															'</ul>' +
														'</div>' +
													'</div>' +
												'</div>' +
												// MEMBER FILTERS
												'<div class="teamFilter">' +
													'<div class="boxTeamFilter">' +
														
														// COLAPSED FILTERS DESCRIPTION
														'<div id="sup_dash_members_panel_filter_colapsed_container_{{ normalized_id }}" class="noFilterMessageContainer">' +
															'<label id="sup_dash_members_panel_filter_colapsed_selected_{{ normalized_id }}" class="noFilterMessageLabel">' + m_translated.without_filters + '</label>' +
														'</div>' +
					
														// UNCOLAPSED FILTERS DESCRIPTION
														'<div id="sup_dash_members_panel_filter_uncolapsed_container_{{ normalized_id }}" hidden class="card-block filterFieldsContainer">' +

															//BOX TITLE
															'<div class="boxTitle mb-1"><%=_T("Filter")%></div>' +
	
															// Filter member by agent state
															'<div class="rowFilter">' +
																'<div class="">' +
																	'<div class="form-group">' +
																		'<label>' + m_translated.agent_state + '</label>' +
																		'<div class="d-flex align-items-end">' +
																			'<div class="flex-grow-1 pr-1">' +
																				'<select id="sup_dash_members_panel_state_filter_{{ normalized_id }}" class="form-control"></select>' +
																			'</div>' +
																				'<button id="sup_dash_members_panel_order_{{ normalized_id }}" current-order="asc" class="pageButtonGeneric butTeamSort  memberSortAsc" disabled="true" type="button" title="<%=_T([[Sort agents by ascending or descending order]])%>"><i></i></button>' +
																			'</div>' +
																	'</div>' +
																'</div>' +
															'</div>' +
															// Filter member by agent state time
															'<div class="rowFilter">' +
																'<div class="">' +
																	'<div class="form-group">' +
																		'<label>' + m_translated.agent_state_time + '</label>' +
																		'<input id="sup_dash_members_panel_state_filter_time_{{ normalized_id }}" placeholder="<%=_T([[Indicate minutes]])%>..." filter_member_state_time="true" class="form-control" type="text" />' +
																	'</div>' +
																'</div>' +
																// Filter member by name
																'<div class="">' +
																	'<div class="form-group">' +
																		'<label>' + m_translated.agent_name + '</label>' +
																		'<input id="sup_dash_members_panel_text_{{ normalized_id }}" filter_member_id="true" placeholder="<%=_T([[Name or user]])%>..." class="form-control" type="text" disabled="true" />' +
																	'</div>' +
																'</div>' +
															'</div>' +
															// Filter member by interactions state (locked, wrapup)
															'<div class="rowFilter">' +
																'<div class="">' +
																	'<div class="form-group">' +
																		'<label>' + m_translated.agent_interactions_state + '</label>' +
																		'<select id="sup_dash_members_panel_interactions_state_filter_{{ normalized_id }}" placeholder="<%=_T([[Indicate minutes]])%>..."  class="form-control"></select>' +
																	'</div>' +
																'</div>' +
																// Filter member by interactions state time
																'<div class="">' +
																	'<div class="form-group">' +
																		'<label>' + m_translated.agent_interactions_state_time + '</label>' +
																		'<input id="sup_dash_members_panel_interactions_state_filter_time_{{ normalized_id }}" placeholder="<%=_T([[Indicate minutes]])%>..." filter_member_interaction_state_time="true" class="form-control" type="text" />' +
																	'</div>' +
																'</div>' +
															'</div>' +
														'</div>' +
														// FILTER ACTIONS
														'<div id="sup_dash_members_panel_filter_actions_container_{{ normalized_id }}" class="filterButtonsContainer">' +
															'<button id="sup_dash_members_panel_reset_{{ normalized_id }}" class="butTeamFilter pageButtonGeneric buttonColorWhite" title="<%=_T("Clean")%>" type="button" disabled="true">' +
																'<i class="far fa-eraser"></i>' +
																'<label><%=_T("Clean")%></label>' +
															'</button>' +
															'<button id="sup_dash_members_panel_search_{{ normalized_id }}" class="butTeamFilterReset pageButtonGeneric buttonColorBlue" title="<%=_T("Refresh")%>" type="button" disabled="true">' +
																'<i class="far fa-sync"></i>' +
																'<label><%=_T("Refresh")%></label>' +
															'</button>' +
														'</div>' +
												'</div>' +
												'</div>' +
												// WAITING
												'<div id="sup_dash_members_waiting_{{ normalized_id }}" class="columnWaiting" style="display:none">' +
													'<div class="columnWaitingAnimation"></div>' +
													'<div id="sup_dash_members_waiting_msg_{{ normalized_id }}" class="supervisorWaitingMessage"></div>' +
													'<div class="columnWaitingOverlay"></div>' +
												'</div>' +
												// MEMBER STATUS POPUP
												'<div class="popupStatusList" style="display:none"></div>' +
												// MEMBER TABLE
												// CONTENT
												'<div class="columnContentAux">' +
													'<div class="columnContent forDetach">' +
														'<div id="sup_dash_members_list_msg_container_{{ normalized_id }}" class="inlineMessagesContainer messageInfo m-2" style="display:none" >' +
															'<label message="true" class="membersContentMessage"></label>' +
														'</div>' +
														'<div id="sup_dash_members_container_list_{{ normalized_id }}">' +
															'<ul id="sup_dash_members_list_{{ normalized_id }}" members_list="true" class="teamList"></ul>' +
														'</div>' +
													'</div>' +
												'</div>' +
												'<div class="teamListPager">' +
													'<div class="listPager">' +
														'<label id="team_page_text_{{ normalized_id }}" class="pagerText"></label>' +
														'<div>' +
															'<button id="team_page_prev_{{ normalized_id }}" class="pg-button butPagerPrev" ></button>' +
															'<button id="team_page_next_{{ normalized_id }}" class="pg-button butPagerNext mr-0" ></button>' +
														'</div>' +
													'</div>' +
												'</div>' +
											'</div>' +
				
										'</div>' + // END COLUMN / MEMBERS
									
									'</div>' + // END ROW COLUMNS
									
								'</div>' + // END BODY - operation
								'<div id="sup_dash_bots_info_container_{{ normalized_id }}" style="width: 100%; display:none;">' + 
								'	<icc-processflow-dashboard id="icc-processflow-dashboard" data-icc-dev-component=true > </icc-processflow-dashboard>'+
								'</div>'+
								// BODY - Alarms configuration
								'<div id="sup_dash_camp_alarms_config_{{ normalized_id }}" viewer_type="alarms_config" class="panelBody alarmViewer" style="display:none;"></div>' +
								// END BODY - Alarms configuration
								
								// Campaign accounts config popup
								'<div id="sup_dash_campaign_accounts_config_{{ normalized_id }}" class="dropdown-menu campaignPopup filterPopUp" style="position: absolute; display:none;"></div>' +
								
							'</div>' + // END CAMPAIGN NODE

						'</div>' + // END PANEL INTERNAL CONTAINER
					'</div>' // END ROW CONTAINER
	}
};

	if ( !inConcert.sup_templates ) {
		inConcert.sup_templates = Templates;
	}
}());
