import './assets/installer.css';

import React, { useState } from 'react';

import chrome_install_step_1_es from './assets/chrome-install-lx-1-es.jpg';
import chrome_install_step_2_es from './assets/chrome-install-lx-2-es.jpg';
import chrome_install_step_3_es from './assets/chrome-install-lx-3-es.jpg';

import chrome_install_step_1_en from './assets/chrome-install-lx-1-en.jpg';
import chrome_install_step_2_en from './assets/chrome-install-lx-2-en.jpg';
import chrome_install_step_3_en from './assets/chrome-install-lx-3-en.jpg';

const  chrome_webstore_url = 'https://chrome.google.com/webstore/detail/inconcert-browser-agent-m/imnannlkgcnnmdlopkgncndmdlpmpcgp'

const _langs = {
    en: {
        "dialog_title":"Installation for Chrome - Browser Monitoring Extension",
        "install_request": "We ask you to install this plug-in that will help us diagnose communication and performance problems.",
        "continue_to_install": "To start the installation of ",
        "cancel": "Cancell",
        "install": "Install",
        "close": "close",
        "chrome_install_step_1":chrome_install_step_1_en,
        "chrome_install_step_2":chrome_install_step_2_en,
        "chrome_install_step_3":chrome_install_step_3_en

    },
    es: {
        "dialog_title":"Instalación para Chrome - Extensión de monitoreo del browser",
        "install_request": "Te solicitamos instalar este plug-in que nos ayudará a diagnosticar problemas de comunicación y rendimiento.",
        "continue_to_install": "A continuación para instalar ",
        "cancel": "Cancelar",
        "install": "Instalar",
        "close": "cerrar",
        "chrome_install_step_1":chrome_install_step_1_es,
        "chrome_install_step_2":chrome_install_step_2_es,
        "chrome_install_step_3":chrome_install_step_3_es
    },

    pt: {

    },
    fr: {

    }
};
function _T(t){
    let clang = inConcert.app.getLoggedUserLanguage();
    if(!_langs[clang])
        clang = 'en';

    return _langs[clang][t]  || _langs['en'][t] || t;
}

function Wizard(props) {

    return (
        <div id="iccbam-install" dir="ltr" >
            <div id="iccbam-overlay"></div>
            <div id="iccbam-dialog">
                <div id="iccbam-dialog-box" class="wide">
                    

                    <div id="iccbam-dialog-title" class="iccbam-text-left">{_T('dialog_title')}</div>
                    <div id="iccbam-dialog-text" class="iccbam-text-left">
                        <p>{_T('install_request')}</p>
                        <p>{_T('continue_to_install')}<strong>Inconcert Agent Browser Monitor</strong>.</p></div>

                    <div id="iccbam-install-step-1">
                            <div class="iccbam-overlay">
                                <span id="iccbam-install-img-1">
                                    <img src={_T('chrome_install_step_1')} />
                                </span>
                            </div>

                            <div class="iccbam-overlay">
                                <span id="iccbam-install-img-2">
                                    <img src={_T('chrome_install_step_2')} />
                                </span>
                            </div>
                            <div class="iccbam-overlay">
                                <span id="iccbam-install-img-3">
                                    <img src={_T('chrome_install_step_3')} />
                                </span>
                            </div>
                        </div>
                    <div class="iccbam-buttons-container">
                        <div class="iccbam-close" 
                        title={_T('close')}
                        onClick={props.onUserCancelled}>
                            {_T('cancel')}
                        </div>
                        <a href="#" class="iccbam-submit-button"
                            onClick={(e) => {
                            let w = 1024;
                            let h = 800;
                            let left = (screen.width/2)-(w/2);
                            let top = (screen.height/2)-(h/2);
                            let params = `location=no,,width=${w},height=${h},top=${top},left=${left};`;
                            window.open(chrome_webstore_url,"install extension",params);
                            e.preventDefault();
                            }}>
                            {_T('install')}
                        </a>
                    </div>
                </div>
            </div>
        </div>
    )
}

export default function ExtensionInstaller(props){

    return (<div><Wizard onUserCancelled={props.onUserCancelled}/></div>)
}
