
/* jshint forin:true, noarg:true, jquery:true, noempty:true, eqeqeq:true, bitwise:true, strict:true, undef:false, unused:vars, curly:true, browser:true, indent:false, maxerr:50, quotmark:false, esversion: 11 */
/* global inConcert*/


if (!this.inConcert) {
	this.inConcert = {};
}

(function () {
	function Cache (fetch, makeKey, cachedSeconds) {
		this.fetch = fetch;
		this.makeKey = makeKey;
		this.cachedMs = cachedSeconds * 1000;
		this.elements = {};
	}

	if (typeof inConcert.Cache !== 'function') {
		inConcert.Cache = Cache;
	}

	Cache.prototype.get = function(fetchData, callback = $.noop) {
		const self = this;
		const key = this.makeKey(fetchData);
		const element = this.elements[key];
		if (element && this.isFresh(element)) {
			return callback(element.data);
		}
		this.fetch(fetchData, function(data, error) {
			if (data) {
				self.elements[key] = {
					data     : data,
					timestamp: (new Date()).getTime()
				};
			}
			callback(data, error);
		});
	};

	Cache.prototype.isFresh = function(element) {
		return element.timestamp + this.cachedMs > new Date().getTime();
	};
}());
