
module(..., package.seeall)

function New (fetchFunction, timeout)
	timeout = timeout or 30
	local cache = {}
	local get = function(key, ...)
		local entry = cache[key]
		if entry and (entry.timestamp + timeout > os.time()) then
			return entry.data
		else
			local data = fetchFunction(key, ...)
			if data ~= nil then
				cache[key] = {
					data = data,
					timestamp = os.time()
				}
			end
			return data
		end
	end
	return {
		get = get
	}
end