--[[
    Con el FLAG "m_rasaApiVersion" indicamos la versión de RASA a utilizar.
    El mismo puede ser modificdo únicamente por Fábrica o TQA para validar pruebas entre las diferentes versiones.
]]--

local m_rasaApiVersion = "2.0"
local m_apiRasa = require("rasa"):new(m_rasaApiVersion) -- rocka

module(..., package.seeall)

function GetAPI ()
	return m_apiRasa
end

function GetAPIVersion ()
	return m_rasaApiVersion
end

function RunRasaVCCsModels ()
	LogInfo("[SHARED.RASA:RunRasaVCCsModels] RUNNING RASA VCCS MODELS.....")
	return m_apiRasa:RunRasaAllVccsApps()
end

function DownRasaVCCsApps ()
	LogInfo("[SHARED.RASA:RunRasaVCCsModels] GOING DOWN RASA VCCS MODELS.....")
	return m_apiRasa:DownRasaAllVccsApps()
end
