module(..., package.seeall)

local sqlServer = sqlServer or {}

sqlServer.makeConnectionData = function(datasource)
	local server = datasource.Server
	if datasource.Port then
		server = server .. "," .. datasource.Port
	end
	local connectionData = {
		{ Driver = "/usr/lib/inconcert_odbc/libmsodbcsql-17.so" },
		{ Server = server },
		{ Uid = datasource.Username },
		{ Pwd = datasource.Password },
		{ Database = datasource.Database }
	}
	return connectionData
end

sqlServer.escapeValue = function(value)
	local dataType = type(value)
	if dataType == "string" then
		value = value:gsub("'", "''")
	end
	return value
end

function Init()
	return sqlServer
end