/* jshint forin:true, noarg:true, jquery:true, noempty:true, eqeqeq:true, bitwise:true,
	strict:true, undef:true, unused:vars, curly:true, browser:true, indent:false, maxerr:50, quotmark:double, esversion: 11 */

/* global inConcert, Mustache, inConcertLanguages, Config */

if (!this.inConcert) {
	this.inConcert = {};
}

if (!this.inConcert.adm_process_flow_messages) {
	this.inConcert.adm_process_flow_messages = {};
}

if (!this.inConcert.adm_process_flow_messages_type) {
	this.inConcert.adm_process_flow_messages_type = {};
}

if (!this.inConcert.adm_process_flow_messages_type.base) {
	this.inConcert.adm_process_flow_messages_type.base = {};
}

if (!this.inConcert.adm_process_flow_messages_button) {
	this.inConcert.adm_process_flow_messages_button = {};
}

if (!this.inConcert.adm_process_flow_messages_button.base) {
	this.inConcert.adm_process_flow_messages_button.base = {};
}

if (!this.inConcert.adm_process_flow_messages_quickreply) {
	this.inConcert.adm_process_flow_messages_quickreply = {};
}

if (!this.inConcert.adm_process_flow_messages_hyperlink) {
	this.inConcert.adm_process_flow_messages_hyperlink = {};
}

(function () {
	//"use strict";

	var format = inConcert.Utils.format;
	var templates = inConcert.templates.process_flows;

//Button
	function adm_process_flow_messages_button(parent, data, $list, $parent, onDeleted) {
		this.parent = parent;
		this.data = JSON.parse(JSON.stringify(data || {}));
		this.$list = $list;
		this.$parent = $parent;
		this.onDeleted = onDeleted || $.noop;
		this.guid = inConcert.Utils.generateGuid();

        let self = this;

		if (data) {
			if (data.port_id) {
				this.guid = data.port_id; 
			}			
		}

		this.types = [
			{
				id : "web_url",
				name : "<%=_T('Web url')%>",
				description : "<%=_T('Open a popup from url.')%>"
			},
			{
				id : "postback",
				name : "<%=_T('State')%>",
				description : "<%=_T('The state will be executed when the user presses the button.')%>"
			}
		];

		//phone_number button will fail on instagram
		if(parent.activity.type !== "INSTAGRAM_BOT")
		{
			this.types.push(
				{
					id : "phone_number",
					name : "<%=_T('Phone number')%>",
					description : "<%=_T('Makes a phone call.')%>"
				}
			);
		}

        if (parent.currentType === "reply_buttons") {
            this.types = [
                {
                    id : "reply",
                    name : "<%=_T('Reply button')%>",
                    description : "<%=_T('Reply button')%>"
                }
            ];
        }

        if (parent.currentType === "list_messages") {
            this.types = [
                {
                    id : "list_messages",
                    name : "<%=_T('Row')%>",
                    description : "<%=_T('Row')%>"
                }
            ];
        }

		this.idDefinition = { 
			id : "id",
			name : "<%=_T('Id')%>",
			description : "<%=_T('Button id (you can use {{ }} to enter variables).')%>",
			required : true,
			maxLength : 20,
            variable: true,
            span: true,
            spanClass: "ic_variable_icon_container",
            variableIconClass: "ic_variable_icon far fa-at",
            form_group: true,
			brackets : true,
            validate : {
				type : "id",
				message : "<%=_T('Only letters, numbers, dashes and dots are allowed in flow name.')%>"
			},
		};

		this.titleDefinition = { 
			id : "title",
			name : "<%=_T('Title')%>",
			description : "<%=_T('Button title (you can use {{ }} to enter variables).')%>",
			required : true,
			maxLength : 20,
            variable: true,
            span: true,
            spanClass: "ic_variable_icon_container",
            variableIconClass: "ic_variable_icon far fa-at",
            form_group: true,
			brackets : true
		};

        this.descriptionDefinition = { 
			id : "description",
			name : "<%=_T('Description')%>",
			description : "<%=_T('Button description (you can use {{ }} to enter variables).')%>",
			required : true,
			maxLength : 72,
            variable: true,
            span: true,
            spanClass: "ic_variable_icon_container",
            variableIconClass: "ic_variable_icon far fa-at",
            form_group: true,
			brackets : true
		};

		//web url
		this.urlDefinition = { 
			id : "url",
			name : "<%=_T('Url')%>",
			description : "<%=_T('Url to be open (you can use {{ }} to enter variables).')%>",
			required : true,
            variable: true,
            span: true,
            spanClass: "ic_variable_icon_container",
            variableIconClass: "ic_variable_icon far fa-at",
            form_group: true,
			brackets : true
		};

		//postback
		var main = this.parent.activity.editor.main;

		this.stateDefinition = { 
			id : "state",
			name : "<%=_T('State')%>",
			description : "<%=_T('Process state to be executed.')%>",
			required : true,
			options : main.GetStatesList(),
            form_group: true
		};

		this.messageDefinition = { 
			id : "message",
			name : "<%=_T('Message')%>",
			description : "<%=_T('Text message to be used when state is executed (you can use {{ }} to enter variables).')%>",
			variable: true,
            span: true,
            spanClass: "ic_variable_icon_container",
            variableIconClass: "ic_variable_icon far fa-at",
            form_group: true,
			brackets : true
		};

		//phone number
		this.phoneNumberDefinition = { 
			id : "phoneNumber",
			name : "<%=_T('Number')%>",
			description : "<%=_T('Phone number to be called (country code included and starting with +, you can use {{ }} to enter variables).')%>",
			required : true,
			variable: true,
            span: true,
            spanClass: "ic_variable_icon_container",
            variableIconClass: "ic_variable_icon far fa-at",
            form_group: true,
			brackets : true
		};

        this.buttonTypeDefinition_options = [];

        this.buttonTypeDefinition = {
			id : "buttonTypeMain",
			name : "Tipo de Botón", //this.options.type_name,
			description : "Selecciona el tipo de botón", //this.options.type_description,
			required : true,
			not_extended : true,
			options : this.buttonTypeDefinition_options, //this.options.message_types,
			change : function() {
				self.__selectType($(this).val());
			},
            form_group: true,
            hidden: (this.types.length <= 1?true:false)
		};
	}

	if (typeof inConcert.adm_process_flow_messages_button.base.base !== "function") {
		inConcert.adm_process_flow_messages_button.base.base = adm_process_flow_messages_button;
	}

	adm_process_flow_messages_button.prototype.Make = function() {
		var self = this;

		let title = "<%=_T('Add Button')%>";
		if (self.parent.currentType === "list_messages") {
			title = "<%=_T('Add Row')%>";
		}

        self.$button = $(Mustache.render(templates.messages_button, {
            guid : this.guid,
			title: title
        }));

		self.__makeTypes();

		self.$button.find("[button_view]").click(function() {
			if (self.$list.find(".editMode").length) {
				return;
			}
			self.__editMode();
		});
		self.$button.find("[button_action=save]").click(function() {
			self.__saveEdit();
		});
		self.$button.find("[button_action=cancel]").click(function() {
			self.__cancelEdit();
		});
		self.$button.find("[button_action=delete]").click(function() {
			self.Delete();
		});

		self.$list.append(self.$button);

		if ($.isEmptyObject(self.data)) {
			self.__editMode();
			this.parent.activity.SelfOverlay(false);
		}
		else {
			self.__viewMode();
		}
		return self.$button;
	};

	adm_process_flow_messages_button.prototype.Delete = function() {
		this.deleted = true;
		this.$button.remove();
		this.$list.siblings("[quickreplies_title]").toggle(this.$list.children().length > 0);
		this.onDeleted();
	};

	adm_process_flow_messages_button.prototype.GetData = function() {
		return (this.deleted || $.isEmptyObject(this.data))? null : this.data;
	};

	adm_process_flow_messages_button.prototype.__currentType = function() {
		return this.data.type || this.types[0].id;
	};

	adm_process_flow_messages_button.prototype.__makeType = function(type) {
		var self = this;
		type.guid = inConcert.Utils.generateGuid();
		var $type = $(Mustache.render(templates.messages_button_type, type));
		$type.find("[button_type]").click(function() {
			self.__selectType($(this).attr("button_type"));
		});
		return $type;
	};

	adm_process_flow_messages_button.prototype.__makeTypes = function() {
		let self = this;
		let $types = [];
		$.each(self.types, function(_, type) {
            self.buttonTypeDefinition_options.push({ id: type.id, name: type.name });
			$types.push(self.__makeType(type));
		});
		
		self.$button.find("[button_types]")
            .append($types)
            .parent().parent().toggle(false);

        self.$button.find("[button_edit_form]").append(
            self.parent.activity.__makeDivFlex(
                self.parent.activity.__makeDivFlex(self.parent.activity.__makeComboFlex(self.buttonTypeDefinition, self.data.msgtype),{ class: "col-12" }),{ class: "row" }
            )
        );
    
    };

	adm_process_flow_messages_button.prototype.__viewMode = function() {
		this.parent.activity.SelfOverlay(false);
		var type = this.__currentType();
		var viewData = this["__" + type + "ViewData"]();
        this.$button.attr("button_id", viewData.id);
		this.$button.attr("button_name", viewData.name);
        this.$button.attr("button_description", viewData.description);
		this.$button.find("[button_title]").text(viewData.title);
		this.$button.find("[button_subtitle]").text(viewData.subtitle);
		this.$button.find("[button_view]")
			.removeClass(function (_, classNames) {
				var current_classes = classNames.split(" ");
				var classes_to_remove = [];
				$.each(current_classes, function (_, class_name) {
					if (/buttonType.*/.test(class_name)) {
						classes_to_remove.push(class_name);
					}
				});
				return classes_to_remove.join(" ");
			})
			.addClass("buttonType" + type);
		this.$button.removeClass("editMode");
	};

	adm_process_flow_messages_button.prototype.__editMode = function() {

        let current_type = this.__currentType();

        if (current_type === "list_messages") {
            this.$button.find("[button_edit]").addClass("flowDesignerMessagesTemplateButtonEditListMessages");
        }

		this.parent.activity.SelfOverlay(true);
		this.$button.addClass("editMode");
		this.__selectType(this.__currentType());
		this.parent.activity.ScrollTo(this.$button.find("[button_edit]"));
	};

	adm_process_flow_messages_button.prototype.__selectType = function(type) {
		this.$button.find(format("[button_type={0}]", type)).prop("checked", true);
		if (this.$typeControls) {
			$.each(this.$typeControls, function(_, $control) {
                if ($control.find("[control_label=buttonTypeMain]").length === 0) { 
                    $control.remove();
                } 				 
			});
		}
		this.$typeControls = this["__" + type + "MakeEditControls"]();
		this.$button.find("[button_edit_form]").append(this.$typeControls);
	};

	adm_process_flow_messages_button.prototype.__saveEdit = function() {
		this.parent.activity.__clearErrors();
		var data = {
			type : this.$button.find("[button_type]:checked").attr("button_type")
		};
		this["__" + data.type + "AddData"](data);
		if (data.error) {
			return this.parent.activity.__showError(data.error);
		}
		this.data = data;
		this.__viewMode();

		this.$list.siblings("[quickreplies_title]").toggle(this.$list.children().length > 0);
	};

	adm_process_flow_messages_button.prototype.__cancelEdit = function() {
		this.parent.activity.__clearErrors();
		if ($.isEmptyObject(this.data)) {
			this.parent.activity.SelfOverlay(false);
			this.Delete();
		}
		else {
			this.__viewMode();
		}
	};

	adm_process_flow_messages_button.prototype.__web_urlViewData = function() {
		return {
			title : this.data[this.titleDefinition.id],
			subtitle : this.data[this.urlDefinition.id],
			name : this.data[this.titleDefinition.id]
		};
	};

	adm_process_flow_messages_button.prototype.__web_urlMakeEditControls = function() {
		let activity = this.parent.activity;
		let $controls = [];

        $controls.push(
            activity.__makeDivFlex(
                activity.__makeDivFlex(activity.__makeInputFlex(this.titleDefinition, this.data[this.titleDefinition.id]),{ class: "col-12" }),{ class: "row" }
            )
        );

        $controls.push(
            activity.__makeDivFlex(
                activity.__makeDivFlex(activity.__makeInputFlex(this.urlDefinition, this.data[this.urlDefinition.id]),{ class: "col-12" }),{ class: "row" }
            )
        );


		return $controls;
	};

	adm_process_flow_messages_button.prototype.__web_urlAddData = function(data) {
		var activity = this.parent.activity;
		activity.__addValue(data, this.titleDefinition, this.$button);
		activity.__addValue(data, this.urlDefinition, this.$button);
		if (!data.error && this.$button.siblings(format("[button_name=\"{0}\"]", data[this.titleDefinition.id])).length) {
			data.error = {
				control : this.titleDefinition.id,
				message : "<%=_T('Already exists a button with same title.')%>"
			};
		}
	};

	adm_process_flow_messages_button.prototype.__postbackViewData = function() {
		var stateId = this.data[this.stateDefinition.id];
		return {
			title : this.data[this.titleDefinition.id],
			subtitle : this.parent.activity.editor.main.GetStateName(stateId),
			name : this.data[this.titleDefinition.id]
		};
	};

	adm_process_flow_messages_button.prototype.__postbackMakeEditControls = function() {
        let activity = this.parent.activity;
        let $controls = [];

        $controls.push(
            activity.__makeDivFlex(
                activity.__makeDivFlex(activity.__makeInputFlex(this.titleDefinition, this.data[this.titleDefinition.id]),{ class: "col-12" }),{ class: "row" }
            )
        );

        $controls.push(
            activity.__makeDivFlex(
                activity.__makeDivFlex(activity.__makeComboFlex(this.stateDefinition, this.data[this.stateDefinition.id]),{ class: "col-12" }),{ class: "row" }
            )
        );

        $controls.push(
            activity.__makeDivFlex(
                activity.__makeDivFlex(activity.__makeInputFlex(this.messageDefinition, this.data[this.messageDefinition.id]),{ class: "col-12" }),{ class: "row" }
            )
        );


		return $controls;
	};

	adm_process_flow_messages_button.prototype.__postbackAddData = function(data) {
		var activity = this.parent.activity;
		activity.__addValue(data, this.titleDefinition, this.$button);
		activity.__addValue(data, this.stateDefinition, this.$button);
		activity.__addValue(data, this.messageDefinition, this.$button);
		if (!data.error && this.$button.siblings(format("[button_name=\"{0}\"]", data[this.titleDefinition.id])).length) {
			data.error = {
				control : this.titleDefinition.id,
				message : "<%=_T('Already exists a button with same title.')%>"
			};
		}
	};

	adm_process_flow_messages_button.prototype.__phone_numberViewData = function() {
		return {
			title : this.data[this.titleDefinition.id],
			subtitle : this.data[this.phoneNumberDefinition.id],
			name : this.data[this.titleDefinition.id]
		};
	};

    adm_process_flow_messages_button.prototype.__replyViewData = function() {
		return {
			title : this.data[this.titleDefinition.id],
			id : this.data[this.idDefinition.id],
			name : this.data[this.titleDefinition.id],
			description : this.data[this.descriptionDefinition.id]
		};
	};

    adm_process_flow_messages_button.prototype.__list_messagesViewData = function() {
		return {
			title : this.data[this.titleDefinition.id],
			id : this.data[this.idDefinition.id],
			name : this.data[this.titleDefinition.id],
			description : this.data[this.descriptionDefinition.id]
		};
	};

    adm_process_flow_messages_button.prototype.__replyMakeEditControls = function() {
        let activity = this.parent.activity;
        let $controls = [];

        $controls.push(
            activity.__makeDivFlex(
                activity.__makeDivFlex(activity.__makeInputFlex(this.idDefinition, this.data[this.idDefinition.id]),{ class: "col-12" }),{ class: "row" }
            )
        );

        $controls.push(
            activity.__makeDivFlex(
                activity.__makeDivFlex(activity.__makeInputFlex(this.titleDefinition, this.data[this.titleDefinition.id]),{ class: "col-12" }),{ class: "row" }
            )
        );

		return $controls;
	};

    adm_process_flow_messages_button.prototype.__list_messagesMakeEditControls = function() {
        let activity = this.parent.activity;
        let $controls = [];

        $controls.push(
            activity.__makeDivFlex(
                activity.__makeDivFlex(activity.__makeInputFlex(this.idDefinition, this.data[this.idDefinition.id]),{ class: "col-12" }),{ class: "row" }
            )
        );

        $controls.push(
            activity.__makeDivFlex(
                activity.__makeDivFlex(activity.__makeInputFlex(this.titleDefinition, this.data[this.titleDefinition.id]),{ class: "col-12" }),{ class: "row" }
            )
        );

        $controls.push(
            activity.__makeDivFlex(
                activity.__makeDivFlex(activity.__makeInputFlex(this.descriptionDefinition, this.data[this.descriptionDefinition.id]),{ class: "col-12" }),{ class: "row" }
            )
        );

		return $controls;
	};

    adm_process_flow_messages_button.prototype.__replyAddData = function(data) {

    	var activity = this.parent.activity;
        let title_original = this.data[this.titleDefinition.id];
        let id_original = this.data[this.idDefinition.id];

		activity.__addValue(data, this.idDefinition, this.$button);
		activity.__addValue(data, this.titleDefinition, this.$button);
		if (!data.error && this.$button.siblings(format("[button_id=\"{0}\"]", data[this.idDefinition.id])).length) {
			data.error = {
				control : this.idDefinition.id,
				message : "<%=_T('Already exists a button with same id.')%>"
			};
		}

        if (!data.error && this.$button.siblings(format("[button_name=\"{0}\"]", data[this.titleDefinition.id])).length) {
			data.error = {
				control : this.titleDefinition.id,
				message : "<%=_T('Already exists a button with same title.')%>"
			};
		}

        data.title_original = title_original;
        data.id_original = id_original;

        // actualizo los puertos
        if (this.parent.activity.saveEditInteractiveButton instanceof Function) {
            this.parent.activity.saveEditInteractiveButton(data);
        }
	};

    adm_process_flow_messages_button.prototype.__list_messagesAddData = function(data) {

        let self = this;
		var activity = this.parent.activity;
        var $top_parent = this.$button.parent().parent().parent().parent().parent();

        let title_original = self.data[this.titleDefinition.id];
        let id_original = self.data[this.idDefinition.id];

		activity.__addValue(data, this.idDefinition, this.$button);
		activity.__addValue(data, this.titleDefinition, this.$button);
		activity.__addValue(data, this.descriptionDefinition, this.$button);

        if (!data.error && $top_parent.find(format("[button_id=\"{0}\"]", data[this.idDefinition.id])).filter(function () {
            return $(this).attr("template_button") !== self.$button.attr("template_button");
          }).length) {
			data.error = {
				control : this.idDefinition.id,
				message : "<%=_T('Already exists a button with same id.')%>"
			};
		}

        if (!data.error && $top_parent.find(format("[button_name=\"{0}\"]", data[this.titleDefinition.id])).filter(function () {
            return $(this).attr("template_button") !== self.$button.attr("template_button");
            }).length) {
			data.error = {
				control : this.titleDefinition.id,
				message : "<%=_T('Already exists a button with same title.')%>"
			};
		}

        if (!data.error && $top_parent.find(format("[button_description=\"{0}\"]", data[this.descriptionDefinition.id])).filter(function () {
            return $(this).attr("template_button") !== self.$button.attr("template_button");
            }).length) {
                data.error = {
				control : this.descriptionDefinition.id,
				message : "<%=_T('Already exists a button with same description.')%>"
			};
		}

        data.title_original = title_original;
        data.id_original = id_original;

        // actualizo los puertos
        if (this.parent.activity.saveEditInteractiveButton instanceof Function) {
            this.parent.activity.saveEditInteractiveButton(data);
        }
	};

	adm_process_flow_messages_button.prototype.__phone_numberMakeEditControls = function() {
        let activity = this.parent.activity;
        let $controls = [];


        $controls.push(
            activity.__makeDivFlex(
                activity.__makeDivFlex(activity.__makeInputFlex(this.titleDefinition, this.data[this.titleDefinition.id]),{ class: "col-12" }),{ class: "row" }
            )
        );

        $controls.push(
            activity.__makeDivFlex(
                activity.__makeDivFlex(activity.__makeInputFlex(this.phoneNumberDefinition, this.data[this.phoneNumberDefinition.id]),{ class: "col-12" }),{ class: "row" }
            )
        );

		return $controls;
	};

	adm_process_flow_messages_button.prototype.__phone_numberAddData = function(data) {
		var activity = this.parent.activity;
		activity.__addValue(data, this.titleDefinition, this.$button);
		activity.__addValue(data, this.phoneNumberDefinition, this.$button);
		if (!data.error && this.$button.siblings(format("[button_name=\"{0}\"]", data[this.titleDefinition.id])).length) {
			data.error = {
				control : this.titleDefinition.id,
				message : "<%=_T('Already exists a button with same title.')%>"
			};
		}
	};

//HyperLink
	function adm_process_flow_messages_hyperlink(parent) {
		this.parent = parent;
		this.data = {};

		//text
		this.hyperTextDefinition = {
			id: "hyperlink_text",
			name: "<%=_T('Text')%>",
			placeholder : "<%=_T('Enter the link text ...')%>",
			required: true,
			maxLength: 150,
            form_group: true
		};

		this.linkDefinition = {
			id: "hyperlink",
			name: "<%=_T('Url')%>",
			placeholder : "<%=_T('Enter the link hyperlink ...')%>",
			required: true,
            form_group: true
		};
	}

	if (typeof inConcert.adm_process_flow_messages_hyperlink.base !== "function") {
		inConcert.adm_process_flow_messages_hyperlink.base = adm_process_flow_messages_hyperlink;
	}

	adm_process_flow_messages_hyperlink.prototype.Make = function (callback) {
		let self = this;
		self.$button = $(templates.messages_hyperlink);

		let activity = this.parent.activity;
		let $controls = [];

        $controls.push(
            activity.__makeDivFlex(activity.__makeDivFlex(activity.__makeInputFlex(this.hyperTextDefinition, this.data[this.hyperTextDefinition.id]),{ class: "col-12" }),{ class: "row" }
        ));

        $controls.push(
            activity.__makeDivFlex(activity.__makeDivFlex(activity.__makeInputFlex(this.linkDefinition, this.data[this.linkDefinition.id]),{ class: "col-12" }),{ class: "row" }
        ));

		this.parent.activity.SelfOverlay(true);

		self.$button.find("[hyperlink_action=save]").click(function () {
			self.__saveEdit(callback);
		});
		self.$button.find("[hyperlink_action=cancel]").click(function () {
			self.__cancelEdit();
		});
		self.$button.find("[hyperlink_edit_form]").append($controls);
		return self.$button;
	};

	adm_process_flow_messages_hyperlink.prototype.Delete = function() {
        $("[messages_hyperlink_form]").hide();
		this.$button.remove();
		this.parent.activity.SelfOverlay(false);
	};

	adm_process_flow_messages_hyperlink.prototype.__saveEdit = function (callback) {
		this.parent.activity.__clearErrors();
		var data = {
		};
		this.__AddData(data);
		if (!data.error && !inConcert.Utils.validate(data.hyperlink, "url").success) {
			data.error = {
				control : this.linkDefinition.id,
				message : "<%=_T('Insert the protocol http(s) in the Url')%>"
			};
		}

		if (data.error) {
			return this.parent.activity.__showError(data.error, this.$button);
		}
		this.data = data;
		callback(this.data);        
		this.parent.activity.SelfOverlay(false);
		this.Delete();
	};

	adm_process_flow_messages_hyperlink.prototype.__AddData = function(data) {
		var activity = this.parent.activity;
		activity.__addValue(data, this.hyperTextDefinition, this.$button);
		activity.__addValue(data, this.linkDefinition, this.$button);
	};

	adm_process_flow_messages_hyperlink.prototype.__cancelEdit = function () {
		this.parent.activity.__clearErrors();
		this.parent.activity.SelfOverlay(false);
		this.Delete();
	};

//Quick reply

	function adm_process_flow_messages_quickreply(parent, data, $list) {
		this.parent = parent;
		this.data = JSON.parse(JSON.stringify(data || {}));
		this.$list = $list;
		this.guid = inConcert.Utils.generateGuid();

        let self = this;
		if (data) {
			if (data.port_id) {
				this.guid = data.port_id; 
			}			
		}

		this.types = [
			{
				id : "text",
				name : "<%=_T('Text')%>",
				description : "<%=_T('Suggests a text option.')%>"
			}
		];

		//Instagram solo admite quick replies de tipo text
		if(parent.activity.type !== "INSTAGRAM_BOT")
		{
			/*this.types.push(
				{
					id : "location",
					name : "<%=_T('Geolocation')%>",
					description : "<%=_T('Geolocalizates user position.')%>"
				}
			);*/
			this.types.push(
				{
					id : "user_phone_number",
					name : "<%=_T('Phone Number')%>",
					description : "<%=_T('Capturates user phone number.')%>"
				}
			);
			this.types.push(
				{
					id : "user_email",
					name : "<%=_T('E-mail')%>",
					description : "<%=_T('Capturates user e-mail.')%>"
				}
			);
		}

        this.quickreplyTypeDefinition_options = [];

        this.quickreplyTypeDefinition = {
			id : "msgtypeMain",
			name : "Selecciona el tipo de respuesta", //this.options.type_name,
			description : "Selecciona el tipo de respuesta", //this.options.type_description,
			required : true,
			not_extended : true,
			options : this.quickreplyTypeDefinition_options, //this.options.message_types,
			change : function() {
				self.__selectType($(this).val());
			},
            form_group: true
		};

        this.titleDefinition = {
            id: "title",
            name: "<%=_T('Title')%>",
            description : "<%=_T('Quickreply title (you can use {{ }} to enter variables).')%>",
            not_extended: true,
            variable: true,
            required : true,
            span: true,
            spanClass: "ic_variable_icon_container",
            variableIconClass: "ic_variable_icon far fa-at",
            form_group: true,
            maxLength : 50,
			brackets : true
        };

        this.postbackMessageDefinition = {
            id: "message",
            name: "<%=_T('Message')%>",
            description : "<%=_T('Postback message to be sent (you can use {{ }} to enter variables).')%>",
            not_extended: true,
            variable: true,
            required : true,
            span: true,
            spanClass: "ic_variable_icon_container",
            variableIconClass: "ic_variable_icon far fa-at",
            form_group: true,
            maxLength : 50,
			brackets : true
        };

        this.iconUrlDefinition = {
            id: "icon_url",
            name: "<%=_T('Icon url')%>",
            description : "<%=_T('Optional icon url (you can use {{ }} to enter variables).')%>",
            not_extended: true,
            variable: true,
            span: true,
            spanClass: "ic_variable_icon_container",
            variableIconClass: "ic_variable_icon far fa-at",
            form_group: true,
            maxLength : 50,
            brackets : true
        };
	}

	if (typeof inConcert.adm_process_flow_messages_quickreply.base !== "function") {
		inConcert.adm_process_flow_messages_quickreply.base = adm_process_flow_messages_quickreply;
	}

	adm_process_flow_messages_quickreply.prototype.Make = function() {
		var self = this;
		self.$button = $(Mustache.render(templates.messages_quickreply, {
			guid : this.guid
		}));

		self.__makeTypes();

		self.$button.find("[quickreply_view]").click(function() {
			if (self.$list.find(".editMode").length) {
				return;
			}
			self.__editMode();
		});
		self.$button.find("[quickreply_action=save]").click(function() {
			self.__saveEdit();
		});
		self.$button.find("[quickreply_action=cancel]").click(function() {
			self.__cancelEdit();
		});
		self.$button.find("[quickreply_action=delete]").click(function() {
			self.Delete();
		});

		self.$list.append(self.$button);

		if ($.isEmptyObject(self.data)) {
			self.__editMode();
		}
		else {
			self.__viewMode();
		}

        self.$list.siblings("[quickreplies_title]").toggle(true);

		return self.$button;
	};

	adm_process_flow_messages_quickreply.prototype.Delete = function() {

		this.deleted = true;
		this.$button.remove();
		this.$list.siblings("[quickreplies_title]").toggle(this.$list.children().length > 0);

        // actualizo los puertos
        if (this.parent.activity.deleteQuickReplyPort instanceof Function) {
            this.parent.activity.deleteQuickReplyPort(this.guid);
        }
	};

	adm_process_flow_messages_quickreply.prototype.GetData = function() {
		return (this.deleted || $.isEmptyObject(this.data))? null : this.data;
	};

	adm_process_flow_messages_quickreply.prototype.__currentType = function() {
		return this.data.type || this.types[0].id;
	};

	adm_process_flow_messages_quickreply.prototype.__makeType = function(type) {
		var self = this;
		type.guid = inConcert.Utils.generateGuid();
		var $type = $(Mustache.render(templates.messages_quickreply_type, type));
		$type.find("[quickreply_type]").click(function() {
			self.__selectType($(this).attr("quickreply_type"));
		});
		return $type;
	};

	adm_process_flow_messages_quickreply.prototype.__makeTypes = function() {
		let self = this;
		let $types = [];
		$.each(self.types, function(_, type) {
            self.quickreplyTypeDefinition_options.push({ id: type.id, name: type.name });
			$types.push(self.__makeType(type));
		});
		self.$button.find("[quickreply_types]")
			.append($types)
			.parent().parent()
			.toggle(false); // valor anterior $types.length > 1
   
        self.quickreplyTypeDefinition.hidden = self.quickreplyTypeDefinition_options.length>1?false:true;

        self.$button.find("[quickreply_edit_form]").append(
            self.parent.activity.__makeDivFlex(
                self.parent.activity.__makeDivFlex(self.parent.activity.__makeComboFlex(self.quickreplyTypeDefinition, self.data.quickreply_type),{ class: "col-12" }),{ class: "row" })
        );

	}; 
	adm_process_flow_messages_quickreply.prototype.__viewMode = function() {
		this.parent.activity.SelfOverlay(false);
		var type = this.__currentType();
		var viewData = this["__" + type + "ViewData"]();
		this.$button.attr("quickreply_name", viewData.name);
		this.$button.find("[quickreply_title]").text(viewData.title);
		this.$button.find("[quickreply_view]")
			.removeClass(function (_, classNames) {
				var current_classes = classNames.split(" ");
				var classes_to_remove = [];
				$.each(current_classes, function (_, class_name) {
					if (/quickreplyType.*/.test(class_name)) {
						classes_to_remove.push(class_name);
					}
				});
				return classes_to_remove.join(" ");
			})
			.addClass("quickreplyType" + type);
		this.$button.removeClass("editMode");
	};

	adm_process_flow_messages_quickreply.prototype.__editMode = function() {
		this.parent.activity.SelfOverlay(true);
		this.$button.addClass("editMode");
		this.__selectType(this.__currentType());
	};

	adm_process_flow_messages_quickreply.prototype.__selectType = function(type) {
		this.$button.find(format("[quickreply_type={0}]", type)).prop("checked", true);
		if (this.$typeControls) {
			$.each(this.$typeControls, function(_, $control) {
				
                if ($control.find("[control_label=msgtypeMain]").length === 0) { 
                    $control.remove();
                }
			});
		}
		this.$typeControls = this["__" + type + "MakeEditControls"]();
		this.$button.find("[quickreply_edit_form]").append(this.$typeControls);
	};

	adm_process_flow_messages_quickreply.prototype.__saveEdit = function() {

		this.parent.activity.__clearErrors();
        let actual_title = this.data.title;
		let data = {
			type : this.$button.find("[quickreply_type]:checked").attr("quickreply_type")
		};
		this["__" + data.type + "AddData"](data);
		if (data.error) {
			return this.parent.activity.__showError(data.error, this.$button);
		}
		this.data = data;
		this.__viewMode();

        // actualizo los puertos
        if (this.parent.activity.saveEditQuickReplyPort instanceof Function) {
            this.parent.activity.saveEditQuickReplyPort(this.guid, actual_title, this.data.title, data.type, true);
        }
        
	};

	adm_process_flow_messages_quickreply.prototype.__cancelEdit = function() {
		this.parent.activity.__clearErrors();
		if ($.isEmptyObject(this.data)) {
			this.parent.activity.SelfOverlay(false);
			this.Delete();
		}
		else {
			this.__viewMode();
		}
	};

	adm_process_flow_messages_quickreply.prototype.__textViewData = function() {
		return {
			title : this.data[this.titleDefinition.id],
			name : this.data[this.titleDefinition.id]
		};
	};

	adm_process_flow_messages_quickreply.prototype.__textMakeEditControls = function() {
        let activity = this.parent.activity;
        let $controls = [];

        $controls.push(
            activity.__makeDivFlex(
                activity.__makeDivFlex(activity.__makeInputFlex(this.titleDefinition, this.data[this.titleDefinition.id]),{ class: "col-12" }),{ class: "row" })
        );

        $controls.push(
            activity.__makeDivFlex(
                activity.__makeDivFlex(activity.__makeInputFlex(this.postbackMessageDefinition, this.data[this.postbackMessageDefinition.id]),{ class: "col-12" }),{ class: "row" }
            )
        );

		if(activity.type !== "INSTAGRAM_BOT")
		{
            $controls.push(
                activity.__makeDivFlex(
                    activity.__makeDivFlex(activity.__makeInputFlex(this.iconUrlDefinition, this.data[this.iconUrlDefinition.id]),{ class: "col-12" }),{ class: "row" }
                )
            );
		}
		return $controls;
	};

	adm_process_flow_messages_quickreply.prototype.__textAddData = function(data) {
		var activity = this.parent.activity;
		activity.__addValue(data, this.titleDefinition, this.$button);
		activity.__addValue(data, this.postbackMessageDefinition, this.$button);
		activity.__addValue(data, this.iconUrlDefinition, this.$button);
		if (!data.error && this.$button.siblings(format("[quickreply_name=\"{0}\"]", data[this.titleDefinition.id])).length) {
			data.error = {
				control : this.titleDefinition.id,
				message : "<%=_T('Already exists a quick reply with same title.')%>"
			};
		}
	};

	adm_process_flow_messages_quickreply.prototype.__locationViewData = function() {
		return {
			title : "<%=_T('Geolocation')%>",
			name : "geolocation"
		};
	};

	adm_process_flow_messages_quickreply.prototype.__locationMakeEditControls = function() {
		return [];
	};

	adm_process_flow_messages_quickreply.prototype.__locationAddData = function(data) {
		if (!data.error && this.$button.siblings("[quickreply_name=geolocation]").length) {
			data.error = {
				message : "<%=_T('Already exists a geolocation quick reply.')%>"
			};
		}
	};

	adm_process_flow_messages_quickreply.prototype.__user_phone_numberViewData = function() {
		return {
			title : "<%=_T('User Phone Number')%>",
			name : "user_phone_number"
		};
	};

	adm_process_flow_messages_quickreply.prototype.__user_phone_numberMakeEditControls = function() {
		return [];
	};

	adm_process_flow_messages_quickreply.prototype.__user_phone_numberAddData = function(data) {
		if (!data.error && this.$button.siblings("[quickreply_name=user_phone_number]").length) {
			data.error = {
				message : "<%=_T('Already exists a phone number quick reply.')%>"
			};
		}
	};

	adm_process_flow_messages_quickreply.prototype.__user_emailViewData = function() {
		return {
			title : "<%=_T('User E-mail')%>",
			name : "user_email"
		};
	};

	adm_process_flow_messages_quickreply.prototype.__user_emailMakeEditControls = function() {
		return [];
	};

	adm_process_flow_messages_quickreply.prototype.__user_emailAddData = function(data) {
		if (!data.error && this.$button.siblings("[quickreply_name=user_email]").length) {
			data.error = {
				message : "<%=_T('Already exists an e-mail quick reply.')%>"
			};
		}
	};

//Types

	function adm_process_flow_messages_type(parent, options) {
		this.parent = parent;
		this.options = options || {};
	}

	if (typeof inConcert.adm_process_flow_messages_type.base.base !== "function") {
		inConcert.adm_process_flow_messages_type.base.base = adm_process_flow_messages_type;
	}

	adm_process_flow_messages_type.prototype.name = "";
	adm_process_flow_messages_type.prototype.description = "";

	adm_process_flow_messages_type.prototype.GetMigrationData = function(self, type, migration, data) {
		//repository files
		let repositoryFiles = self.prototype.GetMigrationRepositoryFiles(self, type, data);
		if (repositoryFiles.length) {
			migration.repositoryFiles = repositoryFiles;
		}
		//shared files
		let sharedFiles = self.prototype.GetMigrationSharedFiles(self, type, data);
		if (sharedFiles.length) {
			migration.sharedFiles = sharedFiles;
		}
		return migration;
	};

	adm_process_flow_messages_type.prototype.GetActivityDeclaredVariables = function(data, editor) {
		editor.main.declaredVariables.add(data.result);
		// return [data.result];
	};

	adm_process_flow_messages_type.prototype.GetMigrationRepositoryFiles = function(/*self, type, data*/) {
		return [];
	};

	adm_process_flow_messages_type.prototype.GetMigrationSharedFiles = function(/*self, type, data*/) {
		return [];
	};

	adm_process_flow_messages_type.prototype.Make = function(/*data*/) {
		return "";
	};

	adm_process_flow_messages_type.prototype.AfterAppendBody = $.noop;

	adm_process_flow_messages_type.prototype.AddValue = $.noop;

	adm_process_flow_messages_type.prototype.AddValueAsync = function(_, callback) {
		callback();
	};

	adm_process_flow_messages_type.prototype.$get = function(query) {
		var $container = this.options.$container || $("#messages_data");
		return query? $container.find(query) : $container;
	};

	adm_process_flow_messages_type.prototype.IsEmbedded = function() {
		return this.options.embedded;
	};

// GEO Message Type

	function adm_process_flow_messages_type_geo(parent, options) {
		adm_process_flow_messages_type_geo.uber.constructor.call(this, parent, options);
		const self = this;

		this.coordsFile = {
			id: "coords_file",
			name: "<%=_T('File')%>",
			description: "<%=_T('File to be imported.')%>",
			required: true,
			validate: {
				extension: {
					types: {
						txt: true
					},
					message: "<%=_T('Unsupported extension file. Only txt.')%>"
				}
			},
			value_f: null,
            controlContainerClass: "form-group align-items-start"
		};

		this.coordsVar = {
			id: "coords_var",
			name: "<%=_T('Coordinates')%>",
			disclaimer: "<%=_T('Use variable element to set element value. Example: {{ coordinates }}.')%>",
			required: true,
			variable: true,
            span: true,
            spanClass: "ic_variable_icon_container",
            variableIconClass: "ic_variable_icon far fa-at",
            form_group: true,
			brackets: true
		};


		this.coordsList = {
			id: "coords_list",
			name: "<%=_T('Coordinates List')%>",
			placeholder: "<%=_T('List of latitudes and longitudes separated by comma (Lat, Lon).')%>",
			required: true,
			with_label: true,
			variable: false,
            form_group: true
		};

		this.input = {
			id : "input",
			name : "<%=_T('Input type')%>",
			description : "<%=_T('Select option.')%>",
			required : true,
			not_extended : true,
			options : [
				{
					id: "coords_var",
					name: "<%=_T('Coordinate')%>",
				},
				{
					id: "coords_list",
					name: "<%=_T('Coordinates List')%>",
				},
				{
					id: "coords_file",
					name: "<%=_T('File')%>",
				}
			],
			change : function() {
				self.__reloadInput();
			},
            form_group: true
		};

		this.__show();
	}

	inConcert.Utils.inherit( adm_process_flow_messages_type_geo, inConcert.adm_process_flow_messages_type.base.base );
	if (typeof inConcert.adm_process_flow_messages_type.base.geo !== "function") {
		inConcert.adm_process_flow_messages_type.base.geo = adm_process_flow_messages_type_geo;
	}
	adm_process_flow_messages_type_geo.prototype.name = "<%=_T('Coordinates')%>";
	adm_process_flow_messages_type_geo.prototype.description = "<%=_T('Coordinates input')%>";

	adm_process_flow_messages_type_geo.prototype.Make = function(data) {
        let self = this;
		let activity = this.parent.activity;
		let $content = [];

        $content.push(
            activity.__makeDivFlex(activity.__makeComboFlex(self.input, data[self.input.id]),{ class: "col-12" })
        );

        $content.push(
            activity.__makeDivFlex(activity.__makeTextareaFlex(self.coordsList, activity.data[self.coordsList.id]),{ class: "col-12" })
        );

        $content.push(
            activity.__makeDivFlex(activity.__makeInputFlex(self.coordsVar, activity.data[self.coordsVar.id]),{ class: "col-12" })
        );

		$content.push(activity.__makeDivFlex(activity.__makeUploadGeo(self.coordsFile, function (file/*, onReady, onProgress, onEnd*/) {
            let reader = new FileReader();
			reader.onload = function (e) {
				self.coordsFile.value_f = e.target.result;
				activity.__setValue(self.coordsList, self.coordsFile.value_f, self.$get());
			};
			reader.readAsText(file);
		}),{ class: "col-12" }));
		return $content;
	};

	adm_process_flow_messages_type_geo.prototype.AfterAppendBody = function(){
		this.__show();
	};

	adm_process_flow_messages_type_geo.prototype.__show = function(){
		let inputType = this.parent.activity.__getValue(this.input, this.$get());
		switch (inputType) {
			case "coords_file":
				this.parent.activity.__showControl(this.coordsList, this.$get());
				this.parent.activity.__showControl(this.coordsFile, this.$get());
				this.parent.activity.__setValue(this.coordsList, this.parent.data.coords_list, this.$get());
				this.parent.activity.__setValue(this.coordsFile, this.parent.data.coords_file, this.$get());
				break;
			case "coords_list":
				this.parent.activity.__showControl(this.coordsList, this.$get());
				this.parent.activity.__setValue(this.coordsList, this.parent.data.coords_list, this.$get());
                this.parent.activity.__hideControl(this.coordsFile, this.$get());
				break;
			case "coords_var":
				this.parent.activity.__showControl(this.coordsVar, this.$get());
				this.parent.activity.__setValue(this.coordsVar, this.parent.data.coords_var, this.$get());
                this.parent.activity.__hideControl(this.coordsList, this.$get());
				this.parent.activity.__hideControl(this.coordsFile, this.$get());
				break;
			default:
				this.parent.activity.__showControl(this.coordsVar, this.$get());
				break;
		}
	};
	
	adm_process_flow_messages_type_geo.prototype.AddValue = function (data) {
		let activity = this.parent.activity;
		let $container = this.$get();

		let inputType = this.parent.activity.__getValue(this.input, this.$get());

		const getArrayObjCoords = function (coords) {
			return coords.map((obj) => {
				const coord = obj.split(",");
				return { lat: coord[0] || 0, lon: coord[1] || 0 };
			});
		};
		data.coordinates = null;
		if (inputType === "coords_list" || inputType === "coords_file") {
			const $control = activity.__getControl(this.coordsList, $container);
			const valCoords = $control.val().trim();
			if (valCoords !== "") {
				const coords = valCoords.split("\n");

				const validateFormat = this.validateFormat(coords);
				if (validateFormat.length > 0) {
					data.error = {
						message: "<%=_T('Coordinates list is invalid, please, verify the format.')%>"
					};
				}
				else {
					data.coordinates = getArrayObjCoords(coords);
				}
			}
			activity.__addValue(data, this.coordsList, $container);

			if (inputType === "coords_file") {
				activity.__addValue(data, this.coordsFile, $container);
			}

		} else {

			const $control = activity.__getControl(this.coordsVar, $container);
			const coords = ($control.val() || "").replace(/\s|\n|\r/g, "");
			const validateFormat = this.validateFormat([coords]);
			if (validateFormat && validateFormat.length === 0) {
				data.coordinates = getArrayObjCoords([coords]);
			}
			activity.__addValue(data, this.coordsVar, $container);
		}
		activity.__addValue(data, this.input, $container);
	};

	adm_process_flow_messages_type_geo.prototype.validateFormat = function (data) {
		return data.filter(el => {
			let pattern = new RegExp("^((-(\\d{1,3})(,\\d{3})*)|(\\d+))(.\\d+),((-(\\d{1,3})(,\\d{3})*)|(\\d+))(.\\d+)*$");
			return !pattern.test(el.trim());
		});
	};

	adm_process_flow_messages_type_geo.prototype.__reloadInput = function(){
		let inputType = this.parent.activity.__getValue(this.input, this.$get());
		let $container = this.$get();
		if (inputType === "coords_var"){
			this.parent.activity.__showControl(this.coordsVar, $container);
			this.parent.activity.__hideControl(this.coordsList, $container);
			this.parent.activity.__hideControl(this.coordsFile, $container);
		} else if (inputType === "coords_list") {
			this.parent.activity.__showControl(this.coordsList, $container);
			this.parent.activity.__hideControl(this.coordsVar, $container);
			this.parent.activity.__hideControl(this.coordsFile, $container);
		} else if (inputType === "coords_file") {
			this.parent.activity.__showControl(this.coordsFile, $container);
			this.parent.activity.__hideControl(this.coordsVar, $container);
			this.parent.activity.__showControl(this.coordsList, $container);
		}
	};


// END Geo Message Type

//text

	function adm_process_flow_messages_type_text(parent, options) {
		adm_process_flow_messages_type_text.uber.constructor.call(this, parent, options);

        this.global_max_length = this.__getMaxLength();

		this.textDefinition = { 
			id : (options && options.id || "text"),
			name : (options && options.title || "<%=_T('Message')%>"),
			description : (options && options.description || "<%=_T('Chat message to send (you can use {{ }} to enter variables).')%>"),
			placeholder : "<%=_T('Enter the message')%>",
			variable: true,
            required : true,
            span: true,
            spanClass: "ic_message_container textarea",
            variableIconClass: "ic_variable_icon far fa-at",
			emojipicker : true,
			brackets: true,
			bottom_button: (!(options && options.embedded) && this.parent.activity.type.toUpperCase() !== "CALL" && parent.activity.quick_reply_name_prefix?true:false),
			hyperlinks: (options && options.embedded?false:true),
            maxLength: this.global_max_length,
            showMaxLength: (options && options.embedded?false:true) || (options && options.showMaxLength?true:false),
            form_group: true,
			without_label: false,
			not_extended : true,
			persoTags: "flow_designer_text_area_message",
			labelClass: (options && options.labelClass || ""),
			help_info: (options && options.help_info || false)
		};
	}

	inConcert.Utils.inherit( adm_process_flow_messages_type_text, inConcert.adm_process_flow_messages_type.base.base );

	if (typeof inConcert.adm_process_flow_messages_type.base.text !== "function") {
		inConcert.adm_process_flow_messages_type.base.text = adm_process_flow_messages_type_text;
	}

	adm_process_flow_messages_type_text.prototype.name = "<%=_T('Text')%>";
	adm_process_flow_messages_type_text.prototype.description = "<%=_T('Text message.')%>";

	adm_process_flow_messages_type_text.prototype.__hasButtons = function() {
		return !this.IsEmbedded(); // && !(this.parent && this.parent.activity && this.parent.activity.without_buttons === true);
	};

	adm_process_flow_messages_type_text.prototype.Make = function(data) {

        let self = this;

        let activity = self.parent.activity;

		let $controlTextArea = activity.__makeTextareaFlex(self.textDefinition, data[self.textDefinition.id]);

        $controlTextArea.keyup(function(/*e*/) {

            if (self.textDefinition.showMaxLength) {

                let max_length = self.global_max_length;
                let text_value = "";
				let control_id = "";

                if (self.parent && self.parent.activity && self.textDefinition) {
                    text_value = self.parent.activity.__getValue(self.textDefinition);
					control_id = self.textDefinition.id;
                } else if (self.parent && self.parent.activity && self.parent.typeEditor.textDefinition) {
                    text_value = self.parent.activity.__getValue(self.parent.typeEditor.textDefinition);
                    max_length = self.parent.typeEditor.global_max_length;
					control_id = self.parent.typeEditor.textDefinition.id;
                } else if (self.activity && self.typeEditor.textDefinition) {
                    text_value = self.activity.__getValue(self.typeEditor.textDefinition);
                    max_length = self.typeEditor.global_max_length;
					control_id = self.typeEditor.textDefinition.id;
                } else {
                    console.error(" ##### Entré aquí ##### ");
                }

                const $message_available_length = $("#message_available_length_" + control_id);

                if (!text_value) {
                    text_value = "";
                }
                let remaining_length = max_length - text_value.length;

                $message_available_length.html( new Intl.NumberFormat().format(remaining_length) + " <%=_T('characters')%> | <b><%=_T('Message')%></b>");

                if(remaining_length <= 0) {
                    $("#message_available_length_" + control_id).addClass("red_text");
                } else {
                    $("#message_available_length_" + control_id).removeClass("red_text");
                }
            }
            
		});

		if (activity.type === "CHAT" && self.textDefinition.hyperlinks) {
            $controlTextArea.find(".ic_message_container.textarea").append(self.__makeButtonHyperLink(data));
		}
        else {
            self.textDefinition.hyperlinks = false;
        }
        
        if (self.textDefinition.showMaxLength) {
            if (this.__makeTextLength) { 
                $controlTextArea.append(this.__makeTextLength(data));
            } else {
                $controlTextArea.append(self.__makeTextLength(data));
            }
        }

		if (self.__hasButtons()) {
            $controlTextArea.find(".ic_message_container.textarea").append(self.__makeButtonsList(data));
			$controlTextArea.find(".ic_message_container.textarea").addClass("withBottomButton");
		}

		const $textArea = (activity.messagesEditor.currentType !== "menu") ? activity.__makeDivFlex($controlTextArea, { class: "col-12" }) : activity.__makeDivFlex($controlTextArea, { class: "col-12" });
		  
		// $content.push($textArea);

		return $textArea;
	};


    adm_process_flow_messages_type_text.prototype.__getMaxLength = function() {

        let type = "";

        if (this && this.parent && this && this.parent.activity && this.parent.activity.type) {
            type = this.parent.activity.type.toUpperCase();
        }

        if (type === "CHAT") {
            return 1000;
        } else if (type === "CALL") {
            return 1000;
        } else if (type === "SMS") {
            return 1000;
        } else if (type === "TWITTER_BOT") {
            return 1000;
        } else if (type === "FACEBOOK_BOT") {
            return 1000;
        } else if (type === "INSTAGRAM_BOT") {
            return 1000;
        } else if (type === "WHATSAPP") {
            return 1000;
        } else {
            return 10000;
        }
	};

	adm_process_flow_messages_type_text.prototype.__addButton = function(button, $buttonsList) {
		$buttonsList = $buttonsList || this.$get("[messages_data_type='text']").find("[buttons_list]");
		var buttonConstructor = inConcert.adm_process_flow_messages_button[this.parent.activity.type.toLowerCase()].list;
		var editor = new buttonConstructor(this.parent, button, $buttonsList);
		this.buttons[editor.guid] = editor;
		editor.Make();
	};

    adm_process_flow_messages_type_text.prototype.__makeTextLength = function(data) {

        if (!data.text) {
            data.text = "";
        }
        let max_length = this.__getMaxLength();
        let available_length = new Intl.NumberFormat().format(max_length - data.text.length);

		let self = this;
		self.buttons = {};
		let $body = $(Mustache.render(templates.messages_text_length, {
			id : self.textDefinition.id,
			available_length : available_length,
            max_length : new Intl.NumberFormat().format(max_length),
		}));

		return $body;
	};
	
	adm_process_flow_messages_type_text.prototype.__makeButtonsList = function(data) {
		var self = this;
		self.buttons = {};
		var $body = $(Mustache.render(templates.messages_buttons_list, {
			add_title : "<%=_T('Add Button')%>"
		}));
		$body.find("[add_button]").click(function() {
			self.__addButton();
		});
		var $buttonsList = $body.find("[buttons_list]");
		$.each(data.buttons || [], function(_, button) {
			self.__addButton(button, $buttonsList);
		});
		$buttonsList.sortable({
			cursor : "move"
		});
		return $body;
	};

	adm_process_flow_messages_type_text.prototype.__addHyperLinkForm = function() {
		const self = this;
		const $container = this.$get();
		const editor = new inConcert.adm_process_flow_messages_hyperlink.base(this.parent);
		let activity = this.parent.activity;
		return editor.Make(function (linkData) {
			self.hyperlinkData.push(linkData);
			activity.__setEmojiTextArea(self.textDefinition, $container, activity.__getEmojiHtmlTextArea(self.textDefinition, $container) + format("<a href='{0}' target='_blank'>{1}</a>", linkData.hyperlink, linkData.hyperlink_text));
		});
	};

	adm_process_flow_messages_type_text.prototype.__makeButtonHyperLink = function(data) {
		const self = this;
		const $body = $(templates.messages_hyperlink_button);
		this.hyperlinkData = data.hyperlinks ? data.hyperlinks : [];
		$body.find("[hyperlink_button]").click(function () {
            $body.find("[messages_hyperlink_form]").show();
			$body.find("[messages_hyperlink_form]").append(self.__addHyperLinkForm());
		});
		return $body;
	};

	adm_process_flow_messages_type_text.prototype.__AddDataHyperLinks = function (activity, $container, textDefinition, data) {
		if (this.hyperlinkData && this.hyperlinkData.length) {
			data.hyperlinks = this.hyperlinkData.filter(function (obj) {
				let html = activity.__getEmojiHtmlTextArea(textDefinition, $container);
				let replace = html.replace(/&amp;/g, "&");
				return replace.includes(obj.hyperlink);
			});

			if (data.hyperlinks && data.hyperlinks.length) {
				this.textDefinition.hyperlinks = true;
			}
		}

        let emojioneImgToUnicode = function () {
            activity.__getControl(textDefinition, $container).siblings(".emoji-wysiwyg-editor").find(".img").each(function () {
                let alt = Config.map[$(this).attr("alt").split(":")[1]];
                $(this).replaceWith(alt);
            });
        };

        emojioneImgToUnicode();
	};

	adm_process_flow_messages_type_text.prototype.AfterAppendBody = function($container) {
		const self = this;
		var activity = this.parent.activity;
		activity.__discoverEmojiPickers($container);
		if(activity.data.errorMessage !== null && activity.data.errorMessage !== undefined) {
			$("[embeed_message_toggled]").show();
		}
		self.__addAutocompleteToInput();
	};
	
	adm_process_flow_messages_type_text.prototype.__moveCursorToEnd = function($myDiv) {
		const divContentEditable = $myDiv[0];
		const selection = window.getSelection();
		const range = document.createRange();
		selection.removeAllRanges();
		range.selectNodeContents(divContentEditable);
		range.collapse(false);
		selection.addRange(range);
		divContentEditable.focus();	
	};

	adm_process_flow_messages_type_text.prototype.__addAutocompleteToInput = function () {
		const self = this;
		const main = self.parent.activity.editor.main;
		// const list = main.LoadDeclaredVariables();
		main.LoadVariablesSet();

		function split( val, splitValue ) {
			// return val.split( /\{/i );
			return val.split( splitValue );

		}
		  
		function extractLast( term, splitValue ) {
			return split( term, splitValue ).pop();
		}
	
		$("[flow_designer_text_area_message]").each(function() {
			let $textArea = $(this);
			let $textAreaCol = $textArea.closest(".col-12");
			let $asociatedDiv = $textAreaCol.find(".emoji-wysiwyg-editor");

			if ($textArea.autocomplete( "instance" )) {
				return;
			}
			$textArea.on( "keydown", function( event ) {
				if ( event.keyCode === $.ui.keyCode.TAB &&
					$( this ).autocomplete( "instance" ).menu.active ) {
					event.preventDefault();
				}
				})
				.autocomplete({
					minLength: 1,
					// search: function( event, ui ) {},
					source: function( request, response ) {
						const typedValue = extractLast(request.term, " ");
						if (!typedValue.startsWith("{")) {
							return [];
						}

						let searchValue = extractLast(request.term, "{");
						var matcher = new RegExp( "^" + $.ui.autocomplete.escapeRegex( searchValue ), "i" );
						let resultList = $.grep( Array.from(main.variables), function( item ){
							return matcher.test( item );
						});
						response( resultList );
						},
					focus: function() {
						// prevent value inserted on focus
						return false;
					},
					select: function( _, ui ) {
						var terms = split( this.value, " " );
						// remove the current input
						terms.pop();
						// add the selected item
						terms.push( "{{" + ui.item.value + "}}" );
						// add placeholder to get the comma-and-space at the end
						terms.push( "" );
						this.value = terms.join( " " );
						$asociatedDiv.text($textArea.val());
						self.__moveCursorToEnd($asociatedDiv);
						return false;
					}
				});

			$textArea.autocomplete( "option", "position", { my : "left top", at: "left bottom", of: $textAreaCol } ); 

			$textArea.change(function() {
				$textArea.autocomplete("search", $asociatedDiv.text());
			});
		});

		$("[id*='ui-id']").css("z-index", 119);
	};

	adm_process_flow_messages_type_text.prototype.__getButtons = function() {
		var self = this;
		var buttons = [];
		if (!this.__hasButtons()) {
			return buttons;
		}
		self.$get("[template_button]").each(function() {
			var guid = $(this).attr("template_button");
			var editor = self.buttons[guid];
			var data = editor && editor.GetData();
			if (data) {
				if (!data.port_id) {
					data.port_id = guid;
				}
				buttons.push(data);
			}
		});
		return buttons;
	};

	adm_process_flow_messages_type_text.prototype.AddValue = function(data) {
		let activity = this.parent.activity;
		let $container = this.$get();
		this.__AddDataHyperLinks(activity, $container, this.textDefinition, data);
		activity.__addValue(data, this.textDefinition, $container);
		data.buttons = this.__getButtons();
	};

//shared files selector

	function sharedFilesSelector(data, onClose) {
		sharedFilesSelector.uber.constructor.call(this);
		this.data = data;
		this.onClose = onClose;
        this.showEditTitleButton = false;
	}

	inConcert.Utils.inherit( sharedFilesSelector, inConcert.adm_process_flow_popup );

	// if (typeof inConcert.adm_process_flow_shared_files_selector !== "function") {
	// 	inConcert.adm_process_flow_shared_files_selector = sharedFilesSelector;
	// }

	sharedFilesSelector.prototype.__getPopupId = function() {
		return "flowDesignerSharedFilesSelectorPopup";
	};

	sharedFilesSelector.prototype.__getClassName = function() {
		return "flowDesignerSharedFilesSelectorPopup sharedFileSelectorPopup";
	};

	sharedFilesSelector.prototype.__getTitle = function() {
		return "<%=_T('Select a file')%>";
	};

	sharedFilesSelector.prototype.__makeContent = function() {
		const self = this;

		let search_files_type_id, abm_files_type_id;
		if (this.data.channel === "CALL") {
			search_files_type_id = "asterisk_audio";
			abm_files_type_id = "asterisk_audio";
		}
		else {
			search_files_type_id = this.data.type;
			abm_files_type_id = this.data.type;
		}

		this.m_sharedFilesList = new inConcert.SharedFilesList({
			fileTypes: [{
				id        : this.data.type,
				name      : this.data.typeName,
				extensions: this.data.typeExtensions
			}],
			fileTypesFilter      : false,
			maxSize              : this.data.sizeLimit,
			agentVisible         : false,
			can_create_new_file  : true,
			create_file_and_quit : true,
			visibility           : {
				AgentVisible          : false,
				AccountMessagesVisible: false,
				FlowDesignerVisible   : true
			},
			$get_save_btn        : function() {
				return self.$get_save_action();
			},
			ownerId              : this.__getPopupId(),
			owner                : this,
			option_id            : this.data.type, //"audio", etc
			search_files_type_id : search_files_type_id,
			abm_files_type_id    : abm_files_type_id,
			callbacks: {
				on_show_maintenance: function() {
					let $actions = self.$get_actions();
					$actions.hide();
				},
				on_hide_maintenance: function() {
					let $actions = self.$get_actions();
					$actions.show();
				}
			}
		});
		const $list = this.m_sharedFilesList.make();
		this.m_sharedFilesList.start();
		return $list;
	};

	sharedFilesSelector.prototype.__getAndValidate = function() {
		let selected_file = this.m_sharedFilesList.getSelectedFile();
		if (selected_file) {
			// ok
			return selected_file;
		}
		// error
		return {error: {message: "<%=_T('Must select a file.')%>"}};
	};

	sharedFilesSelector.prototype.__save = function(sharedFile, callback) {
		this.onClose(sharedFile);
		callback(true);
	};

	sharedFilesSelector.prototype.__cancel = function(callback) {
		this.onClose();
		callback();
	};

//attachment

	function adm_process_flow_messages_type_attachment(parent, options) {
		adm_process_flow_messages_type_attachment.uber.constructor.call(this, parent, options);

		const self = this;

		this.fileTypeDefinition = {
			id : "fileType",
			name : "<%=_T('File Type')%>",
			description : "<%=_T('Type of attachment file.')%>",
			required : true,
			not_extended : true,
			options : [
				{
					id : "image",
					name : "<%=_T('Image')%>"
				}
			],
			change : function() {
				self.__reloadAttachment();
			},
            form_group: true 
		};

		//Not allowed file types on instagram direct message conversation through its API
		if(parent.activity.type !== "INSTAGRAM_BOT")
		{
			this.fileTypeDefinition.options.push(
				{
					id : "audio",
					name : "<%=_T('Audio')%>"
				}
			);
			this.fileTypeDefinition.options.push(
				{
					id : "video",
					name : "<%=_T('Video')%>"
				},
			);
			this.fileTypeDefinition.options.push(
				{
					id : "file",
					name : "<%=_T('File')%>"
				}
			);
		}

		this.attachmentTypeDefinition = {
			id : "attachmentType",
			name : "<%=_T('Source')%>",
			description : "<%=_T('File source.')%>",
			required : true,
			not_extended : true,
			options : [
				{
					id : "url",
					name : "<%=_T('Url')%>",
					description : "<%=_T('Send file from an url.')%>"
				},
				{
					id : "shared_file",
					name : "<%=_T('Shared file')%>",
					description : "<%=_T('Select a file from shared files list.')%>"
				}
			],
			change : function() {
				self.__reloadAttachment();
			},
            form_group: true
		};

		this.urlDefinition = {
			id : "url",
			name : "<%=_T('Url')%>",
			description : "<%=_T('Url from file to be sent (you can use {{ }} to enter variables).')%>",
			required : true,
			change : function() {
				self.__reloadAttachment();
			},
            variable: true,
            span: true,
            spanClass: "ic_variable_icon_container",
            variableIconClass: "ic_variable_icon far fa-at",
            form_group: true,
			brackets : true
		};
	}

	inConcert.Utils.inherit( adm_process_flow_messages_type_attachment, inConcert.adm_process_flow_messages_type.base.base );

	if (typeof inConcert.adm_process_flow_messages_type.base.attachment !== "function") {
		inConcert.adm_process_flow_messages_type.base.attachment = adm_process_flow_messages_type_attachment;
	}

	adm_process_flow_messages_type_attachment.prototype.name = "<%=_T('Attachment')%>";
	adm_process_flow_messages_type_attachment.prototype.description = "<%=_T('Attachment file.')%>";

	adm_process_flow_messages_type_attachment.prototype.GetMigrationRepositoryFiles = function(_, _1, data) {
		let files = [];
		if (data.message && data.message.attachmentType === "repository" && data.message.fileId) {
			files.push({
				id : data.message.fileId
			});
		}
		return files;
	};

	adm_process_flow_messages_type_attachment.prototype.GetMigrationSharedFiles = function(_, _1, data) {
		let files = [];
		if (data.message && data.message.attachmentType === "repository") {
			if (data.message.sharedFile) {
				// canales sin multiples mensajes
				files.push({
					id: data.message.sharedFile
				});
			}
			else if (data.message.options) {
				// canales con multiples mensajes
				for (let i = 0; i < data.message.options.length; i++) {
					let option = data.message.options[i];
					if (option.MessageType.toLowerCase() === "audio") {
						files.push({
							id: option.sharedFile
						});
					}
				}
			}
		}
		return files;
	};

	adm_process_flow_messages_type_attachment.prototype.__getAttachmentSizeLimitMb = function() {
		return 16;
	};

	adm_process_flow_messages_type_attachment.prototype.__getAttachmentSizeLimit = function() {
		return this.__getAttachmentSizeLimitMb() * 1024 * 1024;
	};

	adm_process_flow_messages_type_attachment.prototype.__getFileTypeDefinition = function(fileType) {
		return inConcert.FileUploaderTypes[fileType];
	};

	adm_process_flow_messages_type_attachment.prototype.__getUploaderType = function() {
		let fileType = this.parent.activity.__getValue(this.fileTypeDefinition);
		return this.__getFileTypeDefinition(fileType);
	};

	adm_process_flow_messages_type_attachment.prototype.displayStatusMessage = function(msg_error/*, msg_type, timemout_ms*/) {
		this.parent.activity.__showError(msg_error);
	};

	adm_process_flow_messages_type_attachment.prototype.find_message = function(msg_id) {
		return this.__findMultiSharedFilesMessageConfig(msg_id);
	};

	adm_process_flow_messages_type_attachment.prototype.__findMultiSharedFilesMessageConfig = function(/*msg_id  el id de la grilla */) {
		return this.m_sharedFilesCurrentMessage;
	};

	adm_process_flow_messages_type_attachment.prototype.setMultiSharedFilesMessage = function(messageDef) {
		this.m_sharedFilesCurrentMessage = {
			allowsVariables: true, // si el atributo no se encuentra o se define como undefined el mismo vale TRUE
			maxAudioFiles  : -1    // si el atributo no se encuentra o se define como undefined el tope es infinito
		};
		if (messageDef) {
			if (messageDef.allowsVariables !== undefined) {
				this.m_sharedFilesCurrentMessage.allowsVariables = messageDef.allowsVariables;
			}
			if (messageDef.maxAudioFiles !== undefined) {
				this.m_sharedFilesCurrentMessage.maxAudioFiles = messageDef.maxAudioFiles;
			}
		}
	};

	adm_process_flow_messages_type_attachment.prototype.__LoadMultiSharedFiles = function() {
		const self = this;

		if (!this.canSupportsMultipleSharedFiles()) {
			return;
		}
		if (!this.m_grdMultiMessages) {
			return;
		}
		if (this.m_grdMultiMessages[this.m_gridId]) {
			return;
		}

		this.setMultiSharedFilesMessage();
		this.m_hndMultiSharedFiles = null;
		this.m_grdMultiMessages[this.m_gridId] = new inConcert.adm_form_multi_messages(this, {
			grid_id: self.m_gridId,
			isTtsNotAllowed: true,
			isAllowedCustomVariables: true,
			ownerName: "flow designer",
			visibility: {
				AgentVisible          : false,
				AccountMessagesVisible: false,
				FlowDesignerVisible   : true
			},
			callbacks: {
				show_status_message: function(message, msg_type, timemout_ms) {
					self.displayStatusMessage(message, msg_type, timemout_ms);
				}
			}
		});

		let components = [];
		if (this.data.sharedFile) {
			// compatibilidad con flow anteriores.
			components = [{Id: this.data.sharedFile, MessageType: "audio"}];
		}
		else {
			components = this.data.options || [];
		}
		let rows = [];
		const onLoaded = function () {
			if (rows.length < components.length) {
				return false;
			}
			// se completo
			self.m_grdMultiMessages[self.m_gridId].fill_grid_rows(self.m_gridId, rows);
		};
		//
		let sharedFilesIds = {};
		let hasSharedFiles = false;
		for (let i = 0; i < components.length; i++) {
			let component = components[i];
			if (component.MessageType === "audio") {
				sharedFilesIds[component.Id.toLowerCase()] = true;
				hasSharedFiles = true;
			}
		}
		const fillGrid = function() {
			for (let i = 0; i < components.length; i++) {
				let component = components[i];
				let rowInfo = {};
				if (component.MessageType === "audio") {
					let sharedFile = sharedFilesIds[component.Id.toLowerCase()];
					rowInfo.Id = sharedFile.Id;
					rowInfo.sharedFile = sharedFile.Id;
					rowInfo.Name = sharedFile.Name || component.Id;
					rowInfo.MessageType = "audio";
					rowInfo.RawData = component.RawData || sharedFile || {};
				}
				else {
					rowInfo = component;
				}
				rows.push(rowInfo);
			}
			onLoaded();
		};
		if (!hasSharedFiles) {
			fillGrid();
			return;
		}

		let api = inConcert.app.getSharedFilesAPI();
		api.getFilesByIds(sharedFilesIds, function(status, sharedFiles) {
			if (!status) {
				//TODO: message error
				return;
			}
			sharedFilesIds = sharedFiles;
			fillGrid();
		});
	};

	adm_process_flow_messages_type_attachment.prototype.__MakeMultiSharedFiles = function() {
		const self = this;
		this.m_grdMultiMessages = this.m_grdMultiMessages || {};
		this.m_gridId = this.m_gridId || inConcert.Utils.generateGuid();

        const $markup = $(Mustache.render(templates.messages_add_shared_files, {
			control_id: this.m_gridId,
			hasTitle: false,
            title: (self.options.embedded?"<%=_T('Setup error message')%>":""),
			justifyContentHeader: "justify-content-end" //justify-content-between
		}));

		let event_selector = "[ctrl_type='new_shared_file']";
		$markup.off("click", event_selector)
			.on("click", event_selector, function() {
				const $this = $(this);
				self.m_grdMultiMessages[self.m_gridId].show_file_contextual_menu($this);
			}
		);
		this.frm = this.parent.activity.editor.main.frm;
		return $markup;
	};

	adm_process_flow_messages_type_attachment.prototype.canSupportsMultipleSharedFiles = function() {
		return this.supportsMultipleSharedFiles;
	};

	adm_process_flow_messages_type_attachment.prototype.Make = function(data, supportsMultipleSharedFiles) {

        this.supportsMultipleSharedFiles = supportsMultipleSharedFiles;
		this.data = JSON.parse(JSON.stringify(data));
		if (this.data[this.attachmentTypeDefinition.id] === "repository" && (this.data.sharedFile || supportsMultipleSharedFiles)) {
			this.data[this.attachmentTypeDefinition.id] = "shared_file";
		}
		this.fileTypeDefinition.hidden = this.fileTypeDefinition.options.length <= 1;
		this.attachmentTypeDefinition.hidden = this.attachmentTypeDefinition.options.length <= 1;

		let activity = this.parent.activity;
		let $content = [];

        $content.push(
            activity.__makeDivFlex(
                activity.__makeComboFlex(this.fileTypeDefinition, this.data[this.fileTypeDefinition.id]),{ class: "col-12" }
            )
        );

        $content.push(
            activity.__makeDivFlex(
                activity.__makeComboFlex(this.attachmentTypeDefinition, this.data[this.attachmentTypeDefinition.id]),{ class: "col-4", hidden: (this.attachmentTypeDefinition.options.length <= 1) }
            )
        );

        $content.push(
            activity.__makeDivFlex(
                activity.__makeInputFlex(this.urlDefinition, this.data[this.urlDefinition.id]),{ class: "col-8" }
            )
        );

        if (supportsMultipleSharedFiles) {
			const $markup = this.__MakeMultiSharedFiles();
			$content.push($markup);
		}

        $content.push(
			activity.__makeDivFlex(
				activity.__makeDivFlex(
					$(templates.messages_attachment_shared_file_selector), { class: "form-group" }
						), { class: "col-8 align-self-end" }
					)
				);
		$content.push($(templates.messages_attachment_upload));
		$content.push($(templates.messages_attachment_preview));

		return $content;
	};

	adm_process_flow_messages_type_attachment.prototype.AfterAppendBody = function() {
		this.__LoadMultiSharedFiles();
		this.__reloadAttachment();
	};

	adm_process_flow_messages_type_attachment.prototype.__reloadAttachment = function() {
		let attachmentType = this.parent.activity.__getValue(this.attachmentTypeDefinition, this.$get());
		if (attachmentType === "url") {
			this.__hideSharedFileAttachment();
			this.__hideRepositoryAttachment();
			this.__showUrlAttachment();
		}
		else if (attachmentType === "shared_file" || attachmentType === undefined) {
			this.__hideUrlAttachment();
			this.__hideRepositoryAttachment();
			this.__showSharedFileAttachment();
		}
		else if (attachmentType === "repository") {
			this.__hideUrlAttachment();
			this.__hideSharedFileAttachment();
			this.__showRepositoryAttachment();
		}
	};

	adm_process_flow_messages_type_attachment.prototype.__showUrlAttachment = function() {
		if (!this.urlUploader) {
			this.__loadUrlAttachment();
		}
		this.__updateUrlAttachment();
		this.parent.activity.__showControl(this.urlDefinition, this.$get());
		this.$get("[attachment_preview='url']").show();
	};

	adm_process_flow_messages_type_attachment.prototype.__loadUrlAttachment = function() {
		this.urlUploader = new inConcert.FileUploaderControl({
			preview : {
				$control : this.$get("[attachment_preview='url']"),
				canRemove : false,
				name : false,
				size : false
			},
			type : this.__getUploaderType(),
			disabled : true,
			alwaysValid : true
		});
	};

	adm_process_flow_messages_type_attachment.prototype.__updateUrlAttachment = function() {
		this.urlUploader.changeType(this.__getUploaderType());
		let url = this.parent.activity.__getValue(this.urlDefinition, this.$get());
		let currentFile = this.urlUploader.getFile();
		if (url && (!currentFile || currentFile.url !== url)) {
			this.urlUploader.addInitialFile({
				id : "dummy",
				url : url,
				file : this.urlUploader.makeManualFile({
					name : "dummy",
					type : "dummy",
					size : 1
				}),
				uploaded : true
			});
		}
		else if (!url) {
			this.urlUploader.cleanAllFiles();
		}
	};

	adm_process_flow_messages_type_attachment.prototype.__hideUrlAttachment = function() {
		this.parent.activity.__hideControl(this.urlDefinition, this.$get());
		this.$get("[attachment_preview='url']").hide();
	};

	adm_process_flow_messages_type_attachment.prototype.__showSharedFileAttachment = function() {
		if (this.canSupportsMultipleSharedFiles()) {
			this.$get("[attachment_shared_file_selector_container]").parent().parent().hide();
			this.$get("[attachment_shared_file_selector_container]").hide();
			this.$get("[attachment_preview='shared_file']").hide();
			return;
		}
		if (!this.sharedFile) {
			this.__loadSharedFileAttachment();
		}
		else {
			this.__updateSharedFileAttachment();
		}
		this.$get("[attachment_shared_file_selector_container]").parent().parent().show();
		this.$get("[attachment_shared_file_selector_container]").show();
		this.$get("[attachment_preview='shared_file']").show();
	};

	adm_process_flow_messages_type_attachment.prototype.__setSharedFileAttachment = function(sharedFile) {
		this.sharedFile = sharedFile;
		this.sharedFileUploader.addInitialFile({
			id : sharedFile.RepositoryId,
			file : this.sharedFileUploader.makeManualFile({
				name : sharedFile.Name,
				type : sharedFile.ContentType,
				size : sharedFile.Size
			}),
			uploaded : true
		});
	};

	adm_process_flow_messages_type_attachment.prototype.__loadSharedFileAttachment = function() {
		const self = this;

		this.$get("[attachment_shared_file_selector]").click(function() {
			self.__showSharedFilesSelector();
		});

		this.sharedFileUploader = new inConcert.FileUploaderControl({
			preview : {
				$control : self.$get("[attachment_preview='shared_file']"),
				canRemove : false
			},
			type : self.__getUploaderType(),
			sizeLimitMB : self.__getAttachmentSizeLimitMb(),
			disabled : true
		});

		if (this.data.sharedFile) {
			let api = inConcert.app.getSharedFilesAPI();
			api.getFile({fileId : self.data.sharedFile}, function(status, sharedFile) {
				if (status) {
					self.__setSharedFileAttachment(sharedFile);
				}
			});
		}
	};

	adm_process_flow_messages_type_attachment.prototype.__showSharedFilesSelector = function() {
		const self = this;
		let fileType = this.__getUploaderType();
		let channel = this.parent.activity.type.toUpperCase();

		let popup = new sharedFilesSelector(
			{
				type          : fileType.id,
				typeName      : this.parent.activity.__getComboLabel(this.fileTypeDefinition, self.$get()),
				typeExtensions: fileType.extensions,
				sizeLimit     : this.__getAttachmentSizeLimit(),
				channel       : channel
			},
			function(sharedFile) {
				if (sharedFile) {
					self.__setSharedFileAttachment(sharedFile);
				}
			}
		);
		popup.Show();
	};

	adm_process_flow_messages_type_attachment.prototype.__updateSharedFileAttachment = function() {
		this.sharedFileUploader.changeType(this.__getUploaderType());
	};

	adm_process_flow_messages_type_attachment.prototype.__hideSharedFileAttachment = function() {
		this.$get("[attachment_shared_file_selector_container]").parent().parent().hide();
		this.$get("[attachment_shared_file_selector_container]").hide();
		this.$get("[attachment_preview='shared_file']").hide();
	};

	adm_process_flow_messages_type_attachment.prototype.__showRepositoryAttachment = function() {
		if (!this.repositoryUploader) {
			this.__loadRepositoryAttachment();
		}
		else {
			this.__updateRepositoryAttachment();
		}
		this.$get("[attachment_upload]").show();
		this.$get("[attachment_preview='repository']").show();
	};

	adm_process_flow_messages_type_attachment.prototype.__loadRepositoryAttachment = function() {
		let self = this;
		self.repositoryUploader = new inConcert.FileUploaderControl({
			uploader : {
				$control : self.$get("[attachment_upload]")
			},
			dragger : {
				$control : self.$get("[attachment_upload]")
			},
			preview : {
				$control : self.$get("[attachment_preview='repository']"),
				canRemove : false
			},
			type : self.__getUploaderType(),
			sizeLimitMB : self.__getAttachmentSizeLimitMb()
		});
		self.repositoryUploader.onFileAddError = function(_, result, callback) {
			self.parent.activity.__showError(result.reason, null, 3000);
			callback();
		};
		if (self.data.fileId && !self.data.sharedFile) {
			self.repositoryUploader.addInitialRepositoryFile({
				id : self.data.fileId,
				uploaded : true
			});
		}
	};

	adm_process_flow_messages_type_attachment.prototype.__updateRepositoryAttachment = function() {
		this.repositoryUploader.changeType(this.__getUploaderType());
	};

	adm_process_flow_messages_type_attachment.prototype.__hideRepositoryAttachment = function() {
		this.$get("[attachment_upload]").hide();
		this.$get("[attachment_preview='repository']").hide();
	};

	adm_process_flow_messages_type_attachment.prototype.AddValueAsync = function(data, callback) {
		let activity = this.parent.activity;
		let $container = this.$get();
		activity.__addValue(data, this.attachmentTypeDefinition, $container);
		activity.__addValue(data, this.fileTypeDefinition, $container);

		switch(data[this.attachmentTypeDefinition.id]) {
			case "url":
				this.__addUrlValue(data, callback);
				break;
			case "shared_file":
				this.__addSharedFileValues(data, callback);
				break;
			case "repository":
				this.__addRepositoryValue(data, callback);
				break;
			default:
				callback();
				break;
		}
	};

	adm_process_flow_messages_type_attachment.prototype.__addUrlValue = function(data, callback) {
		let activity = this.parent.activity;
		activity.__addValue(data, this.urlDefinition, this.$get());
		callback();
	};

	adm_process_flow_messages_type_attachment.prototype.__getMultiMessages = function() {
		let items = this.m_grdMultiMessages[this.m_gridId].get_items(this.m_gridId);
		let options = [];
		for (let i = 0; i < items.length; i++) {
			let item = items[i];
			item.type = "file";
			let messageType = (item.MessageType || "").toLowerCase();
			if (messageType === "audio") {
				item.sharedFile = item.Id;
			}
			else if (messageType === "variable") {
				item.message = item.VariableId;
				item.type = item.Engine.toLowerCase();
			}
			else {
				throw("adm_process_flow_messages_type_attachment.prototype.__getMultiMessages - Unrecognized MessageType " + messageType);
			}
			delete item.RawData;
			options.push(item);
		}
		return options;
	};

	adm_process_flow_messages_type_attachment.prototype.__validateMultiSharedFileValues = function() {
		let response = {success: false};
		let multiMessages = this.__getMultiMessages();

		if (!multiMessages || multiMessages.length === 0) {
			// error
			response.success = false;
			response.err = "<%=_T('You must add at least one component.')%>";
			return response;
		}

		let config = this.__findMultiSharedFilesMessageConfig();
		if (config) {
			if (!config.allowsVariables || config.maxAudioFiles > -1) {
				let totalAudioFiles = 0;
				for (let i = 0; i < multiMessages.length; i++) {
					let message = multiMessages[i];
					if (!config.allowsVariables && message.MessageType === "variable") {
						// error
						response.success = false;
						response.err = "<%=_T('The message does not support variables.')%>";
						return response;
					}
					if (message.MessageType === "audio") {
						totalAudioFiles++;
						if (totalAudioFiles > config.maxAudioFiles) {
							// error
							response.success = false;
							response.err = config.maxAudioFiles === 1 ? "<%=_T('The message does not support more than {0} file.')%>" : "<%=_T('The message does not support more than {0} files.')%>";
							return response;
						}
					}
				}
			}
		}

		// ok
		response.success = true;
		response.multiMessages = multiMessages;
		return response;
	};

	adm_process_flow_messages_type_attachment.prototype.__addSharedFileValues = function(data, callback) {
		data[this.attachmentTypeDefinition.id] = "repository";
		if (this.canSupportsMultipleSharedFiles()) {
			let response = this.__validateMultiSharedFileValues();
			if (response.success) {
				data.options = response.multiMessages;
				delete data.sharedFile;
			}
			else {
				data.error = {
					message: response.err
				};
			}
		}
		else {
			if (this.sharedFile) {
				data.sharedFile = this.sharedFile.Id;
			}
			else {
				data.error = {
					message : "<%=_T('Must select a file.')%>"
				};
			}
		}
		callback();
	};

	adm_process_flow_messages_type_attachment.prototype.__addRepositoryValue = function(data, callback) {
		let self = this;
		//get file
		let fileData = self.repositoryUploader.getFile();
		if (!fileData) {
			data.error = {
				message : "<%=_T('Must upload a file.')%>"
			};
			return callback();
		}
		//load data
		data.fileId = fileData.id;
		data.fileName = self.repositoryUploader.getFileName(fileData.file);
		data.mimeType = self.repositoryUploader.getFileType(fileData.file);
		data.extension = self.repositoryUploader.getFileExtension(fileData.file);
		if (fileData.uploaded) {
			return callback();
		}
		//upload file
		self.repositoryUploader.uploadFile(fileData, function(result) {
			if (!self.repositoryUploader.__isOk(result)) {
				data.error = {
					message : "<%=_T('Error uploading file to server.')%>"
				};
			}
			callback();
		});
	};

	//HSM BUTTON INIT
	function adm_process_flow_messages_template_button(parent, $list, button) {
		this.$list = $list;
		this.guid = inConcert.Utils.generateGuid();
		this.data = button;
		this.parent = parent;
		this.data.title = this.data.title || this.data.payload;
		//this.data.urlButtonSufix = this.data.urlButtonSufix || this.data.payload;

		//postback
		var main = this.parent.activity.editor.main;
		this.stateDefinition = {
			id: "payload",
			name: "<%=_T('State')%>",
			not_extended: true,
			required : true,
			description: "<%=_T('Process state to be executed.')%>",
			options: main.GetStatesList(),
            form_group: true
		};		

		//call to action button
		this.callToActionButtonDefinition = {
			id : "payload",
			name : "<%=_T('Resource')%>",
			description : "<%=_T('Resource to be added to the url to be open (you can use {{ }} to enter variables).')%>",
			required : true,
			brackets : true
		};		
	}

	adm_process_flow_messages_template_button.prototype.Make = function (callback) {
		var self = this;
		self.$button = $(Mustache.render(templates.messages_hsm_button, {
			guid: this.guid
		}));

		if (!self.data.readOnly) {
			self.$button.find("[button_view]").click(function () {
				if (self.$list.find(".editMode").length) {
					return;
				}
				self.__editMode();
			});

			self.$button.find("[button_action=save]").click(function () {
				self.__saveEdit();
			});
			self.$button.find("[button_action=cancel]").click(function () {
				self.__cancelEdit();
			});
		}

		this.data.payload = (this.data.type === "call_to_action" && this.data.urlButtonParam) ? this.data.payload : this.__getInitialState();
		this.data.guid = this.guid;
		callback(this.data);
		self.$list.append(self.$button);

		//Los botones de templates AUTHENTICATION no se muestran
		self.$button.hide(this.data.otp_type);
		
		self.__viewMode();
	};
	adm_process_flow_messages_template_button.prototype.__getInitialState = function () {
		var options = this.stateDefinition.options;
		return options.find(state => state.id === this.data.payload) === undefined ? options[0].id : this.data.payload;
	};

	adm_process_flow_messages_template_button.prototype.__viewMode = function () {
		this.parent.activity.SelfOverlay(false);
		var viewData = this.__postbackViewData();
		this.$button.find("[button_title]").text(this.data.title);
		this.$button.find("[button_subtitle]").text(viewData.subtitle);
		this.$button.removeClass("editMode");
	};

	adm_process_flow_messages_template_button.prototype.__editMode = function () {
		this.parent.activity.SelfOverlay(true);
		this.$button.addClass("editMode");
		this.__MakeControl();
		this.parent.activity.ScrollTo(this.$button.find("[button_edit]"));
	};

	adm_process_flow_messages_template_button.prototype.__saveEdit = function () {
		this.parent.activity.__clearErrors();
		var data = {};
		this.__postbackAddData(data);
		this.data.payload = data.payload;
		//this.data.urlButtonSufix = data.urlButtonSufix;
		this.data.__brackets_payload = data.__brackets_payload;
		this.__viewMode();
	};

	adm_process_flow_messages_template_button.prototype.__cancelEdit = function () {
		this.__viewMode();
	};

	adm_process_flow_messages_template_button.prototype.__postbackViewData = function () {
		var stateId = this.data[this.stateDefinition.id];
		return {
			subtitle: this.parent.activity.editor.main.GetStateName(stateId)
		};
	};
	adm_process_flow_messages_template_button.prototype.__MakeControl = function () {
		if (this.$typeControls) {
			$.each(this.$typeControls, function (_, $control) {
				$control.remove();
			});
		}
		this.$typeControls = this.__postbackMakeEditControls();
		this.$button.find("[button_edit_form]").append(this.$typeControls);
	};

	adm_process_flow_messages_template_button.prototype.__postbackMakeEditControls = function () {
        let activity = this.parent.activity;
        let $controls = [];
		if(this.data.type === "call_to_action" && this.data.urlButtonParam) {
			$controls.push(activity.__makeRowFlex(activity.__makeInputFlex(this.callToActionButtonDefinition, this.data[this.callToActionButtonDefinition.id])));
		}
		else {
			$controls.push(activity.__makeRowFlex(activity.__makeComboFlex(this.stateDefinition, this.data[this.stateDefinition.id])));
		}
		return $controls;
	};

	adm_process_flow_messages_template_button.prototype.__postbackAddData = function (data) {
		var activity = this.parent.activity;		
		activity.__addValue(data, (this.data.type === "call_to_action" && this.data.urlButtonParam) ? this.callToActionButtonDefinition : this.stateDefinition, this.$button);
	};

//template

	function adm_process_flow_messages_type_template(parent) {
		var self = this;
		adm_process_flow_messages_type_template.uber.constructor.call(this, parent);

		this.messageSources = [
			{
				id : "account",
				name : "<%=_T('From account')%>",
				description : "<%=_T('A fixed message that belongs to an account.')%>"
			}/*,
			{
				id : "variable",
				name : "<%=_T('Manual')%>",
				description : "<%=_T('Message is set manually.')%>"
			}*/
		];

		this.accountDefinition = {
			id : "account",
			name : "<%=_T('Account')%>",
			description : "<%=_T('Template messages account.')%>",
			required : true,
			not_extended : true,
			sort : true,
			change : function() {
				self.__loadAccountGroups();
			},
            form_group: true
		};

		this.groupDefinition = {
			id : "group",
			name : "<%=_T('Group')%>",
			description : "<%=_T('Template messages group.')%>",
			required : true,
			not_extended : true,
			sort : true,
			hidden : true,
			change : function() {
				self.__loadAccountMessages();
			},
            form_group: true
		};

		this.messageIdDefinition = {
			id : "id",
			name : "<%=_T('Message Id')%>",
			description : "<%=_T('Message id.')%>",
			required : true,
			not_extended : true,
			sort : true,
			change : function() {		
				self.__loadAccountLanguages();
			},
            form_group: true
		};

		this.languageDefinition = {
			id : "language",
			name : "<%=_T('Language')%>",
			description : "<%=_T('Message language.')%>",
			required : true,
			not_extended : true,
			hidden : true,
            form_group: true,
            change : function() {		
				self.__loadAccountTemplate();
			}
		};

	}

	inConcert.Utils.inherit( adm_process_flow_messages_type_template, inConcert.adm_process_flow_messages_type.base.base );

	if (typeof inConcert.adm_process_flow_messages_type.base.template !== "function") {
		inConcert.adm_process_flow_messages_type.base.template = adm_process_flow_messages_type_template;
	}

	adm_process_flow_messages_type_template.prototype.name = "<%=_T('Template')%>";
	adm_process_flow_messages_type_template.prototype.description = "<%=_T('Template message.')%>";

	adm_process_flow_messages_type_template.prototype.__accountMake = function(data) {
        let activity = this.parent.activity;
        let $content = [];

        $content.push(
            activity.__makeDivFlex(activity.__makeComboFlex(this.accountDefinition, data && data.template[this.accountDefinition.id]),{ class: "col-12" })
        );

        $content.push(
            activity.__makeDivFlex(activity.__makeComboFlex(this.groupDefinition, data && data.template[this.groupDefinition.id]),{ class: "col-12" })
        );

        $content.push(
            activity.__makeDivFlex(activity.__makeComboFlex(this.messageIdDefinition, data && data.template[this.messageIdDefinition.id]),{ class: "col-12" })
        );

        $content.push(
            activity.__makeDivFlex(activity.__makeComboFlex(this.languageDefinition, data && data.template[this.languageDefinition.id]),{ class: "col-12" })
        );

        $content.push($(templates.messages_template_header_text));
		$content.push($(templates.messages_template_text));
		$content.push($(templates.messages_hsm_buttons_list));
		return $content;
	};

	adm_process_flow_messages_type_template.prototype.__accountAfterAdd = function(data, $data) {
		let self = this;
		let activity = this.parent.activity;
		activity.editor.GetTemplateMessageOptions(function(accounts) {
			if (!accounts) {
				self.parent.activity.__showError("<%=_T('Error loading template messages')%>");
				return;
			}
			self.__accountsOptions = {};
			self.accountDefinition.options = [];
			$.each(accounts, function(_, account) {
				self.accountDefinition.options.push({ id : account.id, name : account.name, language : account.language });
				self.__accountsOptions[account.id] = account.options;
			});
			activity.__replaceControl(self.accountDefinition,
				activity.__makeComboFlex(self.accountDefinition, data.template[self.accountDefinition.id]), $data);
			self.__loadAccountGroups(data, $data);
		});
	};

	adm_process_flow_messages_type_template.prototype.__loadAccountGroups = function(data, $data) {
		var self = this;
		data = data || {};
		var activity = this.parent.activity;
		data.template = data.template || {};
		var accountId = activity.__getValue(self.accountDefinition, $data);
		if (!accountId) {
			return;
		}
		self.__accountLanguage = self.accountDefinition.options.find(option => option.id === accountId).language;
		var options = self.__accountsOptions[accountId];
		self.templateMessageOptions = {};
		self.groupDefinition.options = [];
		$.each(options, function(_, option) {
			if (!option.available) {
				return;
			}
			var group;
			if (self.templateMessageOptions[option.groupId]) {
				group = self.templateMessageOptions[option.groupId];
			}
			else {
				group = {
					groupId : option.groupId,
					groupName : option.groupName || option.groupId,
					messages : {}
				};
				self.templateMessageOptions[option.groupId] = group;
				self.groupDefinition.options.push({ id : group.groupId, name : group.groupName });
			}
			group.messages[option.id] = option;
		});
		self.groupDefinition.hidden = self.groupDefinition.options.length < 2;
		activity.__replaceControl(self.groupDefinition,
			activity.__makeCombo(self.groupDefinition, data.template[self.groupDefinition.id]), $data);
		self.__loadAccountMessages(data, $data);
	};

	adm_process_flow_messages_type_template.prototype.__loadAccountMessages = function(data, $data) {
		var self = this;
		data = data || {};
		data.template = data.template || {};
		var activity = this.parent.activity;
		var groupId = activity.__getValue(self.groupDefinition, $data);
		if (!groupId) {
			return;
		}
		var messages = self.templateMessageOptions[groupId].messages;
		self.messageIdDefinition.options = [];
		$.each(messages, function(_, message) {
			self.messageIdDefinition.options.push({ id : message.id, name : message.name || message.id });
		});
		activity.__replaceControl(self.messageIdDefinition,
			activity.__makeCombo(self.messageIdDefinition, data.template[self.messageIdDefinition.id]), $data);
		self.__loadAccountLanguages(data, $data);
	};

	adm_process_flow_messages_type_template.prototype.__loadAccountLanguages = function(data, $data) {
		var self = this;
		data = data || {};
		data.template = data.template || {};
		var activity = this.parent.activity;
		var groupId = activity.__getValue(self.groupDefinition, $data);
		var messageId = activity.__getValue(self.messageIdDefinition, $data);
		if (!groupId || !messageId) {
			return;
		}
		var languages = self.templateMessageOptions[groupId].messages[messageId].languages || {};
		self.languageDefinition.options = [];
		$.each(languages, function(id/*, language*/) {
			self.languageDefinition.options.push({ id : id, name : inConcertLanguages.getLanguageLabel(id) });
		});
		self.languageDefinition.options.sort(function(a, b) {
			return a.name.localeCompare(b.name);
		});
		if (self.languageDefinition.options.length !== 1) {
			self.languageDefinition.options.unshift({ id : "USER", name : "<%=_T('User Language')%>" });
		}
		self.languageDefinition.hidden = self.languageDefinition.options.length < 2;
		activity.__replaceControl(self.languageDefinition,
			activity.__makeCombo(self.languageDefinition, data.template[self.languageDefinition.id]), $data);
		self.__loadAccountTemplate(data, $data);
	};

	var defaultTexts = [
		"en",
		"en_US"
	];
	adm_process_flow_messages_type_template.prototype.__getDefaultTemplateMessageLanguage = function(message) {
		if (message.defaultText) {
			return { text : message.defaultText };
		}
		var defaultLanguage = null;
		$.each(defaultTexts, function(_, id) {
			if (message.languages[id]) {
				defaultLanguage = message.languages[id];
				return false;
			}
		});
		if (!defaultLanguage) {
			var keys = Object.keys(message.languages);
			keys.sort();
			defaultLanguage = message.languages[keys[0]];
		}
		return defaultLanguage;
	};

	adm_process_flow_messages_type_template.prototype.__loadAccountTemplate = function(data, $data) {
		var self = this;
		data = data || {};
		data.template = data.template || {};
		var activity = this.parent.activity;
		var groupId = activity.__getValue(self.groupDefinition, $data);
		var messageId = activity.__getValue(self.messageIdDefinition, $data);
		var languageId = activity.__getValue(self.languageDefinition, $data);
		if (!groupId || !messageId || !languageId) {
			return;
		}
		languageId = languageId === "USER" ? self.__accountLanguage : languageId;
		var message = self.templateMessageOptions[groupId].messages[messageId];
		if (!message) {
			return;
		}

		let language = languageId !== "USER"? message.languages[languageId] :
			self.__getDefaultTemplateMessageLanguage(message);
		if (!language) {
			return;
		}

		let header_text;
		let example_header_text;

		if(!message.hsm_buttons) {
			for (const language in message.languages) {
				if (Object.hasOwn(message.languages, language)) {
					if(languageId === language && message.languages[language].components) {
						for (const component in message.languages[language].components) {
							if (Object.hasOwn(message.languages[language].components, component)) {
								if(message.languages[language].components[component] && message.languages[language].components[component].type === "HEADER" && message.languages[language].components[component].format === "TEXT" && message.languages[language].components[component].header_param) {
									header_text = message.languages[language].components[component].text;
									example_header_text = message.languages[language].components[component].header_param;
								}
								else if(message.languages[language].components[component] && message.languages[language].components[component].type === "BUTTONS") {
									message.hsm_buttons = [];
									for (let i = 0; i < message.languages[language].components[component].buttons.length; i++) {
										let button = {};
										button.type = message.languages[language].components[component].buttons[i].type === "QUICK_REPLY" ? "quick_reply" : "call_to_action";
										if(button.type === "call_to_action" && message.languages[language].components[component].buttons[i].type === "URL" && message.languages[language].urlButtonParam) {
											button.urlButtonParam = true;
											button.otp_type = message.languages[language].components[component].buttons[i].otp_type;
										}
										button.payload = message.languages[language].components[component].buttons[i].text;
										message.hsm_buttons.push(button);
									}
								}
							}
						}
					}
				}
			}

			//Si despues de lo anterior no hay botones de respuesta rapida, seteo un array vacio
			message.hsm_buttons = message.hsm_buttons || [];
		}
		var $template = $data? $data.find("#flowDesignerMessagesTemplateText") :
			$("#flowDesignerMessagesTemplateText");
		var $header_template = $data? $data.find("#flowDesignerMessagesTemplateHeaderText") :
			$("#flowDesignerMessagesTemplateHeaderText");

		self.textTemplate = new inConcert.TextTemplate({
			header_control : $header_template,
			header_text : header_text,
			example_header_text : example_header_text,
			example_header_text_value : data.template.header_value_param,
			control : $template,
			content : language.text,
			placeholders : language.params || message.params,
			values : data.template.parameters,
			messages : {
				"required" : "<%=_T('Item value is required')%>"
			}
		});

		this.__make_buttons($data, data.template.hsm_buttons || message.hsm_buttons);
	};

	adm_process_flow_messages_type_template.prototype.__make_buttons = function ($data, buttons) {

		var self = this;
		self.hsm_buttons = [];
		var $list = ($data || this.$get("[template_data]")).find("[hsm_buttons_list]");
		$list.html("");
		if (self.parent.activity.saveEditHsmPorts instanceof Function) {
			self.parent.activity.__processing(true);
			if (buttons) {
				self.parent.activity.saveEditHsmPorts(buttons);
			}
		}
		if (!buttons.length) {
			$list.parent().hide();
			if (self.parent.activity.saveEditHsmPorts instanceof Function) {
				self.parent.activity.__processing(true);
				self.parent.activity.saveEditHsmPorts(buttons);
			}
			return;
		}
		
		
		let list_label_text = (buttons.filter(button => button.type === "quick_reply").length > 0) ? "<%=_T('Quick reply buttons')%>" : ((buttons.filter(button => button.type === "call_to_action" && button.urlButtonParam).length > 0) ? "<%=_T('Call to action buttons')%>" : "");
		
		if(list_label_text !== "") {
			//No se muestra el titulo de la seccion de botones para templates AUTHENTICATION, pero si hay que crear el boton, sin mostrarlo, para que que llegue al proxy
			if (buttons.filter(button => button.type === "quick_reply").length > 0 ? true : (buttons.filter(button => button.type === "call_to_action" && button.urlButtonParam  && !button.otp_type).length > 0) ? true : false) {
				$list.parent().find("[hsm_buttons_title]").parent().show();
			} else {
				$list.parent().find("[hsm_buttons_title]").parent().hide();
			}	

			$.each(buttons, function (_, button) {
				if(button.type === "quick_reply" || button.urlButtonParam) {
					button.readOnly = true;
					var editor = new adm_process_flow_messages_template_button(self.parent, $list, button);
					editor.Make(function (btn) {
						self.hsm_buttons.push(btn);
					});
				}
			});

			if (self.parent.activity.saveEditHsmPorts instanceof Function) {
				self.parent.activity.__processing(true);
				setTimeout(function() {
					self.parent.activity.saveEditHsmPorts(buttons);
				}, 250);
			}

			$list.find("[template_button]").show();
		}
		else {
			$list.parent().hide();
		}
	};

	adm_process_flow_messages_type_template.prototype.__accountAddValue = function (data) {
		var activity = this.parent.activity;
		data.template = {};
		activity.__addValue(data.template, this.messageIdDefinition);
        activity.__addValue(data.template, this.languageDefinition);
		activity.__addValue(data.template, this.groupDefinition);
		activity.__addValue(data.template, this.accountDefinition);
		if (data.template.error) {
			data.error = data.template.error;
			return;
		}
		if(!this.textTemplate) {
			return;
		}
		var textData = this.textTemplate.get(true);
		if (textData.error) {
			data.error = textData.error;
			return;
		}
		data.template.header_value_param = textData.header_value_param;
		data.template.parameters = textData.values;
		data.template.text = textData.template_text;
		data.text = textData.text;
		if (this.hsm_buttons && this.hsm_buttons.length) {
			data.template.hsm_buttons = this.hsm_buttons;
		}
		if(this.__accountsOptions && data.template.account && data.template.id && this.__accountsOptions[data.template.account] && this.__accountsOptions[data.template.account][data.template.id]) {
			data.template.mediaUrl = this.__accountsOptions[data.template.account][data.template.id].mediaUrl;
		}
	};

	adm_process_flow_messages_type_template.prototype.__selectMessageSource = function(source, data, $sources, $data) {
		data = data || {};
		data.template = data.template || {};
		$sources = $sources || this.$get("[template_source]");
		$data = $data || this.$get("[template_data]");
		if (!source) {
			var $source = $sources.first();
			if (!$source.length) {
				return;
			}
			source = $source.attr("template_source");
		}
		$sources.filter(format("[template_source={0}]", source))
			.prop("checked", true);

		if (this.$messageSourceData) {
			$.each(this.$messageSourceData, function(_, $content) {
				$content.remove();
			});
		}
		this.$messageSourceData = this["__" + source + "Make"](data);
		$data.append(this.$messageSourceData);
		if (this["__" + source + "AfterAdd"]) {
			this["__" + source + "AfterAdd"](data, $data);
		}
	};

	adm_process_flow_messages_type_template.prototype.__makeMessageSource = function(messageSource) {
		var self = this;
		messageSource.guid = inConcert.Utils.generateGuid();
		var $messageSource = $(Mustache.render(templates.messages_template_source, messageSource));
		$messageSource.find("[template_source]").change(function() {
			if ($(this).prop("checked")) {
				self.__selectMessageSource($(this).attr("template_source"));
			}
		});
		self.messageSources_d[messageSource.id] = messageSource;
		return $messageSource;
	};

	adm_process_flow_messages_type_template.prototype.Make = function(data) {
		var self = this;
		var $container = $(templates.messages_template);
		var $sources = [];
		self.messageSources_d = {};
		$.each(self.messageSources, function(_, messageSource) {
			$sources.push(self.__makeMessageSource(messageSource));
		});
		$container.filter("[template_sources]")
			.append($sources)
			.toggle($sources.length > 1);

		self.__selectMessageSource(data.messageSource, data, $container.find("[template_source]"), $container.filter("[template_data]"));
		return $container;
	};

	adm_process_flow_messages_type_template.prototype.AddValue = function(data) {
		data.messageSource = this.$get("[template_source]:checked").attr("template_source");
		this["__" + data.messageSource + "AddValue"](data);
	};

//gallery

	function adm_process_flow_messages_type_gallery(parent) {
		adm_process_flow_messages_type_gallery.uber.constructor.call(this, parent);

		var self = this;

		this.imageAspectDefinition = {
			id : "image_aspect_ratio",
			name : "<%=_T('Images aspect')%>",
			description : "<%=_T('Items image aspect.')%>",
			required : true,
			not_extended : true,
			options : [
				{
					id : "horizontal",
					name : "<%=_T('Horizontal')%>"
				},
				{
					id : "square",
					name : "<%=_T('Square')%>"
				}
			],
            form_group: true
		};

		this.itemsDefinition = { 
			id : "optionsVariable",
			name : "<%=_T('Items')%>",
			description : "<%=_T('An array with items list.')%>",
			disclaimer : "<%=_T('Use variable element to set each element value. Example: {{ element.title }}')%>",
			required : true,
			variable: true,
            span: true,
            spanClass: "ic_variable_icon_container",
            variableIconClass: "ic_variable_icon far fa-at",
            form_group: true
		};

		this.titleDefinition = { 
			id : "title",
			name : "<%=_T('Title')%>",
			placeholder : "<%=_T('Title')%>",
			description : "<%=_T('Option title (you can use {{ }} to enter variables).')%>",
			required : true,
			variable: true,
            span: true,
            spanClass: "ic_variable_icon_container",
            variableIconClass: "ic_variable_icon far fa-at",
            form_group: true,
			without_label : true,
			maxLength : 150,
            brackets : true
		};

		this.subtitleDefinition = { 
			id : "subtitle",
			name : "<%=_T('Subtitle')%>",
			placeholder : "<%=_T('Subtitle')%>",
			description : "<%=_T('Option subtitle (you can use {{ }} to enter variables).')%>",
			variable: true,
            span: true,
            spanClass: "ic_variable_icon_container",
            variableIconClass: "ic_variable_icon far fa-at",
            form_group: true,
			without_label : true,
			maxLength : 150,
            brackets : true
		};

		this.imageDefinition = { 
			id : "image_url",
			name : "<%=_T('Image Url')%>",
			placeholder : "<%=_T('Image Url')%>",
			description : "<%=_T('Option image url (you can use {{ }} to enter variables).')%>",
			variable: true,
            span: true,
            spanClass: "ic_variable_icon_container",
            variableIconClass: "ic_variable_icon far fa-at",
            form_group: true,
			without_label : true,
            brackets : true
		};

        this.linkDefinition = {
			id: "link",
			name: "<%=_T('Link')%>",
			description: "<%=_T('Enables subtitle or image link to url.')%>",
			not_extended: true,
			form_group: false,
			envolving_label_class: "form-check-label form-check-label-title",
			envolving_label: true,
			without_label: true,
			controlContainerClass: "form-check",
			checkBoxClass: "form-check-input",
			change: function () {
				self.__toggleFixedOptionLink($(this));
			}
		};

		this.linkUrlDefinition = { 
			id : "link_url",
			name : "<%=_T('Url')%>",
			placeholder : "<%=_T('Url')%>",
			description : "<%=_T('Link url (you can use {{ }} to enter variables).')%>",
			required : true,
			without_label : true,
            controlContainerClass: "form-group flex-grow-1",
			brackets : true
		};
	}

	inConcert.Utils.inherit( adm_process_flow_messages_type_gallery, inConcert.adm_process_flow_messages_type.base.base );

	if (typeof inConcert.adm_process_flow_messages_type.base.gallery !== "function") {
		inConcert.adm_process_flow_messages_type.base.gallery = adm_process_flow_messages_type_gallery;
	}

	adm_process_flow_messages_type_gallery.prototype.name = "<%=_T('Gallery')%>";
	adm_process_flow_messages_type_gallery.prototype.description = "<%=_T('A gallery of items with horizontal navigation.')%>";

	adm_process_flow_messages_type_gallery.prototype.Make = function(data) {
		let $body = $(templates.messages_gallery);
		let $globalOptions = this.__makeGlobalOptions(data);
		let type = data.listType || "fixed";

		if($globalOptions){
			$globalOptions.append(this.__makeListTypes(type));
		}
		else {
			$globalOptions = this.parent.activity.__makeRowFlex(this.__makeListTypes(type));
		}

		$body.find("[global_options]").append($globalOptions);

		this.__selectType(type, data, $body.find("[list_type]"), $globalOptions);
		return $body;
	};
	
	adm_process_flow_messages_type_gallery.prototype.__makeListTypes = function(type) {
        let self = this;
        let $types = [
			$(Mustache.render(templates.messages_gallery_type, {
				id : "fixed",
				name : "<%=_T('Fixed list')%>",
				description : "<%=_T('A fixed items list.')%>",
				guid : inConcert.Utils.generateGuid()
			})),
            $(Mustache.render(templates.messages_gallery_type, {
				id : "variable",
				name : "<%=_T('Variable')%>",
				description : "<%=_T('A variable with items list.')%>",
				guid : inConcert.Utils.generateGuid()
			}))
		];
		$.each($types, function(_, $type) {
			var $input = $type.find("[gallery_type]");
			$input
				.click(function() {
					self.__selectType($(this).attr("gallery_type"));
				})
				.prop("checked", $input.attr("gallery_type") === type);
		});
		var $typesContainer = $(templates.messages_gallery_types_container);
		$typesContainer.find("[messages_gallery_container]").append($types);
		return $typesContainer;
	};

	adm_process_flow_messages_type_gallery.prototype.__selectType = function(type, data, $types, $globalOptions) {
		data = data || {};
		if (this.$typeGlobalElements) {
			this.$typeGlobalElements.remove();
			this.$typeGlobalElements = null;
		}
		($types || this.$get("[list_type]"))
			.hide()
			.filter(format("[list_type={0}]", type))
				.html("")
				.append(this["__" + type + "Make"](data, $globalOptions || this.$get("[global_gallery]")))
				.show();
	};

	adm_process_flow_messages_type_gallery.prototype.__makeGlobalOptions = function(data) { 

		let activity = this.parent.activity;
		if(activity.type !== "INSTAGRAM_BOT") {
			let $globalRow = activity.__makeRowFlex(activity.__makeComboFlex(this.imageAspectDefinition, data[this.imageAspectDefinition.id]),{ class: "col-6" }); 

			$globalRow.attr("global_gallery", true);
			return $globalRow;
		}
		this.imageAspectDefinition.required = false;
		return null;
	};

	adm_process_flow_messages_type_gallery.prototype.__addGlobalOptions = function(data) {
		var activity = this.parent.activity;
		var $container = this.$get("[global_options]");
		activity.__addValue(data, this.imageAspectDefinition, $container);
	};

	adm_process_flow_messages_type_gallery.prototype.__variableMake = function(data) {

		let activity = this.parent.activity;
		let $content = [];

        $content.push(
            activity.__makeDivFlex(
                activity.__makeDivFlex(activity.__makeInputFlex(this.itemsDefinition, data && data[this.itemsDefinition.id]),{ class: "col-12" }),{ class: "row" }
            )
        );

		this.fixedOptions = {};
		let $body = $(templates.messages_gallery_fixed_options);
		$body.find("[add_option_container]").remove();
		this.__addFixedOption(data.optionsTemplate || {}, $body);
		$body.find("[gallery_item_remove]").remove();
		$content.push($body);

		return $content;
	};

	adm_process_flow_messages_type_gallery.prototype.__variableAddValue = function(data) {
		var activity = this.parent.activity;
		var $container = this.$get("[list_type=variable]");
		activity.__addValue(data, this.itemsDefinition, $container);
		data.optionsTemplate = this.__getFixedOptions($container)[0];
		data.error = data.error || data.optionsTemplate.error;
		data.optionsTemplate.error = undefined;
	};

	adm_process_flow_messages_type_gallery.prototype.__fixedMake = function(data) {

		var self = this;
		var $body = $(templates.messages_gallery_fixed_options);

		$body.find("[add_option_container]").click(function() {
			self.__addFixedOption();
		});
		var $list = $body.find("[fixed_list]");
		self.fixedOptions = {};
		$list.sortable({
			cursor : "move"
		});
		$.each(data.options || [], function(_, option) {
			self.__addFixedOption(option, $body);
		});

		return $body;
	};

	adm_process_flow_messages_type_gallery.prototype.__toggleFixedOptionLink = function($link) {
		$link
			.closest("[gallery_item]")
			.find("[link_item]")
            .find("[control=link_url]")
			.prop( "disabled", !$link.prop("checked"));

        $link
			.closest("[gallery_item]")
			.find("[link_item]")
            .find("[control=webview]")
			.prop( "disabled", !$link.prop("checked"));

        $link
			.closest("[gallery_item]")
			.find("[webview_control]")
            .find("[control=webviewSize]")
			.prop( "disabled", !$link.prop("checked"));
	};

	adm_process_flow_messages_type_gallery.prototype.__makeFixedOptionLinkOptions = function(option) { 
		var activity = this.parent.activity;
		var $options = [];
 
        $options.push(activity.__makeInputFlex(this.linkUrlDefinition, option[this.linkUrlDefinition.id])); 
        
		return $options;
	};

	adm_process_flow_messages_type_gallery.prototype.__addFixedOption = function(option, $formBody) {

        let self = this;
        let activity = self.parent.activity;
		option = option || {};
		let $list = $formBody? $formBody.find("[fixed_list]") : self.$get("[list_type=fixed]").find("[fixed_list]");
		let guid = inConcert.Utils.generateGuid();
		self.fixedOptions[guid] = {
			buttons : {}
		};
		let $body = $(Mustache.render(templates.messages_gallery_fixed_option, {
			guid : guid
		}));
		let $form = $body.find("[gallery_item_form]");

        $form.append(
           activity.__makeInputFlex(this.titleDefinition, option[this.titleDefinition.id])
        );

        $form.append(
            activity.__makeInputFlex(this.subtitleDefinition, option[this.subtitleDefinition.id])
        );

        $form.append(
            activity.__makeInputFlex(this.imageDefinition, option[this.imageDefinition.id])
        );

        let rowGroup = [];

		rowGroup.push(activity.__makeDivFlex(activity.__makeCheckboxFlex(this.linkDefinition, option[this.linkDefinition.id]),{ class: "form-group d-flex align-items-center" }));

        let rowGroup2 = [];
        let rowGroup3 = [];

		let $linkItems = this.__makeFixedOptionLinkOptions(option);
		$.each($linkItems, function(index, $item) {
            $item
                .attr("link_item", true)
                .find("[control=link_url]")
                .prop( "disabled", !option[self.linkDefinition.id]);

            $item
                .attr("link_item", true)
                .find("[control=webview]")
                .prop( "disabled", !option.webview);

            $item
                .attr("link_item", true)
                .find("[control=webviewSize]")
                .prop( "disabled", !option.webviewSize);

            if (index === 0) {
                rowGroup.push($item);
            } else if (index === 1 || index === 2) {
                rowGroup2.push($item);
            } else {
                rowGroup3.push($item);
            }
		});

        $form.append(activity.__makeDivFlex(rowGroup, { class: "d-flex flex-row" }));
        $form.append(activity.__makeDivFlex(rowGroup2, { class: "d-flex flex-row" }));
        $form.append(activity.__makeDivFlex(rowGroup3, { class: "d-flex flex-row" }));

		$body.append(this.__makeButtonsList(guid, option, $body));
		$body.find("[gallery_item_remove]").click(function() {
			var $item = $(this).closest("[gallery_item]");
			$item.remove();
		});
		$list.append($body);
	};

	adm_process_flow_messages_type_gallery.prototype.__addFixedOptionLinkData = function(data, $option) {
		var activity = this.parent.activity;
		activity.__addValue(data, this.linkUrlDefinition, $option);
	};

	adm_process_flow_messages_type_gallery.prototype.__getFixedOption = function($option) {
		var data = {};
		var activity = this.parent.activity;
		var $form = $option.find("[gallery_item_form]");
		activity.__addValue(data, this.titleDefinition, $form);
		activity.__addValue(data, this.subtitleDefinition, $form);
		activity.__addValue(data, this.imageDefinition, $form);
		activity.__addValue(data, this.linkDefinition, $form);
		if (data[this.linkDefinition.id]) {
			this.__addFixedOptionLinkData(data, $form);
		}
		data.buttons = this.__getButtons($option.attr("gallery_item"), $option.find("[template_button]"));
		return data;
	};

	adm_process_flow_messages_type_gallery.prototype.__getFixedOptions = function($container) {
		var self = this;
		var options = [];
		$container.find("[gallery_item]").each(function() {
			options.push(self.__getFixedOption($(this)));
		});
		return options;
	};

	adm_process_flow_messages_type_gallery.prototype.__fixedAddValue = function(data) {
		data.options = this.__getFixedOptions(this.$get("[list_type=fixed]"));
		if (!data.options.length) {
			data.error = "<%=_T('Must add almost one item.')%>";
		}
		$.each(data.options, function(_, option) {
			if (!data.error && option.error) {
				data.error = option.error;
				return false;
			}
		});
	};

	adm_process_flow_messages_type_gallery.prototype.__maxButtons = function() {
		return 3;
	};

	adm_process_flow_messages_type_gallery.prototype.__addButton = function(button, guid, $item, $buttonsList) {
		$buttonsList = $buttonsList || $item.find("[buttons_list]");
		var maxButtons = this.__maxButtons();
		if ($buttonsList.find("[template_button]").length >= maxButtons) {
			this.parent.activity.__showError(format("<%=_T('Item has a limit of {0} buttons.')%>", maxButtons), $buttonsList.closest("[gallery_item]"));
			return;
		}
		var buttonConstructor = inConcert.adm_process_flow_messages_button[this.parent.activity.type.toLowerCase()].gallery;
		var editor = new buttonConstructor(this.parent, button, $buttonsList, $item);
		this.fixedOptions[guid].buttons[editor.guid] = editor;
		editor.Make();
	};

	adm_process_flow_messages_type_gallery.prototype.__makeButtonsList = function(guid, data, $item) {
		var self = this;
		if (!self.__maxButtons()) {
			return null;
		}
		var $body = $(Mustache.render(templates.messages_buttons_list, {
			add_title : "<%=_T('Add Button')%>"
		}));
		$body.find("[add_button]").click(function() {
			var $item = $(this).closest("[gallery_item]");
			self.__addButton(null, $item.attr("gallery_item"), $item);
		});
		var $buttonsList = $body.find("[buttons_list]");
		$.each(data.buttons || [], function(_, button) {
			self.__addButton(button, guid, $item, $buttonsList);
		});
		$body.find("[buttons_list]").sortable({
			cursor : "move"
		});
		return $body;
	};

	adm_process_flow_messages_type_gallery.prototype.__getButtons = function(guid, $buttons) {
		var self = this;
		var buttons = [];
		if (!this.__maxButtons()) {
			return buttons;
		}
		$buttons.each(function() {
			var buttonGuid = $(this).attr("template_button");
			var editor = self.fixedOptions[guid] && self.fixedOptions[guid].buttons[buttonGuid] || null;
			var data = editor && editor.GetData();
			if (data) {
				if (!data.port_id) {
					data.port_id = buttonGuid;
				}
				buttons.push(data);
			}
		});
		return buttons;
	};

	adm_process_flow_messages_type_gallery.prototype.AddValue = function(data) {
		this.__addGlobalOptions(data);
		data.listType = this.$get("[gallery_type]:checked").attr("gallery_type");
		this["__" + data.listType + "AddValue"](data);
	};

//list

	function adm_process_flow_messages_type_list(parent) {
		adm_process_flow_messages_type_list.uber.constructor.call(this, parent);

		var self = this;

		this.topElementStyleDefinition = {
			id : "top_element_style",
			name : "<%=_T('Top element style')%>",
			description : "<%=_T('Top element style. If large then image is required and covers all item.')%>",
			required : true,
			not_extended : true,
			options : [
				{
					id : "large",
					name : "<%=_T('Large')%>"
				},
				{
					id : "compact",
					name : "<%=_T('Compact')%>"
				}
			],
            form_group: true
		};

		this.itemsDefinition = { 
			id : "optionsVariable",
			name : "<%=_T('Items')%>",
			description : "<%=_T('An array with items list.')%>",
			disclaimer : "<%=_T('Use variable element to set each element value. Example: {{ element.title }}')%>",
			required : true,
			variable: true,
            span: true,
            spanClass: "ic_variable_icon_container",
            variableIconClass: "ic_variable_icon far fa-at",
            form_group: true
		};

		this.titleDefinition = { 
			id : "title",
			name : "<%=_T('Title')%>",
			placeholder : "<%=_T('Title')%>",
			description : "<%=_T('Option title (you can use {{ }} to enter variables).')%>",
			required : true,
			variable: true,
            span: true,
            spanClass: "ic_variable_icon_container",
            variableIconClass: "ic_variable_icon far fa-at",
            form_group: true,
			without_label : true,
			maxLength : 150,
			brackets : true
		};

		this.subtitleDefinition = { 
			id : "subtitle",
			name : "<%=_T('Subtitle')%>",
			placeholder : "<%=_T('Subtitle')%>",
			description : "<%=_T('Option subtitle (you can use {{ }} to enter variables).')%>",
			variable: true,
            span: true,
            spanClass: "ic_variable_icon_container",
            variableIconClass: "ic_variable_icon far fa-at",
            form_group: true,
			without_label : true,
			maxLength : 150,
            brackets : true
		};

		this.imageDefinition = { 
			id : "image_url",
			name : "<%=_T('Image Url')%>",
			placeholder : "<%=_T('Image Url')%>",
			description : "<%=_T('Option image url (you can use {{ }} to enter variables).')%>",
			variable: true,
            span: true,
            spanClass: "ic_variable_icon_container",
            variableIconClass: "ic_variable_icon far fa-at",
            form_group: true,
			without_label : true,
            brackets : true
		};

        this.linkDefinition = {
			id: "link",
			name: "<%=_T('Link')%>",
			description: "<%=_T('Enables subtitle or image link to url.')%>",
			not_extended: true,
			form_group: false,
			envolving_label_class: "form-check-label form-check-label-title",
			envolving_label: true,
			without_label: true,
			controlContainerClass: "form-check",
			checkBoxClass: "form-check-input",
			change: function () {
				self.__toggleFixedOptionLink($(this));
			}
		};
        
        this.linkUrlDefinition = { 
			id : "link_url",
			name : "<%=_T('Url')%>",
			placeholder : "<%=_T('Url')%>",
			description : "<%=_T('Link url (you can use {{ }} to enter variables).')%>",
			required : true,
			without_label : true,
            controlContainerClass: "form-group flex-grow-1",
			brackets : true
		};
	}

	inConcert.Utils.inherit( adm_process_flow_messages_type_list, inConcert.adm_process_flow_messages_type.base.base );

	if (typeof inConcert.adm_process_flow_messages_type.base.list !== "function") {
		inConcert.adm_process_flow_messages_type.base.list = adm_process_flow_messages_type_list;
	}

	adm_process_flow_messages_type_list.prototype.name = "<%=_T('List')%>";
	adm_process_flow_messages_type_list.prototype.description = "<%=_T('A vertical list of items.')%>";

	adm_process_flow_messages_type_list.prototype.Make = function(data) {
        let $body = $(templates.messages_list);
		let $globalOptions = this.__makeGlobalOptions(data);
		let type = data.listType || "fixed";

		if($globalOptions){
			$globalOptions.append(this.__makeListTypes(type));
		}
		else {
			$globalOptions = this.parent.activity.__makeRowFlex(this.__makeListTypes(type));
		}

		$body.find("[global_options]").append($globalOptions);

		this.__selectType(type, data, $body.find("[list_options_type]"), $globalOptions);

		// $body.find("[bottom_buttons_list]").append(this.__makeBottomButtonsList(data));
		return $body;
	};

	adm_process_flow_messages_type_list.prototype.__maxBottomButtons = function() {
		return 1;
	};

	adm_process_flow_messages_type_list.prototype.__addBottomButton = function(button, $buttonsList, $addButton) {
		var self = this;
		$buttonsList = $buttonsList || this.$get("[bottom_buttons_list]").find("[buttons_list]");
		$addButton = $addButton || this.$get("[bottom_buttons_list]").find("[add_button]");
		var maxButtons = this.__maxBottomButtons();
		if ($buttonsList.find("[template_button]").length >= maxButtons) {
			this.parent.activity.__showError(format("<%=_T('There is a limit of {0} bottom buttons.')%>", maxButtons));
			return;
		}
		var buttonConstructor = inConcert.adm_process_flow_messages_button[this.parent.activity.type.toLowerCase()].list;
		var editor = new buttonConstructor(this.parent, button, $buttonsList, function() {
			if (self.$get("[bottom_buttons_list]").find("[template_button]").length < self.__maxBottomButtons()) {
				self.$get("[bottom_buttons_list]").find("[add_button]").show();
			}
		});
		this.buttons[editor.guid] = editor;
		editor.Make();
	};

	adm_process_flow_messages_type_list.prototype.__makeBottomButtonsList = function(data) {
		let self = this;
		if (!self.__maxBottomButtons()) {
			return;
		}
		self.buttons = {};
		let $body = $(Mustache.render(templates.messages_buttons_list_inferior, {
			add_title : "<%=_T('Add Bottom Button')%>"
		}));
		let $addButton = $body.find("[add_button]");
		let $buttonsList = $body.find("[buttons_list]");

		$addButton.click(function() {
			self.__addBottomButton();
		});
		$.each(data.buttons || [], function(_, button) {
			self.__addBottomButton(button, $buttonsList, $addButton);
		});
		$buttonsList.sortable({
			cursor : "move"
		});
		return $body;
	};

	adm_process_flow_messages_type_list.prototype.__getBottomButtons = function() {
		var self = this;
		var buttons = [];
		if (!this.__maxBottomButtons()) {
			return buttons;
		}
		self.$get("[bottom_buttons_list]").find("[template_button]").each(function() {
			var guid = $(this).attr("template_button");
			var editor = self.buttons[guid];
			var data = editor && editor.GetData();
			if (data) {
				if (!data.port_id) {
					data.port_id = guid;
				}
				buttons.push(data);
			}
		});
		return buttons;
	};

	adm_process_flow_messages_type_list.prototype.__makeListTypes = function(type) {
        let self = this;
        let $types = [
			$(Mustache.render(templates.messages_list_type, {
				id : "fixed",
				name : "<%=_T('Fixed list')%>",
				description : "<%=_T('A fixed items list.')%>",
				guid : inConcert.Utils.generateGuid()
			})),
            $(Mustache.render(templates.messages_list_type, {
				id : "variable",
				name : "<%=_T('Variable')%>",
				description : "<%=_T('A variable with items list.')%>",
				guid : inConcert.Utils.generateGuid()
			}))			
		];
		$.each($types, function(_, $type) {
			let $input = $type.find("[list_type]");
			$input
				.click(function() {
					self.__selectType($(this).attr("list_type"));
				})
				.prop("checked", $input.attr("list_type") === type);
		});
		let $typesContainer = $(templates.messages_list_types_container);
		$typesContainer.find("[messages_list_container]").append($types);
		return $typesContainer;
	};

	adm_process_flow_messages_type_list.prototype.__selectType = function(type, data, $types, $globalOptions) {
		data = data || {};
		if (this.$typeGlobalElements) {
			this.$typeGlobalElements.remove();
			this.$typeGlobalElements = null;
		}
		($types || this.$get("[list_options_type]"))
			.hide()
			.filter(format("[list_options_type={0}]", type))
				.html("")
				.append(this["__" + type + "Make"](data, $globalOptions || this.$get("[global_gallery]")))
				.show();
	};

	adm_process_flow_messages_type_list.prototype.__makeGlobalOptions = function(data) { 
		let activity = this.parent.activity;
		let $globalRow = activity.__makeRowFlex(activity.__makeComboFlex(this.topElementStyleDefinition, data[this.topElementStyleDefinition.id]),{ class: "col-6" }); 
        $globalRow.attr("global_gallery", true);
		return $globalRow;
	};

	adm_process_flow_messages_type_list.prototype.__addGlobalOptions = function(data) {
		var activity = this.parent.activity;
		var $container = this.$get("[global_options]");
		activity.__addValue(data, this.topElementStyleDefinition, $container);
	};

	adm_process_flow_messages_type_list.prototype.__variableMake = function(data) {

		let activity = this.parent.activity;
		let $content = [];

        $content.push(
            activity.__makeDivFlex(
                activity.__makeDivFlex(activity.__makeInputFlex(this.itemsDefinition, data && data[this.itemsDefinition.id]),{ class: "col-12" }),{ class: "row" }
            )
        );

		this.fixedOptions = {};
		let $body = $(templates.messages_list_fixed_options);
		$body.find("[add_option_container]").parent().remove();
		this.__addFixedOption(data.optionsTemplate || {}, $body);
		$body.find("[list_item_remove]").remove();
		$content.push($body);

		return $content;
	};

	adm_process_flow_messages_type_list.prototype.__variableAddValue = function(data) {
		var activity = this.parent.activity;
		var $container = this.$get("[list_options_type=variable]");
		activity.__addValue(data, this.itemsDefinition, $container);
		data.optionsTemplate = this.__getFixedOptions($container)[0];
		data.error = data.error || data.optionsTemplate.error;
		data.optionsTemplate.error = undefined;
	};

	adm_process_flow_messages_type_list.prototype.__fixedMake = function(data) {

		var self = this;
		var $body = $(templates.messages_list_fixed_options);

		$body.find("[add_option_container]").click(function() {
			self.__addFixedOption();
		});
		var $list = $body.find("[fixed_list]");
		self.fixedOptions = {};
		$list.sortable({
			cursor : "move"
		});
		$.each(data.options || [], function(_, option) {
			self.__addFixedOption(option, $body);
		});

		const addBottomButton = $("[bottom_buttons_list]");

		if(!$.trim(addBottomButton.html())) {
			$body.find("[bottom_buttons_list]").append(this.__makeBottomButtonsList(data));
		}

		return $body;
	};

	adm_process_flow_messages_type_list.prototype.__toggleFixedOptionLink = function($link) {
		$link
			.closest("[list_item]")
			.find("[link_item]")
            .find("[control=link_url]")
			.prop( "disabled", !$link.prop("checked"));
	};

	adm_process_flow_messages_type_list.prototype.__makeFixedOptionLinkOptions = function(option) {
		let activity = this.parent.activity;
		let $options = [];

        $options.push(activity.__makeInputFlex(this.linkUrlDefinition, option[this.linkUrlDefinition.id]));

        return $options;
	};

	adm_process_flow_messages_type_list.prototype.__minOptions = function() {
		return 2;
	};

	adm_process_flow_messages_type_list.prototype.__maxOptions = function() {
		return 4;
	};

	adm_process_flow_messages_type_list.prototype.__addFixedOption = function(option, $formBody) {
        let self = this;
        let maxOptions = this.__maxOptions();
        let activity = self.parent.activity;
		option = option || {};
		let $list = $formBody? $formBody.find("[fixed_list]") : self.$get("[list_options_type=fixed]").find("[fixed_list]");
		if ($list.find("[list_item]").length >= maxOptions) {
			this.parent.activity.__showError(format("<%=_T('There is a limit of {0} list items.')%>", maxOptions));
			return;
		}
		let guid = inConcert.Utils.generateGuid();
		self.fixedOptions[guid] = {
			buttons : {}
		};
		let $body = $(Mustache.render(templates.messages_list_fixed_option, {
			guid : guid
		}));
		let $form = $body.find("[list_item_form]");

        $form.append(
            activity.__makeInputFlex(this.titleDefinition, option[this.titleDefinition.id])
         );

         $form.append(
            activity.__makeInputFlex(this.subtitleDefinition, option[this.subtitleDefinition.id])
        );

        $form.append(
            activity.__makeInputFlex(this.imageDefinition, option[this.imageDefinition.id])
        );

        let rowGroup = [];
		rowGroup.push(activity.__makeDivFlex(activity.__makeCheckboxFlex(this.linkDefinition, option[this.linkDefinition.id]),{ class: "form-group form-group d-flex align-items-center" }));

		let $linkItems = this.__makeFixedOptionLinkOptions(option);
		$.each($linkItems, function(_, $item) {
            $item
                .attr("link_item", true)
                .find("[control=link_url]")
                .prop( "disabled", true);

            rowGroup.push($item);
		});

        $form.append(activity.__makeDivFlex(rowGroup, { class: "d-flex flex-row" }));

		$body.append(this.__makeButtonsList(guid, option, $body));
		$body.find("[list_item_remove]").click(function() {
			let $item = $(this).closest("[list_item]");
			$item.remove();
		});
		$list.append($body);
	};

	adm_process_flow_messages_type_list.prototype.__addFixedOptionLinkData = function(data, $option) {
		var activity = this.parent.activity;
		activity.__addValue(data, this.linkUrlDefinition, $option);
	};

	adm_process_flow_messages_type_list.prototype.__getFixedOption = function($option) {
		var data = {};
		var activity = this.parent.activity;
		var $form = $option.find("[list_item_form]");
		activity.__addValue(data, this.titleDefinition, $form);
		activity.__addValue(data, this.subtitleDefinition, $form);
		activity.__addValue(data, this.imageDefinition, $form);
		activity.__addValue(data, this.linkDefinition, $form);
		if (data[this.linkDefinition.id]) {
			this.__addFixedOptionLinkData(data, $form);
		}
		data.buttons = this.__getButtons($option.attr("list_item"), $option.find("[template_button]"));
		return data;
	};

	adm_process_flow_messages_type_list.prototype.__getFixedOptions = function($container) {
		var self = this;
		var options = [];
		$container.find("[list_item]").each(function() {
			options.push(self.__getFixedOption($(this)));
		});
		return options;
	};

	adm_process_flow_messages_type_list.prototype.__fixedAddValue = function(data) {
		var self = this;
		data.options = this.__getFixedOptions(this.$get("[list_options_type=fixed]"));
		var minOptions = this.__minOptions();
		if (data.options.length < minOptions) {
			data.error = format("<%=_T('Must add almost {0} items.')%>", minOptions);
		}
		$.each(data.options, function(index, option) {
			if (!data.error && option.error) {
				data.error = option.error;
				return false;
			}
			if (index === 0 && data[self.topElementStyleDefinition.id] === "large" && !option[self.imageDefinition.id]) {
				data.error = "<%=_T('Top element must have an image if style is large.')%>";
				return false;
			}
		});
	};

	adm_process_flow_messages_type_list.prototype.__maxButtons = function() {
		return 1;
	};

	adm_process_flow_messages_type_list.prototype.__addButton = function(button, guid, $item, $buttonsList) {
		$buttonsList = $buttonsList || $item.find("[buttons_list]");
		var maxButtons = this.__maxButtons();
		if ($buttonsList.find("[template_button]").length >= maxButtons) {
			this.parent.activity.__showError(format("<%=_T('Item has a limit of {0} buttons.')%>", maxButtons), $buttonsList.closest("[list_item]"));
			return;
		}
		var buttonConstructor = inConcert.adm_process_flow_messages_button[this.parent.activity.type.toLowerCase()].gallery;
		var editor = new buttonConstructor(this.parent, button, $buttonsList, $item);
		this.fixedOptions[guid].buttons[editor.guid] = editor;
		editor.Make();
	};

	adm_process_flow_messages_type_list.prototype.__makeButtonsList = function(guid, data, $item) {
		var self = this;
		if (!self.__maxButtons()) {
			return null;
		}
		var $body = $(Mustache.render(templates.messages_buttons_list, {
			add_title : "<%=_T('Add Button')%>"
		}));
		$body.find("[add_button]").click(function() {
			var $item = $(this).closest("[list_item]");
			self.__addButton(null, $item.attr("list_item"), $item);
		});
		var $buttonsList = $body.find("[buttons_list]");
		$.each(data.buttons || [], function(_, button) {
			self.__addButton(button, guid, $item, $buttonsList);
		});
		$body.find("[buttons_list]").sortable({
			cursor : "move"
		});
		return $body;
	};

	adm_process_flow_messages_type_list.prototype.__getButtons = function(guid, $buttons) {
		var self = this;
		var buttons = [];
		if (!this.__maxButtons()) {
			return buttons;
		}
		$buttons.each(function() {
			var buttonGuid = $(this).attr("template_button");
			var editor = self.fixedOptions[guid].buttons[buttonGuid];
			var data = editor && editor.GetData();
			if (data) {
				if (!data.port_id) {
					data.port_id = buttonGuid;
				}
				buttons.push(data);
			}
		});
		return buttons;
	};

	adm_process_flow_messages_type_list.prototype.AddValue = function(data) {

		this.__addGlobalOptions(data);
		data.buttons = this.__getBottomButtons();
		data.listType = this.$get("[list_type]:checked").attr("list_type");

		this["__" + data.listType + "AddValue"](data);
	};

//menu

	function adm_process_flow_messages_type_menu(parent) {
		adm_process_flow_messages_type_menu.uber.constructor.call(this, parent);

		this.messageOptions = {
			template : templates.messages_menu_option,
			type_selector : "[menu_option_type]",
			type_name : "<%=_T('Message Type')%>",
			type_description : "<%=_T('Menu message type.')%>",
			message_selector : "[menu_option_message]",
			toggle : false
		};

		this.optionsListDefinition = {
			count : 10,
			initial : 1,
			customIndexes : {
				10 : "0"
			}
		};

		this.valueDefinition = {
			id : "value",
			name : "<%=_T('Value')%>",
			description : "<%=_T('Value to be entered by client.')%>",
			not_extended : true,
			// required : true,
			controlContainerClass: "col-7",
			without_label: true
		};

		this.idDefinition = {
			id : "id",
			name : "<%=_T('Id')%>",
			description : "<%=_T('Option id. If is set then is returned as result instead of value.')%>",
			not_extended : true,
			controlContainerClass: "col-7",
			without_label: true
		};

		this.recognizeDefinition = {
			id : "recognize",
			name : "<%=_T('Recognize text')%>",
			description : "<%=_T('Text to recognize. If set, this is the text that will be recognized for this option.')%>",
			not_extended : true,
			controlContainerClass: "col-7",
			without_label: true
		};

		this.sharedFilesDefinition = {
			id : "shared_files",
			name : "<%=_T('Include message')%>",
			description : "<%=_T('Shared file to play. If set, this is the audio that will be played for all options.')%>",
			not_extended : true,
			checkBoxClass: "form-check-input",
			controlContainerClass: "d-flex form-check form-check-only mt-0",
			without_label: true, 
		};

		this.itemsDefinition = {
			id : "optionsVariable",
			name : "<%=_T('Options')%>",
			description : "<%=_T('An array with items list.')%>",
			disclaimer : format("<%=_T('Example: {0}')%>", JSON.stringify([
				{ message : "type 1", value : "1", id : "first_option" },
				{ message : "type 2", value : "2", id : "second_option" }
			])),
			required : true,
			variable : true,
			not_extended : true,
			controlContainerClass: "form-group position-relative",
			span: true,
			spanClass: "ic_variable_icon_container",
			variableIconClass: "ic_variable_icon far fa-at"
		};
	}

	inConcert.Utils.inherit( adm_process_flow_messages_type_menu, inConcert.adm_process_flow_messages_type.base.base );

	if (typeof inConcert.adm_process_flow_messages_type.base.menu !== "function") {
		inConcert.adm_process_flow_messages_type.base.menu = adm_process_flow_messages_type_menu;
	}

	adm_process_flow_messages_type_menu.prototype.name = "<%=_T('Menu')%>";
	adm_process_flow_messages_type_menu.prototype.description = "<%=_T('A list of options to be selected.')%>";

	adm_process_flow_messages_type_menu.prototype.GetMigrationRepositoryFiles = function(self, type, data) {
		let files = [];
		let files_d = {};
		(data.message && data.message.options || []).forEach(function(option) {
			let optionFiles = self.prototype.__GetOptionMigrationRepositoryFiles(self, type, option);
			optionFiles.forEach(function(file) {
				if (!files_d[file.id]) {
					files_d[file.id] = true;
					files.push(file);
				}
			});
		});
		return files;
	};

	adm_process_flow_messages_type_menu.prototype.__GetOptionMigrationRepositoryFiles = function(_, type, option) {
		let constructor = inConcert.adm_process_flow_messages_embeed;
		return constructor.prototype.GetMigrationRepositoryFiles(constructor, type, option.message);
	};

	adm_process_flow_messages_type_menu.prototype.GetMigrationSharedFiles = function(self, type, data) {
		let files = [];
		let files_d = {};
		(data.message && data.message.options || []).forEach(function(option) {
			let optionFiles = self.prototype.__GetOptionMigrationSharedFiles(self, type, option);
			optionFiles.forEach(function(file) {
				if (!files_d[file.id]) {
					files_d[file.id] = true;
					files.push(file);
				}
			});
		});
		return files;
	};

	adm_process_flow_messages_type_menu.prototype.__GetOptionMigrationSharedFiles = function(_, type, option) {
		let constructor = inConcert.adm_process_flow_messages_embeed;
		return constructor.prototype.GetMigrationSharedFiles(constructor, type, option.message);
	};

	adm_process_flow_messages_type_menu.prototype.Make = function(data) {
		let $content = [];
		let type = data.optionsVariable? "variable" : "fixed";
		$content.push(this.__makeListTypes(type));
		$content.push(this.__makeVariable(data, type));
		$content.push(this.__makeOptions(data, type));
		return $content;
	};

	adm_process_flow_messages_type_menu.prototype.__makeListTypes = function(type) {
		var self = this;
		var $types = [
			$(Mustache.render(templates.messages_menu_type, {
				id : "fixed",
				name : "<%=_T('Fixed list')%>",
				description : "<%=_T('A fixed items list.')%>",
				guid : inConcert.Utils.generateGuid()
			})),
			$(Mustache.render(templates.messages_menu_type, {
				id : "variable",
				name : "<%=_T('Variable')%>",
				description : "<%=_T('A variable with items list.')%>",
				guid : inConcert.Utils.generateGuid()
			}))
		];
		$.each($types, function(_, $type) {
			var $input = $type.find("[menu_type]");
			$input
				.click(function() {
					self.__selectType($(this).attr("menu_type"));
				})
				.prop("checked", $input.attr("menu_type") === type);
		});
		var $typesContainer = $(templates.messages_menu_types_container);
		$typesContainer.find("[list_types]").append($types);
		return $typesContainer;
	};

	adm_process_flow_messages_type_menu.prototype.__selectType = function(type) {
		this.$get("[menu_options_container]").toggle(type === "fixed");
		this.parent.activity.__toggleControlRow(this.itemsDefinition, type === "variable", this.$get());
		if(this.parent && this.parent.activity && this.parent.activity.AfterSelectType && $.isFunction(this.parent.activity.AfterSelectType)){
			this.parent.activity.AfterSelectType();
		}
	};

	adm_process_flow_messages_type_menu.prototype.__makeVariable = function(data, type) {
		let activity = this.parent.activity;
		let $vsriable = activity.__makeDivFlex(
			[
			  activity.__makeDivFlex(
				activity.__makeInputFlex(
				  this.itemsDefinition,
				  data[this.itemsDefinition.id]
				),
				{ class: "col-12" }
			  ),
			],
			{ class: "row" }
		  );
		  
		$vsriable.toggle(type === "variable");
		return $vsriable;
	};

	adm_process_flow_messages_type_menu.prototype.__makeOptions = function(data, type) {
		let $options = [];
		let optionsByIndex = (data.options || []).reduce(function(current, option) {
			current[option.index || option.value] = option;
			return current;
		}, {});

		for (let i = 0; i < this.optionsListDefinition.count; i++) {
			let index = this.optionsListDefinition.initial + i;
			index = (this.optionsListDefinition.customIndexes[index] || index).toString();
			$options.push(this.__makeOption(index, optionsByIndex[index]));
		}

		let $menu = $(templates.messages_menu_options);
		$menu.find("[menu_options]").append($options);
		$menu.toggle(type === "fixed");
		return $menu;
	};

	adm_process_flow_messages_type_menu.prototype.__makeOption = function(index, option) {
		option = option || {};
		option.index = index;

		let editor = new inConcert.adm_process_flow_messages_embeed(this.parent, this.messageOptions);
		let $option = editor.Make(option.message || {});
		$option.data("message_editor", editor);

		this.__makeOptionValue($option, option);
		this.__makeOptionAsrRecognize($option, option);
		this.__makeEnableSharedFiles($option, option);
		this.__makeOptionSelector($option, option);

		return $option;
	};

	adm_process_flow_messages_type_menu.prototype.__makeOptionValue = function($option, option) {
		let activity = this.parent.activity;
		$option.find("[menu_option_value]").append(
				activity.__makeDivFlex(
				  [
					activity.__makeDivFlex(
						activity.__makeLabel({controlLabel:"value", children: "<%=_T('Value')%><%=_T(':')%>"}),
						{ class: "col-5"}
					),
					activity.__makeInput(this.valueDefinition, option[this.valueDefinition.id] || option.index),
				  ],
				  { class: "form-group form-row", persoTags: "hidden_control=false"}
				)
		);

		// $option.find("[menu_option_value]").append(
		// 	activity.__makeDivFlex(
		// 		[
		// 		  activity.__makeDivFlex(
		// 			  activity.__makeLabel({controlLabel:"value", class:"required", children: "<%=_T('Identifier')%><%=_T(':')%>"}),
		// 			  { class: "col-5"}
		// 		  ),
		// 		  activity.__makeDivFlex(
		// 				activity.__makeInput(this.idDefinition, option[this.idDefinition.id]),
		// 				{ class: "col-7"}
		// 		  )
		// 		],
		// 		{ class: "form-group form-row", persoTags: "hidden_control=false"}
		// 	  )
		// );
	};

	adm_process_flow_messages_type_menu.prototype.__makeOptionAsrRecognize = function($option, option) {
		let activity = this.parent.activity;	
		
		$option.find("[menu_option_recognize]").append(
			activity.__makeDivFlex(
				[
					activity.__makeDivFlex(
						activity.__makeLabel({controlLabel:"value", children: "<%=_T('Recognize text')%>"}),
						{ class: "col-5"}
					),
					activity.__makeInput(this.recognizeDefinition, option[this.recognizeDefinition.id])
				],
				{ class: "form-group form-row", persoTags: "hidden_control=false"}
			)
		);
	};

	adm_process_flow_messages_type_menu.prototype.__toggleOptionsAsrRecognize = function(show) {
		this.$get("[menu_option_recognize]").each(function(/*index, option*/) {
			this.hidden = show;
		});
	};

	adm_process_flow_messages_type_menu.prototype.__makeEnableSharedFiles = function($option, option) {
		this.sharedFilesDefinition.change = function() {
			const $shared_files_ctrls = $option.find("[menu_option_shared_files_ctrls]");
			$shared_files_ctrls.toggle();
		};
		let activity = this.parent.activity;
		let is_selected = false;
		if (option.message) {
			if (option.message.msgtype === "text") {
				is_selected = true;
			}
			else if (option.message.msgtype === "attachment") {
				if (option.message.sharedFile || (option.message.options || []).length > 0) {
					is_selected = true;
				}
			}
		}
		// let $ctrl = activity.__makeCheckbox(this.sharedFilesDefinition, is_selected);
		let $ctrl = activity.__makeDivFlex(
			[
			  activity.__makeDivFlex(
				activity.__makeLabel({
				  controlLabel: "value",
				  children: "<%=_T('Include message')%>",
				}),
				{ class: "col-5" }
			  ),
			  activity.__makeDivFlex(
				activity.__makeCheckbox(
				  this.sharedFilesDefinition,
				  is_selected
				),
				{ class: "col-7" }
			  ),
			],
			{ class: "form-group form-row", persoTags: "hidden_control=false" }
		  );
		  
		let $menu_option_shared_files_enabled = $option.find("[menu_option_shared_files_enabled]");
		$menu_option_shared_files_enabled.append($ctrl);
		let $chk = $ctrl.find("[control]");
		let shared_file_info = {chk_id: $chk.attr("id")};
		$menu_option_shared_files_enabled.data("shared_file_info", shared_file_info);
		if (is_selected) {
			this.sharedFilesDefinition.change();
		}
	};

	adm_process_flow_messages_type_menu.prototype.__makeOptionSelector = function($option, option) {
		let activity = this.parent.activity;
		let enabled = option.message? true : false;
		let indexDefinition = {
			id : "index_" + option.index,
			name : option.index,
			inverse_order : true,
			controlContainerClass: "d-flex form-check form-check-only mt-0",
			form_group: false,
			without_label: true,
			label_aux: false,
			checkBoxClass:"form-check-input",
			change : function() {
				$option.toggleClass("selected", $(this).is(":checked"))
					.find("[menu_option_form]").toggle($(this).is(":checked"));
				if(activity && activity.AfterSelectType && $.isFunction(activity.AfterSelectType)){
					activity.AfterSelectType();
				}
			}
		};
		$option.toggleClass("selected", enabled);
		$option.data("index", option.index);
		$option.find("[menu_option_selector]").append(
			activity.__makeDivFlex(
			  [
				activity.__makeDivFlex(
				  [
					activity.__makeLabel({
					  controlLabel: `index_${option.index}`,
					  children: option.index,
					  class: "mb-0"
					}),
					activity.__makeCheckbox(indexDefinition, enabled),
				  ],
				  { class: "col-12 d-flex flex-row justify-content-between align-items-center" }
				),
			  ],
			  { class: "row" }
			)
		  );
		  
		  
		$option.find("[menu_option_form]").toggle(enabled);
	};

	adm_process_flow_messages_type_menu.prototype.AfterAppendBody = function() {
		const self = this;
		this.$get("[menu_option]").each(function() {
			self.__afterAppendBodyOption($(this));
		});
	};

	adm_process_flow_messages_type_menu.prototype.__afterAppendBodyOption = function($option) {
		$option.data("message_editor").AfterAppendBody();
	};

	adm_process_flow_messages_type_menu.prototype.AddValue = function(data) {
		let type =  this.$get("[menu_type]:checked").attr("menu_type");
		if (type === "variable") {
			this.__addVariable(data);
		}
		else {
			this.__addOptions(data);
		}
	};

	adm_process_flow_messages_type_menu.prototype.__addVariable = function(data) {
		this.parent.activity.__addValue(data, this.itemsDefinition);
	};

	adm_process_flow_messages_type_menu.prototype.__addOptions = function(data) {
		const self = this;
		data.options = [];
		let $chks_digit_selected = [];
		this.$get("[menu_option].selected").each(function() {
			const $chk_digit_selector = $(this);
			$chks_digit_selected.push($chk_digit_selector);
			let option = self.__getOption($chk_digit_selector, data);
			data.options.push(option);
		});
		if (data.options.length === 0){
			data.error = {
				message: "<%=_T('At least one option is required.')%>"
			};
		}
		else {
			let sharedFiles = [];
			for (let i = 0; i < $chks_digit_selected.length; i++) {
				let $chk_digit_selector =  $chks_digit_selected[i];
				let $menu_option_shared_files_enabled = $chk_digit_selector.find("[menu_option_shared_files_enabled]");
				let shared_file_info = $menu_option_shared_files_enabled.data("shared_file_info");
				let $chk = $("#" + shared_file_info.chk_id);
				let is_selected = $chk.prop("checked");
				if (is_selected) {
					sharedFiles.push(1);
				}
			}
			if (sharedFiles.length === 0){
				data.error = {
					message: "<%=_T('You have not associated shared files. You must associate one.')%>"
				};
			}
		}
	};

	adm_process_flow_messages_type_menu.prototype.__getOption = function($option, data) {
		let option = {
			index : $option.data("index"),
			message : {}
		};
		this.__addOptionMessage($option, option, data);
		this.__addOptionValue($option, option, data);
		data.error = data.error || option.error || option.message.error;
		return option;
	};

	adm_process_flow_messages_type_menu.prototype.__addOptionMessage = function($option, option/*, data*/) {
		$option.data("message_editor").AddValue(option.message);
	};

	adm_process_flow_messages_type_menu.prototype.__addOptionValue = function($option, option, data) {
		let self = this;
		let activity = self.parent.activity;
		self.valueDefinition.validate = function(value) {
			let repeated = data.options.find(function(option) {
				return option[self.valueDefinition.id] === value;
			});
			if (repeated) {
				return "<%=_T('Option value is repeated.')%>";
			}
		};
		activity.__addValue(option, self.valueDefinition, $option);
		activity.__addValue(option, self.idDefinition, $option);
		activity.__addValue(option, self.recognizeDefinition, $option);
	};

	adm_process_flow_messages_type_menu.prototype.AddValueAsync = function(data, callback) {
		const self = this;
		if (!data.options) {
			return callback();
		}
		let params = {
			totalOptions: data.options.length,
			index: null,
			totalAssignedSharedFiles: 0,
			errorsIndexes: []
		};
		let $options = this.$get("[menu_option].selected");
		inConcert.Utils.asyncIterate(data.options, function(option, next, index) {
			const $option = $options.eq(index);
			params.index = index;
			self.__getOptionAsync($option, option, data, next, params);
		}, callback);
	};

	adm_process_flow_messages_type_menu.prototype.__getOptionAsync = function($option, option, data, callback, params) {
		const self = this;

		this.__addOptionMessageAsync($option, option, data, function() {
			self.__addOptionValueAsync($option, option, data, function() {
				data.error = data.error || option.error;
				if (option.message.sharedFile) {
					params.totalAssignedSharedFiles++;
				}
				else {
					params.errorsIndexes.push({index: params.index, error: option.message.error});
				}
				if (params.totalOptions === (params.index + 1)) {
					if (params.totalAssignedSharedFiles === 0) {
						if (!data.error && params.errorsIndexes.length > 0) {
							data.error = params.errorsIndexes[0].error;
						}
					}
				}
				callback();
			});
		});
	};

	adm_process_flow_messages_type_menu.prototype.__addOptionMessageAsync = function($option, option, _, callback) {
		let message_editor = $option.data("message_editor");
		message_editor.AddValueAsync(option.message, callback, $option);
	};

	adm_process_flow_messages_type_menu.prototype.__addOptionValueAsync = function(_, _1, _2, callback) {
		callback();
	};

//Embeed

	function adm_process_flow_messages_embeed(parent, options) {

		let self = this;

		this.parent = parent;
		this.options = $.extend({
			template : templates.embeed_message,
			title : "<%=_T('Define an error message')%>",
			disclaimer : null,
			type_selector : "[embeed_message_type]",
			type_name : "<%=_T('Message Type')%>",
			type_description : "<%=_T('Message type.')%>",
			message_selector : "[embeed_message]",
			message_types : [
				{
					id : "text",
					name : "<%=_T('Text')%>"
				}
			],
			checkboxInput: true,
			toggle : (options.always_enabled ? false : true),
			toggle_selector : "[embeed_message_toggle]",
			toggled_selector : "[embeed_message_toggled]"
		}, options || {});

		this.messageTypeDefinition = {
			id : "msgtype",
			name : this.options.type_name,
			description : this.options.type_description,
			required : true,
			not_extended : true,
			options : this.options.message_types,
			controlContainerClass: "col-7 mb-0",
			without_label: true,
			change : function() {
				self.__selectMessageType();
			},
            form_group: true
		};
	}

	if (typeof inConcert.adm_process_flow_messages_embeed !== "function") {
		inConcert.adm_process_flow_messages_embeed = adm_process_flow_messages_embeed;
	}

	adm_process_flow_messages_embeed.prototype.__GetOptionMigrationRepositoryFiles = function(_, type, option) {
		let constructor = inConcert.adm_process_flow_messages_type[type.toLowerCase()][option.message.msgtype];
		return constructor && constructor.prototype.GetMigrationRepositoryFiles(constructor, type, option) || [];
	};

	adm_process_flow_messages_embeed.prototype.GetMigrationRepositoryFiles = function(_, type, data) {
		let constructor = inConcert.adm_process_flow_messages_type[type.toLowerCase()][data.msgtype];
		return constructor && constructor.prototype.GetMigrationRepositoryFiles(constructor, type, data) || [];
	};

	adm_process_flow_messages_embeed.prototype.GetMigrationSharedFiles = function(_, _1, data) {
		let files = [];
		if (!data.message) {
			return files;
		}
		// canales con multiples mensajes
		for (let i = 0; i < (data.message.options || []).length; i++) {
			let menuOption = data.message.options[i];
			if (!menuOption.message) {
				continue;
			}
			for (let j = 0; j < (menuOption.message.options || []).length; j++) {
				let component = menuOption.message.options[j];
				if (component.MessageType.toLowerCase() === "audio") {
					files.push({
						id: component.sharedFile
					});
				}
			}
		}
		return files;
	};

	adm_process_flow_messages_embeed.prototype.Make = function(data) {

		let activity = this.parent.activity;
		this.$container = $(Mustache.render(this.options.template, this.options));	
        this.messageTypeDefinition.fieldClass = "col_12_ErrorMsg";
        this.messageTypeDefinition.hidden = this.messageTypeDefinition.options.length <= 1;

		this.$container.find(this.options.type_selector).append(
			activity.__makeDivFlex(
				[
				  activity.__makeDivFlex(
					  activity.__makeLabel({controlLabel:"value", class:"required", children: "<%=_T('Message Type')%>"}),
					  { class: "col-5"}
				  ),
				  activity.__makeComboFlex(this.messageTypeDefinition, data[this.messageTypeDefinition.id]),
				],
				{ class: "form-group form-row", persoTags: "hidden_control=false"}
			  )
			);

		this.__makeMessage(data);
		this.__makeToggle(data);
		return this.$container;
	};

	adm_process_flow_messages_embeed.prototype.AfterAppendBody = function() {
		this.__afterAppendBodyMessage();
	};

	adm_process_flow_messages_embeed.prototype.canSupportsMultipleSharedFiles = function() {
		let channel = (this.parent.activity.editor.main.data.Type || "").toUpperCase();
		let availablChannels = {"CALL": true};
		let isAvailable = availablChannels[channel];
		return isAvailable || false;
	};

	adm_process_flow_messages_embeed.prototype.__makeMessage = function(data) {
		let activity = this.parent.activity;
		let type = activity.__getValue(this.messageTypeDefinition, this.$container);

		this.options.embedded = true;
		this.options.$container = this.$container;
		let editor = new this.parent.types[type || "attachment"](this.parent, this.options);

		const supportsMultipleSharedFiles = this.canSupportsMultipleSharedFiles();

		const $markup = editor.Make(data || {}, supportsMultipleSharedFiles); 
		this.$container.find(this.options.message_selector)
			.html("")
			.append($markup);
		this.$container.data("editor", editor);
	};

	adm_process_flow_messages_embeed.prototype.__makeToggle = function(data) {

		let self = this;
		if (!self.options.toggle) {
			return;
		}

        let checked = false;
        if (data && (data.msgtype === "attachment" || data.msgtype === "text")) {
            checked = true;
        }

		self.$container.find(self.options.toggle_selector)
			.prop("checked", checked)
			.change(function() {
				self.$container.find(self.options.toggled_selector).toggle($(this).is(":checked"));
                self.$container.find("#messages_container_embeed_title_label").toggle($(this).is(":checked"));
                self.$container.find(".flowDesignerMessagesEmbeedMessageDisclaimer").toggle($(this).is(":checked"));                
                self.$container.find("[disclaimer]").toggle($(this).is(":checked"));
                self.$container.find("[embeed_message_type]").toggle($(this).is(":checked"));                           
				if(self.parent && self.parent.activity && self.parent.activity.AfterSelectType && $.isFunction(self.parent.activity.AfterSelectType)){
					self.parent.activity.AfterSelectType();
				}
			})
			.change();
	};

	adm_process_flow_messages_embeed.prototype.__selectMessageType = function() {
		this.__makeMessage({});
		this.__afterAppendBodyMessage();
		if(this.parent && this.parent.activity && this.parent.activity.AfterSelectType && $.isFunction(this.parent.activity.AfterSelectType)){
			this.parent.activity.AfterSelectType();
		}
	};

	adm_process_flow_messages_embeed.prototype.__afterAppendBodyMessage = function() {
		this.$container.data("editor").AfterAppendBody();
		this.$container.find("[embeed_message_type]").toggle(this.messageTypeDefinition.options.length > 1);
	};

	adm_process_flow_messages_embeed.prototype.AddValue = function(data) {

		if (this.options.toggle && !this.$container.find(this.options.toggle_selector).is(":checked")) {
			return;
		}
		let activity = this.parent.activity;
		activity.__addValue(data, this.messageTypeDefinition, this.$container);

		this.$container.data("editor").AddValue(data);
	};

	adm_process_flow_messages_embeed.prototype.AddValueAsync = function(data, callback, $option) {
		if (this.options.toggle && !this.$container.find(this.options.toggle_selector).is(":checked")) {
			return callback();
		}
		if ($option) {
			let $menu_option_shared_files_enabled = $option.find("[menu_option_shared_files_enabled] [control='shared_files']");
			let is_selected = $menu_option_shared_files_enabled.prop("checked");
			if (!is_selected) {
				return callback();
			}
		}
		let editor = this.$container.data("editor");
		editor.AddValueAsync(data, callback, $option);
	};

//reply_buttons

    function adm_process_flow_messages_type_reply_buttons(parent) {
        adm_process_flow_messages_type_reply_buttons.uber.constructor.call(this, parent);

        var self = this;

        this.publicFileUrl = undefined;
        this.publicFileName = undefined;

        this.fileTypeDefinition = {
            id : "type",
            name : "<%=_T('Header Type')%>",
            description : "<%=_T('Type of header.')%>",
            required : true,
            not_extended : true,
            options : [
                {
                    id : "text",
                    name : "<%=_T('Text')%>"
                },
                {
                    id : "whatsapp_cloud_image",
                    name : "<%=_T('Image')%>"
                },
                {
                    id : "whatsapp_cloud_video",
                    name : "<%=_T('Video')%>"
                },
                {
                    id : "whatsapp_cloud_document",
                    name : "<%=_T('Document')%>"
                }
            ],
            change : function() {
                self.__reloadAttachment();
            },
            form_group: true 
        };

        this.attachmentTypeDefinition = {
            id : "wspAttachmentType",
            name : "<%=_T('Source')%>",
            description : "<%=_T('File source.')%>",
            required : true,
            not_extended : true,
            options : [
                {
                    id : "url",
                    name : "<%=_T('Url')%>",
                    description : "<%=_T('Send file from an url.')%>"
                },
                {
                    id : "shared_file",
                    name : "<%=_T('Shared file')%>",
                    description : "<%=_T('Select a file from shared files list.')%>"
                }
            ],
            change : function() {
                self.__reloadAttachment();
            },
            form_group: true
        };

        this.global_max_length_header = this.__getMaxLengthHeader();
        this.global_max_length_body = this.__getMaxLengthBody();
        this.global_max_length_footer = this.__getMaxLengthFooter();

        this.headerTextDefinition = { 
            id : "header_text",
            name : "<%=_T('Header')%>",
            description : "<%=_T('Enter the header message')%>",
            placeholder : "<%=_T('Enter the header message')%>",
            variable: false,
            required : false,
            emojipicker : false,
            brackets: false,
            hyperlinks: false,
            maxLength: this.global_max_length_header,
            showMaxLength: true,
            form_group: true,
            without_label: false,
            not_extended : true,
        };

        this.bodyTextDefinition = { 
            id : "body_text",
            name : "<%=_T('Message')%>",
            description : "<%=_T('Chat message to send (you can use {{ }} to enter variables).')%>",
            placeholder : "<%=_T('Enter the body message')%>",
            variable: true,
            required : true,
            span: true,
            spanClass: "ic_message_container textarea",
            variableIconClass: "ic_variable_icon far fa-at",
            emojipicker : true,
            brackets: true,
            hyperlinks: false,
            maxLength: this.global_max_length_body,
            showMaxLength: true,
            form_group: true,
            without_label: false,
            not_extended : true,
        };

        this.footerTextDefinition = { 
            id : "footer_text",
            name : "<%=_T('Footer')%>",
            description : "<%=_T('Enter the footer message')%>",
            placeholder : "<%=_T('Enter the footer message')%>",
            variable: false,
            required : false,
            emojipicker : false,
            brackets: false,
            hyperlinks: false,
            maxLength: this.global_max_length_footer,
            showMaxLength: true,
            form_group: true,
            without_label: false,
            not_extended : true,
        };

        this.accountDefinition = {
			id : "account",
			name : "<%=_T('Account')%>",
			description : "<%=_T('Template messages account.')%>",
			required : true,
			not_extended : true,
			sort : true,
            form_group: true
		};

        this.urlDefinition = {
            id : "wspUrl",
            name : "<%=_T('Url')%>",
            description : "<%=_T('Url')%>",
            required : false,
            change : function() {
                self.__reloadAttachment();
            },
            variable: true,
            span: true,
            spanClass: "ic_variable_icon_container",
            variableIconClass: "ic_variable_icon far fa-at",
            form_group: true,
            brackets : true
        };
    }

    inConcert.Utils.inherit( adm_process_flow_messages_type_reply_buttons, inConcert.adm_process_flow_messages_type.base.base );

    if (typeof inConcert.adm_process_flow_messages_type.base.reply_buttons !== "function") {
        inConcert.adm_process_flow_messages_type.base.reply_buttons = adm_process_flow_messages_type_reply_buttons;
    }

    adm_process_flow_messages_type_reply_buttons.prototype.name = "<%=_T('Reply Buttons')%>";
    adm_process_flow_messages_type_reply_buttons.prototype.description = "<%=_T('A reply_buttons of items with horizontal navigation.')%>";

    adm_process_flow_messages_type_reply_buttons.prototype.GetMigrationRepositoryFiles = function(_, _1, data) {
        let files = [];
        if (data.message && data.message.attachmentType === "repository" && data.message.fileId) {
            files.push({
                id : data.message.fileId
            });
        }
        return files;
    };

    adm_process_flow_messages_type_reply_buttons.prototype.GetMigrationSharedFiles = function(_, _1, data) {
        let files = [];
        if (data.message && data.message.attachmentType === "repository") {
            if (data.message.sharedFile) {
                // canales sin multiples mensajes
                files.push({
                    id: data.message.sharedFile
                });
            }
            else if (data.message.options) {
                // canales con multiples mensajes
                for (let i = 0; i < data.message.options.length; i++) {
                    let option = data.message.options[i];
                    if (option.MessageType.toLowerCase() === "audio") {
                        files.push({
                            id: option.sharedFile
                        });
                    }
                }
            }
        }
        return files;
    };

    adm_process_flow_messages_type_reply_buttons.prototype.canSupportsMultipleSharedFiles = function() {
        return false;
    };

    adm_process_flow_messages_type_reply_buttons.prototype.__getAttachmentSizeLimitMb = function() {
        return 16;
    };

    adm_process_flow_messages_type_reply_buttons.prototype.__getAttachmentSizeLimit = function() {
        return this.__getAttachmentSizeLimitMb() * 1024 * 1024;
    };

    adm_process_flow_messages_type_reply_buttons.prototype.__getFileTypeDefinition = function(fileType) {
        return inConcert.FileUploaderTypes[fileType];
    };

    adm_process_flow_messages_type_reply_buttons.prototype.__getUploaderType = function() {
        let fileType = this.parent.activity.__getValue(this.fileTypeDefinition);
        return this.__getFileTypeDefinition(fileType);
    };

    adm_process_flow_messages_type_reply_buttons.prototype.displayStatusMessage = function(msg_error/*, msg_type, timemout_ms*/) {
        this.parent.activity.__showError(msg_error);
    };

    adm_process_flow_messages_type_reply_buttons.prototype.find_message = function(msg_id) {
        return this.__findMultiSharedFilesMessageConfig(msg_id);
    };

    adm_process_flow_messages_type_reply_buttons.prototype.Make = function(data) {
        let self = this;

        data.interactive = data.interactive || {};
        data.interactive.header = data.interactive.header || {};
        data.interactive.body = data.interactive.body || {};
        data.interactive.footer = data.interactive.footer || {};
        data.interactive.action = data.interactive.action || {};

        this.data = JSON.parse(JSON.stringify(data));

        let $content = [];
        
        let file_type_save = "text";

        if (data.interactive.header.type === "image") {
            file_type_save = "whatsapp_cloud_image";
        } else if (data.interactive.header.type === "video") {
            file_type_save = "whatsapp_cloud_video";
        } else if (data.interactive.header.type === "document") {
            file_type_save = "whatsapp_cloud_document";
        }

        $content.push(
            this.parent.activity.__makeDivFlex(
                this.parent.activity.__makeComboFlex(this.fileTypeDefinition, file_type_save),{ class: "col-12" }
            )
        );

        if (!this.data[this.attachmentTypeDefinition.id]) {			
			this.data[this.attachmentTypeDefinition.id] = this.attachmentTypeDefinition.options[0].id;
		}

        $content.push(
            this.parent.activity.__makeDivFlex(
                this.parent.activity.__makeComboFlex(this.attachmentTypeDefinition, this.data[this.attachmentTypeDefinition.id]),{ class: "col-4", hidden: (this.attachmentTypeDefinition.options.length <= 1) }
            )
        );

        if (this.data[this.attachmentTypeDefinition.id] === "url" || this.data[this.attachmentTypeDefinition.id] === "shared_file") {
            if (data.interactive.header.type === "image") {
                this.publicFileUrl = data.interactive.header.image.link;
            } else if (data.interactive.header.type === "video") {
                this.publicFileUrl = data.interactive.header.video.link;
            } else if (data.interactive.header.type === "document") {
                this.publicFileUrl = data.interactive.header.document.link;
                this.publicFileName = data.interactive.header.document.filename;
            }
        }

        var accountDefinition_value;

        if (this.data && this.data.campaignId && this.data.accountId) {
            accountDefinition_value = this.data.campaignId + "|" + this.data.accountId;
        }

        $content.push(
            this.parent.activity.__makeDivFlex(
                this.parent.activity.__makeComboFlex(this.accountDefinition, accountDefinition_value),{ class: "col-8" } 
            )
        );

        $content.push(
            this.parent.activity.__makeDivFlex(
                this.parent.activity.__makeInputFlex(this.urlDefinition, this.publicFileUrl),{ class: ((this.attachmentTypeDefinition.options.length <= 1)?"col-12":"col-8") } 
            )
        );

        $content.push(
			this.parent.activity.__makeDivFlex(
				this.parent.activity.__makeDivFlex(
					$(templates.messages_attachment_shared_file_selector), { class: "form-group" }
						), { class: "col-8 align-self-end" }
					)
				);
				
        $content.push($(templates.messages_attachment_upload));
        $content.push($(templates.messages_attachment_preview));
        															
        let $controlTextAreaHeader = this.parent.activity.__makeInputFlex(this.headerTextDefinition, data.interactive.header.text);
			
        if (this.__makeTextLengthHeader) { 
            $controlTextAreaHeader.append(this.__makeTextLengthHeader(data));
        } else {
            $controlTextAreaHeader.append(self.__makeTextLengthHeader(data));
        }

        $controlTextAreaHeader = this.parent.activity.__makeDivFlex($controlTextAreaHeader, { class: "col-12" });

        $controlTextAreaHeader.keyup(function(/*e*/) {

            if (self.headerTextDefinition.showMaxLength) {
                let max_length = self.global_max_length_header;
                let text_value = "";

                if (self.parent && self.parent.activity && self.headerTextDefinition) {
                    text_value = self.parent.activity.__getValue(self.headerTextDefinition);
                } else if (self.parent && self.parent.activity && self.parent.typeEditor.headerTextDefinition) {
                    text_value = self.parent.activity.__getValue(self.parent.typeEditor.headerTextDefinition);
                    max_length = self.parent.typeEditor.global_max_length_header;
                } else if (self.activity && self.typeEditor.headerTextDefinition) {
                    text_value = self.activity.__getValue(self.typeEditor.headerTextDefinition);
                    max_length = self.typeEditor.global_max_length_header;
                } else {
                    console.error(" ##### Entré aquí ##### ");
                }

                const $messages_wsp_header_text_length = $("#messages_wsp_header_text_length");

                if (!text_value) {
                    text_value = "";
                }
                let remaining_length = max_length - text_value.length;

                $messages_wsp_header_text_length.html( new Intl.NumberFormat().format(remaining_length) + " <%=_T('characters')%> | <b><%=_T('Message')%></b>");

                if(remaining_length <= 0) {
                    $("#messages_wsp_header_text_length").addClass("red_text");
                } else {
                    $("#messages_wsp_header_text_length").removeClass("red_text");
                }
            }
            
        });

        $content.push($controlTextAreaHeader);
														  
        let $controlTextAreaBody = this.parent.activity.__makeTextareaFlex(this.bodyTextDefinition, data.interactive.body.text);
				
        if (this.__makeTextLengthBody) { 
            $controlTextAreaBody.append(this.__makeTextLengthBody(data));
        } else {
            $controlTextAreaBody.append(self.__makeTextLengthBody(data));
        }

        $controlTextAreaBody = this.parent.activity.__makeDivFlex($controlTextAreaBody, { class: "col-12" });

        $controlTextAreaBody.keyup(function(/*e*/) {

            if (self.bodyTextDefinition.showMaxLength) {
                let max_length = self.global_max_length_body;
                let text_value = "";

                if (self.parent && self.parent.activity && self.bodyTextDefinition) {
                    text_value = self.parent.activity.__getValue(self.bodyTextDefinition);
                } else if (self.parent && self.parent.activity && self.parent.typeEditor.bodyTextDefinition) {
                    text_value = self.parent.activity.__getValue(self.parent.typeEditor.bodyTextDefinition);
                    max_length = self.parent.typeEditor.global_max_length_body;
                } else if (self.activity && self.typeEditor.bodyTextDefinition) {
                    text_value = self.activity.__getValue(self.typeEditor.bodyTextDefinition);
                    max_length = self.typeEditor.global_max_length_body;
                } else {
                    console.error(" ##### Entré aquí ##### ");
                }

                const $messages_wsp_body_text_length = $("#messages_wsp_body_text_length");

                if (!text_value) {
                    text_value = "";
                }
                let remaining_length = max_length - text_value.length;

                $messages_wsp_body_text_length.html( new Intl.NumberFormat().format(remaining_length) + " <%=_T('characters')%> | <b><%=_T('Message')%></b>");

                if(remaining_length <= 0) {
                    $("#messages_wsp_body_text_length").addClass("red_text");
                } else {
                    $("#messages_wsp_body_text_length").removeClass("red_text");
                }
            }
            
        });

        $content.push($controlTextAreaBody);
														
        let $controlTextAreaFooter = this.parent.activity.__makeInputFlex(this.footerTextDefinition, data.interactive.footer.text);
				
        if (this.__makeTextLengthFooter) { 
            $controlTextAreaFooter.append(this.__makeTextLengthFooter(data));
        } else {
            $controlTextAreaFooter.append(self.__makeTextLengthFooter(data));
        }

        $controlTextAreaFooter = this.parent.activity.__makeDivFlex($controlTextAreaFooter, { class: "col-12" });

        $controlTextAreaFooter.keyup(function(_) {

            if (self.bodyTextDefinition.showMaxLength) {
                let max_length = self.global_max_length_footer;
                let text_value = "";

                if (self.parent && self.parent.activity && self.footerTextDefinition) {
                    text_value = self.parent.activity.__getValue(self.footerTextDefinition);
                } else if (self.parent && self.parent.activity && self.parent.typeEditor.footerTextDefinition) {
                    text_value = self.parent.activity.__getValue(self.parent.typeEditor.footerTextDefinition);
                    max_length = self.parent.typeEditor.global_max_length_footer;
                } else if (self.activity && self.typeEditor.footerTextDefinition) {
                    text_value = self.activity.__getValue(self.typeEditor.footerTextDefinition);
                    max_length = self.typeEditor.global_max_length_footer;
                } else {
                    console.error(" ##### Entré aquí ##### ");
                }

                const $messages_wsp_footer_text_length = $("#messages_wsp_footer_text_length");

                if (!text_value) {
                    text_value = "";
                }
                let remaining_length = max_length - text_value.length;

                $messages_wsp_footer_text_length.html( new Intl.NumberFormat().format(remaining_length) + " <%=_T('characters')%> | <b><%=_T('Message')%></b>");

                if(remaining_length <= 0) {
                    $("#messages_wsp_footer_text_length").addClass("red_text");
                } else {
                    $("#messages_wsp_footer_text_length").removeClass("red_text");
                }
            }
            
        });

        $content.push($controlTextAreaFooter);

        let guid = inConcert.Utils.generateGuid();

        let $buttons = $(Mustache.render(templates.messages_reply_buttons_fixed_option, {
            guid : guid
        }));
        
        $content.push(this.__makeButtonsList(guid, this.data.interactive.action, $buttons));
        
        return $content;
    };

    adm_process_flow_messages_type_reply_buttons.prototype.__getMaxLengthHeader = function() {
        return 20;
    };

    adm_process_flow_messages_type_reply_buttons.prototype.__getMaxLengthBody = function() {
        return 1024;
    };

    adm_process_flow_messages_type_reply_buttons.prototype.__getMaxLengthFooter = function() {
        return 60;
    };

    adm_process_flow_messages_type_reply_buttons.prototype.__makeTextLengthHeader = function(data) {

        let text = "";
        if (data && data.interactive && data.interactive.header && data.interactive.header.text) {
            text = data.interactive.header.text;
        }

        let max_length = this.__getMaxLengthHeader();
        let available_length = new Intl.NumberFormat().format(max_length - text.length);

        let self = this;
        self.buttons = {};
        let $body = $(Mustache.render(templates.messages_wsp_header_text_length, {
            available_length : available_length,
            max_length : new Intl.NumberFormat().format(max_length),
        }));

        return $body;
    };

    adm_process_flow_messages_type_reply_buttons.prototype.__makeTextLengthBody = function(data) {

        let text = "";
        if (data && data.interactive && data.interactive.body && data.interactive.body.text) {
            text = data.interactive.body.text;
        }

        let max_length = this.__getMaxLengthBody();
        let available_length = new Intl.NumberFormat().format(max_length - text.length);

        let $body = $(Mustache.render(templates.messages_wsp_body_text_length, {
            available_length : available_length,
            max_length : new Intl.NumberFormat().format(max_length),
        }));

        return $body;
    };

    adm_process_flow_messages_type_reply_buttons.prototype.__makeTextLengthFooter = function(data) {

        let text = "";
        if (data && data.interactive && data.interactive.footer && data.interactive.footer.text) {
            text = data.interactive.footer.text;
        }

        let max_length = this.__getMaxLengthFooter();
        let available_length = new Intl.NumberFormat().format(max_length - text.length);

        let $body = $(Mustache.render(templates.messages_wsp_footer_text_length, {
            available_length : available_length,
            max_length : new Intl.NumberFormat().format(max_length),
        }));

        return $body;
    };

    adm_process_flow_messages_type_reply_buttons.prototype.AfterAppendBody = function($container) {
        this.__reloadAttachment();
        var activity = this.parent.activity;
        activity.__discoverEmojiPickers($container);
    };

    adm_process_flow_messages_type_reply_buttons.prototype.__reloadAttachment = function() {

        let self = this;

        self.__accountAfterAdd(self.data, undefined, function(){
            let fileType = self.parent.activity.__getValue(self.fileTypeDefinition, self.$get());
            let attachmentType = self.parent.activity.__getValue(self.attachmentTypeDefinition, self.$get());

            if (fileType === "text") {
                self.__hideUrlAttachment();
                self.__hideAccountDefinition();
                self.__hideSharedFileAttachment();
                self.__hideRepositoryAttachment();
                self.__hideAttachmentTypeDefinition();
                self.__showTextMessage();
            }
            else if (attachmentType === "url") {
                self.__hideSharedFileAttachment();
                self.__hideAccountDefinition();
                self.__hideRepositoryAttachment();
                self.__showUrlAttachment();
                self.__showAttachmentTypeDefinition();
                self.__hideTextMessage();
            }
            else if (attachmentType === "shared_file" || attachmentType === undefined) {
                self.__hideUrlAttachment();
                self.__showAccountDefinition();
                self.__hideRepositoryAttachment();
                self.__showSharedFileAttachment();
                self.__showAttachmentTypeDefinition();
                self.__hideTextMessage();
            }
            else if (attachmentType === "repository") {
                self.__hideUrlAttachment();
                self.__hideAccountDefinition();
                self.__hideSharedFileAttachment();
                self.__showRepositoryAttachment();
                self.__showAttachmentTypeDefinition();
                self.__hideTextMessage();
            }
        });
    };

    adm_process_flow_messages_type_reply_buttons.prototype.__showUrlAttachment = function() {
        if (!this.urlUploader) {
            this.__loadUrlAttachment();
        }
        this.__updateUrlAttachment();
        this.parent.activity.__showControl(this.urlDefinition, this.$get());
        this.$get("[attachment_preview='url']").show();
    };

    adm_process_flow_messages_type_reply_buttons.prototype.__showAccountDefinition = function() {
        this.parent.activity.__showControl(this.accountDefinition, this.$get());
    };

    adm_process_flow_messages_type_reply_buttons.prototype.__loadUrlAttachment = function() {
        this.urlUploader = new inConcert.FileUploaderControl({
            preview : {
                $control : this.$get("[attachment_preview='url']"),
                canRemove : false,
                name : false,
                size : false
            },
            type : this.__getUploaderType(),
            disabled : true,
            alwaysValid : true
        });
    };

    adm_process_flow_messages_type_reply_buttons.prototype.__updateUrlAttachment = function() {
        this.urlUploader.changeType(this.__getUploaderType());
        let url = this.parent.activity.__getValue(this.urlDefinition, this.$get());
        let currentFile = this.urlUploader.getFile();
        if (url && (!currentFile || currentFile.url !== url)) {
            this.urlUploader.addInitialFile({
                id : "dummy",
                url : url,
                file : this.urlUploader.makeManualFile({
                    name : "dummy",
                    type : "dummy",
                    size : 1
                }),
                uploaded : true
            });
        }
        else if (!url) {
            this.urlUploader.cleanAllFiles();
        }
    };

    adm_process_flow_messages_type_reply_buttons.prototype.__hideUrlAttachment = function() {
        this.parent.activity.__hideControl(this.urlDefinition, this.$get());
        this.$get("[attachment_preview='url']").hide();
    };
    
    adm_process_flow_messages_type_reply_buttons.prototype.__hideAccountDefinition = function() {
        this.parent.activity.__hideControl(this.accountDefinition, this.$get());
    };

    adm_process_flow_messages_type_reply_buttons.prototype.__showSharedFileAttachment = function() {

        if (this.canSupportsMultipleSharedFiles()) {
            this.$get("[attachment_shared_file_selector_container]").parent().parent().hide();
            this.$get("[attachment_shared_file_selector_container]").hide();
            this.$get("[attachment_preview='shared_file']").hide();
            return;
        }
        if (!this.sharedFile) {
            this.__loadSharedFileAttachment();
        }
        else {
            this.__updateSharedFileAttachment();
        }
        this.$get("[attachment_shared_file_selector_container]").parent().parent().show();
        this.$get("[attachment_shared_file_selector_container]").show();
        this.$get("[attachment_preview='shared_file']").show();
    };

    adm_process_flow_messages_type_reply_buttons.prototype.__accountAfterAdd = function(data, $data, callback) {

		let self = this;
		let activity = this.parent.activity;
		activity.editor.GetTemplateMessageOptions(function(accounts) {
			if (!accounts) {
				self.parent.activity.__showError("<%=_T('Error loading template messages')%>");
                callback();
				return;
			}
			self.__accountsOptions = {};
			self.accountDefinition.options = [];
			$.each(accounts, function(_, account) {
    			self.accountDefinition.options.push({ id : account.campaign + "|" + account.id, name : account.name, language : account.language });
				self.__accountsOptions[account.campaign + "|" + account.id] = account.options;
			});

            var accountDefinition_value;

            if (data && data.campaignId && data.accountId) {
                accountDefinition_value = data.campaignId + "|" + data.accountId;
            }

			activity.__replaceControl(self.accountDefinition,
				activity.__makeComboFlex(self.accountDefinition, accountDefinition_value), $data);

            callback();
		});
	};

    adm_process_flow_messages_type_reply_buttons.prototype.__setSharedFileAttachment = function(sharedFile) {

        let self = this;
        self.sharedFile = sharedFile;

        let campaign_data = self.parent.activity.__getValue(self.accountDefinition, self.$get());
        let campaignId;
        let accountId;

        if (campaign_data && campaign_data.split("|").length > 1) {
            campaignId = campaign_data.split("|")[0];
            accountId = campaign_data.split("|")[1];

            inConcert.invoke({
                url: inConcert.app.getBaseDomain() + "/inconcert/apps/administration/campaigns/whatsapp_get_cloud_api_public_repository_file_url/",
                type: "POST",
                data: JSON.stringify({
                    campaignId : campaignId,
                    accountId : accountId,
                    fileId: sharedFile.RepositoryId,
                    fileName: sharedFile.Name
                }),
                dataType: "json",
                contentType: "application/json",
                success: function(response) {

                    if(response.result && response.result === "OK") {
                        
                        self.publicFileUrl = response.publicFileUrl;
                        self.publicFileName = sharedFile.Name;

                        self.sharedFileUploader.addInitialFile({
                            id : sharedFile.RepositoryId,
                            file : self.sharedFileUploader.makeManualFile({
                                name : sharedFile.Name,
                                type : sharedFile.ContentType,
                                size : sharedFile.Size
                            }),
                            uploaded : true
                        },function(fileResult) {
                            if (fileResult && fileResult.result && fileResult.result !== "OK") {
                                self.parent.activity.__showError("<%=_T('"+ fileResult.reason +"')%>", null, 3000);
                            } else if (!fileResult || !fileResult.result) {
                                self.parent.activity.__showError("<%=_T('Unknown error')%>", null, 3000);
                            }
                        });
                    }
                    else {
                        let errorMsg = response.reason || "Unknown error";
                        self.parent.activity.__showError("<%=_T('"+ errorMsg +"')%>", null, 3000);
                    }
                },
                error: function(_, text_status) {
                    let errorMsg = text_status.reason || "Unknown error";
                    if (errorMsg === "GetCloudApiPublicRepositoryFileUrl not allowed on WAVY integration type") {
                        self.parent.activity.__showError("<%=_T('GetCloudApiPublicRepositoryFileUrl not allowed on WAVY integration type')%>", null, 3000);
                    } else {
                        self.parent.activity.__showError("<%=_T('"+ errorMsg +"')%>", null, 3000);
                    }
                }
            });
        }
    };

    adm_process_flow_messages_type_reply_buttons.prototype.__loadSharedFileAttachment = function() {
        const self = this;
        this.$get("[attachment_shared_file_selector]").click(function() {
            self.__showSharedFilesSelector();
        });

        this.sharedFileUploader = new inConcert.FileUploaderControl({
            preview : {
                $control : self.$get("[attachment_preview='shared_file']"),
                canRemove : false
            },
            type : self.__getUploaderType(),
            sizeLimitMB : self.__getAttachmentSizeLimitMb(),
            disabled : true
        });

        if (this.data.sharedFile) {
            let api = inConcert.app.getSharedFilesAPI();
            api.getFile({fileId : self.data.sharedFile}, function(status, sharedFile) {
                if (status) {
                    self.__setSharedFileAttachment(sharedFile);
                }
            });
        }
    };

    adm_process_flow_messages_type_reply_buttons.prototype.__showSharedFilesSelector = function() {
        const self = this;
        let fileType = this.__getUploaderType();
        let channel = this.parent.activity.type.toUpperCase();

        let popup = new sharedFilesSelector(
            {
                type          : fileType.id,
                typeName      : this.parent.activity.__getComboLabel(this.fileTypeDefinition, self.$get()),
                typeExtensions: fileType.extensions,
                sizeLimit     : this.__getAttachmentSizeLimit(),
                channel       : channel
            },
            function(sharedFile) {
                if (sharedFile) {
                    self.__setSharedFileAttachment(sharedFile);
                }
            }
        );
        popup.Show();
    };

    adm_process_flow_messages_type_reply_buttons.prototype.__updateSharedFileAttachment = function() {
        this.sharedFileUploader.changeType(this.__getUploaderType());
    };

    adm_process_flow_messages_type_reply_buttons.prototype.__hideSharedFileAttachment = function() {
        this.$get("[attachment_shared_file_selector_container]").parent().parent().hide();
        this.$get("[attachment_shared_file_selector_container]").hide();
        this.$get("[attachment_preview='shared_file']").hide();
    };

    adm_process_flow_messages_type_reply_buttons.prototype.__hideAttachmentTypeDefinition = function() {
        this.parent.activity.__toggleControl(this.attachmentTypeDefinition, false);
    };

    adm_process_flow_messages_type_reply_buttons.prototype.__showAttachmentTypeDefinition = function() {
        this.parent.activity.__toggleControl(this.attachmentTypeDefinition, true);
    };

    adm_process_flow_messages_type_reply_buttons.prototype.__showRepositoryAttachment = function() {
        if (!this.repositoryUploader) {
            this.__loadRepositoryAttachment();
        }
        else {
            this.__updateRepositoryAttachment();
        }
        this.$get("[attachment_upload]").show();
        this.$get("[attachment_preview='repository']").show();
    };

    adm_process_flow_messages_type_reply_buttons.prototype.__showTextMessage = function() {
        this.parent.activity.__toggleControl(this.headerTextDefinition, true);
        $("#messages_wsp_header_text_length").show();
    };

    adm_process_flow_messages_type_reply_buttons.prototype.__hideTextMessage = function() {
        this.parent.activity.__toggleControl(this.headerTextDefinition, false);
        $("#messages_wsp_header_text_length").hide();
    };

    adm_process_flow_messages_type_reply_buttons.prototype.__loadRepositoryAttachment = function() {
        let self = this;
        self.repositoryUploader = new inConcert.FileUploaderControl({
            uploader : {
                $control : self.$get("[attachment_upload]")
            },
            dragger : {
                $control : self.$get("[attachment_upload]")
            },
            preview : {
                $control : self.$get("[attachment_preview='repository']"),
                canRemove : false
            },
            type : self.__getUploaderType(),
            sizeLimitMB : self.__getAttachmentSizeLimitMb()
        });
        self.repositoryUploader.onFileAddError = function(_, result, callback) {
            self.parent.activity.__showError(result.reason, null, 3000);
            callback();
        };
        if (self.data.fileId && !self.data.sharedFile) {
            self.repositoryUploader.addInitialRepositoryFile({
                id : self.data.fileId,
                uploaded : true
            });
        }
    };

    adm_process_flow_messages_type_reply_buttons.prototype.__updateRepositoryAttachment = function() {
        this.repositoryUploader.changeType(this.__getUploaderType());
    };

    adm_process_flow_messages_type_reply_buttons.prototype.__hideRepositoryAttachment = function() {
        this.$get("[attachment_upload]").hide();
        this.$get("[attachment_preview='repository']").hide();
    };

    adm_process_flow_messages_type_reply_buttons.prototype.__maxButtons = function() {
        return 3;
    };

    adm_process_flow_messages_type_reply_buttons.prototype.__addButton = function(button, _, _1, $buttonsList) {

        var maxButtons = this.__maxButtons();

        $buttonsList = $buttonsList || this.$get("[messages_data_type='reply_buttons']").find("[buttons_list]");

        if ($buttonsList.find("[template_button]").length >= maxButtons) {
            this.parent.activity.__showError(format("<%=_T('Item has a limit of {0} buttons.')%>", maxButtons), null, 3000);
            return;
        }

        var buttonConstructor = inConcert.adm_process_flow_messages_button[this.parent.activity.type.toLowerCase()].reply_buttons;
        var editor = new buttonConstructor(this.parent, button, $buttonsList);

        this.buttons[editor.guid] = editor;
        editor.Make();
    };

    adm_process_flow_messages_type_reply_buttons.prototype.__makeButtonsList = function(guid, data, $item) {

        var self = this;

        data.buttons = data.buttons || [];

        if (!self.__maxButtons()) {
            return null;
        }
        var $body = $(Mustache.render(templates.messages_buttons_list_whatsapp, {
            add_title : "<%=_T('Add Button')%>"
        }));
        $body.find("[add_button]").click(function() {
            var $item = $(this).closest("[buttons_list]");
            self.__addButton(null, $item.attr("buttons_list"), $item);
        });
        var $buttonsList = $body.find("[buttons_list]");
        $.each(data.buttons || [], function(_, button) {
            if(button.reply) {
                button.id = button.reply.id;
                button.title = button.reply.title;
            }
            self.__addButton(button, guid, $item, $buttonsList);
        });
        $body.find("[buttons_list]").sortable({
            cursor : "move"
        });

		if (data.buttons.length > 0) {
			$body.find("[quickreplies_title]").show();
		} else {
			$body.find("[quickreplies_title]").hide();
		}

        return $body;
    };

    adm_process_flow_messages_type_reply_buttons.prototype.__getButtons = function() {

        var self = this;
        var buttons = [];

        self.$get("[template_button]").each(function() {
            var guid = $(this).attr("template_button");
            var editor = self.buttons[guid];
            var data = editor && editor.GetData();

            if (data) {
                let btn = JSON.parse(JSON.stringify(data));
                btn.type = "reply";
                btn.reply = btn.reply || {};
                btn.reply.id = data.id;
                btn.reply.title = data.title;
                delete btn.port_id;
                delete btn.id;
                delete btn.title;
                delete btn.title_original;
                delete btn.id_original;
                delete btn.reply.title_original;
                delete btn.reply.id_original;
                buttons.push(btn);
            }
        });
        return buttons;
    };

    adm_process_flow_messages_type_reply_buttons.prototype.AddValue = function(data) {

        let activity = this.parent.activity;
        
        data.interactive = data.interactive || {};
        data.interactive.type = "button";
        data.interactive.header = data.interactive.header || {};
        data.interactive.body = data.interactive.body || {};
        data.interactive.footer = data.interactive.footer || {};
        data.interactive.action = data.interactive.action || {};
        
        let file_type = activity.__getValue(this.fileTypeDefinition);
        let file_type_save = "text";

        if (file_type === "whatsapp_cloud_image") {
            file_type_save = "image";
        } else if (file_type === "whatsapp_cloud_video") {
            file_type_save = "video";
        } else if (file_type === "whatsapp_cloud_document") {
            file_type_save = "document";
        }

        data.interactive.header.type = file_type_save;
        let type = activity.__getValue(this.attachmentTypeDefinition);

        if (data.interactive.header.type === "text") {
            let text = activity.__getValue(this.headerTextDefinition);
            data.interactive.header.text = text;
        } else if (data.interactive.header.type === "image") {
            data.interactive.header.image = data.interactive.header.image || {};
            if (type === "shared_file") { // shared_file
                data.interactive.header.image.link = this.publicFileUrl;
            } else { // url
                let url = activity.__getValue(this.urlDefinition);                
                data.interactive.header.image.link = url;
            }
        } else if (data.interactive.header.type === "video") {
            data.interactive.header.video = data.interactive.header.video || {};

            if (type === "shared_file") { // shared_file
                data.interactive.header.video.link = this.publicFileUrl;
            } else { // url
                let url = activity.__getValue(this.urlDefinition);
                data.interactive.header.video.link = url;
            }
        } else if (data.interactive.header.type === "document") {
            data.interactive.header.document = data.interactive.header.document || {};

            if (type === "shared_file") { // shared_file
                data.interactive.header.document.link = this.publicFileUrl;
                data.interactive.header.document.filename = this.publicFileName;
            } else { // url
                let url = activity.__getValue(this.urlDefinition);
                data.interactive.header.document.link = url;
            }
        }

        let campaign_data = activity.__getValue(this.accountDefinition, this.$get());

        if (campaign_data && campaign_data.split("|").length > 1) {
            data.campaignId = campaign_data.split("|")[0];
            data.accountId = campaign_data.split("|")[1];
        }

		if (data.interactive.header.type === "text" || type !== "shared_file") {
			delete data.campaignId;
            delete data.accountId;
		}

        let data_temp = {};
        activity.__addValue(data_temp, this.bodyTextDefinition);
        data.interactive.body.text = data_temp.body_text;
        data.interactive.body.__brackets_text = data_temp.__brackets_body_text;


        if (!data.interactive.body.text) {
            data.error = "<%=_T('Message is required.')%>";
        }

        let footer_text = activity.__getValue(this.footerTextDefinition);
        data.interactive.footer.text = footer_text;

        data.interactive.action.buttons = this.__getButtons();

        if (!data.interactive.action.buttons.length) {
            data.error = "<%=_T('Must add almost one button.')%>";
        }

    };

    adm_process_flow_messages_type_reply_buttons.prototype.AddValueAsync = function(data, callback) {

		let activity = this.parent.activity;
		let $container = this.$get();
		activity.__addValue(data, this.attachmentTypeDefinition, $container);
		activity.__addValue(data, this.fileTypeDefinition, $container);

        if (data[this.fileTypeDefinition.id] !== "text") {
            switch(data[this.attachmentTypeDefinition.id]) {
                case "url":
                    this.__addUrlValue(data, callback);
                    break;
                case "shared_file":
                    this.__addSharedFileValues(data, callback);
                    break;
                case "repository":
                    this.__addRepositoryValue(data, callback);
                    break;
                default:
                    callback();
                    break;
            }
        } else {
            callback();
        }
            
	};

    adm_process_flow_messages_type_reply_buttons.prototype.__addUrlValue = function(data, callback) {
		let activity = this.parent.activity;
		activity.__addValue(data, this.urlDefinition, this.$get());
		callback();
	};

    adm_process_flow_messages_type_reply_buttons.prototype.__addSharedFileValues = function(data, callback) {

		if (this.canSupportsMultipleSharedFiles()) {
			let response = this.__validateMultiSharedFileValues();
			if (response.success) {
				data.options = response.multiMessages;
				delete data.sharedFile;
				delete data.RepositoryId;
			}
			else {
				data.error = {
					message: response.err
				};
			}
		}
		else {
			if (this.sharedFile) {
				data.sharedFile = this.sharedFile.Id;
				data.RepositoryId = this.sharedFile.RepositoryId;
			}
			else {
				data.error = {
					message : "<%=_T('Must select a file.')%>"
				};
			}
		}
		callback();
	};

    adm_process_flow_messages_type_reply_buttons.prototype.__addRepositoryValue = function(data, callback) {
        let self = this;
        //get file
        let fileData = self.repositoryUploader.getFile();
        if (!fileData) {
            data.error = {
                message : "<%=_T('Must upload a file.')%>"
            };
            return callback();
        }
        //load data
        data.fileId = fileData.id;
        data.fileName = self.repositoryUploader.getFileName(fileData.file);
        data.mimeType = self.repositoryUploader.getFileType(fileData.file);
        data.extension = self.repositoryUploader.getFileExtension(fileData.file);
        if (fileData.uploaded) {
            return callback();
        }
        //upload file
        self.repositoryUploader.uploadFile(fileData, function(result) {
            if (!self.repositoryUploader.__isOk(result)) {
                data.error = {
                    message : "<%=_T('Error uploading file to server.')%>"
                };
            }
            callback();
        });
    };

//list_messages

    function adm_process_flow_messages_type_list_messages(parent) {
        adm_process_flow_messages_type_list_messages.uber.constructor.call(this, parent);

        this.global_max_length_header = this.__getMaxLengthHeader();
        this.global_max_length_body = this.__getMaxLengthBody();
        this.global_max_length_footer = this.__getMaxLengthFooter();
        this.global_max_length_button = this.__getMaxLengthButton();

        this.headerTextDefinition = { 
            id : "header_text",
            name : "<%=_T('Header')%>",
            description : "<%=_T('Enter the header message')%>",
            placeholder : "<%=_T('Enter the header message')%>",
            variable: false,
            required : false,
            emojipicker : false,
            brackets: false,
            hyperlinks: false,
            maxLength: this.global_max_length_header,
            showMaxLength: true,
            form_group: true,
            without_label: false,
            not_extended : true,
        };

        this.bodyTextDefinition = { 
            id : "body_text",
            name : "<%=_T('Message')%>",
            description : "<%=_T('Chat message to send (you can use {{ }} to enter variables).')%>",
            placeholder : "<%=_T('Enter the message')%>",
            variable: true,
            required : true,
            span: true,
            spanClass: "ic_message_container textarea",
            variableIconClass: "ic_variable_icon far fa-at",
            emojipicker : true,
            brackets: true,
            hyperlinks: false,
            maxLength: this.global_max_length_body,
            showMaxLength: true,
            form_group: true,
            without_label: false,
            not_extended : true,
        };

        this.footerTextDefinition = { 
            id : "footer_text",
            name : "<%=_T('Footer')%>",
            description : "<%=_T('Enter the footer message')%>",
            placeholder : "<%=_T('Enter the footer message')%>",
            variable: false,
            required : false,
            emojipicker : false,
            brackets: false,
            hyperlinks: false,
            maxLength: this.global_max_length_footer,
            showMaxLength: true,
            form_group: true,
            without_label: false,
            not_extended : true,
        };

        this.buttonTextDefinition = { 
            id : "button_text",
            name : "<%=_T('Button Label')%>",
            description : "<%=_T('Enter the button label')%>",
            placeholder : "<%=_T('Enter the button label')%>",
            variable: false,
            required : true,
            emojipicker : false,
            brackets: false,
            hyperlinks: false,
            maxLength: this.global_max_length_button,
            showMaxLength: true,
            form_group: true,
            without_label: false,
            not_extended : true,
        };

        this.titleDefinition = { 
            id : "title",
            name : "<%=_T('Section')%>",
            placeholder : "<%=_T('Title')%>",
            description : "<%=_T('Title')%>",
            required : true,
            variable: false,
            controlContainerClass : "form-group flex-grow-1",
            form_group: false,
            without_label : false,
            maxLength : 24,
            brackets : false
        };

    }

    inConcert.Utils.inherit( adm_process_flow_messages_type_list_messages, inConcert.adm_process_flow_messages_type.base.base );

    if (typeof inConcert.adm_process_flow_messages_type.base.list_messages !== "function") {
        inConcert.adm_process_flow_messages_type.base.list_messages = adm_process_flow_messages_type_list_messages;
    }

    adm_process_flow_messages_type_list_messages.prototype.name = "<%=_T('List Messages')%>";
    adm_process_flow_messages_type_list_messages.prototype.description = "<%=_T('A list messages of items with horizontal navigation.')%>";

    adm_process_flow_messages_type_list_messages.prototype.Make = function(data) {

        let self = this;

        data.interactive = data.interactive || {};
        data.interactive.header = data.interactive.header || {};
        data.interactive.body = data.interactive.body || {};
        data.interactive.footer = data.interactive.footer || {};
        data.interactive.action = data.interactive.action || {};

        let $content = [];

																		
        let $controlTextAreaHeader = this.parent.activity.__makeInputFlex(this.headerTextDefinition, data.interactive.header.text);
								 
		 

        if (this.__makeTextLengthHeader) { 
            $controlTextAreaHeader.append(this.__makeTextLengthHeader(data));
        } else {
            $controlTextAreaHeader.append(self.__makeTextLengthHeader(data));
        }

        $controlTextAreaHeader = this.parent.activity.__makeDivFlex($controlTextAreaHeader, { class: "col-12" });

        $controlTextAreaHeader.keyup(function(/*e*/) {

            if (self.headerTextDefinition.showMaxLength) {
                let max_length = self.global_max_length_header;
                let text_value = "";

                if (self.parent && self.parent.activity && self.headerTextDefinition) {
                    text_value = self.parent.activity.__getValue(self.headerTextDefinition);
                } else if (self.parent && self.parent.activity && self.parent.typeEditor.headerTextDefinition) {
                    text_value = self.parent.activity.__getValue(self.parent.typeEditor.headerTextDefinition);
                    max_length = self.parent.typeEditor.global_max_length_header;
                } else if (self.activity && self.typeEditor.headerTextDefinition) {
                    text_value = self.activity.__getValue(self.typeEditor.headerTextDefinition);
                    max_length = self.typeEditor.global_max_length_header;
                } else {
                    console.error(" ##### Entré aquí ##### ");
                }

                const $messages_wsp_header_text_length = $("#messages_wsp_list_header_text_length");

                if (!text_value) {
                    text_value = "";
                }
                let remaining_length = max_length - text_value.length;

                $messages_wsp_header_text_length.html( new Intl.NumberFormat().format(remaining_length) + " <%=_T('characters')%> | <b><%=_T('Message')%></b>");

                if(remaining_length <= 0) {
                    $("#messages_wsp_list_header_text_length").addClass("red_text");
                } else {
                    $("#messages_wsp_list_header_text_length").removeClass("red_text");
                }
            }
            
        });

        $content.push($controlTextAreaHeader);
													  
        let $controlTextAreaBody = this.parent.activity.__makeTextareaFlex(this.bodyTextDefinition, data.interactive.body.text);
				
        if (this.__makeTextLengthBody) { 
            $controlTextAreaBody.append(this.__makeTextLengthBody(data));
        } else {
            $controlTextAreaBody.append(self.__makeTextLengthBody(data));
        }

        $controlTextAreaBody = this.parent.activity.__makeDivFlex($controlTextAreaBody, { class: "col-12" });

        $controlTextAreaBody.keyup(function(/*e*/) {

            if (self.bodyTextDefinition.showMaxLength) {
                let max_length = self.global_max_length_body;
                let text_value = "";

                if (self.parent && self.parent.activity && self.bodyTextDefinition) {
                    text_value = self.parent.activity.__getValue(self.bodyTextDefinition);
                } else if (self.parent && self.parent.activity && self.parent.typeEditor.bodyTextDefinition) {
                    text_value = self.parent.activity.__getValue(self.parent.typeEditor.bodyTextDefinition);
                    max_length = self.parent.typeEditor.global_max_length_body;
                } else if (self.activity && self.typeEditor.bodyTextDefinition) {
                    text_value = self.activity.__getValue(self.typeEditor.bodyTextDefinition);
                    max_length = self.typeEditor.global_max_length_body;
                } else {
                    console.error(" ##### Entré aquí ##### ");
                }

                const $messages_wsp_body_text_length = $("#messages_wsp_list_body_text_length");

                if (!text_value) {
                    text_value = "";
                }
                let remaining_length = max_length - text_value.length;

                $messages_wsp_body_text_length.html( new Intl.NumberFormat().format(remaining_length) + " <%=_T('characters')%> | <b><%=_T('Message')%></b>");

                if(remaining_length <= 0) {
                    $("#messages_wsp_list_body_text_length").addClass("red_text");
                } else {
                    $("#messages_wsp_list_body_text_length").removeClass("red_text");
                }
            }
            
        });

        $content.push($controlTextAreaBody);
															
        let $controlTextAreaFooter = this.parent.activity.__makeInputFlex(this.footerTextDefinition, data.interactive.footer.text);
			
        if (this.__makeTextLengthFooter) { 
            $controlTextAreaFooter.append(this.__makeTextLengthFooter(data));
        } else {
            $controlTextAreaFooter.append(self.__makeTextLengthFooter(data));
        }

        $controlTextAreaFooter = this.parent.activity.__makeDivFlex($controlTextAreaFooter, { class: "col-12" });

        $controlTextAreaFooter.keyup(function(/*e*/) {

            if (self.bodyTextDefinition.showMaxLength) {
                let max_length = self.global_max_length_footer;
                let text_value = "";

                if (self.parent && self.parent.activity && self.footerTextDefinition) {
                    text_value = self.parent.activity.__getValue(self.footerTextDefinition);
                } else if (self.parent && self.parent.activity && self.parent.typeEditor.footerTextDefinition) {
                    text_value = self.parent.activity.__getValue(self.parent.typeEditor.footerTextDefinition);
                    max_length = self.parent.typeEditor.global_max_length_footer;
                } else if (self.activity && self.typeEditor.footerTextDefinition) {
                    text_value = self.activity.__getValue(self.typeEditor.footerTextDefinition);
                    max_length = self.typeEditor.global_max_length_footer;
                } else {
                    console.error(" ##### Entré aquí ##### ");
                }

                const $messages_wsp_footer_text_length = $("#messages_wsp_list_footer_text_length");

                if (!text_value) {
                    text_value = "";
                }
                let remaining_length = max_length - text_value.length;

                $messages_wsp_footer_text_length.html( new Intl.NumberFormat().format(remaining_length) + " <%=_T('characters')%> | <b><%=_T('Message')%></b>");

                if(remaining_length <= 0) {
                    $("#messages_wsp_list_footer_text_length").addClass("red_text");
                } else {
                    $("#messages_wsp_list_footer_text_length").removeClass("red_text");
                }
            }
            
        });

        $content.push($controlTextAreaFooter);
													
        let $controlTextAreaButton = this.parent.activity.__makeInputFlex(this.buttonTextDefinition, data.interactive.action.button);
				
        if (this.__makeTextLengthButton) { 
            $controlTextAreaButton.append(this.__makeTextLengthButton(data));
        } else {
            $controlTextAreaButton.append(self.__makeTextLengthButton(data));
        }

        $controlTextAreaButton = this.parent.activity.__makeDivFlex($controlTextAreaButton, { class: "col-12" });

        $controlTextAreaButton.keyup(function(/*e*/) {

            if (self.buttonTextDefinition.showMaxLength) {
                let max_length = self.global_max_length_button;
                let text_value = "";

                if (self.parent && self.parent.activity && self.buttonTextDefinition) {
                    text_value = self.parent.activity.__getValue(self.buttonTextDefinition);
                } else if (self.parent && self.parent.activity && self.parent.typeEditor.buttonTextDefinition) {
                    text_value = self.parent.activity.__getValue(self.parent.typeEditor.buttonTextDefinition);
                    max_length = self.parent.typeEditor.global_max_length_button;
                } else if (self.activity && self.typeEditor.buttonTextDefinition) {
                    text_value = self.activity.__getValue(self.typeEditor.buttonTextDefinition);
                    max_length = self.typeEditor.global_max_length_button;
                } else {
                    console.error(" ##### Entré aquí ##### ");
                }

                const $messages_wsp_button_text_length = $("#messages_wsp_list_button_text_length");

                if (!text_value) {
                    text_value = "";
                }
                let remaining_length = max_length - text_value.length;

                $messages_wsp_button_text_length.html( new Intl.NumberFormat().format(remaining_length) + " <%=_T('characters')%> | <b><%=_T('Message')%></b>");

                if(remaining_length <= 0) {
                    $("#messages_wsp_list_button_text_length").addClass("red_text");
                } else {
                    $("#messages_wsp_list_button_text_length").removeClass("red_text");
                }
            }
            
        });

        $content.push($controlTextAreaButton);

        let $body = $(templates.messages_list_messages);

        ($body.find("[list_type]"))
                .html("")
                .append(this.__fixedMake(data, this.$get("[global_list_messages]")))
                .show();

        $content.push($body);

        return $content;
    };

    adm_process_flow_messages_type_list_messages.prototype.__getMaxLengthHeader = function() {
        return 60;
    };

    adm_process_flow_messages_type_list_messages.prototype.__getMaxLengthBody = function() {
        return 1024;
    };

    adm_process_flow_messages_type_list_messages.prototype.__getMaxLengthFooter = function() {
        return 60;
    };

    adm_process_flow_messages_type_list_messages.prototype.__getMaxLengthButton = function() {
        return 20;
    };

    adm_process_flow_messages_type_list_messages.prototype.__makeTextLengthHeader = function(data) {

        let text = "";
        if (data && data.interactive && data.interactive.header && data.interactive.header.text) {
            text = data.interactive.header.text;
        }

        let max_length = this.__getMaxLengthHeader();
        let available_length = new Intl.NumberFormat().format(max_length - text.length);

        let $body = $(Mustache.render(templates.messages_wsp_list_header_text_length, {
            available_length : available_length,
            max_length : new Intl.NumberFormat().format(max_length),
        }));

        return $body;
    };

    adm_process_flow_messages_type_list_messages.prototype.__makeTextLengthBody = function(data) {

        let text = "";
        if (data && data.interactive && data.interactive.body && data.interactive.body.text) {
            text = data.interactive.body.text;
        }

        let max_length = this.__getMaxLengthBody();
        let available_length = new Intl.NumberFormat().format(max_length - text.length);

        let $body = $(Mustache.render(templates.messages_wsp_list_body_text_length, {
            available_length : available_length,
            max_length : new Intl.NumberFormat().format(max_length),
        }));

        return $body;
    };

    adm_process_flow_messages_type_list_messages.prototype.__makeTextLengthFooter = function(data) {

        let text = "";
        if (data && data.interactive && data.interactive.footer && data.interactive.footer.text) {
            text = data.interactive.footer.text;
        }

        let max_length = this.__getMaxLengthFooter();
        let available_length = new Intl.NumberFormat().format(max_length - text.length);

        let $body = $(Mustache.render(templates.messages_wsp_list_footer_text_length, {
            available_length : available_length,
            max_length : new Intl.NumberFormat().format(max_length),
        }));

        return $body;
    };

    adm_process_flow_messages_type_list_messages.prototype.__makeTextLengthButton = function(data) {

        let text = "";
        if (data && data.interactive && data.interactive.button && data.interactive.button.text) {
            text = data.interactive.button.text;
        }

        let max_length = this.__getMaxLengthButton();
        let available_length = new Intl.NumberFormat().format(max_length - text.length);

        let $body = $(Mustache.render(templates.messages_wsp_list_button_text_length, {
            available_length : available_length,
            max_length : new Intl.NumberFormat().format(max_length),
        }));

        return $body;
    };

    adm_process_flow_messages_type_list_messages.prototype.AfterAppendBody = function($container) {
        var activity = this.parent.activity;
        activity.__discoverEmojiPickers($container);
    };

    adm_process_flow_messages_type_list_messages.prototype.__addGlobalOptions = function(data) {
        var activity = this.parent.activity;
        var $container = this.$get("[global_options]");
        activity.__addValue(data, this.imageAspectDefinition, $container);
    };

    adm_process_flow_messages_type_list_messages.prototype.__fixedMake = function(data) {
        data.interactive = data.interactive || {};
        data.interactive.action = data.interactive.action || {};
        data.interactive.action.sections = data.interactive.action.sections || {};

        var self = this;
        var $body = $(templates.messages_list_messages_fixed_options);

        $body.find("[add_option_container]").click(function() {
            self.__addFixedOption();
        });
        var $list = $body.find("[fixed_list]");

        self.fixedOptions = {};
        $list.sortable({
            cursor : "move"
        });
        $.each(data.interactive.action.sections || [], function(_, option) {
            self.__addFixedOption(option, $body);
        });

        return $body;
    };

    adm_process_flow_messages_type_list_messages.prototype.__addFixedOption = function(option, $formBody) {

        let self = this;
        let activity = self.parent.activity;
        option = option || {};
        let $list = $formBody? $formBody.find("[fixed_list]") : self.$get("[list_type]").find("[fixed_list]");

        var maxSections = self.__maxSections();

        if ($list.find("[list_messages_item_form]").length >= maxSections) {
            activity.__showError(format("<%=_T('Item has a limit of {0} sections.')%>", maxSections));
            return;
        }

        let guid = inConcert.Utils.generateGuid();
        self.fixedOptions[guid] = {
            rows : {}
        };
        let $body = $(Mustache.render(templates.messages_list_messages_fixed_option, {
            guid : guid
        }));
        let $button_delete = $(Mustache.render(templates.messages_list_messages_fixed_option_delete_button, {
            guid : guid
        }));

        let $form = $body.find("[list_messages_item_form]");
        let $titleDefinition = activity.__makeInputFlex(this.titleDefinition, option[this.titleDefinition.id]);
        
        $titleDefinition.append(
            $button_delete
        );

        $form.append(
            $titleDefinition
        );

        $body.append(this.__makeButtonsList(guid, option, $body));
        $body.find("[list_messages_item_remove]").click(function() {
            var $item = $(this).closest("[list_messages_item]");
            $item.remove();
        });
        $list.append($body);
    };

    adm_process_flow_messages_type_list_messages.prototype.__getFixedOption = function($option) {
        var data = {};
        var activity = this.parent.activity;
        var $form = $option.find("[list_messages_item_form]");
        activity.__addValue(data, this.titleDefinition, $form);
        data.rows = this.__getButtons($option.attr("list_messages_item"), $option.find("[template_button]"));

        if (!data.rows.length) {
            data.error = "<%=_T('Must add almost one row.')%>";
        }

        return data;
    };

    adm_process_flow_messages_type_list_messages.prototype.__getFixedOptions = function($container) {
        var self = this;
        var options = [];
        $container.find("[list_messages_item]").each(function() {
            options.push(self.__getFixedOption($(this)));
        });
        return options;
    };

    adm_process_flow_messages_type_list_messages.prototype.__maxButtons = function() {
        return 10;
    };

    adm_process_flow_messages_type_list_messages.prototype.__maxSections = function() {
        return 10;
    };

    adm_process_flow_messages_type_list_messages.prototype.__maxRows = function() {
        return 10;
    };

    adm_process_flow_messages_type_list_messages.prototype.__addButton = function(button, guid, $item, $buttonsList) {
        $buttonsList = $buttonsList || $item.find("[buttons_list]");
        var maxButtons = this.__maxButtons();
        if ($buttonsList.find("[template_button]").length >= maxButtons) {
            this.parent.activity.__showError(format("<%=_T('Item has a limit of {0} buttons.')%>", maxButtons), null, 3000);
            return;
        }
        var buttonConstructor = inConcert.adm_process_flow_messages_button[this.parent.activity.type.toLowerCase()].list_messages;
        var editor = new buttonConstructor(this.parent, button, $buttonsList, $item);
        this.fixedOptions[guid].rows[editor.guid] = editor;
        editor.Make();
    };

    adm_process_flow_messages_type_list_messages.prototype.__makeButtonsList = function(guid, data, $item) {
        var self = this;
        if (!self.__maxButtons()) {
            return null;
        }
        var $body = $(Mustache.render(templates.messages_buttons_list_interactive, {
            add_title : "<%=_T('Add Row')%>"
        }));

        var $buttonsList = $body.find("[buttons_list]");

        $body.find("[add_button]").click(function() {
            var maxRows = self.__maxRows();
            if ($buttonsList.parent().parent().parent().parent().find("[template_button]").length >= maxRows) {
                self.parent.activity.__showError(format("<%=_T('Item has a limit of {0} rows.')%>", maxRows));
                return;
            } else {
                var $item = $(this).closest("[list_messages_item]");
                self.__addButton(null, $item.attr("list_messages_item"), $item);
            }
        });
        
        $.each(data.rows || [], function(_, button) {
            button.type = "list_messages";
            self.__addButton(button, guid, $item, $buttonsList);
        });
        $body.find("[buttons_list]").sortable({
            cursor : "move"
        });
        return $body;
    };

    adm_process_flow_messages_type_list_messages.prototype.__getButtons = function(guid, $rows) {
        var self = this;
        var rows = [];
        if (!this.__maxButtons()) {
            return rows;
        }
        $rows.each(function() {
            var buttonGuid = $(this).attr("template_button");
            var editor = self.fixedOptions[guid] && self.fixedOptions[guid].rows[buttonGuid] || null;
            var data = editor && editor.GetData();
            if (data) {
                let row = JSON.parse(JSON.stringify(data));
                delete row.port_id;
                delete row.type;
                delete row.title_original;
                delete row.id_original;

                rows.push(row);
            }
        });
        return rows;
    };

    adm_process_flow_messages_type_list_messages.prototype.AddValue = function(data) {

        let activity = this.parent.activity;

        data.interactive = data.interactive || {};
        data.interactive.type = "list";
        data.interactive.header = data.interactive.header || {};
        data.interactive.body = data.interactive.body || {};
        data.interactive.footer = data.interactive.footer || {};
        data.interactive.action = data.interactive.action || {};
        
        let file_type_save = "text";
        data.interactive.header.type = file_type_save;

        if (data.interactive.header.type === "text") {
            let text = activity.__getValue(this.headerTextDefinition);
            data.interactive.header.text = text;
        }

        let data_temp = {};
        activity.__addValue(data_temp, this.bodyTextDefinition);
        data.interactive.body.text = data_temp.body_text;
        data.interactive.body.__brackets_text = data_temp.__brackets_body_text;

        let footer_text = activity.__getValue(this.footerTextDefinition);
        data.interactive.footer.text = footer_text;

        let action_button = activity.__getValue(this.buttonTextDefinition);
        data.interactive.action.button = action_button;

        data.interactive.action.sections = this.__getFixedOptions(this.$get("[list_type]"));

        if (!data.interactive.action.button) {
            data.error = "<%=_T('Button label is required.')%>";
        }

        if (!data.interactive.body.text) {
            data.error = "<%=_T('Message is required.')%>";
        }

        if (!data.interactive.action.sections.length) {
            data.error = "<%=_T('Must add almost one section.')%>";
        }
        $.each(data.interactive.action.sections, function(_, row) {
            if (!data.error && row.error) {
                data.error = row.error;
                return false;
            }
        });
    };

//Class

	function adm_process_flow_messages(activity) {
		var self = this;

		this.activity = activity;

		this.types = inConcert.adm_process_flow_messages_type[this.activity.type.toLowerCase()];

        this.showWritingDefinition = {
            id: "writing",
            name: "<%=_T('Show Typing')%>",
            description: "<%=_T('Show typing icon a few seconds before send message makes interaction more natural.')%>",
            not_extended: true,
            form_group: false,
            envolving_label_class: "form-check-label form-check-label-title",
            envolving_label: true,
            without_label: true,
            controlContainerClass: "form-check form-check-right-input",
            checkBoxClass: "form-check-input",
            change : function() {
				self.__toggleWriting($(this).prop("checked"));
			},
        };

        this.writingWaitDefinition = {
            id: "writingWait",
            name: "<%=_T('Typing Seconds')%>",
            description : "<%=_T('Number of seconds typing icon is shown before send message.')%>",
            not_extended: true,
            variable: true,
            span: true,
            validate : {
				range : {
					type : "integer",
					allowVariables : true,
					min : 1,
					max : 30
				}
			},
            defaultValue : 3,
            spanClass: "ic_variable_icon_container",
            envolving_label_class: "form-check-label form-check-label-title",
            controlContainerClass: "form-check mt-0",
            variableIconClass: "ic_variable_icon far fa-at",
            form_group: true
        };

        this.messageTypeMainDefinition_options = [];

        this.messageTypeMainDefinition = {
			id : "msgtype",
			name : "<%=_T('Message type')%>",
			description : "<%=_T('Message type')%>",
			//required : true,
			not_extended : true,
			options : this.messageTypeMainDefinition_options,
			change : function() {
				self.__selectMessageTypeMain();
			}, 
            form_group: true
        };
	}

	if (typeof inConcert.adm_process_flow_messages.base !== "function") {
		inConcert.adm_process_flow_messages.base = adm_process_flow_messages;
	}

	adm_process_flow_messages.prototype.GetMigrationData = function(_, type, migration, data) {

		if (typeof(data.message) === "string") {
			data.message = { msgtype : "text", text : data.message };
		}

		let messageType = inConcert.adm_process_flow_messages_type[type.toLowerCase()][data.message.msgtype];
		return messageType.prototype.GetMigrationData(messageType, type, migration, data);
	};

	adm_process_flow_messages.prototype.GetActivityDeclaredVariables = function(type, data, editor) {
		let messageType = inConcert.adm_process_flow_messages_type[type.toLowerCase()][data.message.msgtype];
		return messageType.prototype.GetActivityDeclaredVariables(data, editor);
	};

	adm_process_flow_messages.prototype.GetName = function() {
		return "<%=_T('Message type')%>";
	};

	adm_process_flow_messages.prototype.GetDescription = function() {
		return "<%=_T('Chat message to be sent.')%>";
	};

	adm_process_flow_messages.prototype.GetTitle = function() {
		return "<%=_T('Message to be sent.')%>";
	};

	adm_process_flow_messages.prototype.__maxQuickreplies = function() {
		return 11;
	};

	adm_process_flow_messages.prototype.__hasWriting = function() {
		if (this.activity && this.activity.data && this.activity.data.type === "ask_for_help") {
			return false;
		} else {
			return true;
		}
	};

	adm_process_flow_messages.prototype.canSupportsMultipleSharedFiles = function() {
		let channel = (this.typeEditor.parent.activity.editor.main.data.Type || "").toUpperCase();
		let availablChannels = {"CALL": true};
		let isAvailable = availablChannels[channel];
		return isAvailable || false;
	};

	adm_process_flow_messages.prototype.__selectType = function(type, data, firstLoad) {

        if (!type) {			
			if (this.messageTypeMainDefinition_options.length === 0) {
				return;
			}
			type = this.messageTypeMainDefinition_options[0].id;
		}
		if (!firstLoad) {
			this.typesData = this.typesData || {};
			data = this.typesData[type];
			this.typesData[this.currentType] = {};
			this.typeEditor.AddValue(this.typesData[this.currentType]);
		}
		this.currentType = type;
		this.instancesEditorsByType = this.instancesEditorsByType || {};
		this.instancesEditorsByType[type] = this.instancesEditorsByType[type] || new this.types[type](this, this.activity.messageOptions);
		this.typeEditor = this.instancesEditorsByType[type];
		this.$container.find("[messages_data_type]").hide();

		let $messages_data_type = this.$container.find("[messages_data_type='" + type + "']");

		if ($messages_data_type.length === 0) {
			const supportsMultipleSharedFiles = this.canSupportsMultipleSharedFiles();
			const $markup = this.typeEditor.Make(data || {}, supportsMultipleSharedFiles); 
			$messages_data_type = $("<div messages_data_type='" + type + (((type === "mail") || (type ==="menu"))?(""):("' class='row' ")) + " style='display:none;'></div>");
            $messages_data_type.html("").append($markup);
			this.$container.prepend($messages_data_type);
		}
		$messages_data_type.show();

		if (!firstLoad) {
			this.typeEditor.AfterAppendBody(this.$container.find("[messages_data_type='"+ type +"']"));
		}
		if(this.activity.AfterSelectType && $.isFunction(this.activity.AfterSelectType)){
			this.activity.AfterSelectType(type);
		}
	};

    adm_process_flow_messages.prototype.__selectMessageTypeMain = function() {
        let self = this;
        let type = self.activity.__getValue(this.messageTypeMainDefinition);
        self.__selectType(type);
	};
	adm_process_flow_messages.prototype.__makeTop = function() {
		return this.options.$top;
	};

	adm_process_flow_messages.prototype.__makeBottom = function() {
		return this.options.$bottom;
	};

	adm_process_flow_messages.prototype.__makeTypes = function(data) {
		let self = this;
		//let $types = [];
		let types_sorted = self.options.types ||
			inConcert.adm_process_flow_messages_type[this.activity.type.toLowerCase() + "_sorted"];
		//Remove text type if TTS Profile is not defined for current vcc and the activity type is CALL
		var bRemoveTextType = function() {
			if(self.activity.type === "CALL") {
				if(inConcert.app.get_vcc_info().ttsasrEngines && $.isArray(inConcert.app.get_vcc_info().ttsasrEngines)) {
					var bExistsTtsProfile = false;
					inConcert.app.get_vcc_info().ttsasrEngines.forEach(function(engine) {
						if(engine.providerType === "TTS" || engine.providerType === "TTS-ASR") {
							bExistsTtsProfile = true;
							if(!engine.profileId || engine.profileId === "") {
								return true;
							}
						}
					});
					if(!bExistsTtsProfile){
						return true;
					}
				}
			}
		};
		if(bRemoveTextType()) {
			types_sorted = types_sorted.filter(item => item !== "text");
		}
		$.each(types_sorted || [], function(_, id) {
			self.messageTypeMainDefinition_options.push({ id: id, name: self.types[id].prototype.name });
		});
        if(bRemoveTextType()) {
			self.__selectType(undefined, data, true);
		}
		else {
			self.__selectType(data.msgtype, data, true);
        }
	};

	adm_process_flow_messages.prototype.__addQuickreply = function(button, $buttonsList) {
		$buttonsList = $buttonsList || this.$get("[quickreplies_list]");
		$buttonsList.siblings("[quickreplies_title]").show();
		var buttonConstructor = inConcert.adm_process_flow_messages_quickreply[this.activity.type.toLowerCase()];
		var editor = new buttonConstructor(this, button, $buttonsList);
		this.quickreplies[editor.guid] = editor;
		editor.Make();
	};

	adm_process_flow_messages.prototype.__makeQuickreplies = function(data) {
		var self = this;
		if (!self.__maxQuickreplies()) {
			return;
		}
		var $body = $(templates.messages_quickreplies_list);
		$body.find("[add_quickreply]").click(function() {
			var maxQuickreplies = self.__maxQuickreplies();
			if (self.$get("[template_quickreply]").length < maxQuickreplies) {
				self.__addQuickreply();
			}
			else {
				self.activity.__showError(format("<%=_T('Message has a limit of {0} quickreplies.')%>", maxQuickreplies));
			}
		});
		self.quickreplies = {};
		var $list = $body.find("[quickreplies_list]");
		$list.sortable({
			cursor : "move"
		});
		$.each(data.quickreplies || [], function(_, quickreply) {
			self.__addQuickreply(quickreply, $list);
		});
		self.$container.append($body);

        $list.siblings("[quickreplies_title]").toggle($list.children().length > 0);
	};

	adm_process_flow_messages.prototype.__getQuickreplies = function() {
		let self = this;
		if (!this.__maxQuickreplies()) {
			return null;
		}
		let buttons = [];
		self.$get("[template_quickreply]").each(function() {
			let guid = $(this).attr("template_quickreply");
			let editor = self.quickreplies[guid];
			let data = editor && editor.GetData();
			if (data) {
				if (!data.port_id) {
					data.port_id = guid;
				}
                data.isQuickReply = true;
				buttons.push(data);
			}
		});
		return buttons;
	};

	adm_process_flow_messages.prototype.__makeForm = function($formContent) {
		if (this.__hasWriting()) {

            $formContent.push(
                this.activity.__makeDivFlex(
                  [
                    this.activity.__makeDivFlex(this.activity.__makeDivFlex(this.activity.__makeCheckbox(this.showWritingDefinition,this.data[this.showWritingDefinition.id]),{ class: "form-group" }),{ class: "col-6" }),
                    this.activity.__makeDivFlex(this.activity.__makeDivFlex(this.activity.__makeInputFlex(this.writingWaitDefinition,this.data[this.writingWaitDefinition.id]),{ class: "form-group" }),{ class: "col-6" })
                  ],{ class: "row" }
                )
            );
		}
		return $formContent;
	};

	adm_process_flow_messages.prototype.Make = function($formContent, data, options, $outputs, $error_message, hide_configuration_tab, hide_message_type_definition) { 
		this.isNew = !!data;
		this.data = data || {};
		this.options = options || {};
		let hiddeMessageTypeDefinition = false;
		if (hide_message_type_definition !== undefined && hide_message_type_definition) {
			hiddeMessageTypeDefinition = true;
		}
		if (typeof(this.data) === "string") {
			let text = this.data;
			if (text.indexOf("\"") === 0) {
				text = text.replace(/"/g, "");
			}
			else if (text.indexOf("\'") === 0) {
				text = text.replace(/'/g, "");
			}
			else {
				text = "{{" + text + "}}";
			}
			this.data = {
				msgtype : "text",
				text : text
			};
		}
        this.$container =  $("<div id='messages_data'></div>");

		this.__makeTypes(this.data);
		this.__makeQuickreplies(this.data);

		let $top = this.__makeTop(); 
		let $bottom = this.__makeBottom();
		$formContent = this.__makeForm($formContent);

		const $tabs = $(templates.messages_tabs);

        let $message_content = this.activity.__makeDivFlex(this.activity.__makeDivFlex(null, { class: "card-block" }), { class: "card no-card" });
        let $configuration_content = this.activity.__makeDivFlex(this.activity.__makeDivFlex(null, { class: "card-block" }), { class: "card no-card" });

        this.messageTypeMainDefinition.hidden = this.messageTypeMainDefinition_options.length <= 1;
        
		if (!hiddeMessageTypeDefinition) {
			$message_content.find(".card-block").first()
				.append(this.activity.__makeDivFlex(this.activity.__makeDivFlex(this.activity.__makeComboFlex(this.messageTypeMainDefinition, (data && data.msgtype)?data.msgtype:this.messageTypeMainDefinition_options[0].id), { class: "col-12" }), { class: "row" }));
		}

        $message_content.find(".card-block").first()
			.append($top)
			.append(this.$container)
			.append($bottom);

		
		if ($error_message) {
			if (options.error_message_on_top) {
				$message_content.find(".card-block").first()
					.prepend($error_message);
			} else {
				$message_content.find(".card-block").first()
					.append($error_message);
			}                
		}

		$configuration_content.find(".card-block").first()
		    .append($formContent);

        $tabs.filter("#tabContent-send-and-wait").find("#message")
            .append($message_content);
        $tabs.filter("#tabContent-send-and-wait").find("#configuration")
            .append($configuration_content);

        if ($outputs) {
            $tabs.filter("#tabContent-send-and-wait").find("#outputs")
                .append($outputs);
            this.activity.$outputs = $outputs;

			if (this.activity.type === "WHATSAPP" && (this.data.msgtype !== "list_messages")) {
                $tabs.find("[add_button]").parent().hide();
            }
        } else {
            $tabs.find("[href='#outputs']").parent().hide();
            
			if (this.activity.editor.main.__getVersion() === "2" || this.activity.data.type === "ask_for_help") {
				$tabs.find("[add_quickreply]").parent().hide();
			}
            
            if (this.activity && (this.activity.type === "WHATSAPP" || this.activity.data.type === "ask_for_help")) {
                $tabs.find("[add_button]").parent().hide();
            }
        }

        if (hide_configuration_tab) {
            $tabs.find("[href='#configuration']").parent().hide();
        }
        
		if (typeof(this.activity.output_options || "") === "string") {
			$tabs.find("[add_quickreply]").parent().hide();
		}
		
		return $tabs;
	};

	adm_process_flow_messages.prototype.ShowErrorScreen = function(title, message) {

		const $tabs = $("#tabs-message");
		const $message = $("#tabContent-send-and-wait");

		$tabs.find("[href='#outputs']").parent().hide();
		$tabs.find("[href='#configuration']").parent().hide();

		let $message_content = $(Mustache.render(templates.activity_error_screen, {
            title : title,
			message: message
        }));
		
		$message.children().hide();
		$message.append($message_content);
	};

	adm_process_flow_messages.prototype.__toggleWriting = function(checked) {
		this.activity.__disableEnableControl(this.writingWaitDefinition, !checked);
	};

	adm_process_flow_messages.prototype.__afterAppendBodyForm = function() {
		if (this.__hasWriting()) {
			this.__toggleWriting(this.data[this.showWritingDefinition.id]);
		}
	};

	adm_process_flow_messages.prototype.AfterAppendBody = function() {
		this.activity.tabs = new inConcert.conf_form_tab({
			parent       : this.activity,
			container_id : "flow_designer_message_tabs",
			tabs_list    : {
				message : {
					id               : "message",
					name             : "<%=_T('Message')%>",
					tab_container_id : "flow_designer_message_tabs_message",
					selected         : true,
					initial_state    : "enabled"
				},
				configuration : {
					id               : "configuration",
					name             : "<%=_T('Configuration')%>",
					tab_container_id : "flow_designer_message_tabs_configuration",
					initial_state    : "enabled"
				},
				outputs : {
					id               : "outputs",
					name             : "<%=_T('Outputs')%>",
					tab_container_id : "flow_designer_message_tabs_outputs",
					initial_state    : "enabled"
				}
			}
		});
		this.activity.tabs.show_tabs_container();

		if (!this.activity.$outputs) {
			this.activity.tabs.hide_tab("outputs");
		}

		if (this.typeEditor) {
			let type = this.activity.__getValue(this.messageTypeMainDefinition);
			this.typeEditor.AfterAppendBody(this.$container.find("[messages_data_type='"+ type +"']"));
		}

		this.__afterAppendBodyForm();
	};

	adm_process_flow_messages.prototype.__addFormValue = function(messageData) {
		this.activity.__addValue(messageData, this.showWritingDefinition);
		this.activity.__addValue(messageData, this.messageTypeMainDefinition);
		if (messageData[this.showWritingDefinition.id]) {
			this.activity.__addValue(messageData, this.writingWaitDefinition);
		}
		if (this.activity.__getAndValidateFormMessage) {
			this.activity.__getAndValidateFormMessage(messageData);
		}
	};

	adm_process_flow_messages.prototype.AddValue = function(data, messageId, callback) {
		const self = this;
		//configuration
		let messageData = {};
		this.__addFormValue(messageData);
		let configurationError = false;
		if (messageData.error || data.error) {
			configurationError = true;
			this.activity.tabs.switch_tab("configuration");
		}
		//message
		//messageData.msgtype = this.$get("[message_type]:checked").attr("message_type");
		this.typeEditor.AddValue(messageData);
		if (!configurationError && messageData.error) {
			data.error = messageData.error;
			self.activity.tabs.switch_tab("message");
			callback();
			return;
		}

		this.typeEditor.AddValueAsync(messageData, function() {
			messageData.quickreplies = self.__getQuickreplies();
			if (self.activity.type === "INSTAGRAM_BOT") {
				messageData.QuickRepliesTitle = "<%=_T('Click on a quick reply')%>";
			}
			data.error = data.error || messageData.error;
			messageData.error = undefined;
			data[messageId] = messageData;
			if (!configurationError && data.error) {
				self.activity.tabs.switch_tab("message");
			}
			callback();
		});
	};

	adm_process_flow_messages.prototype.$get = function(query) {
		return query? this.$container.find(query) : this.$container;
	};

	adm_process_flow_messages.prototype.__makeErrorMessage = function() {
		if (!this.errorMessageOptions) {
			return null;
		}
		this.errorMessageEditor = new inConcert.adm_process_flow_messages_embeed(
			this.messagesEditor, this.errorMessageOptions);
			
		let errorMessageObj = this.data.errorMessage;
		if (errorMessageObj && errorMessageObj.msgtype && !this.errorMessageOptions.message_types.find(msgtype => msgtype.id === errorMessageObj.msgtype)) {
			errorMessageObj = {};
		}
		return this.errorMessageEditor.Make(errorMessageObj || {});
	};

}());
