/*
 jquery.okayNav.js 2.0.4 (https://github.com/VPenkov/okayNav)
 Author: Vergil Penkov (http://vergilpenkov.com/)
 MIT license: https://opensource.org/licenses/MIT
*/
(function(factory){if(typeof define==="function"&&define.amd)define(["jquery"],factory);else if(typeof module==="object"&&module.exports)module.exports=function(root,jQuery){if(jQuery===undefined)if(typeof window!=="undefined")jQuery=require("jquery");else jQuery=require("jquery")(root);factory(jQuery);return jQuery};else factory(jQuery)})(function($){var okayNav="okayNav",defaults={parent:"",toggle_icon_class:"okayNav__menu-toggle",toggle_icon_content:"<span /><span /><span />",align_right:true,
swipe_enabled:true,threshold:50,resize_delay:10,beforeOpen:function(){},afterOpen:function(){},beforeClose:function(){},afterClose:function(){},itemHidden:function(){},itemDisplayed:function(){}};function Plugin(element,options){var self=this;this.options=$.extend({},defaults,options);self.navigation=$(element);self.document=$(document);self.window=$(window);this.options.parent==""?this.options.parent=self.navigation.parent():"";self.nav_open=false;self.parent_full_width=0;self.radCoef=180/Math.PI;
self.sTouch={x:0,y:0};self.cTouch={x:0,y:0};self.sTime=0;self.nav_position=0;self.percent_open=0;self.nav_moving=false;self.init()}$.extend(Plugin.prototype,{init:function(){var self=this;$("body").addClass("okayNav-loaded");self.navigation.addClass("okayNav loaded").children("ul").addClass("okayNav__nav--visible");if(self.options.align_right)self.navigation.append('<ul class="okayNav__nav--invisible transition-enabled nav-right" />').append('<a href="#" class="'+self.options.toggle_icon_class+' okay-invisible">'+
self.options.toggle_icon_content+"</a>");else self.navigation.prepend('<ul class="okayNav__nav--invisible transition-enabled nav-left" />').prepend('<a href="#" class="'+self.options.toggle_icon_class+' okay-invisible">'+self.options.toggle_icon_content+"</a>");self.nav_visible=self.navigation.children(".okayNav__nav--visible");self.nav_invisible=self.navigation.children(".okayNav__nav--invisible");self.toggle_icon=self.navigation.children("."+self.options.toggle_icon_class);self.toggle_icon_width=
self.toggle_icon.outerWidth(true);self.default_width=self.getChildrenWidth(self.navigation);self.parent_full_width=$(self.options.parent).outerWidth(true);self.last_visible_child_width=0;self.initEvents();self.nav_visible.contents().filter(function(){return this.nodeType=Node.TEXT_NODE&&/\S/.test(this.nodeValue)===false}).remove();if(self.options.swipe_enabled==true)self.initSwipeEvents()},initEvents:function(){var self=this;self.document.on("click.okayNav",function(e){var _target=$(e.target);if(self.nav_open===
true&&_target.closest(".okayNav").length==0)self.closeInvisibleNav();if(e.target===self.toggle_icon.get(0)){e.preventDefault();self.toggleInvisibleNav()}});var optimizeResize=self._debounce(function(){self.recalcNav()},self.options.resize_delay);self.window.on("load.okayNav resize.okayNav",optimizeResize)},initSwipeEvents:function(){var self=this;self.document.on("touchstart.okayNav",function(e){self.nav_invisible.removeClass("transition-enabled");if(e.originalEvent.touches.length==1){var touch=e.originalEvent.touches[0];
if(touch.pageX<25&&self.options.align_right==false||touch.pageX>$(self.options.parent).outerWidth(true)-25&&self.options.align_right==true||self.nav_open===true){self.sTouch.x=self.cTouch.x=touch.pageX;self.sTouch.y=self.cTouch.y=touch.pageY;self.sTime=Date.now()}}}).on("touchmove.okayNav",function(e){var touch=e.originalEvent.touches[0];self._triggerMove(touch.pageX,touch.pageY);self.nav_moving=true}).on("touchend.okayNav",function(e){self.sTouch={x:0,y:0};self.cTouch={x:0,y:0};self.sTime=0;if(self.percent_open>
100-self.options.threshold){self.nav_position=0;self.closeInvisibleNav()}else if(self.nav_moving==true){self.nav_position=self.nav_invisible.width();self.openInvisibleNav()}self.nav_moving=false;self.nav_invisible.addClass("transition-enabled")})},_getDirection:function(dx){if(this.options.align_right)return dx>0?-1:1;else return dx<0?-1:1},_triggerMove:function(x,y){var self=this;self.cTouch.x=x;self.cTouch.y=y;var currentTime=Date.now();var dx=self.cTouch.x-self.sTouch.x;var dy=self.cTouch.y-self.sTouch.y;
var opposing=dy*dy;var distance=Math.sqrt(dx*dx+opposing);var dOpposing=Math.sqrt(opposing);var angle=Math.asin(Math.sin(dOpposing/distance))*self.radCoef;var speed=distance/(currentTime-self.sTime);self.sTouch.x=x;self.sTouch.y=y;if(angle<20){var dir=self._getDirection(dx);var newPos=self.nav_position+dir*distance;var menuWidth=self.nav_invisible.width();var overflow=0;if(newPos<0)overflow=-newPos;else if(newPos>menuWidth)overflow=menuWidth-newPos;var size=menuWidth-(self.nav_position+dir*distance+
overflow);var threshold=size/menuWidth*100;self.nav_position+=dir*distance+overflow;self.percent_open=threshold;self.nav_invisible.css("transform","translateX("+(self.options.align_right?1:-1)*threshold+"%)")}},getParent:function(){return this.options.parent},getVisibleNav:function(){return this.nav_visible},getInvisibleNav:function(){return this.nav_invisible},getNavToggleIcon:function(){return this.toggle_icon},_debounce:function(func,wait,immediate){var timeout;return function(){var context=this,
args=arguments;var later=function(){timeout=null;if(!immediate)func.apply(context,args)};var callNow=immediate&&!timeout;clearTimeout(timeout);timeout=setTimeout(later,wait);if(callNow)func.apply(context,args)}},openInvisibleNav:function(){var self=this;!self.options.enable_swipe?self.options.beforeOpen.call():"";self.toggle_icon.addClass("icon--active");self.nav_invisible.addClass("nav-open");self.nav_open=true;self.nav_invisible.css({"-webkit-transform":"translateX(0%)","transform":"translateX(0%)"});
self.options.afterOpen.call()},closeInvisibleNav:function(){var self=this;!self.options.enable_swipe?self.options.beforeClose.call():"";self.toggle_icon.removeClass("icon--active");self.nav_invisible.removeClass("nav-open");if(self.options.align_right)self.nav_invisible.css({"-webkit-transform":"translateX(100%)","transform":"translateX(100%)"});else self.nav_invisible.css({"-webkit-transform":"translateX(-100%)","transform":"translateX(-100%)"});self.nav_open=false;self.options.afterClose.call()},
toggleInvisibleNav:function(){var self=this;if(!self.nav_open)self.openInvisibleNav();else self.closeInvisibleNav()},getChildrenWidth:function(el){var children_width=0;var children=$(el).children();for(var i=0;i<children.length;i++)children_width+=$(children[i]).outerWidth(true);return children_width},getVisibleItemCount:function(){return $("li",this.nav_visible).length},getHiddenItemCount:function(){return $("li",this.nav_invisible).length},recalcNav:function(){var self=this;var wrapper_width=$(self.options.parent).outerWidth(true),
space_taken=self.getChildrenWidth(self.options.parent),nav_full_width=self.navigation.outerWidth(true),visible_nav_items=self.getVisibleItemCount(),collapse_width=self.nav_visible.outerWidth(true)+self.toggle_icon_width,expand_width=space_taken+self.last_visible_child_width+self.toggle_icon_width,expandAll_width=space_taken-nav_full_width+self.default_width;if(wrapper_width>expandAll_width){self._expandAllItems();self.toggle_icon.addClass("okay-invisible");return}if(visible_nav_items>0&&nav_full_width<=
collapse_width&&wrapper_width<=expand_width)self._collapseNavItem();if(wrapper_width>expand_width+self.toggle_icon_width+15)self._expandNavItem();self.getHiddenItemCount()==0?self.toggle_icon.addClass("okay-invisible"):self.toggle_icon.removeClass("okay-invisible")},_collapseNavItem:function(){var self=this;var $last_child=$("li:last-child",self.nav_visible);self.last_visible_child_width=$last_child.outerWidth(true);self.document.trigger("okayNav:collapseItem",$last_child);$last_child.detach().prependTo(self.nav_invisible);
self.options.itemHidden.call();self.recalcNav()},_expandNavItem:function(){var self=this;var $first=$("li:first-child",self.nav_invisible);self.document.trigger("okayNav:expandItem",$first);$first.detach().appendTo(self.nav_visible);self.options.itemDisplayed.call()},_expandAllItems:function(){var self=this;$("li",self.nav_invisible).detach().appendTo(self.nav_visible);self.options.itemDisplayed.call()},_collapseAllItems:function(){var self=this;$("li",self.nav_visible).detach().appendTo(self.nav_invisible);
self.options.itemHidden.call()},destroy:function(){var self=this;$("li",self.nav_invisible).appendTo(self.nav_visible);self.nav_invisible.remove();self.nav_visible.removeClass("okayNav__nav--visible");self.toggle_icon.remove();self.document.unbind(".okayNav");self.window.unbind(".okayNav")}});$.fn[okayNav]=function(options){var args=arguments;if(options===undefined||typeof options==="object")return this.each(function(){if(!$.data(this,"plugin_"+okayNav))$.data(this,"plugin_"+okayNav,new Plugin(this,
options))});else if(typeof options==="string"&&options[0]!=="_"&&options!=="init"){var returns;this.each(function(){var instance=$.data(this,"plugin_"+okayNav);if(instance instanceof Plugin&&typeof instance[options]==="function")returns=instance[options].apply(instance,Array.prototype.slice.call(args,1));if(options==="destroy")$.data(this,"plugin_"+okayNav,null)});return returns!==undefined?returns:this}}});
